/*! For license information please see azure-ad-bundle.js.LICENSE.txt */
(()=>{"use strict";const e="https://graph.microsoft.com",t=new Set([e,"https://graph.microsoft.us","https://dod-graph.microsoft.us","https://graph.microsoft.de","https://microsoftgraph.chinacloudapi.cn","https://canary.graph.microsoft.com"]);function i(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}function o(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}var s;Object.create,Object.create,"function"==typeof SuppressedError&&SuppressedError,function(e){e.GET="GET",e.PATCH="PATCH",e.POST="POST",e.PUT="PUT",e.DELETE="DELETE"}(s||(s={}));class n{constructor(e){if(this.requests=new Map,void 0!==e){const t=n.requestLimit;if(e.length>t){const e=new Error(`Maximum requests limit exceeded, Max allowed number of requests are ${t}`);throw e.name="Limit Exceeded Error",e}for(const t of e)this.addRequest(t)}}static validateDependencies(e){if(0===e.size){const e=new Error("Empty requests map, Please provide at least one request.");throw e.name="Empty Requests Error",e}return(e=>{const t=e.entries();let i=t.next();for(;!i.done;){const e=i.value[1];if(void 0!==e.dependsOn&&e.dependsOn.length>0)return!1;i=t.next()}return!0})(e)||(e=>{const t=e.entries();let i=t.next();const o=i.value[1];if(void 0!==o.dependsOn&&o.dependsOn.length>0)return!1;let s=i;for(i=t.next();!i.done;){const e=i.value[1];if(void 0===e.dependsOn||1!==e.dependsOn.length||e.dependsOn[0]!==s.value[1].id)return!1;s=i,i=t.next()}return!0})(e)||(e=>{const t=e.entries();let i=t.next();const o=i.value[1];let s;if(void 0===o.dependsOn||0===o.dependsOn.length)s=o.id;else{if(1!==o.dependsOn.length)return!1;{const t=o.dependsOn[0];if(t===o.id||!e.has(t))return!1;s=t}}for(i=t.next();!i.done;){const e=i.value[1];if((void 0===e.dependsOn||0===e.dependsOn.length)&&s!==e.id)return!1;if(void 0!==e.dependsOn&&0!==e.dependsOn.length){if(1===e.dependsOn.length&&(e.id===s||e.dependsOn[0]!==s))return!1;if(e.dependsOn.length>1)return!1}i=t.next()}return!0})(e)}static getRequestData(e){return o(this,void 0,void 0,(function*(){const t={url:""},i=new RegExp("^https?://");t.url=i.test(e.url)?"/"+e.url.split(/.*?\/\/.*?\//)[1]:e.url,t.method=e.method;const o={};return e.headers.forEach(((e,t)=>{o[t]=e})),Object.keys(o).length&&(t.headers=o),e.method!==s.PATCH&&e.method!==s.POST&&e.method!==s.PUT||(t.body=yield n.getRequestBody(e)),t}))}static getRequestBody(e){return o(this,void 0,void 0,(function*(){let t,i=!1;try{const o=e.clone();t=yield o.json(),i=!0}catch(e){}if(!i)try{if("undefined"!=typeof Blob){const i=yield e.blob(),o=new FileReader;t=yield new Promise((e=>{o.addEventListener("load",(()=>{const t=o.result,i=new RegExp("^s*data:(.+?/.+?(;.+?=.+?)*)?(;base64)?,(.*)s*$").exec(t);e(i[4])}),!1),o.readAsDataURL(i)}))}else"undefined"!=typeof Buffer&&(t=(yield e.buffer()).toString("base64"));i=!0}catch(e){}return t}))}addRequest(e){const t=n.requestLimit;if(""===e.id){const e=new Error("Id for a request is empty, Please provide an unique id");throw e.name="Empty Id For Request",e}if(this.requests.size===t){const e=new Error(`Maximum requests limit exceeded, Max allowed number of requests are ${t}`);throw e.name="Limit Exceeded Error",e}if(this.requests.has(e.id)){const t=new Error(`Adding request with duplicate id ${e.id}, Make the id of the requests unique`);throw t.name="Duplicate RequestId Error",t}return this.requests.set(e.id,e),e.id}removeRequest(e){const t=this.requests.delete(e),i=this.requests.entries();let o=i.next();for(;!o.done;){const t=o.value[1].dependsOn;if(void 0!==t){const i=t.indexOf(e);-1!==i&&t.splice(i,1),0===t.length&&delete o.value[1].dependsOn}o=i.next()}return t}getContent(){return o(this,void 0,void 0,(function*(){const e=[],t={requests:e},i=this.requests.entries();let o=i.next();if(o.done){const e=new Error("No requests added yet, Please add at least one request.");throw e.name="Empty Payload",e}if(!n.validateDependencies(this.requests)){const e=new Error("Invalid dependency found, Dependency should be:\n1. Parallel - no individual request states a dependency in the dependsOn property.\n2. Serial - all individual requests depend on the previous individual request.\n3. Same - all individual requests that state a dependency in the dependsOn property, state the same dependency.");throw e.name="Invalid Dependency",e}for(;!o.done;){const t=o.value[1],s=yield n.getRequestData(t.request);if(void 0!==s.body&&(void 0===s.headers||void 0===s.headers["content-type"])){const e=new Error(`Content-type header is not mentioned for request #${t.id}, For request having body, Content-type header should be mentioned`);throw e.name="Invalid Content-type header",e}s.id=t.id,void 0!==t.dependsOn&&t.dependsOn.length>0&&(s.dependsOn=t.dependsOn),e.push(s),o=i.next()}return t.requests=e,t}))}addDependency(e,t){if(!this.requests.has(e)){const t=new Error(`Dependent ${e} does not exists, Please check the id`);throw t.name="Invalid Dependent",t}if(void 0!==t&&!this.requests.has(t)){const e=new Error(`Dependency ${t} does not exists, Please check the id`);throw e.name="Invalid Dependency",e}if(void 0!==t){const i=this.requests.get(e);if(void 0===i.dependsOn&&(i.dependsOn=[]),-1!==i.dependsOn.indexOf(t)){const i=new Error(`Dependency ${t} is already added for the request ${e}`);throw i.name="Duplicate Dependency",i}i.dependsOn.push(t)}else{const i=this.requests.entries();let o,s=i.next();for(;!s.done&&s.value[1].id!==e;)o=s,s=i.next();if(void 0===o){const e=new Error(`Can't add dependency ${t}, There is only a dependent request in the batch`);throw e.name="Invalid Dependency Addition",e}{const t=o.value[0];if(void 0===s.value[1].dependsOn&&(s.value[1].dependsOn=[]),-1!==s.value[1].dependsOn.indexOf(t)){const i=new Error(`Dependency ${t} is already added for the request ${e}`);throw i.name="Duplicate Dependency",i}s.value[1].dependsOn.push(t)}}}removeDependency(e,t){const i=this.requests.get(e);if(void 0===i||void 0===i.dependsOn||0===i.dependsOn.length)return!1;if(void 0!==t){const e=i.dependsOn.indexOf(t);return-1!==e&&(i.dependsOn.splice(e,1),!0)}return delete i.dependsOn,!0}}n.requestLimit=20;const r=new Set(["graph.microsoft.com","graph.microsoft.us","dod-graph.microsoft.us","graph.microsoft.de","microsoftgraph.chinacloudapi.cn","canary.graph.microsoft.com"]);class a extends Error{constructor(e){super(e),Object.setPrototypeOf(this,a.prototype)}static setGraphClientError(e){let t;return e instanceof Error?t=e:(t=new a,t.customError=e),t}}const l=["$select","$expand","$orderby","$filter","$top","$skip","$skipToken","$count"],d=e=>{const t=e&&e.constructor&&e.constructor.name;if("Buffer"===t||"Blob"===t||"File"===t||"FormData"===t||"string"==typeof e)return e;if("ArrayBuffer"===t)e=Buffer.from(e);else if("Int8Array"===t||"Int16Array"===t||"Int32Array"===t||"Uint8Array"===t||"Uint16Array"===t||"Uint32Array"===t||"Uint8ClampedArray"===t||"Float32Array"===t||"Float64Array"===t||"DataView"===t)e=Buffer.from(e.buffer);else try{e=JSON.stringify(e)}catch(e){throw new Error("Unable to stringify the content")}return e},c=e=>u(e),h=(e,t)=>(t.forEach((e=>p(e))),u(e,t)),u=(e,t=r)=>{if(-1!==(e=e.toLowerCase()).indexOf("https://")){const i=(e=e.replace("https://","")).indexOf(":"),o=e.indexOf("/");let s="";if(-1!==o)return-1!==i&&i<o?(s=e.substring(0,i),t.has(s)):(s=e.substring(0,o),t.has(s))}return!1},p=e=>{if(-1!==e.indexOf("/"))throw new a("Please add only hosts or hostnames to the CustomHosts config. If the url is `http://example.com:3000/`, host is `example:3000`")};class g{constructor(e=[]){this.middlewareOptions=new Map;for(const t of e){const e=t.constructor;this.middlewareOptions.set(e,t)}}getMiddlewareOptions(e){return this.middlewareOptions.get(e)}setMiddlewareOptions(e,t){this.middlewareOptions.set(e,t)}}const f=(e,t,i)=>{let o=null;if("undefined"!=typeof Request&&e instanceof Request)o=e.headers.get(i);else if(void 0!==t&&void 0!==t.headers)if("undefined"!=typeof Headers&&t.headers instanceof Headers)o=t.headers.get(i);else if(t.headers instanceof Array){const e=t.headers;for(let t=0,s=e.length;t<s;t++)if(e[t][0]===i){o=e[t][1];break}}else void 0!==t.headers[i]&&(o=t.headers[i]);return o},v=(e,t,i,o)=>{if("undefined"!=typeof Request&&e instanceof Request)e.headers.set(i,o);else if(void 0!==t)if(void 0===t.headers)t.headers=new Headers({[i]:o});else if("undefined"!=typeof Headers&&t.headers instanceof Headers)t.headers.set(i,o);else if(t.headers instanceof Array){let e=0;const s=t.headers.length;for(;e<s;e++){const s=t.headers[e];if(s[0]===i){s[1]=o;break}}e===s&&t.headers.push([i,o])}else Object.assign(t.headers,{[i]:o})},m=(e,t,i,o)=>{"undefined"!=typeof Request&&e instanceof Request?e.headers.append(i,o):void 0!==t&&(void 0===t.headers?t.headers=new Headers({[i]:o}):"undefined"!=typeof Headers&&t.headers instanceof Headers?t.headers.append(i,o):t.headers instanceof Array?t.headers.push([i,o]):void 0===t.headers?t.headers={[i]:o}:void 0===t.headers[i]?t.headers[i]=o:t.headers[i]+=`, ${o}`)};class b{constructor(e,t){this.authenticationProvider=e,this.authenticationProviderOptions=t}}var y,w,x,k,C,$,S;!function(e){e[e.NONE=0]="NONE",e[e.REDIRECT_HANDLER_ENABLED=1]="REDIRECT_HANDLER_ENABLED",e[e.RETRY_HANDLER_ENABLED=2]="RETRY_HANDLER_ENABLED",e[e.AUTHENTICATION_HANDLER_ENABLED=4]="AUTHENTICATION_HANDLER_ENABLED"}(y||(y={}));class _{constructor(){this.featureUsage=y.NONE}static updateFeatureUsageFlag(e,t){let i;e.middlewareControl instanceof g?i=e.middlewareControl.getMiddlewareOptions(_):e.middlewareControl=new g,void 0===i&&(i=new _,e.middlewareControl.setMiddlewareOptions(_,i)),i.setFeatureUsage(t)}setFeatureUsage(e){this.featureUsage=this.featureUsage|e}getFeatureUsage(){return this.featureUsage.toString(16)}}class I{constructor(e){this.authenticationProvider=e}execute(e){return o(this,void 0,void 0,(function*(){const t="string"==typeof e.request?e.request:e.request.url;if(c(t)||e.customHosts&&h(t,e.customHosts)){let t,i,o;e.middlewareControl instanceof g&&(t=e.middlewareControl.getMiddlewareOptions(b)),t&&(i=t.authenticationProvider,o=t.authenticationProviderOptions),i||(i=this.authenticationProvider);const s=`Bearer ${yield i.getAccessToken(o)}`;m(e.request,e.options,I.AUTHORIZATION_HEADER,s),_.updateFeatureUsageFlag(e,y.AUTHENTICATION_HANDLER_ENABLED)}else e.options.headers&&delete e.options.headers[I.AUTHORIZATION_HEADER];return yield this.nextMiddleware.execute(e)}))}setNext(e){this.nextMiddleware=e}}I.AUTHORIZATION_HEADER="Authorization";class T{execute(e){return o(this,void 0,void 0,(function*(){e.response=yield fetch(e.request,e.options)}))}}class D{constructor(e=D.DEFAULT_DELAY,t=D.DEFAULT_MAX_RETRIES,i=D.defaultShouldRetry){if(e>D.MAX_DELAY&&t>D.MAX_MAX_RETRIES){const e=new Error(`Delay and MaxRetries should not be more than ${D.MAX_DELAY} and ${D.MAX_MAX_RETRIES}`);throw e.name="MaxLimitExceeded",e}if(e>D.MAX_DELAY){const e=new Error(`Delay should not be more than ${D.MAX_DELAY}`);throw e.name="MaxLimitExceeded",e}if(t>D.MAX_MAX_RETRIES){const e=new Error(`MaxRetries should not be more than ${D.MAX_MAX_RETRIES}`);throw e.name="MaxLimitExceeded",e}if(e<0&&t<0){const e=new Error("Delay and MaxRetries should not be negative");throw e.name="MinExpectationNotMet",e}if(e<0){const e=new Error("Delay should not be negative");throw e.name="MinExpectationNotMet",e}if(t<0){const e=new Error("MaxRetries should not be negative");throw e.name="MinExpectationNotMet",e}this.delay=Math.min(e,D.MAX_DELAY),this.maxRetries=Math.min(t,D.MAX_MAX_RETRIES),this.shouldRetry=i}getMaxDelay(){return D.MAX_DELAY}}D.DEFAULT_DELAY=3,D.DEFAULT_MAX_RETRIES=3,D.MAX_DELAY=180,D.MAX_MAX_RETRIES=10,D.defaultShouldRetry=()=>!0;class P{constructor(e=new D){this.options=e}isRetry(e){return-1!==P.RETRY_STATUS_CODES.indexOf(e.status)}isBuffered(e,t){const i="string"==typeof e?t.method:e.method;return i!==s.PUT&&i!==s.PATCH&&i!==s.POST||"application/octet-stream"!==f(e,t,"Content-Type")}getDelay(e,t,i){const o=()=>Number(Math.random().toFixed(3)),s=void 0!==e.headers?e.headers.get(P.RETRY_AFTER_HEADER):null;let n;return n=null!==s?Number.isNaN(Number(s))?Math.round((new Date(s).getTime()-Date.now())/1e3):Number(s):t>=2?this.getExponentialBackOffTime(t)+i+o():i+o(),Math.min(n,this.options.getMaxDelay()+o())}getExponentialBackOffTime(e){return Math.round(.5*(Math.pow(2,e)-1))}sleep(e){return o(this,void 0,void 0,(function*(){const t=1e3*e;return new Promise((e=>setTimeout(e,t)))}))}getOptions(e){let t;return e.middlewareControl instanceof g&&(t=e.middlewareControl.getMiddlewareOptions(this.options.constructor)),void 0===t&&(t=Object.assign(new D,this.options)),t}executeWithRetry(e,t,i){return o(this,void 0,void 0,(function*(){if(yield this.nextMiddleware.execute(e),t<i.maxRetries&&this.isRetry(e.response)&&this.isBuffered(e.request,e.options)&&i.shouldRetry(i.delay,t,e.request,e.options,e.response)){++t,v(e.request,e.options,P.RETRY_ATTEMPT_HEADER,t.toString());const o=this.getDelay(e.response,t,i.delay);return yield this.sleep(o),yield this.executeWithRetry(e,t,i)}}))}execute(e){return o(this,void 0,void 0,(function*(){const t=this.getOptions(e);return _.updateFeatureUsageFlag(e,y.RETRY_HANDLER_ENABLED),yield this.executeWithRetry(e,0,t)}))}setNext(e){this.nextMiddleware=e}}P.RETRY_STATUS_CODES=[429,503,504],P.RETRY_ATTEMPT_HEADER="Retry-Attempt",P.RETRY_AFTER_HEADER="Retry-After";class L{constructor(e=L.DEFAULT_MAX_REDIRECTS,t=L.defaultShouldRedirect){if(e>L.MAX_MAX_REDIRECTS){const e=new Error(`MaxRedirects should not be more than ${L.MAX_MAX_REDIRECTS}`);throw e.name="MaxLimitExceeded",e}if(e<0){const e=new Error("MaxRedirects should not be negative");throw e.name="MinExpectationNotMet",e}this.maxRedirects=e,this.shouldRedirect=t}}L.DEFAULT_MAX_REDIRECTS=5,L.MAX_MAX_REDIRECTS=20,L.defaultShouldRedirect=()=>!0;class E{constructor(e=new L){this.options=e}isRedirect(e){return-1!==E.REDIRECT_STATUS_CODES.indexOf(e.status)}hasLocationHeader(e){return e.headers.has(E.LOCATION_HEADER)}getLocationHeader(e){return e.headers.get(E.LOCATION_HEADER)}isRelativeURL(e){return-1===e.indexOf("://")}shouldDropAuthorizationHeader(e,t){const i=/^[A-Za-z].+?:\/\/.+?(?=\/|$)/,o=i.exec(e);let s,n;null!==o&&(s=o[0]);const r=i.exec(t);return null!==r&&(n=r[0]),void 0!==s&&void 0!==n&&s!==n}updateRequestUrl(e,t){return o(this,void 0,void 0,(function*(){var i,s;t.request="string"==typeof t.request?e:yield(i=e,s=t.request,o(void 0,void 0,void 0,(function*(){const e=s.headers.get("Content-Type")?yield s.blob():yield Promise.resolve(void 0),{method:t,headers:o,referrer:n,referrerPolicy:r,mode:a,credentials:l,cache:d,redirect:c,integrity:h,keepalive:u,signal:p}=s;return new Request(i,{method:t,headers:o,body:e,referrer:n,referrerPolicy:r,mode:a,credentials:l,cache:d,redirect:c,integrity:h,keepalive:u,signal:p})})))}))}getOptions(e){let t;return e.middlewareControl instanceof g&&(t=e.middlewareControl.getMiddlewareOptions(L)),void 0===t&&(t=Object.assign(new L,this.options)),t}executeWithRedirect(e,t,i){return o(this,void 0,void 0,(function*(){yield this.nextMiddleware.execute(e);const o=e.response;if(t<i.maxRedirects&&this.isRedirect(o)&&this.hasLocationHeader(o)&&i.shouldRedirect(o)){if(++t,o.status===E.STATUS_CODE_SEE_OTHER)e.options.method=s.GET,delete e.options.body;else{const t=this.getLocationHeader(o);!this.isRelativeURL(t)&&this.shouldDropAuthorizationHeader(o.url,t)&&delete e.options.headers[E.AUTHORIZATION_HEADER],yield this.updateRequestUrl(t,e)}yield this.executeWithRedirect(e,t,i)}}))}execute(e){return o(this,void 0,void 0,(function*(){const t=this.getOptions(e);return e.options.redirect=E.MANUAL_REDIRECT,_.updateFeatureUsageFlag(e,y.REDIRECT_HANDLER_ENABLED),yield this.executeWithRedirect(e,0,t)}))}setNext(e){this.nextMiddleware=e}}E.REDIRECT_STATUS_CODES=[301,302,303,307,308],E.STATUS_CODE_SEE_OTHER=303,E.LOCATION_HEADER="Location",E.AUTHORIZATION_HEADER="Authorization",E.MANUAL_REDIRECT="manual";class O{execute(e){return o(this,void 0,void 0,(function*(){const t="string"==typeof e.request?e.request:e.request.url;if(c(t)||e.customHosts&&h(t,e.customHosts)){let t=f(e.request,e.options,O.CLIENT_REQUEST_ID_HEADER);t||(t=(()=>{let e="";for(let t=0;t<32;t++)8!==t&&12!==t&&16!==t&&20!==t||(e+="-"),e+=Math.floor(16*Math.random()).toString(16);return e})(),v(e.request,e.options,O.CLIENT_REQUEST_ID_HEADER,t));let i,o=`${O.PRODUCT_NAME}/3.0.2`;if(e.middlewareControl instanceof g&&(i=e.middlewareControl.getMiddlewareOptions(_)),i){const e=i.getFeatureUsage();o+=` (${O.FEATURE_USAGE_STRING}=${e})`}m(e.request,e.options,O.SDK_VERSION_HEADER,o)}else delete e.options.headers[O.CLIENT_REQUEST_ID_HEADER],delete e.options.headers[O.SDK_VERSION_HEADER];return yield this.nextMiddleware.execute(e)}))}setNext(e){this.nextMiddleware=e}}O.CLIENT_REQUEST_ID_HEADER="client-request-id",O.SDK_VERSION_HEADER="SdkVersion",O.PRODUCT_NAME="graph-js",O.FEATURE_USAGE_STRING="featureUsage",(x=w||(w={}))[x.MANUAL=0]="MANUAL",x[x.RANDOM=1]="RANDOM",function(e){e.ARRAYBUFFER="arraybuffer",e.BLOB="blob",e.DOCUMENT="document",e.JSON="json",e.RAW="raw",e.STREAM="stream",e.TEXT="text"}(k||(k={})),function(e){e.TEXT_HTML="text/html",e.TEXT_XML="text/xml",e.APPLICATION_XML="application/xml",e.APPLICATION_XHTML="application/xhtml+xml"}(C||(C={})),function(e){e.TEXT_PLAIN="text/plain",e.APPLICATION_JSON="application/json"}($||($={})),function(e){e.DOCUMENT="^(text\\/(html|xml))|(application\\/(xml|xhtml\\+xml))$",e.IMAGE="^image\\/.+"}(S||(S={}));class F{static parseDocumentResponse(e,t){return"undefined"!=typeof DOMParser?new Promise(((i,o)=>{e.text().then((e=>{try{const o=(new DOMParser).parseFromString(e,t);i(o)}catch(e){o(e)}}))})):Promise.resolve(e.body)}static convertResponse(e,t){return o(this,void 0,void 0,(function*(){if(204===e.status)return Promise.resolve();let i;const o=e.headers.get("Content-type");switch(t){case k.ARRAYBUFFER:i=yield e.arrayBuffer();break;case k.BLOB:i=yield e.blob();break;case k.DOCUMENT:i=yield F.parseDocumentResponse(e,C.TEXT_XML);break;case k.JSON:i=yield e.json();break;case k.STREAM:i=yield Promise.resolve(e.body);break;case k.TEXT:i=yield e.text();break;default:if(null!==o){const t=o.split(";")[0];i=new RegExp(S.DOCUMENT).test(t)?yield F.parseDocumentResponse(e,t):new RegExp(S.IMAGE).test(t)?e.blob():t===$.TEXT_PLAIN?yield e.text():t===$.APPLICATION_JSON?yield e.json():Promise.resolve(e.body)}else i=Promise.resolve(e.body)}return i}))}static getResponse(e,t,i){return o(this,void 0,void 0,(function*(){if(t===k.RAW)return Promise.resolve(e);{const o=yield F.convertResponse(e,t);if(!e.ok)throw o;if("function"!=typeof i)return o;i(null,o)}}))}}class A{constructor(e=-1,t=-1){this.minValue=e,this.maxValue=t}}class R{constructor(e,t){this._location=t,this._responseBody=e}get location(){return this._location}set location(e){this._location=e}get responseBody(){return this._responseBody}set responseBody(e){this._responseBody=e}static CreateUploadResult(e,t){return new R(e,t.get("location"))}}class V{constructor(e,t,i,o={}){if(this.DEFAULT_FILE_SIZE=5242880,this.client=e,!t.sliceFile)throw new a("Please pass the FileUpload object, StreamUpload object or any custom implementation of the FileObject interface");this.file=t,this.file=t,o.rangeSize||(o.rangeSize=this.DEFAULT_FILE_SIZE),this.options=o,this.uploadSession=i,this.nextRange=new A(0,this.options.rangeSize-1)}static createUploadSession(e,t,i,s={}){return o(this,void 0,void 0,(function*(){const o=yield e.api(t).headers(s).post(i);return{url:o.uploadUrl,expiry:new Date(o.expirationDateTime),isCancelled:!1}}))}parseRange(e){const t=e[0];if(void 0===t||""===t)return new A;const i=t.split("-"),o=parseInt(i[0],10);let s=parseInt(i[1],10);return Number.isNaN(s)&&(s=this.file.size-1),new A(o,s)}updateTaskStatus(e){this.uploadSession.expiry=new Date(e.expirationDateTime),this.nextRange=this.parseRange(e.nextExpectedRanges)}getNextRange(){if(-1===this.nextRange.minValue)return this.nextRange;const e=this.nextRange.minValue;let t=e+this.options.rangeSize-1;return t>=this.file.size&&(t=this.file.size-1),new A(e,t)}sliceFile(e){if(console.warn("The LargeFileUploadTask.sliceFile() function has been deprecated and moved into the FileObject interface."),this.file.content instanceof ArrayBuffer||this.file.content instanceof Blob||this.file.content instanceof Uint8Array)return this.file.content.slice(e.minValue,e.maxValue+1);throw new a("The LargeFileUploadTask.sliceFile() function expects only Blob, ArrayBuffer or Uint8Array file content. Please note that the sliceFile() function is deprecated.")}upload(){return o(this,void 0,void 0,(function*(){const e=this.options&&this.options.uploadEventHandlers;for(;!this.uploadSession.isCancelled;){const t=this.getNextRange();if(-1===t.maxValue){const e=new Error("Task with which you are trying to upload is already completed, Please check for your uploaded file");throw e.name="Invalid Session",e}const i=yield this.file.sliceFile(t),o=yield this.uploadSliceGetRawResponse(i,t,this.file.size);if(!o)throw new a("Something went wrong! Large file upload slice response is null.");const s=yield F.getResponse(o);if(201===o.status||200===o.status&&s.id)return R.CreateUploadResult(s,o.headers);const n={expirationDateTime:s.expirationDateTime||s.ExpirationDateTime,nextExpectedRanges:s.NextExpectedRanges||s.nextExpectedRanges};this.updateTaskStatus(n),e&&e.progress&&e.progress(t,e.extraCallbackParam)}}))}uploadSlice(e,t,i){return o(this,void 0,void 0,(function*(){return yield this.client.api(this.uploadSession.url).headers({"Content-Length":""+(t.maxValue-t.minValue+1),"Content-Range":`bytes ${t.minValue}-${t.maxValue}/${i}`,"Content-Type":"application/octet-stream"}).put(e)}))}uploadSliceGetRawResponse(e,t,i){return o(this,void 0,void 0,(function*(){return yield this.client.api(this.uploadSession.url).headers({"Content-Length":""+(t.maxValue-t.minValue+1),"Content-Range":`bytes ${t.minValue}-${t.maxValue}/${i}`,"Content-Type":"application/octet-stream"}).responseType(k.RAW).put(e)}))}cancel(){return o(this,void 0,void 0,(function*(){const e=yield this.client.api(this.uploadSession.url).responseType(k.RAW).delete();return 204===e.status&&(this.uploadSession.isCancelled=!0),e}))}getStatus(){return o(this,void 0,void 0,(function*(){const e=yield this.client.api(this.uploadSession.url).get();return this.updateTaskStatus(e),e}))}resume(){return o(this,void 0,void 0,(function*(){return yield this.getStatus(),yield this.upload()}))}getUploadSession(){return this.uploadSession}}class M{constructor(e,t,i){if(this.content=e,this.name=t,this.size=i,!e||!t||!i)throw new a("Please provide the upload content, name of the file and size of the file")}sliceFile(e){return this.content.slice(e.minValue,e.maxValue+1)}}class z extends V{constructor(e,t,i,o){super(e,t,i,o)}static constructCreateSessionUrl(e,t=z.DEFAULT_UPLOAD_PATH){return e=e.trim(),""===(t=t.trim())&&(t="/"),"/"!==t[0]&&(t=`/${t}`),"/"!==t[t.length-1]&&(t=`${t}/`),`/me/drive/root:${t.split("/").map((e=>encodeURIComponent(e))).join("/")}${encodeURIComponent(e)}:/createUploadSession`}static getFileInfo(e,t){let i,o;if("undefined"!=typeof Blob&&e instanceof Blob)i=new File([e],t),o=i.size;else if("undefined"!=typeof File&&e instanceof File)i=e,o=i.size;else if("undefined"!=typeof Uint8Array&&e instanceof Uint8Array){const t=e;o=t.byteLength,i=t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}return{content:i,size:o}}static create(e,t,i){return o(this,void 0,void 0,(function*(){if(!e||!t||!i)throw new a("Please provide the Graph client instance, file object and OneDriveLargeFileUploadOptions value");const o=i.fileName,s=z.getFileInfo(t,o),n=new M(s.content,o,s.size);return this.createTaskWithFileObject(e,n,i)}))}static createTaskWithFileObject(e,t,i){return o(this,void 0,void 0,(function*(){if(!e||!t||!i)throw new a("Please provide the Graph client instance, FileObject interface implementation and OneDriveLargeFileUploadOptions value");const o=z.constructCreateSessionUrl(i.fileName,i.path),s={fileName:i.fileName,fileDescription:i.fileDescription,conflictBehavior:i.conflictBehavior},n=yield z.createUploadSession(e,o,s),r=((e=5242880)=>{const t=62914560;return e>t&&(e=t),(i=e)>327680&&(i=320*Math.floor(i/327680)*1024),i;var i})(i.rangeSize);return new z(e,t,n,{rangeSize:r,uploadEventHandlers:i.uploadEventHandlers})}))}static createUploadSession(e,t,i){const s=Object.create(null,{createUploadSession:{get:()=>super.createUploadSession}});return o(this,void 0,void 0,(function*(){const o={item:{"@microsoft.graph.conflictBehavior":(null==i?void 0:i.conflictBehavior)||"rename",name:null==i?void 0:i.fileName,description:null==i?void 0:i.fileDescription}};return s.createUploadSession.call(this,e,t,o)}))}commit(e,t="rename"){return o(this,void 0,void 0,(function*(){const i={name:this.file.name,"@microsoft.graph.conflictBehavior":t,"@microsoft.graph.sourceUrl":this.uploadSession.url};return yield this.client.api(e).put(i)}))}}z.DEFAULT_UPLOAD_PATH="/";class N{constructor(e){this.provider=e}getAccessToken(){return o(this,void 0,void 0,(function*(){return new Promise(((e,t)=>{this.provider(((i,s)=>o(this,void 0,void 0,(function*(){if(s)e(s);else{i||(i=new a("Access token is undefined or empty.\t\t\t\t\t\tPlease provide a valid token.\t\t\t\t\t\tFor more help - https://github.com/microsoftgraph/msgraph-sdk-javascript/blob/dev/docs/CustomAuthenticationProvider.md"));const e=yield a.setGraphClientError(i);t(e)}}))))}))}))}}class U extends Error{constructor(e=-1,t,i){super(t||i&&i.message),Object.setPrototypeOf(this,U.prototype),this.statusCode=e,this.code=null,this.requestId=null,this.date=new Date,this.body=null,this.stack=i?i.stack:this.stack}}class B{static constructError(e,t){const i=new U(t,"",e);return void 0!==e.name&&(i.code=e.name),i.body=e.toString(),i.date=new Date,i}static constructErrorFromResponse(e,t){const i=e.error,o=new U(t,i.message);return o.code=i.code,void 0!==i.innerError&&(o.requestId=i.innerError["request-id"],o.date=new Date(i.innerError.date)),o.body=JSON.stringify(i),o}static getError(e=null,t=-1,i){return o(this,void 0,void 0,(function*(){let o;if(e&&e.error?o=B.constructErrorFromResponse(e,t):e instanceof Error?o=B.constructError(e,t):(o=new U(t),o.body=e),"function"!=typeof i)return o;i(o,null)}))}}class H{constructor(e,t,i){this.parsePath=e=>{if(-1!==e.indexOf("https://")){const t=(e=e.replace("https://","")).indexOf("/");-1!==t&&(this.urlComponents.host="https://"+e.substring(0,t),e=e.substring(t+1,e.length));const i=e.indexOf("/");-1!==i&&(this.urlComponents.version=e.substring(0,i),e=e.substring(i+1,e.length))}"/"===e.charAt(0)&&(e=e.substr(1));const t=e.indexOf("?");if(-1===t)this.urlComponents.path=e;else{this.urlComponents.path=e.substr(0,t);const i=e.substring(t+1,e.length).split("&");for(const e of i)this.parseQueryParameter(e)}},this.httpClient=e,this.config=t,this.urlComponents={host:this.config.baseUrl,version:this.config.defaultVersion,oDataQueryParams:{},otherURLQueryParams:{},otherURLQueryOptions:[]},this._headers={},this._options={},this._middlewareOptions=[],this.parsePath(i)}addCsvQueryParameter(e,t,i){this.urlComponents.oDataQueryParams[e]=this.urlComponents.oDataQueryParams[e]?this.urlComponents.oDataQueryParams[e]+",":"";let o=[];i.length>1&&"string"==typeof t?o=Array.prototype.slice.call(i):"string"==typeof t?o.push(t):o=o.concat(t),this.urlComponents.oDataQueryParams[e]+=o.join(",")}buildFullUrl(){const e=(e=>{const t=e=>e.replace(/\/+$/,""),i=e=>e.replace(/^\/+/,"");return Array.prototype.slice.call(e).reduce(((e,o)=>[t(e),i(o)].join("/")))})([this.urlComponents.host,this.urlComponents.version,this.urlComponents.path])+this.createQueryString();return this.config.debugLogging&&console.log(e),e}createQueryString(){const e=this.urlComponents,t=[];if(0!==Object.keys(e.oDataQueryParams).length)for(const i in e.oDataQueryParams)Object.prototype.hasOwnProperty.call(e.oDataQueryParams,i)&&t.push(i+"="+e.oDataQueryParams[i]);if(0!==Object.keys(e.otherURLQueryParams).length)for(const i in e.otherURLQueryParams)Object.prototype.hasOwnProperty.call(e.otherURLQueryParams,i)&&t.push(i+"="+e.otherURLQueryParams[i]);if(0!==e.otherURLQueryOptions.length)for(const i of e.otherURLQueryOptions)t.push(i);return t.length>0?"?"+t.join("&"):""}parseQueryParameter(e){if("string"==typeof e)if("?"===e.charAt(0)&&(e=e.substring(1)),-1!==e.indexOf("&")){const t=e.split("&");for(const e of t)this.parseQueryParamenterString(e)}else this.parseQueryParamenterString(e);else if(e.constructor===Object)for(const t in e)Object.prototype.hasOwnProperty.call(e,t)&&this.setURLComponentsQueryParamater(t,e[t]);return this}parseQueryParamenterString(e){if(this.isValidQueryKeyValuePair(e)){const t=e.indexOf("="),i=e.substring(0,t),o=e.substring(t+1);this.setURLComponentsQueryParamater(i,o)}else this.urlComponents.otherURLQueryOptions.push(e)}setURLComponentsQueryParamater(e,t){if(-1!==l.indexOf(e)){const i=this.urlComponents.oDataQueryParams[e],o=i&&("$expand"===e||"$select"===e||"$orderby"===e);this.urlComponents.oDataQueryParams[e]=o?i+","+t:t}else this.urlComponents.otherURLQueryParams[e]=t}isValidQueryKeyValuePair(e){const t=e.indexOf("=");return-1!==t&&!(-1!==e.indexOf("(")&&e.indexOf("(")<t)}updateRequestOptions(e){const t=Object.assign({},e.headers);if(void 0!==this.config.fetchOptions){const t=Object.assign({},this.config.fetchOptions);Object.assign(e,t),void 0!==typeof this.config.fetchOptions.headers&&(e.headers=Object.assign({},this.config.fetchOptions.headers))}Object.assign(e,this._options),void 0!==e.headers&&Object.assign(t,e.headers),Object.assign(t,this._headers),e.headers=t}send(e,t,i){var s;return o(this,void 0,void 0,(function*(){let o;const n=new g(this._middlewareOptions);this.updateRequestOptions(t);const r=null===(s=this.config)||void 0===s?void 0:s.customHosts;try{return o=(yield this.httpClient.sendRequest({request:e,options:t,middlewareControl:n,customHosts:r})).response,yield F.getResponse(o,this._responseType,i)}catch(e){if(e instanceof a)throw e;let t;throw o&&(t=o.status),yield B.getError(e,t,i)}}))}setHeaderContentType(){if(!this._headers)return void this.header("Content-Type","application/json");const e=Object.keys(this._headers);for(const t of e)if("content-type"===t.toLowerCase())return;this.header("Content-Type","application/json")}header(e,t){return this._headers[e]=t,this}headers(e){for(const t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this._headers[t]=e[t]);return this}option(e,t){return this._options[e]=t,this}options(e){for(const t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this._options[t]=e[t]);return this}middlewareOptions(e){return this._middlewareOptions=e,this}version(e){return this.urlComponents.version=e,this}responseType(e){return this._responseType=e,this}select(e){return this.addCsvQueryParameter("$select",e,arguments),this}expand(e){return this.addCsvQueryParameter("$expand",e,arguments),this}orderby(e){return this.addCsvQueryParameter("$orderby",e,arguments),this}filter(e){return this.urlComponents.oDataQueryParams.$filter=e,this}search(e){return this.urlComponents.oDataQueryParams.$search=e,this}top(e){return this.urlComponents.oDataQueryParams.$top=e,this}skip(e){return this.urlComponents.oDataQueryParams.$skip=e,this}skipToken(e){return this.urlComponents.oDataQueryParams.$skipToken=e,this}count(e=!0){return this.urlComponents.oDataQueryParams.$count=e.toString(),this}query(e){return this.parseQueryParameter(e)}get(e){return o(this,void 0,void 0,(function*(){const t=this.buildFullUrl(),i={method:s.GET};return yield this.send(t,i,e)}))}post(e,t){return o(this,void 0,void 0,(function*(){const i=this.buildFullUrl(),o={method:s.POST,body:d(e)};return"FormData"===(e&&e.constructor&&e.constructor.name)?o.headers={}:(this.setHeaderContentType(),o.headers=this._headers),yield this.send(i,o,t)}))}create(e,t){return o(this,void 0,void 0,(function*(){return yield this.post(e,t)}))}put(e,t){return o(this,void 0,void 0,(function*(){const i=this.buildFullUrl();this.setHeaderContentType();const o={method:s.PUT,body:d(e)};return yield this.send(i,o,t)}))}patch(e,t){return o(this,void 0,void 0,(function*(){const i=this.buildFullUrl();this.setHeaderContentType();const o={method:s.PATCH,body:d(e)};return yield this.send(i,o,t)}))}update(e,t){return o(this,void 0,void 0,(function*(){return yield this.patch(e,t)}))}delete(e){return o(this,void 0,void 0,(function*(){const t=this.buildFullUrl(),i={method:s.DELETE};return yield this.send(t,i,e)}))}del(e){return o(this,void 0,void 0,(function*(){return yield this.delete(e)}))}getStream(e){return o(this,void 0,void 0,(function*(){const t=this.buildFullUrl(),i={method:s.GET};return this.responseType(k.STREAM),yield this.send(t,i,e)}))}putStream(e,t){return o(this,void 0,void 0,(function*(){const i=this.buildFullUrl(),o={method:s.PUT,headers:{"Content-Type":"application/octet-stream"},body:e};return yield this.send(i,o,t)}))}}class j{constructor(...e){if(!e||!e.length){const e=new Error;throw e.name="InvalidMiddlewareChain",e.message="Please provide a default middleware chain or custom middleware chain",e}this.setMiddleware(...e)}setMiddleware(...e){e.length>1?this.parseMiddleWareArray(e):this.middleware=e[0]}parseMiddleWareArray(e){e.forEach(((t,i)=>{i<e.length-1&&t.setNext(e[i+1])})),this.middleware=e[0]}sendRequest(e){return o(this,void 0,void 0,(function*(){if("string"==typeof e.request&&void 0===e.options){const e=new Error;throw e.name="InvalidRequestOptions",e.message="Unable to execute the middleware, Please provide valid options for a request",e}return yield this.middleware.execute(e),e}))}}class q{static createWithAuthenticationProvider(e){const t=new I(e),i=new P(new D),o=new O,s=new T;if(t.setNext(i),"object"==typeof process){const e=new E(new L);i.setNext(e),e.setNext(o)}else i.setNext(o);return o.setNext(s),q.createWithMiddleware(t)}static createWithMiddleware(...e){return new j(...e)}}class Z{constructor(e){this.config={baseUrl:"https://graph.microsoft.com/",debugLogging:!1,defaultVersion:"v1.0"},(()=>{if("undefined"==typeof Promise&&"undefined"==typeof fetch){const e=new Error("Library cannot function without Promise and fetch. So, please provide polyfill for them.");throw e.name="PolyFillNotAvailable",e}if("undefined"==typeof Promise){const e=new Error("Library cannot function without Promise. So, please provide polyfill for it.");throw e.name="PolyFillNotAvailable",e}if("undefined"==typeof fetch){const e=new Error("Library cannot function without fetch. So, please provide polyfill for it.");throw e.name="PolyFillNotAvailable",e}})();for(const t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this.config[t]=e[t]);let t;if(void 0!==e.authProvider&&void 0!==e.middleware){const e=new Error;throw e.name="AmbiguityInInitialization",e.message="Unable to Create Client, Please provide either authentication provider for default middleware chain or custom middleware chain not both",e}if(void 0!==e.authProvider)t=q.createWithAuthenticationProvider(e.authProvider);else{if(void 0===e.middleware){const e=new Error;throw e.name="InvalidMiddlewareChain",e.message="Unable to Create Client, Please provide either authentication provider for default middleware chain or custom middleware chain",e}t=new j(...[].concat(e.middleware))}this.httpClient=t}static init(e){const t={};for(const i in e)Object.prototype.hasOwnProperty.call(e,i)&&(t[i]="authProvider"===i?new N(e[i]):e[i]);return Z.initWithMiddleware(t)}static initWithMiddleware(e){return new Z(e)}api(e){return new H(this.httpClient,this.config,e)}}class W{}var G,Q,K;class X{constructor(){this.eventHandlers=[]}fire(e){for(const t of this.eventHandlers)t(e)}add(e){this.eventHandlers.push(e)}remove(e){for(let t=0;t<this.eventHandlers.length;t++)this.eventHandlers[t]===e&&(this.eventHandlers.splice(t,1),t--)}}class J{get isMultiAccountSupportedAndEnabled(){return!1}set baseURL(e){if(!se(e))throw new Error(`${e} is not a valid Graph URL endpoint.`);this._baseURL=e}get baseURL(){return this._baseURL}set customHosts(e){this._customHosts=e}get customHosts(){return this._customHosts}get isMultiAccountSupported(){return this.isMultipleAccountSupported}get state(){return this._state}get isIncrementalConsentDisabled(){return this._isIncrementalConsentDisabled}set isIncrementalConsentDisabled(e){this._isIncrementalConsentDisabled=e}get name(){return"MgtIProvider"}constructor(){this.isMultipleAccountDisabled=!0,this._loginChangedDispatcher=new X,this._activeAccountChangedDispatcher=new X,this._baseURL=e,this._customHosts=void 0,this._isIncrementalConsentDisabled=!1,this.isMultipleAccountSupported=!1,this._state=Q.Loading}setState(e){e!==this._state&&(this._state=e,this._loginChangedDispatcher.fire({}))}onStateChanged(e){this._loginChangedDispatcher.add(e)}removeStateChangedHandler(e){this._loginChangedDispatcher.remove(e)}setActiveAccount(e){this.fireActiveAccountChanged()}onActiveAccountChanged(e){this._activeAccountChangedDispatcher.add(e)}removeActiveAccountChangedHandler(e){this._activeAccountChangedDispatcher.remove(e)}fireActiveAccountChanged(){this._activeAccountChangedDispatcher.fire({})}getAccessTokenForScopes(...e){return this.getAccessToken({scopes:e})}}!function(e){e[e.Popup=0]="Popup",e[e.Redirect=1]="Redirect"}(G||(G={})),(K=Q||(Q={}))[K.Loading=0]="Loading",K[K.SignedOut=1]="SignedOut",K[K.SignedIn=2]="SignedIn";var Y,ee=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};class te{static get globalProvider(){return this._globalProvider}static set globalProvider(e){e!==this._globalProvider&&(this._globalProvider&&(this._globalProvider.removeStateChangedHandler(this.handleProviderStateChanged),this._globalProvider.isMultiAccountSupportedAndEnabled&&this._globalProvider.removeActiveAccountChangedHandler(this.handleActiveAccountChanged)),e&&(e.onStateChanged(this.handleProviderStateChanged),e.isMultiAccountSupportedAndEnabled&&e.onActiveAccountChanged(this.handleActiveAccountChanged)),this._globalProvider=e,this._eventDispatcher.fire(Y.ProviderChanged))}static onProviderUpdated(e){this._eventDispatcher.add(e)}static removeProviderUpdatedListener(e){this._eventDispatcher.remove(e)}static onActiveAccountChanged(e){this._activeAccountChangedDispatcher.add(e)}static removeActiveAccountChangedListener(e){this._activeAccountChangedDispatcher.remove(e)}static me(){return this.client?(this._mePromise||(this._mePromise=this.getMe()),this._mePromise):(this._mePromise=null,null)}static getMe(){return ee(this,void 0,void 0,(function*(){try{const e=yield this.client.api("me").get();if(null==e?void 0:e.id)return e}catch(e){}return null}))}static getCacheId(){var e;return ee(this,void 0,void 0,(function*(){if(this._cacheId)return this._cacheId;if((null===(e=te.globalProvider)||void 0===e?void 0:e.state)===Q.SignedIn&&!this._cacheId&&this.client)try{this._cacheId=yield this.createCacheId()}catch(e){}return this._cacheId}))}static unsetCacheId(){this._cacheId=null,this._mePromise=null}static createCacheId(){return ee(this,void 0,void 0,(function*(){if(te.globalProvider.isMultiAccountSupportedAndEnabled){const e=this.createCacheIdWithAccountDetails();if(e)return e}return yield this.createCacheIdWithUserDetails()}))}static createCacheIdWithUserDetails(){return ee(this,void 0,void 0,(function*(){const e=yield this.me();return(null==e?void 0:e.id)?e.id+"-"+e.userPrincipalName:null}))}static createCacheIdWithAccountDetails(){const e=te.globalProvider.getActiveAccount();return e.tenantId&&e.id?e.tenantId+e.id:null}static get client(){return te.globalProvider&&te.globalProvider.state===Q.SignedIn?te.globalProvider.graph.client:null}}te._eventDispatcher=new X,te._activeAccountChangedDispatcher=new X,te.handleProviderStateChanged=()=>{te.globalProvider&&te.globalProvider.state===Q.SignedIn||(te._mePromise=null),te._eventDispatcher.fire(Y.ProviderStateChanged)},te.handleActiveAccountChanged=()=>{te.unsetCacheId(),te._activeAccountChangedDispatcher.fire(null)},function(e){e[e.ProviderChanged=0]="ProviderChanged",e[e.ProviderStateChanged=1]="ProviderStateChanged"}(Y||(Y={}));const ie=(...e)=>{const t={scopes:e};return te.globalProvider.isIncrementalConsentDisabled?[]:[new b(void 0,t)]},oe=(...e)=>{const t=e[0];let i=t;for(let t=1;t<e.length;++t){const o=e[t];i.setNext&&i.setNext(o),i=o}return t},se=e=>{try{const i=new URL(e).origin;if(t.has(i))return i}catch(e){return}};class ne{constructor(e,t,i,o){this.resource=i.startsWith("/")?i:`/${i}`,this.method=o,this.index=e,this.id=t}}var re=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};class ae{static get baseUrl(){return"https://graph.microsoft.com"}constructor(e){this.graph=e,this.allRequests=[],this.requestsQueue=[],this.scopes=[],this.nextIndex=0,this.retryAfter=0}get hasRequests(){return this.requestsQueue.length>0}get(e,t,i,o){const s=this.nextIndex++,n=new ne(s,e,t,"GET");n.headers=o,this.allRequests.push(n),this.requestsQueue.push(s),i&&(this.scopes=this.scopes.concat(i))}executeNext(){return re(this,void 0,void 0,(function*(){const e=new Map;var t;if(this.retryAfter&&(yield(t=1e3*this.retryAfter,function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(void 0,void 0,void 0,(function*(){return new Promise((e=>{setTimeout(e,t)}))}))),this.retryAfter=0),!this.hasRequests)return e;const i=this.requestsQueue.splice(0,20),o=new n;for(const e of i.map((e=>this.allRequests[e])))o.addRequest({id:e.index.toString(),request:new Request(ae.baseUrl+e.resource,{method:e.method,headers:e.headers})});const s=this.scopes.length?ie(...this.scopes):[],r=this.graph.api("$batch").middlewareOptions(s),a=yield o.getContent(),l=yield r.post(a);for(const t of l.responses){const i=new W,o=parseInt(t.id,10),s=this.allRequests[o];if(i.id=s.id,i.index=s.index,i.headers=t.headers,200===t.status)"string"==typeof t.body?t.headers["Content-Type"].includes("image/jpeg")?i.content="data:image/jpeg;base64,"+t.body:t.headers["Content-Type"].includes("image/pjpeg")?i.content="data:image/pjpeg;base64,"+t.body:t.headers["Content-Type"].includes("image/png")&&(i.content="data:image/png;base64,"+t.body):i.content=t.body,e.set(s.id,i);else if(429===t.status){this.requestsQueue.unshift(o);const e=t.headers["Retry-After"];this.retryAfter=Math.max(this.retryAfter,parseInt(e,10)||1)}}return e}))}executeAll(){return re(this,void 0,void 0,(function*(){const e=new Map;for(;this.hasRequests;){const t=yield this.executeNext();for(const[i,o]of t)e.set(i,o)}return e}))}}class le{constructor(e){this.componentName="string"==typeof e?e:e.tagName.toLowerCase()}}class de{constructor(e,t){this._packageVersion=e,this._providerName=t}execute(e){var t;return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){try{if("string"==typeof e.request)if(se(e.request)){const t=[],i=e.middlewareControl.getMiddlewareOptions(le);if(i){const e=`${i.componentName}/${this._packageVersion}`;t.push(e)}if(this._providerName){const e=`${this._providerName}/${this._packageVersion}`;t.push(e)}const o=`mgt/${this._packageVersion}`;t.push(o),t.push(f(e.request,e.options,"SdkVersion"));const s=t.join(", ");v(e.request,e.options,"SdkVersion",s)}else null===(t=null==e?void 0:e.options)||void 0===t||delete t.headers.SdkVersion}catch(e){}return yield this._nextMiddleware.execute(e)}))}setNext(e){this._nextMiddleware=e}}const ce=new class{constructor(){this._disambiguation=""}get defaultPrefix(){return"mgt"}withDisambiguation(e){return e&&!this._disambiguation&&(this._disambiguation=e),this}get prefix(){return this._disambiguation?`${this.defaultPrefix}-${this._disambiguation}`:this.defaultPrefix}get disambiguation(){return this._disambiguation}get isDisambiguated(){return Boolean(this._disambiguation)}normalize(e){return this.isDisambiguated?e.toUpperCase().replace(this.prefix.toUpperCase(),this.defaultPrefix.toUpperCase()):e}};class he{get client(){return this._client}get componentName(){return this._componentName}get version(){return this._version}constructor(e,t="v1.0"){this._client=e,this._version=t}forComponent(e){const t=new he(this._client,this._version);return t.setComponent(e),t}api(e){let t=this._client.api(e).version(this._version);return this._componentName&&(t.middlewareOptions=e=>(t._middlewareOptions=t._middlewareOptions.concat(e),t),t=t.middlewareOptions([new le(this._componentName)])),t}createBatch(){return new ae(this)}setComponent(e){this._componentName=e instanceof Element?ce.normalize(e.tagName):e}}class ue extends he{static fromGraph(e){const t=new ue(e.client);return t.setComponent(e.componentName),t}constructor(e,t="beta"){super(e,t)}forComponent(e){const t=new ue(this.client);return this.setComponent(e),t}}const pe=window,ge=pe.ShadowRoot&&(void 0===pe.ShadyCSS||pe.ShadyCSS.nativeShadow)&&"adoptedStyleSheets"in Document.prototype&&"replace"in CSSStyleSheet.prototype,fe=Symbol(),ve=new WeakMap;class me{constructor(e,t,i){if(this._$cssResult$=!0,i!==fe)throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");this.cssText=e,this.t=t}get styleSheet(){let e=this.o;const t=this.t;if(ge&&void 0===e){const i=void 0!==t&&1===t.length;i&&(e=ve.get(t)),void 0===e&&((this.o=e=new CSSStyleSheet).replaceSync(this.cssText),i&&ve.set(t,e))}return e}toString(){return this.cssText}}const be=(e,...t)=>{const i=1===e.length?e[0]:t.reduce(((t,i,o)=>t+(e=>{if(!0===e._$cssResult$)return e.cssText;if("number"==typeof e)return e;throw Error("Value passed to 'css' function must be a 'css' function result: "+e+". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.")})(i)+e[o+1]),e[0]);return new me(i,e,fe)},ye=ge?e=>e:e=>e instanceof CSSStyleSheet?(e=>{let t="";for(const i of e.cssRules)t+=i.cssText;return(e=>new me("string"==typeof e?e:e+"",void 0,fe))(t)})(e):e;var we;const xe=window,ke=xe.trustedTypes,Ce=ke?ke.emptyScript:"",$e=xe.reactiveElementPolyfillSupport,Se={toAttribute(e,t){switch(t){case Boolean:e=e?Ce:null;break;case Object:case Array:e=null==e?e:JSON.stringify(e)}return e},fromAttribute(e,t){let i=e;switch(t){case Boolean:i=null!==e;break;case Number:i=null===e?null:Number(e);break;case Object:case Array:try{i=JSON.parse(e)}catch(e){i=null}}return i}},_e=(e,t)=>t!==e&&(t==t||e==e),Ie={attribute:!0,type:String,converter:Se,reflect:!1,hasChanged:_e},Te="finalized";class De extends HTMLElement{constructor(){super(),this._$Ei=new Map,this.isUpdatePending=!1,this.hasUpdated=!1,this._$El=null,this._$Eu()}static addInitializer(e){var t;this.finalize(),(null!==(t=this.h)&&void 0!==t?t:this.h=[]).push(e)}static get observedAttributes(){this.finalize();const e=[];return this.elementProperties.forEach(((t,i)=>{const o=this._$Ep(i,t);void 0!==o&&(this._$Ev.set(o,i),e.push(o))})),e}static createProperty(e,t=Ie){if(t.state&&(t.attribute=!1),this.finalize(),this.elementProperties.set(e,t),!t.noAccessor&&!this.prototype.hasOwnProperty(e)){const i="symbol"==typeof e?Symbol():"__"+e,o=this.getPropertyDescriptor(e,i,t);void 0!==o&&Object.defineProperty(this.prototype,e,o)}}static getPropertyDescriptor(e,t,i){return{get(){return this[t]},set(o){const s=this[e];this[t]=o,this.requestUpdate(e,s,i)},configurable:!0,enumerable:!0}}static getPropertyOptions(e){return this.elementProperties.get(e)||Ie}static finalize(){if(this.hasOwnProperty(Te))return!1;this[Te]=!0;const e=Object.getPrototypeOf(this);if(e.finalize(),void 0!==e.h&&(this.h=[...e.h]),this.elementProperties=new Map(e.elementProperties),this._$Ev=new Map,this.hasOwnProperty("properties")){const e=this.properties,t=[...Object.getOwnPropertyNames(e),...Object.getOwnPropertySymbols(e)];for(const i of t)this.createProperty(i,e[i])}return this.elementStyles=this.finalizeStyles(this.styles),!0}static finalizeStyles(e){const t=[];if(Array.isArray(e)){const i=new Set(e.flat(1/0).reverse());for(const e of i)t.unshift(ye(e))}else void 0!==e&&t.push(ye(e));return t}static _$Ep(e,t){const i=t.attribute;return!1===i?void 0:"string"==typeof i?i:"string"==typeof e?e.toLowerCase():void 0}_$Eu(){var e;this._$E_=new Promise((e=>this.enableUpdating=e)),this._$AL=new Map,this._$Eg(),this.requestUpdate(),null===(e=this.constructor.h)||void 0===e||e.forEach((e=>e(this)))}addController(e){var t,i;(null!==(t=this._$ES)&&void 0!==t?t:this._$ES=[]).push(e),void 0!==this.renderRoot&&this.isConnected&&(null===(i=e.hostConnected)||void 0===i||i.call(e))}removeController(e){var t;null===(t=this._$ES)||void 0===t||t.splice(this._$ES.indexOf(e)>>>0,1)}_$Eg(){this.constructor.elementProperties.forEach(((e,t)=>{this.hasOwnProperty(t)&&(this._$Ei.set(t,this[t]),delete this[t])}))}createRenderRoot(){var e;const t=null!==(e=this.shadowRoot)&&void 0!==e?e:this.attachShadow(this.constructor.shadowRootOptions);return((e,t)=>{ge?e.adoptedStyleSheets=t.map((e=>e instanceof CSSStyleSheet?e:e.styleSheet)):t.forEach((t=>{const i=document.createElement("style"),o=pe.litNonce;void 0!==o&&i.setAttribute("nonce",o),i.textContent=t.cssText,e.appendChild(i)}))})(t,this.constructor.elementStyles),t}connectedCallback(){var e;void 0===this.renderRoot&&(this.renderRoot=this.createRenderRoot()),this.enableUpdating(!0),null===(e=this._$ES)||void 0===e||e.forEach((e=>{var t;return null===(t=e.hostConnected)||void 0===t?void 0:t.call(e)}))}enableUpdating(e){}disconnectedCallback(){var e;null===(e=this._$ES)||void 0===e||e.forEach((e=>{var t;return null===(t=e.hostDisconnected)||void 0===t?void 0:t.call(e)}))}attributeChangedCallback(e,t,i){this._$AK(e,i)}_$EO(e,t,i=Ie){var o;const s=this.constructor._$Ep(e,i);if(void 0!==s&&!0===i.reflect){const n=(void 0!==(null===(o=i.converter)||void 0===o?void 0:o.toAttribute)?i.converter:Se).toAttribute(t,i.type);this._$El=e,null==n?this.removeAttribute(s):this.setAttribute(s,n),this._$El=null}}_$AK(e,t){var i;const o=this.constructor,s=o._$Ev.get(e);if(void 0!==s&&this._$El!==s){const e=o.getPropertyOptions(s),n="function"==typeof e.converter?{fromAttribute:e.converter}:void 0!==(null===(i=e.converter)||void 0===i?void 0:i.fromAttribute)?e.converter:Se;this._$El=s,this[s]=n.fromAttribute(t,e.type),this._$El=null}}requestUpdate(e,t,i){let o=!0;void 0!==e&&(((i=i||this.constructor.getPropertyOptions(e)).hasChanged||_e)(this[e],t)?(this._$AL.has(e)||this._$AL.set(e,t),!0===i.reflect&&this._$El!==e&&(void 0===this._$EC&&(this._$EC=new Map),this._$EC.set(e,i))):o=!1),!this.isUpdatePending&&o&&(this._$E_=this._$Ej())}async _$Ej(){this.isUpdatePending=!0;try{await this._$E_}catch(e){Promise.reject(e)}const e=this.scheduleUpdate();return null!=e&&await e,!this.isUpdatePending}scheduleUpdate(){return this.performUpdate()}performUpdate(){var e;if(!this.isUpdatePending)return;this.hasUpdated,this._$Ei&&(this._$Ei.forEach(((e,t)=>this[t]=e)),this._$Ei=void 0);let t=!1;const i=this._$AL;try{t=this.shouldUpdate(i),t?(this.willUpdate(i),null===(e=this._$ES)||void 0===e||e.forEach((e=>{var t;return null===(t=e.hostUpdate)||void 0===t?void 0:t.call(e)})),this.update(i)):this._$Ek()}catch(e){throw t=!1,this._$Ek(),e}t&&this._$AE(i)}willUpdate(e){}_$AE(e){var t;null===(t=this._$ES)||void 0===t||t.forEach((e=>{var t;return null===(t=e.hostUpdated)||void 0===t?void 0:t.call(e)})),this.hasUpdated||(this.hasUpdated=!0,this.firstUpdated(e)),this.updated(e)}_$Ek(){this._$AL=new Map,this.isUpdatePending=!1}get updateComplete(){return this.getUpdateComplete()}getUpdateComplete(){return this._$E_}shouldUpdate(e){return!0}update(e){void 0!==this._$EC&&(this._$EC.forEach(((e,t)=>this._$EO(t,this[t],e))),this._$EC=void 0),this._$Ek()}updated(e){}firstUpdated(e){}}var Pe;De[Te]=!0,De.elementProperties=new Map,De.elementStyles=[],De.shadowRootOptions={mode:"open"},null==$e||$e({ReactiveElement:De}),(null!==(we=xe.reactiveElementVersions)&&void 0!==we?we:xe.reactiveElementVersions=[]).push("1.6.3");const Le=window,Ee=Le.trustedTypes,Oe=Ee?Ee.createPolicy("lit-html",{createHTML:e=>e}):void 0,Fe="$lit$",Ae=`lit$${(Math.random()+"").slice(9)}$`,Re="?"+Ae,Ve=`<${Re}>`,Me=document,ze=()=>Me.createComment(""),Ne=e=>null===e||"object"!=typeof e&&"function"!=typeof e,Ue=Array.isArray,Be=e=>Ue(e)||"function"==typeof(null==e?void 0:e[Symbol.iterator]),He="[ \t\n\f\r]",je=/<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g,qe=/-->/g,Ze=/>/g,We=RegExp(`>|${He}(?:([^\\s"'>=/]+)(${He}*=${He}*(?:[^ \t\n\f\r"'\`<>=]|("|')|))|$)`,"g"),Ge=/'/g,Qe=/"/g,Ke=/^(?:script|style|textarea|title)$/i,Xe=e=>(t,...i)=>({_$litType$:e,strings:t,values:i}),Je=Xe(1),Ye=(Xe(2),Symbol.for("lit-noChange")),et=Symbol.for("lit-nothing"),tt=new WeakMap,it=Me.createTreeWalker(Me,129,null,!1);function ot(e,t){if(!Array.isArray(e)||!e.hasOwnProperty("raw"))throw Error("invalid template strings array");return void 0!==Oe?Oe.createHTML(t):t}const st=(e,t)=>{const i=e.length-1,o=[];let s,n=2===t?"<svg>":"",r=je;for(let t=0;t<i;t++){const i=e[t];let a,l,d=-1,c=0;for(;c<i.length&&(r.lastIndex=c,l=r.exec(i),null!==l);)c=r.lastIndex,r===je?"!--"===l[1]?r=qe:void 0!==l[1]?r=Ze:void 0!==l[2]?(Ke.test(l[2])&&(s=RegExp("</"+l[2],"g")),r=We):void 0!==l[3]&&(r=We):r===We?">"===l[0]?(r=null!=s?s:je,d=-1):void 0===l[1]?d=-2:(d=r.lastIndex-l[2].length,a=l[1],r=void 0===l[3]?We:'"'===l[3]?Qe:Ge):r===Qe||r===Ge?r=We:r===qe||r===Ze?r=je:(r=We,s=void 0);const h=r===We&&e[t+1].startsWith("/>")?" ":"";n+=r===je?i+Ve:d>=0?(o.push(a),i.slice(0,d)+Fe+i.slice(d)+Ae+h):i+Ae+(-2===d?(o.push(void 0),t):h)}return[ot(e,n+(e[i]||"<?>")+(2===t?"</svg>":"")),o]};class nt{constructor({strings:e,_$litType$:t},i){let o;this.parts=[];let s=0,n=0;const r=e.length-1,a=this.parts,[l,d]=st(e,t);if(this.el=nt.createElement(l,i),it.currentNode=this.el.content,2===t){const e=this.el.content,t=e.firstChild;t.remove(),e.append(...t.childNodes)}for(;null!==(o=it.nextNode())&&a.length<r;){if(1===o.nodeType){if(o.hasAttributes()){const e=[];for(const t of o.getAttributeNames())if(t.endsWith(Fe)||t.startsWith(Ae)){const i=d[n++];if(e.push(t),void 0!==i){const e=o.getAttribute(i.toLowerCase()+Fe).split(Ae),t=/([.?@])?(.*)/.exec(i);a.push({type:1,index:s,name:t[2],strings:e,ctor:"."===t[1]?ct:"?"===t[1]?ut:"@"===t[1]?pt:dt})}else a.push({type:6,index:s})}for(const t of e)o.removeAttribute(t)}if(Ke.test(o.tagName)){const e=o.textContent.split(Ae),t=e.length-1;if(t>0){o.textContent=Ee?Ee.emptyScript:"";for(let i=0;i<t;i++)o.append(e[i],ze()),it.nextNode(),a.push({type:2,index:++s});o.append(e[t],ze())}}}else if(8===o.nodeType)if(o.data===Re)a.push({type:2,index:s});else{let e=-1;for(;-1!==(e=o.data.indexOf(Ae,e+1));)a.push({type:7,index:s}),e+=Ae.length-1}s++}}static createElement(e,t){const i=Me.createElement("template");return i.innerHTML=e,i}}function rt(e,t,i=e,o){var s,n,r,a;if(t===Ye)return t;let l=void 0!==o?null===(s=i._$Co)||void 0===s?void 0:s[o]:i._$Cl;const d=Ne(t)?void 0:t._$litDirective$;return(null==l?void 0:l.constructor)!==d&&(null===(n=null==l?void 0:l._$AO)||void 0===n||n.call(l,!1),void 0===d?l=void 0:(l=new d(e),l._$AT(e,i,o)),void 0!==o?(null!==(r=(a=i)._$Co)&&void 0!==r?r:a._$Co=[])[o]=l:i._$Cl=l),void 0!==l&&(t=rt(e,l._$AS(e,t.values),l,o)),t}class at{constructor(e,t){this._$AV=[],this._$AN=void 0,this._$AD=e,this._$AM=t}get parentNode(){return this._$AM.parentNode}get _$AU(){return this._$AM._$AU}u(e){var t;const{el:{content:i},parts:o}=this._$AD,s=(null!==(t=null==e?void 0:e.creationScope)&&void 0!==t?t:Me).importNode(i,!0);it.currentNode=s;let n=it.nextNode(),r=0,a=0,l=o[0];for(;void 0!==l;){if(r===l.index){let t;2===l.type?t=new lt(n,n.nextSibling,this,e):1===l.type?t=new l.ctor(n,l.name,l.strings,this,e):6===l.type&&(t=new gt(n,this,e)),this._$AV.push(t),l=o[++a]}r!==(null==l?void 0:l.index)&&(n=it.nextNode(),r++)}return it.currentNode=Me,s}v(e){let t=0;for(const i of this._$AV)void 0!==i&&(void 0!==i.strings?(i._$AI(e,i,t),t+=i.strings.length-2):i._$AI(e[t])),t++}}class lt{constructor(e,t,i,o){var s;this.type=2,this._$AH=et,this._$AN=void 0,this._$AA=e,this._$AB=t,this._$AM=i,this.options=o,this._$Cp=null===(s=null==o?void 0:o.isConnected)||void 0===s||s}get _$AU(){var e,t;return null!==(t=null===(e=this._$AM)||void 0===e?void 0:e._$AU)&&void 0!==t?t:this._$Cp}get parentNode(){let e=this._$AA.parentNode;const t=this._$AM;return void 0!==t&&11===(null==e?void 0:e.nodeType)&&(e=t.parentNode),e}get startNode(){return this._$AA}get endNode(){return this._$AB}_$AI(e,t=this){e=rt(this,e,t),Ne(e)?e===et||null==e||""===e?(this._$AH!==et&&this._$AR(),this._$AH=et):e!==this._$AH&&e!==Ye&&this._(e):void 0!==e._$litType$?this.g(e):void 0!==e.nodeType?this.$(e):Be(e)?this.T(e):this._(e)}k(e){return this._$AA.parentNode.insertBefore(e,this._$AB)}$(e){this._$AH!==e&&(this._$AR(),this._$AH=this.k(e))}_(e){this._$AH!==et&&Ne(this._$AH)?this._$AA.nextSibling.data=e:this.$(Me.createTextNode(e)),this._$AH=e}g(e){var t;const{values:i,_$litType$:o}=e,s="number"==typeof o?this._$AC(e):(void 0===o.el&&(o.el=nt.createElement(ot(o.h,o.h[0]),this.options)),o);if((null===(t=this._$AH)||void 0===t?void 0:t._$AD)===s)this._$AH.v(i);else{const e=new at(s,this),t=e.u(this.options);e.v(i),this.$(t),this._$AH=e}}_$AC(e){let t=tt.get(e.strings);return void 0===t&&tt.set(e.strings,t=new nt(e)),t}T(e){Ue(this._$AH)||(this._$AH=[],this._$AR());const t=this._$AH;let i,o=0;for(const s of e)o===t.length?t.push(i=new lt(this.k(ze()),this.k(ze()),this,this.options)):i=t[o],i._$AI(s),o++;o<t.length&&(this._$AR(i&&i._$AB.nextSibling,o),t.length=o)}_$AR(e=this._$AA.nextSibling,t){var i;for(null===(i=this._$AP)||void 0===i||i.call(this,!1,!0,t);e&&e!==this._$AB;){const t=e.nextSibling;e.remove(),e=t}}setConnected(e){var t;void 0===this._$AM&&(this._$Cp=e,null===(t=this._$AP)||void 0===t||t.call(this,e))}}class dt{constructor(e,t,i,o,s){this.type=1,this._$AH=et,this._$AN=void 0,this.element=e,this.name=t,this._$AM=o,this.options=s,i.length>2||""!==i[0]||""!==i[1]?(this._$AH=Array(i.length-1).fill(new String),this.strings=i):this._$AH=et}get tagName(){return this.element.tagName}get _$AU(){return this._$AM._$AU}_$AI(e,t=this,i,o){const s=this.strings;let n=!1;if(void 0===s)e=rt(this,e,t,0),n=!Ne(e)||e!==this._$AH&&e!==Ye,n&&(this._$AH=e);else{const o=e;let r,a;for(e=s[0],r=0;r<s.length-1;r++)a=rt(this,o[i+r],t,r),a===Ye&&(a=this._$AH[r]),n||(n=!Ne(a)||a!==this._$AH[r]),a===et?e=et:e!==et&&(e+=(null!=a?a:"")+s[r+1]),this._$AH[r]=a}n&&!o&&this.j(e)}j(e){e===et?this.element.removeAttribute(this.name):this.element.setAttribute(this.name,null!=e?e:"")}}class ct extends dt{constructor(){super(...arguments),this.type=3}j(e){this.element[this.name]=e===et?void 0:e}}const ht=Ee?Ee.emptyScript:"";class ut extends dt{constructor(){super(...arguments),this.type=4}j(e){e&&e!==et?this.element.setAttribute(this.name,ht):this.element.removeAttribute(this.name)}}class pt extends dt{constructor(e,t,i,o,s){super(e,t,i,o,s),this.type=5}_$AI(e,t=this){var i;if((e=null!==(i=rt(this,e,t,0))&&void 0!==i?i:et)===Ye)return;const o=this._$AH,s=e===et&&o!==et||e.capture!==o.capture||e.once!==o.once||e.passive!==o.passive,n=e!==et&&(o===et||s);s&&this.element.removeEventListener(this.name,this,o),n&&this.element.addEventListener(this.name,this,e),this._$AH=e}handleEvent(e){var t,i;"function"==typeof this._$AH?this._$AH.call(null!==(i=null===(t=this.options)||void 0===t?void 0:t.host)&&void 0!==i?i:this.element,e):this._$AH.handleEvent(e)}}class gt{constructor(e,t,i){this.element=e,this.type=6,this._$AN=void 0,this._$AM=t,this.options=i}get _$AU(){return this._$AM._$AU}_$AI(e){rt(this,e)}}const ft={O:Fe,P:Ae,A:Re,C:1,M:st,L:at,R:Be,D:rt,I:lt,V:dt,H:ut,N:pt,U:ct,F:gt},vt=Le.litHtmlPolyfillSupport;var mt,bt;null==vt||vt(nt,lt),(null!==(Pe=Le.litHtmlVersions)&&void 0!==Pe?Pe:Le.litHtmlVersions=[]).push("2.8.0");class yt extends De{constructor(){super(...arguments),this.renderOptions={host:this},this._$Do=void 0}createRenderRoot(){var e,t;const i=super.createRenderRoot();return null!==(e=(t=this.renderOptions).renderBefore)&&void 0!==e||(t.renderBefore=i.firstChild),i}update(e){const t=this.render();this.hasUpdated||(this.renderOptions.isConnected=this.isConnected),super.update(e),this._$Do=((e,t,i)=>{var o,s;const n=null!==(o=null==i?void 0:i.renderBefore)&&void 0!==o?o:t;let r=n._$litPart$;if(void 0===r){const e=null!==(s=null==i?void 0:i.renderBefore)&&void 0!==s?s:null;n._$litPart$=r=new lt(t.insertBefore(ze(),e),e,void 0,null!=i?i:{})}return r._$AI(e),r})(t,this.renderRoot,this.renderOptions)}connectedCallback(){var e;super.connectedCallback(),null===(e=this._$Do)||void 0===e||e.setConnected(!0)}disconnectedCallback(){var e;super.disconnectedCallback(),null===(e=this._$Do)||void 0===e||e.setConnected(!1)}render(){return Ye}}yt.finalized=!0,yt._$litElement$=!0,null===(mt=globalThis.litElementHydrateSupport)||void 0===mt||mt.call(globalThis,{LitElement:yt});const wt=globalThis.litElementPolyfillSupport;null==wt||wt({LitElement:yt}),(null!==(bt=globalThis.litElementVersions)&&void 0!==bt?bt:globalThis.litElementVersions=[]).push("3.3.3");const xt=(e,t)=>"method"===t.kind&&t.descriptor&&!("value"in t.descriptor)?{...t,finisher(i){i.createProperty(t.key,e)}}:{kind:"field",key:Symbol(),placement:"own",descriptor:{},originalKey:t.key,initializer(){"function"==typeof t.initializer&&(this[t.key]=t.initializer.call(this))},finisher(i){i.createProperty(t.key,e)}},kt=(e,t,i)=>{t.constructor.createProperty(i,e)};function Ct(e){return(t,i)=>void 0!==i?kt(e,t,i):xt(e,t)}function $t(e){return Ct({...e,state:!0})}var St;null===(St=window.HTMLSlotElement)||void 0===St||St.prototype.assignedElements;class _t{static get strings(){return this._strings}static set strings(e){this._strings=e,this._stringsEventDispatcher.fire(null)}static getDocumentDirection(){var e,t;switch((null===(e=document.body)||void 0===e?void 0:e.getAttribute("dir"))||(null===(t=document.documentElement)||void 0===t?void 0:t.getAttribute("dir"))){case"rtl":return"rtl";case"auto":return"auto";default:return"ltr"}}static onStringsUpdated(e){this._stringsEventDispatcher.add(e)}static removeOnStringsUpdated(e){this._stringsEventDispatcher.remove(e)}static onDirectionUpdated(e){this._directionEventDispatcher.add(e),this.initDirection()}static removeOnDirectionUpdated(e){this._directionEventDispatcher.remove(e)}static initDirection(){if(this._isDirectionInit)return;this._isDirectionInit=!0,this.mutationObserver=new MutationObserver((e=>{e.forEach((e=>{"dir"===e.attributeName&&this._directionEventDispatcher.fire(null)}))}));const e={attributes:!0,attributeFilter:["dir"]};this.mutationObserver.observe(document.body,e),this.mutationObserver.observe(document.documentElement,e)}static updateStringsForTag(e,t){var i;if((e=e.toLowerCase()).startsWith("mgt-")&&(e=e.substring(4)),this._strings&&t){for(const e of Object.entries(t)){const i=this._strings[e[0]];"string"==typeof i&&(t[e[0]]=i)}if(null===(i=this._strings._components)||void 0===i?void 0:i[e]){const i=this._strings._components[e];for(const e of Object.keys(i))t[e]&&(t[e]=i[e])}}return t}}_t._stringsEventDispatcher=new X,_t._directionEventDispatcher=new X,_t._isDirectionInit=!1;const It="3.1.3";var Tt,Dt=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};!function(e){e.mobile="",e.tablet="tablet",e.desktop="desktop"}(Tt||(Tt={}));class Pt extends yt{static get packageVersion(){return It}get mediaQuery(){return this.offsetWidth<768?Tt.mobile:this.offsetWidth<1200?Tt.tablet:Tt.desktop}get isLoadingState(){return this._isLoadingState}get isFirstUpdated(){return this._isFirstUpdated}get strings(){return{}}constructor(){super(),this.direction="ltr",this._isLoadingState=!1,this._isFirstUpdated=!1,this.setLoadingState=e=>{this._isLoadingState!==e&&(this._isLoadingState=e,this.requestUpdate("isLoadingState"))},this.handleProviderUpdates=()=>{this.requestStateUpdate()},this.handleActiveAccountUpdates=()=>{this.clearState(),this.requestStateUpdate()},this.handleLocalizationChanged=()=>{_t.updateStringsForTag(this.tagName,this.strings),this.requestUpdate()},this.handleDirectionChanged=()=>{this.direction=_t.getDocumentDirection()},this.handleDirectionChanged(),this.handleLocalizationChanged()}connectedCallback(){super.connectedCallback(),_t.onStringsUpdated(this.handleLocalizationChanged),_t.onDirectionUpdated(this.handleDirectionChanged)}disconnectedCallback(){super.disconnectedCallback(),_t.removeOnStringsUpdated(this.handleLocalizationChanged),_t.removeOnDirectionUpdated(this.handleDirectionChanged),te.removeProviderUpdatedListener(this.handleProviderUpdates),te.removeActiveAccountChangedListener(this.handleActiveAccountUpdates)}firstUpdated(e){super.firstUpdated(e),this._isFirstUpdated=!0,te.onProviderUpdated(this.handleProviderUpdates),te.onActiveAccountChanged(this.handleActiveAccountUpdates),this.requestStateUpdate()}loadState(){return Promise.resolve()}clearState(){}fireCustomEvent(e,t,i=!1,o=!1,s=!1){const n=new CustomEvent(e,{bubbles:i,cancelable:o,composed:s,detail:t});return this.dispatchEvent(n)}updated(e){super.updated(e);const t=new CustomEvent("updated",{bubbles:!0,cancelable:!0});this.dispatchEvent(t)}requestStateUpdate(e=!1){return Dt(this,void 0,void 0,(function*(){if(!this._isFirstUpdated)return;this.isLoadingState&&!e&&(yield this._currentLoadStatePromise);const t=te.globalProvider;if(!t)return Promise.resolve();if(t.state!==Q.SignedOut){if(t.state===Q.Loading)return Promise.resolve();{const t=new Promise(((i,o)=>Dt(this,void 0,void 0,(function*(){try{this.setLoadingState(!0),this.fireCustomEvent("loadingInitiated"),yield this.loadState(),this.setLoadingState(!1),this.fireCustomEvent("loadingCompleted"),i()}catch(e){this.clearState(),this.setLoadingState(!1),this.fireCustomEvent("loadingFailed"),o(e)}return this._currentLoadStatePromise=this.isLoadingState&&this._currentLoadStatePromise&&e?this._currentLoadStatePromise.then((()=>t)):t}))))}}else this.clearState()}))}}!function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);n>3&&r&&Object.defineProperty(t,i,r)}([$t(),function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}("design:type",String)],Pt.prototype,"direction",void 0);var Lt=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Et=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};class Ot extends Pt{constructor(){super(...arguments),this.stateChangedHandler=()=>{this.fireCustomEvent("onStateChanged",this.provider.state)}}get provider(){return this._provider}set provider(e){this._provider&&this.provider.removeStateChangedHandler((()=>this.stateChangedHandler)),this._provider=e,this._provider&&this.provider.onStateChanged((()=>this.stateChangedHandler))}get isAvailable(){return!0}firstUpdated(e){super.firstUpdated(e);let t=!1;if(this.dependsOn){let e=this.dependsOn;for(;e;){if(e.isAvailable){t=!0;break}e=e.dependsOn}}!t&&this.isAvailable&&this.initializeProvider()}initializeProvider(){}}Lt([Ct({attribute:"depends-on",converter:e=>document.querySelector(e),type:String}),Et("design:type",Ot)],Ot.prototype,"dependsOn",void 0),Lt([Ct({attribute:"base-url",type:String}),Et("design:type",String)],Ot.prototype,"baseUrl",void 0),Lt([Ct({attribute:"custom-hosts",type:String,converter:e=>e.split(",").map((e=>e.trim()))}),Et("design:type",Array)],Ot.prototype,"customHosts",void 0);const Ft=(e,t)=>At(e,t,new Set),At=(e,t,i)=>{const o=Object.prototype.toString.call(e),s=Object.prototype.toString.call(t);if("object"==typeof e&&"object"==typeof t&&o===s&&"[object Object]"===o&&!i.has(e)){i.add(e);for(const o in e)if(!At(e[o],t[o],i))return!1;for(const i in t)if(!Object.prototype.hasOwnProperty.call(e,i))return!1;return!0}if(Array.isArray(e)&&Array.isArray(t)&&!i.has(e)){if(i.add(e),e.length!==t.length)return!1;for(let o=0;o<e.length;o++)if(!At(e[o],t[o],i))return!1;return!0}return e===t},Rt=(e,t)=>{if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;if(0===e.length)return!0;const i=new Set(e);for(const e of t)if(!i.has(e))return!1;return!0};class Vt{static renderTemplate(e,t,i){var o;let s;if(t.$parentTemplateContext&&(i=Object.assign(Object.assign({},i),{$parent:t.$parentTemplateContext})),null===(o=t.content)||void 0===o?void 0:o.childNodes.length){const o=t.content.cloneNode(!0);s=this.renderNode(o,e,i)}else if(t.childNodes.length){const o=document.createElement("div");for(const e of t.childNodes)o.appendChild(this.simpleCloneNode(e));s=this.renderNode(o,e,i)}s&&e.appendChild(s)}static setBindingSyntax(e,t){this._startExpression=e,this._endExpression=t;const i=this.escapeRegex(this._startExpression),o=this.escapeRegex(this._endExpression);this._expression=new RegExp(`${i}\\s*([$\\w\\.,'"\\s()\\[\\]]+)\\s*${o}`,"g")}static get globalContext(){return this._globalContext}static get expression(){return this._expression||this.setBindingSyntax("{{","}}"),this._expression}static escapeRegex(e){return e.replace(/[-/\\^$*+?.()|[\]{}]/g,"\\$&")}static simpleCloneNode(e){if(!e)return null;const t=e.cloneNode(!1);for(const i of e.childNodes){const e=this.simpleCloneNode(i);e&&t.appendChild(e)}return t}static expandExpressionsAsString(e,t){return e.replace(this.expression,((e,i)=>{const o=this.evalInContext(i||this.trimExpression(e),t);return o?"object"==typeof o?JSON.stringify(o):o.toString():""}))}static renderNode(e,t,i){if("#text"===e.nodeName)return e.textContent=this.expandExpressionsAsString(e.textContent,i),e;if("TEMPLATE"===e.nodeName)return e.$parentTemplateContext=i,e;const o=e;if(o.attributes)for(const e of o.attributes)if("data-props"===e.name){const s=this.trimExpression(e.value);for(const e of s.split(",")){const s=e.trim().split(":");if(2===s.length){const e=s[0].trim(),n=this.evalInContext(s[1].trim(),i);e.startsWith("@")?"function"==typeof n&&o.addEventListener(e.substring(1),(e=>n(e,i,t))):o[e]=n}}}else o.setAttribute(e.name,this.expandExpressionsAsString(e.value,i));const s=[],n=[];let r=!1;for(const o of e.childNodes){const e=o;let a=!1;if(e.dataset){let l=!1;if(e.dataset.if){const t=e.dataset.if;this.evalBoolInContext(this.trimExpression(t),i)?(e.removeAttribute("data-if"),r=!0,a=!0):(n.push(e),l=!0)}else void 0!==e.dataset.else&&(r?(n.push(e),l=!0):e.removeAttribute("data-else"));e.dataset.for&&!l?s.push(e):l||this.renderNode(o,t,i)}else this.renderNode(o,t,i);a||"#text"===o.nodeName||(r=!1)}for(const e of n)o.removeChild(e);for(const e of s){const s=e.dataset.for,n=this.trimExpression(s).split(/\s(in|of)\s/i);if(3===n.length){const s=n[0].trim(),r=n[2].trim(),a=this.evalInContext(r,i);if(Array.isArray(a)){e.removeAttribute("data-for");for(let n=0;n<a.length;n++){const r=Object.assign({$index:n},i);r[s]=a[n];const l=e.cloneNode(!0);this.renderNode(l,t,r),o.insertBefore(l,e)}}o.removeChild(e)}}return e}static evalBoolInContext(e,t){return t=Object.assign(Object.assign({},t),this.globalContext),new Function("with(this) { return !!("+e+")}").call(t)}static evalInContext(e,t){t=Object.assign(Object.assign({},t),this.globalContext);const i=new Function("with(this) { return "+e+";}");let o;try{o=i.call(t)}catch(e){}return o}static trimExpression(e){return(e=e.trim()).startsWith(this._startExpression)&&e.endsWith(this._endExpression)&&(e=(e=e.substr(this._startExpression.length,e.length-this._startExpression.length-this._endExpression.length)).trim()),e}}Vt._globalContext={};var Mt=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},zt=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};class Nt extends Pt{constructor(){super(),this.templates={},this._renderedSlots=!1,this._renderedTemplates={},this._slotNamesAddedDuringRender=[],this.templateContext=this.templateContext||{}}update(e){this.templates=this.getTemplates(),this._slotNamesAddedDuringRender=[],super.update(e)}updated(e){super.updated(e),this.removeUnusedSlottedElements()}renderTemplate(e,t,i){if(!this.hasTemplate(e))return null;i=i||e,this._slotNamesAddedDuringRender.push(i),this._renderedSlots=!0;const o=Je`
      <slot name=${i}></slot>
    `,s=Object.assign(Object.assign({},t),this.templateContext);if(Object.prototype.hasOwnProperty.call(this._renderedTemplates,i)){const{context:e,slot:t}=this._renderedTemplates[i];if(Ft(e,s))return o;this.removeChild(t)}const n=document.createElement("div");n.slot=i,n.dataset.generated="template",Vt.renderTemplate(n,this.templates[e],s),this.appendChild(n),this._renderedTemplates[i]={context:s,slot:n};const r={templateType:e,context:s,element:n};return this.fireCustomEvent("templateRendered",r),o}hasTemplate(e){var t;return Boolean(null===(t=this.templates)||void 0===t?void 0:t[e])}getTemplates(){const e={};for(let t=0;t<this.children.length;t++){const i=this.children[t];if("TEMPLATE"===i.nodeName){const o=i;o.dataset.type?e[o.dataset.type]=o:e.default=o,o.templateOrder=t}}return e}renderError(){return this.hasTemplate("error")?this.renderTemplate("error",this.error):Je`
      <div class="error">
        ${this.error}
      </div>
    `}removeUnusedSlottedElements(){var e;if(this._renderedSlots){for(let t=0;t<this.children.length;t++){const i=this.children[t];(null===(e=i.dataset)||void 0===e?void 0:e.generated)&&!this._slotNamesAddedDuringRender.includes(i.slot)&&(this.removeChild(i),delete this._renderedTemplates[i.slot],t--)}this._renderedSlots=!1}}}Mt([Ct({attribute:!1}),zt("design:type",Object)],Nt.prototype,"templateContext",void 0),Mt([$t(),zt("design:type",Object)],Nt.prototype,"error",void 0);const Ut=(e,t)=>t.some((t=>e instanceof t));let Bt,Ht;const jt=new WeakMap,qt=new WeakMap,Zt=new WeakMap,Wt=new WeakMap,Gt=new WeakMap;let Qt={get(e,t,i){if(e instanceof IDBTransaction){if("done"===t)return qt.get(e);if("objectStoreNames"===t)return e.objectStoreNames||Zt.get(e);if("store"===t)return i.objectStoreNames[1]?void 0:i.objectStore(i.objectStoreNames[0])}return Xt(e[t])},set:(e,t,i)=>(e[t]=i,!0),has:(e,t)=>e instanceof IDBTransaction&&("done"===t||"store"===t)||t in e};function Kt(e){return"function"==typeof e?(t=e)!==IDBDatabase.prototype.transaction||"objectStoreNames"in IDBTransaction.prototype?(Ht||(Ht=[IDBCursor.prototype.advance,IDBCursor.prototype.continue,IDBCursor.prototype.continuePrimaryKey])).includes(t)?function(...e){return t.apply(Jt(this),e),Xt(jt.get(this))}:function(...e){return Xt(t.apply(Jt(this),e))}:function(e,...i){const o=t.call(Jt(this),e,...i);return Zt.set(o,e.sort?e.sort():[e]),Xt(o)}:(e instanceof IDBTransaction&&function(e){if(qt.has(e))return;const t=new Promise(((t,i)=>{const o=()=>{e.removeEventListener("complete",s),e.removeEventListener("error",n),e.removeEventListener("abort",n)},s=()=>{t(),o()},n=()=>{i(e.error||new DOMException("AbortError","AbortError")),o()};e.addEventListener("complete",s),e.addEventListener("error",n),e.addEventListener("abort",n)}));qt.set(e,t)}(e),Ut(e,Bt||(Bt=[IDBDatabase,IDBObjectStore,IDBIndex,IDBCursor,IDBTransaction]))?new Proxy(e,Qt):e);var t}function Xt(e){if(e instanceof IDBRequest)return function(e){const t=new Promise(((t,i)=>{const o=()=>{e.removeEventListener("success",s),e.removeEventListener("error",n)},s=()=>{t(Xt(e.result)),o()},n=()=>{i(e.error),o()};e.addEventListener("success",s),e.addEventListener("error",n)}));return t.then((t=>{t instanceof IDBCursor&&jt.set(t,e)})).catch((()=>{})),Gt.set(t,e),t}(e);if(Wt.has(e))return Wt.get(e);const t=Kt(e);return t!==e&&(Wt.set(e,t),Gt.set(t,e)),t}const Jt=e=>Gt.get(e),Yt=["get","getKey","getAll","getAllKeys","count"],ei=["put","add","delete","clear"],ti=new Map;function ii(e,t){if(!(e instanceof IDBDatabase)||t in e||"string"!=typeof t)return;if(ti.get(t))return ti.get(t);const i=t.replace(/FromIndex$/,""),o=t!==i,s=ei.includes(i);if(!(i in(o?IDBIndex:IDBObjectStore).prototype)||!s&&!Yt.includes(i))return;const n=async function(e,...t){const n=this.transaction(e,s?"readwrite":"readonly");let r=n.store;return o&&(r=r.index(t.shift())),(await Promise.all([r[i](...t),s&&n.done]))[0]};return ti.set(t,n),n}var oi;oi=e=>({...e,get:(t,i,o)=>ii(t,i)||e.get(t,i,o),has:(t,i)=>!!ii(t,i)||e.has(t,i)}),Qt=oi(Qt);var si=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};class ni{constructor(e,t){if(!(t in e.stores))throw Error('"store" must be defined in the "schema"');this.schema=e,this.store=t}getValue(e){return si(this,void 0,void 0,(function*(){if(!window.indexedDB)return null;try{return(yield this.getDb()).get(this.store,e)}catch(e){return null}}))}putValue(e,t){return si(this,void 0,void 0,(function*(){if(window.indexedDB)try{yield(yield this.getDb()).put(this.store,Object.assign(Object.assign({},t),{timeCached:Date.now()}),e)}catch(e){return}}))}clearStore(){return si(this,void 0,void 0,(function*(){if(window.indexedDB)try{yield(yield this.getDb()).clear(this.store)}catch(e){return}}))}getDBName(){return si(this,void 0,void 0,(function*(){const e=yield te.getCacheId();if(e)return`mgt-${this.schema.name}-${e}`}))}getDb(){return si(this,void 0,void 0,(function*(){const e=yield this.getDBName();if(e)return function(e,t,{blocked:i,upgrade:o,blocking:s,terminated:n}={}){const r=indexedDB.open(e,t),a=Xt(r);return o&&r.addEventListener("upgradeneeded",(e=>{o(Xt(r.result),e.oldVersion,e.newVersion,Xt(r.transaction))})),i&&r.addEventListener("blocked",(()=>i())),a.then((e=>{n&&e.addEventListener("close",(()=>n())),s&&e.addEventListener("versionchange",(()=>s()))})).catch((()=>{})),a}(e,this.schema.version,{upgrade:(t,i,o,s)=>{const n=JSON.parse(localStorage.getItem(ri))||[];n.includes(e)||n.push(e),localStorage.setItem(ri,JSON.stringify(n));for(const e in this.schema.stores)Object.prototype.hasOwnProperty.call(this.schema.stores,e)&&!t.objectStoreNames.contains(e)&&t.createObjectStore(e)}})}))}}const ri="mgt-db-list";class ai{static getCache(e,t){const i=`${e.name}/${t}`;return this.isInitialized||this.init(),this.cacheStore.has(t)||this.cacheStore.set(i,new ni(e,t)),this.cacheStore.get(i)}static clearCacheById(e){const t=[],i=JSON.parse(localStorage.getItem(ri));if(i){const o=[];i.forEach((i=>{i.includes(e)?t.push(new Promise(((e,t)=>{const o=indexedDB.deleteDatabase(i);o.onsuccess=()=>e(),o.onerror=()=>{console.error(`🦒: ${o.error.name} occurred deleting cache: ${i}`,o.error.message),t()}}))):o.push(i)})),o.length>0?localStorage.setItem(ri,JSON.stringify(o)):localStorage.removeItem(ri)}return Promise.all(t)}static get config(){return this.cacheConfig}static init(){let e;te.globalProvider&&(e=te.globalProvider.state),te.onProviderUpdated((()=>function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){if(e===Q.SignedIn&&te.globalProvider.state===Q.SignedOut){const e=yield te.getCacheId();null!==e&&(yield this.clearCacheById(e))}e=te.globalProvider.state})))),this.isInitialized=!0}}ai.cacheStore=new Map,ai.isInitialized=!1,ai.cacheConfig={defaultInvalidationPeriod:36e5,groups:{invalidationPeriod:null,isEnabled:!0},isEnabled:!0,people:{invalidationPeriod:null,isEnabled:!0},photos:{invalidationPeriod:null,isEnabled:!0},presence:{invalidationPeriod:3e5,isEnabled:!0},users:{invalidationPeriod:null,isEnabled:!0},response:{invalidationPeriod:null,isEnabled:!0},files:{invalidationPeriod:null,isEnabled:!0},fileLists:{invalidationPeriod:null,isEnabled:!0}};class li{static get microsoftTeamsLib(){return this._microsoftTeamsLib||window.microsoftTeams}static set microsoftTeamsLib(e){this._microsoftTeamsLib=e}static get isAvailable(){return!(!this.microsoftTeamsLib||(window.parent!==window.self||!window.nativeInterface)&&"embedded-page-container"!==window.name&&"extension-tab-frame"!==window.name)}static executeDeepLink(e,t){const i=this.microsoftTeamsLib;i.initialize(),i.executeDeepLink(e,t)}}var di=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};class ci{get value(){return this._value}get hasNext(){return Boolean(this._nextLink)}static create(e,t,i){return di(this,void 0,void 0,(function*(){const o=yield t.get();if(null==o?void 0:o.value){const t=new ci;return t._graph=e,t._value=o.value,t._nextLink=o["@odata.nextLink"],t._version=i||e.version,t}return null}))}static createFromValue(e,t,i=null){const o=new ci;return o._graph=e,o._value=t,o._nextLink=i,o._version=e.version,o}get nextLink(){return this._nextLink||""}next(){var e;return di(this,void 0,void 0,(function*(){if(this._nextLink){const t=this._nextLink.split(this._version)[1],i=yield this._graph.api(t).version(this._version).get();if(null===(e=null==i?void 0:i.value)||void 0===e?void 0:e.length)return this._value=this._value.concat(i.value),this._nextLink=i["@odata.nextLink"],i.value}return null}))}}const hi=new WeakMap,ui=(e,t,i)=>{const o=[];for(const s of e)o.push(s.replace(t,i));return o},pi=(e,...t)=>{if(ce.isDisambiguated){let t=hi.get(e);if(!t){const i=new RegExp("(</?)mgt-(?!"+ce.disambiguation+"-)"),o=`$1${ce.prefix}-`;t=Object.assign(ui(e,i,o),{raw:ui(e.raw,i,o)}),hi.set(e,t)}e=t}return Je(e,...t)},gi=e=>{const t=`${ce.prefix}-${e}`,i=customElements.get(t),o=e=>e.packageVersion||" Unknown likely <3.0.0";return i?e=>(console.error(`🦒: Tag name ${t} is already defined using class ${i.name} version ${o(i)}\n`,`Currently registering class ${e.name} with version ${o(e)}\n`,"Please use the disambiguation feature to define a unique tag name for this component see: https://github.com/microsoftgraph/microsoft-graph-toolkit/tree/main/packages/mgt-components#disambiguation"),e):(s=t,e=>"function"==typeof e?((e,t)=>(customElements.define(e,t),t))(s,e):((e,t)=>{const{kind:i,elements:o}=t;return{kind:i,elements:o,finisher(t){customElements.define(e,t)}}})(s,e));var s};class fi{constructor(e){this._getCustomHeaders=e}execute(e){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){if(this._getCustomHeaders){const t=yield this._getCustomHeaders();for(const i in t)Object.prototype.hasOwnProperty.call(t,i)&&v(e.request,e.options,i,t[i])}return yield this._nextMiddleware.execute(e)}))}setNext(e){this._nextMiddleware=e}}class vi extends he{constructor(e,t){const i=[new P(new D),new O,new de(It),new fi(t),new T];super(Z.initWithMiddleware({baseUrl:e,middleware:oe(...i),customHosts:new Set([new URL(e).hostname])}))}}const mi=[be`

`],bi=document.createElement("style");bi.appendChild(document.createTextNode("\n@font-face {\n    font-family: 'FabricMDL2Icons';\n    src: url('https://static2.sharepointonline.com/files/fabric/assets/icons/fabricmdl2icons-2.68.woff2') format('woff2'),\n    url(https://static2.sharepointonline.com/files/fabric/assets/icons/fabricmdl2icons-2.68.woff) format(\"woff\"),\n    url(https://static2.sharepointonline.com/files/fabric/assets/icons/fabricmdl2icons-2.68.ttf) format(\"truetype\");\n}\n")),document.head.appendChild(bi);const yi=document.createElement("style");yi.innerHTML=mi.toString(),document.head.appendChild(yi);const wi=e=>(...t)=>({_$litDirective$:e,values:t});class xi{constructor(e){}get _$AU(){return this._$AM._$AU}_$AT(e,t,i){this._$Ct=e,this._$AM=t,this._$Ci=i}_$AS(e,t){return this.update(e,t)}update(e,t){return this.render(...t)}}const ki=wi(class extends xi{constructor(e){var t;if(super(e),1!==e.type||"class"!==e.name||(null===(t=e.strings)||void 0===t?void 0:t.length)>2)throw Error("`classMap()` can only be used in the `class` attribute and must be the only part in the attribute.")}render(e){return" "+Object.keys(e).filter((t=>e[t])).join(" ")+" "}update(e,[t]){var i,o;if(void 0===this.it){this.it=new Set,void 0!==e.strings&&(this.nt=new Set(e.strings.join(" ").split(/\s/).filter((e=>""!==e))));for(const e in t)t[e]&&!(null===(i=this.nt)||void 0===i?void 0:i.has(e))&&this.it.add(e);return this.render(t)}const s=e.element.classList;this.it.forEach((e=>{e in t||(s.remove(e),this.it.delete(e))}));for(const e in t){const i=!!t[e];i===this.it.has(e)||(null===(o=this.nt)||void 0===o?void 0:o.has(e))||(i?(s.add(e),this.it.add(e)):(s.remove(e),this.it.delete(e)))}return Ye}}),Ci=e=>{const t=new Date,i=new Date(t.getFullYear(),t.getMonth(),t.getDate());if(e>=i)return e.toLocaleString("default",{hour:"numeric",minute:"numeric"});const o=new Date(i);if(o.setDate(t.getDate()-t.getDay()),e>=o)return e.toLocaleString("default",{hour:"numeric",minute:"numeric",weekday:"short"});const s=new Date(o);return s.setDate(o.getDate()-7),e>=s?e.toLocaleString("default",{day:"numeric",month:"numeric",weekday:"short"}):e.toLocaleString("default",{day:"numeric",month:"numeric",year:"numeric"})},$i=(e,t)=>{let i;return function(){window.clearTimeout(i),i=window.setTimeout((()=>e.apply(this,arguments)),t)}},Si=e=>new Promise(((t,i)=>{const o=new FileReader;o.onerror=i,o.onload=()=>{t(o.result)},o.readAsDataURL(e)})),_i=e=>e.startsWith("[")?e.match(/([a-zA-Z0-9+._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9_-]+)/gi).toString():e,Ii=e=>/^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(e),Ti=(e,t=2)=>{if(0===e)return"0 Bytes";const i=t<0?0:t,o=Math.floor(Math.log(e)/Math.log(1024));return`${parseFloat((e/Math.pow(1024,o)).toFixed(i))} ${["Bytes","KB","MB","GB","TB","PB","EB","ZB","YB"][o]}`},Di=e=>(e&&(e=null==(e=null==(e=null==e?void 0:e.replace(/<ddd\/>/gi,"..."))?void 0:e.replace(/<c0>/gi,"<b>"))?void 0:e.replace(/<\/c0>/gi,"</b>")),e),Pi=e=>null==e?void 0:e.replace(/\.[^/.]+$/,""),Li=e=>new URL(e).pathname.split("/").pop().replace(/-/g," "),Ei=()=>ai.config.response.isEnabled&&ai.config.isEnabled,Oi={name:"presence",stores:{presence:"presence"},version:2},Fi={name:"users",stores:{users:"users",usersQuery:"usersQuery",userFilters:"userFilters"},version:3},Ai={name:"photos",stores:{contacts:"contacts",users:"users",groups:"groups",teams:"teams"},version:2},Ri={name:"people",stores:{contacts:"contacts",groupPeople:"groupPeople",peopleQuery:"peopleQuery"},version:3},Vi={name:"groups",stores:{groups:"groups",groupsQuery:"groupsQuery"},version:5},Mi={name:"responses",stores:{responses:"responses"},version:2},zi={name:"search",stores:{responses:"responses"},version:2},Ni={name:"files",stores:{driveFiles:"driveFiles",groupFiles:"groupFiles",siteFiles:"siteFiles",userFiles:"userFiles",insightFiles:"insightFiles",fileQueries:"fileQueries"},version:2},Ui={name:"file-lists",stores:{fileLists:"fileLists",insightfileLists:"insightfileLists"},version:2};var Bi,Hi,ji=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};!function(e){e[e.any=0]="any",e.person="person",e.group="group"}(Bi||(Bi={})),function(e){e.any="any",e.user="user",e.contact="contact"}(Hi||(Hi={}));const qi=()=>ai.config.people.invalidationPeriod||ai.config.defaultInvalidationPeriod,Zi=()=>ai.config.people.isEnabled&&ai.config.isEnabled,Wi=(e,t,i=10,o=Hi.any,s="")=>ji(void 0,void 0,void 0,(function*(){const n=`${t}:${i}:${o}`;let r;if(Zi()){const e=Ri,t=Ri.stores.peopleQuery;r=ai.getCache(e,t);const i=Zi()?yield r.getValue(n):null;if(i&&qi()>Date.now()-i.timeCached)return i.results.map((e=>JSON.parse(e)))}let a,l="personType/class eq 'Person'";o!==Hi.any&&(o===Hi.user?l+="and personType/subclass eq 'OrganizationUser'":l+="and (personType/subclass eq 'ImplicitContact' or personType/subclass eq 'PersonalContact')"),""!==s&&(l+=`${l} and ${s}`);try{let s=e.api("/me/people").search('"'+t+'"').top(i).filter(l).middlewareOptions(ie("people.read"));if(o!==Hi.contact&&(s=s.header("X-PeopleQuery-QuerySources","Mailbox,Directory")),a=yield s.get(),Zi()&&a){const e={maxResults:i,results:null};e.results=a.value.map((e=>JSON.stringify(e))),yield r.putValue(n,e)}}catch(e){}return null==a?void 0:a.value})),Gi=(e,t=Hi.any,i="",o=10)=>ji(void 0,void 0,void 0,(function*(){let s;const n=`${i||`*:${t}`}:${o}`;if(Zi()){s=ai.getCache(Ri,Ri.stores.peopleQuery);const e=yield s.getValue(n);if(e&&qi()>Date.now()-e.timeCached)return e.results.map((e=>JSON.parse(e)))}let r,a="personType/class eq 'Person'";t!==Hi.any&&(t===Hi.user?a+="and personType/subclass eq 'OrganizationUser'":a+="and (personType/subclass eq 'ImplicitContact' or personType/subclass eq 'PersonalContact')"),i&&(a+=` and ${i}`);try{let i=e.api("/me/people").middlewareOptions(ie("people.read")).top(o).filter(a);t!==Hi.contact&&(i=i.header("X-PeopleQuery-QuerySources","Mailbox,Directory")),r=yield i.get(),Zi()&&r&&(yield s.putValue(n,{maxResults:10,results:r.value.map((e=>JSON.stringify(e)))}))}catch(e){}return r?r.value:null})),Qi=e=>{var t,i;const o=e,s=e,n=e;return s.mail?_i(s.mail):(null===(t=o.scoredEmailAddresses)||void 0===t?void 0:t.length)?_i(o.scoredEmailAddresses[0].address):(null===(i=n.emailAddresses)||void 0===i?void 0:i.length)?_i(n.emailAddresses[0].address):null},Ki=(e,t)=>ji(void 0,void 0,void 0,(function*(){let i;if(Zi()){i=ai.getCache(Ri,Ri.stores.contacts);const e=yield i.getValue(t);if(e&&qi()>Date.now()-e.timeCached)return JSON.parse(e.person)}const o=`${t.replace(/#/g,"%2523")}`,s=yield e.api("/me/contacts").filter(`emailAddresses/any(a:a/address eq '${o}')`).middlewareOptions(ie("contacts.read")).get();return Zi()&&s&&(yield i.putValue(t,{person:JSON.stringify(s.value)})),s?s.value:null}));var Xi=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const Ji=()=>ai.config.users.invalidationPeriod||ai.config.defaultInvalidationPeriod,Yi=()=>ai.config.users.isEnabled&&ai.config.isEnabled,eo=(e,t)=>Xi(void 0,void 0,void 0,(function*(){let i;if(Yi()){i=ai.getCache(Fi,Fi.stores.users);const e=yield i.getValue("me");if(e&&Ji()>Date.now()-e.timeCached){const i=JSON.parse(e.user),o=t?t.filter((e=>!Object.keys(i).includes(e))):null;if(!o||o.length<=1)return i}}let o="me";t&&(o=o+"?$select="+t.toString());const s=yield e.api(o).middlewareOptions(ie("user.read")).get();return Yi()&&(yield i.putValue("me",{user:JSON.stringify(s)})),s})),to=(e,t,i)=>Xi(void 0,void 0,void 0,(function*(){let o;if(Yi()){o=ai.getCache(Fi,Fi.stores.users);const e=yield o.getValue(t);if(e&&Ji()>Date.now()-e.timeCached){const t=e.user?JSON.parse(e.user):null,o=i&&t?i.filter((e=>!Object.keys(t).includes(e))):null;if(!o||o.length<=1)return t}}let s,n=`/users/${t}`;i&&(n=n+"?$select="+i.toString());try{s=yield e.api(n).middlewareOptions(ie("user.readbasic.all")).get()}catch(e){}return Yi()&&(yield o.putValue(t,{user:JSON.stringify(s)})),s})),io=(e,t,i="",o="",s)=>Xi(void 0,void 0,void 0,(function*(){if(!t||0===t.length)return[];const n=e.createBatch(),r={},a={},l=[];let d;i=i.toLowerCase(),Yi()&&(d=ai.getCache(Fi,Fi.stores.users));for(const s of t){r[s]=null;let t,c,h=`/users/${s}`;if(Yi()&&(c=yield d.getValue(s)),(null==c?void 0:c.user)&&Ji()>Date.now()-c.timeCached)if(t=JSON.parse(null==c?void 0:c.user),i){if(t){const e=t.displayName;(null==e?void 0:e.toLowerCase().includes(i))&&(a[s]=t)}}else t?r[s]=t:(n.get(s,h,["user.readbasic.all"]),l.push(s));else""!==s&&("me"===s.toString()?r[s]=yield eo(e):(h=`/users/${s}`,o&&(h+=`${h}?$filter=${o}`),n.get(s,h,["user.readbasic.all"]),l.push(s)))}try{if(n.hasRequests){const e=yield n.executeAll();for(const o of t){const t=e.get(o);if(null==t?void 0:t.content){const e=t.content;i?((null==e?void 0:e.displayName.toLowerCase())||"").includes(i)&&(a[o]=e):r[o]=e,Yi()&&(yield d.putValue(o,{user:JSON.stringify(e)}))}else{const e=s.find((e=>Object.values(e).includes(o)));e&&(r[o]=e)}}}return i&&Object.keys(a).length?Promise.all(Object.values(a)):Promise.all(Object.values(r))}catch(i){try{return t.filter((e=>l.includes(e))).forEach((t=>{r[t]=to(e,t)})),Yi()&&(yield Promise.all(t.filter((e=>l.includes(e))).map((e=>Xi(void 0,void 0,void 0,(function*(){return yield d.putValue(e,{user:JSON.stringify(yield r[e])})})))))),Promise.all(Object.values(r))}catch(e){return[]}}})),oo=(e,t,i=10,o="")=>Xi(void 0,void 0,void 0,(function*(){const s={maxResults:i,results:null},n=`${t}:${i}:${o}`;let r;if(Yi()){r=ai.getCache(Fi,Fi.stores.usersQuery);const e=yield r.getValue(n);if(e&&Ji()>Date.now()-e.timeCached)return e.results.map((e=>JSON.parse(e)))}const a=`${t.replace(/#/g,"%2523")}`,l=e.api("users").header("ConsistencyLevel","eventual").count(!0).search(`"displayName:${a}" OR "mail:${a}"`);let d;""!==o&&l.filter(o);try{d=yield l.top(i).middlewareOptions(ie("User.ReadBasic.All")).get()}catch(e){}return Yi()&&d&&(s.results=d.value.map((e=>JSON.stringify(e))),yield r.putValue(t,s)),d?d.value:null})),so=(e,t,i,o=10,s=Bi.person,n=!1,r="",a="")=>Xi(void 0,void 0,void 0,(function*(){const l={maxResults:o,results:null};let d;const c=`${i||"*"}:${t||"*"}:${o}:${s}:${n}:${r}`;if(Yi()){d=ai.getCache(Fi,Fi.stores.usersQuery);const e=yield d.getValue(c);if(e&&Ji()>Date.now()-e.timeCached)return e.results.map((e=>JSON.parse(e)))}let h="";t&&(h=`startswith(displayName,'${t}') or startswith(givenName,'${t}') or startswith(surname,'${t}') or startswith(mail,'${t}') or startswith(userPrincipalName,'${t}')`);let u=`/groups/${i}/${n?"transitiveMembers":"members"}`;s===Bi.person?u+="/microsoft.graph.user":s===Bi.group&&(u+="/microsoft.graph.group",t&&(h=`startswith(displayName,'${t}') or startswith(mail,'${t}')`)),r&&(h+=t?` and ${r}`:r),a&&(h+=t?` and ${a}`:a);const p=yield e.api(u).count(!0).top(o).filter(h).header("ConsistencyLevel","eventual").middlewareOptions(ie("GroupMember.Read.All")).get();return Yi()&&p&&(l.results=p.value.map((e=>JSON.stringify(e))),yield d.putValue(c,l)),p?p.value:null})),no=(e,t,i,o=10,s=Bi.person,n=!1,r="")=>Xi(void 0,void 0,void 0,(function*(){const a=[];for(const l of i)try{const i=yield so(e,t,l,o,s,n,r);a.push(...i)}catch(e){continue}return a}));var ro=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const ao=()=>ai.config.photos.invalidationPeriod||ai.config.defaultInvalidationPeriod,lo=()=>ai.config.photos.isEnabled&&ai.config.isEnabled,co=(e,t,i)=>ro(void 0,void 0,void 0,(function*(){try{const o=yield e.api(`${t}/photo/$value`).responseType(k.RAW).middlewareOptions(ie(...i)).get();if(404===o.status)return{eTag:null,photo:null};if(!o.ok)return null;return{eTag:o["@odata.mediaEtag"],photo:yield Si(yield o.blob())}}catch(e){return null}})),ho=(e,t)=>ro(void 0,void 0,void 0,(function*(){let i,o;return lo()&&(i=ai.getCache(Ai,Ai.stores.contacts),o=yield i.getValue(t),o&&ao()>Date.now()-o.timeCached)?o.photo:(o=yield co(e,`me/contacts/${t}`,["contacts.read"]),lo()&&o&&(yield i.putValue(t,o)),o?o.photo:null)})),uo=(e,t)=>ro(void 0,void 0,void 0,(function*(){let i,o;if(lo()){if(i=ai.getCache(Ai,Ai.stores.users),o=yield i.getValue(t),o&&ao()>Date.now()-o.timeCached)return o.photo;if(o)try{const i=yield e.api(`users/${t}/photo`).get();i&&(i["@odata.mediaEtag"]!==o.eTag||null===i["@odata.mediaEtag"]&&null===o.eTag)&&(o=null)}catch(e){return null}}return o=o||(yield co(e,`users/${t}`,["user.readbasic.all"])),lo()&&o&&(yield i.putValue(t,o)),o?o.photo:null})),po=(e,t,i=!0)=>ro(void 0,void 0,void 0,(function*(){if("personType"in t&&"OrganizationUser"!==t.personType.subclass){if("PersonalContact"===t.personType.subclass&&i){const i=Qi(t),o=yield Ki(e,i);if((null==o?void 0:o.length)&&o[0].id)return yield ho(e,o[0].id)}return null}if(t.userPrincipalName||t.id){const i=t.userPrincipalName||t.id;return yield uo(e,i)}if(t.id){const i=yield uo(e,t.id);if(i)return i}const o=Qi(t);if(o){const t=yield oo(e,o,1);if(null==t?void 0:t.length)return yield uo(e,t[0].id);if(i){const t=yield Ki(e,o);if(null==t?void 0:t.length)return yield ho(e,t[0].id)}}return null})),go=(e,t,i)=>ro(void 0,void 0,void 0,(function*(){const o=ai.getCache(Ai,t);yield o.putValue(e,i)}));var fo=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const vo=()=>ai.config.presence.invalidationPeriod||ai.config.defaultInvalidationPeriod,mo=()=>ai.config.presence.isEnabled&&ai.config.isEnabled,bo=(e,t)=>fo(void 0,void 0,void 0,(function*(){let i;if(mo()){i=ai.getCache(Oi,Oi.stores.presence);const e=yield i.getValue(t||"me");if(e&&vo()>Date.now()-e.timeCached)return JSON.parse(e.presence)}const o=t?["presence.read.all"]:["presence.read"],s=t?`/users/${t}/presence`:"/me/presence",n=yield e.api(s).middlewareOptions(ie(...o)).get();return mo()&&(yield i.putValue(t||"me",{presence:JSON.stringify(n)})),n})),yo=e=>{const t=e;return t.statusCode&&"code"in t&&"body"in t&&t.date&&"message"in t&&"name"in t&&"requestId"in t};const wo=(e,t,i)=>function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(void 0,void 0,void 0,(function*(){let o,s,n,r=null;const a=t?`users/${t}`:"me",l=a+(i?`?$select=${i.toString()}`:""),d=t?["user.readbasic.all"]:["user.read"];if(Yi()){const e=ai.getCache(Fi,Fi.stores.users);n=yield e.getValue(t||"me"),n&&Ji()>Date.now()-n.timeCached?(r=n.user?JSON.parse(n.user):null,null!==r&&i&&i.filter((e=>!Object.keys(r).includes(e))).length>=1&&(r=null,n=null)):n=null}if(lo())if(s=yield((e,t)=>ro(void 0,void 0,void 0,(function*(){const i=ai.getCache(Ai,t);return yield i.getValue(e)})))(t||"me",Ai.stores.users),s&&ao()>Date.now()-s.timeCached)o=s.photo;else if(s)try{const i=yield e.api(`${a}/photo`).get();(null==i?void 0:i["@odata.mediaEtag"])&&i["@odata.mediaEtag"]===s.eTag?(yield go(t||"me",Ai.stores.users,s),o=s.photo):s=null}catch(e){yo(e)&&("ErrorItemNotFound"!==e.code&&"ImageNotFound"!==e.code||(yield go(t||"me",Ai.stores.users,{eTag:null,photo:null})))}if(s||n)if(s){if(!n)try{const i=yield e.api(l).middlewareOptions(ie(...d)).get();if(i){if(Yi()){const e=ai.getCache(Fi,Fi.stores.users);yield e.putValue(t||"me",{user:JSON.stringify(i)})}r=i}}catch(e){}}else try{const i=yield co(e,a,d);i&&(lo()&&(yield go(t||"me",Ai.stores.users,{eTag:i.eTag,photo:i.photo})),o=i.photo)}catch(e){}else{let s;const n=e.createBatch();t?(n.get("user",`/users/${t}${i?"?$select="+i.toString():""}`,["user.readbasic.all"]),n.get("photo",`users/${t}/photo/$value`,["user.readbasic.all"])):(n.get("user","me",["user.read"]),n.get("photo","me/photo/$value",["user.read"]));const a=yield n.executeAll(),l=a.get("photo");l&&(s=l.headers.ETag,o=l.content);const d=a.get("user");if(d&&(r=d.content),Yi()){const e=ai.getCache(Fi,Fi.stores.users);yield e.putValue(t||"me",{user:JSON.stringify(r)})}lo()&&(yield go(t||"me",Ai.stores.users,{eTag:s,photo:o}))}return r&&(r.personImage=o),r}));var xo,ko;!function(e){e[e.image=2]="image",e[e.oneline=3]="oneline",e[e.twolines=4]="twolines",e[e.threelines=5]="threelines",e[e.fourlines=6]="fourlines"}(xo||(xo={})),function(e){e[e.ArrowDown=0]="ArrowDown",e[e.TeamSeparator=1]="TeamSeparator",e[e.Search=2]="Search",e[e.SkypeArrow=3]="SkypeArrow",e[e.SmallEmail=4]="SmallEmail",e[e.SmallEmailHovered=5]="SmallEmailHovered",e[e.SmallChat=6]="SmallChat",e[e.SmallChatHovered=7]="SmallChatHovered",e[e.Video=8]="Video",e[e.VideoHovered=9]="VideoHovered",e[e.ExpandDown=10]="ExpandDown",e[e.Overview=11]="Overview",e[e.Send=12]="Send",e[e.Contact=13]="Contact",e[e.Copy=14]="Copy",e[e.Phone=15]="Phone",e[e.CellPhone=16]="CellPhone",e[e.Chat=17]="Chat",e[e.Call=18]="Call",e[e.CallHovered=19]="CallHovered",e[e.Confirmation=20]="Confirmation",e[e.Department=21]="Department",e[e.Email=22]="Email",e[e.OfficeLocation=23]="OfficeLocation",e[e.Person=24]="Person",e[e.Messages=25]="Messages",e[e.Organization=26]="Organization",e[e.ExpandRight=27]="ExpandRight",e[e.Profile=28]="Profile",e[e.Birthday=29]="Birthday",e[e.File=30]="File",e[e.Files=31]="Files",e[e.Back=32]="Back",e[e.Close=33]="Close",e[e.Upload=34]="Upload",e[e.FileCloud=35]="FileCloud",e[e.DragFile=36]="DragFile",e[e.Cancel=37]="Cancel",e[e.CheckMark=38]="CheckMark",e[e.Success=39]="Success",e[e.Fail=40]="Fail",e[e.SelectAccount=41]="SelectAccount",e[e.News=42]="News",e[e.DoubleBookmark=43]="DoubleBookmark",e[e.ChevronLeft=44]="ChevronLeft",e[e.ChevronRight=45]="ChevronRight",e[e.Event=46]="Event",e[e.BookOpen=47]="BookOpen",e[e.FileOuter=48]="FileOuter",e[e.BookQuestion=49]="BookQuestion",e[e.Globe=50]="Globe",e[e.Delete=51]="Delete",e[e.Add=52]="Add",e[e.Calendar=53]="Calendar",e[e.Planner=54]="Planner",e[e.Milestone=55]="Milestone",e[e.PersonAdd=56]="PersonAdd",e[e.PresenceAvailable=57]="PresenceAvailable",e[e.PresenceOofAvailable=58]="PresenceOofAvailable",e[e.PresenceBusy=59]="PresenceBusy",e[e.PresenceOofBusy=60]="PresenceOofBusy",e[e.PresenceDnd=61]="PresenceDnd",e[e.PresenceOofDnd=62]="PresenceOofDnd",e[e.PresenceAway=63]="PresenceAway",e[e.PresenceOofAway=64]="PresenceOofAway",e[e.PresenceOffline=65]="PresenceOffline",e[e.PresenceStatusUnknown=66]="PresenceStatusUnknown"}(ko||(ko={}));const Co=(e,t)=>{switch(e){case ko.ArrowDown:return Je`
        <svg width="12" height="12" viewBox="0 0 12 12" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M6 9L2.46447 5.46447H6H9.53553L6 9Z" />
        </svg>
      `;case ko.TeamSeparator:return Je`
        <svg width="6" height="10" viewBox="0 0 6 10" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path
            fill-rule="evenodd"
            clip-rule="evenodd"
            d="M5.70711 5L1.49999 9.20711L0.792886 8.50001L4.29289 5L0.792887 1.49999L1.49999 0.792885L5.70711 5Z"
            fill=${t}
          />
        </svg>
      `;case ko.Search:return Je`
        <svg width="12" height="12" viewBox="0 0 12 12" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
          <path d="M7.30887 8.01596C6.53903 8.63179 5.56252 9.00004 4.5 9.00004C2.01472 9.00004 0 6.98531 0 4.50002C0 2.01473 2.01472 0 4.5 0C6.98528 0 9 2.01473 9 4.50002C9 5.56252 8.63177 6.53901 8.01597 7.30885L11.8536 11.1464C12.0488 11.3417 12.0488 11.6583 11.8536 11.8536C11.6583 12.0488 11.3417 12.0488 11.1464 11.8536L7.30887 8.01596ZM8 4.50002C8 2.56701 6.433 1 4.5 1C2.567 1 1 2.56701 1 4.50002C1 6.43302 2.567 8.00003 4.5 8.00003C6.433 8.00003 8 6.43302 8 4.50002Z" fill="currentColor"/>
        </svg>`;case ko.SkypeArrow:return Je`
        <svg viewBox="0 0 12 10" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path
            d="M3.95184 0.480534C4.23385 0.10452 4.70926 -0.0724722 5.1685 0.0275755C5.62775 0.127623 5.98645 0.486329 6.0865 0.945575C6.18655 1.40482 6.00956 1.88023 5.63354 2.16224L4.07196 3.72623H10.7988C11.4622 3.72623 12 4.26403 12 4.92744C12 5.59086 11.4622 6.12866 10.7988 6.12866H4.07196L5.63114 7.68784C6.0955 8.15225 6.0955 8.90515 5.63114 9.36955C5.51655 9.48381 5.38119 9.57514 5.23234 9.63862C5.09341 9.69857 4.94399 9.73042 4.79269 9.73232C4.63498 9.73233 4.4789 9.70046 4.33382 9.63862C4.18765 9.57669 4.05593 9.48507 3.94703 9.36955L0.343377 5.7659C-0.114459 5.29881 -0.114459 4.55128 0.343377 4.08419L3.95184 0.480534Z"
            fill="#B4009E"
          />
        </svg>
      `;case ko.SmallEmail:return Je`
        <svg width="17" height="14" viewBox="0 0 17 14" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path class="filled" d="M16 3.373V10.5C16 11.8807 14.8807 13 13.5 13H2.5C1.11929 13 -7.62939e-05 11.8807 -7.62939e-05 10.5V3.373L7.74649 7.93097C7.90297 8.02301 8.09704 8.02301 8.25351 7.93097L16 3.373ZM13.5 0C14.7871 0 15.847 0.972604 15.9848 2.22293L8 6.91991L0.0151832 2.22293C0.15304 0.972604 1.21294 0 2.5 0H13.5Z" fill="currentColor"/>
          <path class="regular" d="M13.608 0.833496C14.9887 0.833496 16.108 1.95278 16.108 3.3335V11.3335C16.108 12.7142 14.9887 13.8335 13.608 13.8335H2.60803C1.22732 13.8335 0.108032 12.7142 0.108032 11.3335V3.3335C0.108032 1.95278 1.22732 0.833496 2.60803 0.833496H13.608ZM15.108 4.7945L8.36154 8.76446C8.23115 8.84117 8.07464 8.85395 7.93554 8.80281L7.85452 8.76446L1.10803 4.7965V11.3335C1.10803 12.1619 1.77961 12.8335 2.60803 12.8335H13.608C14.4365 12.8335 15.108 12.1619 15.108 11.3335V4.7945ZM13.608 1.8335H2.60803C1.77961 1.8335 1.10803 2.50507 1.10803 3.3335V3.6355L8.10803 7.75341L15.108 3.6345V3.3335C15.108 2.50507 14.4365 1.8335 13.608 1.8335Z" fill="currentColor"/>
        </svg>
      `;case ko.SmallChat:return Je`
        <svg width="17" height="17" viewBox="0 0 17 17" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path class="filled" d="M8 0C12.4183 0 16 3.58172 16 8C16 12.4183 12.4183 16 8 16C6.72679 16 5.49591 15.7018 4.38669 15.1393L4.266 15.075L0.621091 15.9851C0.311269 16.0625 0.0262241 15.8369 0.00130987 15.5438L0.00114131 15.4624L0.0149329 15.3787L0.925 11.735L0.86169 11.6153C0.406602 10.7186 0.124331 9.74223 0.0327466 8.72826L0.00737596 8.34634L0 8C0 3.58172 3.58172 0 8 0ZM8.5 9H5.5L5.41012 9.00806C5.17688 9.05039 5 9.25454 5 9.5C5 9.74546 5.17688 9.94961 5.41012 9.99194L5.5 10H8.5L8.58988 9.99194C8.82312 9.94961 9 9.74546 9 9.5C9 9.25454 8.82312 9.05039 8.58988 9.00806L8.5 9ZM10.5 6H5.5L5.41012 6.00806C5.17688 6.05039 5 6.25454 5 6.5C5 6.74546 5.17688 6.94961 5.41012 6.99194L5.5 7H10.5L10.5899 6.99194C10.8231 6.94961 11 6.74546 11 6.5C11 6.25454 10.8231 6.05039 10.5899 6.00806L10.5 6Z" fill="currentColor"/>
          <path class="regular" d="M8.38599 0.833496C12.8043 0.833496 16.386 4.41522 16.386 8.8335C16.386 13.2518 12.8043 16.8335 8.38599 16.8335C7.11277 16.8335 5.8819 16.5353 4.77267 15.9728L4.65199 15.9085L1.00708 16.8186C0.697255 16.8959 0.41221 16.6704 0.387296 16.3773L0.387128 16.2959L0.400919 16.2122L1.31099 12.5685L1.24768 12.4488C0.792589 11.5521 0.510317 10.5757 0.418733 9.56176L0.393362 9.17984L0.385986 8.8335C0.385986 4.41522 3.96771 0.833496 8.38599 0.833496ZM8.38599 1.8335C4.51999 1.8335 1.38599 4.9675 1.38599 8.8335C1.38599 10.0505 1.69653 11.2213 2.27951 12.2584C2.32645 12.3419 2.34809 12.4365 2.34291 12.5308L2.32873 12.6247L1.57299 15.6455L4.59703 14.8918C4.65892 14.8764 4.72261 14.8731 4.78472 14.8814L4.87629 14.9026L4.963 14.941C5.9996 15.5233 7.16969 15.8335 8.38599 15.8335C12.252 15.8335 15.386 12.6995 15.386 8.8335C15.386 4.9675 12.252 1.8335 8.38599 1.8335ZM8.88599 9.8335C9.16213 9.8335 9.38599 10.0574 9.38599 10.3335C9.38599 10.579 9.20911 10.7831 8.97586 10.8254L8.88599 10.8335H5.88599C5.60984 10.8335 5.38599 10.6096 5.38599 10.3335C5.38599 10.088 5.56286 9.88389 5.79611 9.84155L5.88599 9.8335H8.88599ZM10.886 6.8335C11.1621 6.8335 11.386 7.05735 11.386 7.3335C11.386 7.57896 11.2091 7.7831 10.9759 7.82544L10.886 7.8335L5.88599 7.8335C5.60984 7.8335 5.38599 7.60964 5.38599 7.3335C5.38599 7.08804 5.56286 6.88389 5.79611 6.84155L5.88599 6.8335L10.886 6.8335Z" fill="currentColor"/>
        </svg>
      `;case ko.Video:return Je`
        <svg width="17" height="13" viewBox="0 0 17 13" fill="none" xmlns="http://www.w3.org/2000/svg">
        <path class="filled" d="M11 2.5C11 1.11929 9.88071 0 8.5 0H2.5C1.11929 0 0 1.11929 0 2.5V9.5C0 10.8807 1.11929 12 2.5 12H8.5C9.88071 12 11 10.8807 11 9.5V2.5ZM12 3.93082V8.08149L14.7642 10.4319C15.2512 10.8461 16 10.4999 16 9.86055V2.19315C16 1.55685 15.2575 1.20962 14.7692 1.61756L12 3.93082Z" fill="currentColor"/>
          <path class="regular" d="M2.72095 0.833496C1.34024 0.833496 0.220947 1.95278 0.220947 3.3335V10.3335C0.220947 11.7142 1.34024 12.8335 2.72095 12.8335H9.72095C11.1017 12.8335 12.2209 11.7142 12.2209 10.3335V9.33348L14.6209 11.1335C15.2802 11.6279 16.2209 11.1575 16.2209 10.3335V3.33348C16.2209 2.50944 15.2802 2.03905 14.6209 2.53348L12.2209 4.33348V3.3335C12.2209 1.95278 11.1017 0.833496 9.72095 0.833496H2.72095ZM12.2209 5.58348L15.2209 3.33348V10.3335L12.2209 8.08348V5.58348ZM11.2209 3.3335V10.3335C11.2209 11.1619 10.5494 11.8335 9.72095 11.8335H2.72095C1.89252 11.8335 1.22095 11.1619 1.22095 10.3335V3.3335C1.22095 2.50507 1.89252 1.8335 2.72095 1.8335H9.72095C10.5494 1.8335 11.2209 2.50507 11.2209 3.3335Z" fill="currentColor"/>
        </svg>
      `;case ko.ExpandDown:return Je`
        <svg width="15" height="8" viewBox="0 0 15 8" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M14 1L7.5 7L1 1" stroke="currentColor" />
        </svg>
      `;case ko.Overview:return Je`
        <svg width="16" height="13" viewBox="0 0 16 13" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M3.5 10.5C2.67157 10.5 2 9.82843 2 9V4C2 3.17157 2.67157 2.5 3.5 2.5H12.5C13.3284 2.5 14 3.17157 14 4V9C14 9.82843 13.3284 10.5 12.5 10.5H3.5ZM3.5 3.5C3.22386 3.5 3 3.72386 3 4V5.5H13V4C13 3.72386 12.7761 3.5 12.5 3.5H3.5ZM5 6.5H3V9C3 9.27614 3.22386 9.5 3.5 9.5H5V6.5ZM6 9.5H12.5C12.7761 9.5 13 9.27614 13 9V6.5H6V9.5ZM0 3C0 1.61929 1.11929 0.5 2.5 0.5H13.5C14.8807 0.5 16 1.61929 16 3V10C16 11.3807 14.8807 12.5 13.5 12.5H2.5C1.11929 12.5 0 11.3807 0 10V3ZM2.5 1.5C1.67157 1.5 1 2.17157 1 3V10C1 10.8284 1.67157 11.5 2.5 11.5H13.5C14.3284 11.5 15 10.8284 15 10V3C15 2.17157 14.3284 1.5 13.5 1.5H2.5Z" fill="#717171"/>
        </svg>
      `;case ko.Send:return Je`
        <svg xmlns="http://www.w3.org/2000/svg">
          <path
            d="M4.27144 8.99999L1.72572 2.45387C1.54854 1.99826 1.9928 1.56256 2.43227 1.71743L2.50153 1.74688L16.0015 8.49688C16.3902 8.69122 16.4145 9.22336 16.0744 9.45992L16.0015 9.50311L2.50153 16.2531C2.0643 16.4717 1.58932 16.0697 1.70282 15.6178L1.72572 15.5461L4.27144 8.99999L1.72572 2.45387L4.27144 8.99999ZM3.3028 3.4053L5.25954 8.43705L10.2302 8.43749C10.515 8.43749 10.7503 8.64911 10.7876 8.92367L10.7927 8.99999C10.7927 9.28476 10.5811 9.52011 10.3065 9.55736L10.2302 9.56249L5.25954 9.56205L3.3028 14.5947L14.4922 8.99999L3.3028 3.4053Z"
          />
        </svg>
      `;case ko.Contact:return Je`
        <svg width="16" height="12" viewBox="0 0 16 12" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M6 4.5C6 5.32843 5.32843 6 4.5 6C3.67157 6 3 5.32843 3 4.5C3 3.67157 3.67157 3 4.5 3C5.32843 3 6 3.67157 6 4.5ZM2 7.69879C2 7.17479 2.42479 6.75 2.94879 6.75H6.05121C6.57521 6.75 7 7.17479 7 7.69879C7 8.54603 6.42338 9.28454 5.60144 9.49003L5.54243 9.50478C4.85801 9.67589 4.14199 9.67589 3.45757 9.50478L3.39856 9.49003C2.57661 9.28454 2 8.54603 2 7.69879ZM9.5 4C9.22386 4 9 4.22386 9 4.5C9 4.77614 9.22386 5 9.5 5H12.5C12.7761 5 13 4.77614 13 4.5C13 4.22386 12.7761 4 12.5 4H9.5ZM9.5 7C9.22386 7 9 7.22386 9 7.5C9 7.77614 9.22386 8 9.5 8H12.5C12.7761 8 13 7.77614 13 7.5C13 7.22386 12.7761 7 12.5 7H9.5ZM0 1.75C0 0.783502 0.783502 0 1.75 0H14.25C15.2165 0 16 0.783502 16 1.75V10.25C16 11.2165 15.2165 12 14.25 12H1.75C0.783501 12 0 11.2165 0 10.25V1.75ZM1.75 1C1.33579 1 1 1.33579 1 1.75V10.25C1 10.6642 1.33579 11 1.75 11H14.25C14.6642 11 15 10.6642 15 10.25V1.75C15 1.33579 14.6642 1 14.25 1H1.75Z" fill="#717171"/>
        </svg>
      `;case ko.Call:return Je`
        <svg width="13" height="17" viewBox="0 0 13 17" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path class="filled" d="M3.98706 1.06589C4.89545 0.792081 5.86254 1.19479 6.31418 2.01224L6.38841 2.16075L7.04987 3.63213C7.46246 4.54992 7.28209 5.61908 6.60754 6.3496L6.47529 6.48248L5.43194 7.45541C5.24417 7.63298 5.38512 8.32181 6.06527 9.49986C6.67716 10.5597 7.17487 11.0552 7.41986 11.0823L7.4628 11.082L7.5158 11.0716L9.56651 10.4446C10.1332 10.2713 10.7438 10.4487 11.1298 10.8865L11.2215 11.0014L12.5781 12.8815C13.1299 13.6462 13.0689 14.6842 12.4533 15.378L12.3314 15.5039L11.7886 16.018C10.7948 16.9592 9.34348 17.2346 8.07389 16.7231C6.13867 15.9433 4.38077 14.1607 2.78368 11.3945C1.18323 8.62242 0.519004 6.20438 0.815977 4.13565C0.99977 2.85539 1.87301 1.78674 3.07748 1.3462L3.27036 1.28192L3.98706 1.06589Z" fill="currentColor"/>
          <path class="regular" d="M3.9292 0.399388L3.2125 0.615419C1.90898 1.00834 0.951582 2.1215 0.758116 3.46915C0.461142 5.53787 1.12537 7.95591 2.72582 10.728C4.32291 13.4942 6.0808 15.2768 8.01603 16.0565C9.28562 16.5681 10.7369 16.2927 11.7308 15.3515L12.2736 14.8374C13.0011 14.1485 13.1065 13.0275 12.5202 12.215L11.1636 10.3349C10.788 9.81423 10.1226 9.59039 9.50865 9.7781L7.45794 10.4051L7.40494 10.4154C7.17877 10.4485 6.65754 9.95942 6.00741 8.83335C5.32726 7.65531 5.1863 6.96648 5.37408 6.7889L6.41743 5.81598C7.19937 5.08681 7.43039 3.94078 6.99201 2.96562L6.33055 1.49424C5.91866 0.578005 4.89102 0.109471 3.9292 0.399388ZM5.41847 1.90427L6.07993 3.37564C6.34277 3.96031 6.20426 4.64744 5.73543 5.08463L4.68953 6.05994C4.02044 6.69268 4.24206 7.77567 5.14138 9.33335C5.98759 10.799 6.75958 11.5233 7.58908 11.3977L7.71341 11.3711L9.80102 10.7344C10.0057 10.6718 10.2275 10.7464 10.3527 10.92L11.7093 12.8001C12.0024 13.2064 11.9497 13.7669 11.586 14.1113L11.0432 14.6254C10.3333 15.2977 9.29663 15.4944 8.38977 15.129C6.6917 14.4448 5.08689 12.8175 3.59185 10.228C2.09375 7.63319 1.48745 5.42604 1.74797 3.61125C1.88616 2.64864 2.57001 1.85352 3.5011 1.57287L4.2178 1.35684C4.69871 1.21188 5.21253 1.44615 5.41847 1.90427Z" fill="currentColor"/>
        </svg>
      `;case ko.Confirmation:return Je`
      <svg width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
        <path d="M7.03212 13.9072L3.56056 10.0017C3.28538 9.69214 2.81132 9.66425 2.50174 9.93944C2.19215 10.2146 2.16426 10.6887 2.43945 10.9983L6.43945 15.4983C6.72614 15.8208 7.2252 15.8355 7.53034 15.5303L18.0303 5.03033C18.3232 4.73744 18.3232 4.26256 18.0303 3.96967C17.7374 3.67678 17.2626 3.67678 16.9697 3.96967L7.03212 13.9072Z" fill="#009E00"/>
      </svg>
      `;case ko.Copy:return Je`
        <svg width="13" height="14" viewBox="0 0 13 14" xmlns="http://www.w3.org/2000/svg">
          <path
            d="M12.625 5.50293V14H3.875V11.375H0.375V0H6.24707L8.87207 2.625H9.74707L12.625 5.50293ZM10 5.25H11.1279L10 4.12207V5.25ZM3.875 2.625H7.62793L5.87793 0.875H1.25V10.5H3.875V2.625ZM11.75 6.125H9.125V3.5H4.75V13.125H11.75V6.125Z"
          />
        </svg>
      `;case ko.Phone:return Je`
        <svg width="15" height="15" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 2048 2048" fill="none">
            <path d="M1607 1213q44 0 84 16t72 48l220 220q31 31 47 71t17 85q0 44-16 84t-48 72l-14 14q-54 54-99 96t-94 70-109 44-143 15q-125 0-257-39t-262-108-256-164-237-207-206-238-162-256T38 775 0 523q0-83 14-142t43-108 70-93 96-99l16-16q31-31 71-48t85-17q44 0 84 17t72 48l220 220q31 31 47 71t17 85q0 44-15 78t-37 63-48 51-49 45-37 44-15 49q0 38 27 65l551 551q27 27 65 27 26 0 48-15t45-37 45-48 51-49 62-37 79-15zm-83 707q72 0 120-13t88-39 76-64 85-86q27-27 27-65 0-18-14-42t-38-52-51-55-56-54-51-47-37-35q-27-27-66-27-26 0-48 15t-44 37-45 48-52 49-62 37-79 15q-44 0-84-16t-72-48L570 927q-31-31-47-71t-17-85q0-44 15-78t37-63 48-51 49-46 37-44 15-48q0-39-27-66-13-13-34-36t-47-51-54-56-56-52-51-37-43-15q-38 0-65 27l-85 85q-37 37-64 76t-40 87-14 120q0 112 36 231t101 238 153 234 192 219 219 190 234 150 236 99 226 36z" fill="${t}"></path>
        </svg>
      `;case ko.CellPhone:return Je`
        <svg width="10" height="16" viewBox="0 0 10 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M4 12C3.72386 12 3.5 12.2239 3.5 12.5C3.5 12.7761 3.72386 13 4 13H6C6.27614 13 6.5 12.7761 6.5 12.5C6.5 12.2239 6.27614 12 6 12H4ZM2 0C0.89543 0 0 0.895431 0 2V14C0 15.1046 0.895431 16 2 16H8C9.10457 16 10 15.1046 10 14V2C10 0.89543 9.10457 0 8 0H2ZM1 2C1 1.44772 1.44772 1 2 1H8C8.55228 1 9 1.44772 9 2V14C9 14.5523 8.55228 15 8 15H2C1.44772 15 1 14.5523 1 14V2Z" fill="#717171"/>
        </svg>
      `;case ko.Chat:return Je`
        <svg width="16" height="16" viewBox="0 0 16 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M8 0C12.4183 0 16 3.58172 16 8C16 12.4183 12.4183 16 8 16C6.72679 16 5.49591 15.7018 4.38669 15.1393L4.266 15.075L0.621091 15.9851C0.311269 16.0625 0.0262241 15.8369 0.00130987 15.5438L0.00114131 15.4624L0.0149329 15.3787L0.925 11.735L0.86169 11.6153C0.406602 10.7186 0.124331 9.74223 0.0327466 8.72826L0.00737596 8.34634L0 8C0 3.58172 3.58172 0 8 0ZM8 1C4.13401 1 1 4.13401 1 8C1 9.21704 1.31054 10.3878 1.89352 11.4249C1.94046 11.5084 1.9621 11.603 1.95692 11.6973L1.94274 11.7912L1.187 14.812L4.21104 14.0583C4.27294 14.0429 4.33662 14.0396 4.39873 14.0479L4.4903 14.0691L4.57701 14.1075C5.61362 14.6898 6.7837 15 8 15C11.866 15 15 11.866 15 8C15 4.13401 11.866 1 8 1ZM8.5 9C8.77614 9 9 9.22386 9 9.5C9 9.74546 8.82312 9.94961 8.58988 9.99194L8.5 10H5.5C5.22386 10 5 9.77614 5 9.5C5 9.25454 5.17688 9.05039 5.41012 9.00806L5.5 9H8.5ZM10.5 6C10.7761 6 11 6.22386 11 6.5C11 6.74546 10.8231 6.94961 10.5899 6.99194L10.5 7L5.5 7C5.22386 7 5 6.77614 5 6.5C5 6.25454 5.17688 6.05039 5.41012 6.00806L5.5 6L10.5 6Z" fill="#717171"/>
        </svg>
      `;case ko.Department:return Je`
        <svg width="17" height="14" viewBox="0 0 17 14" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M4 1.5V3H2C0.895431 3 0 3.89543 0 5V12C0 13.1046 0.895432 14 2 14H14.0026C15.1071 14 16.0026 13.1046 16.0026 12V5C16.0026 3.89543 15.1071 3 14.0026 3H12V1.5C12 0.671573 11.3284 0 10.5 0H5.5C4.67157 0 4 0.671573 4 1.5ZM5.5 1H10.5C10.7761 1 11 1.22386 11 1.5V3H5V1.5C5 1.22386 5.22386 1 5.5 1ZM2 4H14.0026C14.5549 4 15.0026 4.44772 15.0026 5V7H12L12 6.50073C12 6.22459 11.7761 6.00073 11.5 6.00073C11.2239 6.00073 11 6.22459 11 6.50074L11 7H5V6.50073C5 6.22459 4.77614 6.00073 4.5 6.00073C4.22386 6.00073 4 6.22459 4 6.50073V7H1V5C1 4.44772 1.44772 4 2 4ZM11 8L11 8.5C11 8.77615 11.2239 9 11.5 9C11.7762 9 12 8.77614 12 8.5L12 8H15.0026V12C15.0026 12.5523 14.5549 13 14.0026 13H2C1.44772 13 1 12.5523 1 12V8H4V8.5C4 8.77614 4.22386 9 4.5 9C4.77614 9 5 8.77614 5 8.5V8H11Z" fill="#717171"/>
        </svg>
      `;case ko.Email:return Je`
        <svg width="16" height="13" viewBox="0 0 16 13" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M13.5 0C14.8807 0 16 1.11929 16 2.5V10.5C16 11.8807 14.8807 13 13.5 13H2.5C1.11929 13 0 11.8807 0 10.5V2.5C0 1.11929 1.11929 0 2.5 0H13.5ZM15 3.961L8.25351 7.93097C8.12311 8.00767 7.96661 8.02045 7.82751 7.96932L7.74649 7.93097L1 3.963V10.5C1 11.3284 1.67157 12 2.5 12H13.5C14.3284 12 15 11.3284 15 10.5V3.961ZM13.5 1H2.5C1.67157 1 1 1.67157 1 2.5V2.802L8 6.91991L15 2.801V2.5C15 1.67157 14.3284 1 13.5 1Z" fill="#717171"/>
        </svg>
      `;case ko.OfficeLocation:return Je`
        <svg width="14" height="16" viewBox="0 0 14 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <title>Location icon</title>
          <path d="M10 7C10 8.65685 8.65685 10 7 10C5.34315 10 4 8.65685 4 7C4 5.34315 5.34315 4 7 4C8.65685 4 10 5.34315 10 7ZM9 7C9 5.89543 8.10457 5 7 5C5.89543 5 5 5.89543 5 7C5 8.10457 5.89543 9 7 9C8.10457 9 9 8.10457 9 7ZM11.9497 11.955C14.6834 9.2201 14.6834 4.78601 11.9497 2.05115C9.21608 -0.683716 4.78392 -0.683716 2.05025 2.05115C-0.683418 4.78601 -0.683418 9.2201 2.05025 11.955L3.57128 13.4538L5.61408 15.4389L5.74691 15.5567C6.52168 16.1847 7.65623 16.1455 8.38611 15.4391L10.8223 13.0691L11.9497 11.955ZM2.75499 2.75619C5.09944 0.410715 8.90055 0.410715 11.245 2.75619C13.5294 5.04153 13.5879 8.71039 11.4207 11.0667L11.245 11.2499L9.92371 12.5539L7.69315 14.7225L7.60016 14.8021C7.24594 15.0699 6.7543 15.0698 6.40012 14.802L6.30713 14.7224L3.3263 11.817L2.75499 11.2499L2.57927 11.0667C0.412077 8.71039 0.47065 5.04153 2.75499 2.75619Z" fill="#717171"/>
        </svg>
      `;case ko.Birthday:return Je`
        <svg width="14" height="13" viewBox="0 0 14 13" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M5.81357 0.667333C6.07581 0.320242 6.48151 0 7 0C7.51849 0 7.92419 0.320242 8.18643 0.667333C8.45471 1.0224 8.63508 1.47991 8.69561 1.93392C8.75552 2.3832 8.70532 2.89341 8.42852 3.3086C8.134 3.75039 7.63965 4 7 4C6.36035 4 5.866 3.75039 5.57148 3.3086C5.29468 2.89341 5.24448 2.3832 5.30439 1.93392C5.36492 1.47991 5.54529 1.0224 5.81357 0.667333ZM6.40353 2.7539C6.484 2.87461 6.63965 3 7 3C7.36035 3 7.516 2.87461 7.59647 2.7539C7.69468 2.60659 7.74448 2.3668 7.70439 2.06608C7.66492 1.77009 7.54529 1.4776 7.38857 1.27017C7.22581 1.05476 7.08151 1 7 1C6.91849 1 6.77419 1.05476 6.61143 1.27017C6.45471 1.4776 6.33508 1.77009 6.29561 2.06608C6.25552 2.3668 6.30532 2.60659 6.40353 2.7539ZM1 7C1 5.89543 1.89543 5 3 5H11C12.1046 5 13 5.89543 13 7V12H13.5C13.7761 12 14 12.2239 14 12.5C14 12.7761 13.7761 13 13.5 13H0.5C0.223858 13 0 12.7761 0 12.5C0 12.2239 0.223858 12 0.5 12H1V7ZM2 12H12V9.01931C11.9109 9.10285 11.8174 9.18842 11.7208 9.27412C11.4006 9.55804 11.0346 9.85319 10.6715 10.0802C10.3274 10.2953 9.90815 10.5 9.5 10.5C8.77182 10.5 8.30806 9.98986 8.00471 9.65617C7.9834 9.63273 7.96289 9.61016 7.94312 9.58869C7.5876 9.20261 7.35769 9 7 9C6.64231 9 6.4124 9.20261 6.05688 9.58869C6.03711 9.61016 6.0166 9.63273 5.99529 9.65617C5.69194 9.98986 5.22818 10.5 4.5 10.5C4.10587 10.5 3.69263 10.2897 3.35907 10.0789C3.00198 9.85313 2.63516 9.55951 2.31117 9.27666C2.20329 9.18247 2.09896 9.08844 2 8.9971V12ZM2 7.59993C2.05039 7.65198 2.11363 7.71652 2.1873 7.7902C2.38843 7.99132 2.6649 8.25801 2.96883 8.52334C3.27484 8.79049 3.59802 9.04687 3.89343 9.23362C4.21237 9.43525 4.41413 9.5 4.5 9.5C4.75817 9.5 4.93171 9.33433 5.32125 8.91131L5.32447 8.90781C5.65956 8.5439 6.16039 8 7 8C7.83961 8 8.34044 8.5439 8.67553 8.90781L8.67875 8.91131C9.06828 9.33433 9.24183 9.5 9.5 9.5C9.6106 9.5 9.82569 9.42967 10.1414 9.23229C10.4381 9.04681 10.7573 8.79196 11.0573 8.52588C11.3554 8.26163 11.6238 7.99594 11.8184 7.7955C11.89 7.72165 11.9513 7.65703 12 7.60506V7C12 6.44772 11.5523 6 11 6H3C2.44772 6 2 6.44772 2 7V7.59993Z" fill="#717171"/>
        </svg>
      `;case ko.Person:return Je`
        <svg width="14" height="16" viewBox="0 0 14 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M7 0C4.79086 0 3 1.79086 3 4C3 6.20914 4.79086 8 7 8C9.20914 8 11 6.20914 11 4C11 1.79086 9.20914 0 7 0ZM4 4C4 2.34315 5.34315 1 7 1C8.65685 1 10 2.34315 10 4C10 5.65685 8.65685 7 7 7C5.34315 7 4 5.65685 4 4ZM2.00873 9C0.903151 9 0 9.88687 0 11C0 12.6912 0.83281 13.9663 2.13499 14.7966C3.41697 15.614 5.14526 16 7 16C8.85474 16 10.583 15.614 11.865 14.7966C13.1672 13.9663 14 12.6912 14 11C14 9.89557 13.1045 9.00001 12 9.00001L2.00873 9ZM1 11C1 10.4467 1.44786 10 2.00873 10L12 10C12.5522 10 13 10.4478 13 11C13 12.3088 12.3777 13.2837 11.3274 13.9534C10.2568 14.636 8.73511 15 7 15C5.26489 15 3.74318 14.636 2.67262 13.9534C1.62226 13.2837 1 12.3088 1 11Z" fill="#717171"/>
        </svg>
      `;case ko.Messages:return Je`
        <svg width="16" height="13" viewBox="0 0 16 13" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M13.5 0C14.8807 0 16 1.11929 16 2.5V10.5C16 11.8807 14.8807 13 13.5 13H2.5C1.11929 13 0 11.8807 0 10.5V2.5C0 1.11929 1.11929 0 2.5 0H13.5ZM15 3.961L8.25351 7.93097C8.12311 8.00767 7.96661 8.02045 7.82751 7.96932L7.74649 7.93097L1 3.963V10.5C1 11.3284 1.67157 12 2.5 12H13.5C14.3284 12 15 11.3284 15 10.5V3.961ZM13.5 1H2.5C1.67157 1 1 1.67157 1 2.5V2.802L8 6.91991L15 2.801V2.5C15 1.67157 14.3284 1 13.5 1Z" fill="#717171"/>
        </svg>
      `;case ko.Organization:return Je`
        <svg width="16" height="17" viewBox="0 0 16 17" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M7.99992 0C6.34271 0 4.99927 1.34344 4.99927 3.00066C4.99927 4.48754 6.08073 5.72183 7.49999 5.95985V7.5H4.5C3.67157 7.5 3 8.17157 3 9V10.0416C1.5811 10.2799 0.5 11.514 0.5 13.0007C0.5 14.6579 1.84344 16.0013 3.50066 16.0013C5.15787 16.0013 6.50131 14.6579 6.50131 13.0007C6.50131 11.5136 5.41954 10.2791 4 10.0414V9C4 8.72386 4.22386 8.5 4.5 8.5H11.5C11.7761 8.5 12 8.72386 12 9V10.0416C10.5811 10.2799 9.5 11.514 9.5 13.0007C9.5 14.6579 10.8434 16.0013 12.5007 16.0013C14.1579 16.0013 15.5013 14.6579 15.5013 13.0007C15.5013 11.5136 14.4195 10.2791 13 10.0414V9C13 8.17157 12.3284 7.5 11.5 7.5H8.49999V5.95983C9.91918 5.72176 11.0006 4.48749 11.0006 3.00066C11.0006 1.34344 9.65714 0 7.99992 0ZM5.99927 3.00066C5.99927 1.89572 6.89499 1 7.99992 1C9.10485 1 10.0006 1.89572 10.0006 3.00066C10.0006 4.10559 9.10485 5.00131 7.99992 5.00131C6.89499 5.00131 5.99927 4.10559 5.99927 3.00066ZM1.5 13.0007C1.5 11.8957 2.39572 11 3.50066 11C4.60559 11 5.50131 11.8957 5.50131 13.0007C5.50131 14.1056 4.60559 15.0013 3.50066 15.0013C2.39572 15.0013 1.5 14.1056 1.5 13.0007ZM12.5007 11C13.6056 11 14.5013 11.8957 14.5013 13.0007C14.5013 14.1056 13.6056 15.0013 12.5007 15.0013C11.3957 15.0013 10.5 14.1056 10.5 13.0007C10.5 11.8957 11.3957 11 12.5007 11Z" fill="#717171"/>
        </svg>
      `;case ko.ExpandRight:return Je`
        <svg width="8" height="13" viewBox="0 0 8 13" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M1 12L6.5 6.5L1 1" stroke="#B8B8B8" stroke-width="2" />
        </svg>
      `;case ko.Profile:return Je`
        <svg width="14" height="16" viewBox="0 0 14 16" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M7 0C4.79086 0 3 1.79086 3 4C3 6.20914 4.79086 8 7 8C9.20914 8 11 6.20914 11 4C11 1.79086 9.20914 0 7 0ZM4 4C4 2.34315 5.34315 1 7 1C8.65685 1 10 2.34315 10 4C10 5.65685 8.65685 7 7 7C5.34315 7 4 5.65685 4 4ZM2.00873 9C0.903151 9 0 9.88687 0 11C0 12.6912 0.83281 13.9663 2.13499 14.7966C3.41697 15.614 5.14526 16 7 16C8.85474 16 10.583 15.614 11.865 14.7966C13.1672 13.9663 14 12.6912 14 11C14 9.89557 13.1045 9.00001 12 9.00001L2.00873 9ZM1 11C1 10.4467 1.44786 10 2.00873 10L12 10C12.5522 10 13 10.4478 13 11C13 12.3088 12.3777 13.2837 11.3274 13.9534C10.2568 14.636 8.73511 15 7 15C5.26489 15 3.74318 14.636 2.67262 13.9534C1.62226 13.2837 1 12.3088 1 11Z" fill="#717171"/>
        </svg>
      `;case ko.File:return Je`
        <svg width="28" height="28" viewBox="0 0 20 28" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path
            opacity="0.64"
            d="M19.613 6.993L13.018 0.421C12.7473 0.15221 12.3815 0.000947397 12 0H1.4C0.628 0 0 0.615 0 1.372V24.642C0 25.391 0.622 26 1.386 26H18.6C19.372 26 20 25.385 20 24.628V7.923C20 7.577 19.86 7.237 19.613 6.993Z"
            fill="#605E5C"
          />
          <path
            d="M19 24.628C19 24.83 18.816 25 18.6 25H1.386C1.173 25 1 24.84 1 24.642V1.372C1 1.17 1.184 1 1.4 1H12V6.6C12 7.372 12.628 8 13.4 8H19V24.628Z"
            fill="white"
          />
          <path d="M18.204 6.99994L13 1.81494V6.59994C13 6.81994 13.18 6.99994 13.4 6.99994H18.204Z" fill="white" />
        </svg>
      `;case ko.Files:return Je`
        <svg width="17" height="15" viewBox="0 0 17 15" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M14.9956 4.07309V4C14.9956 2.61929 13.8763 1.5 12.4956 1.5H7.66418L6.06391 0.299946C5.80428 0.105247 5.48851 0 5.16399 0H2.5C1.11916 0 -0.000181445 1.11949 2.20615e-08 2.50033L0.0011832 11.4978C0.00135142 12.7772 0.962583 13.8321 2.2023 13.9798C2.2867 13.9945 2.37375 14.0021 2.46289 14.0021H13.1798C13.8981 14.0021 14.5156 13.4929 14.6524 12.7877L16.0097 5.78769C16.1587 5.01967 15.696 4.29703 14.9956 4.07309ZM2.5 1H5.16399C5.27216 1 5.37742 1.03508 5.46396 1.09998L7.19756 2.40002C7.2841 2.46492 7.38936 2.5 7.49753 2.5H12.4956C13.324 2.5 13.9956 3.17157 13.9956 4V4.00214H3.824C3.10596 4.00214 2.48863 4.511 2.35158 5.21583L1.05351 11.8916C1.01941 11.7661 1.0012 11.634 1.00118 11.4976L1 2.5002C0.999891 1.67169 1.6715 1 2.5 1ZM3.33319 5.4067C3.37888 5.17176 3.58465 5.00214 3.824 5.00214H14.5372C14.8515 5.00214 15.0879 5.28874 15.028 5.59732L13.6706 12.5973C13.6251 12.8324 13.4192 13.0021 13.1798 13.0021H2.46289C2.14845 13.0021 1.91206 12.7154 1.97208 12.4067L3.33319 5.4067Z" fill="#717171"/>
        </svg>
      `;case ko.Back:return Je`
        <svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">
          <path
            d="M16 8.5H1.95312L8.10156 14.6484L7.39844 15.3516L0.046875 8L7.39844 0.648438L8.10156 1.35156L1.95312 7.5H16V8.5Z"
          />
        </svg>
      `;case ko.Close:return Je`
        <svg width="10" height="10" viewBox="0 0 10 10" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
          <path d="M5.73838 5.032L9.70337 1.067L8.99638 0.360001L5.03137 4.325L1.06637 0.360001L0.359375 1.067L4.32438 5.032L0.359375 8.997L1.06637 9.704L5.03137 5.739L8.99638 9.704L9.70337 8.997L5.73838 5.032Z" fill="currentColor"/>
        </svg>
     `;case ko.Upload:return Je`
        <svg class="upload-icon" width="21" height="12" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M4.5 2C4.08579 2 3.75 2.33579 3.75 2.75C3.75 3.16421 4.08579 3.5 4.5 3.5H15C15.4142 3.5 15.75 3.16421 15.75 2.75C15.75 2.33579 15.4142 2 15 2H4.5ZM10.4963 17.3493C10.4466 17.7154 10.1328 17.9976 9.75311 17.9976C9.3389 17.9976 9.00311 17.6618 9.00311 17.2476L9.00249 7.05856L6.02995 10.026L5.94578 10.0986C5.65202 10.3162 5.23537 10.2917 4.96929 10.0253C4.67661 9.73215 4.67695 9.25728 4.97005 8.96459L9.25962 4.67989C9.33377 4.61512 9.42089 4.56485 9.5169 4.53385L9.59777 4.51072C9.64749 4.50019 9.69837 4.4947 9.74849 4.4947L9.80855 4.49661L9.87781 4.50451L9.99828 4.53462L10.0895 4.57254L10.1259 4.59371L10.2169 4.6523L10.2875 4.71481L14.5303 8.96546L14.6029 9.04964C14.8205 9.34345 14.7959 9.7601 14.5294 10.0261L14.4452 10.0987C14.1514 10.3162 13.7347 10.2917 13.4687 10.0251L10.5025 7.05456L10.5031 17.2476L10.4963 17.3493Z" fill="#ffffff"/>
        </svg>
      `;case ko.FileCloud:return Je`
        <svg width="16" height="16"  xmlns="http://www.w3.org/2000/svg">
          <path
            d="m8,0c2.8166,0 4.4145,1.9233 4.6469,4.246l0.071,0c1.8127,0 3.2821,1.5119 3.2821,3.377c0,0.0953 -0.0038,0.1897 -0.0114,0.283c-0.322,-0.4017 -0.6967,-0.7591 -1.1138,-1.062c-0.3104,-0.9329 -1.1627,-1.598 -2.1568,-1.598l-0.0711,0c-0.5137,0 -0.9439,-0.3893 -0.9951,-0.9005c-0.2021,-2.0206 -1.5433,-3.3455 -3.6518,-3.3455c-2.1139,0 -3.4489,1.3159 -3.6518,3.3455c-0.0511,0.5112 -0.4813,0.9005 -0.9951,0.9005l-0.071,0c-1.2539,0 -2.2821,1.0579 -2.2821,2.377c0,1.3191 1.0282,2.377 2.2821,2.377l2.6655,0c-0.087,0.323 -0.1466,0.6572 -0.1762,1l-2.4893,0c-1.8127,0 -3.2821,-1.5119 -3.2821,-3.377c0,-1.8029 1.3731,-3.2758 3.102,-3.372l0.2511,-0.005c0.2338,-2.338 1.8303,-4.246 4.6469,-4.246zm3.5,16c2.4853,0 4.5,-2.0147 4.5,-4.5c0,-2.4853 -2.0147,-4.5 -4.5,-4.5c-2.4853,0 -4.5,2.0147 -4.5,4.5c0,2.4853 2.0147,4.5 4.5,4.5zm0,-7c0.2761,0 0.5,0.2239 0.5,0.5l0,1.5l1.5,0c0.2761,0 0.5,0.2239 0.5,0.5c0,0.2761 -0.2239,0.5 -0.5,0.5l-1.5,0l0,1.5c0,0.2761 -0.2239,0.5 -0.5,0.5c-0.2761,0 -0.5,-0.2239 -0.5,-0.5l0,-1.5l-1.5,0c-0.2761,0 -0.5,-0.2239 -0.5,-0.5c0,-0.2761 0.2239,-0.5 0.5,-0.5l1.5,0l0,-1.5c0,-0.2761 0.2239,-0.5 0.5,-0.5z" fill="#0078D4"
          />
        </svg>
      `;case ko.DragFile:return Je`
        <svg width="13" height="16" xmlns="http://www.w3.org/2000/svg">
          <path
            d="m0,1.00189c0,-0.8451 0.983,-1.3091 1.636,-0.772l11.006,9.0622c0.724,0.5964 0.302,1.772 -0.636,1.772l-5.592,0c-0.435,0 -0.849,0.1892 -1.134,0.5185l-3.524,4.0725c-0.606,0.7003 -1.756,0.2717 -1.756,-0.6544l0,-13.9988zm12.006,9.0622l-11.006,-9.0622l0,13.9988l3.524,-4.0724c0.475,-0.5488 1.164,-0.8642 1.89,-0.8642l5.592,0z"
          />
        </svg>
      `;case ko.Cancel:return Je`
        <svg width="11" height="11" viewBox="0 0 11 11" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M0.588591 0.715694L0.646447 0.646447C0.820013 0.47288 1.08944 0.453595 1.28431 0.588591L1.35355 0.646447L6 5.293L10.6464 0.646447C10.8417 0.451185 11.1583 0.451185 11.3536 0.646447C11.5488 0.841709 11.5488 1.15829 11.3536 1.35355L6.707 6L11.3536 10.6464C11.5271 10.82 11.5464 11.0894 11.4114 11.2843L11.3536 11.3536C11.18 11.5271 10.9106 11.5464 10.7157 11.4114L10.6464 11.3536L6 6.707L1.35355 11.3536C1.15829 11.5488 0.841709 11.5488 0.646447 11.3536C0.451185 11.1583 0.451185 10.8417 0.646447 10.6464L5.293 6L0.646447 1.35355C0.47288 1.17999 0.453595 0.910563 0.588591 0.715694L0.646447 0.646447L0.588591 0.715694Z" fill="currentColor"/>
        </svg>
     `;case ko.Success:return Je`
        <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">
          <path fill="#009E00" d="m6.322,12c3.492,0 6.323,-2.6863 6.323,-6c0,-3.3137 -2.831,-6 -6.323,-6c-3.491,0 -6.322,2.6863 -6.322,6c0,3.3137 2.831,6 6.322,6z"/>
          <path fill="white" d="m9.629,3.7509c-0.131,-0.125 -0.31,-0.1952 -0.496,-0.1952c-0.187,0 -0.365,0.0702 -0.497,0.1952l-3.267,3.1l-1.393,-1.3222c-0.177,-0.1695 -0.436,-0.2361 -0.68,-0.1746c-0.243,0.0615 -0.433,0.2418 -0.497,0.4725c-0.065,0.2307 0.005,0.4767 0.184,0.6449l1.807,1.7154c0.019,0.0331 0.041,0.0646 0.066,0.094c0.289,0.2562 0.738,0.2562 1.027,0c0.024,-0.0294 0.047,-0.0609 0.065,-0.0941l3.681,-3.4931c0.275,-0.2603 0.275,-0.6824 0,-0.9428z"/>
        </svg>
      `;case ko.CheckMark:return Je`
      <svg width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
        <path class="filled" d="M10 0C15.5228 0 20 4.47715 20 10C20 15.5228 15.5228 20 10 20C4.47715 20 0 15.5228 0 10C0 4.47715 4.47715 0 10 0ZM13.2197 6.96967L8.75 11.4393L6.78033 9.46967C6.48744 9.17678 6.01256 9.17678 5.71967 9.46967C5.42678 9.76256 5.42678 10.2374 5.71967 10.5303L8.21967 13.0303C8.51256 13.3232 8.98744 13.3232 9.28033 13.0303L14.2803 8.03033C14.5732 7.73744 14.5732 7.26256 14.2803 6.96967C13.9874 6.67678 13.5126 6.67678 13.2197 6.96967Z" fill="currentColor"/>
        <path class="regular" d="M10 1.5C5.30558 1.5 1.5 5.30558 1.5 10C1.5 14.6944 5.30558 18.5 10 18.5C14.6944 18.5 18.5 14.6944 18.5 10C18.5 5.30558 14.6944 1.5 10 1.5ZM0 10C0 4.47715 4.47715 0 10 0C15.5228 0 20 4.47715 20 10C20 15.5228 15.5228 20 10 20C4.47715 20 0 15.5228 0 10Z" fill="currentColor"/>
      </svg>
      `;case ko.Fail:return Je`
        <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">
          <path fill="#EF355D" d="m6,12c3.314,0 6,-2.6863 6,-6c0,-3.3137 -2.686,-6 -6,-6c-3.314,0 -6,2.6863 -6,6c0,3.3137 2.686,6 6,6z"/>
          <path fill="white" d="m6.943,6.0004l1.544,-1.5444c0.169,-0.1683 0.236,-0.4142 0.174,-0.6448c-0.061,-0.2306 -0.241,-0.4107 -0.472,-0.4722c-0.231,-0.0616 -0.477,0.0049 -0.645,0.1742l-1.544,1.5443l-1.545,-1.5443c-0.26,-0.259 -0.681,-0.2583 -0.941,0.0014c-0.26,0.2598 -0.26,0.6808 -0.001,0.9414l1.544,1.5444l-1.544,1.5444c-0.259,0.2606 -0.259,0.6815 0.001,0.9413c0.26,0.2598 0.681,0.2604 0.941,0.0015l1.545,-1.5444l1.544,1.5444c0.261,0.2589 0.682,0.2583 0.942,-0.0015c0.259,-0.2598 0.26,-0.6807 0.001,-0.9413l-1.544,-1.5444z" />
        </svg>
      `;case ko.SelectAccount:return Je`
    <svg xmlns="http://www.w3.org/2000/svg" width="17" height="17" viewBox="0 0 17 17" fill="none">
      <path fill=${t} d="M6.22176 13.9567C3.55468 13.653 2 11.8026 2 10V9.5C2 8.67157 2.67157 8 3.5 8H5.59971C5.43777 8.31679 5.30564 8.65136 5.20703 9H3.5C3.22386 9 3 9.22386 3 9.5V10C3 11.1281 3.88187 12.333 5.50235 12.7996C5.69426 13.216 5.93668 13.6043 6.22176 13.9567ZM9.62596 5.06907C9.70657 4.81036 9.75 4.53525 9.75 4.25C9.75 2.73122 8.51878 1.5 7 1.5C5.48122 1.5 4.25 2.73122 4.25 4.25C4.25 5.53662 5.13357 6.61687 6.32704 6.91706C6.64202 6.55055 7.00446 6.226 7.40482 5.95294C7.27488 5.98371 7.13934 6 7 6C6.0335 6 5.25 5.2165 5.25 4.25C5.25 3.2835 6.0335 2.5 7 2.5C7.9665 2.5 8.75 3.2835 8.75 4.25C8.75 4.73141 8.55561 5.16743 8.24104 5.48382C8.67558 5.28783 9.14016 5.14664 9.62596 5.06907ZM10.5 15C12.9853 15 15 12.9853 15 10.5C15 8.01472 12.9853 6 10.5 6C8.01472 6 6 8.01472 6 10.5C6 12.9853 8.01472 15 10.5 15ZM10.5 8C10.7761 8 11 8.22386 11 8.5V10H12.5C12.7761 10 13 10.2239 13 10.5C13 10.7761 12.7761 11 12.5 11H11V12.5C11 12.7761 10.7761 13 10.5 13C10.2239 13 10 12.7761 10 12.5V11H8.5C8.22386 11 8 10.7761 8 10.5C8 10.2239 8.22386 10 8.5 10H10V8.5C10 8.22386 10.2239 8 10.5 8Z"/>
    </svg>
  `;case ko.News:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
        <path d="M18.75 20H5.25C3.51697 20 2.10075 18.6435 2.00514 16.9344L2 16.75V6.25C2 5.05914 2.92516 4.08436 4.09595 4.00519L4.25 4H16.75C17.9409 4 18.9156 4.92516 18.9948 6.09595L19 6.25V7H19.75C20.9409 7 21.9156 7.92516 21.9948 9.09595L22 9.25V16.75C22 18.483 20.6435 19.8992 18.9344 19.9949L18.75 20H5.25H18.75ZM5.25 18.5H18.75C19.6682 18.5 20.4212 17.7929 20.4942 16.8935L20.5 16.75V9.25C20.5 8.8703 20.2178 8.55651 19.8518 8.50685L19.75 8.5H19V16.25C19 16.6297 18.7178 16.9435 18.3518 16.9932L18.25 17C17.8703 17 17.5565 16.7178 17.5068 16.3518L17.5 16.25V6.25C17.5 5.8703 17.2178 5.55651 16.8518 5.50685L16.75 5.5H4.25C3.8703 5.5 3.55651 5.78215 3.50685 6.14823L3.5 6.25V16.75C3.5 17.6682 4.20711 18.4212 5.10647 18.4942L5.25 18.5H18.75H5.25ZM12.246 14.5H15.2522C15.6665 14.5 16.0022 14.8358 16.0022 15.25C16.0022 15.6297 15.7201 15.9435 15.354 15.9932L15.2522 16H12.246C11.8318 16 11.496 15.6642 11.496 15.25C11.496 14.8703 11.7782 14.5565 12.1442 14.5068L12.246 14.5H15.2522H12.246ZM9.24328 11.0045C9.6575 11.0045 9.99328 11.3403 9.99328 11.7545V15.25C9.99328 15.6642 9.6575 16 9.24328 16H5.74776C5.33355 16 4.99776 15.6642 4.99776 15.25V11.7545C4.99776 11.3403 5.33355 11.0045 5.74776 11.0045H9.24328ZM8.49328 12.5045H6.49776V14.5H8.49328V12.5045ZM12.246 11.0045H15.2522C15.6665 11.0045 16.0022 11.3403 16.0022 11.7545C16.0022 12.1342 15.7201 12.448 15.354 12.4976L15.2522 12.5045H12.246C11.8318 12.5045 11.496 12.1687 11.496 11.7545C11.496 11.3748 11.7782 11.061 12.1442 11.0113L12.246 11.0045H15.2522H12.246ZM5.74776 7.50247H15.2522C15.6665 7.50247 16.0022 7.83826 16.0022 8.25247C16.0022 8.63217 15.7201 8.94596 15.354 8.99563L15.2522 9.00247H5.74776C5.33355 9.00247 4.99776 8.66669 4.99776 8.25247C4.99776 7.87278 5.27991 7.55898 5.64599 7.50932L5.74776 7.50247H15.2522H5.74776Z" fill="none" />
      </svg>
      `;case ko.DoubleBookmark:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M4 6.74814C4 5.50535 5.00742 4.49786 6.25013 4.49786H15.2506C16.4933 4.49786 17.5008 5.50535 17.5008 6.74814V21.2499C17.5008 21.5185 17.3572 21.7666 17.1243 21.9003C16.8914 22.0341 16.6048 22.0332 16.3728 21.8978L10.7504 18.6179L5.12797 21.8978C4.89599 22.0332 4.60936 22.0341 4.37648 21.9003C4.14359 21.7666 4 21.5185 4 21.2499V6.74814ZM6.25013 5.99805C5.83589 5.99805 5.50008 6.33387 5.50008 6.74814V19.944L10.3725 17.1016C10.606 16.9653 10.8948 16.9653 11.1283 17.1016L16.0007 19.944V6.74814C16.0007 6.33387 15.6649 5.99805 15.2506 5.99805H6.25013ZM15.2497 2C17.8732 2 20 4.12691 20 6.75058V18.6232C20 19.0374 19.6642 19.3733 19.25 19.3733C18.8357 19.3733 18.4999 19.0374 18.4999 18.6232V6.75058C18.4999 4.95543 17.0448 3.50018 15.2497 3.50018H6.63687C6.63687 3.50018 6.75016 2.94339 7.43379 2.41948C8.00023 2 8.60182 2 8.60182 2H15.2497Z" fill="none" />
        </svg>
      `;case ko.ChevronLeft:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M15.5303 4.21967C15.8232 4.51256 15.8232 4.98744 15.5303 5.28033L8.81066 12L15.5303 18.7197C15.8232 19.0126 15.8232 19.4874 15.5303 19.7803C15.2374 20.0732 14.7626 20.0732 14.4697 19.7803L7.21967 12.5303C6.92678 12.2374 6.92678 11.7626 7.21967 11.4697L14.4697 4.21967C14.7626 3.92678 15.2374 3.92678 15.5303 4.21967Z" fill="none" />
        </svg>`;case ko.ChevronRight:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="currentColor" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M8.46967 4.21967C8.17678 4.51256 8.17678 4.98744 8.46967 5.28033L15.1893 12L8.46967 18.7197C8.17678 19.0126 8.17678 19.4874 8.46967 19.7803C8.76256 20.0732 9.23744 20.0732 9.53033 19.7803L16.7803 12.5303C17.0732 12.2374 17.0732 11.7626 16.7803 11.4697L9.53033 4.21967C9.23744 3.92678 8.76256 3.92678 8.46967 4.21967Z" fill="currentColor" />
        </svg>`;case ko.Delete:return Je`
        <svg width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M8.5 4H11.5C11.5 3.17157 10.8284 2.5 10 2.5C9.17157 2.5 8.5 3.17157 8.5 4ZM7.5 4C7.5 2.61929 8.61929 1.5 10 1.5C11.3807 1.5 12.5 2.61929 12.5 4H17.5C17.7761 4 18 4.22386 18 4.5C18 4.77614 17.7761 5 17.5 5H16.4456L15.2521 15.3439C15.0774 16.8576 13.7957 18 12.2719 18H7.72813C6.20431 18 4.92256 16.8576 4.7479 15.3439L3.55437 5H2.5C2.22386 5 2 4.77614 2 4.5C2 4.22386 2.22386 4 2.5 4H7.5ZM5.74131 15.2292C5.85775 16.2384 6.71225 17 7.72813 17H12.2719C13.2878 17 14.1422 16.2384 14.2587 15.2292L15.439 5H4.56101L5.74131 15.2292ZM8.5 7.5C8.77614 7.5 9 7.72386 9 8V14C9 14.2761 8.77614 14.5 8.5 14.5C8.22386 14.5 8 14.2761 8 14V8C8 7.72386 8.22386 7.5 8.5 7.5ZM12 8C12 7.72386 11.7761 7.5 11.5 7.5C11.2239 7.5 11 7.72386 11 8V14C11 14.2761 11.2239 14.5 11.5 14.5C11.7761 14.5 12 14.2761 12 14V8Z" fill="currentColor"/>
        </svg>
    `;case ko.Add:return Je`
        <svg width="16" height="15" viewBox="0 0 16 15" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
          <path d="M8.39563 0.5C8.39563 0.223858 8.17177 0 7.89563 0C7.61949 0 7.39563 0.223858 7.39563 0.5V7H0.89563C0.619487 7 0.39563 7.22386 0.39563 7.5C0.39563 7.77614 0.619487 8 0.89563 8H7.39563V14.5C7.39563 14.7761 7.61949 15 7.89563 15C8.17177 15 8.39563 14.7761 8.39563 14.5V8H14.8956C15.1718 8 15.3956 7.77614 15.3956 7.5C15.3956 7.22386 15.1718 7 14.8956 7H8.39563V0.5Z" fill="${t}"/>
        </svg>`;case ko.Calendar:return Je`
        <svg width="20" height="20" viewBox="0 0 20 20" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M7 11C7.55228 11 8 10.5523 8 10C8 9.44771 7.55228 9 7 9C6.44772 9 6 9.44771 6 10C6 10.5523 6.44772 11 7 11ZM8 13C8 13.5523 7.55228 14 7 14C6.44772 14 6 13.5523 6 13C6 12.4477 6.44772 12 7 12C7.55228 12 8 12.4477 8 13ZM10 11C10.5523 11 11 10.5523 11 10C11 9.44771 10.5523 9 10 9C9.44771 9 9 9.44771 9 10C9 10.5523 9.44771 11 10 11ZM11 13C11 13.5523 10.5523 14 10 14C9.44771 14 9 13.5523 9 13C9 12.4477 9.44771 12 10 12C10.5523 12 11 12.4477 11 13ZM13 11C13.5523 11 14 10.5523 14 10C14 9.44771 13.5523 9 13 9C12.4477 9 12 9.44771 12 10C12 10.5523 12.4477 11 13 11ZM17 5.5C17 4.11929 15.8807 3 14.5 3H5.5C4.11929 3 3 4.11929 3 5.5V14.5C3 15.8807 4.11929 17 5.5 17H14.5C15.8807 17 17 15.8807 17 14.5V5.5ZM4 7H16V14.5C16 15.3284 15.3284 16 14.5 16H5.5C4.67157 16 4 15.3284 4 14.5V7ZM5.5 4H14.5C15.3284 4 16 4.67157 16 5.5V6H4V5.5C4 4.67157 4.67157 4 5.5 4Z" fill=${t}/>
        </svg>
    `;case ko.Planner:return Je`
        <svg width="24" height="24" fill="none" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
          <path d="M17.75 3A3.25 3.25 0 0 1 21 6.25v11.5A3.25 3.25 0 0 1 17.75 21H6.25A3.25 3.25 0 0 1 3 17.75V6.25A3.25 3.25 0 0 1 6.25 3h11.5Zm1.75 5.5h-15v9.25c0 .966.784 1.75 1.75 1.75h11.5a1.75 1.75 0 0 0 1.75-1.75V8.5Zm-11.75 6a1.25 1.25 0 1 1 0 2.5 1.25 1.25 0 0 1 0-2.5Zm4.25 0a1.25 1.25 0 1 1 0 2.5 1.25 1.25 0 0 1 0-2.5Zm-4.25-4a1.25 1.25 0 1 1 0 2.5 1.25 1.25 0 0 1 0-2.5Zm4.25 0a1.25 1.25 0 1 1 0 2.5 1.25 1.25 0 0 1 0-2.5Zm4.25 0a1.25 1.25 0 1 1 0 2.5 1.25 1.25 0 0 1 0-2.5Zm1.5-6H6.25A1.75 1.75 0 0 0 4.5 6.25V7h15v-.75a1.75 1.75 0 0 0-1.75-1.75Z" fill="${t}"/>
        </svg>`;case ko.Milestone:return Je`
        <svg width="24" height="24" fill="${t}" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
          <path d="M15.25 13c.966 0 1.75.784 1.75 1.75v4.5A1.75 1.75 0 0 1 15.25 21H3.75A1.75 1.75 0 0 1 2 19.25v-4.5c0-.966.783-1.75 1.75-1.75h11.5ZM21 14.899v5.351a.75.75 0 0 1-1.494.102l-.006-.102v-5.338a3.006 3.006 0 0 0 1.5-.013Zm-5.75-.399H3.75a.25.25 0 0 0-.25.25v4.5c0 .138.111.25.25.25h11.5a.25.25 0 0 0 .25-.25v-4.5a.25.25 0 0 0-.25-.25Zm5-4.408a1.908 1.908 0 1 1 0 3.816 1.908 1.908 0 0 1 0-3.816ZM15.244 3c.967 0 1.75.784 1.75 1.75v4.5a1.75 1.75 0 0 1-1.75 1.75h-11.5a1.75 1.75 0 0 1-1.75-1.75v-4.5a1.75 1.75 0 0 1 1.607-1.744L3.745 3h11.5Zm0 1.5h-11.5l-.057.007a.25.25 0 0 0-.193.243v4.5c0 .138.112.25.25.25h11.5a.25.25 0 0 0 .25-.25v-4.5a.25.25 0 0 0-.25-.25ZM20.25 3a.75.75 0 0 1 .743.648L21 3.75v5.351a3.004 3.004 0 0 0-1.5-.013V3.75a.75.75 0 0 1 .75-.75Z" fill="${t}"/>
        </svg>`;case ko.PersonAdd:return Je`
        <svg width="20" height="20" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg" class="svg" fill="currentColor">
          <path d="M9 2a4 4 0 100 8 4 4 0 000-8zM6 6a3 3 0 116 0 3 3 0 01-6 0z"></path>
          <path d="M4 11a2 2 0 00-2 2c0 1.7.83 2.97 2.13 3.8A9.14 9.14 0 009 18c.41 0 .82-.02 1.21-.06A5.5 5.5 0 019.6 17 12 12 0 019 17a8.16 8.16 0 01-4.33-1.05A3.36 3.36 0 013 13a1 1 0 011-1h5.6c.18-.36.4-.7.66-1H4z"></path>
          <path d="M14.5 19a4.5 4.5 0 100-9 4.5 4.5 0 000 9zm0-7c.28 0 .5.22.5.5V14h1.5a.5.5 0 010 1H15v1.5a.5.5 0 01-1 0V15h-1.5a.5.5 0 010-1H14v-1.5c0-.28.22-.5.5-.5z"></path>
        </svg>`;case ko.Event:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M17.75 3C19.5449 3 21 4.45507 21 6.25V17.75C21 19.5449 19.5449 21 17.75 21H6.25C4.45507 21 3 19.5449 3 17.75V6.25C3 4.45507 4.45507 3 6.25 3H17.75ZM19.5 8.5H4.5V17.75C4.5 18.7165 5.2835 19.5 6.25 19.5H17.75C18.7165 19.5 19.5 18.7165 19.5 17.75V8.5ZM7.75 14.5C8.44036 14.5 9 15.0596 9 15.75C9 16.4404 8.44036 17 7.75 17C7.05964 17 6.5 16.4404 6.5 15.75C6.5 15.0596 7.05964 14.5 7.75 14.5ZM12 14.5C12.6904 14.5 13.25 15.0596 13.25 15.75C13.25 16.4404 12.6904 17 12 17C11.3096 17 10.75 16.4404 10.75 15.75C10.75 15.0596 11.3096 14.5 12 14.5ZM7.75 10.5C8.44036 10.5 9 11.0596 9 11.75C9 12.4404 8.44036 13 7.75 13C7.05964 13 6.5 12.4404 6.5 11.75C6.5 11.0596 7.05964 10.5 7.75 10.5ZM12 10.5C12.6904 10.5 13.25 11.0596 13.25 11.75C13.25 12.4404 12.6904 13 12 13C11.3096 13 10.75 12.4404 10.75 11.75C10.75 11.0596 11.3096 10.5 12 10.5ZM16.25 10.5C16.9404 10.5 17.5 11.0596 17.5 11.75C17.5 12.4404 16.9404 13 16.25 13C15.5596 13 15 12.4404 15 11.75C15 11.0596 15.5596 10.5 16.25 10.5ZM17.75 4.5H6.25C5.2835 4.5 4.5 5.2835 4.5 6.25V7H19.5V6.25C19.5 5.2835 18.7165 4.5 17.75 4.5Z" fill="none" />
        </svg>
      `;case ko.BookOpen:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M12 19.1375C11.4986 19.6686 10.788 20 10 20H3.75C2.7835 20 2 19.2165 2 18.25V5.75C2 4.7835 2.7835 4 3.75 4H10C10.788 4 11.4986 4.33145 12 4.86253C12.5014 4.33145 13.212 4 14 4H20.25C21.2165 4 22 4.7835 22 5.75V18.25C22 19.2165 21.2165 20 20.25 20H14C13.212 20 12.5014 19.6686 12 19.1375ZM3.5 5.75V18.25C3.5 18.3881 3.61193 18.5 3.75 18.5H10C10.6904 18.5 11.25 17.9404 11.25 17.25V6.75C11.25 6.05964 10.6904 5.5 10 5.5H3.75C3.61193 5.5 3.5 5.61193 3.5 5.75ZM12.75 17.25C12.75 17.9404 13.3096 18.5 14 18.5H20.25C20.3881 18.5 20.5 18.3881 20.5 18.25V5.75C20.5 5.61193 20.3881 5.5 20.25 5.5H14C13.3096 5.5 12.75 6.05964 12.75 6.75V17.25Z" fill="none" />
        </svg>
      `;case ko.FileOuter:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M6 2C4.89543 2 4 2.89543 4 4V20C4 21.1046 4.89543 22 6 22H18C19.1046 22 20 21.1046 20 20V9.82777C20 9.29733 19.7893 8.78863 19.4142 8.41355L13.5864 2.58579C13.2114 2.21071 12.7027 2 12.1722 2H6ZM5.5 4C5.5 3.72386 5.72386 3.5 6 3.5H12V8C12 9.10457 12.8954 10 14 10H18.5V20C18.5 20.2761 18.2761 20.5 18 20.5H6C5.72386 20.5 5.5 20.2761 5.5 20V4ZM17.3793 8.5H14C13.7239 8.5 13.5 8.27614 13.5 8V4.62066L17.3793 8.5Z" fill="none" />
        </svg>
      `;case ko.BookQuestion:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M10.9998 8.01752C10.9905 8.42363 10.6584 8.74999 10.25 8.74999C9.5 8.74999 9.5 7.9989 9.5 7.9989L9.5 7.99777L9.50001 7.99539L9.50006 7.99017C9.50032 7.9755 9.50072 7.96084 9.50144 7.94618C9.50262 7.92198 9.50473 7.89159 9.50846 7.8559C9.51591 7.78477 9.52996 7.69092 9.55665 7.58186C9.60973 7.36492 9.71565 7.07652 9.92848 6.78906C10.3825 6.17582 11.1982 5.72727 12.513 5.7501C13.4627 5.76659 14.3059 6.16497 14.834 6.82047C15.371 7.48704 15.5517 8.3902 15.1964 9.27853C14.8342 10.1839 14.0149 10.5437 13.5442 10.7503L13.4932 10.7728C13.2147 10.8957 13.0813 10.9599 13.0013 11.024L13 11.0251L13 11.7492C13.0001 12.1634 12.6643 12.4999 12.2501 12.5C11.8359 12.5 11.5001 12.1643 11.5 11.7501L11.5 11C11.5 10.4769 11.752 10.1029 12.0633 9.85345C12.3134 9.65303 12.6276 9.51483 12.8491 9.4174L12.8875 9.40049C13.4292 9.16137 13.6868 9.01346 13.8036 8.72145C13.9483 8.35977 13.8789 8.02596 13.6659 7.76153C13.4439 7.48604 13.0371 7.25943 12.487 7.24988C11.5518 7.23364 11.2425 7.53509 11.134 7.68162C11.0656 7.77404 11.0309 7.86797 11.0137 7.93838C11.0052 7.973 11.0017 7.99908 11.0003 8.01197L10.9998 8.01752ZM12.25 15.5C12.8023 15.5 13.25 15.0523 13.25 14.5C13.25 13.9477 12.8023 13.5 12.25 13.5C11.6977 13.5 11.25 13.9477 11.25 14.5C11.25 15.0523 11.6977 15.5 12.25 15.5ZM4 4.5C4 3.11929 5.11929 2 6.5 2H18C19.3807 2 20.5 3.11929 20.5 4.5V18.75C20.5 19.1642 20.1642 19.5 19.75 19.5H5.5C5.5 20.0523 5.94772 20.5 6.5 20.5H19.75C20.1642 20.5 20.5 20.8358 20.5 21.25C20.5 21.6642 20.1642 22 19.75 22H6.5C5.11929 22 4 20.8807 4 19.5V4.5ZM5.5 4.5V18H19V4.5C19 3.94772 18.5523 3.5 18 3.5H6.5C5.94772 3.5 5.5 3.94772 5.5 4.5Z" fill="none" />
        </svg>
      `;case ko.Globe:return Je`
        <svg width="24" height="24" viewBox="0 0 24 24" fill="none" aria-hidden="true" xmlns="http://www.w3.org/2000/svg">
          <path d="M12.0001 1.99805C17.5238 1.99805 22.0016 6.47589 22.0016 11.9996C22.0016 17.5233 17.5238 22.0011 12.0001 22.0011C6.47638 22.0011 1.99854 17.5233 1.99854 11.9996C1.99854 6.47589 6.47638 1.99805 12.0001 1.99805ZM14.939 16.4993H9.06118C9.71322 18.9135 10.8466 20.5011 12.0001 20.5011C13.1536 20.5011 14.2869 18.9135 14.939 16.4993ZM7.5084 16.4999L4.78591 16.4998C5.74425 18.0328 7.1777 19.2384 8.88008 19.9104C8.3578 19.0906 7.92681 18.0643 7.60981 16.8949L7.5084 16.4999ZM19.2143 16.4998L16.4918 16.4999C16.168 17.8337 15.7004 18.9995 15.119 19.9104C16.716 19.2804 18.0757 18.1814 19.0291 16.7833L19.2143 16.4998ZM7.09351 9.99895H3.7359L3.73115 10.0162C3.57906 10.6525 3.49854 11.3166 3.49854 11.9996C3.49854 13.0558 3.69112 14.0669 4.0431 14.9999L7.21626 14.9995C7.07396 14.0504 6.99854 13.0422 6.99854 11.9996C6.99854 11.3156 7.031 10.6464 7.09351 9.99895ZM15.397 9.99901H8.60316C8.53514 10.6393 8.49853 11.309 8.49853 11.9996C8.49853 13.0591 8.58468 14.0694 8.73827 14.9997H15.2619C15.4155 14.0694 15.5016 13.0591 15.5016 11.9996C15.5016 11.309 15.465 10.6393 15.397 9.99901ZM20.2647 9.99811L16.9067 9.99897C16.9692 10.6464 17.0016 11.3156 17.0016 11.9996C17.0016 13.0422 16.9262 14.0504 16.7839 14.9995L19.9571 14.9999C20.309 14.0669 20.5016 13.0558 20.5016 11.9996C20.5016 11.3102 20.4196 10.64 20.2647 9.99811ZM8.88114 4.08875L8.85823 4.09747C6.81092 4.91218 5.1549 6.49949 4.25023 8.49935L7.29835 8.49972C7.61171 6.74693 8.15855 5.221 8.88114 4.08875ZM12.0001 3.49805L11.8844 3.50335C10.619 3.6191 9.39651 5.62107 8.8288 8.4993H15.1714C14.6052 5.62914 13.388 3.63033 12.1264 3.50436L12.0001 3.49805ZM15.1201 4.08881L15.2269 4.2629C15.8961 5.37537 16.4043 6.83525 16.7018 8.49972L19.7499 8.49935C18.8853 6.58795 17.3343 5.05341 15.4113 4.21008L15.1201 4.08881Z" />
        </svg>
      `;case ko.PresenceAvailable:return Je`
        <svg fill="#13a10e" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 10A5 5 0 1 0 5 0a5 5 0 0 0 0 10Zm2.1-5.9L4.85 6.35a.5.5 0 0 1-.7 0l-1-1a.5.5 0 0 1 .7-.7l.65.64 1.9-1.9a.5.5 0 0 1 .7.71Z" fill="#13a10e"></path>
        </svg>`;case ko.PresenceOofAvailable:return Je`
        <svg fill="#13a10e" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
            <path d="M5 0a5 5 0 1 0 0 10A5 5 0 0 0 5 0ZM1 5a4 4 0 1 1 8 0 4 4 0 0 1-8 0Zm6.1-1.6c.2.2.2.5 0 .7L4.85 6.35a.5.5 0 0 1-.7 0l-1-1a.5.5 0 1 1 .7-.7l.65.64 1.9-1.9c.2-.19.5-.19.7 0Z" fill="#13a10e"></path>
        </svg>`;case ko.PresenceBusy:return Je`
        <svg fill="#d13438" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M10 5A5 5 0 1 1 0 5a5 5 0 0 1 10 0Z" fill="#d13438"></path>
        </svg>`;case ko.PresenceOofBusy:return Je`
        <svg fill="#d13438" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 1a4 4 0 1 0 0 8 4 4 0 0 0 0-8ZM0 5a5 5 0 1 1 10 0A5 5 0 0 1 0 5Z" fill="#d13438"></path>
        </svg>
      `;case ko.PresenceDnd:return Je`
        <svg fill="#d13438" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 10A5 5 0 1 0 5 0a5 5 0 0 0 0 10ZM3.5 4.5h3a.5.5 0 0 1 0 1h-3a.5.5 0 0 1 0-1Z" fill="#d13438"></path>
        </svg>`;case ko.PresenceOofDnd:return Je`
        <svg fill="#d13438" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 0a5 5 0 1 0 0 10A5 5 0 0 0 5 0ZM1 5a4 4 0 1 1 8 0 4 4 0 0 1-8 0Zm2 0c0-.28.22-.5.5-.5h3a.5.5 0 0 1 0 1h-3A.5.5 0 0 1 3 5Z" fill="#d13438"></path>
        </svg>`;case ko.PresenceAway:return Je`
        <svg fill="#eaa300" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 10A5 5 0 1 0 5 0a5 5 0 0 0 0 10Zm0-7v1.8l1.35 1.35a.5.5 0 1 1-.7.7l-1.5-1.5A.5.5 0 0 1 4 5V3a.5.5 0 0 1 1 0Z" fill="#eaa300"></path>
        </svg>`;case ko.PresenceOofAway:return Je`
        <svg fill="#c239b3" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5.35 3.85a.5.5 0 1 0-.7-.7l-1.5 1.5a.5.5 0 0 0 0 .7l1.5 1.5a.5.5 0 1 0 .7-.7L4.7 5.5h1.8a.5.5 0 1 0 0-1H4.7l.65-.65ZM5 0a5 5 0 1 0 0 10A5 5 0 0 0 5 0ZM1 5a4 4 0 1 1 8 0 4 4 0 0 1-8 0Z" fill="#c239b3"></path>
        </svg>`;case ko.PresenceOffline:return Je`
        <svg fill="#929292" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M6.85 3.15c.2.2.2.5 0 .7L5.71 5l1.14 1.15a.5.5 0 1 1-.7.7L5 5.71 3.85 6.85a.5.5 0 1 1-.7-.7L4.29 5 3.15 3.85a.5.5 0 1 1 .7-.7L5 4.29l1.15-1.14c.2-.2.5-.2.7 0ZM0 5a5 5 0 1 1 10 0A5 5 0 0 1 0 5Zm5-4a4 4 0 1 0 0 8 4 4 0 0 0 0-8Z" fill="#929292"></path>
        </svg>`;case ko.PresenceStatusUnknown:return Je`
        <svg fill="#d13438" aria-hidden="true" width="10" height="10" viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg">
          <path d="M5 1a4 4 0 1 0 0 8 4 4 0 0 0 0-8ZM0 5a5 5 0 1 1 10 0A5 5 0 0 1 0 5Z" fill="#d13438"></path>
        </svg>`}},$o=()=>void 0!==window.getWindowSegments,So=[be`
.root .scout-top{position:fixed;top:0;left:0}.root .scout-bottom{position:fixed;bottom:0;right:0}.root .flyout{display:none;position:fixed;z-index:9999999;opacity:0;box-shadow:var(--mgt-flyout-box-shadow,var(--elevation-shadow-card-rest));border-radius:8px}.root .flyout.small{overflow-y:auto;overflow-x:hidden}.root.visible .flyout{display:inline-block;animation-name:fade-in;animation-duration:.3s;animation-timing-function:cubic-bezier(.1,.9,.2,1);animation-fill-mode:both;transition:top .3s ease,bottom .3s ease,left .3s ease}.root.visible .flyout.small{overflow-y:auto;overflow-x:hidden}@keyframes fade-in{from{opacity:0;margin-top:-10px;margin-bottom:-10px}to{opacity:1;margin-top:0;margin-bottom:0}}
`];var _o=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Io=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};let To=class extends Pt{static get styles(){return So}get isOpen(){return this._isOpen}set isOpen(e){const t=this._isOpen;t!==e&&(this._isOpen=e,window.requestAnimationFrame((()=>{this.setupWindowEvents(this.isOpen);const e=this._flyout;!this.isOpen&&e&&(e.style.width=null,e.style.setProperty("--mgt-flyout-set-width",null),e.style.setProperty("--mgt-flyout-set-height",null),e.style.maxHeight=null,e.style.top=null,e.style.left=null,e.style.bottom=null)})),this.requestUpdate("isOpen",t),this.dispatchEvent(new Event(e?"opened":"closed")))}get _edgePadding(){return 24}get _flyout(){return this.renderRoot.querySelector(".flyout")}get _anchor(){return this.renderRoot.querySelector(".anchor")}get _topScout(){return this.renderRoot.querySelector(".scout-top")}get _bottomScout(){return this.renderRoot.querySelector(".scout-bottom")}constructor(){super(),this._renderedOnce=!1,this._isOpen=!1,this._smallView=!1,this.handleWindowEvent=e=>{const t=this._flyout;if(t)if(e.composedPath){const i=e.composedPath();if(i.includes(t)||"pointerdown"===e.type&&i.includes(this))return}else{let i=e.target;for(;i;)if(i=i.parentElement,i===t||"pointerdown"===e.type&&i===this)return}this.close()},this.handleResize=()=>{this.close()},this.handleKeyUp=e=>{"Escape"===e.key&&this.close()},this.handleFlyoutWheel=e=>{e.preventDefault()},this.avoidHidingAnchor=!0,this.addEventListener("expanded",(()=>{window.requestAnimationFrame((()=>{this.updateFlyout()}))}))}open(){this.isOpen=!0}close(){this.isOpen=!1}disconnectedCallback(){this.setupWindowEvents(!1),super.disconnectedCallback()}updated(e){super.updated(e),window.requestAnimationFrame((()=>{this.updateFlyout()}))}render(){const e={root:!0,visible:this.isOpen},t=this.renderAnchor();let i=null;if(this._windowHeight=window.innerHeight&&document.documentElement.clientHeight?Math.min(window.innerHeight,document.documentElement.clientHeight):window.innerHeight||document.documentElement.clientHeight,this._windowHeight<250&&(this._smallView=!0),this.isOpen||this._renderedOnce){this._renderedOnce=!0;const e=ki({flyout:!0,small:this._smallView});i=Je`
        <div class=${e} @wheel=${this.handleFlyoutWheel}>
          ${this.renderFlyout()}
        </div>
      `}return Je`
      <div class=${ki(e)}>
        <div class="anchor">
          ${t}
        </div>
        <div class="scout-top"></div>
        <div class="scout-bottom"></div>
        ${i}
      </div>
    `}renderAnchor(){return Je`
      <slot name="anchor"></slot>
    `}renderFlyout(){return Je`
      <slot name="flyout"></slot>
    `}updateFlyout(e=!0){if(!this.isOpen)return;const t=this._anchor,i=this._flyout;if(i&&t){const o=window.innerWidth&&document.documentElement.clientWidth?Math.min(window.innerWidth,document.documentElement.clientWidth):window.innerWidth||document.documentElement.clientWidth;this._windowHeight=window.innerHeight&&document.documentElement.clientHeight?Math.min(window.innerHeight,document.documentElement.clientHeight):window.innerHeight||document.documentElement.clientHeight;let s,n,r,a=0,l=0;const d=i.getBoundingClientRect(),c=t.getBoundingClientRect(),h=this._topScout.getBoundingClientRect(),u=this._bottomScout.getBoundingClientRect(),p={height:this._windowHeight,left:0,top:0,width:o};if($o()){const e=($o()?window:null).getWindowSegments();let t;const i=c.left+c.width/2,o=c.top+c.height/2;for(const s of e)if(i>=s.left&&o>=s.top){t=s;break}t&&(p.left=t.left,p.top=t.top,p.width=t.width,p.height=t.height)}d.width+2*this._edgePadding>p.width?d.width>p.width?(r=p.width,a=0):a=(p.width-d.width)/2:a=c.left+d.width+this._edgePadding>p.width?c.left-(c.left+d.width+this._edgePadding-p.width):c.left<this._edgePadding?this._edgePadding:c.left;const g=p.height-(c.top+c.height),f=c.top;this.avoidHidingAnchor?g<=d.height?f<d.height?f>g?(s=p.height-c.top,n=f):(l=c.bottom,n=g):(s=p.height-c.top,n=f):(l=c.bottom,n=g):d.height+2*this._edgePadding>p.height?d.height>=p.height?(n=p.height,l=0):l=(p.height-d.height)/2:l=c.top+c.height+d.height+this._edgePadding>p.height?p.height-d.height-this._edgePadding:Math.max(c.top+c.height,this._edgePadding),0===h.top&&0===h.left||(a-=h.left,void 0!==s?s+=u.top-this._windowHeight:l-=h.top),"rtl"===this.direction?a>100&&this.offsetLeft>100&&(i.style.left=p.width-a+d.left-d.width-30+"px"):i.style.left=`${a+p.left}px`,void 0!==s?(i.style.top="unset",i.style.bottom=`${s}px`):(i.style.bottom="unset",i.style.top=`${l+p.top}px`),r&&(i.style.width=`${r}px`,i.style.setProperty("--mgt-flyout-set-width",`${r}px`),window.requestAnimationFrame((()=>this.updateFlyout()))),n?(i.style.maxHeight=`${n}px`,i.style.setProperty("--mgt-flyout-set-height",`${n}px`)):(i.style.maxHeight=null,i.style.setProperty("--mgt-flyout-set-height","unset")),e&&window.requestAnimationFrame((()=>this.updateFlyout(!1)))}}setupWindowEvents(e){e&&this.isLightDismiss?(window.addEventListener("wheel",this.handleWindowEvent),window.addEventListener("pointerdown",this.handleWindowEvent),window.addEventListener("resize",this.handleResize),window.addEventListener("keyup",this.handleKeyUp)):(window.removeEventListener("wheel",this.handleWindowEvent),window.removeEventListener("pointerdown",this.handleWindowEvent),window.removeEventListener("resize",this.handleResize),window.removeEventListener("keyup",this.handleKeyUp))}};var Do;_o([Ct({attribute:"light-dismiss",type:Boolean}),Io("design:type",Boolean)],To.prototype,"isLightDismiss",void 0),_o([Ct({attribute:null,type:Boolean}),Io("design:type",Boolean)],To.prototype,"avoidHidingAnchor",void 0),_o([Ct({attribute:"isOpen",type:Boolean}),Io("design:type",Boolean),Io("design:paramtypes",[Boolean])],To.prototype,"isOpen",null),To=_o([gi("flyout"),Io("design:paramtypes",[])],To),function(e){e[e.none=0]="none",e[e.hover=1]="hover",e[e.click=2]="click"}(Do||(Do={}));const Po=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{font-size:var(--default-font-size)}:host .flyout [slot=anchor]{display:flex;cursor:pointer}:host .flyout [slot=anchor].vertical{flex-direction:column;justify-content:center;align-items:center;margin-inline-start:0;--person-avatar-size:72px}:host .person-root{display:flex;flex-direction:row;align-items:center;background-color:var(--person-background-color,transparent);border-radius:var(--person-border-radius,4px)}:host .person-root.small .avatar-wrapper{min-width:var(--person-avatar-size,24px);width:var(--person-avatar-size,24px);height:var(--person-avatar-size,24px)}:host .person-root.noline .presence-basic,:host .person-root.oneline .presence-basic{border-width:1px;position:relative;bottom:calc(var(--person-avatar-size,24px) * .12 - 4px)}:host .person-root.twolines .avatar-wrapper{min-width:var(--person-avatar-size,40px);width:var(--person-avatar-size,40px);height:var(--person-avatar-size,40px)}:host .person-root.twolines .avatar-wrapper .contact-icon,:host .person-root.twolines .avatar-wrapper .initials{font-size:calc(var(--person-avatar-size,40px) * .4)}:host .person-root.twolines .avatar-wrapper .presence-wrapper svg{width:calc(var(--person-avatar-size,40px) * .28);height:calc(var(--person-avatar-size,40px) * .28)}:host .person-root.large .avatar-wrapper,:host .person-root.threelines .avatar-wrapper{min-width:var(--person-avatar-size,56px);width:var(--person-avatar-size,56px);height:var(--person-avatar-size,56px)}:host .person-root.large .avatar-wrapper .contact-icon,:host .person-root.large .avatar-wrapper .initials,:host .person-root.threelines .avatar-wrapper .contact-icon,:host .person-root.threelines .avatar-wrapper .initials{font-size:calc(var(--person-avatar-size,56px) * .4)}:host .person-root.large .avatar-wrapper .presence-wrapper svg,:host .person-root.threelines .avatar-wrapper .presence-wrapper svg{width:calc(var(--person-avatar-size,56px) * .28);height:calc(var(--person-avatar-size,56px) * .28)}:host .person-root.fourlines .avatar-wrapper{min-width:var(--person-avatar-size,72px);width:var(--person-avatar-size,72px);height:var(--person-avatar-size,72px)}:host .person-root.fourlines .avatar-wrapper .contact-icon,:host .person-root.fourlines .avatar-wrapper .initials{font-size:calc(var(--person-avatar-size,72px) * .4)}:host .person-root.fourlines .avatar-wrapper .presence-wrapper svg{width:calc(var(--person-avatar-size,72px) * .28);height:calc(var(--person-avatar-size,72px) * .28)}:host .person-root.vertical{flex-direction:column;justify-content:center;align-items:center}:host .person-root.vertical .avatar-wrapper{min-width:var(--person-avatar-size,72px);width:var(--person-avatar-size,72px);height:var(--person-avatar-size,72px)}:host .person-root.vertical .avatar-wrapper .contact-icon,:host .person-root.vertical .avatar-wrapper .initials{font-size:calc(var(--person-avatar-size,72px) * .4)}:host .person-root.vertical .avatar-wrapper .presence-wrapper svg{width:calc(var(--person-avatar-size,72px) * .28);height:calc(var(--person-avatar-size,72px) * .28)}:host .person-root .avatar-wrapper{min-width:var(--person-avatar-size,24px);width:var(--person-avatar-size,24px);height:var(--person-avatar-size,24px);position:relative;box-sizing:border-box}:host .person-root .avatar-wrapper .contact-icon,:host .person-root .avatar-wrapper .initials,:host .person-root .avatar-wrapper img{height:100%;width:100%;border:var(--person-avatar-border,none);border-radius:var(--person-avatar-border-radius,50%);margin-block-start:var(--person-avatar-top-spacing,0)}:host .person-root .avatar-wrapper .contact-icon,:host .person-root .avatar-wrapper .initials{display:flex;justify-content:center;align-items:center;font-size:calc(var(--person-avatar-size,24px) * .4);font-weight:400;background:var(--person-initials-background-color,var(--neutral-fill-secondary-rest));color:var(--person-initials-text-color,var(--neutral-fill-strong-hover))}:host .person-root .avatar-wrapper .presence-wrapper{bottom:var(--person-presence-wrapper-bottom,0);right:0;position:absolute;border-radius:50%;background-color:var(--neutral-layer-1);border:1px solid var(--neutral-layer-1)}:host .person-root .avatar-wrapper .presence-wrapper svg{display:flex;width:calc(var(--person-avatar-size,24px) * .28);height:calc(var(--person-avatar-size,24px) * .28)}:host .person-root .details-wrapper{display:flex;flex-direction:column;align-items:flex-start;min-width:var(--person-details-wrapper-width,168px);margin-inline-start:var(--person-details-left-spacing,12px);margin-block-end:var(--person-details-bottom-spacing,0)}:host .person-root .details-wrapper.vertical{display:inline-flex;flex-direction:column;justify-content:center;align-items:center;margin-inline-start:0}:host .person-root .details-wrapper .line1{font-size:var(--person-line1-font-size,ms-font-size-14);font-weight:var(--person-line1-font-weight,600);color:var(--person-line1-text-color,var(--neutral-foreground-rest));text-transform:var(--person-line1-text-transform,inherit);line-height:var(--person-line1-text-line-height,20px)}:host .person-root .details-wrapper .line2{font-size:var(--person-line2-font-size,var(--email-font-size,ms-font-size-12));font-weight:var(--person-line2-font-weight,400);color:var(--person-line2-text-color,var(--secondary-text-color));text-transform:var(--person-line2-text-transform,inherit);line-height:var(--person-line2-text-line-height,16px)}:host .person-root .details-wrapper .line3{font-size:var(--person-line3-font-size,var(--email-font-size,ms-font-size-12));font-weight:var(--person-line3-font-weight,400);color:var(--person-line3-text-color,var(--secondary-text-color));text-transform:var(--person-line3-text-transform,inherit);line-height:var(--person-line3-text-line-height,16px)}:host .person-root .details-wrapper .line4{font-size:var(--person-line4-font-size,var(--email-font-size,ms-font-size-12));font-weight:var(--person-line4-font-weight,400);color:var(--person-line4-text-color,var(--secondary-text-color));text-transform:var(--person-line4-text-transform,inherit);line-height:var(--person-line4-text-line-height,16px)}@media (forced-colors:active) and (prefers-color-scheme:dark){:host svg,:host svg>path{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}@media (forced-colors:active) and (prefers-color-scheme:dark){:host svg,:host svg>path{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}[dir=rtl] .presence-wrapper{right:unset!important;left:0}
`];var Lo,Eo;!function(e){e[e.avatar=2]="avatar",e[e.oneline=3]="oneline",e[e.twolines=4]="twolines",e[e.threelines=5]="threelines",e[e.fourlines=6]="fourlines"}(Lo||(Lo={})),function(e){e.photo="photo",e.initials="initials"}(Eo||(Eo={}));const Oo=Object.assign(Object.assign({},{Available:"Available",Away:"Away",BeRightBack:"Be right back",Busy:"Busy",DoNotDisturb:"Do not disturb",InACall:"In a call",InAConferenceCall:"In a conference call",Inactive:"Inactive",InAMeeting:"In a meeting",Offline:"Offline",OffWork:"Off work",OutOfOffice:"Out of office",PresenceUnknown:"Presence unknown",Presenting:"Presenting",UrgentInterruptionsOnly:"Urgent interruptions only"}),{photoFor:"Photo for",emailAddress:"Email address",initials:"Initials"}),Fo=e=>"personType"in e||"userType"in e,Ao=e=>null!=e?e:et;var Ro,Vo=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Mo=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};const zo=["businessPhones","displayName","givenName","jobTitle","department","mail","mobilePhone","officeLocation","preferredLanguage","surname","userPrincipalName","id","userType"];let No=Ro=class extends Nt{static get styles(){return Po}get strings(){return Oo}get personQuery(){return this._personQuery}set personQuery(e){e!==this._personQuery&&(this._personQuery=e,this.personDetailsInternal=null,this.requestStateUpdate())}get fallbackDetails(){return this._fallbackDetails}set fallbackDetails(e){e!==this._fallbackDetails&&(this._fallbackDetails=e,this.personDetailsInternal||this.requestStateUpdate())}get userId(){return this._userId}set userId(e){e!==this._userId&&(this._userId=e,this.personDetailsInternal=null,this.requestStateUpdate())}get usage(){return this._usage}set usage(e){e!==this._usage&&(this._usage=e,this.requestStateUpdate())}get personDetailsInternal(){return this._personDetailsInternal}set personDetailsInternal(e){this._personDetailsInternal!==e&&(this._personDetailsInternal=e,this._fetchedImage=null,this._fetchedPresence=null,this.requestStateUpdate(),this.requestUpdate("personDetailsInternal"))}get personDetails(){return this._personDetails}set personDetails(e){this._personDetails!==e&&(this._personDetails=e,this._fetchedImage=null,this._fetchedPresence=null,this.requestStateUpdate(),this.requestUpdate("personDetails"))}get personImage(){return this._personImage||this._fetchedImage}set personImage(e){if(e===this._personImage)return;this._isInvalidImageSrc=!e;const t=this._personImage;this._personImage=e,this.requestUpdate("personImage",t)}get avatarType(){return this._avatarType}set avatarType(e){e!==this._avatarType&&(this._avatarType=e,this.requestStateUpdate())}get personPresence(){return this._personPresence||this._fetchedPresence}set personPresence(e){if(e===this._personPresence)return;const t=this._personPresence;this._personPresence=e,this.requestUpdate("personPresence",t)}static get requiredScopes(){const e=["user.readbasic.all","user.read","people.read","presence.read.all","presence.read"];return Ro.config.useContactApis&&e.push("contacts.read"),e}get flyout(){return this.renderRoot.querySelector(".flyout")}constructor(){super(),this._mouseLeaveTimeout=-1,this._mouseEnterTimeout=-1,this.handleMouseClick=e=>{const t=e.target;this.personCardInteraction===Do.click&&t.tagName!==`${ce.prefix}-PERSON-CARD`.toUpperCase()&&this.showPersonCard()},this.handleKeyDown=e=>{e&&"Enter"===e.key&&this.showPersonCard()},this.handleMouseEnter=()=>{clearTimeout(this._mouseEnterTimeout),clearTimeout(this._mouseLeaveTimeout),this.personCardInteraction===Do.hover&&(this._mouseEnterTimeout=window.setTimeout(this.showPersonCard,500))},this.handleMouseLeave=()=>{clearTimeout(this._mouseEnterTimeout),clearTimeout(this._mouseLeaveTimeout),this._mouseLeaveTimeout=window.setTimeout(this.hidePersonCard,500)},this.hidePersonCard=()=>{const e=this.flyout;e&&e.close();const t=this.querySelector(".mgt-person-card")||this.renderRoot.querySelector(".mgt-person-card");t&&(t.isExpanded=!1,t.clearHistory())},this.showPersonCard=()=>{this._personCardShouldRender||(this._personCardShouldRender=!0);const e=this.flyout;e&&e.open()},this.personCardInteraction=Do.none,this.line1Property="displayName",this.line2Property="jobTitle",this.line3Property="department",this.line4Property="email",this.view=xo.image,this.avatarSize="auto",this.disableImageFetch=!1,this._isInvalidImageSrc=!1,this._avatarType=Eo.photo,this.verticalLayout=!1}render(){if(this.isLoadingState&&!this.personDetails&&!this.personDetailsInternal&&!this.fallbackDetails)return this.renderLoading();const e=this.personDetails||this.personDetailsInternal||this.fallbackDetails,t=this.getImage(),i=this.personPresence||this._fetchedPresence;if(!e&&!t)return this.renderNoData();!(null==e?void 0:e.personImage)&&t&&(e.personImage=t);let o=this.renderTemplate("default",{person:e,personImage:t,personPresence:i});if(!o){const s=this.renderDetails(e,i),n=this.renderAvatar(e,t,i);o=Je`
        ${n}
        ${s}
      `}this.personCardInteraction!==Do.none&&(o=this.renderFlyout(o,e,t,i));const s=ki({"person-root":!0,small:!this.isThreeLines()&&!this.isFourLines()&&!this.isLargeAvatar(),large:"auto"!==this.avatarSize&&this.isLargeAvatar(),noline:this.isNoLine(),oneline:this.isOneLine(),twolines:this.isTwoLines(),threelines:this.isThreeLines(),fourlines:this.isFourLines(),vertical:this.isVertical()});return Je`
      <div
        class="${s}"
        dir=${this.direction}
        @click=${this.handleMouseClick}
        @mouseenter=${this.handleMouseEnter}
        @mouseleave=${this.handleMouseLeave}
        @keydown=${this.handleKeyDown}
        tabindex="${Ao(this.personCardInteraction!==Do.none?"0":void 0)}"
      >
        ${o}
      </div>
    `}renderLoading(){return this.renderTemplate("loading",null)||Je``}clearState(){this._personImage="",this._personDetailsInternal=null,this._fetchedImage=null,this._fetchedPresence=null}renderNoData(){const e=this.renderTemplate("no-data",null);if(e)return e;const t={"avatar-icon":!0,vertical:this.isVertical(),small:!this.isLargeAvatar(),threeLines:this.isThreeLines(),fourLines:this.isFourLines()};return Je`
       <i class=${ki(t)}></i>
     `}renderPersonIcon(){return Co(ko.Person)}renderImage(e,t){var i;const o=`${this.strings.photoFor} ${e.displayName}`,s=t&&!this._isInvalidImageSrc&&this.avatarType===Eo.photo,n=this.avatarType===Eo.photo&&this.view===xo.image,r=null!==(i=(null==e?void 0:e.displayName)||Qi(e))&&void 0!==i?i:void 0,a=Je`<img
      title="${Ao(n?r:void 0)}"
      alt=${o}
      src=${t}
      @error=${()=>this._isInvalidImageSrc=!0} />`,l=e?this.getInitials(e):"",d=null==l?void 0:l.length,c=ki({initials:d&&!s,"contact-icon":!d}),h=Je`<i>${this.renderPersonIcon()}</i>`,u=Je`
      <span 
        title="${Ao(this.view===xo.image?r:void 0)}"
        role="${Ao(this.view===xo.image?void 0:"presentation")}"
        class="${c}"
      >
        ${d?l:h}
      </span>
`;return s?a:u}renderPresence(e){var t;if(!this.showPresence||!e)return Je``;let i;const{activity:o,availability:s}=e;switch(s){case"Available":case"AvailableIdle":i=Co("OutOfOffice"===o?ko.PresenceOofAvailable:ko.PresenceAvailable);break;case"Busy":case"BusyIdle":switch(o){case"OutOfOffice":case"OnACall":i=Co(ko.PresenceOofBusy);break;default:i=Co(ko.PresenceBusy)}break;case"DoNotDisturb":i=Co("OutOfOffice"===o?ko.PresenceOofDnd:ko.PresenceDnd);break;case"Away":i=Co("OutOfOffice"===o?ko.PresenceOofAway:ko.PresenceAway);break;case"BeRightBack":i=Co(ko.PresenceAway);break;case"Offline":switch(o){case"Offline":i=Co(ko.PresenceOffline);break;case"OutOfOffice":case"OffWork":i=Co(ko.PresenceOofAway);break;default:i=Co(ko.PresenceStatusUnknown)}break;default:i=Co(ko.PresenceStatusUnknown)}const n=ki({"presence-wrapper":!0,noline:this.isNoLine(),oneline:this.isOneLine()}),r=null!==(t=this.strings[o])&&void 0!==t?t:et;return Je`
      <span
        class="${n}"
        title="${r}"
        aria-label="${r}"
        role="img">
          ${i}
      </span>
    `}renderAvatar(e,t,i){let o="";if(t&&!this._isInvalidImageSrc&&this._avatarType!==Eo.initials||!e?(o=e&&e.displayName||"",""!==o&&(o=`${this.strings.photoFor} ${o}`)):o=`${this.strings.initials} ${this.getInitials(e)}`,""===o){const t=Qi(e);null!==t&&(o=`${this.strings.emailAddress} ${t}`)}const s=this.renderImage(e,t),n=this.renderPresence(i);return Je`
      <div class="avatar-wrapper">
        ${s}
        ${n}
      </div>
    `}handleLine1Clicked(){this.fireCustomEvent("line1clicked",this.personDetailsInternal)}handleLine2Clicked(){this.fireCustomEvent("line2clicked",this.personDetailsInternal)}handleLine3Clicked(){this.fireCustomEvent("line3clicked",this.personDetailsInternal)}handleLine4Clicked(){this.fireCustomEvent("line4clicked",this.personDetailsInternal)}renderDetails(e,t){if(!e||this.view===xo.image||this.view===Lo.avatar)return Je``;const i=e;t&&(i.presenceActivity=null==t?void 0:t.activity,i.presenceAvailability=null==t?void 0:t.availability);const o=[];if(this.view>xo.image){const e=this.getTextFromProperty(i,this.line1Property);if(this.hasTemplate("line1")){const t=this.renderTemplate("line1",{person:i});o.push(Je`
           <div class="line1" @click=${()=>this.handleLine1Clicked()} role="presentation" aria-label="${e}">${t}</div>
         `)}else e&&o.push(Je`
             <div class="line1" @click=${()=>this.handleLine1Clicked()} role="presentation" aria-label="${e}">${e}</div>
           `)}if(this.view>xo.oneline){const e=this.getTextFromProperty(i,this.line2Property);if(this.hasTemplate("line2")){const t=this.renderTemplate("line2",{person:i});o.push(Je`
           <div class="line2" @click=${()=>this.handleLine2Clicked()} role="presentation" aria-label="${e}">${t}</div>
         `)}else e&&o.push(Je`
             <div class="line2" @click=${()=>this.handleLine2Clicked()} role="presentation" aria-label="${e}">${e}</div>
           `)}if(this.view>xo.twolines){const e=this.getTextFromProperty(i,this.line3Property);if(this.hasTemplate("line3")){const t=this.renderTemplate("line3",{person:i});o.push(Je`
           <div class="line3" @click=${()=>this.handleLine3Clicked()} role="presentation" aria-label="${e}">${t}</div>
         `)}else e&&o.push(Je`
             <div class="line3" @click=${()=>this.handleLine3Clicked()} role="presentation" aria-label="${e}">${e}</div>
           `)}if(this.view>xo.threelines){const e=this.getTextFromProperty(i,this.line4Property);if(this.hasTemplate("line4")){const t=this.renderTemplate("line4",{person:i});o.push(Je`
          <div class="line4" @click=${()=>this.handleLine4Clicked()} role="presentation" aria-label="${e}">${t}</div>
        `)}else e&&o.push(Je`
            <div class="line4" @click=${()=>this.handleLine4Clicked()} role="presentation" aria-label="${e}">${e}</div>
          `)}const s=ki({"details-wrapper":!0,vertical:this.isVertical()});return Je`
      <div class="${s}">
        ${o}
      </div>
    `}renderFlyout(e,t,i,o){const s=this._personCardShouldRender?Je`
           <div slot="flyout" data-testid="flyout-slot">
             ${this.renderFlyoutContent(t,i,o)}
           </div>`:Je``,n=ki({vertical:this.isVertical()});return pi`
      <mgt-flyout light-dismiss class="flyout" .avoidHidingAnchor=${!1}>
        <div slot="anchor" class="${n}">${e}</div>
        ${s}
      </mgt-flyout>`}renderFlyoutContent(e,t,i){return this.renderTemplate("person-card",{person:e,personImage:t})||pi`
        <mgt-person-card
          class="mgt-person-card"
          lock-tab-navigation
          .personDetails=${e}
          .personImage=${t}
          .personPresence=${i}
          .showPresence=${this.showPresence}>
        </mgt-person-card>`}loadState(){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){const e=te.globalProvider;if(!e||e.state===Q.Loading)return;if(e&&e.state===Q.SignedOut)return void(this.personDetailsInternal=null);const t=e.graph.forComponent(this);this.fallbackDetails&&(this.line2Property="email"),this.verticalLayout&&this.view<xo.fourlines&&(this.line2Property="email");let i=[...zo,this.line1Property,this.line2Property,this.line3Property,this.line4Property];i=i.filter((e=>"email"!==e));let o=this.personDetailsInternal||this.personDetails||this.fallbackDetails;if(o){if(!o.personImage&&this.fetchImage&&this._avatarType===Eo.photo&&!this.personImage&&!this._fetchedImage){let e;e="groupTypes"in o?yield((e,t)=>ro(void 0,void 0,void 0,(function*(){let i,o;const s=t.id;if(lo()){if(o=ai.getCache(Ai,Ai.stores.groups),i=yield o.getValue(s),i&&ao()>Date.now()-i.timeCached)return i.photo;if(i)try{const t=yield e.api(`groups/${s}/photo`).get();t&&(t["@odata.mediaEtag"]!==i.eTag||null===t["@odata.mediaEtag"]&&null===i.eTag)&&(i=null)}catch(e){return null}}return i=i||(yield co(e,`groups/${s}`,["user.readbasic.all"])),lo()&&i&&(yield o.putValue(s,i)),i?i.photo:null})))(t,o):yield po(t,o,Ro.config.useContactApis),e&&(o.personImage=e,this._fetchedImage=e)}}else if(this.userId||"me"===this.personQuery){let e;e=this._avatarType!==Eo.photo||this.disableImageFetch?"me"===this.personQuery?yield eo(t,i):yield to(t,this.userId,i):yield wo(t,this.userId,i),this.personDetailsInternal=e,this.personDetails=e,this._fetchedImage=this.getImage()}else if(this.personQuery){let e=yield Wi(t,this.personQuery,1);if(e&&0!==e.length||(e=(yield oo(t,this.personQuery,1))||[]),(null==e?void 0:e.length)&&(this.personDetailsInternal=e[0],this.personDetails=e[0],this._avatarType===Eo.photo&&!this.disableImageFetch)){const i=yield po(t,e[0],Ro.config.useContactApis);i&&(this.personDetailsInternal.personImage=i,this.personDetails.personImage=i,this._fetchedImage=i)}}const s={activity:"Offline",availability:"Offline",id:null};if(this.showPresence&&!this.personPresence&&!this._fetchedPresence)try{if(o=this.personDetailsInternal||this.personDetails,o){const e="me"!==this.personQuery?null==o?void 0:o.id:null;this._fetchedPresence=yield bo(t,e)}else this._fetchedPresence=s}catch(e){this._fetchedPresence=s}}))}getInitials(e){var t,i,o,s,n,r;if(e||(e=this.personDetailsInternal),"initials"in e)return e.initials;let a="";if(Fo(e)&&(a+=null!==(o=null===(i=null===(t=e.givenName)||void 0===t?void 0:t[0])||void 0===i?void 0:i.toUpperCase())&&void 0!==o?o:"",a+=null!==(r=null===(n=null===(s=e.surname)||void 0===s?void 0:s[0])||void 0===n?void 0:n.toUpperCase())&&void 0!==r?r:""),!a&&e.displayName){const t=e.displayName.split(/\s+/);for(let e=0;e<2&&e<t.length;e++)t[e][0]&&this.isLetter(t[e][0])&&(a+=t[e][0].toUpperCase())}return a}getImage(){if(this.personImage)return this.personImage;if(this._fetchedImage)return this._fetchedImage;const e=this.personDetailsInternal||this.personDetails;return(null==e?void 0:e.personImage)?e.personImage:null}isLetter(e){try{return e.match(new RegExp("\\p{L}","u"))}catch(t){return e.toLowerCase()!==e.toUpperCase()}}getTextFromProperty(e,t){if(!t||0===t.length)return null;const i=t.trim().split(",");let o,s=0;for(;!o&&s<i.length;){const t=i[s].trim();switch(t){case"mail":case"email":o=Qi(e);break;default:o=e[t]}s++}return o}isLargeAvatar(){return"large"===this.avatarSize||"auto"===this.avatarSize&&this.view>xo.oneline}isNoLine(){return this.view<xo.oneline}isOneLine(){return this.view===xo.oneline}isTwoLines(){return this.view===xo.twolines}isThreeLines(){return this.view===xo.threelines}isFourLines(){return this.view===xo.fourlines}isVertical(){return this.verticalLayout}};No.config={useContactApis:!0},Vo([Ct({attribute:"person-query"}),Mo("design:type",String),Mo("design:paramtypes",[String])],No.prototype,"personQuery",null),Vo([Ct({attribute:"fallback-details",type:Object}),Mo("design:type",Object),Mo("design:paramtypes",[Object])],No.prototype,"fallbackDetails",null),Vo([Ct({attribute:"user-id"}),Mo("design:type",String),Mo("design:paramtypes",[String])],No.prototype,"userId",null),Vo([Ct({attribute:"usage"}),Mo("design:type",String),Mo("design:paramtypes",[String])],No.prototype,"usage",null),Vo([Ct({attribute:"show-presence",type:Boolean}),Mo("design:type",Boolean)],No.prototype,"showPresence",void 0),Vo([Ct({attribute:"avatar-size",type:String}),Mo("design:type",String)],No.prototype,"avatarSize",void 0),Vo([$t(),Mo("design:type",Object),Mo("design:paramtypes",[Object])],No.prototype,"personDetailsInternal",null),Vo([Ct({attribute:"person-details",type:Object}),Mo("design:type",Object),Mo("design:paramtypes",[Object])],No.prototype,"personDetails",null),Vo([Ct({attribute:"person-image",type:String}),Mo("design:type",String),Mo("design:paramtypes",[String])],No.prototype,"personImage",null),Vo([Ct({attribute:"fetch-image",type:Boolean}),Mo("design:type",Boolean)],No.prototype,"fetchImage",void 0),Vo([Ct({attribute:"disable-image-fetch",type:Boolean}),Mo("design:type",Boolean)],No.prototype,"disableImageFetch",void 0),Vo([Ct({attribute:"vertical-layout",type:Boolean}),Mo("design:type",Boolean)],No.prototype,"verticalLayout",void 0),Vo([Ct({attribute:"avatar-type",converter:e=>"initials"===(e=e.toLowerCase())?Eo.initials:Eo.photo}),Mo("design:type",String),Mo("design:paramtypes",[String])],No.prototype,"avatarType",null),Vo([Ct({attribute:"person-presence",type:Object}),Mo("design:type",Object),Mo("design:paramtypes",[Object])],No.prototype,"personPresence",null),Vo([Ct({attribute:"person-card",converter:e=>(e=e.toLowerCase(),void 0===Do[e]?Do.none:Do[e])}),Mo("design:type",Number)],No.prototype,"personCardInteraction",void 0),Vo([Ct({attribute:"line1-property"}),Mo("design:type",String)],No.prototype,"line1Property",void 0),Vo([Ct({attribute:"line2-property"}),Mo("design:type",String)],No.prototype,"line2Property",void 0),Vo([Ct({attribute:"line3-property"}),Mo("design:type",String)],No.prototype,"line3Property",void 0),Vo([Ct({attribute:"line4-property"}),Mo("design:type",String)],No.prototype,"line4Property",void 0),Vo([Ct({converter:e=>e&&0!==e.length?(e=e.toLowerCase(),void 0===xo[e]?xo.image:xo[e]):xo.image}),Mo("design:type",Number)],No.prototype,"view",void 0),Vo([$t(),Mo("design:type",String)],No.prototype,"_fetchedImage",void 0),Vo([$t(),Mo("design:type",Object)],No.prototype,"_fetchedPresence",void 0),Vo([$t(),Mo("design:type",Boolean)],No.prototype,"_isInvalidImageSrc",void 0),Vo([$t(),Mo("design:type",Boolean)],No.prototype,"_personCardShouldRender",void 0),No=Ro=Vo([gi("person"),Mo("design:paramtypes",[])],No);const Uo=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{--card-height:auto;--card-width:99%;background-color:var(--agenda-background-color,transparent)}:host .header{margin:var(--agenda-header-margin,18px 0 12px 10px);font-size:var(--agenda-header-font-size,24px);font-style:normal;font-weight:400;line-height:32px;color:var(--agenda-header-color,var(--neutral-foreground-rest));opacity:.9}:host .agenda,:host .group{display:flex;flex-direction:column;row-gap:var(--agenda-event-row-gap,14px)}:host .agenda>.group:first-child>.header,:host .group>.group:first-child>.header{margin-top:0}:host .agenda .event,:host .group .event{background:var(--agenda-event-background-color,var(--fill-color));border:var(--agenda-event-border,solid 2px transparent);box-shadow:var(--agenda-event-box-shadow,var(--elevation-shadow-card-rest));padding:var(--agenda-event-padding,12px);position:relative;display:flex;flex:1 1 auto;content-visibility:visible;contain:none}:host .agenda .event-container,:host .group .event-container{border-radius:calc(var(--layer-corner-radius) * 1px);padding:1px}:host .agenda .event.narrow,:host .group .event.narrow{display:flex;flex-direction:column;inset:0}:host .agenda .event-time-container,:host .group .event-time-container{font-style:normal;font-weight:600;font-size:12px;color:var(--agenda-event-time-color,var(--neutral-foreground-rest));width:112px;height:16px}:host .agenda .event-time-container.narrow,:host .group .event-time-container.narrow{margin-bottom:1px;width:100%}:host .agenda .event-time,:host .group .event-time{font-size:var(--agenda-event-time-font-size,12px);color:var(--agenda-event-time-color,var(--neutral-foreground-rest));font-weight:600}:host .agenda .event-details-container,:host .group .event-details-container{display:flex;flex-direction:column;position:relative;bottom:8px;top:0;padding-inline-start:32px}:host .agenda .event-details-container.narrow,:host .group .event-details-container.narrow{position:inherit;left:6px;display:flex;flex-direction:column;padding-inline-start:0}:host .agenda .event-subject,:host .group .event-subject{font-style:normal;font-weight:400;font-size:var(--agenda-event-subject-font-size,20px);line-height:28px;color:var(--agenda-event-subject-color,var(--neutral-foreground-rest));mix-blend-mode:normal;position:inherit;bottom:8px}:host .agenda .event-location-container,:host .group .event-location-container{display:inline-flex;flex-direction:row}:host .agenda .event-location-container .event-location,:host .group .event-location-container .event-location{padding-inline-start:3px;font-style:normal;font-weight:400;font-size:var(--agenda-event-location-font-size,12px);line-height:16px;color:var(--agenda-event-location-color,var(--neutral-foreground-rest))}:host .agenda .event-location-container .event-location-loading,:host .group .event-location-container .event-location-loading{width:90px;height:10px;margin:2px 0 0 4px}:host .agenda .event-location-container .event-location-icon,:host .group .event-location-container .event-location-icon{display:inline-flex}:host .agenda .event-location-container .event-location-icon svg,:host .group .event-location-container .event-location-icon svg{position:relative;top:2px;width:12px;height:12px}:host .agenda .event-location-container .event-location-icon svg path,:host .group .event-location-container .event-location-icon svg path{stroke:var(--agenda-event-location-color,var(--neutral-foreground-rest))}:host .agenda .event-location-container .event-location-icon-loading,:host .group .event-location-container .event-location-icon-loading{width:14px;height:14px}:host .agenda .event-location-container .event-attendee-loading,:host .group .event-location-container .event-attendee-loading{width:20px;height:20px;border-radius:10px;margin:0 2px 0 0}:host .agenda .event-attendees,:host .group .event-attendees{--list-margin:8px 0 0 0;--avatar-size-s:20px}fluent-card.event.event-loading{--card-height:90px}:host .event-attendees{--color:$agenda-event-attendees-color}:host fluent-tooltip{width:auto;contain:inline-size}[dir=rtl] :host{direction:rtl}[dir=rtl] .event-time-container{direction:ltr;display:flex;justify-content:flex-end}@media (forced-colors:active) and (prefers-color-scheme:dark){:host .agenda .event-location-container .event-location-icon svg path{stroke:#fff!important}}@media (forced-colors:active) and (prefers-color-scheme:light){:host .agenda .event-location-container .event-location-icon svg path{stroke:#000!important}}
`];var Bo=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const Ho=(e,t,i="calendars.read")=>Bo(void 0,void 0,void 0,(function*(){const o=e.api(t).middlewareOptions(ie(i)).orderby("start/dateTime");return ci.create(e,o)})),{I:jo}=ft,qo=()=>document.createComment(""),Zo=(e,t,i)=>{var o;const s=e._$AA.parentNode,n=void 0===t?e._$AB:t._$AA;if(void 0===i){const t=s.insertBefore(qo(),n),o=s.insertBefore(qo(),n);i=new jo(t,o,e,e.options)}else{const t=i._$AB.nextSibling,r=i._$AM,a=r!==e;if(a){let t;null===(o=i._$AQ)||void 0===o||o.call(i,e),i._$AM=e,void 0!==i._$AP&&(t=e._$AU)!==r._$AU&&i._$AP(t)}if(t!==n||a){let e=i._$AA;for(;e!==t;){const t=e.nextSibling;s.insertBefore(e,n),e=t}}}return i},Wo=(e,t,i=e)=>(e._$AI(t,i),e),Go={},Qo=e=>{var t;null===(t=e._$AP)||void 0===t||t.call(e,!1,!0);let i=e._$AA;const o=e._$AB.nextSibling;for(;i!==o;){const e=i.nextSibling;i.remove(),i=e}},Ko=(e,t,i)=>{const o=new Map;for(let s=t;s<=i;s++)o.set(e[s],s);return o},Xo=wi(class extends xi{constructor(e){if(super(e),2!==e.type)throw Error("repeat() can only be used in text expressions")}ct(e,t,i){let o;void 0===i?i=t:void 0!==t&&(o=t);const s=[],n=[];let r=0;for(const t of e)s[r]=o?o(t,r):r,n[r]=i(t,r),r++;return{values:n,keys:s}}render(e,t,i){return this.ct(e,t,i).values}update(e,[t,i,o]){var s;const n=e._$AH,{values:r,keys:a}=this.ct(t,i,o);if(!Array.isArray(n))return this.ut=a,r;const l=null!==(s=this.ut)&&void 0!==s?s:this.ut=[],d=[];let c,h,u=0,p=n.length-1,g=0,f=r.length-1;for(;u<=p&&g<=f;)if(null===n[u])u++;else if(null===n[p])p--;else if(l[u]===a[g])d[g]=Wo(n[u],r[g]),u++,g++;else if(l[p]===a[f])d[f]=Wo(n[p],r[f]),p--,f--;else if(l[u]===a[f])d[f]=Wo(n[u],r[f]),Zo(e,d[f+1],n[u]),u++,f--;else if(l[p]===a[g])d[g]=Wo(n[p],r[g]),Zo(e,n[u],n[p]),p--,g++;else if(void 0===c&&(c=Ko(a,g,f),h=Ko(l,u,p)),c.has(l[u]))if(c.has(l[p])){const t=h.get(a[g]),i=void 0!==t?n[t]:null;if(null===i){const t=Zo(e,n[u]);Wo(t,r[g]),d[g]=t}else d[g]=Wo(i,r[g]),Zo(e,n[u],i),n[t]=null;g++}else Qo(n[p]),p--;else Qo(n[u]),u++;for(;g<=f;){const t=Zo(e,d[f+1]);Wo(t,r[g]),d[g++]=t}for(;u<=p;){const e=n[u++];null!==e&&Qo(e)}return this.ut=a,((e,t=Go)=>{e._$AH=t})(e,d),Ye}}),Jo=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .people-list{list-style:none;margin:var(--people-list-margin,8px 4px 8px 8px);padding:unset;display:flex;align-items:center;gap:var(--people-avatar-gap,4px)}:host .overflow span{vertical-align:middle;color:var(--people-overflow-font-color,currentColor);font-size:var(--people-overflow-font-size,12px);font-weight:var(--people-overflow-font-weight,400)}
`];var Yo=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},es=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};let ts=class extends Nt{static get styles(){return Jo}get groupId(){return this._groupId}set groupId(e){this._groupId!==e&&(this._groupId=e,this.requestStateUpdate(!0))}get userIds(){return this._userIds}set userIds(e){Rt(this._userIds,e)||(this._userIds=e,this.requestStateUpdate(!0))}get peopleQueries(){return this._peopleQueries}set peopleQueries(e){Rt(this._peopleQueries,e)||(this._peopleQueries=e,this.requestStateUpdate(!0))}get resource(){return this._resource}set resource(e){this._resource!==e&&(this._resource=e,this.requestStateUpdate(!0))}get version(){return this._version}set version(e){this._version!==e&&(this._version=e,this.requestStateUpdate(!0))}get fallbackDetails(){return this._fallbackDetails}set fallbackDetails(e){e!==this._fallbackDetails&&(this._fallbackDetails=e,this.requestStateUpdate())}static get requiredScopes(){return[...new Set(["user.read.all","people.read","user.readbasic.all","presence.read.all","contacts.read",...No.requiredScopes])]}constructor(){super(),this.personCardInteraction=Do.hover,this.scopes=[],this._peoplePresence={},this._version="v1.0",this._arrowKeyLocation=-1,this.handleKeyDown=e=>{const t=this.shadowRoot.querySelector(".people-list");let i;const o=null==t?void 0:t.children;for(const e of o){const t=e;t.setAttribute("tabindex","-1"),t.blur()}const s=t.childElementCount,n=e.key;if("ArrowRight"===n)this._arrowKeyLocation=(this._arrowKeyLocation+1+s)%s;else if("ArrowLeft"===n)this._arrowKeyLocation=(this._arrowKeyLocation-1+s)%s;else if("Tab"===n||"Escape"===n)this._arrowKeyLocation=-1,t.blur();else if(["Enter","space"," "].includes(n)&&this.personCardInteraction!==Do.none){const e=o[this._arrowKeyLocation].querySelector("mgt-person");e&&e.showPersonCard()}this._arrowKeyLocation>-1&&(i=o[this._arrowKeyLocation],i.setAttribute("tabindex","1"),i.focus())},this.showMax=3}clearState(){this.people=null}requestStateUpdate(e){return e&&(this.people=null),super.requestStateUpdate(e)}render(){return this.isLoadingState?this.renderLoading():this.people&&0!==this.people.length?this.renderTemplate("default",{people:this.people,max:this.showMax})||this.renderPeople():this.renderNoData()}renderLoading(){return this.renderTemplate("loading",null)||Je``}renderPeople(){const e=this.people.slice(0,this.showMax).filter((e=>e));return Je`
      <ul
        tabindex="0"
        class="people-list"
        aria-label="people"
        @keydown=${this.handleKeyDown}>
        ${Xo(e,(e=>e.id?e.id:e.displayName),(e=>Je`
            <li tabindex="-1" class="people-person">
              ${this.renderPerson(e)}
            </li>
          `))}
        ${this.people.length>this.showMax?this.renderOverflow():null}
      </ul>
    `}renderOverflow(){const e=this.people.length-this.showMax;return this.renderTemplate("overflow",{extra:e,max:this.showMax,people:this.people})||Je`
        <li tabindex="-1" aria-label="and ${e} more attendees" class="overflow"><span>+${e}</span></li>
      `}renderPerson(e){let t={activity:"Offline",availability:"Offline",id:null};return this.showPresence&&this._peoplePresence&&(t=this._peoplePresence[e.id]),this.renderTemplate("person",{person:e},e.id)||pi`
        <mgt-person
          .personDetails=${e}
          .fetchImage=${!0}
          .avatarSize=${"small"}
          .personCardInteraction=${this.personCardInteraction}
          .showPresence=${this.showPresence}
          .personPresence=${t}
          .usage=${"people"}
        ></mgt-person>
      `}renderNoData(){return this.renderTemplate("no-data",null)||Je``}loadState(){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){if(!this.people){const e=te.globalProvider;if(e&&e.state===Q.SignedIn){const t=e.graph.forComponent(this);this.groupId?this.people=yield so(t,null,this.groupId,this.showMax,Bi.person):this.userIds||this.peopleQueries?this.people=this.userIds?yield io(t,this.userIds,"","",this._fallbackDetails):yield((e,t,i)=>Xi(void 0,void 0,void 0,(function*(){var o;if(!t||0===t.length)return[];const s=e.createBatch(),n=[];let r,a;Yi()&&(a=ai.getCache(Fi,Fi.stores.usersQuery));for(const e of t)if(Yi()&&(r=yield a.getValue(e)),Yi()&&(null==r?void 0:r.results[0])&&Ji()>Date.now()-r.timeCached){const e=JSON.parse(r.results[0]);n.push(e)}else s.get(e,`/me/people?$search="${e}"`,["people.read"],{"X-PeopleQuery-QuerySources":"Mailbox,Directory"});if(s.hasRequests)try{const e=yield s.executeAll();for(const s of t){const t=e.get(s);if((null===(o=null==t?void 0:t.content)||void 0===o?void 0:o.value)&&t.content.value.length>0)n.push(t.content.value[0]),Yi()&&(yield a.putValue(s,{maxResults:1,results:[JSON.stringify(t.content.value[0])]}));else{const e=i.find((e=>Object.values(e).includes(s)));e&&n.push(e)}}return n}catch(i){try{return Promise.all(t.filter((e=>e&&""!==e)).map((t=>Xi(void 0,void 0,void 0,(function*(){const i=yield Wi(e,t,1);if(null==i?void 0:i.length)return Yi()&&(yield a.putValue(t,{maxResults:1,results:[JSON.stringify(i[0])]})),i[0]})))))}catch(e){return[]}}return n})))(t,this.peopleQueries,this._fallbackDetails):this.resource?this.people=yield((e,t,i,o)=>ji(void 0,void 0,void 0,(function*(){var s;let n;const r=`${t}${i}`;if(Zi()){n=ai.getCache(Ri,Ri.stores.peopleQuery);const e=yield n.getValue(r);if(e&&qi()>Date.now()-e.timeCached)return e.results.map((e=>JSON.parse(e)))}let a=e.api(i).version(t);(null==o?void 0:o.length)&&(a=a.middlewareOptions(ie(...o)));let l=yield a.get();if(l&&Array.isArray(l.value)&&l["@odata.nextLink"]){let i=l;for(;null==i?void 0:i["@odata.nextLink"];){const o=i["@odata.nextLink"].split(t)[1];i=yield e.client.api(o).version(t).get(),(null===(s=null==i?void 0:i.value)||void 0===s?void 0:s.length)&&(i.value=l.value.concat(i.value),l=i)}}if(Zi()&&l){const e={results:null};Array.isArray(l.value)?e.results=l.value.map((e=>JSON.stringify(e))):e.results=[JSON.stringify(l)],yield n.putValue(r,e)}return null==l?void 0:l.value})))(t,this.version,this.resource,this.scopes):this.people=yield Gi(t),this.showPresence?this._peoplePresence=yield((e,t)=>fo(void 0,void 0,void 0,(function*(){if(!t||0===t.length)return{};const i={},o=[],s=["presence.read.all"];let n;mo()&&(n=ai.getCache(Oi,Oi.stores.presence));for(const e of t)if(null==e?void 0:e.id){const t=e.id;let s;i[t]=null,mo()&&(s=yield n.getValue(t)),mo()&&s&&vo()>Date.now()-s.timeCached?i[t]=JSON.parse(s.presence):o.push(t)}try{if(o.length>0){const t=yield e.api("/communications/getPresencesByUserId").middlewareOptions(ie(...s)).post({ids:o});for(const e of t.value)i[e.id]=e,mo()&&(yield n.putValue(e.id,{presence:JSON.stringify(e)}))}return i}catch(o){try{const o=yield Promise.all(t.filter((e=>(null==e?void 0:e.id)&&!i[e.id]&&"personType"in e&&"OrganizationUser"===e.personType.subclass)).map((t=>bo(e,t.id))));for(const e of o)i[e.id]=e;return i}catch(e){return null}}})))(t,this.people):this._peoplePresence=null}}}))}};Yo([Ct({attribute:"group-id",type:String}),es("design:type",String),es("design:paramtypes",[Object])],ts.prototype,"groupId",null),Yo([Ct({attribute:"user-ids",converter:(e,t)=>e.split(",").map((e=>e.trim()))}),es("design:type",Array),es("design:paramtypes",[Array])],ts.prototype,"userIds",null),Yo([Ct({attribute:"people",type:Object}),es("design:type",Array)],ts.prototype,"people",void 0),Yo([Ct({attribute:"people-queries",converter:(e,t)=>e.split(",").map((e=>e.trim()))}),es("design:type",Array),es("design:paramtypes",[Array])],ts.prototype,"peopleQueries",null),Yo([Ct({attribute:"show-max",type:Number}),es("design:type",Number)],ts.prototype,"showMax",void 0),Yo([Ct({attribute:"show-presence",type:Boolean}),es("design:type",Boolean)],ts.prototype,"showPresence",void 0),Yo([Ct({attribute:"person-card",converter:(e,t)=>(e=e.toLowerCase(),void 0===Do[e]?Do.hover:Do[e])}),es("design:type",Number)],ts.prototype,"personCardInteraction",void 0),Yo([Ct({attribute:"resource",type:String}),es("design:type",String),es("design:paramtypes",[Object])],ts.prototype,"resource",null),Yo([Ct({attribute:"version",type:String}),es("design:type",String),es("design:paramtypes",[Object])],ts.prototype,"version",null),Yo([Ct({attribute:"scopes",converter:e=>e?e.toLowerCase().split(","):null,reflect:!0}),es("design:type",Array)],ts.prototype,"scopes",void 0),Yo([Ct({attribute:"fallback-details",type:Array}),es("design:type",Array),es("design:paramtypes",[Array])],ts.prototype,"fallbackDetails",null),Yo([$t(),es("design:type",Object)],ts.prototype,"_arrowKeyLocation",void 0),ts=Yo([gi("people"),es("design:paramtypes",[])],ts);const is=function(){if("undefined"!=typeof globalThis)return globalThis;if("undefined"!=typeof global)return global;if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;try{return new Function("return this")()}catch(e){return{}}}();void 0===is.trustedTypes&&(is.trustedTypes={createPolicy:(e,t)=>t});const os={configurable:!1,enumerable:!1,writable:!1};void 0===is.FAST&&Reflect.defineProperty(is,"FAST",Object.assign({value:Object.create(null)},os));const ss=is.FAST;if(void 0===ss.getById){const e=Object.create(null);Reflect.defineProperty(ss,"getById",Object.assign({value(t,i){let o=e[t];return void 0===o&&(o=i?e[t]=i():null),o}},os))}const ns=Object.freeze([]);function rs(){const e=new WeakMap;return function(t){let i=e.get(t);if(void 0===i){let o=Reflect.getPrototypeOf(t);for(;void 0===i&&null!==o;)i=e.get(o),o=Reflect.getPrototypeOf(o);i=void 0===i?[]:i.slice(0),e.set(t,i)}return i}}const as=is.FAST.getById(1,(()=>{const e=[],t=[];function i(){if(t.length)throw t.shift()}function o(e){try{e.call()}catch(e){t.push(e),setTimeout(i,0)}}function s(){let t=0;for(;t<e.length;)if(o(e[t]),t++,t>1024){for(let i=0,o=e.length-t;i<o;i++)e[i]=e[i+t];e.length-=t,t=0}e.length=0}return Object.freeze({enqueue:function(t){e.length<1&&is.requestAnimationFrame(s),e.push(t)},process:s})})),ls=is.trustedTypes.createPolicy("fast-html",{createHTML:e=>e});let ds=ls;const cs=`fast-${Math.random().toString(36).substring(2,8)}`,hs=`${cs}{`,us=`}${cs}`,ps=Object.freeze({supportsAdoptedStyleSheets:Array.isArray(document.adoptedStyleSheets)&&"replace"in CSSStyleSheet.prototype,setHTMLPolicy(e){if(ds!==ls)throw new Error("The HTML policy can only be set once.");ds=e},createHTML:e=>ds.createHTML(e),isMarker:e=>e&&8===e.nodeType&&e.data.startsWith(cs),extractDirectiveIndexFromMarker:e=>parseInt(e.data.replace(`${cs}:`,"")),createInterpolationPlaceholder:e=>`${hs}${e}${us}`,createCustomAttributePlaceholder(e,t){return`${e}="${this.createInterpolationPlaceholder(t)}"`},createBlockPlaceholder:e=>`\x3c!--${cs}:${e}--\x3e`,queueUpdate:as.enqueue,processUpdates:as.process,nextUpdate:()=>new Promise(as.enqueue),setAttribute(e,t,i){null==i?e.removeAttribute(t):e.setAttribute(t,i)},setBooleanAttribute(e,t,i){i?e.setAttribute(t,""):e.removeAttribute(t)},removeChildNodes(e){for(let t=e.firstChild;null!==t;t=e.firstChild)e.removeChild(t)},createTemplateWalker:e=>document.createTreeWalker(e,133,null,!1)});class gs{constructor(e,t){this.sub1=void 0,this.sub2=void 0,this.spillover=void 0,this.source=e,this.sub1=t}has(e){return void 0===this.spillover?this.sub1===e||this.sub2===e:-1!==this.spillover.indexOf(e)}subscribe(e){const t=this.spillover;if(void 0===t){if(this.has(e))return;if(void 0===this.sub1)return void(this.sub1=e);if(void 0===this.sub2)return void(this.sub2=e);this.spillover=[this.sub1,this.sub2,e],this.sub1=void 0,this.sub2=void 0}else-1===t.indexOf(e)&&t.push(e)}unsubscribe(e){const t=this.spillover;if(void 0===t)this.sub1===e?this.sub1=void 0:this.sub2===e&&(this.sub2=void 0);else{const i=t.indexOf(e);-1!==i&&t.splice(i,1)}}notify(e){const t=this.spillover,i=this.source;if(void 0===t){const t=this.sub1,o=this.sub2;void 0!==t&&t.handleChange(i,e),void 0!==o&&o.handleChange(i,e)}else for(let o=0,s=t.length;o<s;++o)t[o].handleChange(i,e)}}class fs{constructor(e){this.subscribers={},this.sourceSubscribers=null,this.source=e}notify(e){var t;const i=this.subscribers[e];void 0!==i&&i.notify(e),null===(t=this.sourceSubscribers)||void 0===t||t.notify(e)}subscribe(e,t){var i;if(t){let i=this.subscribers[t];void 0===i&&(this.subscribers[t]=i=new gs(this.source)),i.subscribe(e)}else this.sourceSubscribers=null!==(i=this.sourceSubscribers)&&void 0!==i?i:new gs(this.source),this.sourceSubscribers.subscribe(e)}unsubscribe(e,t){var i;if(t){const i=this.subscribers[t];void 0!==i&&i.unsubscribe(e)}else null===(i=this.sourceSubscribers)||void 0===i||i.unsubscribe(e)}}const vs=ss.getById(2,(()=>{const e=/(:|&&|\|\||if)/,t=new WeakMap,i=ps.queueUpdate;let o,s=e=>{throw new Error("Must call enableArrayObservation before observing arrays.")};function n(e){let i=e.$fastController||t.get(e);return void 0===i&&(Array.isArray(e)?i=s(e):t.set(e,i=new fs(e))),i}const r=rs();class a{constructor(e){this.name=e,this.field=`_${e}`,this.callback=`${e}Changed`}getValue(e){return void 0!==o&&o.watch(e,this.name),e[this.field]}setValue(e,t){const i=this.field,o=e[i];if(o!==t){e[i]=t;const s=e[this.callback];"function"==typeof s&&s.call(e,o,t),n(e).notify(this.name)}}}class l extends gs{constructor(e,t,i=!1){super(e,t),this.binding=e,this.isVolatileBinding=i,this.needsRefresh=!0,this.needsQueue=!0,this.first=this,this.last=null,this.propertySource=void 0,this.propertyName=void 0,this.notifier=void 0,this.next=void 0}observe(e,t){this.needsRefresh&&null!==this.last&&this.disconnect();const i=o;o=this.needsRefresh?this:void 0,this.needsRefresh=this.isVolatileBinding;const s=this.binding(e,t);return o=i,s}disconnect(){if(null!==this.last){let e=this.first;for(;void 0!==e;)e.notifier.unsubscribe(this,e.propertyName),e=e.next;this.last=null,this.needsRefresh=this.needsQueue=!0}}watch(e,t){const i=this.last,s=n(e),r=null===i?this.first:{};if(r.propertySource=e,r.propertyName=t,r.notifier=s,s.subscribe(this,t),null!==i){if(!this.needsRefresh){let t;o=void 0,t=i.propertySource[i.propertyName],o=this,e===t&&(this.needsRefresh=!0)}i.next=r}this.last=r}handleChange(){this.needsQueue&&(this.needsQueue=!1,i(this))}call(){null!==this.last&&(this.needsQueue=!0,this.notify(this))}records(){let e=this.first;return{next:()=>{const t=e;return void 0===t?{value:void 0,done:!0}:(e=e.next,{value:t,done:!1})},[Symbol.iterator]:function(){return this}}}}return Object.freeze({setArrayObserverFactory(e){s=e},getNotifier:n,track(e,t){void 0!==o&&o.watch(e,t)},trackVolatile(){void 0!==o&&(o.needsRefresh=!0)},notify(e,t){n(e).notify(t)},defineProperty(e,t){"string"==typeof t&&(t=new a(t)),r(e).push(t),Reflect.defineProperty(e,t.name,{enumerable:!0,get:function(){return t.getValue(this)},set:function(e){t.setValue(this,e)}})},getAccessors:r,binding(e,t,i=this.isVolatileBinding(e)){return new l(e,t,i)},isVolatileBinding:t=>e.test(t.toString())})}));function ms(e,t){vs.defineProperty(e,t)}const bs=ss.getById(3,(()=>{let e=null;return{get:()=>e,set(t){e=t}}}));class ys{constructor(){this.index=0,this.length=0,this.parent=null,this.parentContext=null}get event(){return bs.get()}get isEven(){return this.index%2==0}get isOdd(){return this.index%2!=0}get isFirst(){return 0===this.index}get isInMiddle(){return!this.isFirst&&!this.isLast}get isLast(){return this.index===this.length-1}static setEvent(e){bs.set(e)}}vs.defineProperty(ys.prototype,"index"),vs.defineProperty(ys.prototype,"length");const ws=Object.seal(new ys);class xs{constructor(){this.targets=new WeakSet}addStylesTo(e){this.targets.add(e)}removeStylesFrom(e){this.targets.delete(e)}isAttachedTo(e){return this.targets.has(e)}withBehaviors(...e){return this.behaviors=null===this.behaviors?e:this.behaviors.concat(e),this}}function ks(e){return e.map((e=>e instanceof xs?ks(e.styles):[e])).reduce(((e,t)=>e.concat(t)),[])}function Cs(e){return e.map((e=>e instanceof xs?e.behaviors:null)).reduce(((e,t)=>null===t?e:(null===e&&(e=[]),e.concat(t))),null)}xs.create=(()=>{if(ps.supportsAdoptedStyleSheets){const e=new Map;return t=>new _s(t,e)}return e=>new Ts(e)})();let $s=(e,t)=>{e.adoptedStyleSheets=[...e.adoptedStyleSheets,...t]},Ss=(e,t)=>{e.adoptedStyleSheets=e.adoptedStyleSheets.filter((e=>-1===t.indexOf(e)))};if(ps.supportsAdoptedStyleSheets)try{document.adoptedStyleSheets.push(),document.adoptedStyleSheets.splice(),$s=(e,t)=>{e.adoptedStyleSheets.push(...t)},Ss=(e,t)=>{for(const i of t){const t=e.adoptedStyleSheets.indexOf(i);-1!==t&&e.adoptedStyleSheets.splice(t,1)}}}catch(e){}class _s extends xs{constructor(e,t){super(),this.styles=e,this.styleSheetCache=t,this._styleSheets=void 0,this.behaviors=Cs(e)}get styleSheets(){if(void 0===this._styleSheets){const e=this.styles,t=this.styleSheetCache;this._styleSheets=ks(e).map((e=>{if(e instanceof CSSStyleSheet)return e;let i=t.get(e);return void 0===i&&(i=new CSSStyleSheet,i.replaceSync(e),t.set(e,i)),i}))}return this._styleSheets}addStylesTo(e){$s(e,this.styleSheets),super.addStylesTo(e)}removeStylesFrom(e){Ss(e,this.styleSheets),super.removeStylesFrom(e)}}let Is=0;class Ts extends xs{constructor(e){super(),this.styles=e,this.behaviors=null,this.behaviors=Cs(e),this.styleSheets=ks(e),this.styleClass="fast-style-class-"+ ++Is}addStylesTo(e){const t=this.styleSheets,i=this.styleClass;e=this.normalizeTarget(e);for(let o=0;o<t.length;o++){const s=document.createElement("style");s.innerHTML=t[o],s.className=i,e.append(s)}super.addStylesTo(e)}removeStylesFrom(e){const t=(e=this.normalizeTarget(e)).querySelectorAll(`.${this.styleClass}`);for(let i=0,o=t.length;i<o;++i)e.removeChild(t[i]);super.removeStylesFrom(e)}isAttachedTo(e){return super.isAttachedTo(this.normalizeTarget(e))}normalizeTarget(e){return e===document?document.body:e}}const Ds=Object.freeze({locate:rs()}),Ps={toView:e=>e?"true":"false",fromView:e=>null!=e&&"false"!==e&&!1!==e&&0!==e},Ls={toView(e){if(null==e)return null;const t=1*e;return isNaN(t)?null:t.toString()},fromView(e){if(null==e)return null;const t=1*e;return isNaN(t)?null:t}};class Es{constructor(e,t,i=t.toLowerCase(),o="reflect",s){this.guards=new Set,this.Owner=e,this.name=t,this.attribute=i,this.mode=o,this.converter=s,this.fieldName=`_${t}`,this.callbackName=`${t}Changed`,this.hasCallback=this.callbackName in e.prototype,"boolean"===o&&void 0===s&&(this.converter=Ps)}setValue(e,t){const i=e[this.fieldName],o=this.converter;void 0!==o&&(t=o.fromView(t)),i!==t&&(e[this.fieldName]=t,this.tryReflectToAttribute(e),this.hasCallback&&e[this.callbackName](i,t),e.$fastController.notify(this.name))}getValue(e){return vs.track(e,this.name),e[this.fieldName]}onAttributeChangedCallback(e,t){this.guards.has(e)||(this.guards.add(e),this.setValue(e,t),this.guards.delete(e))}tryReflectToAttribute(e){const t=this.mode,i=this.guards;i.has(e)||"fromView"===t||ps.queueUpdate((()=>{i.add(e);const o=e[this.fieldName];switch(t){case"reflect":const t=this.converter;ps.setAttribute(e,this.attribute,void 0!==t?t.toView(o):o);break;case"boolean":ps.setBooleanAttribute(e,this.attribute,o)}i.delete(e)}))}static collect(e,...t){const i=[];t.push(Ds.locate(e));for(let o=0,s=t.length;o<s;++o){const s=t[o];if(void 0!==s)for(let t=0,o=s.length;t<o;++t){const o=s[t];"string"==typeof o?i.push(new Es(e,o)):i.push(new Es(e,o.property,o.attribute,o.mode,o.converter))}}return i}}function Os(e,t){let i;function o(e,t){arguments.length>1&&(i.property=t),Ds.locate(e.constructor).push(i)}return arguments.length>1?(i={},void o(e,t)):(i=void 0===e?{}:e,o)}const Fs={mode:"open"},As={},Rs=ss.getById(4,(()=>{const e=new Map;return Object.freeze({register:t=>!e.has(t.type)&&(e.set(t.type,t),!0),getByType:t=>e.get(t)})}));class Vs{constructor(e,t=e.definition){"string"==typeof t&&(t={name:t}),this.type=e,this.name=t.name,this.template=t.template;const i=Es.collect(e,t.attributes),o=new Array(i.length),s={},n={};for(let e=0,t=i.length;e<t;++e){const t=i[e];o[e]=t.attribute,s[t.name]=t,n[t.attribute]=t}this.attributes=i,this.observedAttributes=o,this.propertyLookup=s,this.attributeLookup=n,this.shadowOptions=void 0===t.shadowOptions?Fs:null===t.shadowOptions?void 0:Object.assign(Object.assign({},Fs),t.shadowOptions),this.elementOptions=void 0===t.elementOptions?As:Object.assign(Object.assign({},As),t.elementOptions),this.styles=void 0===t.styles?void 0:Array.isArray(t.styles)?xs.create(t.styles):t.styles instanceof xs?t.styles:xs.create([t.styles])}get isDefined(){return!!Rs.getByType(this.type)}define(e=customElements){const t=this.type;if(Rs.register(this)){const e=this.attributes,i=t.prototype;for(let t=0,o=e.length;t<o;++t)vs.defineProperty(i,e[t]);Reflect.defineProperty(t,"observedAttributes",{value:this.observedAttributes,enumerable:!0})}return e.get(this.name)||e.define(this.name,t,this.elementOptions),this}}function Ms(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}Vs.forType=Rs.getByType;const zs=new WeakMap,Ns={bubbles:!0,composed:!0,cancelable:!0};function Us(e){return e.shadowRoot||zs.get(e)||null}class Bs extends fs{constructor(e,t){super(e),this.boundObservables=null,this.behaviors=null,this.needsInitialization=!0,this._template=null,this._styles=null,this._isConnected=!1,this.$fastController=this,this.view=null,this.element=e,this.definition=t;const i=t.shadowOptions;if(void 0!==i){const t=e.attachShadow(i);"closed"===i.mode&&zs.set(e,t)}const o=vs.getAccessors(e);if(o.length>0){const t=this.boundObservables=Object.create(null);for(let i=0,s=o.length;i<s;++i){const s=o[i].name,n=e[s];void 0!==n&&(delete e[s],t[s]=n)}}}get isConnected(){return vs.track(this,"isConnected"),this._isConnected}setIsConnected(e){this._isConnected=e,vs.notify(this,"isConnected")}get template(){return this._template}set template(e){this._template!==e&&(this._template=e,this.needsInitialization||this.renderTemplate(e))}get styles(){return this._styles}set styles(e){this._styles!==e&&(null!==this._styles&&this.removeStyles(this._styles),this._styles=e,this.needsInitialization||null===e||this.addStyles(e))}addStyles(e){const t=Us(this.element)||this.element.getRootNode();if(e instanceof HTMLStyleElement)t.append(e);else if(!e.isAttachedTo(t)){const i=e.behaviors;e.addStylesTo(t),null!==i&&this.addBehaviors(i)}}removeStyles(e){const t=Us(this.element)||this.element.getRootNode();if(e instanceof HTMLStyleElement)t.removeChild(e);else if(e.isAttachedTo(t)){const i=e.behaviors;e.removeStylesFrom(t),null!==i&&this.removeBehaviors(i)}}addBehaviors(e){const t=this.behaviors||(this.behaviors=new Map),i=e.length,o=[];for(let s=0;s<i;++s){const i=e[s];t.has(i)?t.set(i,t.get(i)+1):(t.set(i,1),o.push(i))}if(this._isConnected){const e=this.element;for(let t=0;t<o.length;++t)o[t].bind(e,ws)}}removeBehaviors(e,t=!1){const i=this.behaviors;if(null===i)return;const o=e.length,s=[];for(let n=0;n<o;++n){const o=e[n];if(i.has(o)){const e=i.get(o)-1;0===e||t?i.delete(o)&&s.push(o):i.set(o,e)}}if(this._isConnected){const e=this.element;for(let t=0;t<s.length;++t)s[t].unbind(e)}}onConnectedCallback(){if(this._isConnected)return;const e=this.element;this.needsInitialization?this.finishInitialization():null!==this.view&&this.view.bind(e,ws);const t=this.behaviors;if(null!==t)for(const[i]of t)i.bind(e,ws);this.setIsConnected(!0)}onDisconnectedCallback(){if(!this._isConnected)return;this.setIsConnected(!1);const e=this.view;null!==e&&e.unbind();const t=this.behaviors;if(null!==t){const e=this.element;for(const[i]of t)i.unbind(e)}}onAttributeChangedCallback(e,t,i){const o=this.definition.attributeLookup[e];void 0!==o&&o.onAttributeChangedCallback(this.element,i)}emit(e,t,i){return!!this._isConnected&&this.element.dispatchEvent(new CustomEvent(e,Object.assign(Object.assign({detail:t},Ns),i)))}finishInitialization(){const e=this.element,t=this.boundObservables;if(null!==t){const i=Object.keys(t);for(let o=0,s=i.length;o<s;++o){const s=i[o];e[s]=t[s]}this.boundObservables=null}const i=this.definition;null===this._template&&(this.element.resolveTemplate?this._template=this.element.resolveTemplate():i.template&&(this._template=i.template||null)),null!==this._template&&this.renderTemplate(this._template),null===this._styles&&(this.element.resolveStyles?this._styles=this.element.resolveStyles():i.styles&&(this._styles=i.styles||null)),null!==this._styles&&this.addStyles(this._styles),this.needsInitialization=!1}renderTemplate(e){const t=this.element,i=Us(t)||t;null!==this.view?(this.view.dispose(),this.view=null):this.needsInitialization||ps.removeChildNodes(i),e&&(this.view=e.render(t,i,t))}static forCustomElement(e){const t=e.$fastController;if(void 0!==t)return t;const i=Vs.forType(e.constructor);if(void 0===i)throw new Error("Missing FASTElement definition.");return e.$fastController=new Bs(e,i)}}function Hs(e){return class extends e{constructor(){super(),Bs.forCustomElement(this)}$emit(e,t,i){return this.$fastController.emit(e,t,i)}connectedCallback(){this.$fastController.onConnectedCallback()}disconnectedCallback(){this.$fastController.onDisconnectedCallback()}attributeChangedCallback(e,t,i){this.$fastController.onAttributeChangedCallback(e,t,i)}}}const js=Object.assign(Hs(HTMLElement),{from:e=>Hs(e),define:(e,t)=>new Vs(e,t).define().type}),qs=new Map;"metadata"in Reflect||(Reflect.metadata=function(e,t){return function(i){Reflect.defineMetadata(e,t,i)}},Reflect.defineMetadata=function(e,t,i){let o=qs.get(i);void 0===o&&qs.set(i,o=new Map),o.set(e,t)},Reflect.getOwnMetadata=function(e,t){const i=qs.get(t);if(void 0!==i)return i.get(e)});class Zs{constructor(e,t){this.container=e,this.key=t}instance(e){return this.registerResolver(0,e)}singleton(e){return this.registerResolver(1,e)}transient(e){return this.registerResolver(2,e)}callback(e){return this.registerResolver(3,e)}cachedCallback(e){return this.registerResolver(3,bn(e))}aliasTo(e){return this.registerResolver(5,e)}registerResolver(e,t){const{container:i,key:o}=this;return this.container=this.key=void 0,i.registerResolver(o,new rn(o,e,t))}}function Ws(e){const t=e.slice(),i=Object.keys(e),o=i.length;let s;for(let n=0;n<o;++n)s=i[n],_n(s)||(t[s]=e[s]);return t}const Gs=Object.freeze({none(e){throw Error(`${e.toString()} not registered, did you forget to add @singleton()?`)},singleton:e=>new rn(e,1,e),transient:e=>new rn(e,2,e)}),Qs=Object.freeze({default:Object.freeze({parentLocator:()=>null,responsibleForOwnerRequests:!1,defaultResolver:Gs.singleton})}),Ks=new Map;function Xs(e){return t=>Reflect.getOwnMetadata(e,t)}let Js=null;const Ys=Object.freeze({createContainer:e=>new vn(null,Object.assign({},Qs.default,e)),findResponsibleContainer(e){const t=e.$$container$$;return t&&t.responsibleForOwnerRequests?t:Ys.findParentContainer(e)},findParentContainer(e){const t=new CustomEvent(gn,{bubbles:!0,composed:!0,cancelable:!0,detail:{container:void 0}});return e.dispatchEvent(t),t.detail.container||Ys.getOrCreateDOMContainer()},getOrCreateDOMContainer:(e,t)=>e?e.$$container$$||new vn(e,Object.assign({},Qs.default,t,{parentLocator:Ys.findParentContainer})):Js||(Js=new vn(null,Object.assign({},Qs.default,t,{parentLocator:()=>null}))),getDesignParamtypes:Xs("design:paramtypes"),getAnnotationParamtypes:Xs("di:paramtypes"),getOrCreateAnnotationParamTypes(e){let t=this.getAnnotationParamtypes(e);return void 0===t&&Reflect.defineMetadata("di:paramtypes",t=[],e),t},getDependencies(e){let t=Ks.get(e);if(void 0===t){const i=e.inject;if(void 0===i){const i=Ys.getDesignParamtypes(e),o=Ys.getAnnotationParamtypes(e);if(void 0===i)if(void 0===o){const i=Object.getPrototypeOf(e);t="function"==typeof i&&i!==Function.prototype?Ws(Ys.getDependencies(i)):[]}else t=Ws(o);else if(void 0===o)t=Ws(i);else{t=Ws(i);let e,s=o.length;for(let i=0;i<s;++i)e=o[i],void 0!==e&&(t[i]=e);const n=Object.keys(o);let r;s=n.length;for(let e=0;e<s;++e)r=n[e],_n(r)||(t[r]=o[r])}}else t=Ws(i);Ks.set(e,t)}return t},defineProperty(e,t,i,o=!1){const s=`$di_${t}`;Reflect.defineProperty(e,t,{get:function(){let e=this[s];if(void 0===e){const n=this instanceof HTMLElement?Ys.findResponsibleContainer(this):Ys.getOrCreateDOMContainer();if(e=n.get(i),this[s]=e,o&&this instanceof js){const o=this.$fastController,n=()=>{Ys.findResponsibleContainer(this).get(i)!==this[s]&&(this[s]=e,o.notify(t))};o.subscribe({handleChange:n},"isConnected")}}return e}})},createInterface(e,t){const i="function"==typeof e?e:t,o="string"==typeof e?e:e&&"friendlyName"in e&&e.friendlyName||kn,s="string"!=typeof e&&(e&&"respectConnection"in e&&e.respectConnection||!1),n=function(e,t,i){if(null==e||void 0!==new.target)throw new Error(`No registration for interface: '${n.friendlyName}'`);t?Ys.defineProperty(e,t,n,s):Ys.getOrCreateAnnotationParamTypes(e)[i]=n};return n.$isInterface=!0,n.friendlyName=null==o?"(anonymous)":o,null!=i&&(n.register=function(e,t){return i(new Zs(e,null!=t?t:n))}),n.toString=function(){return`InterfaceSymbol<${n.friendlyName}>`},n},inject:(...e)=>function(t,i,o){if("number"==typeof o){const i=Ys.getOrCreateAnnotationParamTypes(t),s=e[0];void 0!==s&&(i[o]=s)}else if(i)Ys.defineProperty(t,i,e[0]);else{const i=o?Ys.getOrCreateAnnotationParamTypes(o.value):Ys.getOrCreateAnnotationParamTypes(t);let s;for(let t=0;t<e.length;++t)s=e[t],void 0!==s&&(i[t]=s)}},transient:e=>(e.register=function(t){return yn.transient(e,e).register(t)},e.registerInRequestor=!1,e),singleton:(e,t=on)=>(e.register=function(t){return yn.singleton(e,e).register(t)},e.registerInRequestor=t.scoped,e)}),en=Ys.createInterface("Container");function tn(e){return function(t){const i=function(e,t,o){Ys.inject(i)(e,t,o)};return i.$isResolver=!0,i.resolve=function(i,o){return e(t,i,o)},i}}Ys.inject;const on={scoped:!1};function sn(e,t,i){Ys.inject(sn)(e,t,i)}function nn(e,t){return t.getFactory(e).construct(t)}tn(((e,t,i)=>()=>i.get(e))),tn(((e,t,i)=>i.has(e,!0)?i.get(e):void 0)),sn.$isResolver=!0,sn.resolve=()=>{},tn(((e,t,i)=>{const o=nn(e,t),s=new rn(e,0,o);return i.registerResolver(e,s),o})),tn(((e,t,i)=>nn(e,t)));class rn{constructor(e,t,i){this.key=e,this.strategy=t,this.state=i,this.resolving=!1}get $isResolver(){return!0}register(e){return e.registerResolver(this.key,this)}resolve(e,t){switch(this.strategy){case 0:return this.state;case 1:if(this.resolving)throw new Error(`Cyclic dependency found: ${this.state.name}`);return this.resolving=!0,this.state=e.getFactory(this.state).construct(t),this.strategy=0,this.resolving=!1,this.state;case 2:{const i=e.getFactory(this.state);if(null===i)throw new Error(`Resolver for ${String(this.key)} returned a null factory`);return i.construct(t)}case 3:return this.state(e,t,this);case 4:return this.state[0].resolve(e,t);case 5:return t.get(this.state);default:throw new Error(`Invalid resolver strategy specified: ${this.strategy}.`)}}getFactory(e){var t,i,o;switch(this.strategy){case 1:case 2:return e.getFactory(this.state);case 5:return null!==(o=null===(i=null===(t=e.getResolver(this.state))||void 0===t?void 0:t.getFactory)||void 0===i?void 0:i.call(t,e))&&void 0!==o?o:null;default:return null}}}function an(e){return this.get(e)}function ln(e,t){return t(e)}class dn{constructor(e,t){this.Type=e,this.dependencies=t,this.transformers=null}construct(e,t){let i;return i=void 0===t?new this.Type(...this.dependencies.map(an,e)):new this.Type(...this.dependencies.map(an,e),...t),null==this.transformers?i:this.transformers.reduce(ln,i)}registerTransformer(e){(this.transformers||(this.transformers=[])).push(e)}}const cn={$isResolver:!0,resolve:(e,t)=>t};function hn(e){return"function"==typeof e.register}function un(e){return function(e){return hn(e)&&"boolean"==typeof e.registerInRequestor}(e)&&e.registerInRequestor}const pn=new Set(["Array","ArrayBuffer","Boolean","DataView","Date","Error","EvalError","Float32Array","Float64Array","Function","Int8Array","Int16Array","Int32Array","Map","Number","Object","Promise","RangeError","ReferenceError","RegExp","Set","SharedArrayBuffer","String","SyntaxError","TypeError","Uint8Array","Uint8ClampedArray","Uint16Array","Uint32Array","URIError","WeakMap","WeakSet"]),gn="__DI_LOCATE_PARENT__",fn=new Map;class vn{constructor(e,t){this.owner=e,this.config=t,this._parent=void 0,this.registerDepth=0,this.context=null,null!==e&&(e.$$container$$=this),this.resolvers=new Map,this.resolvers.set(en,cn),e instanceof Node&&e.addEventListener(gn,(e=>{e.composedPath()[0]!==this.owner&&(e.detail.container=this,e.stopImmediatePropagation())}))}get parent(){return void 0===this._parent&&(this._parent=this.config.parentLocator(this.owner)),this._parent}get depth(){return null===this.parent?0:this.parent.depth+1}get responsibleForOwnerRequests(){return this.config.responsibleForOwnerRequests}registerWithContext(e,...t){return this.context=e,this.register(...t),this.context=null,this}register(...e){if(100==++this.registerDepth)throw new Error("Unable to autoregister dependency");let t,i,o,s,n;const r=this.context;for(let a=0,l=e.length;a<l;++a)if(t=e[a],Cn(t))if(hn(t))t.register(this,r);else if(void 0!==t.prototype)yn.singleton(t,t).register(this);else for(i=Object.keys(t),s=0,n=i.length;s<n;++s)o=t[i[s]],Cn(o)&&(hn(o)?o.register(this,r):this.register(o));return--this.registerDepth,this}registerResolver(e,t){wn(e);const i=this.resolvers,o=i.get(e);return null==o?i.set(e,t):o instanceof rn&&4===o.strategy?o.state.push(t):i.set(e,new rn(e,4,[o,t])),t}registerTransformer(e,t){const i=this.getResolver(e);if(null==i)return!1;if(i.getFactory){const e=i.getFactory(this);return null!=e&&(e.registerTransformer(t),!0)}return!1}getResolver(e,t=!0){if(wn(e),void 0!==e.resolve)return e;let i,o=this;for(;null!=o;){if(i=o.resolvers.get(e),null!=i)return i;if(null==o.parent){const i=un(e)?this:o;return t?this.jitRegister(e,i):null}o=o.parent}return null}has(e,t=!1){return!!this.resolvers.has(e)||!(!t||null==this.parent)&&this.parent.has(e,!0)}get(e){if(wn(e),e.$isResolver)return e.resolve(this,this);let t,i=this;for(;null!=i;){if(t=i.resolvers.get(e),null!=t)return t.resolve(i,this);if(null==i.parent){const o=un(e)?this:i;return t=this.jitRegister(e,o),t.resolve(i,this)}i=i.parent}throw new Error(`Unable to resolve key: ${e}`)}getAll(e,t=!1){wn(e);const i=this;let o,s=i;if(t){let t=ns;for(;null!=s;)o=s.resolvers.get(e),null!=o&&(t=t.concat(xn(o,s,i))),s=s.parent;return t}for(;null!=s;){if(o=s.resolvers.get(e),null!=o)return xn(o,s,i);if(s=s.parent,null==s)return ns}return ns}getFactory(e){let t=fn.get(e);if(void 0===t){if($n(e))throw new Error(`${e.name} is a native function and therefore cannot be safely constructed by DI. If this is intentional, please use a callback or cachedCallback resolver.`);fn.set(e,t=new dn(e,Ys.getDependencies(e)))}return t}registerFactory(e,t){fn.set(e,t)}createChild(e){return new vn(null,Object.assign({},this.config,e,{parentLocator:()=>this}))}jitRegister(e,t){if("function"!=typeof e)throw new Error(`Attempted to jitRegister something that is not a constructor: '${e}'. Did you forget to register this dependency?`);if(pn.has(e.name))throw new Error(`Attempted to jitRegister an intrinsic type: ${e.name}. Did you forget to add @inject(Key)`);if(hn(e)){const i=e.register(t);if(!(i instanceof Object)||null==i.resolve){const i=t.resolvers.get(e);if(null!=i)return i;throw new Error("A valid resolver was not returned from the static register method")}return i}if(e.$isInterface)throw new Error(`Attempted to jitRegister an interface: ${e.friendlyName}`);{const i=this.config.defaultResolver(e,t);return t.resolvers.set(e,i),i}}}const mn=new WeakMap;function bn(e){return function(t,i,o){if(mn.has(o))return mn.get(o);const s=e(t,i,o);return mn.set(o,s),s}}const yn=Object.freeze({instance:(e,t)=>new rn(e,0,t),singleton:(e,t)=>new rn(e,1,t),transient:(e,t)=>new rn(e,2,t),callback:(e,t)=>new rn(e,3,t),cachedCallback:(e,t)=>new rn(e,3,bn(t)),aliasTo:(e,t)=>new rn(t,5,e)});function wn(e){if(null==e)throw new Error("key/value cannot be null or undefined. Are you trying to inject/register something that doesn't exist with DI?")}function xn(e,t,i){if(e instanceof rn&&4===e.strategy){const o=e.state;let s=o.length;const n=new Array(s);for(;s--;)n[s]=o[s].resolve(t,i);return n}return[e.resolve(t,i)]}const kn="(anonymous)";function Cn(e){return"object"==typeof e&&null!==e||"function"==typeof e}const $n=function(){const e=new WeakMap;let t=!1,i="",o=0;return function(s){return t=e.get(s),void 0===t&&(i=s.toString(),o=i.length,t=o>=29&&o<=100&&125===i.charCodeAt(o-1)&&i.charCodeAt(o-2)<=32&&93===i.charCodeAt(o-3)&&101===i.charCodeAt(o-4)&&100===i.charCodeAt(o-5)&&111===i.charCodeAt(o-6)&&99===i.charCodeAt(o-7)&&32===i.charCodeAt(o-8)&&101===i.charCodeAt(o-9)&&118===i.charCodeAt(o-10)&&105===i.charCodeAt(o-11)&&116===i.charCodeAt(o-12)&&97===i.charCodeAt(o-13)&&110===i.charCodeAt(o-14)&&88===i.charCodeAt(o-15),e.set(s,t)),t}}(),Sn={};function _n(e){switch(typeof e){case"number":return e>=0&&(0|e)===e;case"string":{const t=Sn[e];if(void 0!==t)return t;const i=e.length;if(0===i)return Sn[e]=!1;let o=0;for(let t=0;t<i;++t)if(o=e.charCodeAt(t),0===t&&48===o&&i>1||o<48||o>57)return Sn[e]=!1;return Sn[e]=!0}default:return!1}}function In(e){return`${e.toLowerCase()}:presentation`}const Tn=new Map,Dn=Object.freeze({define(e,t,i){const o=In(e);void 0===Tn.get(o)?Tn.set(o,t):Tn.set(o,!1),i.register(yn.instance(o,t))},forTag(e,t){const i=In(e),o=Tn.get(i);return!1===o?Ys.findResponsibleContainer(t).get(i):o||null}});class Pn{constructor(e,t){this.template=e||null,this.styles=void 0===t?null:Array.isArray(t)?xs.create(t):t instanceof xs?t:xs.create([t])}applyTo(e){const t=e.$fastController;null===t.template&&(t.template=this.template),null===t.styles&&(t.styles=this.styles)}}class Ln extends js{constructor(){super(...arguments),this._presentation=void 0}get $presentation(){return void 0===this._presentation&&(this._presentation=Dn.forTag(this.tagName,this)),this._presentation}templateChanged(){void 0!==this.template&&(this.$fastController.template=this.template)}stylesChanged(){void 0!==this.styles&&(this.$fastController.styles=this.styles)}connectedCallback(){null!==this.$presentation&&this.$presentation.applyTo(this),super.connectedCallback()}static compose(e){return(t={})=>new On(this===Ln?class extends Ln{}:this,e,t)}}function En(e,t,i){return"function"==typeof e?e(t,i):e}Ms([ms],Ln.prototype,"template",void 0),Ms([ms],Ln.prototype,"styles",void 0);class On{constructor(e,t,i){this.type=e,this.elementDefinition=t,this.overrideDefinition=i,this.definition=Object.assign(Object.assign({},this.elementDefinition),this.overrideDefinition)}register(e,t){const i=this.definition,o=this.overrideDefinition,s=`${i.prefix||t.elementPrefix}-${i.baseName}`;t.tryDefineElement({name:s,type:this.type,baseClass:this.elementDefinition.baseClass,callback:e=>{const t=new Pn(En(i.template,e,i),En(i.styles,e,i));e.definePresentation(t);let s=En(i.shadowOptions,e,i);e.shadowRootMode&&(s?o.shadowOptions||(s.mode=e.shadowRootMode):null!==s&&(s={mode:e.shadowRootMode})),e.defineElement({elementOptions:En(i.elementOptions,e,i),shadowOptions:s,attributes:En(i.attributes,e,i)})}})}}class Fn{createCSS(){return""}createBehavior(){}}function An(e){const t=e.parentElement;if(t)return t;{const t=e.getRootNode();if(t.host instanceof HTMLElement)return t.host}return null}const Rn=document.createElement("div");class Vn{setProperty(e,t){ps.queueUpdate((()=>this.target.setProperty(e,t)))}removeProperty(e){ps.queueUpdate((()=>this.target.removeProperty(e)))}}class Mn extends Vn{constructor(){super();const e=new CSSStyleSheet;this.target=e.cssRules[e.insertRule(":root{}")].style,document.adoptedStyleSheets=[...document.adoptedStyleSheets,e]}}class zn extends Vn{constructor(){super(),this.style=document.createElement("style"),document.head.appendChild(this.style);const{sheet:e}=this.style;if(e){const t=e.insertRule(":root{}",e.cssRules.length);this.target=e.cssRules[t].style}}}class Nn{constructor(e){this.store=new Map,this.target=null;const t=e.$fastController;this.style=document.createElement("style"),t.addStyles(this.style),vs.getNotifier(t).subscribe(this,"isConnected"),this.handleChange(t,"isConnected")}targetChanged(){if(null!==this.target)for(const[e,t]of this.store.entries())this.target.setProperty(e,t)}setProperty(e,t){this.store.set(e,t),ps.queueUpdate((()=>{null!==this.target&&this.target.setProperty(e,t)}))}removeProperty(e){this.store.delete(e),ps.queueUpdate((()=>{null!==this.target&&this.target.removeProperty(e)}))}handleChange(e,t){const{sheet:i}=this.style;if(i){const e=i.insertRule(":host{}",i.cssRules.length);this.target=i.cssRules[e].style}else this.target=null}}Ms([ms],Nn.prototype,"target",void 0);class Un{constructor(e){this.target=e.style}setProperty(e,t){ps.queueUpdate((()=>this.target.setProperty(e,t)))}removeProperty(e){ps.queueUpdate((()=>this.target.removeProperty(e)))}}class Bn{setProperty(e,t){Bn.properties[e]=t;for(const i of Bn.roots.values())qn.getOrCreate(Bn.normalizeRoot(i)).setProperty(e,t)}removeProperty(e){delete Bn.properties[e];for(const t of Bn.roots.values())qn.getOrCreate(Bn.normalizeRoot(t)).removeProperty(e)}static registerRoot(e){const{roots:t}=Bn;if(!t.has(e)){t.add(e);const i=qn.getOrCreate(this.normalizeRoot(e));for(const e in Bn.properties)i.setProperty(e,Bn.properties[e])}}static unregisterRoot(e){const{roots:t}=Bn;if(t.has(e)){t.delete(e);const i=qn.getOrCreate(Bn.normalizeRoot(e));for(const e in Bn.properties)i.removeProperty(e)}}static normalizeRoot(e){return e===Rn?document:e}}Bn.roots=new Set,Bn.properties={};const Hn=new WeakMap,jn=ps.supportsAdoptedStyleSheets?class extends Vn{constructor(e){super();const t=new CSSStyleSheet;this.target=t.cssRules[t.insertRule(":host{}")].style,e.$fastController.addStyles(xs.create([t]))}}:Nn,qn=Object.freeze({getOrCreate(e){if(Hn.has(e))return Hn.get(e);let t;return t=e===Rn?new Bn:e instanceof Document?ps.supportsAdoptedStyleSheets?new Mn:new zn:e instanceof js?new jn(e):new Un(e),Hn.set(e,t),t}});class Zn extends Fn{constructor(e){super(),this.subscribers=new WeakMap,this._appliedTo=new Set,this.name=e.name,null!==e.cssCustomPropertyName&&(this.cssCustomProperty=`--${e.cssCustomPropertyName}`,this.cssVar=`var(${this.cssCustomProperty})`),this.id=Zn.uniqueId(),Zn.tokensById.set(this.id,this)}get appliedTo(){return[...this._appliedTo]}static from(e){return new Zn({name:"string"==typeof e?e:e.name,cssCustomPropertyName:"string"==typeof e?e:void 0===e.cssCustomPropertyName?e.name:e.cssCustomPropertyName})}static isCSSDesignToken(e){return"string"==typeof e.cssCustomProperty}static isDerivedDesignTokenValue(e){return"function"==typeof e}static getTokenById(e){return Zn.tokensById.get(e)}getOrCreateSubscriberSet(e=this){return this.subscribers.get(e)||this.subscribers.set(e,new Set)&&this.subscribers.get(e)}createCSS(){return this.cssVar||""}getValueFor(e){const t=Xn.getOrCreate(e).get(this);if(void 0!==t)return t;throw new Error(`Value could not be retrieved for token named "${this.name}". Ensure the value is set for ${e} or an ancestor of ${e}.`)}setValueFor(e,t){return this._appliedTo.add(e),t instanceof Zn&&(t=this.alias(t)),Xn.getOrCreate(e).set(this,t),this}deleteValueFor(e){return this._appliedTo.delete(e),Xn.existsFor(e)&&Xn.getOrCreate(e).delete(this),this}withDefault(e){return this.setValueFor(Rn,e),this}subscribe(e,t){const i=this.getOrCreateSubscriberSet(t);t&&!Xn.existsFor(t)&&Xn.getOrCreate(t),i.has(e)||i.add(e)}unsubscribe(e,t){const i=this.subscribers.get(t||this);i&&i.has(e)&&i.delete(e)}notify(e){const t=Object.freeze({token:this,target:e});this.subscribers.has(this)&&this.subscribers.get(this).forEach((e=>e.handleChange(t))),this.subscribers.has(e)&&this.subscribers.get(e).forEach((e=>e.handleChange(t)))}alias(e){return t=>e.getValueFor(t)}}Zn.uniqueId=(()=>{let e=0;return()=>(e++,e.toString(16))})(),Zn.tokensById=new Map;class Wn{constructor(e,t,i){this.source=e,this.token=t,this.node=i,this.dependencies=new Set,this.observer=vs.binding(e,this,!1),this.observer.handleChange=this.observer.call,this.handleChange()}disconnect(){this.observer.disconnect()}handleChange(){this.node.store.set(this.token,this.observer.observe(this.node.target,ws))}}class Gn{constructor(){this.values=new Map}set(e,t){this.values.get(e)!==t&&(this.values.set(e,t),vs.getNotifier(this).notify(e.id))}get(e){return vs.track(this,e.id),this.values.get(e)}delete(e){this.values.delete(e)}all(){return this.values.entries()}}const Qn=new WeakMap,Kn=new WeakMap;class Xn{constructor(e){this.target=e,this.store=new Gn,this.children=[],this.assignedValues=new Map,this.reflecting=new Set,this.bindingObservers=new Map,this.tokenValueChangeHandler={handleChange:(e,t)=>{const i=Zn.getTokenById(t);if(i&&(i.notify(this.target),Zn.isCSSDesignToken(i))){const t=this.parent,o=this.isReflecting(i);if(t){const s=t.get(i),n=e.get(i);s===n||o?s===n&&o&&this.stopReflectToCSS(i):this.reflectToCSS(i)}else o||this.reflectToCSS(i)}}},Qn.set(e,this),vs.getNotifier(this.store).subscribe(this.tokenValueChangeHandler),e instanceof js?e.$fastController.addBehaviors([this]):e.isConnected&&this.bind()}static getOrCreate(e){return Qn.get(e)||new Xn(e)}static existsFor(e){return Qn.has(e)}static findParent(e){if(Rn!==e.target){let t=An(e.target);for(;null!==t;){if(Qn.has(t))return Qn.get(t);t=An(t)}return Xn.getOrCreate(Rn)}return null}static findClosestAssignedNode(e,t){let i=t;do{if(i.has(e))return i;i=i.parent?i.parent:i.target!==Rn?Xn.getOrCreate(Rn):null}while(null!==i);return null}get parent(){return Kn.get(this)||null}has(e){return this.assignedValues.has(e)}get(e){const t=this.store.get(e);if(void 0!==t)return t;const i=this.getRaw(e);return void 0!==i?(this.hydrate(e,i),this.get(e)):void 0}getRaw(e){var t;return this.assignedValues.has(e)?this.assignedValues.get(e):null===(t=Xn.findClosestAssignedNode(e,this))||void 0===t?void 0:t.getRaw(e)}set(e,t){Zn.isDerivedDesignTokenValue(this.assignedValues.get(e))&&this.tearDownBindingObserver(e),this.assignedValues.set(e,t),Zn.isDerivedDesignTokenValue(t)?this.setupBindingObserver(e,t):this.store.set(e,t)}delete(e){this.assignedValues.delete(e),this.tearDownBindingObserver(e);const t=this.getRaw(e);t?this.hydrate(e,t):this.store.delete(e)}bind(){const e=Xn.findParent(this);e&&e.appendChild(this);for(const e of this.assignedValues.keys())e.notify(this.target)}unbind(){this.parent&&Kn.get(this).removeChild(this)}appendChild(e){e.parent&&Kn.get(e).removeChild(e);const t=this.children.filter((t=>e.contains(t)));Kn.set(e,this),this.children.push(e),t.forEach((t=>e.appendChild(t))),vs.getNotifier(this.store).subscribe(e);for(const[t,i]of this.store.all())e.hydrate(t,this.bindingObservers.has(t)?this.getRaw(t):i)}removeChild(e){const t=this.children.indexOf(e);return-1!==t&&this.children.splice(t,1),vs.getNotifier(this.store).unsubscribe(e),e.parent===this&&Kn.delete(e)}contains(e){return function(e,t){let i=t;for(;null!==i;){if(i===e)return!0;i=An(i)}return!1}(this.target,e.target)}reflectToCSS(e){this.isReflecting(e)||(this.reflecting.add(e),Xn.cssCustomPropertyReflector.startReflection(e,this.target))}stopReflectToCSS(e){this.isReflecting(e)&&(this.reflecting.delete(e),Xn.cssCustomPropertyReflector.stopReflection(e,this.target))}isReflecting(e){return this.reflecting.has(e)}handleChange(e,t){const i=Zn.getTokenById(t);i&&this.hydrate(i,this.getRaw(i))}hydrate(e,t){if(!this.has(e)){const i=this.bindingObservers.get(e);Zn.isDerivedDesignTokenValue(t)?i?i.source!==t&&(this.tearDownBindingObserver(e),this.setupBindingObserver(e,t)):this.setupBindingObserver(e,t):(i&&this.tearDownBindingObserver(e),this.store.set(e,t))}}setupBindingObserver(e,t){const i=new Wn(t,e,this);return this.bindingObservers.set(e,i),i}tearDownBindingObserver(e){return!!this.bindingObservers.has(e)&&(this.bindingObservers.get(e).disconnect(),this.bindingObservers.delete(e),!0)}}Xn.cssCustomPropertyReflector=new class{startReflection(e,t){e.subscribe(this,t),this.handleChange({token:e,target:t})}stopReflection(e,t){e.unsubscribe(this,t),this.remove(e,t)}handleChange(e){const{token:t,target:i}=e;this.add(t,i)}add(e,t){qn.getOrCreate(t).setProperty(e.cssCustomProperty,this.resolveCSSValue(Xn.getOrCreate(t).get(e)))}remove(e,t){qn.getOrCreate(t).removeProperty(e.cssCustomProperty)}resolveCSSValue(e){return e&&"function"==typeof e.createCSS?e.createCSS():e}},Ms([ms],Xn.prototype,"children",void 0);const Jn=Object.freeze({create:function(e){return Zn.from(e)},notifyConnection:e=>!(!e.isConnected||!Xn.existsFor(e)||(Xn.getOrCreate(e).bind(),0)),notifyDisconnection:e=>!(e.isConnected||!Xn.existsFor(e)||(Xn.getOrCreate(e).unbind(),0)),registerRoot(e=Rn){Bn.registerRoot(e)},unregisterRoot(e=Rn){Bn.unregisterRoot(e)}}),Yn=Object.freeze({definitionCallbackOnly:null,ignoreDuplicate:Symbol()}),er=new Map,tr=new Map;let ir=null;const or=Ys.createInterface((e=>e.cachedCallback((e=>(null===ir&&(ir=new nr(null,e)),ir))))),sr=Object.freeze({tagFor:e=>tr.get(e),responsibleFor(e){const t=e.$$designSystem$$;return t||Ys.findResponsibleContainer(e).get(or)},getOrCreate(e){if(!e)return null===ir&&(ir=Ys.getOrCreateDOMContainer().get(or)),ir;const t=e.$$designSystem$$;if(t)return t;const i=Ys.getOrCreateDOMContainer(e);if(i.has(or,!1))return i.get(or);{const t=new nr(e,i);return i.register(yn.instance(or,t)),t}}});class nr{constructor(e,t){this.owner=e,this.container=t,this.designTokensInitialized=!1,this.prefix="fast",this.shadowRootMode=void 0,this.disambiguate=()=>Yn.definitionCallbackOnly,null!==e&&(e.$$designSystem$$=this)}withPrefix(e){return this.prefix=e,this}withShadowRootMode(e){return this.shadowRootMode=e,this}withElementDisambiguation(e){return this.disambiguate=e,this}withDesignTokenRoot(e){return this.designTokenRoot=e,this}register(...e){const t=this.container,i=[],o=this.disambiguate,s=this.shadowRootMode,n={elementPrefix:this.prefix,tryDefineElement(e,n,r){const a=function(e,t,i){return"string"==typeof e?{name:e,type:t,callback:i}:e}(e,n,r),{name:l,callback:d,baseClass:c}=a;let{type:h}=a,u=l,p=er.get(u),g=!0;for(;p;){const e=o(u,h,p);switch(e){case Yn.ignoreDuplicate:return;case Yn.definitionCallbackOnly:g=!1,p=void 0;break;default:u=e,p=er.get(u)}}g&&((tr.has(h)||h===Ln)&&(h=class extends h{}),er.set(u,h),tr.set(h,u),c&&tr.set(c,u)),i.push(new rr(t,u,h,s,d,g))}};this.designTokensInitialized||(this.designTokensInitialized=!0,null!==this.designTokenRoot&&Jn.registerRoot(this.designTokenRoot)),t.registerWithContext(n,...e);for(const e of i)e.callback(e),e.willDefine&&null!==e.definition&&e.definition.define();return this}}class rr{constructor(e,t,i,o,s,n){this.container=e,this.name=t,this.type=i,this.shadowRootMode=o,this.callback=s,this.willDefine=n,this.definition=null}definePresentation(e){Dn.define(this.name,e,this.container)}defineElement(e){this.definition=new Vs(this.type,Object.assign(Object.assign({},e),{name:this.name}))}tagFor(e){return sr.tagFor(e)}}const ar=sr.getOrCreate(undefined).withPrefix("fluent");const lr=(...e)=>{if(null==e?void 0:e.length)for(const t of e)ar.register(t())};class dr extends Ln{}class cr{constructor(){this.targetIndex=0}}class hr extends cr{constructor(){super(...arguments),this.createPlaceholder=ps.createInterpolationPlaceholder}}class ur extends cr{constructor(e,t,i){super(),this.name=e,this.behavior=t,this.options=i}createPlaceholder(e){return ps.createCustomAttributePlaceholder(this.name,e)}createBehavior(e){return new this.behavior(e,this.options)}}function pr(e,t){this.source=e,this.context=t,null===this.bindingObserver&&(this.bindingObserver=vs.binding(this.binding,this,this.isBindingVolatile)),this.updateTarget(this.bindingObserver.observe(e,t))}function gr(e,t){this.source=e,this.context=t,this.target.addEventListener(this.targetName,this)}function fr(){this.bindingObserver.disconnect(),this.source=null,this.context=null}function vr(){this.bindingObserver.disconnect(),this.source=null,this.context=null;const e=this.target.$fastView;void 0!==e&&e.isComposed&&(e.unbind(),e.needsBindOnly=!0)}function mr(){this.target.removeEventListener(this.targetName,this),this.source=null,this.context=null}function br(e){ps.setAttribute(this.target,this.targetName,e)}function yr(e){ps.setBooleanAttribute(this.target,this.targetName,e)}function wr(e){if(null==e&&(e=""),e.create){this.target.textContent="";let t=this.target.$fastView;void 0===t?t=e.create():this.target.$fastTemplate!==e&&(t.isComposed&&(t.remove(),t.unbind()),t=e.create()),t.isComposed?t.needsBindOnly&&(t.needsBindOnly=!1,t.bind(this.source,this.context)):(t.isComposed=!0,t.bind(this.source,this.context),t.insertBefore(this.target),this.target.$fastView=t,this.target.$fastTemplate=e)}else{const t=this.target.$fastView;void 0!==t&&t.isComposed&&(t.isComposed=!1,t.remove(),t.needsBindOnly?t.needsBindOnly=!1:t.unbind()),this.target.textContent=e}}function xr(e){this.target[this.targetName]=e}function kr(e){const t=this.classVersions||Object.create(null),i=this.target;let o=this.version||0;if(null!=e&&e.length){const s=e.split(/\s+/);for(let e=0,n=s.length;e<n;++e){const n=s[e];""!==n&&(t[n]=o,i.classList.add(n))}}if(this.classVersions=t,this.version=o+1,0!==o){o-=1;for(const e in t)t[e]===o&&i.classList.remove(e)}}class Cr extends hr{constructor(e){super(),this.binding=e,this.bind=pr,this.unbind=fr,this.updateTarget=br,this.isBindingVolatile=vs.isVolatileBinding(this.binding)}get targetName(){return this.originalTargetName}set targetName(e){if(this.originalTargetName=e,void 0!==e)switch(e[0]){case":":if(this.cleanedTargetName=e.substr(1),this.updateTarget=xr,"innerHTML"===this.cleanedTargetName){const e=this.binding;this.binding=(t,i)=>ps.createHTML(e(t,i))}break;case"?":this.cleanedTargetName=e.substr(1),this.updateTarget=yr;break;case"@":this.cleanedTargetName=e.substr(1),this.bind=gr,this.unbind=mr;break;default:this.cleanedTargetName=e,"class"===e&&(this.updateTarget=kr)}}targetAtContent(){this.updateTarget=wr,this.unbind=vr}createBehavior(e){return new $r(e,this.binding,this.isBindingVolatile,this.bind,this.unbind,this.updateTarget,this.cleanedTargetName)}}class $r{constructor(e,t,i,o,s,n,r){this.source=null,this.context=null,this.bindingObserver=null,this.target=e,this.binding=t,this.isBindingVolatile=i,this.bind=o,this.unbind=s,this.updateTarget=n,this.targetName=r}handleChange(){this.updateTarget(this.bindingObserver.observe(this.source,this.context))}handleEvent(e){ys.setEvent(e);const t=this.binding(this.source,this.context);ys.setEvent(null),!0!==t&&e.preventDefault()}}let Sr=null;class _r{addFactory(e){e.targetIndex=this.targetIndex,this.behaviorFactories.push(e)}captureContentBinding(e){e.targetAtContent(),this.addFactory(e)}reset(){this.behaviorFactories=[],this.targetIndex=-1}release(){Sr=this}static borrow(e){const t=Sr||new _r;return t.directives=e,t.reset(),Sr=null,t}}function Ir(e){if(1===e.length)return e[0];let t;const i=e.length,o=e.map((e=>"string"==typeof e?()=>e:(t=e.targetName||t,e.binding))),s=new Cr(((e,t)=>{let s="";for(let n=0;n<i;++n)s+=o[n](e,t);return s}));return s.targetName=t,s}const Tr=us.length;function Dr(e,t){const i=t.split(hs);if(1===i.length)return null;const o=[];for(let t=0,s=i.length;t<s;++t){const s=i[t],n=s.indexOf(us);let r;if(-1===n)r=s;else{const t=parseInt(s.substring(0,n));o.push(e.directives[t]),r=s.substring(n+Tr)}""!==r&&o.push(r)}return o}function Pr(e,t,i=!1){const o=t.attributes;for(let s=0,n=o.length;s<n;++s){const r=o[s],a=r.value,l=Dr(e,a);let d=null;null===l?i&&(d=new Cr((()=>a)),d.targetName=r.name):d=Ir(l),null!==d&&(t.removeAttributeNode(r),s--,n--,e.addFactory(d))}}function Lr(e,t,i){const o=Dr(e,t.textContent);if(null!==o){let s=t;for(let n=0,r=o.length;n<r;++n){const r=o[n],a=0===n?t:s.parentNode.insertBefore(document.createTextNode(""),s.nextSibling);"string"==typeof r?a.textContent=r:(a.textContent=" ",e.captureContentBinding(r)),s=a,e.targetIndex++,a!==t&&i.nextNode()}e.targetIndex--}}const Er=document.createRange();class Or{constructor(e,t){this.fragment=e,this.behaviors=t,this.source=null,this.context=null,this.firstChild=e.firstChild,this.lastChild=e.lastChild}appendTo(e){e.appendChild(this.fragment)}insertBefore(e){if(this.fragment.hasChildNodes())e.parentNode.insertBefore(this.fragment,e);else{const t=this.lastChild;if(e.previousSibling===t)return;const i=e.parentNode;let o,s=this.firstChild;for(;s!==t;)o=s.nextSibling,i.insertBefore(s,e),s=o;i.insertBefore(t,e)}}remove(){const e=this.fragment,t=this.lastChild;let i,o=this.firstChild;for(;o!==t;)i=o.nextSibling,e.appendChild(o),o=i;e.appendChild(t)}dispose(){const e=this.firstChild.parentNode,t=this.lastChild;let i,o=this.firstChild;for(;o!==t;)i=o.nextSibling,e.removeChild(o),o=i;e.removeChild(t);const s=this.behaviors,n=this.source;for(let e=0,t=s.length;e<t;++e)s[e].unbind(n)}bind(e,t){const i=this.behaviors;if(this.source!==e)if(null!==this.source){const o=this.source;this.source=e,this.context=t;for(let s=0,n=i.length;s<n;++s){const n=i[s];n.unbind(o),n.bind(e,t)}}else{this.source=e,this.context=t;for(let o=0,s=i.length;o<s;++o)i[o].bind(e,t)}}unbind(){if(null===this.source)return;const e=this.behaviors,t=this.source;for(let i=0,o=e.length;i<o;++i)e[i].unbind(t);this.source=null}static disposeContiguousBatch(e){if(0!==e.length){Er.setStartBefore(e[0].firstChild),Er.setEndAfter(e[e.length-1].lastChild),Er.deleteContents();for(let t=0,i=e.length;t<i;++t){const i=e[t],o=i.behaviors,s=i.source;for(let e=0,t=o.length;e<t;++e)o[e].unbind(s)}}}}class Fr{constructor(e,t){this.behaviorCount=0,this.hasHostBehaviors=!1,this.fragment=null,this.targetOffset=0,this.viewBehaviorFactories=null,this.hostBehaviorFactories=null,this.html=e,this.directives=t}create(e){if(null===this.fragment){let e;const t=this.html;if("string"==typeof t){e=document.createElement("template"),e.innerHTML=ps.createHTML(t);const i=e.content.firstElementChild;null!==i&&"TEMPLATE"===i.tagName&&(e=i)}else e=t;const i=function(e,t){const i=e.content;document.adoptNode(i);const o=_r.borrow(t);Pr(o,e,!0);const s=o.behaviorFactories;o.reset();const n=ps.createTemplateWalker(i);let r;for(;r=n.nextNode();)switch(o.targetIndex++,r.nodeType){case 1:Pr(o,r);break;case 3:Lr(o,r,n);break;case 8:ps.isMarker(r)&&o.addFactory(t[ps.extractDirectiveIndexFromMarker(r)])}let a=0;(ps.isMarker(i.firstChild)||1===i.childNodes.length&&t.length)&&(i.insertBefore(document.createComment(""),i.firstChild),a=-1);const l=o.behaviorFactories;return o.release(),{fragment:i,viewBehaviorFactories:l,hostBehaviorFactories:s,targetOffset:a}}(e,this.directives);this.fragment=i.fragment,this.viewBehaviorFactories=i.viewBehaviorFactories,this.hostBehaviorFactories=i.hostBehaviorFactories,this.targetOffset=i.targetOffset,this.behaviorCount=this.viewBehaviorFactories.length+this.hostBehaviorFactories.length,this.hasHostBehaviors=this.hostBehaviorFactories.length>0}const t=this.fragment.cloneNode(!0),i=this.viewBehaviorFactories,o=new Array(this.behaviorCount),s=ps.createTemplateWalker(t);let n=0,r=this.targetOffset,a=s.nextNode();for(let e=i.length;n<e;++n){const e=i[n],t=e.targetIndex;for(;null!==a;){if(r===t){o[n]=e.createBehavior(a);break}a=s.nextNode(),r++}}if(this.hasHostBehaviors){const t=this.hostBehaviorFactories;for(let i=0,s=t.length;i<s;++i,++n)o[n]=t[i].createBehavior(e)}return new Or(t,o)}render(e,t,i){"string"==typeof t&&(t=document.getElementById(t)),void 0===i&&(i=t);const o=this.create(i);return o.bind(e,ws),o.appendTo(t),o}}const Ar=/([ \x09\x0a\x0c\x0d])([^\0-\x1F\x7F-\x9F "'>=/]+)([ \x09\x0a\x0c\x0d]*=[ \x09\x0a\x0c\x0d]*(?:[^ \x09\x0a\x0c\x0d"'`<>=]*|"[^"]*|'[^']*))$/;function Rr(e,...t){const i=[];let o="";for(let s=0,n=e.length-1;s<n;++s){const n=e[s];let r=t[s];if(o+=n,r instanceof Fr){const e=r;r=()=>e}if("function"==typeof r&&(r=new Cr(r)),r instanceof hr){const e=Ar.exec(n);null!==e&&(r.targetName=e[2])}r instanceof cr?(o+=r.createPlaceholder(i.length),i.push(r)):o+=r}return o+=e[e.length-1],new Fr(o,i)}function Vr(e,t,i){return isNaN(e)||e<=t?t:e>=i?i:e}function Mr(e,t,i){return isNaN(e)||e<=t?0:e>=i?1:e/(i-t)}function zr(e,t,i){return isNaN(e)?t:t+e*(i-t)}function Nr(e,t,i){return isNaN(e)||e<=0?t:e>=1?i:t+e*(i-t)}function Ur(e,t){const i=Math.pow(10,t);return Math.round(e*i)/i}Math.PI;class Br{constructor(e,t,i,o){this.r=e,this.g=t,this.b=i,this.a="number"!=typeof o||isNaN(o)?1:o}static fromObject(e){return!e||isNaN(e.r)||isNaN(e.g)||isNaN(e.b)?null:new Br(e.r,e.g,e.b,e.a)}equalValue(e){return this.r===e.r&&this.g===e.g&&this.b===e.b&&this.a===e.a}toStringHexRGB(){return"#"+[this.r,this.g,this.b].map(this.formatHexValue).join("")}toStringHexRGBA(){return this.toStringHexRGB()+this.formatHexValue(this.a)}toStringHexARGB(){return"#"+[this.a,this.r,this.g,this.b].map(this.formatHexValue).join("")}toStringWebRGB(){return`rgb(${Math.round(zr(this.r,0,255))},${Math.round(zr(this.g,0,255))},${Math.round(zr(this.b,0,255))})`}toStringWebRGBA(){return`rgba(${Math.round(zr(this.r,0,255))},${Math.round(zr(this.g,0,255))},${Math.round(zr(this.b,0,255))},${Vr(this.a,0,1)})`}roundToPrecision(e){return new Br(Ur(this.r,e),Ur(this.g,e),Ur(this.b,e),Ur(this.a,e))}clamp(){return new Br(Vr(this.r,0,1),Vr(this.g,0,1),Vr(this.b,0,1),Vr(this.a,0,1))}toObject(){return{r:this.r,g:this.g,b:this.b,a:this.a}}formatHexValue(e){return function(e){const t=Math.round(Vr(e,0,255)).toString(16);return 1===t.length?"0"+t:t}(zr(e,0,255))}}const Hr=/^#((?:[0-9a-f]{6}|[0-9a-f]{3}))$/i;function jr(e){const t=Hr.exec(e);if(null===t)return null;let i=t[1];if(3===i.length){const e=i.charAt(0),t=i.charAt(1),o=i.charAt(2);i=e.concat(e,t,t,o,o)}const o=parseInt(i,16);return isNaN(o)?null:new Br(Mr((16711680&o)>>>16,0,255),Mr((65280&o)>>>8,0,255),Mr(255&o,0,255),1)}var qr,Zr;!function(e){e.ltr="ltr",e.rtl="rtl"}(qr||(qr={}));class Wr{constructor(e,t,i){this.h=e,this.s=t,this.l=i}static fromObject(e){return!e||isNaN(e.h)||isNaN(e.s)||isNaN(e.l)?null:new Wr(e.h,e.s,e.l)}equalValue(e){return this.h===e.h&&this.s===e.s&&this.l===e.l}roundToPrecision(e){return new Wr(Ur(this.h,e),Ur(this.s,e),Ur(this.l,e))}toObject(){return{h:this.h,s:this.s,l:this.l}}}class Gr{constructor(e,t,i){this.l=e,this.a=t,this.b=i}static fromObject(e){return!e||isNaN(e.l)||isNaN(e.a)||isNaN(e.b)?null:new Gr(e.l,e.a,e.b)}equalValue(e){return this.l===e.l&&this.a===e.a&&this.b===e.b}roundToPrecision(e){return new Gr(Ur(this.l,e),Ur(this.a,e),Ur(this.b,e))}toObject(){return{l:this.l,a:this.a,b:this.b}}}Gr.epsilon=216/24389,Gr.kappa=24389/27;class Qr{constructor(e,t,i){this.x=e,this.y=t,this.z=i}static fromObject(e){return!e||isNaN(e.x)||isNaN(e.y)||isNaN(e.z)?null:new Qr(e.x,e.y,e.z)}equalValue(e){return this.x===e.x&&this.y===e.y&&this.z===e.z}roundToPrecision(e){return new Qr(Ur(this.x,e),Ur(this.y,e),Ur(this.z,e))}toObject(){return{x:this.x,y:this.y,z:this.z}}}function Kr(e){function t(e){return e<=.03928?e/12.92:Math.pow((e+.055)/1.055,2.4)}return function(e){return.2126*e.r+.7152*e.g+.0722*e.b}(new Br(t(e.r),t(e.g),t(e.b),1))}function Xr(e,t,i){return i-t==0?0:(e-t)/(i-t)}function Jr(e,t,i){return(Xr(e.r,t.r,i.r)+Xr(e.g,t.g,i.g)+Xr(e.b,t.b,i.b))/3}function Yr(e){const t=Math.max(e.r,e.g,e.b),i=Math.min(e.r,e.g,e.b),o=t-i;let s=0;0!==o&&(s=t===e.r?(e.g-e.b)/o%6*60:t===e.g?60*((e.b-e.r)/o+2):60*((e.r-e.g)/o+4)),s<0&&(s+=360);const n=(t+i)/2;let r=0;return 0!==o&&(r=o/(1-Math.abs(2*n-1))),new Wr(s,r,n)}function ea(e,t=1){return function(e,t=1){function i(e){return e<=.0031308?12.92*e:1.055*Math.pow(e,1/2.4)-.055}const o=i(3.2404542*e.x-1.5371385*e.y-.4985314*e.z),s=i(-.969266*e.x+1.8760108*e.y+.041556*e.z),n=i(.0556434*e.x-.2040259*e.y+1.0572252*e.z);return new Br(o,s,n,t)}(function(e){const t=(e.l+16)/116,i=t+e.a/500,o=t-e.b/200,s=Math.pow(i,3),n=Math.pow(t,3),r=Math.pow(o,3);let a=0;a=s>Gr.epsilon?s:(116*i-16)/Gr.kappa;let l=0;l=e.l>Gr.epsilon*Gr.kappa?n:e.l/Gr.kappa;let d=0;return d=r>Gr.epsilon?r:(116*o-16)/Gr.kappa,a=Qr.whitePoint.x*a,l=Qr.whitePoint.y*l,d=Qr.whitePoint.z*d,new Qr(a,l,d)}(e),t)}function ta(e,t,i){return isNaN(e)||e<=0?t:e>=1?i:new Br(Nr(e,t.r,i.r),Nr(e,t.g,i.g),Nr(e,t.b,i.b),Nr(e,t.a,i.a))}function ia(e,t){const i=e.relativeLuminance>t.relativeLuminance?e:t,o=e.relativeLuminance>t.relativeLuminance?t:e;return(i.relativeLuminance+.05)/(o.relativeLuminance+.05)}Qr.whitePoint=new Qr(.95047,1,1.08883),function(e){e[e.RGB=0]="RGB",e[e.HSL=1]="HSL",e[e.HSV=2]="HSV",e[e.XYZ=3]="XYZ",e[e.LAB=4]="LAB",e[e.LCH=5]="LCH"}(Zr||(Zr={}));const oa=Object.freeze({create:(e,t,i)=>new sa(e,t,i),from:e=>new sa(e.r,e.g,e.b)});class sa extends Br{constructor(e,t,i){super(e,t,i,1),this.toColorString=this.toStringHexRGB,this.contrast=ia.bind(null,this),this.createCSS=this.toColorString,this.relativeLuminance=Kr(this)}static fromObject(e){return new sa(e.r,e.g,e.b)}}function na(e,t,i=0,o=e.length-1){if(o===i)return e[i];const s=Math.floor((o-i)/2)+i;return t(e[s])?na(e,t,i,s):na(e,t,s+1,o)}const ra=(-.1+Math.sqrt(.21))/2;function aa(e){return e.relativeLuminance<=ra}function la(e){return aa(e)?-1:1}const da={stepContrast:1.03,stepContrastRamp:.03,preserveSource:!1},ca=Object.freeze({create:function(e,t,i){return"number"==typeof e?ca.from(oa.create(e,t,i)):ca.from(e)},from:function(e,t){return function(e){const t={r:0,g:0,b:0,toColorString:()=>"",contrast:()=>0,relativeLuminance:0};for(const i in t)if(typeof t[i]!=typeof e[i])return!1;return!0}(e)?ha.from(e,t):ha.from(oa.create(e.r,e.g,e.b),t)}});class ha{constructor(e,t){this.closestIndexCache=new Map,this.source=e,this.swatches=t,this.reversedSwatches=Object.freeze([...this.swatches].reverse()),this.lastIndex=this.swatches.length-1}colorContrast(e,t,i,o){void 0===i&&(i=this.closestIndexOf(e));let s=this.swatches;const n=this.lastIndex;let r=i;return void 0===o&&(o=la(e)),-1===o&&(s=this.reversedSwatches,r=n-r),na(s,(i=>ia(e,i)>=t),r,n)}get(e){return this.swatches[e]||this.swatches[Vr(e,0,this.lastIndex)]}closestIndexOf(e){if(this.closestIndexCache.has(e.relativeLuminance))return this.closestIndexCache.get(e.relativeLuminance);let t=this.swatches.indexOf(e);if(-1!==t)return this.closestIndexCache.set(e.relativeLuminance,t),t;const i=this.swatches.reduce(((t,i)=>Math.abs(i.relativeLuminance-e.relativeLuminance)<Math.abs(t.relativeLuminance-e.relativeLuminance)?i:t));return t=this.swatches.indexOf(i),this.closestIndexCache.set(e.relativeLuminance,t),t}static saturationBump(e,t){const i=Yr(e).s,o=Yr(t);return o.s<i?function(e,t=1){const i=(1-Math.abs(2*e.l-1))*e.s,o=i*(1-Math.abs(e.h/60%2-1)),s=e.l-i/2;let n=0,r=0,a=0;return e.h<60?(n=i,r=o,a=0):e.h<120?(n=o,r=i,a=0):e.h<180?(n=0,r=i,a=o):e.h<240?(n=0,r=o,a=i):e.h<300?(n=o,r=0,a=i):e.h<360&&(n=i,r=0,a=o),new Br(n+s,r+s,a+s,t)}(new Wr(o.h,i,o.l)):t}static ramp(e){const t=e/100;return t>.5?(t-.5)/.5:2*t}static createHighResolutionPalette(e){const t=[],i=function(e){function t(e){return e>Gr.epsilon?Math.pow(e,1/3):(Gr.kappa*e+16)/116}const i=t(e.x/Qr.whitePoint.x),o=t(e.y/Qr.whitePoint.y),s=t(e.z/Qr.whitePoint.z);return new Gr(116*o-16,500*(i-o),200*(o-s))}(function(e){function t(e){return e<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4)}const i=t(e.r),o=t(e.g),s=t(e.b);return new Qr(.4124564*i+.3575761*o+.1804375*s,.2126729*i+.7151522*o+.072175*s,.0193339*i+.119192*o+.9503041*s)}(Br.fromObject(e).roundToPrecision(4))),o=ea(new Gr(0,i.a,i.b)).clamp().roundToPrecision(4),s=ea(new Gr(50,i.a,i.b)).clamp().roundToPrecision(4),n=ea(new Gr(100,i.a,i.b)).clamp().roundToPrecision(4),r=new Br(0,0,0),a=new Br(1,1,1),l=n.equalValue(a)?0:14,d=o.equalValue(r)?0:14;for(let e=100+l;e>=0-d;e-=.5){let i;i=e<0?ta(e/d+1,r,o):e<=50?ta(ha.ramp(e),o,s):e<=100?ta(ha.ramp(e),s,n):ta((e-100)/l,n,a),i=ha.saturationBump(s,i).roundToPrecision(4),t.push(oa.from(i))}return new ha(e,t)}static adjustEnd(e,t,i,o){const s=-1===o?t.swatches:t.reversedSwatches,n=e=>{const i=t.closestIndexOf(e);return 1===o?t.lastIndex-i:i};1===o&&i.reverse();const r=e(i[i.length-2]);if(Ur(ia(i[i.length-1],i[i.length-2]),2)<r){i.pop();const e=n(t.colorContrast(s[t.lastIndex],r,void 0,o))-n(i[i.length-2]);let a=1;for(let o=i.length-e-1;o<i.length;o++){const e=n(i[o]),r=o===i.length-1?t.lastIndex:e+a;i[o]=s[r],a++}}1===o&&i.reverse()}static createColorPaletteByContrast(e,t){const i=ha.createHighResolutionPalette(e),o=e=>Ur(t.stepContrast+t.stepContrast*(1-e.relativeLuminance)*t.stepContrastRamp,2),s=[];let n=t.preserveSource?e:i.swatches[0];s.push(n);do{const e=o(n);n=i.colorContrast(n,e,void 0,1),s.push(n)}while(n.relativeLuminance>0);if(t.preserveSource){n=e;do{const e=o(n);n=i.colorContrast(n,e,void 0,-1),s.unshift(n)}while(n.relativeLuminance<1)}return this.adjustEnd(o,i,s,-1),t.preserveSource&&this.adjustEnd(o,i,s,1),s}static from(e,t){const i=void 0===t?da:Object.assign(Object.assign({},da),t);return new ha(e,Object.freeze(ha.createColorPaletteByContrast(e,i)))}}const ua=oa.create(1,1,1),pa=oa.create(0,0,0),ga=oa.create(.5,.5,.5),fa=jr("#0078D4"),va=oa.create(fa.r,fa.g,fa.b);function ma(e,t,i,o,s){const n=e=>e.contrast(ua)>=s?ua:pa,r=n(e),a=n(t);return{rest:r,hover:a,active:r.relativeLuminance===a.relativeLuminance?r:n(i),focus:n(o)}}var ba;!function(e){e[e.Burn=0]="Burn",e[e.Color=1]="Color",e[e.Darken=2]="Darken",e[e.Dodge=3]="Dodge",e[e.Lighten=4]="Lighten",e[e.Multiply=5]="Multiply",e[e.Overlay=6]="Overlay",e[e.Screen=7]="Screen"}(ba||(ba={}));class ya{constructor(e,t,i,o){this.toColorString=()=>this.cssGradient,this.contrast=ia.bind(null,this),this.createCSS=this.toColorString,this.color=new Br(e,t,i),this.cssGradient=o,this.relativeLuminance=Kr(this.color),this.r=e,this.g=t,this.b=i}static fromObject(e,t){return new ya(e.r,e.g,e.b,t)}}const wa=new Br(0,0,0),xa=new Br(1,1,1);function ka(e,t,i,o,s,n,r,a,l=10,d=!1){const c=e.closestIndexOf(t);function h(i){if(d){const o=e.closestIndexOf(t),s=e.get(o),n=i.relativeLuminance<t.relativeLuminance?wa:xa,r=function(e,t,i=null){let o=0,s=i;return null!==s?o=Jr(e,t,s):(s=new Br(0,0,0,1),o=Jr(e,t,s),o<=0&&(s=new Br(1,1,1,1),o=Jr(e,t,s))),o=Math.round(1e3*o)/1e3,new Br(s.r,s.g,s.b,o)}(jr(i.toColorString()),jr(s.toColorString()),n).roundToPrecision(2),a=function(e,t){if(t.a>=1)return t;if(t.a<=0)return new Br(e.r,e.g,e.b,1);const i=t.a*t.r+(1-t.a)*e.r,o=t.a*t.g+(1-t.a)*e.g,s=t.a*t.b+(1-t.a)*e.b;return new Br(i,o,s,1)}(jr(t.toColorString()),r);return oa.from(a)}return i}void 0===a&&(a=la(t));const u=c+a*i,p=u+a*(o-i),g=u+a*(s-i),f=u+a*(n-i),v=-1===a?0:100-l,m=-1===a?l:100;function b(t,i){const o=e.get(t);if(i){const i=e.get(t+a*r),s=-1===a?i:o,n=-1===a?o:i,l=`linear-gradient(${h(s).toColorString()} ${v}%, ${h(n).toColorString()} ${m}%)`;return ya.fromObject(s,l)}return h(o)}return{rest:b(u,!0),hover:b(p,!0),active:b(g,!1),focus:b(f,!0)}}function Ca(e,t,i,o,s,n,r,a){null==a&&(a=la(t));const l=e.closestIndexOf(e.colorContrast(t,i));return{rest:e.get(l+a*o),hover:e.get(l+a*s),active:e.get(l+a*n),focus:e.get(l+a*r)}}function $a(e,t,i,o,s,n,r){const a=e.closestIndexOf(t);return null==r&&(r=la(t)),{rest:e.get(a+r*i),hover:e.get(a+r*o),active:e.get(a+r*s),focus:e.get(a+r*n)}}function Sa(e,t,i,o,s,n,r=void 0,a,l,d,c,h=void 0){return aa(t)?$a(e,t,a,l,d,c,h):$a(e,t,i,o,s,n,r)}var _a;function Ia(e,t){return e.closestIndexOf((i=t,oa.create(i,i,i)));var i}function Ta(e,t,i){return e.get(Ia(e,t)+-1*i)}!function(e){e[e.LightMode=.98]="LightMode",e[e.DarkMode=.15]="DarkMode"}(_a||(_a={}));const{create:Da}=Jn;function Pa(e){return Jn.create({name:e,cssCustomPropertyName:null})}const La=Da("direction").withDefault(qr.ltr),Ea=Da("disabled-opacity").withDefault(.3),Oa=Da("base-height-multiplier").withDefault(8),Fa=(Da("base-horizontal-spacing-multiplier").withDefault(3),Da("density").withDefault(0)),Aa=Da("design-unit").withDefault(4),Ra=Da("control-corner-radius").withDefault(4),Va=Da("layer-corner-radius").withDefault(8),Ma=Da("stroke-width").withDefault(1),za=Da("focus-stroke-width").withDefault(2),Na=Da("body-font").withDefault('"Segoe UI Variable", "Segoe UI", sans-serif'),Ua=Da("font-weight").withDefault(400);function Ba(e){return t=>{const i=e.getValueFor(t),o=Ua.getValueFor(t);if(i.endsWith("px")){const e=Number.parseFloat(i.replace("px",""));if(e<=12)return`"wght" ${o}, "opsz" 8`;if(e>24)return`"wght" ${o}, "opsz" 36`}return`"wght" ${o}, "opsz" 10.5`}}const Ha=Da("type-ramp-base-font-size").withDefault("14px"),ja=Da("type-ramp-base-line-height").withDefault("20px"),qa=Da("type-ramp-base-font-variations").withDefault(Ba(Ha)),Za=Da("type-ramp-minus-1-font-size").withDefault("12px"),Wa=Da("type-ramp-minus-1-line-height").withDefault("16px"),Ga=Da("type-ramp-minus-1-font-variations").withDefault(Ba(Za)),Qa=Da("type-ramp-minus-2-font-size").withDefault("10px"),Ka=Da("type-ramp-minus-2-line-height").withDefault("14px"),Xa=Da("type-ramp-minus-2-font-variations").withDefault(Ba(Qa)),Ja=Da("type-ramp-plus-1-font-size").withDefault("16px"),Ya=Da("type-ramp-plus-1-line-height").withDefault("22px"),el=Da("type-ramp-plus-1-font-variations").withDefault(Ba(Ja)),tl=Da("type-ramp-plus-2-font-size").withDefault("20px"),il=Da("type-ramp-plus-2-line-height").withDefault("26px"),ol=Da("type-ramp-plus-2-font-variations").withDefault(Ba(tl)),sl=Da("type-ramp-plus-3-font-size").withDefault("24px"),nl=Da("type-ramp-plus-3-line-height").withDefault("32px"),rl=Da("type-ramp-plus-3-font-variations").withDefault(Ba(sl)),al=Da("type-ramp-plus-4-font-size").withDefault("28px"),ll=Da("type-ramp-plus-4-line-height").withDefault("36px"),dl=Da("type-ramp-plus-4-font-variations").withDefault(Ba(al)),cl=Da("type-ramp-plus-5-font-size").withDefault("32px"),hl=Da("type-ramp-plus-5-line-height").withDefault("40px"),ul=Da("type-ramp-plus-5-font-variations").withDefault(Ba(cl)),pl=Da("type-ramp-plus-6-font-size").withDefault("40px"),gl=Da("type-ramp-plus-6-line-height").withDefault("52px"),fl=Da("type-ramp-plus-6-font-variations").withDefault(Ba(pl)),vl=Da("base-layer-luminance").withDefault(_a.LightMode),ml=Pa("accent-fill-rest-delta").withDefault(0),bl=Pa("accent-fill-hover-delta").withDefault(-2),yl=Pa("accent-fill-active-delta").withDefault(-5),wl=Pa("accent-fill-focus-delta").withDefault(0),xl=Pa("accent-foreground-rest-delta").withDefault(0),kl=Pa("accent-foreground-hover-delta").withDefault(3),Cl=Pa("accent-foreground-active-delta").withDefault(-8),$l=Pa("accent-foreground-focus-delta").withDefault(0),Sl=Pa("neutral-fill-rest-delta").withDefault(-1),_l=Pa("neutral-fill-hover-delta").withDefault(1),Il=Pa("neutral-fill-active-delta").withDefault(0),Tl=Pa("neutral-fill-focus-delta").withDefault(0),Dl=Pa("neutral-fill-input-rest-delta").withDefault(-1),Pl=Pa("neutral-fill-input-hover-delta").withDefault(1),Ll=Pa("neutral-fill-input-active-delta").withDefault(0),El=Pa("neutral-fill-input-focus-delta").withDefault(-2),Ol=Pa("neutral-fill-input-alt-rest-delta").withDefault(2),Fl=Pa("neutral-fill-input-alt-hover-delta").withDefault(4),Al=Pa("neutral-fill-input-alt-active-delta").withDefault(6),Rl=Pa("neutral-fill-input-alt-focus-delta").withDefault(2),Vl=Pa("neutral-fill-layer-rest-delta").withDefault(-2),Ml=Pa("neutral-fill-layer-hover-delta").withDefault(-3),zl=Pa("neutral-fill-layer-active-delta").withDefault(-3),Nl=Pa("neutral-fill-layer-alt-rest-delta").withDefault(-1),Ul=Pa("neutral-fill-secondary-rest-delta").withDefault(3),Bl=Pa("neutral-fill-secondary-hover-delta").withDefault(2),Hl=Pa("neutral-fill-secondary-active-delta").withDefault(1),jl=Pa("neutral-fill-secondary-focus-delta").withDefault(3),ql=Pa("neutral-fill-stealth-rest-delta").withDefault(0),Zl=Pa("neutral-fill-stealth-hover-delta").withDefault(3),Wl=Pa("neutral-fill-stealth-active-delta").withDefault(2),Gl=Pa("neutral-fill-stealth-focus-delta").withDefault(0),Ql=Pa("neutral-fill-strong-rest-delta").withDefault(0),Kl=Pa("neutral-fill-strong-hover-delta").withDefault(8),Xl=Pa("neutral-fill-strong-active-delta").withDefault(-5),Jl=Pa("neutral-fill-strong-focus-delta").withDefault(0),Yl=Pa("neutral-stroke-rest-delta").withDefault(8),ed=Pa("neutral-stroke-hover-delta").withDefault(12),td=Pa("neutral-stroke-active-delta").withDefault(6),id=Pa("neutral-stroke-focus-delta").withDefault(8),od=Pa("neutral-stroke-control-rest-delta").withDefault(3),sd=Pa("neutral-stroke-control-hover-delta").withDefault(5),nd=Pa("neutral-stroke-control-active-delta").withDefault(5),rd=Pa("neutral-stroke-control-focus-delta").withDefault(5),ad=Pa("neutral-stroke-divider-rest-delta").withDefault(4),ld=Pa("neutral-stroke-layer-rest-delta").withDefault(3),dd=Pa("neutral-stroke-layer-hover-delta").withDefault(3),cd=Pa("neutral-stroke-layer-active-delta").withDefault(3),hd=Pa("neutral-stroke-strong-hover-delta").withDefault(0),ud=Pa("neutral-stroke-strong-active-delta").withDefault(0),pd=Pa("neutral-stroke-strong-focus-delta").withDefault(0),gd=Da("neutral-base-color").withDefault(ga),fd=Pa("neutral-palette").withDefault((e=>ca.from(gd.getValueFor(e)))),vd=Da("accent-base-color").withDefault(va),md=Pa("accent-palette").withDefault((e=>ca.from(vd.getValueFor(e)))),bd=Pa("neutral-layer-card-container-recipe").withDefault({evaluate:e=>Ta(fd.getValueFor(e),vl.getValueFor(e),Vl.getValueFor(e))}),yd=(Da("neutral-layer-card-container").withDefault((e=>bd.getValueFor(e).evaluate(e))),Pa("neutral-layer-floating-recipe").withDefault({evaluate:e=>function(e,t,i){return e.get(Ia(e,t)+i)}(fd.getValueFor(e),vl.getValueFor(e),Vl.getValueFor(e))})),wd=Da("neutral-layer-floating").withDefault((e=>yd.getValueFor(e).evaluate(e))),xd=Pa("neutral-layer-1-recipe").withDefault({evaluate:e=>function(e,t){return e.get(Ia(e,t))}(fd.getValueFor(e),vl.getValueFor(e))}),kd=Da("neutral-layer-1").withDefault((e=>xd.getValueFor(e).evaluate(e))),Cd=Pa("neutral-layer-2-recipe").withDefault({evaluate:e=>Ta(fd.getValueFor(e),vl.getValueFor(e),Vl.getValueFor(e))}),$d=(Da("neutral-layer-2").withDefault((e=>Cd.getValueFor(e).evaluate(e))),Pa("neutral-layer-3-recipe").withDefault({evaluate:e=>function(e,t,i){return e.get(Ia(e,t)+-1*i*2)}(fd.getValueFor(e),vl.getValueFor(e),Vl.getValueFor(e))})),Sd=(Da("neutral-layer-3").withDefault((e=>$d.getValueFor(e).evaluate(e))),Pa("neutral-layer-4-recipe").withDefault({evaluate:e=>function(e,t,i){return e.get(Ia(e,t)+-1*i*3)}(fd.getValueFor(e),vl.getValueFor(e),Vl.getValueFor(e))})),_d=(Da("neutral-layer-4").withDefault((e=>Sd.getValueFor(e).evaluate(e))),Da("fill-color").withDefault((e=>kd.getValueFor(e))));var Id;!function(e){e[e.normal=4.5]="normal",e[e.large=3]="large"}(Id||(Id={}));const Td=Pa("accent-fill-recipe").withDefault({evaluate:(e,t)=>function(e,t,i,o,s,n,r,a,l,d,c,h,u,p){return aa(t)?Ca(e,t,8,d,c,h,u,void 0):Ca(e,t,5,o,s,n,r,void 0)}(md.getValueFor(e),t||_d.getValueFor(e),0,ml.getValueFor(e),bl.getValueFor(e),yl.getValueFor(e),wl.getValueFor(e),0,0,ml.getValueFor(e),bl.getValueFor(e),yl.getValueFor(e),wl.getValueFor(e))}),Dd=Da("accent-fill-rest").withDefault((e=>Td.getValueFor(e).evaluate(e).rest)),Pd=Da("accent-fill-hover").withDefault((e=>Td.getValueFor(e).evaluate(e).hover)),Ld=Da("accent-fill-active").withDefault((e=>Td.getValueFor(e).evaluate(e).active)),Ed=Da("accent-fill-focus").withDefault((e=>Td.getValueFor(e).evaluate(e).focus)),Od=Pa("foreground-on-accent-recipe").withDefault({evaluate:e=>ma(Dd.getValueFor(e),Pd.getValueFor(e),Ld.getValueFor(e),Ed.getValueFor(e),Id.normal)}),Fd=Da("foreground-on-accent-rest").withDefault((e=>Od.getValueFor(e).evaluate(e).rest)),Ad=Da("foreground-on-accent-hover").withDefault((e=>Od.getValueFor(e).evaluate(e).hover)),Rd=Da("foreground-on-accent-active").withDefault((e=>Od.getValueFor(e).evaluate(e).active)),Vd=Da("foreground-on-accent-focus").withDefault((e=>Od.getValueFor(e).evaluate(e).focus)),Md=Pa("accent-foreground-recipe").withDefault({evaluate:(e,t)=>Ca(md.getValueFor(e),t||_d.getValueFor(e),9.5,xl.getValueFor(e),kl.getValueFor(e),Cl.getValueFor(e),$l.getValueFor(e))}),zd=Da("accent-foreground-rest").withDefault((e=>Md.getValueFor(e).evaluate(e).rest)),Nd=Da("accent-foreground-hover").withDefault((e=>Md.getValueFor(e).evaluate(e).hover)),Ud=Da("accent-foreground-active").withDefault((e=>Md.getValueFor(e).evaluate(e).active)),Bd=Da("accent-foreground-focus").withDefault((e=>Md.getValueFor(e).evaluate(e).focus)),Hd=Pa("accent-stroke-control-recipe").withDefault({evaluate:(e,t)=>ka(fd.getValueFor(e),t||_d.getValueFor(e),-3,-3,-3,-3,10,1,void 0,!0)}),jd=Da("accent-stroke-control-rest").withDefault((e=>Hd.getValueFor(e).evaluate(e,Dd.getValueFor(e)).rest)),qd=Da("accent-stroke-control-hover").withDefault((e=>Hd.getValueFor(e).evaluate(e,Pd.getValueFor(e)).hover)),Zd=Da("accent-stroke-control-active").withDefault((e=>Hd.getValueFor(e).evaluate(e,Ld.getValueFor(e)).active)),Wd=Da("accent-stroke-control-focus").withDefault((e=>Hd.getValueFor(e).evaluate(e,Ed.getValueFor(e)).focus)),Gd=Pa("neutral-fill-recipe").withDefault({evaluate:(e,t)=>Sa(fd.getValueFor(e),t||_d.getValueFor(e),Sl.getValueFor(e),_l.getValueFor(e),Il.getValueFor(e),Tl.getValueFor(e),void 0,2,3,1,2,void 0)}),Qd=Da("neutral-fill-rest").withDefault((e=>Gd.getValueFor(e).evaluate(e).rest)),Kd=Da("neutral-fill-hover").withDefault((e=>Gd.getValueFor(e).evaluate(e).hover)),Xd=Da("neutral-fill-active").withDefault((e=>Gd.getValueFor(e).evaluate(e).active)),Jd=(Da("neutral-fill-focus").withDefault((e=>Gd.getValueFor(e).evaluate(e).focus)),Pa("neutral-fill-input-recipe").withDefault({evaluate:(e,t)=>Sa(fd.getValueFor(e),t||_d.getValueFor(e),Dl.getValueFor(e),Pl.getValueFor(e),Ll.getValueFor(e),El.getValueFor(e),void 0,2,3,1,0,void 0)})),Yd=Da("neutral-fill-input-rest").withDefault((e=>Jd.getValueFor(e).evaluate(e).rest)),ec=Da("neutral-fill-input-hover").withDefault((e=>Jd.getValueFor(e).evaluate(e).hover)),tc=(Da("neutral-fill-input-active").withDefault((e=>Jd.getValueFor(e).evaluate(e).active)),Da("neutral-fill-input-focus").withDefault((e=>Jd.getValueFor(e).evaluate(e).focus))),ic=Pa("neutral-fill-input-alt-recipe").withDefault({evaluate:(e,t)=>Sa(fd.getValueFor(e),t||_d.getValueFor(e),Ol.getValueFor(e),Fl.getValueFor(e),Al.getValueFor(e),Rl.getValueFor(e),1,Ol.getValueFor(e),Ol.getValueFor(e)-Fl.getValueFor(e),Ol.getValueFor(e)-Al.getValueFor(e),Rl.getValueFor(e),1)}),oc=Da("neutral-fill-input-alt-rest").withDefault((e=>ic.getValueFor(e).evaluate(e).rest)),sc=Da("neutral-fill-input-alt-hover").withDefault((e=>ic.getValueFor(e).evaluate(e).hover)),nc=Da("neutral-fill-input-alt-active").withDefault((e=>ic.getValueFor(e).evaluate(e).active)),rc=Da("neutral-fill-input-alt-focus").withDefault((e=>ic.getValueFor(e).evaluate(e).focus)),ac=Pa("neutral-fill-layer-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),Vl.getValueFor(e),Ml.getValueFor(e),zl.getValueFor(e),Vl.getValueFor(e),1)}),lc=(Da("neutral-fill-layer-rest").withDefault((e=>ac.getValueFor(e).evaluate(e).rest)),Da("neutral-fill-layer-hover").withDefault((e=>ac.getValueFor(e).evaluate(e).hover)),Da("neutral-fill-layer-active").withDefault((e=>ac.getValueFor(e).evaluate(e).active)),Pa("neutral-fill-layer-alt-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),Nl.getValueFor(e),Nl.getValueFor(e),Nl.getValueFor(e),Nl.getValueFor(e))})),dc=(Da("neutral-fill-layer-alt-rest").withDefault((e=>lc.getValueFor(e).evaluate(e).rest)),Pa("neutral-fill-secondary-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),Ul.getValueFor(e),Bl.getValueFor(e),Hl.getValueFor(e),jl.getValueFor(e))})),cc=Da("neutral-fill-secondary-rest").withDefault((e=>dc.getValueFor(e).evaluate(e).rest)),hc=Da("neutral-fill-secondary-hover").withDefault((e=>dc.getValueFor(e).evaluate(e).hover)),uc=Da("neutral-fill-secondary-active").withDefault((e=>dc.getValueFor(e).evaluate(e).active)),pc=Da("neutral-fill-secondary-focus").withDefault((e=>dc.getValueFor(e).evaluate(e).focus)),gc=Pa("neutral-fill-stealth-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),ql.getValueFor(e),Zl.getValueFor(e),Wl.getValueFor(e),Gl.getValueFor(e))}),fc=Da("neutral-fill-stealth-rest").withDefault((e=>gc.getValueFor(e).evaluate(e).rest)),vc=Da("neutral-fill-stealth-hover").withDefault((e=>gc.getValueFor(e).evaluate(e).hover)),mc=Da("neutral-fill-stealth-active").withDefault((e=>gc.getValueFor(e).evaluate(e).active)),bc=Da("neutral-fill-stealth-focus").withDefault((e=>gc.getValueFor(e).evaluate(e).focus)),yc=Pa("neutral-fill-strong-recipe").withDefault({evaluate:(e,t)=>Ca(fd.getValueFor(e),t||_d.getValueFor(e),4.5,Ql.getValueFor(e),Kl.getValueFor(e),Xl.getValueFor(e),Jl.getValueFor(e))}),wc=(Da("neutral-fill-strong-rest").withDefault((e=>yc.getValueFor(e).evaluate(e).rest)),Da("neutral-fill-strong-hover").withDefault((e=>yc.getValueFor(e).evaluate(e).hover)),Da("neutral-fill-strong-active").withDefault((e=>yc.getValueFor(e).evaluate(e).active)),Da("neutral-fill-strong-focus").withDefault((e=>yc.getValueFor(e).evaluate(e).focus)),Pa("neutral-foreground-recipe").withDefault({evaluate:(e,t)=>Ca(fd.getValueFor(e),t||_d.getValueFor(e),16,0,-19,-30,0)})),xc=Da("neutral-foreground-rest").withDefault((e=>wc.getValueFor(e).evaluate(e).rest)),kc=Da("neutral-foreground-hover").withDefault((e=>wc.getValueFor(e).evaluate(e).hover)),Cc=Da("neutral-foreground-active").withDefault((e=>wc.getValueFor(e).evaluate(e).active)),$c=(Da("neutral-foreground-focus").withDefault((e=>wc.getValueFor(e).evaluate(e).focus)),Pa("neutral-foreground-hint-recipe").withDefault({evaluate:(e,t)=>function(e,t,i){return e.colorContrast(t,4.5)}(fd.getValueFor(e),t||_d.getValueFor(e))})),Sc=Da("neutral-foreground-hint").withDefault((e=>$c.getValueFor(e).evaluate(e))),_c=Pa("neutral-stroke-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),Yl.getValueFor(e),ed.getValueFor(e),td.getValueFor(e),id.getValueFor(e))}),Ic=Da("neutral-stroke-rest").withDefault((e=>_c.getValueFor(e).evaluate(e).rest)),Tc=Da("neutral-stroke-hover").withDefault((e=>_c.getValueFor(e).evaluate(e).hover)),Dc=Da("neutral-stroke-active").withDefault((e=>_c.getValueFor(e).evaluate(e).active)),Pc=(Da("neutral-stroke-focus").withDefault((e=>_c.getValueFor(e).evaluate(e).focus)),Pa("neutral-stroke-control-recipe").withDefault({evaluate:(e,t)=>ka(fd.getValueFor(e),t||_d.getValueFor(e),od.getValueFor(e),sd.getValueFor(e),nd.getValueFor(e),rd.getValueFor(e),5)})),Lc=Da("neutral-stroke-control-rest").withDefault((e=>Pc.getValueFor(e).evaluate(e).rest)),Ec=Da("neutral-stroke-control-hover").withDefault((e=>Pc.getValueFor(e).evaluate(e).hover)),Oc=Da("neutral-stroke-control-active").withDefault((e=>Pc.getValueFor(e).evaluate(e).active)),Fc=(Da("neutral-stroke-control-focus").withDefault((e=>Pc.getValueFor(e).evaluate(e).focus)),Pa("neutral-stroke-divider-recipe").withDefault({evaluate:(e,t)=>function(e,t,i){return e.get(e.closestIndexOf(t)+la(t)*i)}(fd.getValueFor(e),t||_d.getValueFor(e),ad.getValueFor(e))})),Ac=Da("neutral-stroke-divider-rest").withDefault((e=>Fc.getValueFor(e).evaluate(e))),Rc=Pa("neutral-stroke-input-recipe").withDefault({evaluate:(e,t)=>function(e,t,i,o,s,n,r,a){const l=e.closestIndexOf(t),d=la(t),c=l+d*i,h=c+d*(o-i),u=c+d*(s-i),p=c+d*(n-i),g=`calc(100% - ${a})`;function f(t,i){const o=e.get(t);if(i){const i=e.get(t+20*d),s=`linear-gradient(${o.toColorString()} ${g}, ${i.toColorString()} ${g}, ${i.toColorString()})`;return ya.fromObject(o,s)}return o}return{rest:f(c,!0),hover:f(h,!0),active:f(u,!1),focus:f(p,!0)}}(fd.getValueFor(e),t||_d.getValueFor(e),od.getValueFor(e),sd.getValueFor(e),nd.getValueFor(e),rd.getValueFor(e),0,Ma.getValueFor(e)+"px")}),Vc=Da("neutral-stroke-input-rest").withDefault((e=>Rc.getValueFor(e).evaluate(e).rest)),Mc=Da("neutral-stroke-input-hover").withDefault((e=>Rc.getValueFor(e).evaluate(e).hover)),zc=(Da("neutral-stroke-input-active").withDefault((e=>Rc.getValueFor(e).evaluate(e).active)),Da("neutral-stroke-input-focus").withDefault((e=>Rc.getValueFor(e).evaluate(e).focus)),Pa("neutral-stroke-layer-recipe").withDefault({evaluate:(e,t)=>$a(fd.getValueFor(e),t||_d.getValueFor(e),ld.getValueFor(e),dd.getValueFor(e),cd.getValueFor(e),ld.getValueFor(e))})),Nc=Da("neutral-stroke-layer-rest").withDefault((e=>zc.getValueFor(e).evaluate(e).rest)),Uc=(Da("neutral-stroke-layer-hover").withDefault((e=>zc.getValueFor(e).evaluate(e).hover)),Da("neutral-stroke-layer-active").withDefault((e=>zc.getValueFor(e).evaluate(e).active)),Pa("neutral-stroke-strong-recipe").withDefault({evaluate:(e,t)=>Ca(fd.getValueFor(e),t||_d.getValueFor(e),5.5,0,hd.getValueFor(e),ud.getValueFor(e),pd.getValueFor(e))})),Bc=Da("neutral-stroke-strong-rest").withDefault((e=>Uc.getValueFor(e).evaluate(e).rest)),Hc=Da("neutral-stroke-strong-hover").withDefault((e=>Uc.getValueFor(e).evaluate(e).hover)),jc=Da("neutral-stroke-strong-active").withDefault((e=>Uc.getValueFor(e).evaluate(e).active)),qc=(Da("neutral-stroke-strong-focus").withDefault((e=>Uc.getValueFor(e).evaluate(e).focus)),Pa("focus-stroke-outer-recipe").withDefault({evaluate:e=>(fd.getValueFor(e),aa(_d.getValueFor(e))?ua:pa)})),Zc=Da("focus-stroke-outer").withDefault((e=>qc.getValueFor(e).evaluate(e))),Wc=Pa("focus-stroke-inner-recipe").withDefault({evaluate:e=>{return md.getValueFor(e),t=_d.getValueFor(e),Zc.getValueFor(e),aa(t)?pa:ua;var t}}),Gc=Da("focus-stroke-inner").withDefault((e=>Wc.getValueFor(e).evaluate(e))),Qc=Pa("foreground-on-accent-large-recipe").withDefault({evaluate:e=>ma(Dd.getValueFor(e),Pd.getValueFor(e),Ld.getValueFor(e),Ed.getValueFor(e),Id.large)}),Kc=(Da("foreground-on-accent-rest-large").withDefault((e=>Qc.getValueFor(e).evaluate(e).rest)),Da("foreground-on-accent-hover-large").withDefault((e=>Qc.getValueFor(e).evaluate(e,Pd.getValueFor(e)).hover)),Da("foreground-on-accent-active-large").withDefault((e=>Qc.getValueFor(e).evaluate(e,Ld.getValueFor(e)).active)),Da("foreground-on-accent-focus-large").withDefault((e=>Qc.getValueFor(e).evaluate(e,Ed.getValueFor(e)).focus)),Da("neutral-fill-inverse-rest-delta").withDefault(0)),Xc=Da("neutral-fill-inverse-hover-delta").withDefault(-3),Jc=Da("neutral-fill-inverse-active-delta").withDefault(7),Yc=Da("neutral-fill-inverse-focus-delta").withDefault(0),eh=Pa("neutral-fill-inverse-recipe").withDefault({evaluate:(e,t)=>function(e,t,i,o,s,n){const r=la(t),a=e.closestIndexOf(e.colorContrast(t,14)),l=a+r*Math.abs(i-o);let d,c;return(1===r?i<o:r*i>r*o)?(d=a,c=l):(d=l,c=a),{rest:e.get(d),hover:e.get(c),active:e.get(d+r*s),focus:e.get(d+r*n)}}(fd.getValueFor(e),t||_d.getValueFor(e),Kc.getValueFor(e),Xc.getValueFor(e),Jc.getValueFor(e),Yc.getValueFor(e))});function th(e,t){const i=[];let o="";const s=[];for(let n=0,r=e.length-1;n<r;++n){o+=e[n];let r=t[n];if(r instanceof Fn){const e=r.createBehavior();r=r.createCSS(),e&&s.push(e)}r instanceof xs||r instanceof CSSStyleSheet?(""!==o.trim()&&(i.push(o),o=""),i.push(r)):o+=r}return o+=e[e.length-1],""!==o.trim()&&i.push(o),{styles:i,behaviors:s}}function ih(e,...t){const{styles:i,behaviors:o}=th(e,t),s=xs.create(i);return o.length&&s.withBehaviors(...o),s}Da("neutral-fill-inverse-rest").withDefault((e=>eh.getValueFor(e).evaluate(e).rest)),Da("neutral-fill-inverse-hover").withDefault((e=>eh.getValueFor(e).evaluate(e).hover)),Da("neutral-fill-inverse-active").withDefault((e=>eh.getValueFor(e).evaluate(e).active)),Da("neutral-fill-inverse-focus").withDefault((e=>eh.getValueFor(e).evaluate(e).focus));class oh extends Fn{constructor(e,t){super(),this.behaviors=t,this.css="";const i=e.reduce(((e,t)=>("string"==typeof t?this.css+=t:e.push(t),e)),[]);i.length&&(this.styles=xs.create(i))}createBehavior(){return this}createCSS(){return this.css}bind(e){this.styles&&e.$fastController.addStyles(this.styles),this.behaviors.length&&e.$fastController.addBehaviors(this.behaviors)}unbind(e){this.styles&&e.$fastController.removeStyles(this.styles),this.behaviors.length&&e.$fastController.removeBehaviors(this.behaviors)}}function sh(e,...t){const{styles:i,behaviors:o}=th(e,t);return new oh(i,o)}function nh(e){return`:host([hidden]){display:none}:host{display:${e}}`}class rh{constructor(e){this.listenerCache=new WeakMap,this.query=e}bind(e){const{query:t}=this,i=this.constructListener(e);i.bind(t)(),t.addListener(i),this.listenerCache.set(e,i)}unbind(e){const t=this.listenerCache.get(e);t&&(this.query.removeListener(t),this.listenerCache.delete(e))}}class ah extends rh{constructor(e,t){super(e),this.styles=t}static with(e){return t=>new ah(e,t)}constructListener(e){let t=!1;const i=this.styles;return function(){const{matches:o}=this;o&&!t?(e.$fastController.addStyles(i),t=o):!o&&t&&(e.$fastController.removeStyles(i),t=o)}}unbind(e){super.unbind(e),e.$fastController.removeStyles(this.styles)}}const lh=ah.with(window.matchMedia("(forced-colors)"));var dh,ch;ah.with(window.matchMedia("(prefers-color-scheme: dark)")),ah.with(window.matchMedia("(prefers-color-scheme: light)")),(ch=dh||(dh={})).Canvas="Canvas",ch.CanvasText="CanvasText",ch.LinkText="LinkText",ch.VisitedText="VisitedText",ch.ActiveText="ActiveText",ch.ButtonFace="ButtonFace",ch.ButtonText="ButtonText",ch.Field="Field",ch.FieldText="FieldText",ch.Highlight="Highlight",ch.HighlightText="HighlightText",ch.GrayText="GrayText";const hh=Jn.create({name:"elevation-shadow",cssCustomPropertyName:null}).withDefault({evaluate:(e,t,i)=>{let o=.12,s=.14;return t>16&&(o=.2,s=.24),`0 0 2px rgba(0, 0, 0, ${o}), 0 calc(${t} * 0.5px) calc((${t} * 1px)) rgba(0, 0, 0, ${s})`}}),uh=Jn.create("elevation-shadow-card-rest-size").withDefault(4),ph=Jn.create("elevation-shadow-card-hover-size").withDefault(8),gh=Jn.create("elevation-shadow-card-active-size").withDefault(0),fh=Jn.create("elevation-shadow-card-focus-size").withDefault(8),vh=Jn.create("elevation-shadow-card-rest").withDefault((e=>hh.getValueFor(e).evaluate(e,uh.getValueFor(e)))),mh=(Jn.create("elevation-shadow-card-hover").withDefault((e=>hh.getValueFor(e).evaluate(e,ph.getValueFor(e)))),Jn.create("elevation-shadow-card-active").withDefault((e=>hh.getValueFor(e).evaluate(e,gh.getValueFor(e)))),Jn.create("elevation-shadow-card-focus").withDefault((e=>hh.getValueFor(e).evaluate(e,fh.getValueFor(e)))),Jn.create("elevation-shadow-tooltip-size").withDefault(16)),bh=Jn.create("elevation-shadow-tooltip").withDefault((e=>hh.getValueFor(e).evaluate(e,mh.getValueFor(e)))),yh=Jn.create("elevation-shadow-flyout-size").withDefault(32),wh=Jn.create("elevation-shadow-flyout").withDefault((e=>hh.getValueFor(e).evaluate(e,yh.getValueFor(e)))),xh=Jn.create("elevation-shadow-dialog-size").withDefault(128),kh=Jn.create("elevation-shadow-dialog").withDefault((e=>hh.getValueFor(e).evaluate(e,xh.getValueFor(e))));class Ch extends dr{cardFillColorChanged(e,t){if(t){const e=jr(t);null!==e&&(this.neutralPaletteSource=t,_d.setValueFor(this,oa.create(e.r,e.g,e.b)))}}neutralPaletteSourceChanged(e,t){if(t){const e=jr(t),i=oa.create(e.r,e.g,e.b);fd.setValueFor(this,ca.create(i))}}handleChange(e,t){this.cardFillColor||_d.setValueFor(this,(t=>ac.getValueFor(t).evaluate(t,_d.getValueFor(e)).rest))}connectedCallback(){super.connectedCallback();const e=An(this);if(e){const t=vs.getNotifier(e);t.subscribe(this,"fillColor"),t.subscribe(this,"neutralPalette"),this.handleChange(e,"fillColor")}}}i([Os({attribute:"card-fill-color",mode:"fromView"})],Ch.prototype,"cardFillColor",void 0),i([Os({attribute:"neutral-palette-source",mode:"fromView"})],Ch.prototype,"neutralPaletteSource",void 0);const $h=Ch.compose({baseName:"card",baseClass:dr,template:(e,t)=>Rr`
    <slot></slot>
`,styles:(e,t)=>ih`
    ${nh("block")} :host {
      display: block;
      contain: content;
      height: var(--card-height, 100%);
      width: var(--card-width, 100%);
      box-sizing: border-box;
      background: ${_d};
      color: ${xc};
      border: calc(${Ma} * 1px) solid ${Nc};
      border-radius: calc(${Va} * 1px);
      box-shadow: ${vh};
    }

    :host {
      content-visibility: auto;
    }
  `.withBehaviors(lh(ih`
        :host {
          background: ${dh.Canvas};
          color: ${dh.CanvasText};
        }
      `))});var Sh=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},_h=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},Ih=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr($h);let Th=class extends Nt{constructor(){super(...arguments),this._days=3,this.onResize=()=>{this._isNarrow=this.offsetWidth<600}}static get styles(){return Uo}get date(){return this._date}set date(e){this._date!==e&&(this._date=e,this.reloadState())}get groupId(){return this._groupId}set groupId(e){this._groupId!==e&&(this._groupId=e,this.reloadState())}get days(){return this._days}set days(e){this._days!==e&&(this._days=e,this.reloadState())}get eventQuery(){return this._eventQuery}set eventQuery(e){this._eventQuery!==e&&(this._eventQuery=e,this.reloadState())}get preferredTimezone(){return this._preferredTimezone}set preferredTimezone(e){this._preferredTimezone!==e&&(this._preferredTimezone=e,this.reloadState())}static get requiredScopes(){return[...new Set(["calendars.read",...ts.requiredScopes])]}connectedCallback(){this._isNarrow=this.offsetWidth<600,super.connectedCallback(),window.addEventListener("resize",this.onResize)}disconnectedCallback(){window.removeEventListener("resize",this.onResize),super.disconnectedCallback()}render(){if(!this.events&&this.isLoadingState)return this.renderLoading();if(!this.events||0===this.events.length)return this.renderNoData();const e=this.showMax&&this.showMax>0?this.events.slice(0,this.showMax):this.events,t=this.renderTemplate("default",{events:e});if(t)return t;const i={agenda:!0,grouped:this.groupByDay};return Je`
      <div dir=${this.direction} class="${ki(i)}">
        ${this.groupByDay?this.renderGroups(e):this.renderEvents(e)}
        ${this.isLoadingState?this.renderLoading():Je``}
      </div>
    `}reload(){return Ih(this,void 0,void 0,(function*(){this.events=yield this.loadEvents()}))}renderLoading(){return this.renderTemplate("loading",null)||Je`
        <fluent-card class="event event-loading">
          <div class="event-time-container">
            <div class="event-time-loading loading-element"></div>
          </div>
          <div class="event-details-container">
            <div class="event-subject-loading loading-element"></div>
            <div class="event-location-container">
              <div class="event-location-icon-loading loading-element"></div>
              <div class="event-location-loading loading-element"></div>
            </div>
            <div class="event-location-container">
              <div class="event-attendee-loading loading-element"></div>
              <div class="event-attendee-loading loading-element"></div>
              <div class="event-attendee-loading loading-element"></div>
            </div>
          </div>
        </fluent-card>`}clearState(){this.events=null}renderNoData(){return this.renderTemplate("no-data",null)||Je``}renderEvent(e){this._isNarrow=this.offsetWidth<600;const t={narrow:this._isNarrow};return Je`
      <fluent-card class="${ki(Object.assign({event:!0},t))}">
        <div class="${ki(Object.assign({"event-time-container":!0},t))}">
          <div class="event-time" aria-label="${this.getEventTimeString(e)}">${this.getEventTimeString(e)}</div>
        </div>
        <div class="${ki(Object.assign({"event-details-container":!0},t))}">
          ${this.renderTitle(e)} ${this.renderLocation(e)} ${this.renderAttendees(e)}
        </div>
        <div class="event-other-container">${this.renderOther(e)}</div>
      </fluent-card>
    `}renderHeader(e){return this.renderTemplate("header",{header:e},"header-"+e)||Je`
        <div class="header" aria-label="${e}">${e}</div>
      `}renderTitle(e){return Je`
      <div
        aria-label=${e.subject}
        class="${ki({"event-subject":!0,narrow:this._isNarrow})}"
      >
        ${e.subject}
      </div>`}renderLocation(e){return e.location.displayName?Je`
      <div class="event-location-container">
        <div class="event-location-icon">${Co(ko.OfficeLocation)}</div>
        <div class="event-location" aria-label="${e.location.displayName}">${e.location.displayName}</div>
      </div>
    `:null}renderAttendees(e){return e.attendees.length?pi`
      <mgt-people
        show-max="5"
        show-presence
        class="event-attendees"
        .peopleQueries=${e.attendees.map((e=>e.emailAddress.address))}
      ></mgt-people>
    `:null}renderOther(e){return this.hasTemplate("event-other")?Je`
          ${this.renderTemplate("event-other",{event:e},e.id+"-other")}
        `:null}renderGroups(e){const t={};return e.forEach((e=>{var i;let o=null===(i=null==e?void 0:e.start)||void 0===i?void 0:i.dateTime;"UTC"===e.end.timeZone&&(o+="Z");const s=this.getDateHeaderFromDateTimeString(o);t[s]=t[s]||[],t[s].push(e)})),Je`
      ${Object.keys(t).map((e=>Je`
            <div class="group">${this.renderHeader(e)} ${this.renderEvents(t[e])}</div>
          `))}
    `}renderEvents(e){return Je`
        ${e.map((e=>Je`
              <div
                class="event-container"
                tabindex="0"
                @focus=${()=>this.eventClicked(e)}>
                ${this.renderTemplate("event",{event:e},e.id)||this.renderEvent(e)}
              </div>`))}`}loadState(){return Ih(this,void 0,void 0,(function*(){if(this.events)return;const e=yield this.loadEvents();(null==e?void 0:e.length)>0&&(this.events=e)}))}reloadState(){return Ih(this,void 0,void 0,(function*(){this.events=null,yield this.requestStateUpdate(!0)}))}eventClicked(e){this.fireCustomEvent("eventClick",e)}getEventTimeString(e){if(e.isAllDay)return"ALL DAY";let t=e.start.dateTime;"UTC"===e.start.timeZone&&(t+="Z");let i=e.end.dateTime;return"UTC"===e.end.timeZone&&(i+="Z"),`${this.prettyPrintTimeFromDateTime(new Date(t))} - ${this.prettyPrintTimeFromDateTime(new Date(i))}`}loadEvents(){return Ih(this,void 0,void 0,(function*(){const e=te.globalProvider;let t=[];if((null==e?void 0:e.state)===Q.SignedIn){const i=e.graph.forComponent(this);if(this.eventQuery)try{const e=this.eventQuery.split("|");let o,s;e.length>1?(s=e[0].trim(),o=e[1].trim()):s=this.eventQuery;const n=yield Ho(i,s,o);if(null==n?void 0:n.value)for(t=n.value;n.hasNext;)yield n.next(),t=n.value}catch(e){}else{const e=this.date?new Date(this.date):new Date,o=new Date(e.getTime());o.setDate(e.getDate()+this.days);try{const s=yield((e,t,i,o)=>Bo(void 0,void 0,void 0,(function*(){const s=`startdatetime=${t.toISOString()}`,n=`enddatetime=${i.toISOString()}`;let r;return r=o?`groups/${o}/calendar`:"me",r+=`/calendarview?${s}&${n}`,Ho(e,r)})))(i,e,o,this.groupId);if(null==s?void 0:s.value)for(t=s.value;s.hasNext;)yield s.next(),t=s.value}catch(e){}}}return t}))}prettyPrintTimeFromDateTime(e){return e.toLocaleTimeString(navigator.language,{timeStyle:"short",timeZone:this.preferredTimezone})}getDateHeaderFromDateTimeString(e){return new Date(e).toLocaleDateString(navigator.language,{dateStyle:"full",timeZone:this.preferredTimezone})}};Sh([Ct({attribute:"date",type:String}),_h("design:type",String),_h("design:paramtypes",[Object])],Th.prototype,"date",null),Sh([Ct({attribute:"group-id",type:String}),_h("design:type",String),_h("design:paramtypes",[Object])],Th.prototype,"groupId",null),Sh([Ct({attribute:"days",type:Number}),_h("design:type",Number),_h("design:paramtypes",[Object])],Th.prototype,"days",null),Sh([Ct({attribute:"event-query",type:String}),_h("design:type",String),_h("design:paramtypes",[Object])],Th.prototype,"eventQuery",null),Sh([Ct({attribute:"events",type:Array}),_h("design:type",Array)],Th.prototype,"events",void 0),Sh([Ct({attribute:"show-max",type:Number}),_h("design:type",Number)],Th.prototype,"showMax",void 0),Sh([Ct({attribute:"group-by-day",type:Boolean}),_h("design:type",Boolean)],Th.prototype,"groupByDay",void 0),Sh([Ct({attribute:"preferred-timezone",type:String}),_h("design:type",String),_h("design:paramtypes",[Object])],Th.prototype,"preferredTimezone",null),Sh([Ct({attribute:!1}),_h("design:type",Boolean)],Th.prototype,"_isNarrow",void 0),Th=Sh([gi("agenda")],Th);const Dh=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{font-size:var(--default-font-size);font-weight:var(--default-font-weight,400);border:var(--file-border,1px solid transparent);border-radius:var(--file-border-radius,4px);background-color:var(--file-background-color)}:host .item{display:flex;flex-flow:row nowrap;align-items:center;background-color:var(--file-background-color);padding:var(--file-padding,0);margin:var(--file-margin,0)}:host .item:hover{background-color:var(--file-background-color-hover,var(--neutral-fill-hover));border-radius:var(--file-border-radius,4px);cursor:pointer;--secondary-text-color:var(--secondary-text-hover-color)}:host .item:focus,:host .item:focus-visible{background-color:var(--file-background-color-focus,var(--neutral-fill-hover));border-radius:var(--file-border-radius,4px)}:host .item__file-type-icon{height:var(--file-type-icon-height,28px);display:flex;align-items:center;justify-content:center}:host .item__file-type-icon img{height:var(--file-type-icon-height,28px)}:host .item__details{padding-inline-start:var(--file-padding-inline-start,14px)}:host .item__details .line1{font-size:var(--default-font-size);font-weight:var(--file-line1-font-weight,var(--default-font-weight,400));text-transform:var(--file-line1-text-transform,initial);line-height:20px;color:var(--file-line1-color,var(--neutral-foreground-rest))}:host .item__details .line2{color:var(--file-line2-color,var(--secondary-text-color));font-size:var(--file-line2-font-size,var(--last-modified-font-size,12px));font-weight:var(--file-line2-font-weight,var(--default-font-weight,400));text-transform:var(--file-line2-text-transform,initial);line-height:16px}:host .item__details .line3{color:var(--file-line3-color,var(--secondary-text-color));font-size:var(--file-line3-font-size,var(--size-font-size,12px));font-weight:var(--file-line3-font-weight,var(--default-font-weight,400));text-transform:var(--file-line3-text-transform,initial);line-height:16px}[dir=rtl] .item{direction:rtl}[dir=rtl] .item__details{direction:rtl}
`];var Ph=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const Lh=()=>Ph(void 0,void 0,void 0,(function*(){const e=ai.getCache(Ui,Ui.stores.fileLists);yield e.clearStore()})),Eh=()=>ai.config.files.invalidationPeriod||ai.config.defaultInvalidationPeriod,Oh=()=>ai.config.files.isEnabled&&ai.config.isEnabled,Fh=()=>ai.config.fileLists.isEnabled&&ai.config.isEnabled,Ah=(e,t,i=Ni.stores.fileQueries,o="files.read")=>Ph(void 0,void 0,void 0,(function*(){const s=ai.getCache(Ni,i),n=yield Nh(s,t);if(n)return n;let r;try{r=yield e.api(t).middlewareOptions(ie(o)).get(),Oh()&&(yield s.putValue(t,{file:JSON.stringify(r)}))}catch(e){}return r||null})),Rh=(e,t,i,o,s)=>Ph(void 0,void 0,void 0,(function*(){let n;const r=ai.getCache(Ui,i),a=yield Uh(r,i,`${t}:${s}`);if(a)return n=zh(e,a.files,a.nextLink),n;let l;try{if(l=e.api(t).middlewareOptions(ie(...o)),s&&l.top(s),n=yield Mh(e,l),Fh()){const e=n.nextLink;yield r.putValue(t,{files:n.value.map((e=>JSON.stringify(e))),nextLink:e})}}catch(e){}return n||null})),Vh=(e,t,i)=>Ph(void 0,void 0,void 0,(function*(){if(!t)return[];const o=t.value,s=e.createBatch(),n=[];for(const e of o){const t=e.resourceReference.id;""!==t&&s.get(t,t,i)}try{const e=yield s.executeAll();for(const t of o){const i=e.get(t.resourceReference.id);(null==i?void 0:i.content)&&n.push(i.content)}return n}catch(t){try{return Promise.all(o.filter((e=>Boolean(e.resourceReference.id))).map((t=>Ph(void 0,void 0,void 0,(function*(){return yield e.api(t.resourceReference.id).middlewareOptions(ie(...i)).get()})))))}catch(e){return[]}}})),Mh=(e,t)=>Ph(void 0,void 0,void 0,(function*(){return ci.create(e,t)})),zh=(e,t,i)=>ci.createFromValue(e,t.map((e=>JSON.parse(e))),i),Nh=(e,t)=>Ph(void 0,void 0,void 0,(function*(){if(Oh()){const i=yield e.getValue(t);if(i&&Eh()>Date.now()-i.timeCached)return JSON.parse(i.file)}return null})),Uh=(e,t,i)=>Ph(void 0,void 0,void 0,(function*(){if(e||(e=ai.getCache(Ui,t)),Fh()){const t=yield e.getValue(i);if(t&&(ai.config.fileLists.invalidationPeriod||ai.config.defaultInvalidationPeriod)>Date.now()-t.timeCached)return t}return null})),Bh=e=>Ph(void 0,void 0,void 0,(function*(){const t=e.nextLink;if(e.hasNext&&(yield e.next()),Fh()){const i=ai.getCache(Ui,Ui.stores.fileLists),o=/(graph.microsoft.com\/(v1.0|beta))(.*?)(?=\?)/gi.exec(t)[3];yield i.putValue(o,{files:e.value.map((e=>JSON.stringify(e))),nextLink:t})}})),Hh=(e,t,i,o,s)=>Ph(void 0,void 0,void 0,(function*(){try{const n="files.readwrite",r={"Content-Length":i,"Content-Range":o};let a;try{a=yield e.client.api(t).middlewareOptions(ie(n)).headers(r).put(s)}catch(e){}return a||null}catch(e){return null}})),jh={PowerPoint:"pptx",Word:"docx",Excel:"xlsx",Pdf:"pdf",OneNote:"onetoc",OneNotePage:"one",InfoPath:"xsn",Visio:"vstx",Publisher:"pub",Project:"mpp",Access:"accdb",Mail:"email",Csv:"csv",Archive:"archive",Xps:"vector",Audio:"audio",Video:"video",Image:"photo",Web:"html",Text:"txt",Xml:"xml",Story:"genericfile",ExternalContent:"genericfile",Folder:"folder",Spsite:"spo",Other:"genericfile"},qh="https://spoprod-a.akamaihd.net/files/fabric-cdn-prod_20201008.001/assets/item-types",Zh={modifiedSubtitle:"Modified",sizeSubtitle:"Size"};var Wh=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Gh=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};let Qh=class extends Nt{static get styles(){return Dh}get strings(){return Zh}get fileQuery(){return this._fileQuery}set fileQuery(e){e!==this._fileQuery&&(this._fileQuery=e,this.requestStateUpdate())}get siteId(){return this._siteId}set siteId(e){e!==this._siteId&&(this._siteId=e,this.requestStateUpdate())}get driveId(){return this._driveId}set driveId(e){e!==this._driveId&&(this._driveId=e,this.requestStateUpdate())}get groupId(){return this._groupId}set groupId(e){e!==this._groupId&&(this._groupId=e,this.requestStateUpdate())}get listId(){return this._listId}set listId(e){e!==this._listId&&(this._listId=e,this.requestStateUpdate())}get userId(){return this._userId}set userId(e){e!==this._userId&&(this._userId=e,this.requestStateUpdate())}get itemId(){return this._itemId}set itemId(e){e!==this._itemId&&(this._itemId=e,this.requestStateUpdate())}get itemPath(){return this._itemPath}set itemPath(e){e!==this._itemPath&&(this._itemPath=e,this.requestStateUpdate())}get insightType(){return this._insightType}set insightType(e){e!==this._insightType&&(this._insightType=e,this.requestStateUpdate())}get insightId(){return this._insightId}set insightId(e){e!==this._insightId&&(this._insightId=e,this.requestStateUpdate())}get fileDetails(){return this._fileDetails}set fileDetails(e){e!==this._fileDetails&&(this._fileDetails=e,this.requestStateUpdate())}get fileIcon(){return this._fileIcon}set fileIcon(e){e!==this._fileIcon&&(this._fileIcon=e,this.requestStateUpdate())}static get requiredScopes(){return[...new Set(["files.read","files.read.all","sites.read.all"])]}constructor(){super(),this.line1Property="name",this.line2Property="lastModifiedDateTime",this.line3Property="size",this.view=xo.threelines}render(){if(!this.driveItem&&this.isLoadingState)return this.renderLoading();if(!this.driveItem)return this.renderNoData();const e=this.driveItem;let t;if(t=this.renderTemplate("default",{file:e}),!t){const i=this.renderDetails(e),o=this.renderFileTypeIcon();t=Je`
        <div class="item">
          ${o} ${i}
        </div>`}return t}renderLoading(){return this.renderTemplate("loading",null)||Je``}renderNoData(){return this.renderTemplate("no-data",null)||Je``}renderFileTypeIcon(){if(!this.fileIcon&&!this.driveItem.name)return Je``;let e;if(this.fileIcon)e=this.fileIcon;else{const i=/(?:\.([^.]+))?$/,o=void 0===this.driveItem.package&&void 0===this.driveItem.folder?i.exec(this.driveItem.name)[1]?i.exec(this.driveItem.name)[1].toLowerCase():this.driveItem.size?"null":"folder":void 0!==this.driveItem.package&&"oneNote"===this.driveItem.package.type?"onetoc":"folder";t=o,48,"svg",e=Object.keys(jh).find((e=>jh[e]===t))?`${qh}/${48..toString()}/${t}.svg`:"jpg"===t||"png"===t?(t="photo",`${qh}/${48..toString()}/${t}.svg`):null}var t;return Je`
      <div class="item__file-type-icon">
        ${e?Je`
              <img src=${e} alt="File icon" />
            `:Je`
              ${Co(ko.File)}
            `}
      </div>
    `}renderDetails(e){if(!e||this.view===xo.image)return Je``;const t=[];if(this.view>xo.image){const i=this.getTextFromProperty(e,this.line1Property);i&&t.push(Je`
          <div class="line1" aria-label="${i}">${i}</div>
        `)}if(this.view>xo.oneline){const i=this.getTextFromProperty(e,this.line2Property);i&&t.push(Je`
          <div class="line2" aria-label="${i}">${i}</div>
        `)}if(this.view>xo.twolines){const i=this.getTextFromProperty(e,this.line3Property);i&&t.push(Je`
          <div class="line3" aria-label="${i}">${i}</div>
        `)}return Je`
      <div class="item__details">
        ${t}
      </div>
    `}loadState(){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){if(this.fileDetails)return void(this.driveItem=this.fileDetails);const e=te.globalProvider;if(!e||e.state===Q.Loading)return;if(e.state===Q.SignedOut)return void(this.driveItem=null);const t=e.graph.forComponent(this);let i;const o=!(this.driveId||this.siteId||this.groupId||this.listId||this.userId);this.driveId&&!this.itemId&&!this.itemPath||this.siteId&&!this.itemId&&!this.itemPath||this.groupId&&!this.itemId&&!this.itemPath||this.listId&&!this.siteId&&!this.itemId||this.insightType&&!this.insightId||this.userId&&!this.itemId&&!this.itemPath&&!this.insightType&&!this.insightId?i=null:this.fileQuery?i=yield Ah(t,this.fileQuery):this.itemId&&o?i=yield((e,t)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/me/drive/items/${t}`,Ni.stores.userFiles)})))(t,this.itemId):this.itemPath&&o?i=yield((e,t)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/me/drive/root:/${t}`,Ni.stores.userFiles)})))(t,this.itemPath):this.userId?this.itemId?i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/users/${t}/drive/items/${i}`,Ni.stores.userFiles)})))(t,this.userId,this.itemId):this.itemPath?i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/users/${t}/drive/root:/${i}`,Ni.stores.userFiles)})))(t,this.userId,this.itemPath):this.insightType&&this.insightId&&(i=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/users/${t}/insights/${i}/${o}/resource`,Ni.stores.insightFiles,"sites.read.all")})))(t,this.userId,this.insightType,this.insightId)):this.driveId?this.itemId?i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/drives/${t}/items/${i}`,Ni.stores.driveFiles)})))(t,this.driveId,this.itemId):this.itemPath&&(i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/drives/${t}/root:/${i}`,Ni.stores.driveFiles)})))(t,this.driveId,this.itemPath)):this.siteId&&!this.listId?this.itemId?i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/sites/${t}/drive/items/${i}`,Ni.stores.siteFiles)})))(t,this.siteId,this.itemId):this.itemPath&&(i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/sites/${t}/drive/root:/${i}`,Ni.stores.siteFiles)})))(t,this.siteId,this.itemPath)):this.listId?i=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/sites/${t}/lists/${i}/items/${o}/driveItem`,Ni.stores.siteFiles)})))(t,this.siteId,this.listId,this.itemId):this.groupId?this.itemId?i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/groups/${t}/drive/items/${i}`,Ni.stores.groupFiles)})))(t,this.groupId,this.itemId):this.itemPath&&(i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/groups/${t}/drive/root:/${i}`,Ni.stores.groupFiles)})))(t,this.groupId,this.itemPath)):this.insightType&&!this.userId&&(i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){return Ah(e,`/me/insights/${t}/${i}/resource`,Ni.stores.insightFiles,"sites.read.all")})))(t,this.insightType,this.insightId)),this.driveItem=i}))}getTextFromProperty(e,t){if(!t||0===t.length)return null;const i=t.trim().split(",");let o,s=0;for(;!o&&s<i.length;){const t=i[s].trim();switch(t){case"size":{let t="0";e.size&&(t=Ti(e.size)),o=`${this.strings.sizeSubtitle}: ${t}`;break}case"lastModifiedDateTime":{let t,i;if(e.lastModifiedDateTime){const o=new Date(e.lastModifiedDateTime);t=Ci(o),i=`${this.strings.modifiedSubtitle} ${t}`}else i="";o=i;break}default:o=e[t]}s++}return o}};Wh([Ct({attribute:"file-query"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"fileQuery",null),Wh([Ct({attribute:"site-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"siteId",null),Wh([Ct({attribute:"drive-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"driveId",null),Wh([Ct({attribute:"group-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"groupId",null),Wh([Ct({attribute:"list-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"listId",null),Wh([Ct({attribute:"user-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"userId",null),Wh([Ct({attribute:"item-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"itemId",null),Wh([Ct({attribute:"item-path"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"itemPath",null),Wh([Ct({attribute:"insight-type"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"insightType",null),Wh([Ct({attribute:"insight-id"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"insightId",null),Wh([Ct({type:Object}),Gh("design:type",Object),Gh("design:paramtypes",[Object])],Qh.prototype,"fileDetails",null),Wh([Ct({attribute:"file-icon"}),Gh("design:type",String),Gh("design:paramtypes",[String])],Qh.prototype,"fileIcon",null),Wh([Ct({type:Object}),Gh("design:type",Object)],Qh.prototype,"driveItem",void 0),Wh([Ct({attribute:"line1-property"}),Gh("design:type",String)],Qh.prototype,"line1Property",void 0),Wh([Ct({attribute:"line2-property"}),Gh("design:type",String)],Qh.prototype,"line2Property",void 0),Wh([Ct({attribute:"line3-property"}),Gh("design:type",String)],Qh.prototype,"line3Property",void 0),Wh([Ct({attribute:"view",converter:e=>e&&0!==e.length?(e=e.toLowerCase(),void 0===xo[e]?xo.threelines:xo[e]):xo.threelines}),Gh("design:type",Number)],Qh.prototype,"view",void 0),Qh=Wh([gi("file"),Gh("design:paramtypes",[])],Qh);class Kh extends Ln{constructor(){super(...arguments),this.percentComplete=0}valueChanged(){this.$fastController.isConnected&&this.updatePercentComplete()}minChanged(){this.$fastController.isConnected&&this.updatePercentComplete()}maxChanged(){this.$fastController.isConnected&&this.updatePercentComplete()}connectedCallback(){super.connectedCallback(),this.updatePercentComplete()}updatePercentComplete(){const e="number"==typeof this.min?this.min:0,t="number"==typeof this.max?this.max:100,i="number"==typeof this.value?this.value:0,o=t-e;this.percentComplete=0===o?0:Math.fround((i-e)/o*100)}}Ms([Os({converter:Ls})],Kh.prototype,"value",void 0),Ms([Os({converter:Ls})],Kh.prototype,"min",void 0),Ms([Os({converter:Ls})],Kh.prototype,"max",void 0),Ms([Os({mode:"boolean"})],Kh.prototype,"paused",void 0),Ms([ms],Kh.prototype,"percentComplete",void 0);const Xh=e=>"function"==typeof e,Jh=()=>null;function Yh(e){return void 0===e?Jh:Xh(e)?e:()=>e}function eu(e,t,i){const o=Xh(e)?e:()=>e,s=Yh(t),n=Yh(i);return(e,t)=>o(e,t)?s(e,t):n(e,t)}const tu=class extends Kh{}.compose({baseName:"progress",template:(e,t)=>Rr`
    <template
        role="progressbar"
        aria-valuenow="${e=>e.value}"
        aria-valuemin="${e=>e.min}"
        aria-valuemax="${e=>e.max}"
        class="${e=>e.paused?"paused":""}"
    >
        ${eu((e=>"number"==typeof e.value),Rr`
                <div class="progress" part="progress" slot="determinate">
                    <div
                        class="determinate"
                        part="determinate"
                        style="width: ${e=>e.percentComplete}%"
                    ></div>
                </div>
            `,Rr`
                <div class="progress" part="progress" slot="indeterminate">
                    <slot class="indeterminate" name="indeterminate">
                        ${t.indeterminateIndicator1||""}
                        ${t.indeterminateIndicator2||""}
                    </slot>
                </div>
            `)}
    </template>
`,styles:(e,t)=>ih`
    ${nh("flex")} :host {
      align-items: center;
      height: calc((${Ma} * 3) * 1px);
    }

    .progress {
      background-color: ${Bc};
      border-radius: calc(${Aa} * 1px);
      width: 100%;
      height: calc(${Ma} * 1px);
      display: flex;
      align-items: center;
      position: relative;
    }

    .determinate {
      background-color: ${Dd};
      border-radius: calc(${Aa} * 1px);
      height: calc((${Ma} * 3) * 1px);
      transition: all 0.2s ease-in-out;
      display: flex;
    }

    .indeterminate {
      height: calc((${Ma} * 3) * 1px);
      border-radius: calc(${Aa} * 1px);
      display: flex;
      width: 100%;
      position: relative;
      overflow: hidden;
    }

    .indeterminate-indicator-1 {
      position: absolute;
      opacity: 0;
      height: 100%;
      background-color: ${Dd};
      border-radius: calc(${Aa} * 1px);
      animation-timing-function: cubic-bezier(0.4, 0, 0.6, 1);
      width: 40%;
      animation: indeterminate-1 2s infinite;
    }

    .indeterminate-indicator-2 {
      position: absolute;
      opacity: 0;
      height: 100%;
      background-color: ${Dd};
      border-radius: calc(${Aa} * 1px);
      animation-timing-function: cubic-bezier(0.4, 0, 0.6, 1);
      width: 60%;
      animation: indeterminate-2 2s infinite;
    }

    :host(.paused) .indeterminate-indicator-1,
    :host(.paused) .indeterminate-indicator-2 {
      animation: none;
      background-color: ${Sc};
      width: 100%;
      opacity: 1;
    }

    :host(.paused) .determinate {
      background-color: ${Sc};
    }

    @keyframes indeterminate-1 {
      0% {
        opacity: 1;
        transform: translateX(-100%);
      }
      70% {
        opacity: 1;
        transform: translateX(300%);
      }
      70.01% {
        opacity: 0;
      }
      100% {
        opacity: 0;
        transform: translateX(300%);
      }
    }

    @keyframes indeterminate-2 {
      0% {
        opacity: 0;
        transform: translateX(-150%);
      }
      29.99% {
        opacity: 0;
      }
      30% {
        opacity: 1;
        transform: translateX(-150%);
      }
      100% {
        transform: translateX(166.66%);
        opacity: 1;
      }
    }
  `.withBehaviors(lh(ih`
        .indeterminate-indicator-1,
        .indeterminate-indicator-2,
        .determinate,
        .progress {
          background-color: ${dh.ButtonText};
        }
        :host(.paused) .indeterminate-indicator-1,
        :host(.paused) .indeterminate-indicator-2,
        :host(.paused) .determinate {
          background-color: ${dh.GrayText};
        }
      `)),indeterminateIndicator1:'\n    <span class="indeterminate-indicator-1" part="indeterminate-indicator-1"></span>\n  ',indeterminateIndicator2:'\n    <span class="indeterminate-indicator-2" part="indeterminate-indicator-2"></span>\n  '});class iu{}Ms([Os({attribute:"aria-atomic"})],iu.prototype,"ariaAtomic",void 0),Ms([Os({attribute:"aria-busy"})],iu.prototype,"ariaBusy",void 0),Ms([Os({attribute:"aria-controls"})],iu.prototype,"ariaControls",void 0),Ms([Os({attribute:"aria-current"})],iu.prototype,"ariaCurrent",void 0),Ms([Os({attribute:"aria-describedby"})],iu.prototype,"ariaDescribedby",void 0),Ms([Os({attribute:"aria-details"})],iu.prototype,"ariaDetails",void 0),Ms([Os({attribute:"aria-disabled"})],iu.prototype,"ariaDisabled",void 0),Ms([Os({attribute:"aria-errormessage"})],iu.prototype,"ariaErrormessage",void 0),Ms([Os({attribute:"aria-flowto"})],iu.prototype,"ariaFlowto",void 0),Ms([Os({attribute:"aria-haspopup"})],iu.prototype,"ariaHaspopup",void 0),Ms([Os({attribute:"aria-hidden"})],iu.prototype,"ariaHidden",void 0),Ms([Os({attribute:"aria-invalid"})],iu.prototype,"ariaInvalid",void 0),Ms([Os({attribute:"aria-keyshortcuts"})],iu.prototype,"ariaKeyshortcuts",void 0),Ms([Os({attribute:"aria-label"})],iu.prototype,"ariaLabel",void 0),Ms([Os({attribute:"aria-labelledby"})],iu.prototype,"ariaLabelledby",void 0),Ms([Os({attribute:"aria-live"})],iu.prototype,"ariaLive",void 0),Ms([Os({attribute:"aria-owns"})],iu.prototype,"ariaOwns",void 0),Ms([Os({attribute:"aria-relevant"})],iu.prototype,"ariaRelevant",void 0),Ms([Os({attribute:"aria-roledescription"})],iu.prototype,"ariaRoledescription",void 0);class ou{constructor(e,t){this.target=e,this.propertyName=t}bind(e){e[this.propertyName]=this.target}unbind(){}}function su(e){return new ur("fast-ref",ou,e)}class nu{handleStartContentChange(){this.startContainer.classList.toggle("start",this.start.assignedNodes().length>0)}handleEndContentChange(){this.endContainer.classList.toggle("end",this.end.assignedNodes().length>0)}}const ru=(e,t)=>Rr`
    <span
        part="end"
        ${su("endContainer")}
        class=${e=>t.end?"end":void 0}
    >
        <slot name="end" ${su("end")} @slotchange="${e=>e.handleEndContentChange()}">
            ${t.end||""}
        </slot>
    </span>
`,au=(e,t)=>Rr`
    <span
        part="start"
        ${su("startContainer")}
        class="${e=>t.start?"start":void 0}"
    >
        <slot
            name="start"
            ${su("start")}
            @slotchange="${e=>e.handleStartContentChange()}"
        >
            ${t.start||""}
        </slot>
    </span>
`,lu=Rr`
    <span part="end" ${su("endContainer")}>
        <slot
            name="end"
            ${su("end")}
            @slotchange="${e=>e.handleEndContentChange()}"
        ></slot>
    </span>
`,du=Rr`
    <span part="start" ${su("startContainer")}>
        <slot
            name="start"
            ${su("start")}
            @slotchange="${e=>e.handleStartContentChange()}"
        ></slot>
    </span>
`;function cu(e,...t){const i=Ds.locate(e);t.forEach((t=>{Object.getOwnPropertyNames(t.prototype).forEach((i=>{"constructor"!==i&&Object.defineProperty(e.prototype,i,Object.getOwnPropertyDescriptor(t.prototype,i))})),Ds.locate(t).forEach((e=>i.push(e)))}))}var hu;!function(e){e[e.alt=18]="alt",e[e.arrowDown=40]="arrowDown",e[e.arrowLeft=37]="arrowLeft",e[e.arrowRight=39]="arrowRight",e[e.arrowUp=38]="arrowUp",e[e.back=8]="back",e[e.backSlash=220]="backSlash",e[e.break=19]="break",e[e.capsLock=20]="capsLock",e[e.closeBracket=221]="closeBracket",e[e.colon=186]="colon",e[e.colon2=59]="colon2",e[e.comma=188]="comma",e[e.ctrl=17]="ctrl",e[e.delete=46]="delete",e[e.end=35]="end",e[e.enter=13]="enter",e[e.equals=187]="equals",e[e.equals2=61]="equals2",e[e.equals3=107]="equals3",e[e.escape=27]="escape",e[e.forwardSlash=191]="forwardSlash",e[e.function1=112]="function1",e[e.function10=121]="function10",e[e.function11=122]="function11",e[e.function12=123]="function12",e[e.function2=113]="function2",e[e.function3=114]="function3",e[e.function4=115]="function4",e[e.function5=116]="function5",e[e.function6=117]="function6",e[e.function7=118]="function7",e[e.function8=119]="function8",e[e.function9=120]="function9",e[e.home=36]="home",e[e.insert=45]="insert",e[e.menu=93]="menu",e[e.minus=189]="minus",e[e.minus2=109]="minus2",e[e.numLock=144]="numLock",e[e.numPad0=96]="numPad0",e[e.numPad1=97]="numPad1",e[e.numPad2=98]="numPad2",e[e.numPad3=99]="numPad3",e[e.numPad4=100]="numPad4",e[e.numPad5=101]="numPad5",e[e.numPad6=102]="numPad6",e[e.numPad7=103]="numPad7",e[e.numPad8=104]="numPad8",e[e.numPad9=105]="numPad9",e[e.numPadDivide=111]="numPadDivide",e[e.numPadDot=110]="numPadDot",e[e.numPadMinus=109]="numPadMinus",e[e.numPadMultiply=106]="numPadMultiply",e[e.numPadPlus=107]="numPadPlus",e[e.openBracket=219]="openBracket",e[e.pageDown=34]="pageDown",e[e.pageUp=33]="pageUp",e[e.period=190]="period",e[e.print=44]="print",e[e.quote=222]="quote",e[e.scrollLock=145]="scrollLock",e[e.shift=16]="shift",e[e.space=32]="space",e[e.tab=9]="tab",e[e.tilde=192]="tilde",e[e.windowsLeft=91]="windowsLeft",e[e.windowsOpera=219]="windowsOpera",e[e.windowsRight=92]="windowsRight"}(hu||(hu={}));const uu="ArrowDown",pu="ArrowLeft",gu="ArrowRight",fu="ArrowUp",vu="Enter",mu="Escape",bu="Home",yu="End",wu=" ",xu="Tab",ku={ArrowDown:uu,ArrowLeft:pu,ArrowRight:gu,ArrowUp:fu},Cu="form-associated-proxy",$u="ElementInternals",Su=$u in window&&"setFormValue"in window[$u].prototype,_u=new WeakMap;function Iu(e){const t=class extends e{constructor(...e){super(...e),this.dirtyValue=!1,this.disabled=!1,this.proxyEventsToBlock=["change","click"],this.proxyInitialized=!1,this.required=!1,this.initialValue=this.initialValue||"",this.elementInternals||(this.formResetCallback=this.formResetCallback.bind(this))}static get formAssociated(){return Su}get validity(){return this.elementInternals?this.elementInternals.validity:this.proxy.validity}get form(){return this.elementInternals?this.elementInternals.form:this.proxy.form}get validationMessage(){return this.elementInternals?this.elementInternals.validationMessage:this.proxy.validationMessage}get willValidate(){return this.elementInternals?this.elementInternals.willValidate:this.proxy.willValidate}get labels(){if(this.elementInternals)return Object.freeze(Array.from(this.elementInternals.labels));if(this.proxy instanceof HTMLElement&&this.proxy.ownerDocument&&this.id){const e=this.proxy.labels,t=Array.from(this.proxy.getRootNode().querySelectorAll(`[for='${this.id}']`)),i=e?t.concat(Array.from(e)):t;return Object.freeze(i)}return ns}valueChanged(e,t){this.dirtyValue=!0,this.proxy instanceof HTMLElement&&(this.proxy.value=this.value),this.currentValue=this.value,this.setFormValue(this.value),this.validate()}currentValueChanged(){this.value=this.currentValue}initialValueChanged(e,t){this.dirtyValue||(this.value=this.initialValue,this.dirtyValue=!1)}disabledChanged(e,t){this.proxy instanceof HTMLElement&&(this.proxy.disabled=this.disabled),ps.queueUpdate((()=>this.classList.toggle("disabled",this.disabled)))}nameChanged(e,t){this.proxy instanceof HTMLElement&&(this.proxy.name=this.name)}requiredChanged(e,t){this.proxy instanceof HTMLElement&&(this.proxy.required=this.required),ps.queueUpdate((()=>this.classList.toggle("required",this.required))),this.validate()}get elementInternals(){if(!Su)return null;let e=_u.get(this);return e||(e=this.attachInternals(),_u.set(this,e)),e}connectedCallback(){super.connectedCallback(),this.addEventListener("keypress",this._keypressHandler),this.value||(this.value=this.initialValue,this.dirtyValue=!1),this.elementInternals||(this.attachProxy(),this.form&&this.form.addEventListener("reset",this.formResetCallback))}disconnectedCallback(){this.proxyEventsToBlock.forEach((e=>this.proxy.removeEventListener(e,this.stopPropagation))),!this.elementInternals&&this.form&&this.form.removeEventListener("reset",this.formResetCallback)}checkValidity(){return this.elementInternals?this.elementInternals.checkValidity():this.proxy.checkValidity()}reportValidity(){return this.elementInternals?this.elementInternals.reportValidity():this.proxy.reportValidity()}setValidity(e,t,i){this.elementInternals?this.elementInternals.setValidity(e,t,i):"string"==typeof t&&this.proxy.setCustomValidity(t)}formDisabledCallback(e){this.disabled=e}formResetCallback(){this.value=this.initialValue,this.dirtyValue=!1}attachProxy(){var e;this.proxyInitialized||(this.proxyInitialized=!0,this.proxy.style.display="none",this.proxyEventsToBlock.forEach((e=>this.proxy.addEventListener(e,this.stopPropagation))),this.proxy.disabled=this.disabled,this.proxy.required=this.required,"string"==typeof this.name&&(this.proxy.name=this.name),"string"==typeof this.value&&(this.proxy.value=this.value),this.proxy.setAttribute("slot",Cu),this.proxySlot=document.createElement("slot"),this.proxySlot.setAttribute("name",Cu)),null===(e=this.shadowRoot)||void 0===e||e.appendChild(this.proxySlot),this.appendChild(this.proxy)}detachProxy(){var e;this.removeChild(this.proxy),null===(e=this.shadowRoot)||void 0===e||e.removeChild(this.proxySlot)}validate(e){this.proxy instanceof HTMLElement&&this.setValidity(this.proxy.validity,this.proxy.validationMessage,e)}setFormValue(e,t){this.elementInternals&&this.elementInternals.setFormValue(e,t||e)}_keypressHandler(e){if(e.key===vu&&this.form instanceof HTMLFormElement){const e=this.form.querySelector("[type=submit]");null==e||e.click()}}stopPropagation(e){e.stopPropagation()}};return Os({mode:"boolean"})(t.prototype,"disabled"),Os({mode:"fromView",attribute:"value"})(t.prototype,"initialValue"),Os({attribute:"current-value"})(t.prototype,"currentValue"),Os(t.prototype,"name"),Os({mode:"boolean"})(t.prototype,"required"),ms(t.prototype,"value"),t}function Tu(e){class t extends(Iu(e)){}class i extends t{constructor(...e){super(e),this.dirtyChecked=!1,this.checkedAttribute=!1,this.checked=!1,this.dirtyChecked=!1}checkedAttributeChanged(){this.defaultChecked=this.checkedAttribute}defaultCheckedChanged(){this.dirtyChecked||(this.checked=this.defaultChecked,this.dirtyChecked=!1)}checkedChanged(e,t){this.dirtyChecked||(this.dirtyChecked=!0),this.currentChecked=this.checked,this.updateForm(),this.proxy instanceof HTMLInputElement&&(this.proxy.checked=this.checked),void 0!==e&&this.$emit("change"),this.validate()}currentCheckedChanged(e,t){this.checked=this.currentChecked}updateForm(){const e=this.checked?this.value:null;this.setFormValue(e,e)}connectedCallback(){super.connectedCallback(),this.updateForm()}formResetCallback(){super.formResetCallback(),this.checked=!!this.checkedAttribute,this.dirtyChecked=!1}}return Os({attribute:"checked",mode:"boolean"})(i.prototype,"checkedAttribute"),Os({attribute:"current-checked",converter:Ps})(i.prototype,"currentChecked"),ms(i.prototype,"defaultChecked"),ms(i.prototype,"checked"),i}class Du extends Ln{}class Pu extends(Iu(Du)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class Lu extends Pu{constructor(){super(...arguments),this.handleClick=e=>{var t;this.disabled&&(null===(t=this.defaultSlottedContent)||void 0===t?void 0:t.length)<=1&&e.stopPropagation()},this.handleSubmission=()=>{if(!this.form)return;const e=this.proxy.isConnected;e||this.attachProxy(),"function"==typeof this.form.requestSubmit?this.form.requestSubmit(this.proxy):this.proxy.click(),e||this.detachProxy()},this.handleFormReset=()=>{var e;null===(e=this.form)||void 0===e||e.reset()},this.handleUnsupportedDelegatesFocus=()=>{var e;window.ShadowRoot&&!window.ShadowRoot.prototype.hasOwnProperty("delegatesFocus")&&(null===(e=this.$fastController.definition.shadowOptions)||void 0===e?void 0:e.delegatesFocus)&&(this.focus=()=>{this.control.focus()})}}formactionChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.formAction=this.formaction)}formenctypeChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.formEnctype=this.formenctype)}formmethodChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.formMethod=this.formmethod)}formnovalidateChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.formNoValidate=this.formnovalidate)}formtargetChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.formTarget=this.formtarget)}typeChanged(e,t){this.proxy instanceof HTMLInputElement&&(this.proxy.type=this.type),"submit"===t&&this.addEventListener("click",this.handleSubmission),"submit"===e&&this.removeEventListener("click",this.handleSubmission),"reset"===t&&this.addEventListener("click",this.handleFormReset),"reset"===e&&this.removeEventListener("click",this.handleFormReset)}validate(){super.validate(this.control)}connectedCallback(){var e;super.connectedCallback(),this.proxy.setAttribute("type",this.type),this.handleUnsupportedDelegatesFocus();const t=Array.from(null===(e=this.control)||void 0===e?void 0:e.children);t&&t.forEach((e=>{e.addEventListener("click",this.handleClick)}))}disconnectedCallback(){var e;super.disconnectedCallback();const t=Array.from(null===(e=this.control)||void 0===e?void 0:e.children);t&&t.forEach((e=>{e.removeEventListener("click",this.handleClick)}))}}Ms([Os({mode:"boolean"})],Lu.prototype,"autofocus",void 0),Ms([Os({attribute:"form"})],Lu.prototype,"formId",void 0),Ms([Os],Lu.prototype,"formaction",void 0),Ms([Os],Lu.prototype,"formenctype",void 0),Ms([Os],Lu.prototype,"formmethod",void 0),Ms([Os({mode:"boolean"})],Lu.prototype,"formnovalidate",void 0),Ms([Os],Lu.prototype,"formtarget",void 0),Ms([Os],Lu.prototype,"type",void 0),Ms([ms],Lu.prototype,"defaultSlottedContent",void 0);class Eu{}function Ou(e){return e?function(t,i,o){return 1===t.nodeType&&t.matches(e)}:function(e,t,i){return 1===e.nodeType}}Ms([Os({attribute:"aria-expanded"})],Eu.prototype,"ariaExpanded",void 0),Ms([Os({attribute:"aria-pressed"})],Eu.prototype,"ariaPressed",void 0),cu(Eu,iu),cu(Lu,nu,Eu);class Fu{constructor(e,t){this.target=e,this.options=t,this.source=null}bind(e){const t=this.options.property;this.shouldUpdate=vs.getAccessors(e).some((e=>e.name===t)),this.source=e,this.updateTarget(this.computeNodes()),this.shouldUpdate&&this.observe()}unbind(){this.updateTarget(ns),this.source=null,this.shouldUpdate&&this.disconnect()}handleEvent(){this.updateTarget(this.computeNodes())}computeNodes(){let e=this.getNodes();return void 0!==this.options.filter&&(e=e.filter(this.options.filter)),e}updateTarget(e){this.source[this.options.property]=e}}class Au extends Fu{constructor(e,t){super(e,t)}observe(){this.target.addEventListener("slotchange",this)}disconnect(){this.target.removeEventListener("slotchange",this)}getNodes(){return this.target.assignedNodes(this.options)}}function Ru(e){return"string"==typeof e&&(e={property:e}),new ur("fast-slotted",Au,e)}const Vu="not-allowed";function Mu(...e){return e.every((e=>e instanceof HTMLElement))}let zu;const Nu=function(){if("boolean"==typeof zu)return zu;if("undefined"==typeof window||!window.document||!window.document.createElement)return zu=!1,zu;const e=document.createElement("style"),t=function(){const e=document.querySelector('meta[property="csp-nonce"]');return e?e.getAttribute("content"):null}();null!==t&&e.setAttribute("nonce",t),document.head.appendChild(e);try{e.sheet.insertRule("foo:focus-visible {color:inherit}",0),zu=!0}catch(e){zu=!1}finally{document.head.removeChild(e)}return zu}()?"focus-visible":"focus",Uu=sh`(${Oa} + ${Fa}) * ${Aa}`,Bu=sh`
  font-family: ${Na};
  font-size: ${Ha};
  line-height: ${ja};
  font-weight: initial;
  font-variation-settings: ${qa};
`,Hu=(sh`
  font-family: ${Na};
  font-size: ${Za};
  line-height: ${Wa};
  font-weight: initial;
  font-variation-settings: ${Ga};
`,sh`
  font-family: ${Na};
  font-size: ${Qa};
  line-height: ${Ka};
  font-weight: initial;
  font-variation-settings: ${Xa};
`,sh`
  font-family: ${Na};
  font-size: ${Ja};
  line-height: ${Ya};
  font-weight: initial;
  font-variation-settings: ${el};
`,sh`
  font-family: ${Na};
  font-size: ${tl};
  line-height: ${il};
  font-weight: initial;
  font-variation-settings: ${ol};
`,sh`
  font-family: ${Na};
  font-size: ${sl};
  line-height: ${nl};
  font-weight: initial;
  font-variation-settings: ${rl};
`,sh`
  font-family: ${Na};
  font-size: ${al};
  line-height: ${ll};
  font-weight: initial;
  font-variation-settings: ${dl};
`,sh`
  font-family: ${Na};
  font-size: ${cl};
  line-height: ${hl};
  font-weight: initial;
  font-variation-settings: ${ul};
`,sh`
  font-family: ${Na};
  font-size: ${pl};
  line-height: ${gl};
  font-weight: initial;
  font-variation-settings: ${fl};
`,sh`
  outline: calc(${za} * 1px) solid ${Zc};
  outline-offset: calc(${za} * -1px);
`),ju=sh`
  outline: calc(${za} * 1px) solid ${Zc};
  outline-offset: calc(${Ma} * 1px);
`,qu=(e,t,i,o="[disabled]")=>ih`
    .control {
      background: padding-box linear-gradient(${Qd}, ${Qd}),
        border-box ${Lc};
    }

    :host(${i}:hover) .control {
      background: padding-box linear-gradient(${Kd}, ${Kd}),
        border-box ${Ec};
    }

    :host(${i}:active) .control {
      background: padding-box linear-gradient(${Xd}, ${Xd}),
        border-box ${Oc};
    }

    :host(${o}) .control {
      background: padding-box linear-gradient(${Qd}, ${Qd}),
        border-box ${Ic};
    }
  `.withBehaviors(lh(ih`
        .control {
          background: ${dh.ButtonFace};
          border-color: ${dh.ButtonText};
          color: ${dh.ButtonText};
        }

        :host(${i}:hover) .control,
        :host(${i}:active) .control {
          forced-color-adjust: none;
          background: ${dh.HighlightText};
          border-color: ${dh.Highlight};
          color: ${dh.Highlight};
        }

        :host(${o}) .control {
          background: transparent;
          border-color: ${dh.GrayText};
          color: ${dh.GrayText};
        }

        .control:${Nu} {
          outline-color: ${dh.CanvasText};
        }

        :host([href]) .control {
          background: transparent;
          border-color: ${dh.LinkText};
          color: ${dh.LinkText};
        }

        :host([href]:hover) .control,
        :host([href]:active) .control {
          background: transparent;
          border-color: ${dh.CanvasText};
          color: ${dh.CanvasText};
        }
    `)),Zu=(e,t,i,o="[disabled]")=>ih`
    .control {
      background: ${fc};
    }

    :host(${i}:hover) .control {
      background: ${vc};
    }

    :host(${i}:active) .control {
      background: ${mc};
    }

    :host(${o}) .control {
      background: ${fc};
    }
  `.withBehaviors(lh(ih`
        .control {
          forced-color-adjust: none;
          background: transparent;
          color: ${dh.ButtonText};
        }

        :host(${i}:hover) .control,
        :host(${i}:active) .control {
          background: transparent;
          border-color: ${dh.ButtonText};
          color: ${dh.ButtonText};
        }

        :host(${o}) .control {
          background: transparent;
          color: ${dh.GrayText};
        }
        
        .control:${Nu} {
          outline-color: ${dh.CanvasText};
        }

        :host([href]) .control {
          color: ${dh.LinkText};
        }

        :host([href]:hover) .control,
        :host([href]:active) .control {
          background: transparent;
          border-color: ${dh.LinkText};
          color: ${dh.LinkText};
        }
      `));class Wu{constructor(e,t,i){this.propertyName=e,this.value=t,this.styles=i}bind(e){vs.getNotifier(e).subscribe(this,this.propertyName),this.handleChange(e,this.propertyName)}unbind(e){vs.getNotifier(e).unsubscribe(this,this.propertyName),e.$fastController.removeStyles(this.styles)}handleChange(e,t){e[t]===this.value?e.$fastController.addStyles(this.styles):e.$fastController.removeStyles(this.styles)}}function Gu(e,t){return new Wu("appearance",e,t)}const Qu=":not([disabled])",Ku="[disabled]";class Xu extends Lu{appearanceChanged(e,t){e!==t&&(this.classList.add(t),this.classList.remove(e))}connectedCallback(){super.connectedCallback(),this.appearance||(this.appearance="neutral")}defaultSlottedContentChanged(){const e=this.defaultSlottedContent.filter((e=>e.nodeType===Node.ELEMENT_NODE));1===e.length&&e[0]instanceof SVGElement?this.control.classList.add("icon-only"):this.control.classList.remove("icon-only")}}i([Os],Xu.prototype,"appearance",void 0);const Ju=Xu.compose({baseName:"button",baseClass:Lu,template:(e,t)=>Rr`
    <button
        class="control"
        part="control"
        ?autofocus="${e=>e.autofocus}"
        ?disabled="${e=>e.disabled}"
        form="${e=>e.formId}"
        formaction="${e=>e.formaction}"
        formenctype="${e=>e.formenctype}"
        formmethod="${e=>e.formmethod}"
        formnovalidate="${e=>e.formnovalidate}"
        formtarget="${e=>e.formtarget}"
        name="${e=>e.name}"
        type="${e=>e.type}"
        value="${e=>e.value}"
        aria-atomic="${e=>e.ariaAtomic}"
        aria-busy="${e=>e.ariaBusy}"
        aria-controls="${e=>e.ariaControls}"
        aria-current="${e=>e.ariaCurrent}"
        aria-describedby="${e=>e.ariaDescribedby}"
        aria-details="${e=>e.ariaDetails}"
        aria-disabled="${e=>e.ariaDisabled}"
        aria-errormessage="${e=>e.ariaErrormessage}"
        aria-expanded="${e=>e.ariaExpanded}"
        aria-flowto="${e=>e.ariaFlowto}"
        aria-haspopup="${e=>e.ariaHaspopup}"
        aria-hidden="${e=>e.ariaHidden}"
        aria-invalid="${e=>e.ariaInvalid}"
        aria-keyshortcuts="${e=>e.ariaKeyshortcuts}"
        aria-label="${e=>e.ariaLabel}"
        aria-labelledby="${e=>e.ariaLabelledby}"
        aria-live="${e=>e.ariaLive}"
        aria-owns="${e=>e.ariaOwns}"
        aria-pressed="${e=>e.ariaPressed}"
        aria-relevant="${e=>e.ariaRelevant}"
        aria-roledescription="${e=>e.ariaRoledescription}"
        ${su("control")}
    >
        ${au(0,t)}
        <span class="content" part="content">
            <slot ${Ru("defaultSlottedContent")}></slot>
        </span>
        ${ru(0,t)}
    </button>
`,styles:(e,t)=>ih`
    :host(${Qu}) .control {
      cursor: pointer;
    }

    :host(${Ku}) .control {
      cursor: ${Vu};
    }

    @media (forced-colors: none) {
      :host(${Ku}) .control {
        opacity: ${Ea};
      }
    }

    ${ih`
    ${nh("inline-flex")}
    
    :host {
      position: relative;
      box-sizing: border-box;
      ${Bu}
      height: calc(${Uu} * 1px);
      min-width: calc(${Uu} * 1px);
      color: ${xc};
      border-radius: calc(${Ra} * 1px);
      fill: currentcolor;
    }

    .control {
      border: calc(${Ma} * 1px) solid transparent;
      flex-grow: 1;
      box-sizing: border-box;
      display: inline-flex;
      justify-content: center;
      align-items: center;
      padding: 0 calc((10 + (${Aa} * 2 * ${Fa})) * 1px);
      white-space: nowrap;
      outline: none;
      text-decoration: none;
      color: inherit;
      border-radius: inherit;
      fill: inherit;
      font-family: inherit;
    }

    .control,
    .end,
    .start {
      font: inherit;
    }

    .control.icon-only {
      padding: 0;
      line-height: 0;
    }

    .control:${Nu} {
      ${Hu}
    }

    .control::-moz-focus-inner {
      border: 0;
    }

    .content {
      pointer-events: none;
    }

    .start,
    .end {
      display: flex;
      pointer-events: none;
    }

    .start {
      margin-inline-end: 11px;
    }

    .end {
      margin-inline-start: 11px;
    }
  `}
  `.withBehaviors(Gu("neutral",qu(0,0,Qu,Ku)),Gu("accent",((e,t,i,o="[disabled]")=>ih`
    .control {
      background: padding-box linear-gradient(${Dd}, ${Dd}),
        border-box ${jd};
      color: ${Fd};
    }

    :host(${i}:hover) .control {
      background: padding-box linear-gradient(${Pd}, ${Pd}),
        border-box ${qd};
      color: ${Ad};
    }

    :host(${i}:active) .control {
      background: padding-box linear-gradient(${Ld}, ${Ld}),
        border-box ${Zd};
      color: ${Rd};
    }

    :host(${o}) .control {
      background: ${Dd};
    }

    .control:${Nu} {
      box-shadow: 0 0 0 calc(${za} * 1px) ${Gc} inset !important;
    }
  `.withBehaviors(lh(ih`
        .control {
          forced-color-adjust: none;
          background: ${dh.Highlight};
          color: ${dh.HighlightText};
        }

        :host(${i}:hover) .control,
        :host(${i}:active) .control {
          background: ${dh.HighlightText};
          border-color: ${dh.Highlight};
          color: ${dh.Highlight};
        }

        :host(${o}) .control {
          background: transparent;
          border-color: ${dh.GrayText};
          color: ${dh.GrayText};
        }

        .control:${Nu} {
          outline-color: ${dh.CanvasText};
          box-shadow: 0 0 0 calc(${za} * 1px) ${dh.HighlightText} inset !important;
        }

        :host([href]) .control {
          background: ${dh.LinkText};
          color: ${dh.HighlightText};
        }

        :host([href]:hover) .control,
        :host([href]:active) .control {
          background: ${dh.ButtonFace};
          border-color: ${dh.LinkText};
          color: ${dh.LinkText};
        }
      `)))(0,0,Qu,Ku)),Gu("lightweight",((e,t,i,o="[disabled]")=>ih`
    :host {
      color: ${zd};
    }

    .control {
      background: ${fc};
    }

    :host(${i}:hover) .control {
      background: ${vc};
      color: ${Nd};
    }

    :host(${i}:active) .control {
      background: ${mc};
      color: ${Ud};
    }

    :host(${o}) .control {
      background: ${fc};
    }
  `.withBehaviors(lh(ih`
        :host {
          color: ${dh.ButtonText};
        }

        .control {
          forced-color-adjust: none;
          background: transparent;
        }

        :host(${i}:hover) .control,
        :host(${i}:active) .control {
          background: transparent;
          border-color: ${dh.ButtonText};
          color: ${dh.ButtonText};
        }

        :host(${o}) .control {
          background: transparent;
          color: ${dh.GrayText};
        }

        .control:${Nu} {
          outline-color: ${dh.CanvasText};
        }

        :host([href]) .control {
          color: ${dh.LinkText};
        }

        :host([href]:hover) .control,
        :host([href]:active) .control {
          border-color: ${dh.LinkText};
          color: ${dh.LinkText};
        }
      `)))(0,0,Qu,Ku)),Gu("outline",((e,t,i,o="[disabled]")=>ih`
    .control {
      background: transparent !important;
      border-color: ${Ic};
    }

    :host(${i}:hover) .control {
      border-color: ${Tc};
    }

    :host(${i}:active) .control {
      border-color: ${Dc};
    }

    :host(${o}) .control {
      background: transparent !important;
      border-color: ${Ic};
    }
  `.withBehaviors(lh(ih`
        .control {
          border-color: ${dh.ButtonText};
          color: ${dh.ButtonText};
        }

        :host(${i}:hover) .control,
        :host(${i}:active) .control {
          background: ${dh.HighlightText};
          border-color: ${dh.Highlight};
          color: ${dh.Highlight};
        }

        :host(${o}) .control {
          border-color: ${dh.GrayText};
          color: ${dh.GrayText};
        }

        .control:${Nu} {
          outline-color: ${dh.CanvasText};
        }

        :host([href]) .control {
          border-color: ${dh.LinkText};
          color: ${dh.LinkText};
        }

        :host([href]:hover) .control,
        :host([href]:active) .control {
          border-color: ${dh.CanvasText};
          color: ${dh.CanvasText};
        }
      `)))(0,0,Qu,Ku)),Gu("stealth",Zu(0,0,Qu,Ku))),shadowOptions:{delegatesFocus:!0}});class Yu extends Ln{}class ep extends(Tu(Yu)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class tp extends ep{constructor(){super(),this.initialValue="on",this.indeterminate=!1,this.keypressHandler=e=>{this.readOnly||e.key!==wu||(this.indeterminate&&(this.indeterminate=!1),this.checked=!this.checked)},this.clickHandler=e=>{this.disabled||this.readOnly||(this.indeterminate&&(this.indeterminate=!1),this.checked=!this.checked)},this.proxy.setAttribute("type","checkbox")}readOnlyChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.readOnly=this.readOnly)}}Ms([Os({attribute:"readonly",mode:"boolean"})],tp.prototype,"readOnly",void 0),Ms([ms],tp.prototype,"defaultSlottedNodes",void 0),Ms([ms],tp.prototype,"indeterminate",void 0);const ip=tp.compose({baseName:"checkbox",template:(e,t)=>Rr`
    <template
        role="checkbox"
        aria-checked="${e=>e.checked}"
        aria-required="${e=>e.required}"
        aria-disabled="${e=>e.disabled}"
        aria-readonly="${e=>e.readOnly}"
        tabindex="${e=>e.disabled?null:0}"
        @keypress="${(e,t)=>e.keypressHandler(t.event)}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        class="${e=>e.readOnly?"readonly":""} ${e=>e.checked?"checked":""} ${e=>e.indeterminate?"indeterminate":""}"
    >
        <div part="control" class="control">
            <slot name="checked-indicator">
                ${t.checkedIndicator||""}
            </slot>
            <slot name="indeterminate-indicator">
                ${t.indeterminateIndicator||""}
            </slot>
        </div>
        <label
            part="label"
            class="${e=>e.defaultSlottedNodes&&e.defaultSlottedNodes.length?"label":"label label__hidden"}"
        >
            <slot ${Ru("defaultSlottedNodes")}></slot>
        </label>
    </template>
`,styles:(e,t)=>ih`
    ${nh("inline-flex")} :host {
      align-items: center;
      outline: none;
      ${""} user-select: none;
    }

    .control {
      position: relative;
      width: calc((${Uu} / 2 + ${Aa}) * 1px);
      height: calc((${Uu} / 2 + ${Aa}) * 1px);
      box-sizing: border-box;
      border-radius: calc(${Ra} * 1px);
      border: calc(${Ma} * 1px) solid ${Bc};
      background: ${oc};
      cursor: pointer;
    }

    .label__hidden {
      display: none;
      visibility: hidden;
    }

    .label {
      ${Bu}
      color: ${xc};
      ${""} padding-inline-start: calc(${Aa} * 2px + 2px);
      margin-inline-end: calc(${Aa} * 2px + 2px);
      cursor: pointer;
    }

    slot[name='checked-indicator'],
    slot[name='indeterminate-indicator'] {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      fill: ${xc};
      opacity: 0;
      pointer-events: none;
    }

    slot[name='indeterminate-indicator'] {
      position: absolute;
      top: 0;
    }

    :host(.checked) slot[name='checked-indicator'],
    :host(.checked) slot[name='indeterminate-indicator'] {
      fill: ${Fd};
    }

    :host(:not(.disabled):hover) .control {
      background: ${sc};
      border-color: ${Hc};
    }

    :host(:not(.disabled):active) .control {
      background: ${nc};
      border-color: ${jc};
    }

    :host(:${Nu}) .control {
      background: ${rc};
      ${ju}
    }

    :host(.checked) .control {
      background: ${Dd};
      border-color: transparent;
    }

    :host(.checked:not(.disabled):hover) .control {
      background: ${Pd};
      border-color: transparent;
    }

    :host(.checked:not(.disabled):active) .control {
      background: ${Ld};
      border-color: transparent;
    }

    :host(.disabled) .label,
    :host(.readonly) .label,
    :host(.readonly) .control,
    :host(.disabled) .control {
      cursor: ${Vu};
    }

    :host(.checked:not(.indeterminate)) slot[name='checked-indicator'],
    :host(.indeterminate) slot[name='indeterminate-indicator'] {
      opacity: 1;
    }

    :host(.disabled) {
      opacity: ${Ea};
    }
  `.withBehaviors(lh(ih`
        .control {
          border-color: ${dh.FieldText};
          background: ${dh.Field};
        }
        :host(:not(.disabled):hover) .control,
        :host(:not(.disabled):active) .control {
          border-color: ${dh.Highlight};
          background: ${dh.Field};
        }
        slot[name='checked-indicator'],
        slot[name='indeterminate-indicator'] {
          fill: ${dh.FieldText};
        }
        :host(:${Nu}) .control {
          forced-color-adjust: none;
          outline-color: ${dh.FieldText};
          background: ${dh.Field};
          border-color: ${dh.Highlight};
        }
        :host(.checked) .control {
          background: ${dh.Highlight};
          border-color: ${dh.Highlight};
        }
        :host(.checked:not(.disabled):hover) .control,
        :host(.checked:not(.disabled):active) .control {
          background: ${dh.HighlightText};
          border-color: ${dh.Highlight};
        }
        :host(.checked) slot[name='checked-indicator'],
        :host(.checked) slot[name='indeterminate-indicator'] {
          fill: ${dh.HighlightText};
        }
        :host(.checked:hover ) .control slot[name='checked-indicator'],
        :host(.checked:hover ) .control slot[name='indeterminate-indicator'] {
          fill: ${dh.Highlight};
        }
        :host(.disabled) {
          opacity: 1;
        }
        :host(.disabled) .control {
          border-color: ${dh.GrayText};
          background: ${dh.Field};
        }
        :host(.disabled) slot[name='checked-indicator'],
        :host(.checked.disabled:hover) .control slot[name='checked-indicator'],
        :host(.disabled) slot[name='indeterminate-indicator'],
        :host(.checked.disabled:hover) .control slot[name='indeterminate-indicator'] {
          fill: ${dh.GrayText};
        }
      `)),checkedIndicator:'\n    <svg width="16" height="16" xmlns="http://www.w3.org/2000/svg">\n      <path d="M13.86 3.66a.5.5 0 01-.02.7l-7.93 7.48a.6.6 0 01-.84-.02L2.4 9.1a.5.5 0 01.72-.7l2.4 2.44 7.65-7.2a.5.5 0 01.7.02z"/>\n    </svg>\n  ',indeterminateIndicator:'\n    <svg width="16" height="16" xmlns="http://www.w3.org/2000/svg">\n      <path d="M3 8c0-.28.22-.5.5-.5h9a.5.5 0 010 1h-9A.5.5 0 013 8z"/>\n    </svg>\n  '});var op=["input","select","textarea","a[href]","button","[tabindex]:not(slot)","audio[controls]","video[controls]",'[contenteditable]:not([contenteditable="false"])',"details>summary:first-of-type","details"].join(","),sp="undefined"==typeof Element,np=sp?function(){}:Element.prototype.matches||Element.prototype.msMatchesSelector||Element.prototype.webkitMatchesSelector,rp=!sp&&Element.prototype.getRootNode?function(e){return e.getRootNode()}:function(e){return e.ownerDocument},ap=function(e){return"INPUT"===e.tagName},lp=function(e){var t=e.getBoundingClientRect(),i=t.width,o=t.height;return 0===i&&0===o},dp=function(e,t){return!(function(e){return function(e){return ap(e)&&"radio"===e.type}(e)&&!function(e){if(!e.name)return!0;var t,i=e.form||rp(e),o=function(e){return i.querySelectorAll('input[type="radio"][name="'+e+'"]')};if("undefined"!=typeof window&&void 0!==window.CSS&&"function"==typeof window.CSS.escape)t=o(window.CSS.escape(e.name));else try{t=o(e.name)}catch(e){return console.error("Looks like you have a radio button with a name attribute containing invalid CSS selector characters and need the CSS.escape polyfill: %s",e.message),!1}var s=function(e,t){for(var i=0;i<e.length;i++)if(e[i].checked&&e[i].form===t)return e[i]}(t,e.form);return!s||s===e}(e)}(t)||function(e,t){return e.tabIndex<0&&(t||/^(AUDIO|VIDEO|DETAILS)$/.test(e.tagName)||e.isContentEditable)&&isNaN(parseInt(e.getAttribute("tabindex"),10))?0:e.tabIndex}(t)<0||!function(e,t){return!(t.disabled||function(e){return ap(e)&&"hidden"===e.type}(t)||function(e,t){var i=t.displayCheck,o=t.getShadowRoot;if("hidden"===getComputedStyle(e).visibility)return!0;var s=np.call(e,"details>summary:first-of-type")?e.parentElement:e;if(np.call(s,"details:not([open]) *"))return!0;var n=rp(e).host,r=(null==n?void 0:n.ownerDocument.contains(n))||e.ownerDocument.contains(e);if(i&&"full"!==i){if("non-zero-area"===i)return lp(e)}else{if("function"==typeof o){for(var a=e;e;){var l=e.parentElement,d=rp(e);if(l&&!l.shadowRoot&&!0===o(l))return lp(e);e=e.assignedSlot?e.assignedSlot:l||d===e.ownerDocument?l:d.host}e=a}if(r)return!e.getClientRects().length}return!1}(t,e)||function(e){return"DETAILS"===e.tagName&&Array.prototype.slice.apply(e.children).some((function(e){return"SUMMARY"===e.tagName}))}(t)||function(e){if(/^(INPUT|BUTTON|SELECT|TEXTAREA)$/.test(e.tagName))for(var t=e.parentElement;t;){if("FIELDSET"===t.tagName&&t.disabled){for(var i=0;i<t.children.length;i++){var o=t.children.item(i);if("LEGEND"===o.tagName)return!!np.call(t,"fieldset[disabled] *")||!o.contains(e)}return!0}t=t.parentElement}return!1}(t))}(e,t))},cp=function(e,t){if(t=t||{},!e)throw new Error("No node provided");return!1!==np.call(e,op)&&dp(t,e)};class hp extends Ln{constructor(){super(...arguments),this.modal=!0,this.hidden=!1,this.trapFocus=!0,this.trapFocusChanged=()=>{this.$fastController.isConnected&&this.updateTrapFocus()},this.isTrappingFocus=!1,this.handleDocumentKeydown=e=>{if(!e.defaultPrevented&&!this.hidden)switch(e.key){case mu:this.dismiss(),e.preventDefault();break;case xu:this.handleTabKeyDown(e)}},this.handleDocumentFocus=e=>{!e.defaultPrevented&&this.shouldForceFocus(e.target)&&(this.focusFirstElement(),e.preventDefault())},this.handleTabKeyDown=e=>{if(!this.trapFocus||this.hidden)return;const t=this.getTabQueueBounds();return 0!==t.length?1===t.length?(t[0].focus(),void e.preventDefault()):void(e.shiftKey&&e.target===t[0]?(t[t.length-1].focus(),e.preventDefault()):e.shiftKey||e.target!==t[t.length-1]||(t[0].focus(),e.preventDefault())):void 0},this.getTabQueueBounds=()=>hp.reduceTabbableItems([],this),this.focusFirstElement=()=>{const e=this.getTabQueueBounds();e.length>0?e[0].focus():this.dialog instanceof HTMLElement&&this.dialog.focus()},this.shouldForceFocus=e=>this.isTrappingFocus&&!this.contains(e),this.shouldTrapFocus=()=>this.trapFocus&&!this.hidden,this.updateTrapFocus=e=>{const t=void 0===e?this.shouldTrapFocus():e;t&&!this.isTrappingFocus?(this.isTrappingFocus=!0,document.addEventListener("focusin",this.handleDocumentFocus),ps.queueUpdate((()=>{this.shouldForceFocus(document.activeElement)&&this.focusFirstElement()}))):!t&&this.isTrappingFocus&&(this.isTrappingFocus=!1,document.removeEventListener("focusin",this.handleDocumentFocus))}}dismiss(){this.$emit("dismiss"),this.$emit("cancel")}show(){this.hidden=!1}hide(){this.hidden=!0,this.$emit("close")}connectedCallback(){super.connectedCallback(),document.addEventListener("keydown",this.handleDocumentKeydown),this.notifier=vs.getNotifier(this),this.notifier.subscribe(this,"hidden"),this.updateTrapFocus()}disconnectedCallback(){super.disconnectedCallback(),document.removeEventListener("keydown",this.handleDocumentKeydown),this.updateTrapFocus(!1),this.notifier.unsubscribe(this,"hidden")}handleChange(e,t){"hidden"===t&&this.updateTrapFocus()}static reduceTabbableItems(e,t){return"-1"===t.getAttribute("tabindex")?e:cp(t)||hp.isFocusableFastElement(t)&&hp.hasTabbableShadow(t)?(e.push(t),e):t.childElementCount?e.concat(Array.from(t.children).reduce(hp.reduceTabbableItems,[])):e}static isFocusableFastElement(e){var t,i;return!!(null===(i=null===(t=e.$fastController)||void 0===t?void 0:t.definition.shadowOptions)||void 0===i?void 0:i.delegatesFocus)}static hasTabbableShadow(e){var t,i;return Array.from(null!==(i=null===(t=e.shadowRoot)||void 0===t?void 0:t.querySelectorAll("*"))&&void 0!==i?i:[]).some((e=>cp(e)))}}Ms([Os({mode:"boolean"})],hp.prototype,"modal",void 0),Ms([Os({mode:"boolean"})],hp.prototype,"hidden",void 0),Ms([Os({attribute:"trap-focus",mode:"boolean"})],hp.prototype,"trapFocus",void 0),Ms([Os({attribute:"aria-describedby"})],hp.prototype,"ariaDescribedby",void 0),Ms([Os({attribute:"aria-labelledby"})],hp.prototype,"ariaLabelledby",void 0),Ms([Os({attribute:"aria-label"})],hp.prototype,"ariaLabel",void 0);const up=hp.compose({baseName:"dialog",template:(e,t)=>Rr`
    <div class="positioning-region" part="positioning-region">
        ${eu((e=>e.modal),Rr`
                <div
                    class="overlay"
                    part="overlay"
                    role="presentation"
                    @click="${e=>e.dismiss()}"
                ></div>
            `)}
        <div
            role="dialog"
            tabindex="-1"
            class="control"
            part="control"
            aria-modal="${e=>e.modal}"
            aria-describedby="${e=>e.ariaDescribedby}"
            aria-labelledby="${e=>e.ariaLabelledby}"
            aria-label="${e=>e.ariaLabel}"
            ${su("dialog")}
        >
            <slot></slot>
        </div>
    </div>
`,styles:(e,t)=>ih`
  :host([hidden]) {
    display: none;
  }

  :host {
    --dialog-height: 480px;
    --dialog-width: 640px;
    display: block;
  }

  .overlay {
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background: rgba(0, 0, 0, 0.3);
    touch-action: none;
  }

  .positioning-region {
    display: flex;
    justify-content: center;
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    overflow: auto;
  }

  .control {
    box-shadow: ${kh};
    margin-top: auto;
    margin-bottom: auto;
    border-radius: calc(${Va} * 1px);
    width: var(--dialog-width);
    height: var(--dialog-height);
    background: ${_d};
    z-index: 1;
    border: calc(${Ma} * 1px) solid transparent;
  }
`}),pp=[be`
:host .file-upload-area-button{width:auto;display:flex;align-items:end;justify-content:end;margin-inline-end:36px;margin-top:30px}:host fluent-button .upload-icon path{fill:var(--file-upload-button-text-color,var(--foreground-on-accent-rest))}:host fluent-button.file-upload-button::part(control){border:var(--file-upload-button-border,none);background:var(--file-upload-button-background-color,var(--accent-fill-rest))}:host fluent-button.file-upload-button::part(control):hover{background:var(--file-upload-button-background-color-hover,var(--accent-fill-hover))}:host fluent-button.file-upload-button .upload-text{color:var(--file-upload-button-text-color,var(--foreground-on-accent-rest));font-weight:400;line-height:20px}:host input{display:none}:host fluent-progress.file-upload-bar{width:180px;margin-top:10px}:host fluent-dialog::part(overlay){opacity:.5}:host fluent-dialog::part(control){--dialog-width:$file-upload-dialog-width;--dialog-height:$file-upload-dialog-height;padding:var(--file-upload-dialog-padding,24px);border:var(--file-upload-dialog-border,1px solid var(--neutral-fill-rest))}:host fluent-dialog .file-upload-dialog-ok{background:var(--file-upload-dialog-keep-both-button-background-color,var(--accent-fill-rest));border:var(--file-upload-dialog-keep-both-button-border,none);color:var(--file-upload-dialog-keep-both-button-text-color,var(--foreground-on-accent-rest))}:host fluent-dialog .file-upload-dialog-ok:hover{background:var(--file-upload-dialog-keep-both-button-background-color-hover,var(--accent-fill-hover))}:host fluent-dialog .file-upload-dialog-cancel{background:var(--file-upload-dialog-replace-button-background-color,var(--accent-fill-rest));border:var(--file-upload-dialog-replace-button-border,1px solid var(--neutral-foreground-rest));color:var(--file-upload-dialog-replace-button-text-color,var(--neutral-foreground-rest))}:host fluent-dialog .file-upload-dialog-cancel:hover{background:var(--file-upload-dialog-replace-button-background-color-hover,var(--accent-fill-hover))}:host fluent-checkbox{margin-top:12px}:host fluent-checkbox .file-upload-dialog-check{color:var(--file-upload-dialog-text-color,--foreground-on-accent-rest)}:host .file-upload-table{display:flex}:host .file-upload-table.upload{display:flex}:host .file-upload-table .file-upload-cell{padding:1px 0 1px 1px;display:table-cell;vertical-align:middle;position:relative}:host .file-upload-table .file-upload-cell.percent-indicator{padding-inline-start:10px}:host .file-upload-table .file-upload-cell .description{opacity:.5;position:relative}:host .file-upload-table .file-upload-cell .file-upload-filename{max-width:250px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}:host .file-upload-table .file-upload-cell .file-upload-status{position:absolute;left:28px}:host .file-upload-table .file-upload-cell .file-upload-cancel{cursor:pointer;margin-inline-start:20px}:host .file-upload-table .file-upload-cell .file-upload-name{width:auto}:host .file-upload-table .file-upload-cell .cancel-icon{fill:var(--file-upload-dialog-text-color,var(--neutral-foreground-rest))}:host .mgt-file-item{--file-background-color:transparent;--file-padding:0 12px;--file-padding-inline-start:24px}:host .file-upload-template{clear:both}:host .file-upload-template .file-upload-folder-tab{padding-inline-start:20px}:host .file-upload-dialog{display:none}:host .file-upload-dialog .file-upload-dialog-content{background-color:var(--file-upload-dialog-background-color,var(--accent-fill-rest));color:var(--file-upload-dialog-text-color,var(--neutral-foreground-rest))}:host .file-upload-dialog .file-upload-dialog-content-text{margin-bottom:36px}:host .file-upload-dialog .file-upload-dialog-title{margin-top:0}:host .file-upload-dialog .file-upload-dialog-editor{display:flex;align-items:end;justify-content:end;gap:5px}:host .file-upload-dialog .file-upload-dialog-close{float:right;cursor:pointer}:host .file-upload-dialog .file-upload-dialog-close svg{fill:var(--file-upload-dialog-text-color,var(--neutral-foreground-rest));padding-right:5px}:host .file-upload-dialog.visible{display:block}:host fluent-checkbox.file-upload-dialog-check.hide{display:none}:host .file-upload-dialog-success{cursor:pointer;opacity:.5}:host #file-upload-border{display:none}:host #file-upload-border.visible{border:var(--file-upload-border-drag,1px dashed #0078d4);background-color:var(--file-upload-background-color-drag,rgba(0,120,212,.1));position:absolute;inset:0;z-index:1;display:inline-block}[dir=rtl] :host .file-upload-status{left:0;right:28px}
`],gp={failUploadFile:"File upload fail.",cancelUploadFile:"File cancel.",buttonUploadFile:"Upload Files",maximumFilesTitle:"Maximum files",maximumFiles:"Sorry, the maximum number of files you can upload at once is {MaxNumber}. Do you want to upload the first {MaxNumber} files or reselect?",maximumFileSizeTitle:"Maximum files size",maximumFileSize:'Sorry, the maximum file size to upload is {FileSize}. The file "{FileName}" has ',fileTypeTitle:"File type",fileType:'Sorry, the format of following file "{FileName}" cannot be uploaded.',checkAgain:"Don't show again",checkApplyAll:"Apply to all",buttonOk:"OK",buttonCancel:"Cancel",buttonUpload:"Upload",buttonKeep:"Keep both",buttonReplace:"Replace",buttonReselect:"Reselect",fileReplaceTitle:"Replace file",fileReplace:'Do you want to replace the file "{FileName}" or keep both files?',uploadButtonLabel:"File upload button"};var fp=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},vp=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},mp=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(tu,Ju,ip,up);const bp=e=>e.isDirectory,yp=e=>"getAsEntry"in e&&"function"==typeof e.getAsEntry;let wp=class extends Pt{static get styles(){return pp}get strings(){return gp}static get requiredScopes(){return[...new Set(["files.readwrite","files.readwrite.all","sites.readwrite.all"])]}get _dropEffect(){return"copy"}constructor(){super(),this._dragCounter=0,this._maxChunkSize=4194304,this._dialogTitle="",this._dialogContent="",this._dialogPrimaryButton="",this._dialogSecondaryButton="",this._dialogCheckBox="",this._applyAll=!1,this._applyAllConflictBehavior=null,this._maximumFileSize=!1,this._excludedFileType=!1,this.onFileUploadChange=e=>{const t=e.target;!e||t.files.length<1||this.readUploadedFiles(t.files,(()=>t.value=null))},this.onFileUploadClick=()=>{this.renderRoot.querySelector("#file-upload-input").click()},this.handleonDragOver=e=>{e.preventDefault(),e.stopPropagation(),e.dataTransfer.items&&e.dataTransfer.items.length>0&&(e.dataTransfer.dropEffect=e.dataTransfer.dropEffect=this._dropEffect)},this.handleonDragEnter=e=>{e.preventDefault(),e.stopPropagation(),this._dragCounter++,e.dataTransfer.items&&e.dataTransfer.items.length>0&&(e.dataTransfer.dropEffect=this._dropEffect,this.renderRoot.querySelector("#file-upload-border").classList.add("visible"))},this.handleonDragLeave=e=>{e.preventDefault(),e.stopPropagation(),this._dragCounter--,0===this._dragCounter&&this.renderRoot.querySelector("#file-upload-border").classList.remove("visible")},this.handleonDrop=e=>{var t;e.preventDefault(),e.stopPropagation();this.renderRoot.querySelector("#file-upload-border").classList.remove("visible"),(null===(t=e.dataTransfer)||void 0===t?void 0:t.items)&&this.readUploadedFiles(e.dataTransfer.items,(()=>{e.dataTransfer.clearData()})),this._dragCounter=0},this.filesToUpload=[]}render(){if(null!==this.parentElement){const e=this.parentElement;e.addEventListener("dragenter",this.handleonDragEnter),e.addEventListener("dragleave",this.handleonDragLeave),e.addEventListener("dragover",this.handleonDragOver),e.addEventListener("drop",this.handleonDrop)}return Je`
        <div id="file-upload-dialog" class="file-upload-dialog">
          <!-- Modal content -->
          <fluent-dialog modal="true" class="file-upload-dialog-content">
            <span
              class="file-upload-dialog-close"
              id="file-upload-dialog-close">
                ${Co(ko.Cancel)}
            </span>
            <div class="file-upload-dialog-content-text">
              <h2 class="file-upload-dialog-title">${this._dialogTitle}</h2>
              <div>${this._dialogContent}</div>
                <fluent-checkbox
                  id="file-upload-dialog-check"
                  class="file-upload-dialog-check">
                    ${this._dialogCheckBox}
                </fluent-checkbox>
            </div>
            <div class="file-upload-dialog-editor">
              <fluent-button
                appearance="accent"
                class="file-upload-dialog-ok">
                ${this._dialogPrimaryButton}
              </fluent-button>
              <fluent-button
                appearance="outline"
                class="file-upload-dialog-cancel">
                ${this._dialogSecondaryButton}
              </fluent-button>
            </div>
          </fluent-dialog>
        </div>
        <div id="file-upload-border"></div>
        <div class="file-upload-area-button">
          <input
            id="file-upload-input"
            title="${this.strings.uploadButtonLabel}"
            tabindex="-1"
            aria-label="file upload input"
            type="file"
            multiple
            @change="${this.onFileUploadChange}"
          />
          <fluent-button
            appearance="accent"
            class="file-upload-button"
            @click=${this.onFileUploadClick}
            label=${this.strings.uploadButtonLabel}>
              <span slot="start">${Co(ko.Upload)}</span>
              <span class="upload-text">${this.strings.buttonUploadFile}</span>
          </fluent-button>
        </div>
        <div class="file-upload-template">
          ${this.renderFolderTemplate(this.filesToUpload)}
        </div>
       `}renderFolderTemplate(e){const t=[];if(e.length>0){const i=e.map((e=>-1===t.indexOf(e.fullPath.substring(0,e.fullPath.lastIndexOf("/")))?e.fullPath.endsWith("/")?Je`${this.renderFileTemplate(e,"")}`:(t.push(e.fullPath.substring(0,e.fullPath.lastIndexOf("/"))),pi`
            <div class='file-upload-table'>
              <div class='file-upload-cell'>
                <mgt-file
                  .fileDetails=${{name:e.fullPath.substring(1,e.fullPath.lastIndexOf("/")),folder:"Folder"}}
                  .view=${xo.oneline}
                  class="mgt-file-item">
                </mgt-file>
              </div>
            </div>
            ${this.renderFileTemplate(e,"file-upload-folder-tab")}`):Je`${this.renderFileTemplate(e,"file-upload-folder-tab")}`));return Je`${i}`}return Je``}renderFileTemplate(e,t){const i=ki({"file-upload-table":!0,upload:e.completed}),o=t+("lastModifiedDateTime"===e.fieldUploadResponse?" file-upload-dialog-success":""),s=ki({description:"description"===e.fieldUploadResponse}),n=e.completed?Je``:this.renderFileUploadTemplate(e);return pi`
        <div class="${i}">
          <div class="${o}">
            <div class='file-upload-cell'>
              <div class="${s}">
                <div class="file-upload-status">
                  ${e.iconStatus}
                </div>
                <mgt-file
                  .fileDetails=${e.driveItem}
                  .view=${e.view}
                  .line2Property=${e.fieldUploadResponse}
                  part="upload"
                  class="mgt-file-item">
                </mgt-file>
              </div>
            </div>
              ${n}
            </div>
          </div>
        </div>`}renderFileUploadTemplate(e){const t=ki({"file-upload-table":!0,upload:e.completed});return Je`
    <div class='file-upload-cell'>
      <div class='file-upload-table file-upload-name'>
        <div class='file-upload-cell'>
          <div
            title="${e.file.name}"
            class='file-upload-filename'>
            ${e.file.name}
          </div>
        </div>
      </div>
      <div class='file-upload-table'>
        <div class='file-upload-cell'>
          <div class="${t}">
            <fluent-progress class="file-upload-bar" value="${e.percent}"></fluent-progress>
            <div class='file-upload-cell percent-indicator'>
              <span>${e.percent}%</span>
              <span
                class="file-upload-cancel"
                @click=${()=>this.deleteFileUploadSession(e)}>
                ${Co(ko.Cancel)}
              </span>
            </div>
          </div>
        </div>
      </div>
    </div>
    `}deleteFileUploadSession(e){return mp(this,void 0,void 0,(function*(){try{void 0!==e.uploadUrl?(yield(t=this.fileUploadList.graph,i=e.uploadUrl,Ph(void 0,void 0,void 0,(function*(){try{yield t.client.api(i).middlewareOptions(ie("files.readwrite")).delete()}catch(e){return null}}))),e.uploadUrl=void 0,e.completed=!0,this.setUploadFail(e,gp.cancelUploadFile)):(e.uploadUrl=void 0,e.completed=!0,this.setUploadFail(e,gp.cancelUploadFile))}catch(t){e.uploadUrl=void 0,e.completed=!0,this.setUploadFail(e,gp.cancelUploadFile)}var t,i}))}readUploadedFiles(e,t){return mp(this,void 0,void 0,(function*(){const i=yield this.getFilesFromUploadArea(e);yield this.getSelectedFiles(i),t()}))}getSelectedFiles(e){return mp(this,void 0,void 0,(function*(){let t=[];const i=[];this._applyAll=!1,this._applyAllConflictBehavior=null,this._maximumFileSize=!1,this._excludedFileType=!1,this.filesToUpload.forEach((e=>{e.completed?i.push(e):t.push(e)}));for(const i of e){const e=""===i.fullPath?"/"+i.name:i.fullPath;if(0===t.filter((t=>t.fullPath===e)).length){let o=!0;if(void 0!==this.fileUploadList.maxFileSize&&o&&i.size>1024*this.fileUploadList.maxFileSize&&(o=!1,!1===this._maximumFileSize)){const t=yield this.getFileUploadStatus(i,e,"MaxFileSize",this.fileUploadList);null!==t&&1===t[0]&&(this._maximumFileSize=!0)}if(void 0!==this.fileUploadList.excludedFileExtensions&&this.fileUploadList.excludedFileExtensions.length>0&&o&&this.fileUploadList.excludedFileExtensions.filter((e=>i.name.toLowerCase().indexOf(e.toLowerCase())>-1)).length>0&&(o=!1,!1===this._excludedFileType)){const t=yield this.getFileUploadStatus(i,e,"ExcludedFileType",this.fileUploadList);null!==t&&1===t[0]&&(this._excludedFileType=!0)}if(o){const o=yield this.getFileUploadStatus(i,e,"Upload",this.fileUploadList);let s=!1;null!==o&&(-1===o[0]?s=!0:(this._applyAll=Boolean(o[0]),this._applyAllConflictBehavior=o[1]?1:0)),t.push({file:i,driveItem:{name:i.name},fullPath:e,conflictBehavior:null!==o?o[1]?1:0:null,iconStatus:null,percent:1,view:xo.image,completed:s,maxSize:this._maxChunkSize,minSize:0})}}}t=t.sort(((e,t)=>e.fullPath.substring(0,e.fullPath.lastIndexOf("/")).localeCompare(t.fullPath.substring(0,t.fullPath.lastIndexOf("/"))))),t.forEach((e=>{if(0!==i.filter((t=>t.fullPath===e.fullPath)).length){const t=i.findIndex((t=>t.fullPath===e.fullPath));i.splice(t,1)}})),t.push(...i),this.filesToUpload=t;const o=this.filesToUpload.map((e=>this.sendFileItemGraph(e)));yield Promise.all(o)}))}getFileUploadStatus(e,t,i,o){const s=Object.create(null,{requestStateUpdate:{get:()=>super.requestStateUpdate}});return mp(this,void 0,void 0,(function*(){const n=this.renderRoot.querySelector("#file-upload-dialog");switch(i){case"Upload":return null!==(yield(r=this.fileUploadList.graph,a=`${this.getGrapQuery(t)}?$select=id`,Ph(void 0,void 0,void 0,(function*(){try{return(yield r.api(a).middlewareOptions(ie("files.read")).get())||null}catch(e){}return null}))))?!0===this._applyAll?[this._applyAll,this._applyAllConflictBehavior]:(n.classList.add("visible"),this._dialogTitle=gp.fileReplaceTitle,this._dialogContent=gp.fileReplace.replace("{FileName}",e.name),this._dialogCheckBox=gp.checkApplyAll,this._dialogPrimaryButton=gp.buttonReplace,this._dialogSecondaryButton=gp.buttonKeep,yield s.requestStateUpdate.call(this,!0),new Promise((e=>{const t=this.renderRoot.querySelector(".file-upload-dialog-close"),i=this.renderRoot.querySelector(".file-upload-dialog-ok"),o=this.renderRoot.querySelector(".file-upload-dialog-cancel"),s=this.renderRoot.querySelector("#file-upload-dialog-check");s.checked=!1,s.classList.remove("hide");const r=()=>{n.classList.remove("visible"),e([s.checked?1:0,1])},a=()=>{n.classList.remove("visible"),e([s.checked?1:0,0])},l=()=>{n.classList.remove("visible"),e([-1])};i.removeEventListener("click",r),o.removeEventListener("click",a),t.removeEventListener("click",l),i.addEventListener("click",r),o.addEventListener("click",a),t.addEventListener("click",l)}))):null;case"ExcludedFileType":return n.classList.add("visible"),this._dialogTitle=gp.fileTypeTitle,this._dialogContent=gp.fileType.replace("{FileName}",e.name)+" ("+o.excludedFileExtensions.join(",")+")",this._dialogCheckBox=gp.checkAgain,this._dialogPrimaryButton=gp.buttonOk,this._dialogSecondaryButton=gp.buttonCancel,yield s.requestStateUpdate.call(this,!0),new Promise((e=>{const t=this.renderRoot.querySelector(".file-upload-dialog-ok"),i=this.renderRoot.querySelector(".file-upload-dialog-cancel"),o=this.renderRoot.querySelector(".file-upload-dialog-close"),s=this.renderRoot.querySelector("#file-upload-dialog-check");s.checked=!1,s.classList.remove("hide");const r=()=>{n.classList.remove("visible"),e([s.checked?1:0])},a=()=>{n.classList.remove("visible"),e([0])};t.removeEventListener("click",r),i.removeEventListener("click",a),o.removeEventListener("click",a),t.addEventListener("click",r),i.addEventListener("click",a),o.addEventListener("click",a)}));case"MaxFileSize":return n.classList.add("visible"),this._dialogTitle=gp.maximumFileSizeTitle,this._dialogContent=gp.maximumFileSize.replace("{FileSize}",Ti(1024*o.maxFileSize)).replace("{FileName}",e.name)+Ti(e.size)+".",this._dialogCheckBox=gp.checkAgain,this._dialogPrimaryButton=gp.buttonOk,this._dialogSecondaryButton=gp.buttonCancel,yield s.requestStateUpdate.call(this,!0),new Promise((e=>{const t=this.renderRoot.querySelector(".file-upload-dialog-ok"),i=this.renderRoot.querySelector(".file-upload-dialog-cancel"),o=this.renderRoot.querySelector(".file-upload-dialog-close"),s=this.renderRoot.querySelector("#file-upload-dialog-check");s.checked=!1,s.classList.remove("hide");const r=()=>{n.classList.remove("visible"),e([s.checked?1:0])},a=()=>{n.classList.remove("visible"),e([0])};t.removeEventListener("click",r),i.removeEventListener("click",a),o.removeEventListener("click",a),t.addEventListener("click",r),i.addEventListener("click",a),o.addEventListener("click",a)}))}var r,a}))}getGrapQuery(e){let t="";return this.fileUploadList.itemPath&&this.fileUploadList.itemPath.length>0&&(t=this.fileUploadList.itemPath.startsWith("/")?this.fileUploadList.itemPath:"/"+this.fileUploadList.itemPath),this.fileUploadList.userId&&this.fileUploadList.itemId?`/users/${this.fileUploadList.userId}/drive/items/${this.fileUploadList.itemId}:${e}`:this.fileUploadList.userId&&this.fileUploadList.itemPath?`/users/${this.fileUploadList.userId}/drive/root:${t}${e}`:this.fileUploadList.groupId&&this.fileUploadList.itemId?`/groups/${this.fileUploadList.groupId}/drive/items/${this.fileUploadList.itemId}:${e}`:this.fileUploadList.groupId&&this.fileUploadList.itemPath?`/groups/${this.fileUploadList.groupId}/drive/root:${t}${e}`:this.fileUploadList.driveId&&this.fileUploadList.itemId?`/drives/${this.fileUploadList.driveId}/items/${this.fileUploadList.itemId}:${e}`:this.fileUploadList.driveId&&this.fileUploadList.itemPath?`/drives/${this.fileUploadList.driveId}/root:${t}${e}`:this.fileUploadList.siteId&&this.fileUploadList.itemId?`/sites/${this.fileUploadList.siteId}/drive/items/${this.fileUploadList.itemId}:${e}`:this.fileUploadList.siteId&&this.fileUploadList.itemPath?`/sites/${this.fileUploadList.siteId}/drive/root:${t}${e}`:this.fileUploadList.itemId?`/me/drive/items/${this.fileUploadList.itemId}:${e}`:this.fileUploadList.itemPath?`/me/drive/root:${t}${e}`:`/me/drive/root:${e}`}sendFileItemGraph(e){return mp(this,void 0,void 0,(function*(){const t=this.fileUploadList.graph;let i="";if(e.file.size<this._maxChunkSize)try{e.completed||(null!==e.conflictBehavior&&1!==e.conflictBehavior||(i=`${this.getGrapQuery(e.fullPath)}:/content`),0===e.conflictBehavior&&(i=`${this.getGrapQuery(e.fullPath)}:/content?@microsoft.graph.conflictBehavior=rename`),e.driveItem=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){try{const o="files.readwrite";let s;try{s=yield e.client.api(t).middlewareOptions(ie(o)).put(i)}catch(e){}return s||null}catch(e){return null}})))(t,i,e.file),null!==e.driveItem?this.setUploadSuccess(e):(e.driveItem={name:e.file.name},this.setUploadFail(e,gp.failUploadFile)))}catch(t){this.setUploadFail(e,gp.failUploadFile)}else if(!e.completed&&void 0===e.uploadUrl){const i=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){try{const o="files.readwrite",s={item:{"@microsoft.graph.conflictBehavior":0===i||null===i?"rename":"replace"}};let n;try{n=yield e.api(t).middlewareOptions(ie(o)).post(JSON.stringify(s))}catch(e){}return n||null}catch(e){return null}})))(t,`${this.getGrapQuery(e.fullPath)}:/createUploadSession`,e.conflictBehavior);try{if(null!==i){e.uploadUrl=i.uploadUrl;const o=yield this.sendSessionUrlGraph(t,e);null!==o?(e.driveItem=o,this.setUploadSuccess(e)):this.setUploadFail(e,gp.failUploadFile)}else this.setUploadFail(e,gp.failUploadFile)}catch(e){}}}))}sendSessionUrlGraph(e,t){const i=Object.create(null,{requestStateUpdate:{get:()=>super.requestStateUpdate}});return mp(this,void 0,void 0,(function*(){for(;t.file.size>t.minSize;){void 0===t.mimeStreamString&&(t.mimeStreamString=yield this.readFileContent(t.file));const s=new Blob([t.mimeStreamString.slice(t.minSize,t.maxSize)]);if(t.percent=Math.round(t.maxSize/t.file.size*100),yield i.requestStateUpdate.call(this,!0),void 0===t.uploadUrl)return null;{const i=yield Hh(e,t.uploadUrl,""+(t.maxSize-t.minSize),`bytes ${t.minSize}-${t.maxSize-1}/${t.file.size}`,s);if(null===i)return null;if(o=i,Array.isArray(o.nextExpectedRanges))t.minSize=parseInt(i.nextExpectedRanges[0].split("-")[0],10),t.maxSize=t.minSize+this._maxChunkSize,t.maxSize>t.file.size&&(t.maxSize=t.file.size);else if(void 0!==i.id)return i}}var o}))}setUploadSuccess(e){e.percent=100,super.requestStateUpdate(!0),setTimeout((()=>{e.iconStatus=Co(ko.Success),e.view=xo.twolines,e.fieldUploadResponse="lastModifiedDateTime",e.completed=!0,super.requestStateUpdate(!0),Lh()}),500)}setUploadFail(e,t){setTimeout((()=>{e.iconStatus=Co(ko.Fail),e.view=xo.twolines,e.driveItem.description=t,e.fieldUploadResponse="description",e.completed=!0,super.requestStateUpdate(!0)}),500)}readFileContent(e){return new Promise(((t,i)=>{const o=new FileReader;o.onloadend=()=>{t(o.result)},o.onerror=e=>{i(e)},o.readAsArrayBuffer(e)}))}getFilesFromUploadArea(e){return mp(this,void 0,void 0,(function*(){const t=[];let i;const o=[];for(const n of e)if("getAsFile"in(s=n)&&"function"==typeof s.getAsFile||"webkitGetAsEntry"in s&&"function"==typeof s.webkitGetAsEntry)if(yp(n))if(i=n.getAsEntry(),bp(i))t.push(i);else{const e=n.getAsFile();e&&(this.writeFilePath(e,""),o.push(e))}else if(n.webkitGetAsEntry)if(i=n.webkitGetAsEntry(),bp(i))t.push(i);else{const e=n.getAsFile();e&&(this.writeFilePath(e,""),o.push(e))}else{const e=n.getAsFile();e&&(this.writeFilePath(e,""),o.push(e))}else this.writeFilePath(n,""),o.push(n);var s;if(t.length>0){const e=yield this.getFolderFiles(t);o.push(...e)}return o}))}getFolderFiles(e){return new Promise((t=>{let i=0;const o=[];e.forEach((e=>{s(e,"")}));const s=(e,s)=>{bp(e)?n(e.createReader()):(e=>e.isFile)(e)&&(i++,e.file((e=>{i--,this.writeFilePath(e,s),o.push(e),0===i&&t(o)})))},n=e=>{i++,e.readEntries((e=>{i--;for(const t of e)s(t,t.fullPath);0===i&&t(o)}))}}))}writeFilePath(e,t){e.fullPath=t}};fp([Ct({type:Object}),vp("design:type",Array)],wp.prototype,"filesToUpload",void 0),fp([Ct({type:Object}),vp("design:type",Object)],wp.prototype,"fileUploadList",void 0),wp=fp([gi("file-upload"),vp("design:paramtypes",[])],wp);const xp=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{font-size:var(--default-font-size)}:host .title{font-size:14px;font-weight:600;padding:20px 0 12px;line-height:19px}:host .file-list-wrapper{background-color:var(--file-list-background-color,var(--neutral-layer-floating));border:var(--file-list-border,none);position:relative;display:flex;flex-direction:column;border-radius:8px}:host .file-list-wrapper .title{font-size:14px;font-weight:600;margin:0 20px -15px}:host .file-list-wrapper .file-list{display:flex;padding:var(--file-list-padding,0);margin:var(--file-list-margin,0);flex-direction:column;list-style:none}:host .file-list-wrapper .file-list .file-item{cursor:pointer;border-radius:var(--file-border-radius)}:host .file-list-wrapper .file-list .file-item:focus,:host .file-list-wrapper .file-list .file-item:focus-within{--file-background-color:var(--file-background-color-focus, var(--neutral-layer-2))}:host .file-list-wrapper .file-list .file-item.selected{--file-background-color:var(--file-background-color-active, var(--neutral-layer-3))}:host .file-list-wrapper .file-list .file-item .mgt-file-item{--file-padding:10px 20px 10px 20px;--file-padding-inline-start:24px;--file-border-radius:2px;--file-background-color:var(--file-item-background-color, var(--neutral-layer-1))}:host .file-list-wrapper .progress-ring{margin:4px auto;width:var(--progress-ring-size,24px);height:var(--progress-ring-size,24px)}:host .file-list-wrapper .show-more{text-align:center;font-size:var(--show-more-button-font-size,12px);padding:var(--show-more-button-padding,0);border-radius:0 0 var(--show-more-button-border-bottom-right-radius,var(--file-list-border-radius,8px)) var(--show-more-button-border-bottom-left-radius,var(--file-list-border-radius,8px));background-color:var(--show-more-button-background-color,var(--neutral-stroke-divider-rest))}:host .file-list-wrapper .show-more:hover{background-color:var(--show-more-button-background-color-hover,var(--neutral-fill-input-alt-active))}:host .file-list-wrapper .show-more-text{font-size:var(--show-more-button-font-size,12px)}
`],kp={showMoreSubtitle:"Show more items",filesSectionTitle:"Files",sharedTextSubtitle:"Shared"},Cp=class extends Kh{}.compose({baseName:"progress-ring",template:(e,t)=>Rr`
    <template
        role="progressbar"
        aria-valuenow="${e=>e.value}"
        aria-valuemin="${e=>e.min}"
        aria-valuemax="${e=>e.max}"
        class="${e=>e.paused?"paused":""}"
    >
        ${eu((e=>"number"==typeof e.value),Rr`
                <svg
                    class="progress"
                    part="progress"
                    viewBox="0 0 16 16"
                    slot="determinate"
                >
                    <circle
                        class="background"
                        part="background"
                        cx="8px"
                        cy="8px"
                        r="7px"
                    ></circle>
                    <circle
                        class="determinate"
                        part="determinate"
                        style="stroke-dasharray: ${e=>44*e.percentComplete/100}px ${44}px"
                        cx="8px"
                        cy="8px"
                        r="7px"
                    ></circle>
                </svg>
            `,Rr`
                <slot name="indeterminate" slot="indeterminate">
                    ${t.indeterminateIndicator||""}
                </slot>
            `)}
    </template>
`,styles:(e,t)=>ih`
    ${nh("flex")} :host {
      align-items: center;
      height: calc(${Uu} * 1px);
      width: calc(${Uu} * 1px);
    }

    .progress {
      height: 100%;
      width: 100%;
    }

    .background {
      fill: none;
      stroke-width: 2px;
    }

    .determinate {
      stroke: ${Dd};
      fill: none;
      stroke-width: 2px;
      stroke-linecap: round;
      transform-origin: 50% 50%;
      transform: rotate(-90deg);
      transition: all 0.2s ease-in-out;
    }

    .indeterminate-indicator-1 {
      stroke: ${Dd};
      fill: none;
      stroke-width: 2px;
      stroke-linecap: round;
      transform-origin: 50% 50%;
      transform: rotate(-90deg);
      transition: all 0.2s ease-in-out;
      animation: spin-infinite 2s linear infinite;
    }

    :host(.paused) .indeterminate-indicator-1 {
      animation: none;
      stroke: ${Sc};
    }

    :host(.paused) .determinate {
      stroke: ${Sc};
    }

    @keyframes spin-infinite {
      0% {
        stroke-dasharray: 0.01px 43.97px;
        transform: rotate(0deg);
      }
      50% {
        stroke-dasharray: 21.99px 21.99px;
        transform: rotate(450deg);
      }
      100% {
        stroke-dasharray: 0.01px 43.97px;
        transform: rotate(1080deg);
      }
    }
  `.withBehaviors(lh(ih`
        .background {
          stroke: ${dh.Field};
        }
        .determinate,
        .indeterminate-indicator-1 {
          stroke: ${dh.ButtonText};
        }
        :host(.paused) .determinate,
        :host(.paused) .indeterminate-indicator-1 {
          stroke: ${dh.GrayText};
        }
      `)),indeterminateIndicator:'\n    <svg class="progress" part="progress" viewBox="0 0 16 16">\n        <circle\n            class="background"\n            part="background"\n            cx="8px"\n            cy="8px"\n            r="7px"\n        ></circle>\n        <circle\n            class="indeterminate-indicator-1"\n            part="indeterminate-indicator-1"\n            cx="8px"\n            cy="8px"\n            r="7px"\n        ></circle>\n    </svg>\n  '});var $p=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Sp=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},_p=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(Cp);let Ip=class extends Nt{static get styles(){return xp}get strings(){return kp}get fileListQuery(){return this._fileListQuery}set fileListQuery(e){e!==this._fileListQuery&&(this._fileListQuery=e,this.requestStateUpdate(!0))}get displayName(){return this.strings.filesSectionTitle}get cardTitle(){return this.strings.filesSectionTitle}renderIcon(){return Co(ko.Files)}get fileQueries(){return this._fileQueries}set fileQueries(e){Rt(this._fileQueries,e)||(this._fileQueries=e,this.requestStateUpdate(!0))}get siteId(){return this._siteId}set siteId(e){e!==this._siteId&&(this._siteId=e,this.requestStateUpdate(!0))}get driveId(){return this._driveId}set driveId(e){e!==this._driveId&&(this._driveId=e,this.requestStateUpdate(!0))}get groupId(){return this._groupId}set groupId(e){e!==this._groupId&&(this._groupId=e,this.requestStateUpdate(!0))}get itemId(){return this._itemId}set itemId(e){e!==this._itemId&&(this._itemId=e,this.requestStateUpdate(!0))}get itemPath(){return this._itemPath}set itemPath(e){e!==this._itemPath&&(this._itemPath=e,this.requestStateUpdate(!0))}get userId(){return this._userId}set userId(e){e!==this._userId&&(this._userId=e,this.requestStateUpdate(!0))}get insightType(){return this._insightType}set insightType(e){e!==this._insightType&&(this._insightType=e,this.requestStateUpdate(!0))}get fileExtensions(){return this._fileExtensions}set fileExtensions(e){Rt(this._fileExtensions,e)||(this._fileExtensions=e,this.requestStateUpdate(!0))}get pageSize(){return this._pageSize}set pageSize(e){e!==this._pageSize&&(this._pageSize=e,this.requestStateUpdate(!0))}get maxFileSize(){return this._maxFileSize}set maxFileSize(e){e!==this._maxFileSize&&(this._maxFileSize=e,this.requestStateUpdate(!0))}get maxUploadFile(){return this._maxUploadFile}set maxUploadFile(e){e!==this._maxUploadFile&&(this._maxUploadFile=e,this.requestStateUpdate(!0))}get excludedFileExtensions(){return this._excludedFileExtensions}set excludedFileExtensions(e){Rt(this._excludedFileExtensions,e)||(this._excludedFileExtensions=e,this.requestStateUpdate(!0))}static get requiredScopes(){return[...new Set([...Qh.requiredScopes])]}constructor(){super(),this._isCompact=!1,this.disableOpenOnClick=!1,this._focusedItemIndex=-1,this.onFocusFirstItem=()=>this._focusedItemIndex=0,this.onFileListKeyDown=e=>{const t=this.renderRoot.querySelector(".file-list");let i;if(null==t?void 0:t.children.length){if("ArrowUp"!==e.code&&"ArrowDown"!==e.code||("ArrowUp"===e.code&&(-1===this._focusedItemIndex&&(this._focusedItemIndex=t.children.length),this._focusedItemIndex=(this._focusedItemIndex-1+t.children.length)%t.children.length),"ArrowDown"===e.code&&(this._focusedItemIndex=(this._focusedItemIndex+1)%t.children.length),i=t.children[this._focusedItemIndex],this.updateItemBackgroundColor(t,i,"focused")),"Enter"===e.code||"Space"===e.code){i=t.children[this._focusedItemIndex];const o=i.children[0];e.preventDefault(),this.fireCustomEvent("itemClick",o.fileDetails),this.handleFileClick(o.fileDetails),this.updateItemBackgroundColor(t,i,"selected")}"Tab"===e.code&&(i=t.children[this._focusedItemIndex])}},this.pageSize=10,this.itemView=xo.twolines,this.maxUploadFile=10,this.enableFileUpload=!1,this._preloadedFiles=[]}requestStateUpdate(e){return this.clearState(),super.requestStateUpdate(e)}clearState(){super.clearState(),this.files=null}asCompactView(){return this._isCompact=!0,this}asFullView(){return this._isCompact=!1,this}render(){return!this.files&&this.isLoadingState?this.renderLoading():this.files&&0!==this.files.length?this._isCompact?this.renderCompactView():this.renderFullView():this.renderNoData()}renderCompactView(){const e=this.files.slice(0,3);return this.renderFiles(e)}renderFullView(){return this.renderTemplate("default",{files:this.files})||this.renderFiles(this.files)}renderLoading(){return this.renderTemplate("loading",null)||Je``}renderNoData(){return this.renderTemplate("no-data",null)||(!0===this.enableFileUpload&&void 0!==te.globalProvider?Je`
            <div class="file-list-wrapper" dir=${this.direction}>
              ${this.renderFileUpload()}
            </div>`:Je``)}renderFiles(e){return Je`
      <div id="file-list-wrapper" class="file-list-wrapper" dir=${this.direction}>
        ${this.enableFileUpload?this.renderFileUpload():null}
        <ul
          id="file-list"
          class="file-list"
        >
          <li
            tabindex="0"
            class="file-item"
            @keydown="${this.onFileListKeyDown}"
            @focus="${this.onFocusFirstItem}"
            @click=${t=>this.handleItemSelect(e[0],t)}>
            ${this.renderFile(e[0])}
          </li>
          ${Xo(e.slice(1),(e=>e.id),(e=>Je`
              <li
                class="file-item"
                @keydown="${this.onFileListKeyDown}"
                @click=${t=>this.handleItemSelect(e,t)}>
                ${this.renderFile(e)}
              </li>
            `))}
        </ul>
        ${this.hideMoreFilesButton||!this.pageIterator||!this.pageIterator.hasNext&&!this._preloadedFiles.length||this._isCompact?null:this.renderMoreFileButton()}
      </div>
    `}renderFile(e){const t=this.itemView;return this.renderTemplate("file",{file:e},e.id)||pi`
        <mgt-file class="mgt-file-item" .fileDetails=${e} .view=${t}></mgt-file>
      `}renderMoreFileButton(){return this._isLoadingMore?Je`
        <fluent-progress-ring role="progressbar" viewBox="0 0 8 8" class="progress-ring"></fluent-progress-ring>
      `:Je`
        <fluent-button
          appearance="stealth"
          id="show-more"
          class="show-more"
          @click=${()=>this.renderNextPage()}
        >
          <span class="show-more-text">${this.strings.showMoreSubtitle}</span>
        </fluent-button>`}renderFileUpload(){const e={graph:te.globalProvider.graph.forComponent(this),driveId:this.driveId,excludedFileExtensions:this.excludedFileExtensions,groupId:this.groupId,itemId:this.itemId,itemPath:this.itemPath,userId:this.userId,siteId:this.siteId,maxFileSize:this.maxFileSize,maxUploadFile:this.maxUploadFile};return pi`
        <mgt-file-upload .fileUploadList=${e} ></mgt-file-upload>
      `}loadState(){var e;return _p(this,void 0,void 0,(function*(){const t=te.globalProvider;if(!t||t.state===Q.Loading)return;if(t.state===Q.SignedOut)return void(this.files=null);const i=t.graph.forComponent(this);let o,s;const n=!(this.driveId||this.siteId||this.groupId||this.userId);if((this.driveId&&!this.itemId&&!this.itemPath||this.groupId&&!this.itemId&&!this.itemPath||this.siteId&&!this.itemId&&!this.itemPath||this.userId&&!this.insightType&&!this.itemId&&!this.itemPath)&&(this.files=null),!this.files){let t;if(this.fileListQuery?s=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){const o=Ui.stores.fileLists;return Rh(e,t,o,["files.read","sites.read.all"],i)})))(i,this.fileListQuery,this.pageSize):this.fileQueries?o=yield((e,t)=>Ph(void 0,void 0,void 0,(function*(){if(!t||0===t.length)return[];const i=e.createBatch(),o=[],s=["files.read"];let n,r;Oh()&&(n=ai.getCache(Ni,Ni.stores.fileQueries));for(const e of t)Oh()&&(r=yield n.getValue(e)),Oh()&&r&&Eh()>Date.now()-r.timeCached?o.push(JSON.parse(r.file)):""!==e&&i.get(e,e,s);try{const e=yield i.executeAll();for(const i of t){const t=e.get(i);(null==t?void 0:t.content)&&(o.push(t.content),Oh()&&(yield n.putValue(i,{file:JSON.stringify(t.content)})))}return o}catch(i){try{return Promise.all(t.filter((e=>e&&""!==e)).map((t=>Ph(void 0,void 0,void 0,(function*(){const i=yield Ah(e,t);if(i)return Oh()&&(yield n.putValue(t,{file:JSON.stringify(i)})),i})))))}catch(e){return[]}}})))(i,this.fileQueries):n?this.itemId?s=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){const o=`/me/drive/items/${t}/children`,s=Ui.stores.fileLists;return Rh(e,o,s,["files.read"],i)})))(i,this.itemId,this.pageSize):this.itemPath?s=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){const o=`/me/drive/root:/${t}:/children`,s=Ui.stores.fileLists;return Rh(e,o,s,["files.read"],i)})))(i,this.itemPath,this.pageSize):this.insightType?o=yield((e,t)=>Ph(void 0,void 0,void 0,(function*(){const i=`/me/insights/${t}`,o=Ui.stores.insightfileLists,s=ai.getCache(Ui,o),n=yield Uh(s,o,i);if(n)return n.files.map((e=>JSON.parse(e)));const r=["sites.read.all"];let a;try{a=yield e.api(i).filter("resourceReference/type eq 'microsoft.graph.driveItem'").middlewareOptions(ie(...r)).get()}catch(e){}const l=yield Vh(e,a,r);return Fh()&&(yield s.putValue(i,{files:l.map((e=>JSON.stringify(e)))})),l||null})))(i,this.insightType):s=yield((e,t)=>Ph(void 0,void 0,void 0,(function*(){const i=Ui.stores.fileLists;return Rh(e,"/me/drive/root/children",i,["files.read"],t)})))(i,this.pageSize):this.driveId?this.itemId?s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/drives/${t}/items/${i}/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.driveId,this.itemId,this.pageSize):this.itemPath&&(s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/drives/${t}/root:/${i}:/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.driveId,this.itemPath,this.pageSize)):this.groupId?this.itemId?s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/groups/${t}/drive/items/${i}/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.groupId,this.itemId,this.pageSize):this.itemPath&&(s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/groups/${t}/drive/root:/${i}:/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.groupId,this.itemPath,this.pageSize)):this.siteId?this.itemId?s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/sites/${t}/drive/items/${i}/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.siteId,this.itemId,this.pageSize):this.itemPath&&(s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/sites/${t}/drive/root:/${i}:/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.siteId,this.itemPath,this.pageSize)):this.userId&&(this.itemId?s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/users/${t}/drive/items/${i}/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.userId,this.itemId,this.pageSize):this.itemPath?s=yield((e,t,i,o)=>Ph(void 0,void 0,void 0,(function*(){const s=`/users/${t}/drive/root:/${i}:/children`,n=Ui.stores.fileLists;return Rh(e,s,n,["files.read"],o)})))(i,this.userId,this.itemPath,this.pageSize):this.insightType&&(o=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){let o,s;"shared"===i?(o="/me/insights/shared",s=`((lastshared/sharedby/id eq '${t}') and (resourceReference/type eq 'microsoft.graph.driveItem'))`):(o=`/users/${t}/insights/${i}`,s="resourceReference/type eq 'microsoft.graph.driveItem'");const n=`${o}?$filter=${s}`,r=Ui.stores.insightfileLists,a=ai.getCache(Ui,r),l=yield Uh(a,r,n);if(l)return l.files.map((e=>JSON.parse(e)));const d=["sites.read.all"];let c;try{c=yield e.api(o).filter(s).middlewareOptions(ie(...d)).get()}catch(e){}const h=yield Vh(e,c,d);return Fh()&&(yield a.putValue(o,{files:h.map((e=>JSON.stringify(e)))})),h||null})))(i,this.userId,this.insightType))),s&&(this.pageIterator=s,this._preloadedFiles=[...this.pageIterator.value],o=this._preloadedFiles.length>=this.pageSize?this._preloadedFiles.splice(0,this.pageSize):this._preloadedFiles.splice(0,this._preloadedFiles.length)),this.fileExtensions&&null!==this.fileExtensions){if(null===(e=this.pageIterator)||void 0===e?void 0:e.value){for(;this.pageIterator.hasNext;)yield Bh(this.pageIterator);o=this.pageIterator.value,this._preloadedFiles=[]}t=o.filter((e=>{for(const t of this.fileExtensions)if(t===this.getFileExtension(e.name))return e}))}(null==t?void 0:t.length)>=0?(this.files=t,this.pageSize&&(o=this.files.splice(0,this.pageSize),this.files=o)):this.files=o}}))}handleItemSelect(e,t){if(this.handleFileClick(e),this.fireCustomEvent("itemClick",e),t){const e=this.renderRoot.querySelector(".file-list"),i=Array.from(e.children),o=t.target.closest("li"),s=i.indexOf(o);this._focusedItemIndex=s;const n=e.children[this._focusedItemIndex];this.updateItemBackgroundColor(e,n,"selected")}}renderNextPage(){return _p(this,void 0,void 0,(function*(){if(this._preloadedFiles.length>0)this.files=[...this.files,...this._preloadedFiles.splice(0,Math.min(this.pageSize,this._preloadedFiles.length))];else if(this.pageIterator.hasNext){this._isLoadingMore=!0;const e=this.renderRoot.querySelector("#file-list-wrapper");(null==e?void 0:e.animate)&&e.animate([{height:"auto",transformOrigin:"top left"},{height:"auto",transformOrigin:"top left"}],{duration:1e3,easing:"ease-in-out",fill:"both"}),yield Bh(this.pageIterator),this._isLoadingMore=!1,this.files=this.pageIterator.value}this.requestUpdate()}))}handleFileClick(e){(null==e?void 0:e.webUrl)&&!this.disableOpenOnClick&&window.open(e.webUrl,"_blank","noreferrer")}getFileExtension(e){return/(?:\.([^.]+))?$/.exec(e)[1]||""}updateItemBackgroundColor(e,t,i){for(const t of e.children)t.classList.remove(i),t.removeAttribute("tabindex");t&&(t.classList.add(i),t.scrollIntoView({behavior:"smooth",block:"nearest",inline:"start"}),t.setAttribute("tabindex","0"),t.focus());for(const t of e.children)t.classList.remove("selected")}reload(e=!1){e&&Lh(),this.requestStateUpdate(!0)}};$p([$t(),Sp("design:type",Object)],Ip.prototype,"_isCompact",void 0),$p([Ct({attribute:"file-list-query"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"fileListQuery",null),$p([Ct({attribute:"file-queries",converter:(e,t)=>e?e.split(",").map((e=>e.trim())):null}),Sp("design:type",Array),Sp("design:paramtypes",[Array])],Ip.prototype,"fileQueries",null),$p([Ct({type:Object}),Sp("design:type",Array)],Ip.prototype,"files",void 0),$p([Ct({attribute:"site-id"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"siteId",null),$p([Ct({attribute:"drive-id"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"driveId",null),$p([Ct({attribute:"group-id"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"groupId",null),$p([Ct({attribute:"item-id"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"itemId",null),$p([Ct({attribute:"item-path"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"itemPath",null),$p([Ct({attribute:"user-id"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"userId",null),$p([Ct({attribute:"insight-type"}),Sp("design:type",String),Sp("design:paramtypes",[String])],Ip.prototype,"insightType",null),$p([Ct({attribute:"item-view",converter:e=>e&&0!==e.length?(e=e.toLowerCase(),void 0===xo[e]?xo.threelines:xo[e]):xo.threelines}),Sp("design:type",Number)],Ip.prototype,"itemView",void 0),$p([Ct({attribute:"file-extensions",converter:(e,t)=>e.split(",").map((e=>e.trim()))}),Sp("design:type",Array),Sp("design:paramtypes",[Array])],Ip.prototype,"fileExtensions",null),$p([Ct({attribute:"page-size",type:Number}),Sp("design:type",Number),Sp("design:paramtypes",[Number])],Ip.prototype,"pageSize",null),$p([Ct({attribute:"disable-open-on-click",type:Boolean}),Sp("design:type",Object)],Ip.prototype,"disableOpenOnClick",void 0),$p([Ct({attribute:"hide-more-files-button",type:Boolean}),Sp("design:type",Boolean)],Ip.prototype,"hideMoreFilesButton",void 0),$p([Ct({attribute:"max-file-size",type:Number}),Sp("design:type",Number),Sp("design:paramtypes",[Number])],Ip.prototype,"maxFileSize",null),$p([Ct({attribute:"enable-file-upload",type:Boolean}),Sp("design:type",Boolean)],Ip.prototype,"enableFileUpload",void 0),$p([Ct({attribute:"max-upload-file",type:Number}),Sp("design:type",Number),Sp("design:paramtypes",[Number])],Ip.prototype,"maxUploadFile",null),$p([Ct({attribute:"excluded-file-extensions",converter:(e,t)=>e.split(",").map((e=>e.trim()))}),Sp("design:type",Array),Sp("design:paramtypes",[Array])],Ip.prototype,"excludedFileExtensions",null),$p([$t(),Sp("design:type",Boolean)],Ip.prototype,"_isLoadingMore",void 0),Ip=$p([gi("file-list"),Sp("design:paramtypes",[])],Ip);const Tp={comboboxPlaceholder:"Select an item"};let Dp=0;function Pp(e=""){return`${e}${Dp++}`}function Lp(e,t,i){return Math.min(Math.max(i,e),t)}function Ep(e,t,i=0){return[t,i]=[t,i].sort(((e,t)=>e-t)),t<=e&&e<i}function Op(e){return Mu(e)&&("option"===e.getAttribute("role")||e instanceof HTMLOptionElement)}class Fp extends Ln{constructor(e,t,i,o){super(),this.defaultSelected=!1,this.dirtySelected=!1,this.selected=this.defaultSelected,this.dirtyValue=!1,e&&(this.textContent=e),t&&(this.initialValue=t),i&&(this.defaultSelected=i),o&&(this.selected=o),this.proxy=new Option(`${this.textContent}`,this.initialValue,this.defaultSelected,this.selected),this.proxy.disabled=this.disabled}checkedChanged(e,t){this.ariaChecked="boolean"!=typeof t?null:t?"true":"false"}contentChanged(e,t){this.proxy instanceof HTMLOptionElement&&(this.proxy.textContent=this.textContent),this.$emit("contentchange",null,{bubbles:!0})}defaultSelectedChanged(){this.dirtySelected||(this.selected=this.defaultSelected,this.proxy instanceof HTMLOptionElement&&(this.proxy.selected=this.defaultSelected))}disabledChanged(e,t){this.ariaDisabled=this.disabled?"true":"false",this.proxy instanceof HTMLOptionElement&&(this.proxy.disabled=this.disabled)}selectedAttributeChanged(){this.defaultSelected=this.selectedAttribute,this.proxy instanceof HTMLOptionElement&&(this.proxy.defaultSelected=this.defaultSelected)}selectedChanged(){this.ariaSelected=this.selected?"true":"false",this.dirtySelected||(this.dirtySelected=!0),this.proxy instanceof HTMLOptionElement&&(this.proxy.selected=this.selected)}initialValueChanged(e,t){this.dirtyValue||(this.value=this.initialValue,this.dirtyValue=!1)}get label(){var e;return null!==(e=this.value)&&void 0!==e?e:this.text}get text(){var e,t;return null!==(t=null===(e=this.textContent)||void 0===e?void 0:e.replace(/\s+/g," ").trim())&&void 0!==t?t:""}set value(e){const t=`${null!=e?e:""}`;this._value=t,this.dirtyValue=!0,this.proxy instanceof HTMLOptionElement&&(this.proxy.value=t),vs.notify(this,"value")}get value(){var e;return vs.track(this,"value"),null!==(e=this._value)&&void 0!==e?e:this.text}get form(){return this.proxy?this.proxy.form:null}}Ms([ms],Fp.prototype,"checked",void 0),Ms([ms],Fp.prototype,"content",void 0),Ms([ms],Fp.prototype,"defaultSelected",void 0),Ms([Os({mode:"boolean"})],Fp.prototype,"disabled",void 0),Ms([Os({attribute:"selected",mode:"boolean"})],Fp.prototype,"selectedAttribute",void 0),Ms([ms],Fp.prototype,"selected",void 0),Ms([Os({attribute:"value",mode:"fromView"})],Fp.prototype,"initialValue",void 0);class Ap{}Ms([ms],Ap.prototype,"ariaChecked",void 0),Ms([ms],Ap.prototype,"ariaPosInSet",void 0),Ms([ms],Ap.prototype,"ariaSelected",void 0),Ms([ms],Ap.prototype,"ariaSetSize",void 0),cu(Ap,iu),cu(Fp,nu,Ap);class Rp extends Ln{constructor(){super(...arguments),this._options=[],this.selectedIndex=-1,this.selectedOptions=[],this.shouldSkipFocus=!1,this.typeaheadBuffer="",this.typeaheadExpired=!0,this.typeaheadTimeout=-1}get firstSelectedOption(){var e;return null!==(e=this.selectedOptions[0])&&void 0!==e?e:null}get hasSelectableOptions(){return this.options.length>0&&!this.options.every((e=>e.disabled))}get length(){var e,t;return null!==(t=null===(e=this.options)||void 0===e?void 0:e.length)&&void 0!==t?t:0}get options(){return vs.track(this,"options"),this._options}set options(e){this._options=e,vs.notify(this,"options")}get typeAheadExpired(){return this.typeaheadExpired}set typeAheadExpired(e){this.typeaheadExpired=e}clickHandler(e){const t=e.target.closest("option,[role=option]");if(t&&!t.disabled)return this.selectedIndex=this.options.indexOf(t),!0}focusAndScrollOptionIntoView(e=this.firstSelectedOption){this.contains(document.activeElement)&&null!==e&&(e.focus(),requestAnimationFrame((()=>{e.scrollIntoView({block:"nearest"})})))}focusinHandler(e){this.shouldSkipFocus||e.target!==e.currentTarget||(this.setSelectedOptions(),this.focusAndScrollOptionIntoView()),this.shouldSkipFocus=!1}getTypeaheadMatches(){const e=this.typeaheadBuffer.replace(/[.*+\-?^${}()|[\]\\]/g,"\\$&"),t=new RegExp(`^${e}`,"gi");return this.options.filter((e=>e.text.trim().match(t)))}getSelectableIndex(e=this.selectedIndex,t){const i=e>t?-1:e<t?1:0,o=e+i;let s=null;switch(i){case-1:s=this.options.reduceRight(((e,t,i)=>!e&&!t.disabled&&i<o?t:e),s);break;case 1:s=this.options.reduce(((e,t,i)=>!e&&!t.disabled&&i>o?t:e),s)}return this.options.indexOf(s)}handleChange(e,t){"selected"===t&&(Rp.slottedOptionFilter(e)&&(this.selectedIndex=this.options.indexOf(e)),this.setSelectedOptions())}handleTypeAhead(e){this.typeaheadTimeout&&window.clearTimeout(this.typeaheadTimeout),this.typeaheadTimeout=window.setTimeout((()=>this.typeaheadExpired=!0),Rp.TYPE_AHEAD_TIMEOUT_MS),e.length>1||(this.typeaheadBuffer=`${this.typeaheadExpired?"":this.typeaheadBuffer}${e}`)}keydownHandler(e){if(this.disabled)return!0;this.shouldSkipFocus=!1;const t=e.key;switch(t){case bu:e.shiftKey||(e.preventDefault(),this.selectFirstOption());break;case uu:e.shiftKey||(e.preventDefault(),this.selectNextOption());break;case fu:e.shiftKey||(e.preventDefault(),this.selectPreviousOption());break;case yu:e.preventDefault(),this.selectLastOption();break;case xu:return this.focusAndScrollOptionIntoView(),!0;case vu:case mu:return!0;case wu:if(this.typeaheadExpired)return!0;default:return 1===t.length&&this.handleTypeAhead(`${t}`),!0}}mousedownHandler(e){return this.shouldSkipFocus=!this.contains(document.activeElement),!0}multipleChanged(e,t){this.ariaMultiSelectable=t?"true":null}selectedIndexChanged(e,t){var i;if(this.hasSelectableOptions){if((null===(i=this.options[this.selectedIndex])||void 0===i?void 0:i.disabled)&&"number"==typeof e){const i=this.getSelectableIndex(e,t),o=i>-1?i:e;return this.selectedIndex=o,void(t===o&&this.selectedIndexChanged(t,o))}this.setSelectedOptions()}else this.selectedIndex=-1}selectedOptionsChanged(e,t){var i;const o=t.filter(Rp.slottedOptionFilter);null===(i=this.options)||void 0===i||i.forEach((e=>{const t=vs.getNotifier(e);t.unsubscribe(this,"selected"),e.selected=o.includes(e),t.subscribe(this,"selected")}))}selectFirstOption(){var e,t;this.disabled||(this.selectedIndex=null!==(t=null===(e=this.options)||void 0===e?void 0:e.findIndex((e=>!e.disabled)))&&void 0!==t?t:-1)}selectLastOption(){this.disabled||(this.selectedIndex=function(e,t){let i=e.length;for(;i--;)if(!e[i].disabled)return i;return-1}(this.options))}selectNextOption(){!this.disabled&&this.selectedIndex<this.options.length-1&&(this.selectedIndex+=1)}selectPreviousOption(){!this.disabled&&this.selectedIndex>0&&(this.selectedIndex=this.selectedIndex-1)}setDefaultSelectedOption(){var e,t;this.selectedIndex=null!==(t=null===(e=this.options)||void 0===e?void 0:e.findIndex((e=>e.defaultSelected)))&&void 0!==t?t:-1}setSelectedOptions(){var e,t,i;(null===(e=this.options)||void 0===e?void 0:e.length)&&(this.selectedOptions=[this.options[this.selectedIndex]],this.ariaActiveDescendant=null!==(i=null===(t=this.firstSelectedOption)||void 0===t?void 0:t.id)&&void 0!==i?i:"",this.focusAndScrollOptionIntoView())}slottedOptionsChanged(e,t){this.options=t.reduce(((e,t)=>(Op(t)&&e.push(t),e)),[]);const i=`${this.options.length}`;this.options.forEach(((e,t)=>{e.id||(e.id=Pp("option-")),e.ariaPosInSet=`${t+1}`,e.ariaSetSize=i})),this.$fastController.isConnected&&(this.setSelectedOptions(),this.setDefaultSelectedOption())}typeaheadBufferChanged(e,t){if(this.$fastController.isConnected){const e=this.getTypeaheadMatches();if(e.length){const t=this.options.indexOf(e[0]);t>-1&&(this.selectedIndex=t)}this.typeaheadExpired=!1}}}Rp.slottedOptionFilter=e=>Op(e)&&!e.hidden,Rp.TYPE_AHEAD_TIMEOUT_MS=1e3,Ms([Os({mode:"boolean"})],Rp.prototype,"disabled",void 0),Ms([ms],Rp.prototype,"selectedIndex",void 0),Ms([ms],Rp.prototype,"selectedOptions",void 0),Ms([ms],Rp.prototype,"slottedOptions",void 0),Ms([ms],Rp.prototype,"typeaheadBuffer",void 0);class Vp{}Ms([ms],Vp.prototype,"ariaActiveDescendant",void 0),Ms([ms],Vp.prototype,"ariaDisabled",void 0),Ms([ms],Vp.prototype,"ariaExpanded",void 0),Ms([ms],Vp.prototype,"ariaMultiSelectable",void 0),cu(Vp,iu),cu(Rp,Vp);const Mp="above",zp="below";class Np extends Rp{}class Up extends(Iu(Np)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class Bp extends Up{constructor(){super(...arguments),this._value="",this.filteredOptions=[],this.filter="",this.forcedPosition=!1,this.listboxId=Pp("listbox-"),this.maxHeight=0,this.open=!1}formResetCallback(){super.formResetCallback(),this.setDefaultSelectedOption(),this.updateValue()}validate(){super.validate(this.control)}get isAutocompleteInline(){return"inline"===this.autocomplete||this.isAutocompleteBoth}get isAutocompleteList(){return"list"===this.autocomplete||this.isAutocompleteBoth}get isAutocompleteBoth(){return"both"===this.autocomplete}openChanged(){if(this.open)return this.ariaControls=this.listboxId,this.ariaExpanded="true",this.setPositioning(),this.focusAndScrollOptionIntoView(),void ps.queueUpdate((()=>this.focus()));this.ariaControls="",this.ariaExpanded="false"}get options(){return vs.track(this,"options"),this.filteredOptions.length?this.filteredOptions:this._options}set options(e){this._options=e,vs.notify(this,"options")}placeholderChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.placeholder=this.placeholder)}positionChanged(e,t){this.positionAttribute=t,this.setPositioning()}get value(){return vs.track(this,"value"),this._value}set value(e){var t,i,o;const s=`${this._value}`;if(this.$fastController.isConnected&&this.options){const s=this.options.findIndex((t=>t.text.toLowerCase()===e.toLowerCase())),n=null===(t=this.options[this.selectedIndex])||void 0===t?void 0:t.text,r=null===(i=this.options[s])||void 0===i?void 0:i.text;this.selectedIndex=n!==r?s:this.selectedIndex,e=(null===(o=this.firstSelectedOption)||void 0===o?void 0:o.text)||e}s!==e&&(this._value=e,super.valueChanged(s,e),vs.notify(this,"value"))}clickHandler(e){if(!this.disabled){if(this.open){const t=e.target.closest("option,[role=option]");if(!t||t.disabled)return;this.selectedOptions=[t],this.control.value=t.text,this.clearSelectionRange(),this.updateValue(!0)}return this.open=!this.open,this.open&&this.control.focus(),!0}}connectedCallback(){super.connectedCallback(),this.forcedPosition=!!this.positionAttribute,this.value&&(this.initialValue=this.value)}disabledChanged(e,t){super.disabledChanged&&super.disabledChanged(e,t),this.ariaDisabled=this.disabled?"true":"false"}filterOptions(){this.autocomplete&&"none"!==this.autocomplete||(this.filter="");const e=this.filter.toLowerCase();this.filteredOptions=this._options.filter((e=>e.text.toLowerCase().startsWith(this.filter.toLowerCase()))),this.isAutocompleteList&&(this.filteredOptions.length||e||(this.filteredOptions=this._options),this._options.forEach((e=>{e.hidden=!this.filteredOptions.includes(e)})))}focusAndScrollOptionIntoView(){this.contains(document.activeElement)&&(this.control.focus(),this.firstSelectedOption&&requestAnimationFrame((()=>{var e;null===(e=this.firstSelectedOption)||void 0===e||e.scrollIntoView({block:"nearest"})})))}focusoutHandler(e){if(this.syncValue(),!this.open)return!0;const t=e.relatedTarget;this.isSameNode(t)?this.focus():this.options&&this.options.includes(t)||(this.open=!1)}inputHandler(e){if(this.filter=this.control.value,this.filterOptions(),this.isAutocompleteInline||(this.selectedIndex=this.options.map((e=>e.text)).indexOf(this.control.value)),e.inputType.includes("deleteContent")||!this.filter.length)return!0;this.isAutocompleteList&&!this.open&&(this.open=!0),this.isAutocompleteInline&&(this.filteredOptions.length?(this.selectedOptions=[this.filteredOptions[0]],this.selectedIndex=this.options.indexOf(this.firstSelectedOption),this.setInlineSelection()):this.selectedIndex=-1)}keydownHandler(e){const t=e.key;if(e.ctrlKey||e.shiftKey)return!0;switch(t){case"Enter":this.syncValue(),this.isAutocompleteInline&&(this.filter=this.value),this.open=!1,this.clearSelectionRange();break;case"Escape":if(this.isAutocompleteInline||(this.selectedIndex=-1),this.open){this.open=!1;break}this.value="",this.control.value="",this.filter="",this.filterOptions();break;case"Tab":if(this.setInputToSelection(),!this.open)return!0;e.preventDefault(),this.open=!1;break;case"ArrowUp":case"ArrowDown":if(this.filterOptions(),!this.open){this.open=!0;break}this.filteredOptions.length>0&&super.keydownHandler(e),this.isAutocompleteInline&&this.setInlineSelection();break;default:return!0}}keyupHandler(e){switch(e.key){case"ArrowLeft":case"ArrowRight":case"Backspace":case"Delete":case"Home":case"End":this.filter=this.control.value,this.selectedIndex=-1,this.filterOptions()}}selectedIndexChanged(e,t){if(this.$fastController.isConnected){if((t=Lp(-1,this.options.length-1,t))!==this.selectedIndex)return void(this.selectedIndex=t);super.selectedIndexChanged(e,t)}}selectPreviousOption(){!this.disabled&&this.selectedIndex>=0&&(this.selectedIndex=this.selectedIndex-1)}setDefaultSelectedOption(){if(this.$fastController.isConnected&&this.options){const e=this.options.findIndex((e=>null!==e.getAttribute("selected")||e.selected));this.selectedIndex=e,!this.dirtyValue&&this.firstSelectedOption&&(this.value=this.firstSelectedOption.text),this.setSelectedOptions()}}setInputToSelection(){this.firstSelectedOption&&(this.control.value=this.firstSelectedOption.text,this.control.focus())}setInlineSelection(){this.firstSelectedOption&&(this.setInputToSelection(),this.control.setSelectionRange(this.filter.length,this.control.value.length,"backward"))}syncValue(){var e;const t=this.selectedIndex>-1?null===(e=this.firstSelectedOption)||void 0===e?void 0:e.text:this.control.value;this.updateValue(this.value!==t)}setPositioning(){const e=this.getBoundingClientRect(),t=window.innerHeight-e.bottom;this.position=this.forcedPosition?this.positionAttribute:e.top>t?Mp:zp,this.positionAttribute=this.forcedPosition?this.positionAttribute:this.position,this.maxHeight=this.position===Mp?~~e.top:~~t}selectedOptionsChanged(e,t){this.$fastController.isConnected&&this._options.forEach((e=>{e.selected=t.includes(e)}))}slottedOptionsChanged(e,t){super.slottedOptionsChanged(e,t),this.updateValue()}updateValue(e){var t;this.$fastController.isConnected&&(this.value=(null===(t=this.firstSelectedOption)||void 0===t?void 0:t.text)||this.control.value,this.control.value=this.value),e&&this.$emit("change")}clearSelectionRange(){const e=this.control.value.length;this.control.setSelectionRange(e,e)}}Ms([Os({attribute:"autocomplete",mode:"fromView"})],Bp.prototype,"autocomplete",void 0),Ms([ms],Bp.prototype,"maxHeight",void 0),Ms([Os({attribute:"open",mode:"boolean"})],Bp.prototype,"open",void 0),Ms([Os],Bp.prototype,"placeholder",void 0),Ms([Os({attribute:"position"})],Bp.prototype,"positionAttribute",void 0),Ms([ms],Bp.prototype,"position",void 0);class Hp{}Ms([ms],Hp.prototype,"ariaAutoComplete",void 0),Ms([ms],Hp.prototype,"ariaControls",void 0),cu(Hp,Vp),cu(Bp,nu,Hp);const jp=Jn.create("input-placeholder-rest").withDefault((e=>{const t=Jd.getValueFor(e);return $c.getValueFor(e).evaluate(e,t.evaluate(e).rest)})),qp=Jn.create("input-placeholder-hover").withDefault((e=>{const t=Jd.getValueFor(e);return $c.getValueFor(e).evaluate(e,t.evaluate(e).hover)})),Zp=Jn.create("input-filled-placeholder-rest").withDefault((e=>{const t=dc.getValueFor(e);return $c.getValueFor(e).evaluate(e,t.evaluate(e).rest)})),Wp=Jn.create("input-filled-placeholder-hover").withDefault((e=>{const t=dc.getValueFor(e);return $c.getValueFor(e).evaluate(e,t.evaluate(e).hover)})),Gp=(e,t,i)=>ih`
  :host {
    ${Bu}
    color: ${xc};
    fill: currentcolor;
    user-select: none;
    position: relative;
  }

  ${i} {
    box-sizing: border-box;
    position: relative;
    color: inherit;
    border: calc(${Ma} * 1px) solid transparent;
    border-radius: calc(${Ra} * 1px);
    height: calc(${Uu} * 1px);
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
  }

  .control {
    width: 100%;
    outline: none;
  }

  .label {
    display: block;
    color: ${xc};
    cursor: pointer;
    ${Bu}
    margin-bottom: 4px;
  }

  .label__hidden {
    display: none;
    visibility: hidden;
  }

  :host([disabled]) ${i},
  :host([readonly]) ${i},
  :host([disabled]) .label,
  :host([readonly]) .label,
  :host([disabled]) .control,
  :host([readonly]) .control {
    cursor: ${Vu};
  }

  :host([disabled]) {
    opacity: ${Ea};
  }
`,Qp=(e,t,i)=>ih`
  @media (forced-colors: none) {
    :host(:not([disabled]):active)::after {
      left: 50%;
      width: 40%;
      transform: translateX(-50%);
      border-bottom-left-radius: 0;
      border-bottom-right-radius: 0;
    }

    :host(:not([disabled]):focus-within)::after {
      left: 0;
      width: 100%;
      transform: none;
    }

    :host(:not([disabled]):active)::after,
    :host(:not([disabled]):focus-within:not(:active))::after {
      content: '';
      position: absolute;
      height: calc(${za} * 1px);
      bottom: 0;
      border-bottom: calc(${za} * 1px) solid ${Dd};
      border-bottom-left-radius: calc(${Ra} * 1px);
      border-bottom-right-radius: calc(${Ra} * 1px);
      z-index: 2;
      transition: all 300ms cubic-bezier(0.1, 0.9, 0.2, 1);
    }
  }
`,Kp=(e,t,i,o=":not([disabled]):not(:focus-within)")=>ih`
  ${i} {
    background: padding-box linear-gradient(${Yd}, ${Yd}),
      border-box ${Vc};
  }

  :host(${o}:hover) ${i} {
    background: padding-box linear-gradient(${ec}, ${ec}),
      border-box ${Mc};
  }

  :host(:not([disabled]):focus-within) ${i} {
    background: padding-box linear-gradient(${tc}, ${tc}),
      border-box ${Vc};
  }
  
  :host([disabled]) ${i} {
    background: padding-box linear-gradient(${Yd}, ${Yd}),
      border-box ${Ic};
  }

  .control::placeholder {
    color: ${jp};
  }

  :host(${o}:hover) .control::placeholder {
    color: ${qp};
  }
`,Xp=(e,t,i,o=":not([disabled]):not(:focus-within)")=>ih`
  ${i} {
    background: ${cc};
  }

  :host(${o}:hover) ${i} {
    background: ${hc};
  }

  :host(:not([disabled]):focus-within) ${i} {
    background: ${pc};
  }

  :host([disabled]) ${i} {
    background: ${cc};
  }

  .control::placeholder {
    color: ${Zp};
  }

  :host(${o}:hover) .control::placeholder {
    color: ${Wp};
  }
`,Jp=(e,t,i,o=":not([disabled]):not(:focus-within)")=>ih`
  :host {
    color: ${dh.ButtonText};
  }

  ${i} {
    background: ${dh.ButtonFace};
    border-color: ${dh.ButtonText};
  }

  :host(${o}:hover) ${i},
  :host(:not([disabled]):focus-within) ${i} {
    border-color: ${dh.Highlight};
  }

  :host([disabled]) ${i} {
    opacity: 1;
    background: ${dh.ButtonFace};
    border-color: ${dh.GrayText};
  }

  .control::placeholder,
  :host(${o}:hover) .control::placeholder {
    color: ${dh.CanvasText};
  }

  :host(:not([disabled]):focus) ${i} {
    ${Hu}
    outline-color: ${dh.Highlight};
  }

  :host([disabled]) {
    opacity: 1;
    color: ${dh.GrayText};
  }

  :host([disabled]) ::placeholder,
  :host([disabled]) ::-webkit-input-placeholder {
    color: ${dh.GrayText};
  }
`,Yp=".control",eg=":not([disabled]):not([open])",tg="[disabled]",ig=(e,t)=>ih`
    ${nh("inline-flex")}
    
    :host {
      border-radius: calc(${Ra} * 1px);
      box-sizing: border-box;
      color: ${xc};
      fill: currentcolor;
      font-family: ${Na};
      position: relative;
      user-select: none;
      min-width: 250px;
      vertical-align: top;
    }

    .listbox {
      box-shadow: ${wh};
      background: ${_d};
      border-radius: calc(${Va} * 1px);
      box-sizing: border-box;
      display: inline-flex;
      flex-direction: column;
      left: 0;
      max-height: calc(var(--max-height) - (${Uu} * 1px));
      padding: calc((${Aa} - ${Ma} ) * 1px);
      overflow-y: auto;
      position: absolute;
      width: 100%;
      z-index: 1;
      margin: 1px 0;
      border: calc(${Ma} * 1px) solid transparent;
    }

    .listbox[hidden] {
      display: none;
    }

    .control {
      border: calc(${Ma} * 1px) solid transparent;
      border-radius: calc(${Ra} * 1px);
      height: calc(${Uu} * 1px);
      align-items: center;
      box-sizing: border-box;
      cursor: pointer;
      display: flex;
      ${Bu}
      min-height: 100%;
      padding: 0 calc(${Aa} * 2.25px);
      width: 100%;
    }

    :host(:${Nu}) {
      ${Hu}
    }

    :host([disabled]) .control {
      cursor: ${Vu};
      opacity: ${Ea};
      user-select: none;
    }

    :host([open][position='above']) .listbox {
      bottom: calc((${Uu} + ${Aa} * 2) * 1px);
    }

    :host([open][position='below']) .listbox {
      top: calc((${Uu} + ${Aa} * 2) * 1px);
    }

    .selected-value {
      font-family: inherit;
      flex: 1 1 auto;
      text-align: start;
    }

    .indicator {
      flex: 0 0 auto;
      margin-inline-start: 1em;
    }

    slot[name='listbox'] {
      display: none;
      width: 100%;
    }

    :host([open]) slot[name='listbox'] {
      display: flex;
      position: absolute;
    }

    .start {
      margin-inline-end: 11px;
    }

    .end {
      margin-inline-start: 11px;
    }

    .start,
    .end,
    .indicator,
    ::slotted(svg) {
      display: flex;
    }

    ::slotted([role='option']) {
      flex: 0 0 auto;
    }
  `,og=".control",sg=":not([disabled]):not([open])";class ng extends Bp{appearanceChanged(e,t){e!==t&&(this.classList.add(t),this.classList.remove(e))}connectedCallback(){super.connectedCallback(),this.appearance||(this.appearance="outline"),this.listbox&&_d.setValueFor(this.listbox,wd)}}i([Os({mode:"fromView"})],ng.prototype,"appearance",void 0);const rg=ng.compose({baseName:"combobox",baseClass:Bp,shadowOptions:{delegatesFocus:!0},template:(e,t)=>Rr`
    <template
        aria-disabled="${e=>e.ariaDisabled}"
        autocomplete="${e=>e.autocomplete}"
        class="${e=>e.open?"open":""} ${e=>e.disabled?"disabled":""} ${e=>e.position}"
        ?open="${e=>e.open}"
        tabindex="${e=>e.disabled?null:"0"}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        @focusout="${(e,t)=>e.focusoutHandler(t.event)}"
        @keydown="${(e,t)=>e.keydownHandler(t.event)}"
    >
        <div class="control" part="control">
            ${au(0,t)}
            <slot name="control">
                <input
                    aria-activedescendant="${e=>e.open?e.ariaActiveDescendant:null}"
                    aria-autocomplete="${e=>e.ariaAutoComplete}"
                    aria-controls="${e=>e.ariaControls}"
                    aria-disabled="${e=>e.ariaDisabled}"
                    aria-expanded="${e=>e.ariaExpanded}"
                    aria-haspopup="listbox"
                    class="selected-value"
                    part="selected-value"
                    placeholder="${e=>e.placeholder}"
                    role="combobox"
                    type="text"
                    ?disabled="${e=>e.disabled}"
                    :value="${e=>e.value}"
                    @input="${(e,t)=>e.inputHandler(t.event)}"
                    @keyup="${(e,t)=>e.keyupHandler(t.event)}"
                    ${su("control")}
                />
                <div class="indicator" part="indicator" aria-hidden="true">
                    <slot name="indicator">
                        ${t.indicator||""}
                    </slot>
                </div>
            </slot>
            ${ru(0,t)}
        </div>
        <div
            class="listbox"
            id="${e=>e.listboxId}"
            part="listbox"
            role="listbox"
            ?disabled="${e=>e.disabled}"
            ?hidden="${e=>!e.open}"
            ${su("listbox")}
        >
            <slot
                ${Ru({filter:Rp.slottedOptionFilter,flatten:!0,property:"slottedOptions"})}
            ></slot>
        </div>
    </template>
`,styles:(e,t)=>ih`
    ${ig()}

    ${Qp()}

    :host(:empty) .listbox {
      display: none;
    }

    :host([disabled]) *,
    :host([disabled]) {
      cursor: ${Vu};
      user-select: none;
    }

    :host(:active) .selected-value {
      user-select: none;
    }

    .selected-value {
      -webkit-appearance: none;
      background: transparent;
      border: none;
      color: inherit;
      ${Bu}
      height: calc(100% - ${Ma} * 1px));
      margin: auto 0;
      width: 100%;
      outline: none;
    }
  `.withBehaviors(Gu("outline",Kp(0,0,og,sg)),Gu("filled",Xp(0,0,og,sg)),lh(Jp(0,0,og,sg))),indicator:'\n    <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">\n      <path d="M2.15 4.65c.2-.2.5-.2.7 0L6 7.79l3.15-3.14a.5.5 0 11.7.7l-3.5 3.5a.5.5 0 01-.7 0l-3.5-3.5a.5.5 0 010-.7z"/>\n    </svg>\n  '});class ag{constructor(e,t){this.cache=new WeakMap,this.ltr=e,this.rtl=t}bind(e){this.attach(e)}unbind(e){const t=this.cache.get(e);t&&La.unsubscribe(t)}attach(e){const t=this.cache.get(e)||new lg(this.ltr,this.rtl,e),i=La.getValueFor(e);La.subscribe(t),t.attach(i),this.cache.set(e,t)}}class lg{constructor(e,t,i){this.ltr=e,this.rtl=t,this.source=i,this.attached=null}handleChange({target:e,token:t}){this.attach(t.getValueFor(this.source))}attach(e){this.attached!==this[e]&&(null!==this.attached&&this.source.$fastController.removeStyles(this.attached),this.attached=this[e],null!==this.attached&&this.source.$fastController.addStyles(this.attached))}}const dg=Fp.compose({baseName:"option",template:(e,t)=>Rr`
    <template
        aria-checked="${e=>e.ariaChecked}"
        aria-disabled="${e=>e.ariaDisabled}"
        aria-posinset="${e=>e.ariaPosInSet}"
        aria-selected="${e=>e.ariaSelected}"
        aria-setsize="${e=>e.ariaSetSize}"
        class="${e=>[e.checked&&"checked",e.selected&&"selected",e.disabled&&"disabled"].filter(Boolean).join(" ")}"
        role="option"
    >
        ${au(0,t)}
        <span class="content" part="content">
            <slot ${Ru("content")}></slot>
        </span>
        ${ru(0,t)}
    </template>
`,styles:(e,t)=>ih`
    ${nh("inline-flex")} :host {
      position: relative;
      ${Bu}
      background: ${fc};
      border-radius: calc(${Ra} * 1px);
      border: calc(${Ma} * 1px) solid transparent;
      box-sizing: border-box;
      color: ${xc};
      cursor: pointer;
      fill: currentcolor;
      height: calc(${Uu} * 1px);
      overflow: hidden;
      align-items: center;
      padding: 0 calc(((${Aa} * 3) - ${Ma} - 1) * 1px);
      user-select: none;
      white-space: nowrap;
    }

    :host::before {
      content: '';
      display: block;
      position: absolute;
      left: calc((${za} - ${Ma}) * 1px);
      top: calc((${Uu} / 4) - ${za} * 1px);
      width: 3px;
      height: calc((${Uu} / 2) * 1px);
      background: transparent;
      border-radius: calc(${Ra} * 1px);
    }

    :host(:not([disabled]):hover) {
      background: ${vc};
    }

    :host(:not([disabled]):active) {
      background: ${mc};
    }

    :host(:not([disabled]):active)::before {
      background: ${Dd};
      height: calc(((${Uu} / 2) - 6) * 1px);
    }

    :host([aria-selected='true'])::before {
      background: ${Dd};
    }

    :host(:${Nu}) {
      ${Hu}
      background: ${bc};
    }

    :host([aria-selected='true']) {
      background: ${cc};
    }

    :host(:not([disabled])[aria-selected='true']:hover) {
      background: ${hc};
    }

    :host(:not([disabled])[aria-selected='true']:active) {
      background: ${uc};
    }

    :host(:not([disabled]):not([aria-selected='true']):hover) {
      background: ${vc};
    }

    :host(:not([disabled]):not([aria-selected='true']):active) {
      background: ${mc};
    }

    :host([disabled]) {
      cursor: ${Vu};
      opacity: ${Ea};
    }

    .content {
      grid-column-start: 2;
      justify-self: start;
      overflow: hidden;
      text-overflow: ellipsis;
    }

    .start,
    .end,
    ::slotted(svg) {
      display: flex;
    }

    ::slotted([slot='end']) {
      margin-inline-start: 1ch;
    }

    ::slotted([slot='start']) {
      margin-inline-end: 1ch;
    }
  `.withBehaviors(new ag(null,ih`
      :host::before {
        right: calc((${za} - ${Ma}) * 1px);
      }
    `),lh(ih`
        :host {
          background: ${dh.ButtonFace};
          border-color: ${dh.ButtonFace};
          color: ${dh.ButtonText};
        }
        :host(:not([disabled]):not([aria-selected="true"]):hover),
        :host(:not([disabled])[aria-selected="true"]:hover),
        :host([aria-selected="true"]) {
          forced-color-adjust: none;
          background: ${dh.Highlight};
          color: ${dh.HighlightText};
        }
        :host(:not([disabled]):active)::before,
        :host([aria-selected='true'])::before {
          background: ${dh.HighlightText};
        }
        :host([disabled]),
        :host([disabled]:not([aria-selected='true']):hover) {
          background: ${dh.Canvas};
          color: ${dh.GrayText};
          fill: currentcolor;
          opacity: 1;
        }
        :host(:${Nu}) {
          outline-color: ${dh.CanvasText};
        }
      `))}),cg=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{--max-height:var(--picker-max-height, 380px);font-family:var(--default-font-family)}:host .picker{background-color:var(--picker-background-color,transparent)}:host fluent-combobox::part(selected-value)::placeholder{color:var(--picker-text-color,var(--input-filled-placeholder-rest))}:host fluent-combobox::part(selected-value):hover::placeholder{color:var(--picker-text-color-hover,var(--secondary-text-hover-color))}[dir=rtl] .picker{direction:rtl}
`];var hg=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},ug=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(rg,dg);let pg=class extends Nt{get strings(){return Tp}static get styles(){return cg}constructor(){super(),this.version="v1.0",this.maxPages=3,this.scopes=[],this.cacheEnabled=!1,this.cacheInvalidationPeriod=0,this.handleComboboxKeydown=e=>{let t,i;const o=e.key,s=e.target.querySelector(".selected");s&&(t=s.getAttribute("value")),"Enter"===o&&t&&(i=this.response.filter((e=>e.id===t)).pop(),this.fireCustomEvent("selectionChanged",i,!0,!1,!0))},this.placeholder=this.strings.comboboxPlaceholder,this.entityType=null,this.keyName=null,this.isRefreshing=!1}refresh(e=!1){this.isRefreshing=!0,e&&this.clearState(),this.requestStateUpdate(e)}clearState(){this.response=null,this.error=null}render(){var e;if(this.isLoadingState&&!this.response)return this.renderTemplate("loading",null);if(this.hasTemplate("error")){const e=this.error?this.error:null;return this.renderTemplate("error",{error:e},"error")}return this.hasTemplate("no-data")?this.renderTemplate("no-data",null):(null===(e=this.response)||void 0===e?void 0:e.length)>0?this.renderPicker():this.renderGet()}renderPicker(){return pi`
      <fluent-combobox
        @keydown=${this.handleComboboxKeydown}
        current-value=${Ao(this.selectedValue)}
        part="picker"
        class="picker"
        id="combobox"
        autocomplete="list"
        placeholder=${this.placeholder}>
          ${this.response.map((e=>Je`
            <fluent-option value=${e.id} @click=${t=>this.handleClick(t,e)}> ${e[this.keyName]} </fluent-option>`))}
      </fluent-combobox>
     `}renderGet(){return pi`
      <mgt-get
        class="mgt-get"
        resource=${this.resource}
        version=${this.version}
        .scopes=${this.scopes}
        max-pages=${this.maxPages}
        ?cache-enabled=${this.cacheEnabled}
        ?cache-invalidation-period=${this.cacheInvalidationPeriod}>
      </mgt-get>`}loadState(){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){if(!this.response){const e=this.renderRoot.querySelector(".mgt-get");e?e.addEventListener("dataChange",(e=>this.handleDataChange(e))):console.error("🦒: mgt-picker component requires a child mgt-get component. Something has gone horribly wrong.")}this.isRefreshing=!1,yield Promise.resolve()}))}handleDataChange(e){const t=e.detail.response.value,i=e.detail.error?e.detail.error:null;this.response=t,this.error=i}handleClick(e,t){this.fireCustomEvent("selectionChanged",t,!0,!1,!0)}};hg([Ct({attribute:"resource",type:String}),ug("design:type",String)],pg.prototype,"resource",void 0),hg([Ct({attribute:"version",type:String}),ug("design:type",Object)],pg.prototype,"version",void 0),hg([Ct({attribute:"max-pages",type:Number}),ug("design:type",Object)],pg.prototype,"maxPages",void 0),hg([Ct({attribute:"placeholder",type:String}),ug("design:type",String)],pg.prototype,"placeholder",void 0),hg([Ct({attribute:"key-name",type:String}),ug("design:type",String)],pg.prototype,"keyName",void 0),hg([Ct({attribute:"entity-type",type:String}),ug("design:type",String)],pg.prototype,"entityType",void 0),hg([Ct({attribute:"scopes",converter:e=>e?e.toLowerCase().split(","):null}),ug("design:type",Array)],pg.prototype,"scopes",void 0),hg([Ct({attribute:"cache-enabled",type:Boolean}),ug("design:type",Object)],pg.prototype,"cacheEnabled",void 0),hg([Ct({attribute:"cache-invalidation-period",type:Number}),ug("design:type",Object)],pg.prototype,"cacheInvalidationPeriod",void 0),hg([Ct({attribute:"selected-value",type:String}),ug("design:type",String)],pg.prototype,"selectedValue",void 0),hg([$t(),ug("design:type",Array)],pg.prototype,"response",void 0),pg=hg([gi("picker"),ug("design:paramtypes",[])],pg);const gg={termsetIdRequired:"The termsetId property or termset-id attribute is required",noTermsFound:"No terms found",comboboxPlaceholder:"Select a term",loadingMessage:"Loading..."},fg=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{--max-height:var(--taxonomy-picker-list-max-height, 380px)}:host .picker{background-color:var(--taxonomy-picker-background-color,transparent)}:host fluent-combobox::part(selected-value)::placeholder{color:var(--taxonomy-picker-placeholder-color,var(--input-filled-placeholder-rest))}:host fluent-combobox::part(selected-value):hover::placeholder{color:var(--taxonomy-picker-placeholder-color-hover,var(--secondary-text-hover-color))}[dir=rtl] .picker{direction:rtl}
`];var vg=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},mg=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(rg,dg);let bg=class extends Nt{get strings(){return gg}static get styles(){return fg}get defaultSelectedTermId(){return this._defaultSelectedTermId}set defaultSelectedTermId(e){e!==this._defaultSelectedTermId&&(this._defaultSelectedTermId=e,this.requestStateUpdate(!0))}get selectedTerm(){return this._selectedTerm}set selectedTerm(e){this._selectedTerm=e}constructor(){super(),this.version="beta",this.position="below",this.cacheEnabled=!1,this.cacheInvalidationPeriod=0,this.placeholder=this.strings.comboboxPlaceholder,this.isRefreshing=!1,this.noTerms=!1}refresh(e=!1){this.isRefreshing=!0,e&&this.clearState(),this.requestStateUpdate(e)}clearState(){this.terms=null,this.error=null,this.noTerms=!1}render(){var e;return this.isLoadingState&&!this.terms?this.renderLoading():this.error?this.renderError():this.noTerms?this.renderNoData():(null===(e=this.terms)||void 0===e?void 0:e.length)>0?this.renderTaxonomyPicker():this.renderGet()}renderLoading(){return this.renderTemplate("loading",null,"loading")||pi`
        <div class="message-parent">
          <mgt-spinner></mgt-spinner>
          <div label="loading-text" aria-label="loading">
            ${this.strings.loadingMessage}
          </div>
        </div>
      `}renderError(){return this.renderTemplate("error",null,"error")||Je`
              <span>
                ${this.error}
            </span>
          `}renderNoData(){return this.renderTemplate("no-data",null)||Je`
            <span>
              ${this.strings.noTermsFound}
            </span>
          `}renderTaxonomyPicker(){return pi`
      <fluent-combobox class="taxonomy-picker" autocomplete="both" placeholder=${this.placeholder} position=${this.position} ?disabled=${this.disabled}>
        ${this.terms.map((e=>this.renderTaxonomyPickerItem(e)))}
      </fluent-combobox>
     `}renderTaxonomyPickerItem(e){const t=this.defaultSelectedTermId&&this.defaultSelectedTermId===e.id;return Je`
        <fluent-option value=${e.id} ?selected=${t} @click=${t=>this.handleClick(t,e)}> ${this.renderTemplate("term",{term:e},e.id)||e.labels[0].name} </fluent-option>
        `}renderGet(){if(!this.termsetId)return Je`
            <span>
                ${this.strings.termsetIdRequired}
            </span>
            `;let e=`/termStore/sets/${this.termsetId}/children`;return this.termId&&(e=`/termStore/sets/${this.termsetId}/terms/${this.termId}/children`),this.siteId&&(e=`/sites/${this.siteId}${e}`),e+="?$select=id,labels,descriptions,properties",pi`
      <mgt-get
        class="mgt-get"
        resource=${e}
        version=${this.version}
        scopes=${["TermStore.Read.All"]}
        ?cache-enabled=${this.cacheEnabled}
        ?cache-invalidation-period=${this.cacheInvalidationPeriod}>
      </mgt-get>`}loadState(){return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){this.terms||this.renderRoot.querySelector(".mgt-get").addEventListener("dataChange",(e=>this.handleDataChange(e))),this.isRefreshing=!1,yield Promise.resolve()}))}handleDataChange(e){const t=e.detail.error?e.detail.error:null;if(t)return void(this.error=t);this.locale&&(this.locale=this.locale.toLowerCase());const i=e.detail.response.value.map((e=>{const t=e.labels;if(t&&t.length>0&&this.locale){const i=t.find((e=>e.languageTag.toLowerCase()===this.locale));i&&(e.labels=[i,...t.filter((e=>e.languageTag.toLowerCase()!==this.locale))])}return e}));this.terms=i,0===i.length&&(this.noTerms=!0)}handleClick(e,t){this.selectedTerm=t,this.fireCustomEvent("selectionChanged",t)}};vg([Ct({attribute:"term-set-id",type:String}),mg("design:type",String)],bg.prototype,"termsetId",void 0),vg([Ct({attribute:"term-id",type:String}),mg("design:type",String)],bg.prototype,"termId",void 0),vg([Ct({attribute:"site-id",type:String}),mg("design:type",String)],bg.prototype,"siteId",void 0),vg([Ct({attribute:"locale",type:String}),mg("design:type",String)],bg.prototype,"locale",void 0),vg([Ct({attribute:"version",type:String}),mg("design:type",Object)],bg.prototype,"version",void 0),vg([Ct({attribute:"placeholder",type:String}),mg("design:type",String)],bg.prototype,"placeholder",void 0),vg([Ct({attribute:"position",type:String,converter:e=>"above"===e?"above":"below"}),mg("design:type",String)],bg.prototype,"position",void 0),vg([Ct({attribute:"default-selected-term-id",type:String}),mg("design:type",String),mg("design:paramtypes",[String])],bg.prototype,"defaultSelectedTermId",null),vg([Ct({attribute:"selected-term",type:Object}),mg("design:type",Object),mg("design:paramtypes",[Object])],bg.prototype,"selectedTerm",null),vg([Ct({attribute:"disabled",type:Boolean}),mg("design:type",Boolean)],bg.prototype,"disabled",void 0),vg([Ct({attribute:"cache-enabled",type:Boolean}),mg("design:type",Object)],bg.prototype,"cacheEnabled",void 0),vg([Ct({attribute:"cache-invalidation-period",type:Number}),mg("design:type",Object)],bg.prototype,"cacheInvalidationPeriod",void 0),vg([$t(),mg("design:type",Array)],bg.prototype,"terms",void 0),vg([$t(),mg("design:type",Boolean)],bg.prototype,"noTerms",void 0),bg=vg([gi("taxonomy-picker"),mg("design:paramtypes",[])],bg);var yg=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},wg=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};const xg=e=>Array.isArray(null==e?void 0:e.value);var kg;!function(e){e.json="json",e.image="image"}(kg||(kg={}));const Cg=()=>ai.config.response.isEnabled&&ai.config.isEnabled;let $g=class extends Nt{constructor(){super(...arguments),this.scopes=[],this.version="v1.0",this.type=kg.json,this.maxPages=3,this.pollingRate=0,this.cacheEnabled=!1,this.cacheInvalidationPeriod=0,this.isPolling=!1,this.isRefreshing=!1}attributeChangedCallback(e,t,i){super.attributeChangedCallback(e,t,i),this.requestStateUpdate()}refresh(e=!1){this.isRefreshing=!0,e&&this.clearState(),this.requestStateUpdate(e)}clearState(){this.response=null}render(){if(this.isLoadingState&&!this.response)return this.renderTemplate("loading",null);if(this.error)return this.renderTemplate("error",this.error);if(this.hasTemplate("value")&&xg(this.response)){let e;if(xg(this.response)){let t=null;this.isLoadingState&&!this.isPolling&&(t=this.renderTemplate("loading",null)),e=Je`
          ${this.response.value.map((e=>this.renderTemplate("value",e,e.id)))} ${t}
        `}else e=this.renderTemplate("value",this.response);if(this.hasTemplate("default")){const t=this.renderTemplate("default",this.response);return this.templates.value.templateOrder>this.templates.default.templateOrder?Je`
            ${t}${e}
          `:Je`
            ${e}${t}
          `}return e}return this.response?this.renderTemplate("default",this.response)||Je``:this.hasTemplate("no-data")?this.renderTemplate("no-data",null):Je``}loadState(){var e,t,i;return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){const o=te.globalProvider;if(this.error=null,o&&o.state===Q.SignedIn){if(this.resource){try{let s;const n=`${this.version}${this.resource}`;let r=null;if(this.shouldRetrieveCache()){s=ai.getCache(Mi,Mi.stores.responses);const e=Cg()?yield s.getValue(n):null;e&&(this.cacheInvalidationPeriod||ai.config.response.invalidationPeriod||ai.config.defaultInvalidationPeriod)>Date.now()-e.timeCached&&(r=JSON.parse(e.response))}if(!r){let a=this.resource,l=!1;(null===(e=this.response)||void 0===e?void 0:e["@odata.deltaLink"])?(a=this.response["@odata.deltaLink"],l=!0):l=new URL(a,"https://graph.microsoft.com").pathname.endsWith("delta");const d=o.graph.forComponent(this);let c=d.api(a).version(this.version);if((null===(t=this.scopes)||void 0===t?void 0:t.length)&&(c=c.middlewareOptions(ie(...this.scopes))),this.type===kg.json){if(r=yield c.get(),l&&xg(this.response)&&xg(r)){const e=r.value;r.value=this.response.value.concat(e)}if(this.isPolling||Ft(this.response,r)||(this.response=r),xg(r)&&r["@odata.nextLink"]){let e=1,t=r;for(;(e<this.maxPages||this.maxPages<=0||l&&this.pollingRate)&&(null==t?void 0:t["@odata.nextLink"]);){e++;const o=t["@odata.nextLink"].split(this.version)[1];t=yield d.client.api(o).version(this.version).get(),(null===(i=null==t?void 0:t.value)||void 0===i?void 0:i.length)&&(t.value=r.value.concat(t.value),r=t,this.isPolling||(this.response=r))}}}else{if(-1===this.resource.indexOf("/photo/$value")&&-1===this.resource.indexOf("/thumbnails/"))throw new Error("Only /photo/$value and /thumbnails/ endpoints support the image type");let e;if(this.resource.indexOf("/photo/$value")>-1){const t=this.resource.replace("/photo/$value",""),i=yield co(d,t,this.scopes);i&&(e=i.photo)}else if(this.resource.indexOf("/thumbnails/")>-1){const t=yield((e,t,i)=>Ph(void 0,void 0,void 0,(function*(){try{const o=yield e.api(t).responseType(k.RAW).middlewareOptions(ie(...i)).get();return 404===o.status?{eTag:null,thumbnail:null}:o.ok?{eTag:o.headers.get("eTag"),thumbnail:yield Si(yield o.blob())}:null}catch(e){return null}})))(d,this.resource,this.scopes);t&&(e=t.thumbnail)}e&&(r={image:e})}this.shouldUpdateCache()&&r&&(s=ai.getCache(Mi,Mi.stores.responses),yield s.putValue(n,{response:JSON.stringify(r)}))}Ft(this.response,r)||(this.response=r)}catch(e){this.error=e}this.response&&(this.error=null,this.pollingRate&&setTimeout((()=>{this.isPolling=!0,this.loadState().finally((()=>{this.isPolling=!1}))}),this.pollingRate))}else this.response=null;this.isRefreshing=!1,this.fireCustomEvent("dataChange",{response:this.response,error:this.error})}}))}shouldRetrieveCache(){return Cg()&&this.cacheEnabled&&!(this.isRefreshing||this.isPolling)}shouldUpdateCache(){return Cg()&&this.cacheEnabled}};yg([Ct({attribute:"resource",reflect:!0,type:String}),wg("design:type",String)],$g.prototype,"resource",void 0),yg([Ct({attribute:"scopes",converter:(e,t)=>e?e.toLowerCase().split(","):null,reflect:!0}),wg("design:type",Array)],$g.prototype,"scopes",void 0),yg([Ct({attribute:"version",reflect:!0,type:String}),wg("design:type",Object)],$g.prototype,"version",void 0),yg([Ct({attribute:"type",reflect:!0,type:kg}),wg("design:type",String)],$g.prototype,"type",void 0),yg([Ct({attribute:"max-pages",reflect:!0,type:Number}),wg("design:type",Object)],$g.prototype,"maxPages",void 0),yg([Ct({attribute:"polling-rate",reflect:!0,type:Number}),wg("design:type",Object)],$g.prototype,"pollingRate",void 0),yg([Ct({attribute:"cache-enabled",reflect:!0,type:Boolean}),wg("design:type",Object)],$g.prototype,"cacheEnabled",void 0),yg([Ct({attribute:"cache-invalidation-period",type:Number}),wg("design:type",Object)],$g.prototype,"cacheInvalidationPeriod",void 0),yg([Ct({attribute:!1}),wg("design:type",Object)],$g.prototype,"response",void 0),yg([Ct({attribute:!1}),wg("design:type",Object)],$g.prototype,"error",void 0),$g=yg([gi("get")],$g);const Sg=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .signed-in-person{--person-background-color:$signed-in-background-color;padding:var(--login-button-padding,10px 16px)}:host .account{padding:0;margin:7px 0}:host fluent-button.signed-in{height:auto;min-width:auto}:host fluent-button.signed-in::part(control){width:100%;height:100%;padding:var(--login-button-padding,0);background:var(--login-signed-in-background,transparent);word-spacing:inherit;text-indent:inherit;letter-spacing:inherit}:host fluent-button.signed-in::part(control):focus-within,:host fluent-button.signed-in::part(control):hover{background:var(--login-signed-in-hover-background,var(--neutral-fill-stealth-hover));--secondary-text-color:var(--secondary-text-hover-color)}:host fluent-button.signed-out::part(control){color:var(--login-signed-out-button-text-color,var(--neutral-fill-foreground-rest));background:var(--login-signed-out-button-background,padding-box linear-gradient(var(--neutral-fill-rest),var(--neutral-fill-rest)),border-box var(--neutral-stroke-control-rest))}:host fluent-button.signed-out::part(control):focus-within,:host fluent-button.signed-out::part(control):hover{background:var(--login-signed-out-button-hover-background,var(--neutral-fill-stealth-hover))}:host fluent-button.small::part(control):hover{background:0 0}:host fluent-button:focus-visible{outline-style:var(--focus-ring-style,auto)}:host fluent-card{--fill-color:var(--login-popup-background-color, var(--neutral-layer-1));padding:var(--login-popup-padding,16px)}:host .login-root .small .signed-in-person{padding:0;background:0 0}:host .login-root .small .signed-in-person:focus-within,:host .login-root .small .signed-in-person:hover{background:0 0}:host .login-root .account-list{padding:calc(var(--design-unit) * 1px) 0;margin:0}:host .login-root .account-item{height:auto;min-width:auto;margin-top:4px;background:var(--login-popup-background-color,var(--neutral-layer-1));list-style-type:none;cursor:pointer}:host .login-root .account-item:hover{background:var(--login-account-item-hover-bg-color,var(--neutral-fill-stealth-hover));--person-background-color:$login-account-item-hover-bg-color}:host .login-root .flyout .flyout-command{color:var(--login-flyout-command-text-color,var(--accent-foreground-rest))}:host .login-root .flyout .popup-content .commands{display:flex;align-items:flex-end;justify-content:flex-end}:host .login-root .flyout .popup-content .commands fluent-button::part(control){color:var(--login-command-button-text-color,var(--neutral-fill-foreground-rest));background:var(--login-command-button-background-color,var(--neutral-fill-stealth-rest));word-spacing:inherit;text-indent:inherit;letter-spacing:inherit}:host .login-root .flyout .popup-content .commands fluent-button::part(control):hover{background:var(--login-command-button-hover-background-color,var(--neutral-fill-stealth-hover))}:host .login-root .flyout .popup-content .content .main-profile{margin-bottom:56px;margin-top:27px}:host .login-root .flyout .popup-content .add-account{padding-top:16px}:host .login-root .flyout .popup-content .add-account fluent-button::part(control){color:var(--login-add-account-button-text-color,var(--neutral-fill-foreground-rest));background:var(--login-add-account-button-background-color,var(--neutral-fill-stealth-rest));word-spacing:inherit;text-indent:inherit;letter-spacing:inherit}:host .login-root .flyout .popup-content .add-account fluent-button::part(control):hover{background:var(--login-add-account-button-hover-background-color,var(--neutral-fill-stealth-hover))}
`],_g={signInLinkSubtitle:"Sign In",signOutLinkSubtitle:"Sign Out",signInWithADifferentAccount:"Sign in with a different account"};class Ig extends Rp{constructor(){super(...arguments),this.activeIndex=-1,this.rangeStartIndex=-1}get activeOption(){return this.options[this.activeIndex]}get checkedOptions(){var e;return null===(e=this.options)||void 0===e?void 0:e.filter((e=>e.checked))}get firstSelectedOptionIndex(){return this.options.indexOf(this.firstSelectedOption)}activeIndexChanged(e,t){var i,o;this.ariaActiveDescendant=null!==(o=null===(i=this.options[t])||void 0===i?void 0:i.id)&&void 0!==o?o:"",this.focusAndScrollOptionIntoView()}checkActiveIndex(){if(!this.multiple)return;const e=this.activeOption;e&&(e.checked=!0)}checkFirstOption(e=!1){e?(-1===this.rangeStartIndex&&(this.rangeStartIndex=this.activeIndex+1),this.options.forEach(((e,t)=>{e.checked=Ep(t,this.rangeStartIndex)}))):this.uncheckAllOptions(),this.activeIndex=0,this.checkActiveIndex()}checkLastOption(e=!1){e?(-1===this.rangeStartIndex&&(this.rangeStartIndex=this.activeIndex),this.options.forEach(((e,t)=>{e.checked=Ep(t,this.rangeStartIndex,this.options.length)}))):this.uncheckAllOptions(),this.activeIndex=this.options.length-1,this.checkActiveIndex()}connectedCallback(){super.connectedCallback(),this.addEventListener("focusout",this.focusoutHandler)}disconnectedCallback(){this.removeEventListener("focusout",this.focusoutHandler),super.disconnectedCallback()}checkNextOption(e=!1){e?(-1===this.rangeStartIndex&&(this.rangeStartIndex=this.activeIndex),this.options.forEach(((e,t)=>{e.checked=Ep(t,this.rangeStartIndex,this.activeIndex+1)}))):this.uncheckAllOptions(),this.activeIndex+=this.activeIndex<this.options.length-1?1:0,this.checkActiveIndex()}checkPreviousOption(e=!1){e?(-1===this.rangeStartIndex&&(this.rangeStartIndex=this.activeIndex),1===this.checkedOptions.length&&(this.rangeStartIndex+=1),this.options.forEach(((e,t)=>{e.checked=Ep(t,this.activeIndex,this.rangeStartIndex)}))):this.uncheckAllOptions(),this.activeIndex-=this.activeIndex>0?1:0,this.checkActiveIndex()}clickHandler(e){var t;if(!this.multiple)return super.clickHandler(e);const i=null===(t=e.target)||void 0===t?void 0:t.closest("[role=option]");return i&&!i.disabled?(this.uncheckAllOptions(),this.activeIndex=this.options.indexOf(i),this.checkActiveIndex(),this.toggleSelectedForAllCheckedOptions(),!0):void 0}focusAndScrollOptionIntoView(){super.focusAndScrollOptionIntoView(this.activeOption)}focusinHandler(e){if(!this.multiple)return super.focusinHandler(e);this.shouldSkipFocus||e.target!==e.currentTarget||(this.uncheckAllOptions(),-1===this.activeIndex&&(this.activeIndex=-1!==this.firstSelectedOptionIndex?this.firstSelectedOptionIndex:0),this.checkActiveIndex(),this.setSelectedOptions(),this.focusAndScrollOptionIntoView()),this.shouldSkipFocus=!1}focusoutHandler(e){this.multiple&&this.uncheckAllOptions()}keydownHandler(e){if(!this.multiple)return super.keydownHandler(e);if(this.disabled)return!0;const{key:t,shiftKey:i}=e;switch(this.shouldSkipFocus=!1,t){case bu:return void this.checkFirstOption(i);case uu:return void this.checkNextOption(i);case fu:return void this.checkPreviousOption(i);case yu:return void this.checkLastOption(i);case xu:return this.focusAndScrollOptionIntoView(),!0;case mu:return this.uncheckAllOptions(),this.checkActiveIndex(),!0;case wu:if(e.preventDefault(),this.typeAheadExpired)return void this.toggleSelectedForAllCheckedOptions();default:return 1===t.length&&this.handleTypeAhead(`${t}`),!0}}mousedownHandler(e){if(e.offsetX>=0&&e.offsetX<=this.scrollWidth)return super.mousedownHandler(e)}multipleChanged(e,t){var i;this.ariaMultiSelectable=t?"true":null,null===(i=this.options)||void 0===i||i.forEach((e=>{e.checked=!t&&void 0})),this.setSelectedOptions()}setSelectedOptions(){this.multiple?this.$fastController.isConnected&&this.options&&(this.selectedOptions=this.options.filter((e=>e.selected)),this.focusAndScrollOptionIntoView()):super.setSelectedOptions()}sizeChanged(e,t){var i;const o=Math.max(0,parseInt(null!==(i=null==t?void 0:t.toFixed())&&void 0!==i?i:"",10));o!==t&&ps.queueUpdate((()=>{this.size=o}))}toggleSelectedForAllCheckedOptions(){const e=this.checkedOptions.filter((e=>!e.disabled)),t=!e.every((e=>e.selected));e.forEach((e=>e.selected=t)),this.selectedIndex=this.options.indexOf(e[e.length-1]),this.setSelectedOptions()}typeaheadBufferChanged(e,t){if(this.multiple){if(this.$fastController.isConnected){const e=this.getTypeaheadMatches(),t=this.options.indexOf(e[0]);t>-1&&(this.activeIndex=t,this.uncheckAllOptions(),this.checkActiveIndex()),this.typeAheadExpired=!1}}else super.typeaheadBufferChanged(e,t)}uncheckAllOptions(e=!1){this.options.forEach((e=>e.checked=!this.multiple&&void 0)),e||(this.rangeStartIndex=-1)}}Ms([ms],Ig.prototype,"activeIndex",void 0),Ms([Os({mode:"boolean"})],Ig.prototype,"multiple",void 0),Ms([Os({converter:Ls})],Ig.prototype,"size",void 0);const Tg=class extends Rp{}.compose({baseName:"listbox",template:(e,t)=>Rr`
    <template
        aria-activedescendant="${e=>e.ariaActiveDescendant}"
        aria-multiselectable="${e=>e.ariaMultiSelectable}"
        class="listbox"
        role="listbox"
        tabindex="${e=>e.disabled?null:"0"}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        @focusin="${(e,t)=>e.focusinHandler(t.event)}"
        @keydown="${(e,t)=>e.keydownHandler(t.event)}"
        @mousedown="${(e,t)=>e.mousedownHandler(t.event)}"
    >
        <slot
            ${Ru({filter:Ig.slottedOptionFilter,flatten:!0,property:"slottedOptions"})}
        ></slot>
    </template>
`,styles:(e,t)=>ih`
    ${nh("inline-flex")} :host {
      border: calc(${Ma} * 1px) solid ${Ic};
      border-radius: calc(${Ra} * 1px);
      box-sizing: border-box;
      flex-direction: column;
      padding: calc(${Aa} * 1px) 0;
    }

    ::slotted(${e.tagFor(Fp)}) {
      margin: 0 calc(${Aa} * 1px);
    }

    :host(:focus-within:not([disabled])) {
      ${Hu}
    }
  `});var Dg=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Pg=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},Lg=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(Tg,Cp,Ju,$h);let Eg=class extends Nt{static get styles(){return Sg}get strings(){return _g}get flyout(){return this.renderRoot.querySelector(".flyout")}static get requiredScopes(){return[...new Set(["user.read",...No.requiredScopes])]}get _userDetailsKey(){return"-userDetails"}constructor(){super(),this.showPresence=!1,this.loginView="full",this._arrowKeyLocation=-1,this.logout=()=>Lg(this,void 0,void 0,(function*(){if(!this.fireCustomEvent("logoutInitiated"))return;const e=te.globalProvider;(null==e?void 0:e.isMultiAccountSupportedAndEnabled)&&localStorage.removeItem(e.getActiveAccount().id+this._userDetailsKey),(null==e?void 0:e.logout)&&(yield e.logout(),this.userDetails=null,e.isMultiAccountSupportedAndEnabled&&localStorage.removeItem(e.getActiveAccount().id+this._userDetailsKey),this.hideFlyout(),this.fireCustomEvent("logoutCompleted"))})),this.flyoutOpened=()=>{this._isFlyoutOpen=!0},this.flyoutClosed=()=>{this._isFlyoutOpen=!1},this.onUserKeyDown=e=>{if(!this.flyout.isOpen)return;const t=this.renderRoot.querySelector(".popup-content"),i=t.querySelectorAll("ul, fluent-button"),o=t.querySelector("#signout-button")||i[0],s=t.querySelector("#signin-different-account-button")||i[i.length-1];if("Tab"===e.key&&e.shiftKey&&o===e.target&&(e.preventDefault(),null==s||s.focus()),"Tab"!==e.key||e.shiftKey||s!==e.target||(e.preventDefault(),null==o||o.focus()),"Escape"===e.key){const e=this.renderRoot.querySelector("#login-button");null==e||e.focus()}const n=this.renderRoot.querySelector("fluent-card");e.shiftKey&&"Tab"===e.key&&e.target===n&&this.hideFlyout()},this.handleAccountListKeyDown=e=>{const t=this.renderRoot.querySelector("ul.account-list");let i;const o=null==t?void 0:t.children;for(const e of o){const t=e;t.setAttribute("tabindex","-1"),t.blur()}const s=t.childElementCount,n=e.key;if("ArrowDown"===n)this._arrowKeyLocation=(this._arrowKeyLocation+1+s)%s;else if("ArrowUp"===n)this._arrowKeyLocation=(this._arrowKeyLocation-1+s)%s;else if("Tab"===n||"Escape"===n)return this._arrowKeyLocation=-1,t.blur(),void("Escape"===n&&(e.preventDefault(),e.stopPropagation()));this._arrowKeyLocation>-1&&(i=o[this._arrowKeyLocation],i.setAttribute("tabindex","1"),i.focus())},this.onClick=()=>{this.userDetails&&this._isFlyoutOpen?this.hideFlyout():this.userDetails?this.showFlyout():this.login()},this._isFlyoutOpen=!1}connectedCallback(){super.connectedCallback(),this.addEventListener("click",(e=>e.stopPropagation()))}login(){return Lg(this,void 0,void 0,(function*(){const e=te.globalProvider;(e.isMultiAccountSupportedAndEnabled||!this.userDetails&&this.fireCustomEvent("loginInitiated"))&&(null==e?void 0:e.login)&&(yield e.login(),e.state===Q.SignedIn?this.fireCustomEvent("loginCompleted"):this.fireCustomEvent("loginFailed"))}))}render(){return Je`
      <div class="login-root">
        ${this.renderButton()}
        ${this.renderFlyout()}
      </div>
    `}loadState(){return Lg(this,void 0,void 0,(function*(){const e=te.globalProvider;e&&!this.userDetails&&(e.state===Q.SignedIn?(this.userDetails=yield wo(e.graph.forComponent(this)),this.userDetails.personImage&&(this._image=this.userDetails.personImage),e.isMultiAccountSupportedAndEnabled&&localStorage.setItem(te.globalProvider.getActiveAccount().id+this._userDetailsKey,JSON.stringify(this.userDetails)),this.fireCustomEvent("loginCompleted")):this.userDetails=null)}))}renderButton(){var e;const t=(null===(e=te.globalProvider)||void 0===e?void 0:e.state)===Q.SignedIn,i=ki({"signed-in":t&&Boolean(this.userDetails),"signed-out":!t,small:"avatar"===this.loginView}),o=t?"stealth":"neutral",s=t&&this.userDetails,n=s?this.renderSignedInButtonContent(this.userDetails,this._image):this.renderSignedOutButtonContent(),r=s?this._isFlyoutOpen:void 0;return Je`
      <fluent-button
        id="login-button"
        aria-expanded="${Ao(r)}"
        appearance=${o}
        aria-label="${Ao(t?void 0:this.strings.signInLinkSubtitle)}"
        ?disabled=${this.isLoadingState}
        @click=${this.onClick}
        class=${i}>
          ${n}
      </fluent-button>`}renderFlyout(){return pi`
      <mgt-flyout
        class="flyout"
        light-dismiss
        @opened=${this.flyoutOpened}
        @closed=${this.flyoutClosed}>
        <fluent-card 
          slot="flyout" 
          tabindex="0" 
          class="flyout-card"
          @keydown=${this.onUserKeyDown}
          >
          ${this.renderFlyoutContent()}
        </fluent-card>
      </mgt-flyout>`}renderFlyoutContent(){if(this.userDetails)return Je`
       <div class="popup">
         <div class="popup-content">
           <div class="commands">
             ${this.renderFlyoutCommands()}
           </div>
           <div class="content">
             <div class="main-profile">
               ${this.renderFlyoutPersonDetails(this.userDetails,this._image)}
             </div>
             ${this.renderAccounts()}
           </div>
           ${this.renderAddAccountContent()}
         </div>
       </div>
     `}get hasMultipleAccounts(){var e,t,i,o;return(null===(e=te.globalProvider)||void 0===e?void 0:e.isMultiAccountSupportedAndEnabled)&&(null===(o=null===(i=null===(t=te.globalProvider)||void 0===t?void 0:t.getAllAccounts)||void 0===i?void 0:i.call(t))||void 0===o?void 0:o.length)>1}get usesVerticalPersonCard(){return"full"===this.loginView||this.hasMultipleAccounts}renderFlyoutPersonDetails(e,t){return this.renderTemplate("flyout-person-details",{personDetails:e,personImage:t})||pi`
        <mgt-person
          .personDetails=${e}
          .personImage=${t}
          .view=${xo.twolines}
          .line2Property=${"email"}
          ?vertical-layout=${this.usesVerticalPersonCard}
          class="person">
        </mgt-person>`}renderFlyoutCommands(){return this.renderTemplate("flyout-commands",{handleSignOut:()=>this.logout()})||Je`
        <fluent-button
          id="signout-button"
          appearance="stealth"
          size="medium"
          class="flyout-command"
          @click=${this.logout}
          aria-label=${this.strings.signOutLinkSubtitle}>
            ${this.strings.signOutLinkSubtitle}
        </fluent-button>`}renderButtonContent(){return this.userDetails?this.renderSignedInButtonContent(this.userDetails,this._image):this.renderSignedOutButtonContent()}renderAddAccountContent(){if(te.globalProvider.isMultiAccountSupportedAndEnabled)return Je`
        <div class="add-account">
          <fluent-button
            id="signin-different-account-button"
            appearance="stealth"
            aria-label="${this.strings.signInWithADifferentAccount}"
            @click=${()=>{this.login()}}>
            <span slot="start"><i>${Co(ko.SelectAccount,"currentColor")}</i></span>
            ${this.strings.signInWithADifferentAccount}
          </fluent-button>
        </div>`}parsePersonDisplayConfiguration(){const e={view:xo.twolines,avatarSize:"small"};switch(this.loginView){case"avatar":e.view=xo.image,e.avatarSize="small";break;case"compact":e.view=xo.oneline,e.avatarSize="small";break;default:e.view=xo.twolines,e.avatarSize="auto"}return e}renderSignedInButtonContent(e,t){const i=this.renderTemplate("signed-in-button-content",{personDetails:e,personImage:t}),o=this.parsePersonDisplayConfiguration();return i||pi`
        <mgt-person
          .personDetails=${this.userDetails}
          .personImage=${this._image}
          .view=${o.view}
          .showPresence=${this.showPresence}
          .avatarSize=${o.avatarSize}
          line2-property="email"
          class="signed-in-person"
        ></mgt-person>`}renderAccounts(){if(te.globalProvider.state===Q.SignedIn&&te.globalProvider.isMultiAccountSupportedAndEnabled){const e=te.globalProvider,t=e.getAllAccounts();if((null==t?void 0:t.length)>1)return Je`
          <div id="accounts">
            <ul
              tabindex="0"
              class="account-list"
              part="account-list"
              aria-label="${this.ariaLabel}"
              @keydown=${this.handleAccountListKeyDown}
            >
              ${t.filter((t=>t.id!==e.getActiveAccount().id)).map((e=>{const t=localStorage.getItem(e.id+this._userDetailsKey);return pi`
                    <li
                      tabindex="-1"
                      part="account-item"
                      class="account-item"
                      @click=${()=>this.setActiveAccount(e)}
                      @keyup=${t=>{"Enter"===t.key&&this.setActiveAccount(e)}}
                    >
                      <mgt-person
                        .personDetails=${t?JSON.parse(t):null}
                        .fallbackDetails=${{displayName:e.name,mail:e.mail}}
                        .view=${Lo.twolines}
                        class="account"
                      ></mgt-person>
                    </li>`}))}
            </ul>
          </div>
       `}}setActiveAccount(e){te.globalProvider.setActiveAccount(e)}clearState(){this.userDetails=null,this._image=null}renderSignedOutButtonContent(){return this.renderTemplate("signed-out-button-content",null)||Je`
        <span>${this.strings.signInLinkSubtitle}</span>`}showFlyout(){const e=this.flyout;e&&e.open()}hideFlyout(){const e=this.flyout;e&&e.close()}};Dg([Ct({attribute:"user-details",type:Object}),Pg("design:type",Object)],Eg.prototype,"userDetails",void 0),Dg([Ct({attribute:"show-presence",type:Boolean}),Pg("design:type",Object)],Eg.prototype,"showPresence",void 0),Dg([Ct({attribute:"login-view",type:String}),Pg("design:type",String)],Eg.prototype,"loginView",void 0),Dg([$t(),Pg("design:type",Boolean)],Eg.prototype,"_isFlyoutOpen",void 0),Dg([$t(),Pg("design:type",Object)],Eg.prototype,"_arrowKeyLocation",void 0),Eg=Dg([gi("login"),Pg("design:paramtypes",[])],Eg);var Og,Fg=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};!function(e){e[e.any=0]="any",e[e.unified=1]="unified",e[e.security=2]="security",e[e.mailenabledsecurity=4]="mailenabledsecurity",e[e.distribution=8]="distribution"}(Og||(Og={}));const Ag=()=>ai.config.groups.invalidationPeriod||ai.config.defaultInvalidationPeriod,Rg=()=>ai.config.groups.isEnabled&&ai.config.isEnabled,Vg=(e,t,i=10,o=Og.any,s="")=>Fg(void 0,void 0,void 0,(function*(){const n="Group.Read.All";let r;const a=`${t||"*"}*${o}*${s}:${i}`;if(Rg()){r=ai.getCache(Vi,Vi.stores.groupsQuery);const e=yield r.getValue(a);if(e&&Ag()>Date.now()-e.timeCached&&e.top>=i)return e.groups.map((e=>JSON.parse(e))).slice(0,i+1)}let l,d="";const c=[];if(""!==t&&(d=`(startswith(displayName,'${t}') or startswith(mailNickname,'${t}') or startswith(mail,'${t}'))`),s&&(d+=`${t?" and ":""}${s}`),o!==Og.any){const t=e.createBatch(),s=[];Og.unified===(o&Og.unified)&&s.push("groupTypes/any(c:c+eq+'Unified')"),Og.security===(o&Og.security)&&s.push("(mailEnabled eq false and securityEnabled eq true)"),Og.mailenabledsecurity===(o&Og.mailenabledsecurity)&&s.push("(mailEnabled eq true and securityEnabled eq true)"),Og.distribution===(o&Og.distribution)&&s.push("(mailEnabled eq true and securityEnabled eq false)"),d=d?`${d} and `:"";for(const e of s)t.get(e,`/groups?$filter=${d+e}`,["Group.Read.All"]);try{l=yield t.executeAll();for(const e of s)if(l.get(e).content.value)for(const t of l.get(e).content.value)c.find((e=>e.id===t.id))||c.push(t)}catch(t){try{const t=[];for(const o of s)t.push(e.api("groups").filter(`${d} and ${o}`).top(i).count(!0).header("ConsistencyLevel","eventual").middlewareOptions(ie(n)).get());return(yield Promise.all(t)).map((e=>e.value)).reduce(((e,t)=>e.concat(t)),[])}catch(e){return[]}}}else if(0===c.length){const t=yield e.api("groups").filter(d).top(i).count(!0).header("ConsistencyLevel","eventual").middlewareOptions(ie(n)).get();return Rg()&&t&&(yield r.putValue(a,{groups:t.value.map((e=>JSON.stringify(e))),top:i})),t?t.value:null}return c})),Mg=(e,t,i)=>Fg(void 0,void 0,void 0,(function*(){let o;if(Rg()){o=ai.getCache(Vi,Vi.stores.groups);const e=yield o.getValue(t);if(e&&Ag()>Date.now()-e.timeCached){const t=e.group?JSON.parse(e.group):null,o=i&&t?i.filter((e=>!Object.keys(t).includes(e))):null;if(!o||o.length<=1)return t}}let s=`/groups/${t}`;i&&(s=s+"?$select="+i.toString());const n=yield e.api(s).middlewareOptions(ie("Group.Read.All")).get();return Rg()&&(yield o.putValue(t,{group:JSON.stringify(n)})),n})),zg=(e,t,i="")=>Fg(void 0,void 0,void 0,(function*(){if(!t||0===t.length)return[];const o=e.createBatch(),s={},n=[];let r;Rg()&&(r=ai.getCache(Vi,Vi.stores.groups));for(const e of t){let t;if(s[e]=null,Rg()&&(t=yield r.getValue(e)),t&&Ag()>Date.now()-t.timeCached)s[e]=t.group?JSON.parse(t.group):null;else if(""!==e){let t=`/groups/${e}`;i&&(t=`${t}?$filters=${i}`),o.get(e,t,["Group.Read.All"]),n.push(e)}}try{const e=yield o.executeAll();for(const i of t){const t=e.get(i);(null==t?void 0:t.content)&&(s[i]=t.content,Rg()&&(yield r.putValue(i,{group:JSON.stringify(t.content)})))}return Promise.all(Object.values(s))}catch(i){try{return t.filter((e=>n.includes(e))).forEach((t=>{s[t]=Mg(e,t)})),Rg()&&(yield Promise.all(t.filter((e=>n.includes(e))).map((e=>Fg(void 0,void 0,void 0,(function*(){return yield r.putValue(e,{group:JSON.stringify(yield s[e])})})))))),Promise.all(Object.values(s))}catch(e){return[]}}})),Ng=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}
`];let Ug=class extends Pt{static get styles(){return Ng}render(){return Je`<fluent-progress-ring title="spinner"></fluent-progress-ring>`}};Ug=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}([gi("spinner")],Ug);const Bg=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{--person-details-wrapper-width:0;width:auto}:host fluent-text-field{width:100%}:host fluent-text-field::part(root){display:flex;flex-wrap:wrap;height:auto;background:padding-box linear-gradient(var(--people-picker-input-background,var(--neutral-fill-input-rest)),var(--people-picker-input-background,var(--neutral-fill-input-rest))),border-box var(--people-picker-input-border-color,var(--neutral-stroke-input-rest))}:host fluent-text-field::part(root):hover{background:padding-box linear-gradient(var(--people-picker-input-hover-background,var(--neutral-fill-input-hover)),var(--people-picker-input-hover-background,var(--neutral-fill-input-hover))),border-box var(--people-picker-input-hover-border-color,var(--neutral-stroke-input-hover))}:host fluent-text-field::part(root):focus,:host fluent-text-field::part(root):focus-within{background:padding-box linear-gradient(var(--people-picker-input-focus-background,var(--neutral-fill-input-focus)),var(--people-picker-input-focus-background,var(--neutral-fill-input-focus))),border-box var(--people-picker-input-focus-border-color,var(--neutral-stroke-input-focus))}:host fluent-text-field::part(start){margin:unset}:host fluent-text-field::part(control){width:min-content;height:calc((var(--base-height-multiplier) + var(--density)) * var(--design-unit) * 1px);word-spacing:inherit;text-indent:inherit;letter-spacing:inherit}:host fluent-text-field::part(control)::placeholder{color:var(--people-picker-input-placeholder-text-color,var(--input-placeholder-rest))}:host fluent-text-field::part(control):hover::placeholder{color:var(--people-picker-input-placeholder-hover-text-color,var(--input-placeholder-hover))}:host fluent-text-field::part(control):focus-within::placeholder,:host fluent-text-field::part(control):focus::placeholder{color:var(--people-picker-input-placeholder-focus-text-color,var(--input-placeholder-filled))}:host fluent-text-field .search-icon{display:flex;padding-top:10px;padding-inline-start:10px}:host fluent-text-field .search-icon svg path{fill:var(--people-picker-search-icon-color,currentColor)}:host .selected-list{display:flex;flex-wrap:wrap;column-gap:5px;padding:unset;margin:0 5px}:host .selected-list-item{display:flex;column-gap:5px;border-radius:100px;margin-top:3px;background-color:var(--people-picker-selected-option-background-color,var(--person-background-color,var(--neutral-layer-3)))}:host .selected-list-item.highlighted{background-color:var(--people-picker-selected-option-highlight-background-color,var(--accent-fill-rest))}:host .selected-list-item-close-icon{display:flex;justify-content:center;align-items:center;padding-inline-end:8px;cursor:pointer}:host .selected-list-item-close-icon svg path{fill:var(--people-picker-remove-selected-close-icon-color,currentColor)}:host .selected-list-item-person{width:max-content}:host fluent-card{margin-top:4px;background-color:var(--people-picker-dropdown-background-color,var(--neutral-layer-card-container))}:host .searched-people-list{list-style:none;padding:4px;margin:auto}:host .searched-people-list-result{padding:4px;border-radius:4px;background:var(--people-picker-dropdown-result-background-color,var(--person-background-color,transparent))}:host .searched-people-list-result:hover{background:var(--people-picker-dropdown-result-hover-background-color,var(--person-background-color,var(--neutral-fill-rest)))}:host .searched-people-list-result:focus,:host .searched-people-list-result:focus-within{background:var(--people-picker-dropdown-result-focus-background-color,var(--person-background-color,var(--neutral-fill-rest)))}:host .message-parent{display:flex;place-content:center;flex-direction:row;padding:10px 15px;column-gap:5px}:host .message-parent .loading-text,:host .message-parent .search-error-text{font-style:normal;font-weight:600;font-size:14px;line-height:19px;text-align:center;color:var(--people-picker-no-results-text-color,var(--neutral-foreground-hint))}
`];class Hg extends Ln{}class jg extends(Iu(Hg)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class qg extends jg{constructor(){super(...arguments),this.type="text"}readOnlyChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.readOnly=this.readOnly,this.validate())}autofocusChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.autofocus=this.autofocus,this.validate())}placeholderChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.placeholder=this.placeholder)}typeChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.type=this.type,this.validate())}listChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.setAttribute("list",this.list),this.validate())}maxlengthChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.maxLength=this.maxlength,this.validate())}minlengthChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.minLength=this.minlength,this.validate())}patternChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.pattern=this.pattern,this.validate())}sizeChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.size=this.size)}spellcheckChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.spellcheck=this.spellcheck)}connectedCallback(){super.connectedCallback(),this.proxy.setAttribute("type",this.type),this.validate(),this.autofocus&&ps.queueUpdate((()=>{this.focus()}))}select(){this.control.select(),this.$emit("select")}handleTextInput(){this.value=this.control.value}handleChange(){this.$emit("change")}validate(){super.validate(this.control)}}Ms([Os({attribute:"readonly",mode:"boolean"})],qg.prototype,"readOnly",void 0),Ms([Os({mode:"boolean"})],qg.prototype,"autofocus",void 0),Ms([Os],qg.prototype,"placeholder",void 0),Ms([Os],qg.prototype,"type",void 0),Ms([Os],qg.prototype,"list",void 0),Ms([Os({converter:Ls})],qg.prototype,"maxlength",void 0),Ms([Os({converter:Ls})],qg.prototype,"minlength",void 0),Ms([Os],qg.prototype,"pattern",void 0),Ms([Os({converter:Ls})],qg.prototype,"size",void 0),Ms([Os({mode:"boolean"})],qg.prototype,"spellcheck",void 0),Ms([ms],qg.prototype,"defaultSlottedNodes",void 0);class Zg{}function Wg(e,t,i){return e.nodeType!==Node.TEXT_NODE||"string"==typeof e.nodeValue&&!!e.nodeValue.trim().length}cu(Zg,iu),cu(qg,nu,Zg);const Gg=".root";class Qg extends qg{appearanceChanged(e,t){e!==t&&(this.classList.add(t),this.classList.remove(e))}connectedCallback(){super.connectedCallback(),this.appearance||(this.appearance="outline")}}i([Os],Qg.prototype,"appearance",void 0);const Kg=Qg.compose({baseName:"text-field",baseClass:qg,template:(e,t)=>Rr`
    <template
        class="
            ${e=>e.readOnly?"readonly":""}
        "
    >
        <label
            part="label"
            for="control"
            class="${e=>e.defaultSlottedNodes&&e.defaultSlottedNodes.length?"label":"label label__hidden"}"
        >
            <slot
                ${Ru({property:"defaultSlottedNodes",filter:Wg})}
            ></slot>
        </label>
        <div class="root" part="root">
            ${au(0,t)}
            <input
                class="control"
                part="control"
                id="control"
                @input="${e=>e.handleTextInput()}"
                @change="${e=>e.handleChange()}"
                ?autofocus="${e=>e.autofocus}"
                ?disabled="${e=>e.disabled}"
                list="${e=>e.list}"
                maxlength="${e=>e.maxlength}"
                minlength="${e=>e.minlength}"
                pattern="${e=>e.pattern}"
                placeholder="${e=>e.placeholder}"
                ?readonly="${e=>e.readOnly}"
                ?required="${e=>e.required}"
                size="${e=>e.size}"
                ?spellcheck="${e=>e.spellcheck}"
                :value="${e=>e.value}"
                type="${e=>e.type}"
                aria-atomic="${e=>e.ariaAtomic}"
                aria-busy="${e=>e.ariaBusy}"
                aria-controls="${e=>e.ariaControls}"
                aria-current="${e=>e.ariaCurrent}"
                aria-describedby="${e=>e.ariaDescribedby}"
                aria-details="${e=>e.ariaDetails}"
                aria-disabled="${e=>e.ariaDisabled}"
                aria-errormessage="${e=>e.ariaErrormessage}"
                aria-flowto="${e=>e.ariaFlowto}"
                aria-haspopup="${e=>e.ariaHaspopup}"
                aria-hidden="${e=>e.ariaHidden}"
                aria-invalid="${e=>e.ariaInvalid}"
                aria-keyshortcuts="${e=>e.ariaKeyshortcuts}"
                aria-label="${e=>e.ariaLabel}"
                aria-labelledby="${e=>e.ariaLabelledby}"
                aria-live="${e=>e.ariaLive}"
                aria-owns="${e=>e.ariaOwns}"
                aria-relevant="${e=>e.ariaRelevant}"
                aria-roledescription="${e=>e.ariaRoledescription}"
                ${su("control")}
            />
            ${ru(0,t)}
        </div>
    </template>
`,styles:(e,t)=>ih`
    ${nh("inline-block")}

    ${Gp(0,0,Gg)}

    ${Qp()}

    .root {
      display: flex;
      flex-direction: row;
    }

    .control {
      -webkit-appearance: none;
      color: inherit;
      background: transparent;
      border: 0;
      height: calc(100% - 4px);
      margin-top: auto;
      margin-bottom: auto;
      padding: 0 calc(${Aa} * 2px + 1px);
      font-family: inherit;
      font-size: inherit;
      line-height: inherit;
    }

    .start,
    .end {
      display: flex;
      margin: auto;
    }

    .start {
      display: flex;
      margin-inline-start: 11px;
    }

    .end {
      display: flex;
      margin-inline-end: 11px;
    }
  `.withBehaviors(Gu("outline",Kp(0,0,Gg)),Gu("filled",Xp(0,0,Gg)),lh(Jp(0,0,Gg))),shadowOptions:{delegatesFocus:!0}}),Xg={inputPlaceholderText:"Search for a name",maxSelectionsPlaceHolder:"Max contacts added",maxSelectionsAriaLabel:"Maximum contact selections reached",noResultsFound:"We didn't find any matches.",loadingMessage:"Loading...",selected:"selected",removeSelectedUser:"Remove ",selectContact:"select a contact",suggestionsTitle:"Suggested contacts"};var Jg=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Yg=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},ef=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(Kg,$h);let tf=class extends Nt{static get styles(){return Bg}get strings(){return Xg}get flyout(){return this.renderRoot.querySelector(".flyout")}get input(){return this.renderRoot.querySelector("fluent-text-field")}get groupId(){return this._groupId}set groupId(e){this._groupId!==e&&(this._groupId=e,this.requestStateUpdate(!0))}get groupIds(){return this._groupIds}set groupIds(e){Rt(this._groupIds,e)||(this._groupIds=e,this.requestStateUpdate(!0))}get type(){return this._type}set type(e){this._type!==e&&(this._type=e,this.requestStateUpdate(!0))}get groupType(){return this._groupType}set groupType(e){this._groupType!==e&&(this._groupType=e,this.requestStateUpdate(!0))}get userType(){return this._userType}set userType(e){this._userType!==e&&(this._userType=e,this.requestStateUpdate(!0))}get transitiveSearch(){return this._transitiveSearch}set transitiveSearch(e){this.transitiveSearch!==e&&(this._transitiveSearch=e,this.requestStateUpdate(!0))}get people(){return this._people}set people(e){Rt(this._people,e)||(this._people=e,this.requestStateUpdate(!0))}get showMax(){return this._showMax}set showMax(e){e!==this._showMax&&(this._showMax=e,this.requestStateUpdate(!0))}get selectedPeople(){return this._selectedPeople}set selectedPeople(e){e||(e=[]),Rt(this._selectedPeople,e)||(this._selectedPeople=e,this.requestUpdate())}get defaultSelectedUserIds(){return this._defaultSelectedUserIds}set defaultSelectedUserIds(e){Rt(this._defaultSelectedUserIds,e)||(this._defaultSelectedUserIds=e,this.requestStateUpdate(!0))}get defaultSelectedGroupIds(){return this._defaultSelectedGroupIds}set defaultSelectedGroupIds(e){Rt(this._defaultSelectedGroupIds,e)||(this._defaultSelectedGroupIds=e,this.requestStateUpdate(!0))}get userIds(){return this._userIds}set userIds(e){Rt(this._userIds,e)||(this._userIds=e,this.requestStateUpdate(!0))}get userFilters(){return this._userFilters}set userFilters(e){this._userFilters=e,this.requestStateUpdate(!0)}get peopleFilters(){return this._peopleFilters}set peopleFilters(e){this._peopleFilters=e,this.requestStateUpdate(!0)}get groupFilters(){return this._groupFilters}set groupFilters(e){this._groupFilters=e,this.requestStateUpdate(!0)}static get requiredScopes(){return[...new Set(["user.read.all","people.read","group.read.all","user.readbasic.all",...No.requiredScopes])]}constructor(){super(),this._type=Bi.person,this._groupType=Og.any,this._userType=Hi.any,this._selectedPeople=[],this._arrowSelectionCount=-1,this.defaultSelectedUsers=[],this.defaultSelectedGroups=[],this._highlightedUsers=[],this._currentHighlightedUserPos=0,this._isFocused=!1,this._setAnyEmail=!1,this.handleInputClick=()=>{this.flyout.isOpen||this.handleUserSearch()},this.gainedFocus=()=>{this.clearHighlighted(),this._isFocused=!0,this.loadState(),this.showFlyout()},this.lostFocus=()=>{this._isFocused=!1,this.input&&this.input.setAttribute("aria-activedescendant","");const e=this.renderRoot.querySelector(".people-list");if(e)for(const t of e.children)t.classList.remove("focused"),t.setAttribute("aria-selected","false");this.requestUpdate()},this.onUserKeyUp=e=>{const t=e.key,i=e.getModifierState("Control")||e.getModifierState("Meta"),o=i&&"v"===t,s=["ArrowDown","ArrowRight","ArrowUp","ArrowLeft"].includes(t);return!o&&i||s?((i||["ArrowLeft","ArrowRight"].includes(t))&&this.hideFlyout(),void("ArrowDown"===t&&!this.flyout.isOpen&&this._isFocused&&this.handleUserSearch())):["Tab","Enter","Shift"].includes(t)?void 0:"Escape"===t?(this.clearInput(),this._foundPeople=[],void(this._arrowSelectionCount=-1)):"Backspace"===t&&0===this.userInput.length&&this.selectedPeople.length>0?(this.clearHighlighted(),this.selectedPeople=this.selectedPeople.splice(0,this.selectedPeople.length-1),this.loadState(),this.hideFlyout(),void this.fireCustomEvent("selectionChanged",this.selectedPeople)):void([";",","].includes(t)&&this.allowAnyEmail&&(this._setAnyEmail=!0,e.preventDefault(),e.stopPropagation()))},this.onUserInput=e=>{const t=e.target;this.userInput=t.value,this.userInput&&(Ii(this.userInput)&&this.allowAnyEmail?this._setAnyEmail&&this.handleAnyEmail():this.handleUserSearch(),this._setAnyEmail=!1)},this.onUserKeyDown=e=>{const t=e.key,i=this.renderRoot.querySelector(".selected-list"),o=e.getModifierState("Control")||e.getModifierState("Meta");if(o&&i){const e=i.querySelectorAll("mgt-person.selected-list-item-person");if(this.hideFlyout(),o&&"ArrowLeft"===t)this._currentHighlightedUserPos=(this._currentHighlightedUserPos-1+e.length)%e.length,this._currentHighlightedUserPos>=0&&!Number.isNaN(this._currentHighlightedUserPos)?this._highlightedUsers.push(e[this._currentHighlightedUserPos]):this._currentHighlightedUserPos=0;else if(o&&"ArrowRight"===t){const e=this._highlightedUsers.pop();if(e){const t=e.parentElement;t&&(this.clearHighlighted(t),this._currentHighlightedUserPos++)}}else o&&"a"===t&&(this._highlightedUsers=[],e.forEach((e=>this._highlightedUsers.push(e))));this._highlightedUsers&&this.highlightSelectedPeople(this._highlightedUsers)}else if(this.clearHighlighted(),this.flyout.isOpen){if("ArrowUp"!==t&&"ArrowDown"!==t||(this.handleArrowSelection(e),e.preventDefault()),"Enter"===t)if(!e.shiftKey&&this._foundPeople){e.preventDefault(),e.stopPropagation();const t=this._foundPeople[this._arrowSelectionCount];if(t){this.addPerson(t),this.hideFlyout(),this.input.value="";const e=this.input.shadowRoot.querySelector("input");this.hasMaxSelections&&e&&e.setAttribute("disabled","true")}}else this.allowAnyEmail?this.handleAnyEmail():this.showFlyout();"Escape"===t&&e.stopPropagation(),"Tab"===t&&this.hideFlyout(),[";",","].includes(t)&&this.allowAnyEmail&&(e.preventDefault(),e.stopPropagation(),this.userInput=this.input.value,this.handleAnyEmail())}},this.handleCut=()=>{this.writeHighlightedText().then((()=>{this.removeHighlightedOnCut()}),(()=>{}))},this.handleCopy=()=>{this.writeHighlightedText()},this.handlePaste=()=>{navigator.clipboard.readText().then((e=>{if(e)try{const t=JSON.parse(e);if(t&&t.length>0)for(const e of t)this.addPerson(e)}catch(t){if(t instanceof SyntaxError){const t=[",",";"];let i;try{for(const o of t)if(i=e.split(o),i.length>1){this.hideFlyout(),this.selectUsersById(i);break}}catch(e){}}}}),(e=>{}))},this.clearState(),this._showLoading=!0,this.showMax=6,this.disableImages=!1,this.disabled=!1,this.allowAnyEmail=!1,this.addEventListener("copy",this.handleCopy),this.addEventListener("cut",this.handleCut),this.addEventListener("paste",this.handlePaste)}get hasMaxSelections(){return"single"===this.selectionMode&&this.selectedPeople.length>=1}focus(e){this.input&&(this.input.focus(e),this.input.select())}selectUsersById(e){var t;return ef(this,void 0,void 0,(function*(){const i=te.globalProvider,o=te.globalProvider.graph;if(i&&i.state===Q.SignedIn)for(const i in e){const s=e[i];try{const e=yield to(o,s,zo);this.addPerson(e)}catch(e){if(yo(e)&&(null===(t=e.message)||void 0===t?void 0:t.includes("does not exist"))&&this.allowAnyEmail&&Ii(s)){const e={mail:s,displayName:s};this.addPerson(e)}}}}))}selectGroupsById(e){return ef(this,void 0,void 0,(function*(){const t=te.globalProvider,i=te.globalProvider.graph;if(t&&t.state===Q.SignedIn)for(const t in e)try{const o=yield Mg(i,e[t]);this.addPerson(o)}catch(e){}}))}render(){const e=this.renderTemplate("default",{people:this._foundPeople});if(e)return e;const t=this.renderSelectedPeople(this.selectedPeople),i=this.renderInput(t),o=this.renderFlyout(i);return Je`
      <div>
        ${o}
      </div>
    `}clearState(){this.selectedPeople=[],this.userInput="",this._highlightedUsers=[],this._currentHighlightedUserPos=0}requestStateUpdate(e){return e&&(this._groupPeople=null,this._foundPeople=null,this.selectedPeople=[],this.defaultPeople=null),super.requestStateUpdate(e)}renderInput(e){var t,i,o;const s=this.disabled?"":this.placeholder||this.strings.inputPlaceholderText,n=this.hasMaxSelections?this.strings.maxSelectionsAriaLabel:"",r=Je`<span class="search-icon">${Co(ko.Search)}</span>`,a=(null===(t=this.selectedPeople)||void 0===t?void 0:t.length)>0?e:r;return Je`
      <fluent-text-field
        autocomplete="off"
        appearance="outline"
        slot="anchor"
        id="people-picker-input"
        role="combobox"
        placeholder=${this.hasMaxSelections?this.strings.maxSelectionsPlaceHolder:s}
        aria-label=${this.ariaLabel||n||s||this.strings.selectContact}
        aria-expanded=${null!==(o=null===(i=this.flyout)||void 0===i?void 0:i.isOpen)&&void 0!==o&&o}
        @click="${this.hasMaxSelections?void 0:this.handleInputClick}"
        @focus="${this.hasMaxSelections?void 0:this.gainedFocus}"
        @keydown="${this.hasMaxSelections?void 0:this.onUserKeyDown}"
        @input="${this.hasMaxSelections?void 0:this.onUserInput}"
        @blur="${this.lostFocus}"
        ?disabled=${this.disabled}
      >
        <span slot="start">${a}</span>
      </fluent-text-field>
    `}renderSelectedPeople(e){return(null==e?void 0:e.length)?Je`
       <ul
        id="selected-list"
        aria-label="${this.strings.selected}"
        class="selected-list">
          ${Xo(e,(e=>null==e?void 0:e.id),(e=>{var t;return Je`
            <li class="selected-list-item">
              ${this.renderTemplate("selected-person",{person:e},`selected-${(null==e?void 0:e.id)?e.id:e.displayName}`)||this.renderSelectedPerson(e)}

              <div
                role="button"
                tabindex="0"
                class="selected-list-item-close-icon"
                aria-label="${this.strings.removeSelectedUser}${null!==(t=null==e?void 0:e.displayName)&&void 0!==t?t:""}"
                @click="${t=>this.removePerson(e,t)}"
                @keydown="${t=>this.handleRemovePersonKeyDown(e,t)}">
                  ${Co(ko.Close)}
              </div>
          </li>`}))}
      </ul>`:Je``}renderFlyout(e){return pi`
       <mgt-flyout light-dismiss class="flyout">
         ${e}
         <fluent-card
          tabindex="0"
          slot="flyout"
          class="flyout-root"
          @wheel=${e=>this.handleSectionScroll(e)}
          @keydown=${e=>this.onUserKeyDown(e)}
          class="custom">
           ${this.renderFlyoutContent()}
         </fluent-card>
       </mgt-flyout>
     `}renderFlyoutContent(){if(this.isLoadingState||this._showLoading)return this.renderLoading();const e=this._foundPeople;return e&&0!==e.length&&0!==this.showMax?this.renderSearchResults(e):this.renderNoData()}renderLoading(){return this.renderTemplate("loading",null)||pi`
         <div class="message-parent">
           <mgt-spinner></mgt-spinner>
           <div aria-label="${this.strings.loadingMessage}" class="loading-text">
             ${this.strings.loadingMessage}
           </div>
         </div>
       `}renderNoData(){if(this._isFocused)return this.renderTemplate("error",null)||this.renderTemplate("no-data",null)||Je`
         <div class="message-parent">
           <div aria-label=${this.strings.noResultsFound} class="search-error-text">
             ${this.strings.noResultsFound}
           </div>
         </div>
       `}renderSearchResults(e){const t=e.filter((e=>e.id));return Je`
      <ul
        id="suggestions-list"
        class="searched-people-list"
        role="listbox"
        aria-live="polite"
        title=${this.strings.suggestionsTitle}
      >
         ${Xo(t,(e=>e.id),(e=>Je`
            <li
              id="${e.id}"
              class="searched-people-list-result"
              role="option"
              @click="${()=>this.handleSuggestionClick(e)}">
                ${this.renderPersonResult(e)}
            </li>
          `))}
       </ul>
     `}renderPersonResult(e){return this.renderTemplate("person",{person:e},e.id)||pi`
         <mgt-person
          class="person"
          show-presence
          view="twoLines"
          line2-property="jobTitle,mail"
          .personDetails=${e}
          .fetchImage=${!this.disableImages}>
          .personCardInteraction=${Do.none}
        </mgt-person>`}renderSelectedPerson(e){return pi`
       <mgt-person
         tabindex="-1"
         class="selected-list-item-person"
         .personDetails=${e}
         .fetchImage=${!this.disableImages}
         .view=${xo.oneline}
         .personCardInteraction=${Do.none}>
        </mgt-person>
     `}loadState(){var e,t,i,o;return ef(this,void 0,void 0,(function*(){let s=this.people;const n=this.userInput.toLowerCase(),r=te.globalProvider;if(s){if(n){const e=s.filter((e=>null==e?void 0:e.displayName.toLowerCase().includes(n)));s=e}this._showLoading=!1}else if(!s&&r&&r.state===Q.SignedIn){const a=r.graph.forComponent(this);if(!n.length){if(this.defaultPeople)s=this.defaultPeople;else{if(this.groupId||this.groupIds){if(null===this._groupPeople)if(this.groupId)try{this.type===Bi.group?this._groupPeople=yield so(a,null,this.groupId,this.showMax,this.type,this.transitiveSearch):this._groupPeople=yield so(a,null,this.groupId,this.showMax,this.type,this.transitiveSearch,this.userFilters,this.peopleFilters)}catch(e){this._groupPeople=[]}else if(this.groupIds)if(this.type===Bi.group)try{this._groupPeople=yield zg(a,this.groupIds,this.groupFilters)}catch(e){this._groupPeople=[]}else try{const e=yield no(a,"",this.groupIds,this.showMax,this.type,this.transitiveSearch,this.userFilters);this._groupPeople=e}catch(e){this._groupPeople=[]}s=this._groupPeople||[]}else if(this.type===Bi.person||this.type===Bi.any)if(this.userIds)s=yield io(a,this.userIds,"",this.userFilters);else{const e=this.userType===Hi.user||this.userType===Hi.contact;s=this._userFilters&&e?yield((e,t="",i=10)=>Xi(void 0,void 0,void 0,(function*(){let o;const s=`${""===t?"*":t}:${i}`,n={maxResults:i,results:null};if(Yi()){o=ai.getCache(Fi,Fi.stores.userFilters);const e=yield o.getValue(s);if(e&&Ji()>Date.now()-e.timeCached)return e.results.map((e=>JSON.parse(e)))}const r=e.api("/users").top(i);t&&r.filter(t);try{const e=yield r.middlewareOptions(ie("user.read")).get();return Yi()&&e&&(n.results=e.value.map((e=>JSON.stringify(e))),yield o.putValue(t,n)),e.value}catch(e){}})))(a,this._userFilters,this.showMax):yield Gi(a,this.userType,this._peopleFilters,this.showMax)}else if(this.type===Bi.group)if(this.groupIds)try{s=yield this.getGroupsForGroupIds(a,s)}catch(e){}else{let e=(yield Vg(a,"",this.showMax,this.groupType,this._groupFilters))||[];e.length>0&&e[0].value&&(e=e[0].value),s=e}this.defaultPeople=s}this._isFocused&&(this._showLoading=!1)}if(!((null===(e=this.defaultSelectedUserIds)||void 0===e?void 0:e.length)>0||(null===(t=this.defaultSelectedGroupIds)||void 0===t?void 0:t.length)>0)||this.selectedPeople.length||this.defaultSelectedUsers.length||this.defaultSelectedGroups.length||(this.defaultSelectedUsers=yield io(a,this.defaultSelectedUserIds,"",this.userFilters),this.defaultSelectedGroups=yield zg(a,this.defaultSelectedGroupIds,this.peopleFilters),this.defaultSelectedGroups=this.defaultSelectedGroups.filter((e=>null!==e)),this.defaultSelectedUsers=this.defaultSelectedUsers.filter((e=>null!==e)),this.selectedPeople=[...this.defaultSelectedUsers,...this.defaultSelectedGroups],this.requestUpdate(),this.fireCustomEvent("selectionChanged",this.selectedPeople)),n)if(s=[],this.groupId)s=(yield so(a,n,this.groupId,this.showMax,this.type,this.transitiveSearch,this.userFilters,this.peopleFilters))||[];else{if(this.type===Bi.person||this.type===Bi.any){try{if(this.userType===Hi.contact||this.userType===Hi.user)s=(null===(i=this.userIds)||void 0===i?void 0:i.length)?yield io(a,this.userIds,n,this._userFilters):yield oo(a,n,this.showMax,this._userFilters);else if(this.groupIds)try{s=yield no(a,n,this.groupIds,this.showMax,this.type,this.transitiveSearch,this.userFilters)}catch(e){}else s=(null===(o=this.userIds)||void 0===o?void 0:o.length)?yield io(a,this.userIds,n,this._userFilters):(yield Wi(a,n,this.showMax,this.userType,this._peopleFilters))||[]}catch(e){}if(s&&s.length<this.showMax&&this.userType!==Hi.contact&&this.type!==Bi.person)try{const e=(yield oo(a,n,this.showMax,this._userFilters))||[],t=new Set(s.map((e=>e.id)));for(const i of e)t.has(i.id)||s.push(i)}catch(e){}}if((this.type===Bi.group||this.type===Bi.any)&&s.length<this.showMax)if(this.groupIds)try{s=yield((e,t,i,o=10,s=Og.any,n="")=>Fg(void 0,void 0,void 0,(function*(){const r=[],a=yield Vg(e,t,o,s,n);if(a)for(const e of a)e.id&&i.includes(e.id)&&r.push(e);return r})))(a,n,this.groupIds,this.showMax,this.groupType,this.userFilters)}catch(e){}else{let e=[];try{e=(yield Vg(a,n,this.showMax,this.groupType,this._groupFilters))||[],s=s.concat(e)}catch(e){}}}}this._foundPeople=this.filterPeople(s)}))}getGroupsForGroupIds(e,t){return ef(this,void 0,void 0,(function*(){const i=yield zg(e,this.groupIds,this.groupFilters);for(const e of i)t=t.concat(e);return t=t.filter((e=>e))}))}hideFlyout(){const e=this.flyout;e&&e.close(),this.input&&this.input.setAttribute("aria-activedescendant",""),this._arrowSelectionCount=-1}showFlyout(){const e=this.flyout;e&&e.open(),this._arrowSelectionCount=-1}removePerson(e,t){t.stopPropagation();const i=this.selectedPeople.filter((t=>!e.id&&t.displayName?t.displayName!==e.displayName:t.id!==e.id)),o=this.input.shadowRoot.querySelector("input");this.hasMaxSelections&&o&&o.removeAttribute("disabled"),this.selectedPeople=i,this.loadState(),this.fireCustomEvent("selectionChanged",this.selectedPeople),null==o||o.focus()}handleRemovePersonKeyDown(e,t){"Enter"===t.key&&this.removePerson(e,t)}addPerson(e){if(e){setTimeout((()=>{this.clearInput()}),50);const t=this.selectedPeople.filter((t=>!e.id&&t.displayName?t.displayName===e.displayName:t.id===e.id));0===t.length&&(this.selectedPeople=[...this.selectedPeople,e],this.fireCustomEvent("selectionChanged",this.selectedPeople),this.loadState(),this._foundPeople=[],this._arrowSelectionCount=-1)}}clearInput(){this.clearHighlighted(),"single"!==this.selectionMode&&(this.input.value=""),this.userInput=""}handleAnyEmail(){if(this._showLoading=!1,this._arrowSelectionCount=-1,Ii(this.userInput)){const e={mail:this.userInput,displayName:this.userInput};this.addPerson(e)}this.hideFlyout(),this.input&&(this.input.focus(),this._isFocused=!0)}handleSuggestionClick(e){this.addPerson(e);const t=this.input.shadowRoot.querySelector("input");this.hasMaxSelections&&t&&(t.setAttribute("disabled","true"),this.input.value=t.value=""),this.hideFlyout()}handleUserSearch(){this._debouncedSearch||(this._debouncedSearch=$i((()=>ef(this,void 0,void 0,(function*(){const e=setTimeout((()=>{this._showLoading=!0}),50);yield this.loadState(),clearTimeout(e),this._showLoading=!1,this._arrowSelectionCount=-1,this.showFlyout()}))),400)),this._debouncedSearch()}writeHighlightedText(){return ef(this,void 0,void 0,(function*(){const e=[];for(const t of this._highlightedUsers){const{id:i,displayName:o,mail:s,userPrincipalName:n,scoredEmailAddresses:r}=t._personDetails;let a;a=r&&r.length>0?r.pop().address:n||s,e.push({id:i,displayName:o,email:a})}let t="";e.length>0&&(t=JSON.stringify(e)),yield navigator.clipboard.writeText(t)}))}removeHighlightedOnCut(){this.selectedPeople=this.selectedPeople.splice(0,this.selectedPeople.length-this._highlightedUsers.length),this._highlightedUsers=[],this._currentHighlightedUserPos=0,this.loadState(),this.hideFlyout(),this.fireCustomEvent("selectionChanged",this.selectedPeople)}highlightSelectedPeople(e){for(const t of e)(null==t?void 0:t.parentElement).classList.add("highlighted")}clearHighlighted(e){if(e)e.classList.remove("highlighted");else{for(const e of this._highlightedUsers){const t=e.parentElement;t&&t.classList.remove("highlighted")}this._highlightedUsers=[],this._currentHighlightedUserPos=0}}handleArrowSelection(e){var t,i;const o=this.renderRoot.querySelector(".searched-people-list");if(null===(t=null==o?void 0:o.children)||void 0===t?void 0:t.length){e&&("ArrowUp"===e.key&&(-1===this._arrowSelectionCount?this._arrowSelectionCount=0:this._arrowSelectionCount=(this._arrowSelectionCount-1+o.children.length)%o.children.length),"ArrowDown"===e.key&&(-1===this._arrowSelectionCount?this._arrowSelectionCount=0:this._arrowSelectionCount=(this._arrowSelectionCount+1+o.children.length)%o.children.length));for(const e of null!==(i=null==o?void 0:o.children)&&void 0!==i?i:[]){const t=e;t.setAttribute("aria-selected","false"),t.blur(),t.removeAttribute("tabindex")}const t=o.children[this._arrowSelectionCount];t&&(t.setAttribute("tabindex","0"),t.focus(),t.scrollIntoView({behavior:"smooth",block:"nearest",inline:"nearest"}),t.setAttribute("aria-selected","true"),this.input.setAttribute("aria-activedescendant",null==t?void 0:t.id))}}filterPeople(e){const t=[];if(e&&e.length>0){e=e.filter((e=>e));const i=this.selectedPeople.map((e=>e.id?e.id:e.displayName)),o=e.filter((e=>(null==e?void 0:e.id)?-1===i.indexOf(e.id):-1===i.indexOf(null==e?void 0:e.displayName))),s=new Set;for(const e of o){const t=JSON.stringify(e);s.add(t)}s.forEach((e=>{const i=JSON.parse(e);t.push(i)}))}return t}handleSectionScroll(e){const t=this.renderRoot.querySelector(".flyout-root");t&&(e.deltaY<0&&0===t.scrollTop||e.deltaY>0&&t.clientHeight+t.scrollTop>=t.scrollHeight-1||e.stopPropagation())}};Jg([Ct({attribute:"group-id",converter:e=>e.trim()}),Yg("design:type",String),Yg("design:paramtypes",[Object])],tf.prototype,"groupId",null),Jg([Ct({attribute:"group-ids",converter:e=>e.split(",").map((e=>e.trim()))}),Yg("design:type",Array),Yg("design:paramtypes",[Object])],tf.prototype,"groupIds",null),Jg([Ct({attribute:"type",converter:e=>(e=e.toLowerCase())&&0!==e.length?void 0===Bi[e]?Bi.any:Bi[e]:Bi.any}),Yg("design:type",Object),Yg("design:paramtypes",[Object])],tf.prototype,"type",null),Jg([Ct({attribute:"group-type",converter:e=>{if(!e||0===e.length)return Og.any;const t=e.split(","),i=[];for(let e of t)e=e.trim(),void 0!==Og[e]&&i.push(Og[e]);if(0===i.length)return Og.any;const o=i.reduce(((e,t)=>e|t));return o}}),Yg("design:type",Number),Yg("design:paramtypes",[Object])],tf.prototype,"groupType",null),Jg([Ct({attribute:"user-type",converter:e=>(e=e.toLowerCase())&&void 0!==Hi[e]?Hi[e]:Hi.any}),Yg("design:type",String),Yg("design:paramtypes",[Object])],tf.prototype,"userType",null),Jg([Ct({attribute:"transitive-search",type:Boolean}),Yg("design:type",Boolean),Yg("design:paramtypes",[Boolean])],tf.prototype,"transitiveSearch",null),Jg([Ct({attribute:"people",type:Object}),Yg("design:type",Array),Yg("design:paramtypes",[Array])],tf.prototype,"people",null),Jg([Ct({attribute:"show-max",type:Number}),Yg("design:type",Number),Yg("design:paramtypes",[Number])],tf.prototype,"showMax",null),Jg([Ct({attribute:"disable-images",type:Boolean}),Yg("design:type",Boolean)],tf.prototype,"disableImages",void 0),Jg([Ct({attribute:"selected-people",type:Array}),Yg("design:type",Array),Yg("design:paramtypes",[Array])],tf.prototype,"selectedPeople",null),Jg([Ct({attribute:"default-selected-user-ids",converter:e=>e.split(",").map((e=>e.trim())),type:String}),Yg("design:type",Array),Yg("design:paramtypes",[Object])],tf.prototype,"defaultSelectedUserIds",null),Jg([Ct({attribute:"default-selected-group-ids",converter:e=>e.split(",").map((e=>e.trim())),type:String}),Yg("design:type",Array),Yg("design:paramtypes",[Object])],tf.prototype,"defaultSelectedGroupIds",null),Jg([Ct({attribute:"placeholder",type:String}),Yg("design:type",String)],tf.prototype,"placeholder",void 0),Jg([Ct({attribute:"disabled",type:Boolean}),Yg("design:type",Boolean)],tf.prototype,"disabled",void 0),Jg([Ct({attribute:"allow-any-email",type:Boolean}),Yg("design:type",Boolean)],tf.prototype,"allowAnyEmail",void 0),Jg([Ct({attribute:"selection-mode",type:String}),Yg("design:type",String)],tf.prototype,"selectionMode",void 0),Jg([Ct({attribute:"user-ids",converter:e=>e.split(",").map((e=>e.trim())),type:String}),Yg("design:type",Array),Yg("design:paramtypes",[Array])],tf.prototype,"userIds",null),Jg([Ct({attribute:"user-filters"}),Yg("design:type",String),Yg("design:paramtypes",[String])],tf.prototype,"userFilters",null),Jg([Ct({attribute:"people-filters"}),Yg("design:type",String),Yg("design:paramtypes",[String])],tf.prototype,"peopleFilters",null),Jg([Ct({attribute:"group-filters"}),Yg("design:type",String),Yg("design:paramtypes",[String])],tf.prototype,"groupFilters",null),Jg([Ct({attribute:"aria-label",type:String}),Yg("design:type",String)],tf.prototype,"ariaLabel",void 0),Jg([$t(),Yg("design:type",Boolean)],tf.prototype,"_showLoading",void 0),Jg([$t(),Yg("design:type",Object)],tf.prototype,"_arrowSelectionCount",void 0),Jg([$t(),Yg("design:type",Array)],tf.prototype,"_highlightedUsers",void 0),Jg([$t(),Yg("design:type",Object)],tf.prototype,"_isFocused",void 0),Jg([$t(),Yg("design:type",Object)],tf.prototype,"_setAnyEmail",void 0),Jg([$t(),Yg("design:type",Array)],tf.prototype,"_foundPeople",void 0),tf=Jg([gi("people-picker"),Yg("design:paramtypes",[])],tf);var of=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const sf="businessPhones,companyName,department,displayName,givenName,jobTitle,mail,mobilePhone,officeLocation,preferredLanguage,surname,userPrincipalName,id,accountEnabled",nf=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{box-shadow:var(--person-card-box-shadow,var(--elevation-shadow-card-rest));width:var(--mgt-flyout-set-width,375px);overflow:hidden;user-select:none;border-radius:8px;background-color:var(--person-card-background-color,var(--neutral-layer-floating));--file-list-background-color:transparent;--file-list-box-shadow:none;--file-item-background-color:transparent}:host .small{max-height:100vh;overflow-y:auto;overflow-x:hidden}:host .nav{height:0;position:relative;z-index:100}:host .nav__back{padding-top:18px;padding-inline-start:12px;height:32px;width:32px}:host .nav__back svg{fill:var(--person-card-icon-color,var(--accent-foreground-rest))}:host .nav__back:hover{cursor:pointer}:host .nav__back:hover svg{fill:var(--person-card-nav-back-arrow-hover-color,var(--neutral-foreground-rest))}:host .close-card-container{position:relative;z-index:100}:host .close-card-container .close-button{position:absolute;right:10px;margin-top:9px;z-index:1;border:1px solid transparent}:host .close-card-container .close-button svg path{fill:var(--person-card-icon-color,var(--accent-foreground-rest))}:host .close-card-container .close-button:hover svg path{fill:var(--person-card-close-button-hover-color,var(--neutral-foreground-rest))}:host .person-details-container{display:flex;flex-direction:column;padding-inline-start:22px;padding-block:36px;border-bottom:1px solid var(--person-card-border-color,var(--neutral-stroke-rest))}:host .person-details-container .person-image{--person-avatar-top-spacing:var(--person-card-avatar-top-spacing, 15px);--person-details-left-spacing:var(--person-card-details-left-spacing, 15px);--person-details-bottom-spacing:var(--person-card-details-bottom-spacing, 0);--person-background-color:var(--person-card-background-color, var(--neutral-layer-floating));--person-line1-font-size:var(--person-card-line1-font-size, 20px);--person-line1-font-weight:var(--person-card-line1-font-weight, 600);--person-line1-text-line-height:var(--person-card-line1-line-height, 28px);--person-line1-text-color:var(--person-card-line1-text-color, var(--neutral-foreground-rest));--person-line2-font-size:var(--person-card-line2-font-size, 14px);--person-line2-font-weight:var(--person-card-line2-font-weight, 400);--person-line2-text-line-height:var(--person-card-line2-line-height, 20px);--person-line2-text-color:var(--person-card-line2-text-color, var(--neutral-foreground-hint));--person-line3-font-size:var(--person-card-line3-font-size, 14px);--person-line3-font-weight:var(--person-card-line3-font-weight, 400);--person-line3-text-line-height:var(--person-card-line3-line-height, 19px);--person-line3-text-color:var(--person-card-line3-text-color, var(--neutral-foreground-hint));--person-avatar-size:var(--person-card-avatar-size, 75px);--person-presence-wrapper-bottom:-15px}:host .person-details-container .base-icons{display:flex;align-items:center;margin-inline-start:var(--person-card-base-icons-left-spacing,calc(var(--person-card-avatar-size,75px) + var(--person-card-details-left-spacing,15px) - 8px));z-index:1}:host .person-details-container .base-icons .icon{display:flex;align-items:center;font-size:13px;white-space:nowrap}:host .person-details-container .base-icons .icon:not(:last-child){margin-inline-end:28px}:host .person-details-container .base-icons .icon svg .filled{display:none}:host .person-details-container .base-icons .icon svg .regular{display:block}:host .person-details-container .base-icons .icon svg path{fill:var(--person-card-icon-color,var(--accent-foreground-rest))}:host .person-details-container .base-icons .icon:active svg .filled,:host .person-details-container .base-icons .icon:hover svg .filled{display:block}:host .person-details-container .base-icons .icon:active svg .regular,:host .person-details-container .base-icons .icon:hover svg .regular{display:none}:host .person-details-container .base-icons .icon:active svg path,:host .person-details-container .base-icons .icon:hover svg path{fill:var(--person-card-icon-hover-color,var(--accent-foreground-hover))}:host .expanded-details-container{display:flex;flex-direction:column;position:relative}:host .expanded-details-container .expanded-details-button{display:flex;justify-content:center;height:32px}:host .expanded-details-container .expanded-details-button svg path{stroke:var(--person-card-icon-color,var(--accent-foreground-rest))}:host .expanded-details-container .expanded-details-button:hover{cursor:pointer;background-color:var(--person-card-expanded-background-color-hover,var(--neutral-fill-hover))}:host .expanded-details-container .sections .section{padding:20px 0;display:flex;flex-direction:column;position:relative}:host .expanded-details-container .sections .section:not(:last-child)::after{position:absolute;content:"";width:90%;transform:translateX(-50%);border-bottom:1px solid var(--person-card-border-color,var(--neutral-stroke-rest));left:50%;bottom:0}:host .expanded-details-container .sections .section__header{display:flex;flex-direction:row;padding:0 20px}:host .expanded-details-container .sections .section__title{flex-grow:1;color:var(--person-card-line1-text-color,var(--neutral-foreground-rest));font-size:14px;font-weight:600;line-height:19px}:host .expanded-details-container .sections .section__show-more{font-size:12px;font-weight:600;align-self:center;vertical-align:top;--base-height-multiplier:6}:host .expanded-details-container .sections .section__show-more:hover{background-color:var(--person-card-fluent-background-color-hover,var(--neutral-fill-hover))}:host .expanded-details-container .sections .section__content{margin-top:14px}:host .expanded-details-container .sections .section .additional-details{padding:0 20px}:host .expanded-details-container .divider{z-index:100;position:relative;width:375px;margin:0;border-style:none;border-bottom:1px solid var(--person-card-border-color,var(--neutral-stroke-rest))}:host .expanded-details-container .section-nav{height:35px}:host .expanded-details-container .section-nav fluent-tabs{grid-template-columns:minmax(1px,.1fr)}:host .expanded-details-container .section-nav fluent-tabs.horizontal::part(activeIndicator){width:10px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel{max-height:360px;min-height:360px;overflow-y:auto;overflow-x:hidden;padding:0;scrollbar-width:thin}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel .inserted{padding:20px 0;max-width:var(--mgt-flyout-set-width,375px);min-width:var(--mgt-flyout-set-width,360px);--file-list-box-shadow:none;--file-list-padding:0}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel .inserted .title{font-size:14px;font-weight:600;color:var(--title-color-subtitle,var(--neutral-foreground-rest,#1a1a1a));margin:0 20px 20px;line-height:19px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel .overview-panel{max-width:var(--mgt-flyout-set-width,375px)}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel::-webkit-scrollbar{height:4em;width:4px;border-radius:11px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel::-webkit-scrollbar-button{height:1px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel::-webkit-scrollbar-track{border-radius:10px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab-panel::-webkit-scrollbar-thumb{background:grey;border-radius:10px;height:4px}:host .expanded-details-container .section-nav fluent-tabs fluent-tab{padding-bottom:1px!important;border:1px solid transparent!important}:host .expanded-details-container .section-nav fluent-tabs fluent-tab:focus-visible{border:1px solid #2b2b2b!important}:host .expanded-details-container .section-nav fluent-tabs fluent-tab.section-nav__icon{cursor:pointer;box-sizing:border-box;width:53px;height:36px;display:flex;align-items:center;justify-content:center}:host .expanded-details-container .section-nav fluent-tabs fluent-tab.section-nav__icon svg{fill:var(--person-card-fluent-background-color,transparent)}:host .expanded-details-container .section-nav fluent-tabs fluent-tab.section-nav__icon:hover{background:var(--person-card-fluent-background-color-hover,var(--neutral-fill-hover));border-radius:4px;z-index:0;position:relative}:host .expanded-details-container .section-host{min-height:360px;overflow-y:auto;overflow-x:hidden}:host .expanded-details-container .section-host::-webkit-scrollbar{height:4em;width:4px;border-radius:11px}:host .expanded-details-container .section-host::-webkit-scrollbar-button{background:#fff}:host .expanded-details-container .section-host::-webkit-scrollbar-track{background:#fff;border-radius:10px}:host .expanded-details-container .section-host::-webkit-scrollbar-track-piece{background:#fff}:host .expanded-details-container .section-host::-webkit-scrollbar-thumb{background:grey;border-radius:10px;height:4px}:host .expanded-details-container .section-host.small{overflow-y:hidden}:host .loading{margin:40px 20px;display:flex;justify-content:center;height:360px}:host .message-section{border-bottom:1px solid var(--person-card-chat-input-border-color,var(--neutral-foreground-hint));display:flex}:host .message-section fluent-text-field{margin:10px 10px 10px 16px;--neutral-fill-input-rest:$person-card-background-color;--neutral-fill-input-hover:$person-card-chat-input-hover-color;--neutral-fill-input-focus:$person-card-chat-input-focus-color;width:300px;margin-inline-start:16px;border-radius:4px;border:1px solid var(--person-card-chat-input-border-color,var(--neutral-foreground-hint))}:host .message-section .send-message-icon{max-width:15px;margin-top:10px}:host .message-section svg{height:17px;width:16px;fill:var(--person-card-chat-input-border-color,var(--neutral-foreground-hint))}:host .message-section svg:hover{filter:brightness(.5)}:host .message-section svg:disabled{filter:none}:host .person-root.large,:host .person-root.threelines{--person-avatar-size-3-lines:75px}:host fluent-button.close-button.lightweight::part(control),:host fluent-button.expanded-details-button::part(control),:host fluent-button.section__show-more.lightweight::part(control){background:var(--person-card-fluent-background-color,transparent)}:host fluent-button.icon::part(control),:host fluent-button.nav__back::part(control){border:none;padding:0;background:0 0}:host fluent-button.icon::part(control) :hover,:host fluent-button.nav__back::part(control) :hover{background:0 0}[dir=rtl] .base-icons{right:91px}[dir=rtl] .nav__back{width:20px!important;transform:scaleX(-1);filter:fliph;filter:FlipH}[dir=rtl] .close-card-container .close-button{right:auto;left:10px}[dir=rtl] .message-section svg{transform:scale(-1,1)}@media (forced-colors:active) and (prefers-color-scheme:dark){.root{border:1px solid #fff;border-radius:inherit}.root svg,.root svg>path{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}.expanded-details-container>svg,.expanded-details-container>svg>path,svg,svg>path{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}@media (forced-colors:active) and (prefers-color-scheme:light){.root{border:1px solid #000;border-radius:inherit}.root svg,.root svg>path{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}.expanded-details-container>svg,.expanded-details-container>svg>path,svg,svg>path{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}
`];var rf=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};class af extends Nt{get personDetails(){return this._personDetails}set personDetails(e){this._personDetails!==e&&(this._personDetails=e,this.requestStateUpdate())}get isCompact(){return this._isCompact}constructor(){super(),this._isCompact=!1,this._personDetails=null}asCompactView(){return this._isCompact=!0,this.requestUpdate(),this}asFullView(){return this._isCompact=!1,this.requestUpdate(),this}clearState(){this._isCompact=!1,this._personDetails=null}render(){return this.isCompact?this.renderCompactView():this.renderFullView()}renderLoading(){return pi`
      <div class="loading">
        <mgt-spinner></mgt-spinner>
      </div>
    `}renderNoData(){return Je`
      <div class="no-data">No data</div>
    `}navigateCard(e){var t;let i=this.parentNode;for(;i;){i=i.parentNode;const e=i;if((null===(t=null==e?void 0:e.host)||void 0===t?void 0:t.tagName)===`${ce.prefix}-PERSON-CARD`.toUpperCase()){i=e.host;break}}i.navigate(e)}}!function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);n>3&&r&&Object.defineProperty(t,i,r)}([Ct({attribute:"person-details",type:Object}),rf("design:type",Object),rf("design:paramtypes",[Object])],af.prototype,"personDetails",null);const lf=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .loading,:host .no-data{margin:0 20px;display:flex;justify-content:center}:host .no-data{font-style:normal;font-weight:600;font-size:14px;color:var(--font-color,#323130);line-height:19px}:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{position:relative;user-select:none}:host .root .part{display:grid;grid-template-columns:auto 1fr auto}:host .root .part .part__icon{display:flex;min-width:20px;width:20px;height:20px;align-items:center;justify-content:center;margin-left:20px;margin-top:10px;line-height:20px}:host .root .part .part__icon svg{fill:var(--contact-copy-icon-color,var(--neutral-foreground-hint))}:host .root .part .part__details{margin:10px 14px;overflow:hidden}:host .root .part .part__details .part__title{font-size:12px;color:var(--contact-title-color,var(--neutral-foreground-hint));line-height:16px}:host .root .part .part__details .part__value{grid-column:2;color:var(--contact-value-color,var(--neutral-foreground-rest));font-size:14px;font-weight:400;line-height:19px}:host .root .part .part__details .part__value .part__link{color:var(--contact-link-color,var(--accent-foreground-rest));font-size:14px;cursor:pointer;text-overflow:ellipsis;overflow:hidden;white-space:nowrap;width:100%;display:inline-block}:host .root .part .part__details .part__value .part__link:hover{color:var(--contact-link-hover-color,var(--accent-foreground-hover))}:host .root .part .part__copy{width:32px;height:100%;background-color:var(--contact-background-color,transparent);visibility:hidden;display:flex;align-items:center;justify-content:flex-start}:host .root .part .part__copy svg{fill:var(--contact-copy-icon-color,var(--neutral-foreground-hint));cursor:pointer}:host .root .part:hover .part__copy{visibility:visible}:host .root.compact{padding:0}:host .root.compact .part{height:30px;align-items:center}:host .root.compact .part__details{margin:0}:host .root.compact .part__title{display:none}:host .root.compact .part__icon{margin-top:0;margin-right:6px;margin-bottom:2px}[dir=rtl] .part__link.phone{text-align:right;direction:ltr}[dir=rtl] .part__icon{margin:10px 20px 0 0!important}[dir=rtl].compact .part__icon{margin-left:6px!important;margin-top:0!important}@media (forced-colors:active) and (prefers-color-scheme:dark){.root svg{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}.root svg path,.root svg rect{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}@media (forced-colors:active) and (prefers-color-scheme:light){.root svg{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}.root svg path,.root svg rect{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}
`],df={contactSectionTitle:"Contact",emailTitle:"Email",chatTitle:"Teams",businessPhoneTitle:"Business Phone",cellPhoneTitle:"Mobile Phone",departmentTitle:"Department",titleTitle:"Title",officeLocationTitle:"Office Location",copyToClipboardButton:"Copy to clipboard"};let cf=class extends af{static get styles(){return lf}get strings(){return df}get hasData(){if(!this._contactParts)return!1;const e=Object.values(this._contactParts).filter((e=>!!e.value));return!!e.length}constructor(e){var t;super(),this._contactParts={email:{icon:Co(ko.Email),onClick:()=>this.sendEmail(Qi(this._person)),showCompact:!0,title:this.strings.emailTitle},chat:{icon:Co(ko.Chat),onClick:()=>{var e;return this.sendChat(null===(e=this._person)||void 0===e?void 0:e.userPrincipalName)},showCompact:!1,title:this.strings.chatTitle},businessPhone:{icon:Co(ko.Phone),onClick:()=>{var e,t;return this.sendCall((null===(t=null===(e=this._person)||void 0===e?void 0:e.businessPhones)||void 0===t?void 0:t.length)>0?this._person.businessPhones[0]:null)},showCompact:!0,title:this.strings.businessPhoneTitle},cellPhone:{icon:Co(ko.CellPhone),onClick:()=>{var e;return this.sendCall(null===(e=this._person)||void 0===e?void 0:e.mobilePhone)},showCompact:!0,title:this.strings.cellPhoneTitle},department:{icon:Co(ko.Department),showCompact:!1,title:this.strings.departmentTitle},title:{icon:Co(ko.Person),showCompact:!1,title:this.strings.titleTitle},officeLocation:{icon:Co(ko.OfficeLocation),showCompact:!0,title:this.strings.officeLocationTitle}},this.sendCall=e=>{this.sendLink("tel:",e)},this._person=e,this._contactParts.email.value=Qi(this._person),this._contactParts.chat.value=this._person.userPrincipalName,this._contactParts.cellPhone.value=this._person.mobilePhone,this._contactParts.department.value=this._person.department,this._contactParts.title.value=this._person.jobTitle,this._contactParts.officeLocation.value=this._person.officeLocation,(null===(t=this._person.businessPhones)||void 0===t?void 0:t.length)&&(this._contactParts.businessPhone.value=this._person.businessPhones[0])}get displayName(){return this.strings.contactSectionTitle}get cardTitle(){return this.strings.contactSectionTitle}renderIcon(){return Co(ko.Contact)}clearState(){super.clearState();for(const e of Object.keys(this._contactParts))this._contactParts[e].value=null}renderCompactView(){if(!this.hasData)return null;const e=Object.values(this._contactParts).filter((e=>!!e.value));let t=Object.values(e).filter((e=>!!e.value&&e.showCompact));(null==t?void 0:t.length)||(t=Object.values(e).slice(0,2));const i=Je`
      ${t.map((e=>this.renderContactPart(e)))}
    `;return Je`
      <div class="root compact" dir=${this.direction}>
        ${i}
      </div>
    `}renderFullView(){let e;if(this.hasData){const t=Object.values(this._contactParts).filter((e=>!!e.value));e=Je`
        ${t.map((e=>this.renderContactPart(e)))}
      `}return Je`
      <div class="root" dir=${this.direction}>
        ${e}
      </div>
    `}renderContactPart(e){let t=!1;"Mobile Phone"!==e.title&&"Business Phone"!==e.title||(t=!0);const i={part__link:!0,phone:t},o=e.onClick?Je`
          <span class=${ki(i)} @click=${t=>e.onClick(t)}>${e.value}</span>
        `:Je`
          ${e.value}
        `;return Je`
      <div class="part" role="button" @click=${t=>this.handlePartClick(t,e.value)} tabindex="0">
        <div class="part__icon" aria-label=${e.title} title=${e.title}>${e.icon}</div>
        <div class="part__details">
          <div class="part__title">${e.title}</div>
          <div class="part__value" title=${e.title}>${o}</div>
        </div>
        <div
          class="part__copy"
          aria-label=${this.strings.copyToClipboardButton}
          title=${this.strings.copyToClipboardButton}
        >
          ${Co(ko.Copy)}
        </div>
      </div>
    `}handlePartClick(e,t){t&&navigator.clipboard.writeText(t)}sendLink(e,t){t?window.open(`${e}${t}`,"_blank","noreferrer"):console.error(`🦒: Target resource for ${e} link was not provided: resource: ${t}`)}sendChat(e){if(!e)return void console.error("🦒: Can't send chat when upn is not provided");const t=`https://teams.microsoft.com/l/chat/0/0?users=${e}`,i=()=>window.open(t,"_blank","noreferrer");li.isAvailable?li.executeDeepLink(t,(e=>{e||i()})):i()}sendEmail(e){this.sendLink("mailto:",e)}};cf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}([gi("contact"),function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}("design:paramtypes",[Object])],cf);const hf=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .loading,:host .no-data{margin:0 20px;display:flex;justify-content:center}:host .no-data{font-style:normal;font-weight:600;font-size:14px;color:var(--font-color,#323130);line-height:19px}:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{position:relative;user-select:none}:host .root.compact{padding:0}:host .root .message{padding:8px 20px;display:flex;align-items:center;justify-content:space-between}:host .root .message:hover{background-color:var(--message-hover-color,var(--neutral-fill-hover));cursor:pointer}:host .root .message:last-child{margin-bottom:unset}:host .root .message .message__detail{min-width:0;line-height:normal}:host .root .message .message__detail .message__subject{color:var(--message-subject-color,var(--neutral-foreground-color));font-size:var(--message-subject-font-size,14px);font-weight:var(--message-subject-font-weight,600);line-height:var(--message-subject-line-height,20px)}:host .root .message .message__detail .message__from{font-size:var(--message-subject-font-size,12px);color:var(--message-from-color,var(--neutral-foreground-color));line-height:var(--message-subject-line-height,16px);font-weight:var(--message-subject-font-weight,400)}:host .root .message .message__detail .message__message{font-size:var(--message-subject-font-size,12px);color:var(--message-color,var(--neutral-foreground-hint));line-height:var(--message-subject-line-height,16px);font-weight:var(--message-subject-font-weight,400)}:host .root .message .message__detail>div{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}:host .root .message .message__date{margin-top:8px;font-size:12px;color:var(--message-date,var(--neutral-foreground-hint));margin-left:10px;white-space:nowrap}
`],uf={emailsSectionTitle:"Emails"};let pf=class extends af{static get styles(){return hf}get strings(){return uf}constructor(e){super(),this._messages=e}get displayName(){return this.strings.emailsSectionTitle}get cardTitle(){return this.strings.emailsSectionTitle}clearState(){super.clearState(),this._messages=[]}renderIcon(){return Co(ko.Messages)}renderCompactView(){var e;let t;if(this.isLoadingState)t=this.renderLoading();else if(null===(e=this._messages)||void 0===e?void 0:e.length){const e=this._messages?this._messages.slice(0,3).map((e=>this.renderMessage(e))):[];t=Je`
         ${e}
       `}else t=this.renderNoData();return Je`
       <div class="root compact">
         ${t}
       </div>
     `}renderFullView(){var e;let t;return t=this.isLoadingState?this.renderLoading():(null===(e=this._messages)||void 0===e?void 0:e.length)?Je`
         ${this._messages.slice(0,5).map((e=>this.renderMessage(e)))}
       `:this.renderNoData(),Je`
       <div class="root">
         ${t}
       </div>
     `}renderMessage(e){return Je`
       <div class="message" @click=${()=>this.handleMessageClick(e)}>
         <div class="message__detail">
           <div class="message__subject">${e.subject}</div>
           <div class="message__from">${e.from.emailAddress.name}</div>
           <div class="message__message">${e.bodyPreview}</div>
         </div>
         <div class="message__date">${Ci(new Date(e.receivedDateTime))}</div>
       </div>
     `}handleMessageClick(e){window.open(e.webLink,"_blank","noreferrer")}};pf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}([gi("messages"),function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}("design:paramtypes",[Array])],pf);const gf=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .loading,:host .no-data{margin:0 20px;display:flex;justify-content:center}:host .no-data{font-style:normal;font-weight:600;font-size:14px;color:var(--font-color,#323130);line-height:19px}:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{position:relative;user-select:none}:host .root.compact{padding:0}:host .root.compact .coworker .coworker__image{height:40px;width:40px;border-radius:40px;--avatar-size:40px;--avatar-size-s:40px;margin-right:12px}:host .root.compact .coworker .coworker__name{font-size:14px}:host .root.compact .coworker .coworker__title{font-size:12px}:host .root .subtitle{color:var(--organization-sub-title-color,var(--neutral-foreground-hint));font-size:14px;margin:0 20px 8px}:host .root .divider{display:flex;background:var(--organization-coworker-border-color,var(--neutral-stroke-rest));height:1px;margin:26px 20px 18px}:host .root .org-member{height:74px;box-sizing:border-box;border-radius:2px;padding:12px;display:flex;align-items:center;margin-left:20px;margin-right:20px}:host .root .org-member.org-member--target{background-color:var(--organization-active-org-member-target-background-color,var(--neutral-fill-active));border:1px solid var(--organization-active-org-member-border-color,var(--accent-foreground-rest))}:host .root .org-member:not(.org-member--target){border:1px solid var(--organization-coworker-border-color,var(--neutral-stroke-rest))}:host .root .org-member:not(.org-member--target):hover{cursor:pointer;background-color:var(--organization-hover-color,var(--neutral-fill-hover))}:host .root .org-member .org-member__person{flex-grow:1}:host .root .org-member .org-member__details{flex-grow:1}:host .root .org-member .org-member__details .org-member__name{font-size:16px;color:var(--organization-title-color,var(--neutral-foreground-rest));font-weight:600}:host .root .org-member .org-member__details .org-member__department,:host .root .org-member .org-member__details .org-member__title{font-weight:14px;color:var(--organization-sub-title-color,var(--neutral-foreground-hint))}:host .root .org-member__separator:not(:last-child){border:1px solid var(--organization-coworker-border-color,var(--neutral-stroke-rest));box-sizing:border-box;width:0;margin:0 50%;height:14px}:host .root .coworker{display:flex;align-items:center;padding:10px 20px}:host .root .coworker:hover{cursor:pointer;background-color:var(--organization-coworker-hover-color,var(--neutral-fill-hover))}:host .root .coworker .coworker__person{height:46px;border-radius:46px;margin-right:8px}:host .root .direct-report__compact{padding:12px 20px}:host .root .direct-report__compact .direct-report{cursor:pointer;width:38px;margin-right:4px;display:inline;--avatar-size:38px}[dir=rtl] .org-member .org-member__more{transform:scaleX(-1);filter:fliph;filter:FlipH}@media (forced-colors:active) and (prefers-color-scheme:dark){:host svg,:host svg>path{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}@media (forced-colors:active) and (prefers-color-scheme:light){:host svg,:host svg>path{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}
`],ff={reportsToSectionTitle:"Reports to",directReportsSectionTitle:"Direct reports",organizationSectionTitle:"Organization",youWorkWithSubSectionTitle:"You work with",userWorksWithSubSectionTitle:"works with"};let vf=class extends af{static get styles(){return gf}get strings(){return ff}constructor(e,t){super(),this._state=e,this._me=t}clearState(){super.clearState(),this._state=null,this._me=null}get displayName(){const{person:e,directReports:t}=this._state;return!e.manager&&(null==t?void 0:t.length)?`${this.strings.directReportsSectionTitle} (${t.length})`:this.strings.reportsToSectionTitle}get cardTitle(){return this.strings.organizationSectionTitle}renderIcon(){return Co(ko.Organization)}renderCompactView(){var e;let t;if(!(null===(e=this._state)||void 0===e?void 0:e.person))return null;const{person:i,directReports:o}=this._state;return i?(i.manager?t=this.renderCoworker(i.manager):(null==o?void 0:o.length)&&(t=this.renderCompactDirectReports()),Je`
        <div class="root compact">
          ${t}
        </div>
      `):null}renderFullView(){var e;let t;if(!(null===(e=this._state)||void 0===e?void 0:e.person))return null;const{person:i,directReports:o,people:s}=this._state;if(!(i||o||s))return null;{const e=this.renderManagers(),i=this.renderCurrentUser(),o=this.renderDirectReports(),s=this.renderCoworkers();t=Je`
          ${e} ${i} ${o} ${s}
        `}return Je`
       <div class="root" dir=${this.direction}>
         ${t}
       </div>
     `}renderManager(e){return pi`
      <div
        class="org-member"
        @keydown=${t=>{"Enter"!==t.code&&" "!==t.code||this.navigateCard(e)}}
        @click=${()=>this.navigateCard(e)}
      >
        <div class="org-member__person">
          <mgt-person
            .personDetails=${e}
            .fetchImage=${!0}
            .view=${xo.twolines}
            .showPresence=${!0}
          ></mgt-person>
        </div>
        <div tabindex="0" class="org-member__more">
          ${Co(ko.ExpandRight)}
        </div>
      </div>
      <div class="org-member__separator"></div>
     `}renderManagers(){const{person:e}=this._state;if(!(null==e?void 0:e.manager))return null;const t=[];let i=e;for(;i.manager;)t.push(i.manager),i=i.manager;return t.length?t.reverse().map((e=>this.renderManager(e))):null}renderDirectReports(){const{directReports:e}=this._state;return(null==e?void 0:e.length)?Je`
      <div class="org-member__separator"></div>
      <div>
        ${e.map((e=>pi`
            <div
              class="org-member org-member--direct-report"
              @keydown=${t=>{"Enter"!==t.code&&" "!==t.code||this.navigateCard(e)}}
              @click=${()=>this.navigateCard(e)}
            >
              <div class="org-member__person">
                <mgt-person
                  .personDetails=${e}
                  .fetchImage=${!0}
                  .showPresence=${!0}
                  .view=${xo.twolines}
                ></mgt-person>
              </div>
              <div tabindex="0" class="org-member__more">
                ${Co(ko.ExpandRight)}
              </div>
            </div>
            <div class="org-member__separator"></div>
          `))}
      </div>
     `:null}renderCompactDirectReports(){const{directReports:e}=this._state;return Je`
      <div class="direct-report__compact">
        ${e.slice(0,6).map((e=>pi`
            <div
              class="direct-report"
              @keydown=${t=>{"Enter"!==t.code&&" "!==t.code||this.navigateCard(e)}}
              @click=${()=>this.navigateCard(e)}
            >
              <mgt-person
                .personDetails=${e}
                .fetchImage=${!0}
                .showPresence=${!0}
                .view=${xo.twolines}
              ></mgt-person>
            </div>
          `))}
      </div>
    `}renderCurrentUser(){const{person:e}=this._state;return pi`
       <div class="org-member org-member--target">
         <div class="org-member__person">
           <mgt-person
             .personDetails=${e}
             .fetchImage=${!0}
             .showPresence=${!0}
             .view=${xo.twolines}
           ></mgt-person>
         </div>
       </div>
     `}renderCoworker(e){return pi`
      <div
        class="coworker"
        @keydown=${t=>{"Enter"!==t.code&&" "!==t.code||this.navigateCard(e)}}
        @click=${()=>this.navigateCard(e)}
      >
        <div class="coworker__person">
          <mgt-person
            .personDetails=${e}
            .fetchImage=${!0}
            .showPresence=${!0}
            .view=${xo.twolines}
          ></mgt-person>
        </div>
      </div>
    `}renderCoworkers(){const{people:e}=this._state;if(!(null==e?void 0:e.length))return null;const t=this._me.id===this._state.person.id?this.strings.youWorkWithSubSectionTitle:`${this._state.person.givenName} ${this.strings.userWorksWithSubSectionTitle}`;return Je`
       <div class="divider"></div>
       <div class="subtitle" tabindex="0">${t}</div>
       <div>
         ${e.slice(0,6).map((e=>this.renderCoworker(e)))}
       </div>
     `}};vf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}([gi("organization"),function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}("design:paramtypes",[Object,Object])],vf);const mf=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .loading,:host .no-data{margin:0 20px;display:flex;justify-content:center}:host .no-data{font-style:normal;font-weight:600;font-size:14px;color:var(--font-color,#323130);line-height:19px}:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{position:relative;user-select:none;background-color:var(--profile-background-color,--neutral-layer-1)}:host .root{padding:20px 0}:host .root.compact{padding:0}:host .root .title{font-size:14px;font-weight:600;color:var(--profile-title-color,var(--neutral-foreground-rest));margin:0 20px 12px}:host .root section{margin-bottom:24px;padding:0 20px}:host .root section:last-child{margin:0}:host .root section .section__title{font-size:14px;color:var(--profile-section-title-color,var(--neutral-foreground-hint))}:host .root section .section__content{display:flex;flex-direction:column;margin-top:10px}:host .root .token-list{display:flex;flex-flow:row wrap;margin-top:-10px}:host .root .token-list .token-list__item{text-overflow:ellipsis;white-space:nowrap;display:inline-block;overflow:hidden;font-size:14px;align-items:center;background:var(--profile-token-item-background-color,var(--neutral-fill-secondary-rest));border-radius:2px;max-height:28px;padding:4px 8px;margin-right:10px;margin-top:10px;color:var(--profile-token-item-color,var(--neutral-foreground-rest))}:host .root .token-list .token-list__item:last-child{margin-right:initial}:host .root .token-list .token-list__item.overflow{display:none}:host .root .token-list .token-list__item.token-list__item--show-overflow{cursor:pointer;user-select:unset;background:0 0;color:var(--profile-token-overflow-color,var(--accent-foreground-rest))}:host .root .data-list__item{margin-bottom:20px}:host .root .data-list__item:last-child{margin-bottom:initial}:host .root .data-list__item .data-list__item__header{display:flex;justify-content:space-between;align-items:center}:host .root .data-list__item .data-list__item__content{font-size:12px;line-height:16px;color:var(--profile-section-title-color,var(--neutral-foreground-hint));margin-top:4px}:host .root .data-list__item .data-list__item__title{font-size:14px;line-height:16px;color:var(--profile-title-color,var(--neutral-foreground-rest))}:host .root .data-list__item .data-list__item__date-range{color:var(--profile-section-title-color,var(--neutral-foreground-hint));font-size:10px;line-height:12px}:host .root .language__proficiency{opacity:.77}:host .root .work-position .work-position__company{color:#023b8f}:host .root .work-position .work-position__location{font-size:10px;color:var(--profile-section-title-color,var(--neutral-foreground-hint));line-height:16px}:host .root .educational-activity .educational-activity__degree{font-size:12px;line-height:14px;color:var(--profile-section-title-color,var(--neutral-foreground-hint))}:host .root .birthday{display:flex;align-items:center;margin-top:-6px}:host .root .birthday .birthday__icon{margin-right:8px}:host .root .birthday .birthday__date{font-size:12px;color:var(--profile-title-color,var(--neutral-foreground-rest))}[dir=rtl] .token-list__item{margin-right:0!important}
`],bf={SkillsAndExperienceSectionTitle:"Skills & Experience",AboutCompactSectionTitle:"About",SkillsSubSectionTitle:"Skills",LanguagesSubSectionTitle:"Languages",WorkExperienceSubSectionTitle:"Work Experience",EducationSubSectionTitle:"Education",professionalInterestsSubSectionTitle:"Professional Interests",personalInterestsSubSectionTitle:"Personal Interests",birthdaySubSectionTitle:"Birthday",currentYearSubtitle:"Current",socialMediaSubSectionTitle:"Social Media"};let yf=class extends af{static get styles(){return mf}get strings(){return bf}get displayName(){return this.strings.SkillsAndExperienceSectionTitle}get cardTitle(){return this.strings.AboutCompactSectionTitle}get hasData(){var e,t;if(!this.profile)return!1;const{languages:i,skills:o,positions:s,educationalActivities:n}=this.profile;return[this._birthdayAnniversary,null===(e=this._personalInterests)||void 0===e?void 0:e.length,null===(t=this._professionalInterests)||void 0===t?void 0:t.length,null==i?void 0:i.length,null==o?void 0:o.length,null==s?void 0:s.length,null==n?void 0:n.length].filter((e=>!!e)).length>0}get profile(){return this._profile}set profile(e){e!==this._profile&&(this._profile=e,this._birthdayAnniversary=(null==e?void 0:e.anniversaries)?e.anniversaries.find(this.isBirthdayAnniversary):null,this._personalInterests=(null==e?void 0:e.interests)?e.interests.filter(this.isPersonalInterest):null,this._professionalInterests=(null==e?void 0:e.interests)?e.interests.filter(this.isProfessionalInterest):null)}constructor(e){super(),this.isPersonalInterest=e=>{var t;return null===(t=e.categories)||void 0===t?void 0:t.includes("personal")},this.isProfessionalInterest=e=>{var t;return null===(t=e.categories)||void 0===t?void 0:t.includes("professional")},this.isBirthdayAnniversary=e=>"birthday"===e.type,this.profile=e}renderIcon(){return Co(ko.Profile)}clearState(){super.clearState(),this.profile=null}renderCompactView(){return Je`
       <div class="root compact" dir=${this.direction}>
         ${this.renderSubSections().slice(0,2)}
       </div>
     `}renderFullView(){return this.initPostRenderOperations(),Je`
       <div class="root" dir=${this.direction}>
         ${this.renderSubSections()}
       </div>
     `}renderSubSections(){return[this.renderSkills(),this.renderBirthday(),this.renderLanguages(),this.renderWorkExperience(),this.renderEducation(),this.renderProfessionalInterests(),this.renderPersonalInterests()].filter((e=>!!e))}renderLanguages(){var e;const{languages:t}=this._profile;if(!(null==t?void 0:t.length))return null;const i=[];for(const o of t){let t=null;(null===(e=o.proficiency)||void 0===e?void 0:e.length)&&(t=Je`
           <span class="language__proficiency" tabindex="0">
             &nbsp;(${o.proficiency})
           </span>
         `),i.push(Je`
         <div class="token-list__item language">
           <span class="language__title" tabindex="0">${o.displayName}</span>
           ${t}
         </div>
       `)}const o=i.length?this.strings.LanguagesSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${o}</div>
         <div class="section__content">
           <div class="token-list">
             ${i}
           </div>
         </div>
       </section>
     `}renderSkills(){const{skills:e}=this._profile;if(!(null==e?void 0:e.length))return null;const t=[];for(const i of e)t.push(Je`
         <div class="token-list__item skill" tabindex="0">
           ${i.displayName}
         </div>
       `);const i=t.length?this.strings.SkillsSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${i}</div>
         <div class="section__content">
           <div class="token-list">
             ${t}
           </div>
         </div>
       </section>
     `}renderWorkExperience(){var e,t,i,o,s;const{positions:n}=this._profile;if(!(null==n?void 0:n.length))return null;const r=[];for(const n of this._profile.positions)(n.detail.description||""!==n.detail.jobTitle)&&r.push(Je`
           <div class="data-list__item work-position">
             <div class="data-list__item__header">
               <div class="data-list__item__title" tabindex="0">${null===(e=n.detail)||void 0===e?void 0:e.jobTitle}</div>
               <div class="data-list__item__date-range" tabindex="0">
                 ${this.getDisplayDateRange(n.detail)}
               </div>
             </div>
             <div class="data-list__item__content">
               <div class="work-position__company" tabindex="0">
                 ${null===(i=null===(t=null==n?void 0:n.detail)||void 0===t?void 0:t.company)||void 0===i?void 0:i.displayName}
               </div>
               <div class="work-position__location" tabindex="0">
                 ${this.displayLocation(null===(s=null===(o=null==n?void 0:n.detail)||void 0===o?void 0:o.company)||void 0===s?void 0:s.address)}
               </div>
             </div>
           </div>
         `);const a=r.length?this.strings.WorkExperienceSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${a}</div>
         <div class="section__content">
           <div class="data-list">
             ${r}
           </div>
         </div>
       </section>
     `}renderEducation(){const{educationalActivities:e}=this._profile;if(!(null==e?void 0:e.length))return null;const t=[];for(const i of e)t.push(Je`
         <div class="data-list__item educational-activity">
           <div class="data-list__item__header">
             <div class="data-list__item__title" tabindex="0">${i.institution.displayName}</div>
             <div class="data-list__item__date-range" tabindex="0">
               ${this.getDisplayDateRange(i)}
             </div>
           </div>
           ${i.program.displayName?Je`<div class="data-list__item__content">
                  <div class="educational-activity__degree" tabindex="0">
                  ${i.program.displayName}
                </div>`:et}
         </div>
       `);const i=t.length?this.strings.EducationSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${i}</div>
         <div class="section__content">
           <div class="data-list">
             ${t}
           </div>
         </div>
       </section>
     `}renderProfessionalInterests(){var e;if(!(null===(e=this._professionalInterests)||void 0===e?void 0:e.length))return null;const t=[];for(const e of this._professionalInterests)t.push(Je`
         <div class="token-list__item interest interest--professional" tabindex="0">
           ${e.displayName}
         </div>
       `);const i=t.length?this.strings.professionalInterestsSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${i}</div>
         <div class="section__content">
           <div class="token-list">
             ${t}
           </div>
         </div>
       </section>
     `}renderPersonalInterests(){var e;if(!(null===(e=this._personalInterests)||void 0===e?void 0:e.length))return null;const t=[];for(const e of this._personalInterests)t.push(Je`
         <div class="token-list__item interest interest--personal" tabindex="0">
           ${e.displayName}
         </div>
       `);const i=t.length?this.strings.personalInterestsSubSectionTitle:"";return Je`
       <section>
         <div class="section__title" tabindex="0">${i}</div>
         <div class="section__content">
           <div class="token-list">
             ${t}
           </div>
         </div>
       </section>
     `}renderBirthday(){var e;return(null===(e=this._birthdayAnniversary)||void 0===e?void 0:e.date)?Je`
       <section>
         <div class="section__title" tabindex="0">Birthday</div>
         <div class="section__content">
           <div class="birthday">
             <div class="birthday__icon">
               ${Co(ko.Birthday)}
             </div>
             <div class="birthday__date" tabindex="0">
               ${this.getDisplayDate(new Date(this._birthdayAnniversary.date))}
             </div>
           </div>
         </div>
       </section>
     `:null}getDisplayDate(e){return e.toLocaleString("default",{day:"numeric",month:"long"})}getDisplayDateRange(e){if(!e.startMonthYear)return et;const t=new Date(e.startMonthYear).getFullYear();return 0===t||1===t?et:`${t} — ${e.endMonthYear?new Date(e.endMonthYear).getFullYear():this.strings.currentYearSubtitle}`}displayLocation(e){return(null==e?void 0:e.city)?e.state?`${e.city}, ${e.state}`:e.city:et}initPostRenderOperations(){setTimeout((()=>{try{this.shadowRoot.querySelectorAll("section").forEach((e=>{this.handleTokenOverflow(e)}))}catch(e){}}),0)}handleTokenOverflow(e){const t=e.querySelectorAll(".token-list");if(null==t?void 0:t.length)for(const e of Array.from(t)){const t=e.querySelectorAll(".token-list__item");if(!(null==t?void 0:t.length))continue;let i=null,o=t[0].getBoundingClientRect();const s=e.getBoundingClientRect(),n=2*o.height+s.top;for(let e=0;e<t.length-1;e++)if(o=t[e].getBoundingClientRect(),o.top>n){i=Array.from(t).slice(e,t.length);break}if(i){i.forEach((e=>e.classList.add("overflow")));const t=document.createElement("div");t.classList.add("token-list__item"),t.classList.add("token-list__item--show-overflow"),t.tabIndex=0,t.innerText=`+ ${i.length} more`;const o=()=>{t.remove(),i.forEach((e=>e.classList.remove("overflow")))};t.addEventListener("click",(()=>{o()})),t.addEventListener("keydown",(e=>{"Enter"===e.code&&o()})),e.appendChild(t)}}}};yf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r}([gi("profile"),function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}("design:paramtypes",[Object])],yf);const wf={showMoreSectionButton:"Show more",endOfCard:"End of the card",quickMessage:"Send a quick message",expandDetailsLabel:"Expand details",sendMessageLabel:"Send message",emailButtonLabel:"Email",callButtonLabel:"Call",chatButtonLabel:"Chat",closeCardLabel:"Close card",videoButtonLabel:"Video",goBackLabel:"Go Back"},xf="horizontal";class kf extends Ln{constructor(){super(...arguments),this.orientation=xf,this.activeindicator=!0,this.showActiveIndicator=!0,this.prevActiveTabIndex=0,this.activeTabIndex=0,this.ticking=!1,this.change=()=>{this.$emit("change",this.activetab)},this.isDisabledElement=e=>"true"===e.getAttribute("aria-disabled"),this.isHiddenElement=e=>e.hasAttribute("hidden"),this.isFocusableElement=e=>!this.isDisabledElement(e)&&!this.isHiddenElement(e),this.setTabs=()=>{const e="gridColumn",t="gridRow",i=this.isHorizontal()?e:t;this.activeTabIndex=this.getActiveIndex(),this.showActiveIndicator=!1,this.tabs.forEach(((o,s)=>{if("tab"===o.slot){const e=this.activeTabIndex===s&&this.isFocusableElement(o);this.activeindicator&&this.isFocusableElement(o)&&(this.showActiveIndicator=!0);const t=this.tabIds[s],i=this.tabpanelIds[s];o.setAttribute("id",t),o.setAttribute("aria-selected",e?"true":"false"),o.setAttribute("aria-controls",i),o.addEventListener("click",this.handleTabClick),o.addEventListener("keydown",this.handleTabKeyDown),o.setAttribute("tabindex",e?"0":"-1"),e&&(this.activetab=o,this.activeid=t)}o.style[e]="",o.style[t]="",o.style[i]=`${s+1}`,this.isHorizontal()?o.classList.remove("vertical"):o.classList.add("vertical")}))},this.setTabPanels=()=>{this.tabpanels.forEach(((e,t)=>{const i=this.tabIds[t],o=this.tabpanelIds[t];e.setAttribute("id",o),e.setAttribute("aria-labelledby",i),this.activeTabIndex!==t?e.setAttribute("hidden",""):e.removeAttribute("hidden")}))},this.handleTabClick=e=>{const t=e.currentTarget;1===t.nodeType&&this.isFocusableElement(t)&&(this.prevActiveTabIndex=this.activeTabIndex,this.activeTabIndex=this.tabs.indexOf(t),this.setComponent())},this.handleTabKeyDown=e=>{if(this.isHorizontal())switch(e.key){case pu:e.preventDefault(),this.adjustBackward(e);break;case gu:e.preventDefault(),this.adjustForward(e)}else switch(e.key){case fu:e.preventDefault(),this.adjustBackward(e);break;case uu:e.preventDefault(),this.adjustForward(e)}switch(e.key){case bu:e.preventDefault(),this.adjust(-this.activeTabIndex);break;case yu:e.preventDefault(),this.adjust(this.tabs.length-this.activeTabIndex-1)}},this.adjustForward=e=>{const t=this.tabs;let i=0;for(i=this.activetab?t.indexOf(this.activetab)+1:1,i===t.length&&(i=0);i<t.length&&t.length>1;){if(this.isFocusableElement(t[i])){this.moveToTabByIndex(t,i);break}if(this.activetab&&i===t.indexOf(this.activetab))break;i+1>=t.length?i=0:i+=1}},this.adjustBackward=e=>{const t=this.tabs;let i=0;for(i=this.activetab?t.indexOf(this.activetab)-1:0,i=i<0?t.length-1:i;i>=0&&t.length>1;){if(this.isFocusableElement(t[i])){this.moveToTabByIndex(t,i);break}i-1<0?i=t.length-1:i-=1}},this.moveToTabByIndex=(e,t)=>{const i=e[t];this.activetab=i,this.prevActiveTabIndex=this.activeTabIndex,this.activeTabIndex=t,i.focus(),this.setComponent()}}orientationChanged(){this.$fastController.isConnected&&(this.setTabs(),this.setTabPanels(),this.handleActiveIndicatorPosition())}activeidChanged(e,t){this.$fastController.isConnected&&this.tabs.length<=this.tabpanels.length&&(this.prevActiveTabIndex=this.tabs.findIndex((t=>t.id===e)),this.setTabs(),this.setTabPanels(),this.handleActiveIndicatorPosition())}tabsChanged(){this.$fastController.isConnected&&this.tabs.length<=this.tabpanels.length&&(this.tabIds=this.getTabIds(),this.tabpanelIds=this.getTabPanelIds(),this.setTabs(),this.setTabPanels(),this.handleActiveIndicatorPosition())}tabpanelsChanged(){this.$fastController.isConnected&&this.tabpanels.length<=this.tabs.length&&(this.tabIds=this.getTabIds(),this.tabpanelIds=this.getTabPanelIds(),this.setTabs(),this.setTabPanels(),this.handleActiveIndicatorPosition())}getActiveIndex(){return void 0!==this.activeid?-1===this.tabIds.indexOf(this.activeid)?0:this.tabIds.indexOf(this.activeid):0}getTabIds(){return this.tabs.map((e=>{var t;return null!==(t=e.getAttribute("id"))&&void 0!==t?t:`tab-${Pp()}`}))}getTabPanelIds(){return this.tabpanels.map((e=>{var t;return null!==(t=e.getAttribute("id"))&&void 0!==t?t:`panel-${Pp()}`}))}setComponent(){this.activeTabIndex!==this.prevActiveTabIndex&&(this.activeid=this.tabIds[this.activeTabIndex],this.focusTab(),this.change())}isHorizontal(){return this.orientation===xf}handleActiveIndicatorPosition(){this.showActiveIndicator&&this.activeindicator&&this.activeTabIndex!==this.prevActiveTabIndex&&(this.ticking?this.ticking=!1:(this.ticking=!0,this.animateActiveIndicator()))}animateActiveIndicator(){this.ticking=!0;const e=this.isHorizontal()?"gridColumn":"gridRow",t=this.isHorizontal()?"translateX":"translateY",i=this.isHorizontal()?"offsetLeft":"offsetTop",o=this.activeIndicatorRef[i];this.activeIndicatorRef.style[e]=`${this.activeTabIndex+1}`;const s=this.activeIndicatorRef[i];this.activeIndicatorRef.style[e]=`${this.prevActiveTabIndex+1}`;const n=s-o;this.activeIndicatorRef.style.transform=`${t}(${n}px)`,this.activeIndicatorRef.classList.add("activeIndicatorTransition"),this.activeIndicatorRef.addEventListener("transitionend",(()=>{this.ticking=!1,this.activeIndicatorRef.style[e]=`${this.activeTabIndex+1}`,this.activeIndicatorRef.style.transform=`${t}(0px)`,this.activeIndicatorRef.classList.remove("activeIndicatorTransition")}))}adjust(e){const t=this.tabs.filter((e=>this.isFocusableElement(e))),i=t.indexOf(this.activetab),o=Lp(0,t.length-1,i+e),s=this.tabs.indexOf(t[o]);s>-1&&this.moveToTabByIndex(this.tabs,s)}focusTab(){this.tabs[this.activeTabIndex].focus()}connectedCallback(){super.connectedCallback(),this.tabIds=this.getTabIds(),this.tabpanelIds=this.getTabPanelIds(),this.activeTabIndex=this.getActiveIndex()}}Ms([Os],kf.prototype,"orientation",void 0),Ms([Os],kf.prototype,"activeid",void 0),Ms([ms],kf.prototype,"tabs",void 0),Ms([ms],kf.prototype,"tabpanels",void 0),Ms([Os({mode:"boolean"})],kf.prototype,"activeindicator",void 0),Ms([ms],kf.prototype,"activeIndicatorRef",void 0),Ms([ms],kf.prototype,"showActiveIndicator",void 0),cu(kf,nu);const Cf=kf.compose({baseName:"tabs",template:(e,t)=>Rr`
    <template class="${e=>e.orientation}">
        ${au(0,t)}
        <div class="tablist" part="tablist" role="tablist">
            <slot class="tab" name="tab" part="tab" ${Ru("tabs")}></slot>

            ${eu((e=>e.showActiveIndicator),Rr`
                    <div
                        ${su("activeIndicatorRef")}
                        class="activeIndicator"
                        part="activeIndicator"
                    ></div>
                `)}
        </div>
        ${ru(0,t)}
        <div class="tabpanel" part="tabpanel">
            <slot name="tabpanel" ${Ru("tabpanels")}></slot>
        </div>
    </template>
`,styles:(e,t)=>ih`
      ${nh("grid")} :host {
        box-sizing: border-box;
        ${Bu}
        color: ${xc};
        grid-template-columns: auto 1fr auto;
        grid-template-rows: auto 1fr;
      }

      .tablist {
        display: grid;
        grid-template-rows: calc(${Uu} * 1px); auto;
        grid-template-columns: auto;
        position: relative;
        width: max-content;
        align-self: end;
      }

      .start,
      .end {
        align-self: center;
      }

      .activeIndicator {
        grid-row: 2;
        grid-column: 1;
        width: 20px;
        height: 3px;
        border-radius: calc(${Ra} * 1px);
        justify-self: center;
        background: ${Dd};
      }

      .activeIndicatorTransition {
        transition: transform 0.2s ease-in-out;
      }

      .tabpanel {
        grid-row: 2;
        grid-column-start: 1;
        grid-column-end: 4;
        position: relative;
      }

      :host(.vertical) {
        grid-template-rows: auto 1fr auto;
        grid-template-columns: auto 1fr;
      }

      :host(.vertical) .tablist {
        grid-row-start: 2;
        grid-row-end: 2;
        display: grid;
        grid-template-rows: auto;
        grid-template-columns: auto 1fr;
        position: relative;
        width: max-content;
        justify-self: end;
        align-self: flex-start;
        width: 100%;
      }

      :host(.vertical) .tabpanel {
        grid-column: 2;
        grid-row-start: 1;
        grid-row-end: 4;
      }

      :host(.vertical) .end {
        grid-row: 3;
      }

      :host(.vertical) .activeIndicator {
        grid-column: 1;
        grid-row: 1;
        width: 3px;
        height: 20px;
        margin-inline-start: calc(${za} * 1px);
        border-radius: calc(${Ra} * 1px);
        align-self: center;
        background: ${Dd};
      }

      :host(.vertical) .activeIndicatorTransition {
        transition: transform 0.2s linear;
      }
    `.withBehaviors(lh(ih`
        .activeIndicator,
        :host(.vertical) .activeIndicator {
          background: ${dh.Highlight};
        }
      `))});class $f extends Ln{}Ms([Os({mode:"boolean"})],$f.prototype,"disabled",void 0);const Sf=$f.compose({baseName:"tab",template:(e,t)=>Rr`
    <template slot="tab" role="tab" aria-disabled="${e=>e.disabled}">
        <slot></slot>
    </template>
`,styles:(e,t)=>ih`
      ${nh("inline-flex")} :host {
        box-sizing: border-box;
        ${Bu}
        height: calc((${Uu} + (${Aa} * 2)) * 1px);
        padding: 0 calc((6 + (${Aa} * 2 * ${Fa})) * 1px);
        color: ${xc};
        border-radius: calc(${Ra} * 1px);
        border: calc(${Ma} * 1px) solid transparent;
        align-items: center;
        justify-content: center;
        grid-row: 1 / 3;
        cursor: pointer;
      }

      :host([aria-selected='true']) {
        z-index: 2;
      }

      :host(:hover),
      :host(:active) {
        color: ${xc};
      }

      :host(:${Nu}) {
        ${Hu}
      }

      :host(.vertical) {
        justify-content: start;
        grid-column: 1 / 3;
      }

      :host(.vertical[aria-selected='true']) {
        z-index: 2;
      }

      :host(.vertical:hover),
      :host(.vertical:active) {
        color: ${xc};
      }

      :host(.vertical:hover[aria-selected='true']) {
      }
    `.withBehaviors(lh(ih`
          :host {
            forced-color-adjust: none;
            border-color: transparent;
            color: ${dh.ButtonText};
            fill: currentcolor;
          }
          :host(:hover),
          :host(.vertical:hover),
          :host([aria-selected='true']:hover) {
            background: transparent;
            color: ${dh.Highlight};
            fill: currentcolor;
          }
          :host([aria-selected='true']) {
            background: transparent;
            color: ${dh.Highlight};
            fill: currentcolor;
          }
          :host(:${Nu}) {
            background: transparent;
            outline-color: ${dh.ButtonText};
          }
        `))}),_f=class extends Ln{}.compose({baseName:"tab-panel",template:(e,t)=>Rr`
    <template slot="tabpanel" role="tabpanel">
        <slot></slot>
    </template>
`,styles:(e,t)=>ih`
  ${nh("block")} :host {
    box-sizing: border-box;
    ${Bu}
    padding: 0 calc((6 + (${Aa} * 2 * ${Fa})) * 1px);
  }
`});var If,Tf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Df=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},Pf=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr($h,Cf,Sf,_f,Ju,Kg);let Lf=If=class extends Nt{static get styles(){return nf}get strings(){return wf}static get requiredScopes(){return If.getScopes()}static getScopes(){const e=[];return this.config.sections.files&&e.push("Sites.Read.All"),this.config.sections.mailMessages&&(e.push("Mail.Read"),e.push("Mail.ReadBasic")),this.config.sections.organization&&(e.push("User.Read.All"),"boolean"!=typeof this.config.sections.organization&&this.config.sections.organization.showWorksWith&&e.push("People.Read.All")),this.config.sections.profile&&e.push("User.Read.All"),this.config.useContactApis&&e.push("Contacts.Read"),e.indexOf("User.Read.All")<0&&(e.push("User.ReadBasic.All"),e.push("User.Read")),e.indexOf("People.Read.All")<0&&e.push("People.Read"),e.push("Chat.Create","Chat.ReadWrite"),[...new Set(e)]}static get config(){return this._config}get personDetails(){return this._personDetails}set personDetails(e){this._personDetails!==e&&(this._personDetails=e,this.personImage=this.getImage(),this.requestStateUpdate())}get userId(){return this._userId}set userId(e){e!==this._userId&&(this._userId=e,this.personDetails=null,this._cardState=null,this.requestStateUpdate())}get internalPersonDetails(){var e;return(null===(e=this._cardState)||void 0===e?void 0:e.person)||this.personDetails}constructor(){super(),this.isSending=!1,this.goBack=()=>{var e;if(!(null===(e=this._history)||void 0===e?void 0:e.length))return;const t=this._history.pop();this._currentSection=null;const i=this.renderRoot.querySelector("fluent-tab");i&&i.click(),this._cardState=t.state,this._personDetails=t.state.person,this.personImage=t.personImage,this.loadSections()},this.handleEndOfCard=e=>{if(e&&"Tab"===e.code){const e=this.renderRoot.querySelector("#end-of-container");if(e){e.blur();const t=this.renderRoot.querySelector("mgt-person");t&&t.focus()}}},this.closeCard=()=>{this.updateCurrentSection(null),this.isExpanded=!1},this.sendQuickMessage=()=>Pf(this,void 0,void 0,(function*(){const e=this._chatInput.trim();if(!(null==e?void 0:e.length))return;const t=this.personDetails,i=this._me.userPrincipalName;this.isSending=!0;const o=yield((e,t,i)=>of(void 0,void 0,void 0,(function*(){const o={chatType:"oneonOne",members:[{"@odata.type":"#microsoft.graph.aadUserConversationMember",roles:["owner"],"user@odata.bind":`https://graph.microsoft.com/v1.0/users('${i}')`},{"@odata.type":"#microsoft.graph.aadUserConversationMember",roles:["owner"],"user@odata.bind":`https://graph.microsoft.com/v1.0/users('${t}')`}]};return yield e.api("/chats").header("Cache-Control","no-store").middlewareOptions(ie("Chat.Create","Chat.ReadWrite")).post(o)})))(this._graph,t.userPrincipalName,i),s={body:{content:e}};yield((e,t,i)=>of(void 0,void 0,void 0,(function*(){return yield e.api(`/chats/${t}/messages`).header("Cache-Control","no-store").middlewareOptions(ie("Chat.ReadWrite","ChatMessage.Send")).post(i)})))(this._graph,o.id,s),this.isSending=!1,this.clearInputData()})),this.emailUser=()=>{const e=this.internalPersonDetails;if(e){const t=Qi(e);t&&window.open("mailto:"+t,"_blank","noreferrer")}},this.callUser=()=>{var e,t;const i=this.personDetails,o=this.personDetails;if(null===(e=null==i?void 0:i.businessPhones)||void 0===e?void 0:e.length){const e=i.businessPhones[0];e&&window.open("tel:"+e,"_blank","noreferrer")}else if(null===(t=null==o?void 0:o.phones)||void 0===t?void 0:t.length){const e=this.getPersonBusinessPhones(o)[0];e&&window.open("tel:"+e,"_blank","noreferrer")}},this.chatUser=(e=null)=>{const t=this.personDetails;if(null==t?void 0:t.userPrincipalName){let i=`https://teams.microsoft.com/l/chat/0/0?users=${t.userPrincipalName}`;(null==e?void 0:e.length)&&(i+=`&message=${e}`);const o=()=>window.open(i,"_blank","noreferrer");li.isAvailable?li.executeDeepLink(i,(e=>{e||o()})):o()}},this.videoCallUser=()=>{const e=this.personDetails;if(null==e?void 0:e.userPrincipalName){const t=`https://teams.microsoft.com/l/call/0/0?users=${e.userPrincipalName}&withVideo=true`,i=()=>window.open(t,"_blank");li.isAvailable?li.executeDeepLink(t,(e=>{e||i()})):i()}},this.showExpandedDetails=()=>{const e=this.renderRoot.querySelector(".root");(null==e?void 0:e.animate)&&e.animate([{height:"auto",transformOrigin:"top left"},{height:"auto",transformOrigin:"top left"}],{duration:1e3,easing:"ease-in-out",fill:"both"}),this.isExpanded=!0,this.fireCustomEvent("expanded",null,!0)},this.sendQuickMessageOnEnter=e=>{"Enter"===e.code&&this.sendQuickMessage()},this.handleGoBack=e=>{"Enter"===e.code&&this.goBack()},this._chatInput="",this._currentSection=null,this._history=[],this.sections=[],this._graph=null}attributeChangedCallback(e,t,i){super.attributeChangedCallback(e,t,i),t!==i&&"person-query"===e&&(this.personDetails=null,this._cardState=null,this.requestStateUpdate())}navigate(e){this._history.push({personDetails:this.personDetails,personImage:this.getImage(),state:this._cardState}),this._personDetails=e,this._cardState=null,this.personImage=null,this._currentSection=null,this.sections=[],this._chatInput="",this.requestStateUpdate()}clearHistory(){var e;if(this._currentSection=null,!(null===(e=this._history)||void 0===e?void 0:e.length))return;const t=this._history[0];this._history=[],this._cardState=t.state,this._personDetails=t.personDetails,this.personImage=t.personImage,this.loadSections()}render(){var e;if(!this.internalPersonDetails)return this.renderNoData();const t=this.internalPersonDetails,i=this.getImage();if(this.hasTemplate("default"))return this.renderTemplate("default",{person:this.internalPersonDetails,personImage:i});let o;o=this.strings.closeCardLabel;const s=this.isExpanded?Je`
           <div class="close-card-container">
             <fluent-button 
              appearance="lightweight" 
              class="close-button" 
              aria-label=${o}
              @click=${this.closeCard} >
               ${Co(ko.Close)}
             </fluent-button>
           </div>
         `:null;o=this.strings.goBackLabel;const n=(null===(e=this._history)||void 0===e?void 0:e.length)?Je`
            <div class="nav">
              <fluent-button 
                appearance="lightweight"
                class="nav__back" 
                aria-label=${o} 
                @keydown=${this.handleGoBack}
                @click=${this.goBack}>${Co(ko.Back)}
               </fluent-button>
            </div>
          `:null;let r=this.renderTemplate("person-details",{person:this.internalPersonDetails,personImage:i});if(!r){const e=this.renderPerson(),i=this.renderContactIcons(t);r=Je`
         ${e} ${i}
       `}const a=this.isExpanded?this.renderExpandedDetails():this.renderExpandedDetailsButton();this._windowHeight=window.innerHeight&&document.documentElement.clientHeight?Math.min(window.innerHeight,document.documentElement.clientHeight):window.innerHeight||document.documentElement.clientHeight,this._windowHeight<250&&(this._smallView=!0);const l=this.lockTabNavigation?Je`<div @keydown=${this.handleEndOfCard} aria-label=${this.strings.endOfCard} tabindex="0" id="end-of-container"></div>`:Je``;return Je`
      <div class="root" dir=${this.direction}>
        <div class=${ki({small:this._smallView})}>
          ${n}
          ${s}
          <div class="person-details-container">${r}</div>
          <div class="expanded-details-container">${a}</div>
          ${l}
        </div>
      </div>
     `}renderNoData(){return this.renderTemplate("no-data",null)||Je``}renderPerson(){return pi`
      <mgt-person
        tabindex="0"
        class="person-image"
        .personDetails=${this.internalPersonDetails}
        .personImage=${this.getImage()}
        .personPresence=${this.personPresence}
        .showPresence=${this.showPresence}
        .view=${xo.threelines}
      ></mgt-person>
    `}renderPersonSubtitle(e){if(e=e||this.internalPersonDetails,Fo(e)&&e.department)return Je`
       <div class="department">${e.department}</div>
     `}renderContactIcons(e){const t=e=e||this.internalPersonDetails;let i,o,s;Qi(e)&&(i=`${this.strings.emailButtonLabel} ${e.displayName}`,o=Je`
        <fluent-button class="icon"
          aria-label=${i}
          @click=${this.emailUser}>
          ${Co(ko.SmallEmail)}
        </fluent-button>
      `),(null==t?void 0:t.userPrincipalName)&&(i=`${this.strings.chatButtonLabel} ${e.displayName}`,s=Je`
        <fluent-button class="icon"
          aria-label=${i}
          @click=${this.chatUser}>
          ${Co(ko.SmallChat)}
        </fluent-button>
       `),i=`${this.strings.videoButtonLabel} ${e.displayName}`;const n=Je`
      <fluent-button class="icon"
        aria-label=${i}
        @click=${this.videoCallUser}>
        ${Co(ko.Video)}
      </fluent-button>
    `;let r;return t.userPrincipalName&&(i=`${this.strings.callButtonLabel} ${e.displayName}`,r=Je`
         <fluent-button class="icon"
          aria-label=${i}
          @click=${this.callUser}>
          ${Co(ko.Call)}
        </fluent-button>
       `),Je`
       <div class="base-icons">
         ${o} ${s} ${n} ${r}
       </div>
     `}renderExpandedDetailsButton(){return Je`
      <fluent-button
        aria-label=${this.strings.expandDetailsLabel}
        class="expanded-details-button"
        @click=${this.showExpandedDetails}
      >
        ${Co(ko.ExpandDown)}
      </fluent-button>
     `}renderExpandedDetails(){if(!this._cardState&&this._isStateLoading)return pi`
         <div class="loading">
           <mgt-spinner></mgt-spinner>
         </div>
       `;te.globalProvider.state===Q.SignedOut&&this.loadSections();const e=this.renderSectionNavigation();return Je`
      <div class="section-nav">
        ${e}
      </div>
      <hr class="divider"/>
      <div
        class="section-host ${this._smallView?"small":""} ${this._smallView?"small":""}"
        @wheel=${e=>this.handleSectionScroll(e)}
        tabindex=0
      ></div>
    `}renderSectionNavigation(){if(!this.sections||this.sections.length<2&&!this.hasTemplate("additional-details"))return;const e=this._currentSection?this.sections.indexOf(this._currentSection):-1,t=this.sections.map(((t,i)=>{const o=t.tagName.toLowerCase(),s=ki({active:i===e,"section-nav__icon":!0});return Je`
        <fluent-tab
          id="${o}-Tab"
          class=${s}
          slot="tab"
          @keyup="${()=>this.updateCurrentSection(t)}"
          @click=${()=>this.updateCurrentSection(t)}
        >
          ${t.renderIcon()}
        </fluent-tab>
      `})),i=this.sections.map((e=>Je`
        <fluent-tab-panel slot="tabpanel">
          <div class="inserted">
            <div class="title">${e.cardTitle}</div>
            ${this._currentSection?e.asFullView():null}
          </div>
        </fluent-tab-panel>
      `)),o=ki({active:-1===e,"section-nav__icon":!0,overviewTab:!0});return Je`
      <fluent-tabs
        orientation="horizontal"
        activeindicator
        @wheel=${e=>this.handleSectionScroll(e)}
      >
        <fluent-tab
          class="${o}"
          slot="tab"
          @keyup="${()=>this.updateCurrentSection(null)}"
          @click=${()=>this.updateCurrentSection(null)}
        >
          <div>${Co(ko.Overview)}</div>
        </fluent-tab>
        ${t}
        <fluent-tab-panel slot="tabpanel" >
          <div class="overview-panel">${this._currentSection?null:this.renderOverviewSection()}</div>
        </fluent-tab-panel>
        ${i}
      </fluent-tabs>
    `}renderOverviewSection(){const e=this.sections.map((e=>Je`
        <div class="section">
          <div class="section__header">
            <div class="section__title" tabindex=0>${e.displayName}</div>
              <fluent-button
                appearance="lightweight"
                class="section__show-more"
                @click=${()=>this.updateCurrentSection(e)}
              >
                ${this.strings.showMoreSectionButton}
              </fluent-button>
          </div>
          <div class="section__content">${e.asCompactView()}</div>
        </div>
      `)),t=this.renderTemplate("additional-details",{person:this.internalPersonDetails,personImage:this.getImage(),state:this._cardState});return t&&e.splice(1,0,Je`
           <div class="section">
             <div class="additional-details">${t}</div>
           </div>
         `),Je`
       <div class="sections">
          ${this.renderMessagingSection()}
          ${e}
       </div>
     `}renderCurrentSection(){var e;if((null===(e=this.sections)||void 0===e?void 0:e.length)||this.hasTemplate("additional-details"))return 1!==this.sections.length||this.hasTemplate("additional-details")?this._currentSection?Je`
       ${this._currentSection.asFullView()}
     `:this.renderOverviewSection():Je`
         ${this.sections[0].asFullView()}
       `}renderMessagingSection(){const e=this.personDetails,t=this._me.userPrincipalName,i=this._chatInput;return(null==e?void 0:e.userPrincipalName)===t?void 0:Je`
      <div class="message-section">
        <fluent-text-field
          autocomplete="off"
          appearance="outline"
          placeholder="${this.strings.quickMessage}"
          .value=${i}
          @input=${e=>{this._chatInput=e.target.value,this.requestUpdate()}}
          @keydown="${e=>this.sendQuickMessageOnEnter(e)}">
        </fluent-text-field>
        <fluent-button class="send-message-icon"
          aria-label=${this.strings.sendMessageLabel}
          @click=${this.sendQuickMessage}
          ?disabled=${this.isSending}>
          ${this.isSending?Co(ko.Confirmation):Co(ko.Send)}
        </fluent-button>
      </div>
      `}loadState(){var e,t;return Pf(this,void 0,void 0,(function*(){if(this._cardState)return;if(!this.personDetails&&this.inheritDetails){let e=this.parentElement;for(;e&&e.tagName!==`${ce.prefix}-PERSON`.toUpperCase();)e=e.parentElement;const t=e.personDetails||e.personDetailsInternal;e&&t&&(this.personDetails=t,this.personImage=e.personImage)}const i=te.globalProvider;if(!i||i.state!==Q.SignedIn)return;const o=i.graph.forComponent(this);if(this._graph=o,this._isStateLoading=!0,this._me||(this._me=yield te.me()),this.personDetails){const e=this.personDetails;let t;if(Fo(e)&&(t=e.userPrincipalName||e.id),t&&!Qi(e)){const e=yield wo(o,t);this.personDetails=e,this.personImage=this.getImage()}}else if(this.userId||"me"===this.personQuery){const e=yield wo(o,this.userId);this.personDetails=e,this.personImage=this.getImage()}else if(this.personQuery){const e=yield Wi(o,this.personQuery,1);(null==e?void 0:e.length)&&(this.personDetails=e[0],yield po(o,this.personDetails,If.config.useContactApis).then((e=>{e&&(this.personDetails.personImage=e,this.personImage=e)})))}const s={activity:"Offline",availability:"Offline",id:null};if(!this.personPresence&&this.showPresence)try{(null===(e=this.personDetails)||void 0===e?void 0:e.id)?this.personPresence=yield bo(o,this.personDetails.id):this.personPresence=s}catch(e){this.personPresence=s}(null===(t=this.personDetails)||void 0===t?void 0:t.id)&&(this._cardState=yield((e,t,i,o)=>of(void 0,void 0,void 0,(function*(){var s;const n=t.id,r=Qi(t),a="classification"in t||"personType"in t&&("PersonalContact"===t.personType.subclass||"Group"===t.personType.class),l=e.createBatch();let d;a||o.sections.organization&&(((e,t)=>{const i=`manager($levels=max;$select=${sf})`;e.get("person",`users/${t}?$expand=${i}&$select=${sf}&$count=true`,["user.read.all"],{ConsistencyLevel:"eventual"}),e.get("directReports",`users/${t}/directReports?$select=${sf}`)})(l,n),"boolean"!=typeof o.sections.organization&&o.sections.organization.showWorksWith&&((e,t)=>{e.get("people",`users/${t}/people?$filter=personType/class eq 'Person'`,["People.Read.All"])})(l,n)),o.sections.mailMessages&&r&&((e,t)=>{e.get("messages",`me/messages?$search="from:${t}"`,["Mail.ReadBasic"])})(l,r),o.sections.files&&((e,t)=>{let i;i=t?`me/insights/shared?$filter=lastshared/sharedby/address eq '${t}'`:"me/insights/used",e.get("files",i,["Sites.Read.All"])})(l,i?null:r);const c={};try{d=yield l.executeAll()}catch(e){}if(d)for(const[e,t]of d)c[e]=(null===(s=t.content)||void 0===s?void 0:s.value)||t.content;if(!a&&o.sections.profile)try{const t=yield((e,t)=>of(void 0,void 0,void 0,(function*(){return yield e.api(`/users/${t}/profile`).version("beta").get()})))(e,n);t&&(c.profile=t)}catch(e){}return c.directReports&&c.directReports.length>0&&(c.directReports=c.directReports.filter((e=>e.accountEnabled))),c})))(o,this.personDetails,this._me===this.personDetails.id,If.config)),this.loadSections(),this._isStateLoading=!1}))}get hasPhone(){var e,t;const i=this.personDetails,o=this.personDetails;return Boolean(null===(e=null==i?void 0:i.businessPhones)||void 0===e?void 0:e.length)||Boolean(null===(t=null==o?void 0:o.phones)||void 0===t?void 0:t.length)}loadSections(){if(this.sections=[],!this.internalPersonDetails)return;const e=new cf(this.internalPersonDetails);if(e.hasData&&this.sections.push(e),!this._cardState)return;const{person:t,directReports:i,messages:o,files:s,profile:n}=this._cardState;if(If.config.sections.organization&&((null==t?void 0:t.manager)||(null==i?void 0:i.length))&&this.sections.push(new vf(this._cardState,this._me)),If.config.sections.mailMessages&&(null==o?void 0:o.length)&&this.sections.push(new pf(o)),If.config.sections.files&&(null==s?void 0:s.length)&&this.sections.push(new Ip),If.config.sections.profile&&n){const e=new yf(n);e.hasData&&this.sections.push(e)}}getImage(){if(this.personImage)return this.personImage;const e=this.personDetails;return(null==e?void 0:e.personImage)?e.personImage:null}clearInputData(){this._chatInput="",this.requestUpdate()}getPersonBusinessPhones(e){const t=e.phones,i=[];for(const e of t)"business"===e.type&&i.push(e.number);return i}updateCurrentSection(e){if(e){const t=e.tagName.toLowerCase();this.renderRoot.querySelector(`#${t}-Tab`).click()}const t=this.renderRoot.querySelectorAll("fluent-tab-panel");for(const e of t)e.scrollTop=0;this._currentSection=e,this.requestUpdate()}handleSectionScroll(e){const t=this.renderRoot.querySelectorAll("fluent-tab-panel");for(const i of t)i&&(e.deltaY<0&&0===i.scrollTop||e.deltaY>0&&i.clientHeight+i.scrollTop>=i.scrollHeight-1||e.stopPropagation())}};Lf._config={sections:{files:!0,mailMessages:!0,organization:{showWorksWith:!0},profile:!0},useContactApis:!0,isSendMessageVisible:!0},Tf([Ct({attribute:"person-details",type:Object}),Df("design:type",Object),Df("design:paramtypes",[Object])],Lf.prototype,"personDetails",null),Tf([Ct({attribute:"person-query"}),Df("design:type",String)],Lf.prototype,"personQuery",void 0),Tf([Ct({attribute:"lock-tab-navigation",type:Boolean}),Df("design:type",Boolean)],Lf.prototype,"lockTabNavigation",void 0),Tf([Ct({attribute:"user-id"}),Df("design:type",String),Df("design:paramtypes",[String])],Lf.prototype,"userId",null),Tf([Ct({attribute:"person-image",type:String}),Df("design:type",String)],Lf.prototype,"personImage",void 0),Tf([Ct({attribute:"fetch-image",type:Boolean}),Df("design:type",Boolean)],Lf.prototype,"fetchImage",void 0),Tf([Ct({attribute:"is-expanded",type:Boolean}),Df("design:type",Boolean)],Lf.prototype,"isExpanded",void 0),Tf([Ct({attribute:"inherit-details",type:Boolean}),Df("design:type",Boolean)],Lf.prototype,"inheritDetails",void 0),Tf([Ct({attribute:"show-presence",type:Boolean}),Df("design:type",Boolean)],Lf.prototype,"showPresence",void 0),Tf([Ct({attribute:"person-presence",type:Object}),Df("design:type",Object)],Lf.prototype,"personPresence",void 0),Tf([$t(),Df("design:type",Object)],Lf.prototype,"isSending",void 0),Tf([$t(),Df("design:type",Object)],Lf.prototype,"_cardState",void 0),Tf([$t(),Df("design:type",Boolean)],Lf.prototype,"_isStateLoading",void 0),Lf=If=Tf([gi("person-card"),Df("design:paramtypes",[])],Lf);const Ef=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{position:relative}:host .header::part(control){font-size:var(--arrow-options-button-font-size,large);font-weight:var(--arrow-options-button-font-weight,600);color:var(--arrow-options-button-font-color,var(--accent-base-color));background:var(--arrow-options-button-background-color,transparent)}:host .header::part(control):hover{background:var(--neutral-fill-stealth-hover)}:host .header::part(control):active,:host .header::part(control):focus{background:var(--neutral-fill-stealth-active)}:host .menu{position:absolute;left:var(--arrow-options-left,0);z-index:1;display:none}:host .menu.open{display:block;width:max-content}
`],Of="menuitem",Ff="menuitemcheckbox",Af="menuitemradio",Rf={[Of]:"menuitem",[Ff]:"menuitemcheckbox",[Af]:"menuitemradio"},Vf=e=>{const t=e.closest("[dir]");return null!==t&&"rtl"===t.dir?qr.rtl:qr.ltr};class Mf extends Ln{constructor(){super(...arguments),this.role=Of,this.hasSubmenu=!1,this.currentDirection=qr.ltr,this.focusSubmenuOnLoad=!1,this.handleMenuItemKeyDown=e=>{if(e.defaultPrevented)return!1;switch(e.key){case vu:case wu:return this.invoke(),!1;case gu:return this.expandAndFocus(),!1;case pu:if(this.expanded)return this.expanded=!1,this.focus(),!1}return!0},this.handleMenuItemClick=e=>(e.defaultPrevented||this.disabled||this.invoke(),!1),this.submenuLoaded=()=>{this.focusSubmenuOnLoad&&(this.focusSubmenuOnLoad=!1,this.hasSubmenu&&(this.submenu.focus(),this.setAttribute("tabindex","-1")))},this.handleMouseOver=e=>(this.disabled||!this.hasSubmenu||this.expanded||(this.expanded=!0),!1),this.handleMouseOut=e=>(!this.expanded||this.contains(document.activeElement)||(this.expanded=!1),!1),this.expandAndFocus=()=>{this.hasSubmenu&&(this.focusSubmenuOnLoad=!0,this.expanded=!0)},this.invoke=()=>{if(!this.disabled)switch(this.role){case Ff:this.checked=!this.checked;break;case Of:this.updateSubmenu(),this.hasSubmenu?this.expandAndFocus():this.$emit("change");break;case Af:this.checked||(this.checked=!0)}},this.updateSubmenu=()=>{this.submenu=this.domChildren().find((e=>"menu"===e.getAttribute("role"))),this.hasSubmenu=void 0!==this.submenu}}expandedChanged(e){if(this.$fastController.isConnected){if(void 0===this.submenu)return;!1===this.expanded?this.submenu.collapseExpandedItem():this.currentDirection=Vf(this),this.$emit("expanded-change",this,{bubbles:!1})}}checkedChanged(e,t){this.$fastController.isConnected&&this.$emit("change")}connectedCallback(){super.connectedCallback(),ps.queueUpdate((()=>{this.updateSubmenu()})),this.startColumnCount||(this.startColumnCount=1),this.observer=new MutationObserver(this.updateSubmenu)}disconnectedCallback(){super.disconnectedCallback(),this.submenu=void 0,void 0!==this.observer&&(this.observer.disconnect(),this.observer=void 0)}domChildren(){return Array.from(this.children).filter((e=>!e.hasAttribute("hidden")))}}Ms([Os({mode:"boolean"})],Mf.prototype,"disabled",void 0),Ms([Os({mode:"boolean"})],Mf.prototype,"expanded",void 0),Ms([ms],Mf.prototype,"startColumnCount",void 0),Ms([Os],Mf.prototype,"role",void 0),Ms([Os({mode:"boolean"})],Mf.prototype,"checked",void 0),Ms([ms],Mf.prototype,"submenuRegion",void 0),Ms([ms],Mf.prototype,"hasSubmenu",void 0),Ms([ms],Mf.prototype,"currentDirection",void 0),Ms([ms],Mf.prototype,"submenu",void 0),cu(Mf,nu);class zf extends Ln{constructor(){super(...arguments),this.expandedItem=null,this.focusIndex=-1,this.isNestedMenu=()=>null!==this.parentElement&&Mu(this.parentElement)&&"menuitem"===this.parentElement.getAttribute("role"),this.handleFocusOut=e=>{if(!this.contains(e.relatedTarget)&&void 0!==this.menuItems){this.collapseExpandedItem();const e=this.menuItems.findIndex(this.isFocusableElement);this.menuItems[this.focusIndex].setAttribute("tabindex","-1"),this.menuItems[e].setAttribute("tabindex","0"),this.focusIndex=e}},this.handleItemFocus=e=>{const t=e.target;void 0!==this.menuItems&&t!==this.menuItems[this.focusIndex]&&(this.menuItems[this.focusIndex].setAttribute("tabindex","-1"),this.focusIndex=this.menuItems.indexOf(t),t.setAttribute("tabindex","0"))},this.handleExpandedChanged=e=>{if(e.defaultPrevented||null===e.target||void 0===this.menuItems||this.menuItems.indexOf(e.target)<0)return;e.preventDefault();const t=e.target;null===this.expandedItem||t!==this.expandedItem||!1!==t.expanded?t.expanded&&(null!==this.expandedItem&&this.expandedItem!==t&&(this.expandedItem.expanded=!1),this.menuItems[this.focusIndex].setAttribute("tabindex","-1"),this.expandedItem=t,this.focusIndex=this.menuItems.indexOf(t),t.setAttribute("tabindex","0")):this.expandedItem=null},this.removeItemListeners=()=>{void 0!==this.menuItems&&this.menuItems.forEach((e=>{e.removeEventListener("expanded-change",this.handleExpandedChanged),e.removeEventListener("focus",this.handleItemFocus)}))},this.setItems=()=>{const e=this.domChildren();this.removeItemListeners(),this.menuItems=e;const t=this.menuItems.filter(this.isMenuItemElement);t.length&&(this.focusIndex=0);const i=t.reduce(((e,t)=>{const i=function(e){const t=e.getAttribute("role"),i=e.querySelector("[slot=start]");return t!==Of&&null===i||t===Of&&null!==i?1:t!==Of&&null!==i?2:0}(t);return e>i?e:i}),0);t.forEach(((e,t)=>{e.setAttribute("tabindex",0===t?"0":"-1"),e.addEventListener("expanded-change",this.handleExpandedChanged),e.addEventListener("focus",this.handleItemFocus),e instanceof Mf&&(e.startColumnCount=i)}))},this.changeHandler=e=>{if(void 0===this.menuItems)return;const t=e.target,i=this.menuItems.indexOf(t);if(-1!==i&&"menuitemradio"===t.role&&!0===t.checked){for(let e=i-1;e>=0;--e){const t=this.menuItems[e],i=t.getAttribute("role");if(i===Af&&(t.checked=!1),"separator"===i)break}const e=this.menuItems.length-1;for(let t=i+1;t<=e;++t){const e=this.menuItems[t],i=e.getAttribute("role");if(i===Af&&(e.checked=!1),"separator"===i)break}}},this.isMenuItemElement=e=>Mu(e)&&zf.focusableElementRoles.hasOwnProperty(e.getAttribute("role")),this.isFocusableElement=e=>this.isMenuItemElement(e)}itemsChanged(e,t){this.$fastController.isConnected&&void 0!==this.menuItems&&this.setItems()}connectedCallback(){super.connectedCallback(),ps.queueUpdate((()=>{this.setItems()})),this.addEventListener("change",this.changeHandler)}disconnectedCallback(){super.disconnectedCallback(),this.removeItemListeners(),this.menuItems=void 0,this.removeEventListener("change",this.changeHandler)}focus(){this.setFocus(0,1)}collapseExpandedItem(){null!==this.expandedItem&&(this.expandedItem.expanded=!1,this.expandedItem=null)}handleMenuKeyDown(e){if(!e.defaultPrevented&&void 0!==this.menuItems)switch(e.key){case uu:return void this.setFocus(this.focusIndex+1,1);case fu:return void this.setFocus(this.focusIndex-1,-1);case yu:return void this.setFocus(this.menuItems.length-1,-1);case bu:return void this.setFocus(0,1);default:return!0}}domChildren(){return Array.from(this.children).filter((e=>!e.hasAttribute("hidden")))}setFocus(e,t){if(void 0!==this.menuItems)for(;e>=0&&e<this.menuItems.length;){const i=this.menuItems[e];if(this.isFocusableElement(i)){this.focusIndex>-1&&this.menuItems.length>=this.focusIndex-1&&this.menuItems[this.focusIndex].setAttribute("tabindex","-1"),this.focusIndex=e,i.setAttribute("tabindex","0"),i.focus();break}e+=t}}}zf.focusableElementRoles=Rf,Ms([ms],zf.prototype,"items",void 0);const Nf="horizontal";class Uf extends Ln{constructor(){super(...arguments),this.role="separator",this.orientation=Nf}}Ms([Os],Uf.prototype,"role",void 0),Ms([Os],Uf.prototype,"orientation",void 0);const Bf=class extends zf{connectedCallback(){super.connectedCallback(),_d.setValueFor(this,wd)}}.compose({baseName:"menu",baseClass:zf,template:(e,t)=>Rr`
    <template
        slot="${e=>e.slot?e.slot:e.isNestedMenu()?"submenu":void 0}"
        role="menu"
        @keydown="${(e,t)=>e.handleMenuKeyDown(t.event)}"
        @focusout="${(e,t)=>e.handleFocusOut(t.event)}"
    >
        <slot ${Ru("items")}></slot>
    </template>
`,styles:(e,t)=>ih`
    ${nh("block")} :host {
      background: ${wd};
      border: calc(${Ma} * 1px) solid transparent;
      border-radius: calc(${Va} * 1px);
      box-shadow: ${wh};
      padding: calc((${Aa} - ${Ma}) * 1px) 0;
      max-width: 368px;
      min-width: 64px;
    }

    :host([slot='submenu']) {
      width: max-content;
      margin: 0 calc(${Aa} * 2px);
    }

    ::slotted(${e.tagFor(Mf)}) {
      margin: 0 calc(${Aa} * 1px);
    }

    ::slotted(${e.tagFor(Uf)}) {
      margin: calc(${Aa} * 1px) 0;
    }

    ::slotted(hr) {
      box-sizing: content-box;
      height: 0;
      margin: calc(${Aa} * 1px) 0;
      border: none;
      border-top: calc(${Ma} * 1px) solid ${Ac};
    }
  `.withBehaviors(lh(ih`
        :host([slot='submenu']) {
          background: ${dh.Canvas};
          border-color: ${dh.CanvasText};
        }
      `))}),Hf="focus",jf="focusin",qf="focusout",Zf="keydown",Wf="resize",Gf="scroll";class Qf extends Ln{constructor(){super(...arguments),this.anchor="",this.viewport="",this.horizontalPositioningMode="uncontrolled",this.horizontalDefaultPosition="unset",this.horizontalViewportLock=!1,this.horizontalInset=!1,this.horizontalScaling="content",this.verticalPositioningMode="uncontrolled",this.verticalDefaultPosition="unset",this.verticalViewportLock=!1,this.verticalInset=!1,this.verticalScaling="content",this.fixedPlacement=!1,this.autoUpdateMode="anchor",this.anchorElement=null,this.viewportElement=null,this.initialLayoutComplete=!1,this.resizeDetector=null,this.baseHorizontalOffset=0,this.baseVerticalOffset=0,this.pendingPositioningUpdate=!1,this.pendingReset=!1,this.currentDirection=qr.ltr,this.regionVisible=!1,this.forceUpdate=!1,this.updateThreshold=.5,this.update=()=>{this.pendingPositioningUpdate||this.requestPositionUpdates()},this.startObservers=()=>{this.stopObservers(),null!==this.anchorElement&&(this.requestPositionUpdates(),null!==this.resizeDetector&&(this.resizeDetector.observe(this.anchorElement),this.resizeDetector.observe(this)))},this.requestPositionUpdates=()=>{null===this.anchorElement||this.pendingPositioningUpdate||(Qf.intersectionService.requestPosition(this,this.handleIntersection),Qf.intersectionService.requestPosition(this.anchorElement,this.handleIntersection),null!==this.viewportElement&&Qf.intersectionService.requestPosition(this.viewportElement,this.handleIntersection),this.pendingPositioningUpdate=!0)},this.stopObservers=()=>{this.pendingPositioningUpdate&&(this.pendingPositioningUpdate=!1,Qf.intersectionService.cancelRequestPosition(this,this.handleIntersection),null!==this.anchorElement&&Qf.intersectionService.cancelRequestPosition(this.anchorElement,this.handleIntersection),null!==this.viewportElement&&Qf.intersectionService.cancelRequestPosition(this.viewportElement,this.handleIntersection)),null!==this.resizeDetector&&this.resizeDetector.disconnect()},this.getViewport=()=>"string"!=typeof this.viewport||""===this.viewport?document.documentElement:document.getElementById(this.viewport),this.getAnchor=()=>document.getElementById(this.anchor),this.handleIntersection=e=>{this.pendingPositioningUpdate&&(this.pendingPositioningUpdate=!1,this.applyIntersectionEntries(e)&&this.updateLayout())},this.applyIntersectionEntries=e=>{const t=e.find((e=>e.target===this)),i=e.find((e=>e.target===this.anchorElement)),o=e.find((e=>e.target===this.viewportElement));return void 0!==t&&void 0!==o&&void 0!==i&&!!(!this.regionVisible||this.forceUpdate||void 0===this.regionRect||void 0===this.anchorRect||void 0===this.viewportRect||this.isRectDifferent(this.anchorRect,i.boundingClientRect)||this.isRectDifferent(this.viewportRect,o.boundingClientRect)||this.isRectDifferent(this.regionRect,t.boundingClientRect))&&(this.regionRect=t.boundingClientRect,this.anchorRect=i.boundingClientRect,this.viewportElement===document.documentElement?this.viewportRect=new DOMRectReadOnly(o.boundingClientRect.x+document.documentElement.scrollLeft,o.boundingClientRect.y+document.documentElement.scrollTop,o.boundingClientRect.width,o.boundingClientRect.height):this.viewportRect=o.boundingClientRect,this.updateRegionOffset(),this.forceUpdate=!1,!0)},this.updateRegionOffset=()=>{this.anchorRect&&this.regionRect&&(this.baseHorizontalOffset=this.baseHorizontalOffset+(this.anchorRect.left-this.regionRect.left)+(this.translateX-this.baseHorizontalOffset),this.baseVerticalOffset=this.baseVerticalOffset+(this.anchorRect.top-this.regionRect.top)+(this.translateY-this.baseVerticalOffset))},this.isRectDifferent=(e,t)=>Math.abs(e.top-t.top)>this.updateThreshold||Math.abs(e.right-t.right)>this.updateThreshold||Math.abs(e.bottom-t.bottom)>this.updateThreshold||Math.abs(e.left-t.left)>this.updateThreshold,this.handleResize=e=>{this.update()},this.reset=()=>{this.pendingReset&&(this.pendingReset=!1,null===this.anchorElement&&(this.anchorElement=this.getAnchor()),null===this.viewportElement&&(this.viewportElement=this.getViewport()),this.currentDirection=Vf(this),this.startObservers())},this.updateLayout=()=>{let e,t;if("uncontrolled"!==this.horizontalPositioningMode){const e=this.getPositioningOptions(this.horizontalInset);if("center"===this.horizontalDefaultPosition)t="center";else if("unset"!==this.horizontalDefaultPosition){let e=this.horizontalDefaultPosition;if("start"===e||"end"===e){const t=Vf(this);if(t!==this.currentDirection)return this.currentDirection=t,void this.initialize();e=this.currentDirection===qr.ltr?"start"===e?"left":"right":"start"===e?"right":"left"}switch(e){case"left":t=this.horizontalInset?"insetStart":"start";break;case"right":t=this.horizontalInset?"insetEnd":"end"}}const i=void 0!==this.horizontalThreshold?this.horizontalThreshold:void 0!==this.regionRect?this.regionRect.width:0,o=void 0!==this.anchorRect?this.anchorRect.left:0,s=void 0!==this.anchorRect?this.anchorRect.right:0,n=void 0!==this.anchorRect?this.anchorRect.width:0,r=void 0!==this.viewportRect?this.viewportRect.left:0,a=void 0!==this.viewportRect?this.viewportRect.right:0;(void 0===t||"locktodefault"!==this.horizontalPositioningMode&&this.getAvailableSpace(t,o,s,n,r,a)<i)&&(t=this.getAvailableSpace(e[0],o,s,n,r,a)>this.getAvailableSpace(e[1],o,s,n,r,a)?e[0]:e[1])}if("uncontrolled"!==this.verticalPositioningMode){const t=this.getPositioningOptions(this.verticalInset);if("center"===this.verticalDefaultPosition)e="center";else if("unset"!==this.verticalDefaultPosition)switch(this.verticalDefaultPosition){case"top":e=this.verticalInset?"insetStart":"start";break;case"bottom":e=this.verticalInset?"insetEnd":"end"}const i=void 0!==this.verticalThreshold?this.verticalThreshold:void 0!==this.regionRect?this.regionRect.height:0,o=void 0!==this.anchorRect?this.anchorRect.top:0,s=void 0!==this.anchorRect?this.anchorRect.bottom:0,n=void 0!==this.anchorRect?this.anchorRect.height:0,r=void 0!==this.viewportRect?this.viewportRect.top:0,a=void 0!==this.viewportRect?this.viewportRect.bottom:0;(void 0===e||"locktodefault"!==this.verticalPositioningMode&&this.getAvailableSpace(e,o,s,n,r,a)<i)&&(e=this.getAvailableSpace(t[0],o,s,n,r,a)>this.getAvailableSpace(t[1],o,s,n,r,a)?t[0]:t[1])}const i=this.getNextRegionDimension(t,e),o=this.horizontalPosition!==t||this.verticalPosition!==e;if(this.setHorizontalPosition(t,i),this.setVerticalPosition(e,i),this.updateRegionStyle(),!this.initialLayoutComplete)return this.initialLayoutComplete=!0,void this.requestPositionUpdates();this.regionVisible||(this.regionVisible=!0,this.style.removeProperty("pointer-events"),this.style.removeProperty("opacity"),this.classList.toggle("loaded",!0),this.$emit("loaded",this,{bubbles:!1})),this.updatePositionClasses(),o&&this.$emit("positionchange",this,{bubbles:!1})},this.updateRegionStyle=()=>{this.style.width=this.regionWidth,this.style.height=this.regionHeight,this.style.transform=`translate(${this.translateX}px, ${this.translateY}px)`},this.updatePositionClasses=()=>{this.classList.toggle("top","start"===this.verticalPosition),this.classList.toggle("bottom","end"===this.verticalPosition),this.classList.toggle("inset-top","insetStart"===this.verticalPosition),this.classList.toggle("inset-bottom","insetEnd"===this.verticalPosition),this.classList.toggle("vertical-center","center"===this.verticalPosition),this.classList.toggle("left","start"===this.horizontalPosition),this.classList.toggle("right","end"===this.horizontalPosition),this.classList.toggle("inset-left","insetStart"===this.horizontalPosition),this.classList.toggle("inset-right","insetEnd"===this.horizontalPosition),this.classList.toggle("horizontal-center","center"===this.horizontalPosition)},this.setHorizontalPosition=(e,t)=>{if(void 0===e||void 0===this.regionRect||void 0===this.anchorRect||void 0===this.viewportRect)return;let i=0;switch(this.horizontalScaling){case"anchor":case"fill":i=this.horizontalViewportLock?this.viewportRect.width:t.width,this.regionWidth=`${i}px`;break;case"content":i=this.regionRect.width,this.regionWidth="unset"}let o=0;switch(e){case"start":this.translateX=this.baseHorizontalOffset-i,this.horizontalViewportLock&&this.anchorRect.left>this.viewportRect.right&&(this.translateX=this.translateX-(this.anchorRect.left-this.viewportRect.right));break;case"insetStart":this.translateX=this.baseHorizontalOffset-i+this.anchorRect.width,this.horizontalViewportLock&&this.anchorRect.right>this.viewportRect.right&&(this.translateX=this.translateX-(this.anchorRect.right-this.viewportRect.right));break;case"insetEnd":this.translateX=this.baseHorizontalOffset,this.horizontalViewportLock&&this.anchorRect.left<this.viewportRect.left&&(this.translateX=this.translateX-(this.anchorRect.left-this.viewportRect.left));break;case"end":this.translateX=this.baseHorizontalOffset+this.anchorRect.width,this.horizontalViewportLock&&this.anchorRect.right<this.viewportRect.left&&(this.translateX=this.translateX-(this.anchorRect.right-this.viewportRect.left));break;case"center":if(o=(this.anchorRect.width-i)/2,this.translateX=this.baseHorizontalOffset+o,this.horizontalViewportLock){const e=this.anchorRect.left+o,t=this.anchorRect.right-o;e<this.viewportRect.left&&!(t>this.viewportRect.right)?this.translateX=this.translateX-(e-this.viewportRect.left):t>this.viewportRect.right&&!(e<this.viewportRect.left)&&(this.translateX=this.translateX-(t-this.viewportRect.right))}}this.horizontalPosition=e},this.setVerticalPosition=(e,t)=>{if(void 0===e||void 0===this.regionRect||void 0===this.anchorRect||void 0===this.viewportRect)return;let i=0;switch(this.verticalScaling){case"anchor":case"fill":i=this.verticalViewportLock?this.viewportRect.height:t.height,this.regionHeight=`${i}px`;break;case"content":i=this.regionRect.height,this.regionHeight="unset"}let o=0;switch(e){case"start":this.translateY=this.baseVerticalOffset-i,this.verticalViewportLock&&this.anchorRect.top>this.viewportRect.bottom&&(this.translateY=this.translateY-(this.anchorRect.top-this.viewportRect.bottom));break;case"insetStart":this.translateY=this.baseVerticalOffset-i+this.anchorRect.height,this.verticalViewportLock&&this.anchorRect.bottom>this.viewportRect.bottom&&(this.translateY=this.translateY-(this.anchorRect.bottom-this.viewportRect.bottom));break;case"insetEnd":this.translateY=this.baseVerticalOffset,this.verticalViewportLock&&this.anchorRect.top<this.viewportRect.top&&(this.translateY=this.translateY-(this.anchorRect.top-this.viewportRect.top));break;case"end":this.translateY=this.baseVerticalOffset+this.anchorRect.height,this.verticalViewportLock&&this.anchorRect.bottom<this.viewportRect.top&&(this.translateY=this.translateY-(this.anchorRect.bottom-this.viewportRect.top));break;case"center":if(o=(this.anchorRect.height-i)/2,this.translateY=this.baseVerticalOffset+o,this.verticalViewportLock){const e=this.anchorRect.top+o,t=this.anchorRect.bottom-o;e<this.viewportRect.top&&!(t>this.viewportRect.bottom)?this.translateY=this.translateY-(e-this.viewportRect.top):t>this.viewportRect.bottom&&!(e<this.viewportRect.top)&&(this.translateY=this.translateY-(t-this.viewportRect.bottom))}}this.verticalPosition=e},this.getPositioningOptions=e=>e?["insetStart","insetEnd"]:["start","end"],this.getAvailableSpace=(e,t,i,o,s,n)=>{const r=t-s,a=n-(t+o);switch(e){case"start":return r;case"insetStart":return r+o;case"insetEnd":return a+o;case"end":return a;case"center":return 2*Math.min(r,a)+o}},this.getNextRegionDimension=(e,t)=>{const i={height:void 0!==this.regionRect?this.regionRect.height:0,width:void 0!==this.regionRect?this.regionRect.width:0};return void 0!==e&&"fill"===this.horizontalScaling?i.width=this.getAvailableSpace(e,void 0!==this.anchorRect?this.anchorRect.left:0,void 0!==this.anchorRect?this.anchorRect.right:0,void 0!==this.anchorRect?this.anchorRect.width:0,void 0!==this.viewportRect?this.viewportRect.left:0,void 0!==this.viewportRect?this.viewportRect.right:0):"anchor"===this.horizontalScaling&&(i.width=void 0!==this.anchorRect?this.anchorRect.width:0),void 0!==t&&"fill"===this.verticalScaling?i.height=this.getAvailableSpace(t,void 0!==this.anchorRect?this.anchorRect.top:0,void 0!==this.anchorRect?this.anchorRect.bottom:0,void 0!==this.anchorRect?this.anchorRect.height:0,void 0!==this.viewportRect?this.viewportRect.top:0,void 0!==this.viewportRect?this.viewportRect.bottom:0):"anchor"===this.verticalScaling&&(i.height=void 0!==this.anchorRect?this.anchorRect.height:0),i},this.startAutoUpdateEventListeners=()=>{window.addEventListener(Wf,this.update,{passive:!0}),window.addEventListener(Gf,this.update,{passive:!0,capture:!0}),null!==this.resizeDetector&&null!==this.viewportElement&&this.resizeDetector.observe(this.viewportElement)},this.stopAutoUpdateEventListeners=()=>{window.removeEventListener(Wf,this.update),window.removeEventListener(Gf,this.update),null!==this.resizeDetector&&null!==this.viewportElement&&this.resizeDetector.unobserve(this.viewportElement)}}anchorChanged(){this.initialLayoutComplete&&(this.anchorElement=this.getAnchor())}viewportChanged(){this.initialLayoutComplete&&(this.viewportElement=this.getViewport())}horizontalPositioningModeChanged(){this.requestReset()}horizontalDefaultPositionChanged(){this.updateForAttributeChange()}horizontalViewportLockChanged(){this.updateForAttributeChange()}horizontalInsetChanged(){this.updateForAttributeChange()}horizontalThresholdChanged(){this.updateForAttributeChange()}horizontalScalingChanged(){this.updateForAttributeChange()}verticalPositioningModeChanged(){this.requestReset()}verticalDefaultPositionChanged(){this.updateForAttributeChange()}verticalViewportLockChanged(){this.updateForAttributeChange()}verticalInsetChanged(){this.updateForAttributeChange()}verticalThresholdChanged(){this.updateForAttributeChange()}verticalScalingChanged(){this.updateForAttributeChange()}fixedPlacementChanged(){this.$fastController.isConnected&&this.initialLayoutComplete&&this.initialize()}autoUpdateModeChanged(e,t){this.$fastController.isConnected&&this.initialLayoutComplete&&("auto"===e&&this.stopAutoUpdateEventListeners(),"auto"===t&&this.startAutoUpdateEventListeners())}anchorElementChanged(){this.requestReset()}viewportElementChanged(){this.$fastController.isConnected&&this.initialLayoutComplete&&this.initialize()}connectedCallback(){super.connectedCallback(),"auto"===this.autoUpdateMode&&this.startAutoUpdateEventListeners(),this.initialize()}disconnectedCallback(){super.disconnectedCallback(),"auto"===this.autoUpdateMode&&this.stopAutoUpdateEventListeners(),this.stopObservers(),this.disconnectResizeDetector()}adoptedCallback(){this.initialize()}disconnectResizeDetector(){null!==this.resizeDetector&&(this.resizeDetector.disconnect(),this.resizeDetector=null)}initializeResizeDetector(){this.disconnectResizeDetector(),this.resizeDetector=new window.ResizeObserver(this.handleResize)}updateForAttributeChange(){this.$fastController.isConnected&&this.initialLayoutComplete&&(this.forceUpdate=!0,this.update())}initialize(){this.initializeResizeDetector(),null===this.anchorElement&&(this.anchorElement=this.getAnchor()),this.requestReset()}requestReset(){this.$fastController.isConnected&&!1===this.pendingReset&&(this.setInitialState(),ps.queueUpdate((()=>this.reset())),this.pendingReset=!0)}setInitialState(){this.initialLayoutComplete=!1,this.regionVisible=!1,this.translateX=0,this.translateY=0,this.baseHorizontalOffset=0,this.baseVerticalOffset=0,this.viewportRect=void 0,this.regionRect=void 0,this.anchorRect=void 0,this.verticalPosition=void 0,this.horizontalPosition=void 0,this.style.opacity="0",this.style.pointerEvents="none",this.forceUpdate=!1,this.style.position=this.fixedPlacement?"fixed":"absolute",this.updatePositionClasses(),this.updateRegionStyle()}}Qf.intersectionService=new class{constructor(){this.intersectionDetector=null,this.observedElements=new Map,this.requestPosition=(e,t)=>{var i;null!==this.intersectionDetector&&(this.observedElements.has(e)?null===(i=this.observedElements.get(e))||void 0===i||i.push(t):(this.observedElements.set(e,[t]),this.intersectionDetector.observe(e)))},this.cancelRequestPosition=(e,t)=>{const i=this.observedElements.get(e);if(void 0!==i){const e=i.indexOf(t);-1!==e&&i.splice(e,1)}},this.initializeIntersectionDetector=()=>{is.IntersectionObserver&&(this.intersectionDetector=new IntersectionObserver(this.handleIntersection,{root:null,rootMargin:"0px",threshold:[0,1]}))},this.handleIntersection=e=>{if(null===this.intersectionDetector)return;const t=[],i=[];e.forEach((e=>{var o;null===(o=this.intersectionDetector)||void 0===o||o.unobserve(e.target);const s=this.observedElements.get(e.target);void 0!==s&&(s.forEach((o=>{let s=t.indexOf(o);-1===s&&(s=t.length,t.push(o),i.push([])),i[s].push(e)})),this.observedElements.delete(e.target))})),t.forEach(((e,t)=>{e(i[t])}))},this.initializeIntersectionDetector()}},Ms([Os],Qf.prototype,"anchor",void 0),Ms([Os],Qf.prototype,"viewport",void 0),Ms([Os({attribute:"horizontal-positioning-mode"})],Qf.prototype,"horizontalPositioningMode",void 0),Ms([Os({attribute:"horizontal-default-position"})],Qf.prototype,"horizontalDefaultPosition",void 0),Ms([Os({attribute:"horizontal-viewport-lock",mode:"boolean"})],Qf.prototype,"horizontalViewportLock",void 0),Ms([Os({attribute:"horizontal-inset",mode:"boolean"})],Qf.prototype,"horizontalInset",void 0),Ms([Os({attribute:"horizontal-threshold"})],Qf.prototype,"horizontalThreshold",void 0),Ms([Os({attribute:"horizontal-scaling"})],Qf.prototype,"horizontalScaling",void 0),Ms([Os({attribute:"vertical-positioning-mode"})],Qf.prototype,"verticalPositioningMode",void 0),Ms([Os({attribute:"vertical-default-position"})],Qf.prototype,"verticalDefaultPosition",void 0),Ms([Os({attribute:"vertical-viewport-lock",mode:"boolean"})],Qf.prototype,"verticalViewportLock",void 0),Ms([Os({attribute:"vertical-inset",mode:"boolean"})],Qf.prototype,"verticalInset",void 0),Ms([Os({attribute:"vertical-threshold"})],Qf.prototype,"verticalThreshold",void 0),Ms([Os({attribute:"vertical-scaling"})],Qf.prototype,"verticalScaling",void 0),Ms([Os({attribute:"fixed-placement",mode:"boolean"})],Qf.prototype,"fixedPlacement",void 0),Ms([Os({attribute:"auto-update-mode"})],Qf.prototype,"autoUpdateMode",void 0),Ms([ms],Qf.prototype,"anchorElement",void 0),Ms([ms],Qf.prototype,"viewportElement",void 0),Ms([ms],Qf.prototype,"initialLayoutComplete",void 0);const Kf=Mf.compose({baseName:"menu-item",template:(e,t)=>Rr`
    <template
        role="${e=>e.role}"
        aria-haspopup="${e=>e.hasSubmenu?"menu":void 0}"
        aria-checked="${e=>e.role!==Of?e.checked:void 0}"
        aria-disabled="${e=>e.disabled}"
        aria-expanded="${e=>e.expanded}"
        @keydown="${(e,t)=>e.handleMenuItemKeyDown(t.event)}"
        @click="${(e,t)=>e.handleMenuItemClick(t.event)}"
        @mouseover="${(e,t)=>e.handleMouseOver(t.event)}"
        @mouseout="${(e,t)=>e.handleMouseOut(t.event)}"
        class="${e=>e.disabled?"disabled":""} ${e=>e.expanded?"expanded":""} ${e=>`indent-${e.startColumnCount}`}"
    >
            ${eu((e=>e.role===Ff),Rr`
                    <div part="input-container" class="input-container">
                        <span part="checkbox" class="checkbox">
                            <slot name="checkbox-indicator">
                                ${t.checkboxIndicator||""}
                            </slot>
                        </span>
                    </div>
                `)}
            ${eu((e=>e.role===Af),Rr`
                    <div part="input-container" class="input-container">
                        <span part="radio" class="radio">
                            <slot name="radio-indicator">
                                ${t.radioIndicator||""}
                            </slot>
                        </span>
                    </div>
                `)}
        </div>
        ${au(0,t)}
        <span class="content" part="content">
            <slot></slot>
        </span>
        ${ru(0,t)}
        ${eu((e=>e.hasSubmenu),Rr`
                <div
                    part="expand-collapse-glyph-container"
                    class="expand-collapse-glyph-container"
                >
                    <span part="expand-collapse" class="expand-collapse">
                        <slot name="expand-collapse-indicator">
                            ${t.expandCollapseGlyph||""}
                        </slot>
                    </span>
                </div>
            `)}
        ${eu((e=>e.expanded),Rr`
                <${e.tagFor(Qf)}
                    :anchorElement="${e=>e}"
                    vertical-positioning-mode="dynamic"
                    vertical-default-position="bottom"
                    vertical-inset="true"
                    horizontal-positioning-mode="dynamic"
                    horizontal-default-position="end"
                    class="submenu-region"
                    dir="${e=>e.currentDirection}"
                    @loaded="${e=>e.submenuLoaded()}"
                    ${su("submenuRegion")}
                    part="submenu-region"
                >
                    <slot name="submenu"></slot>
                </${e.tagFor(Qf)}>
            `)}
    </template>
`,styles:(e,t)=>ih`
    ${nh("grid")} :host {
      contain: layout;
      overflow: visible;
      ${Bu}
      box-sizing: border-box;
      height: calc(${Uu} * 1px);
      grid-template-columns: minmax(32px, auto) 1fr minmax(32px, auto);
      grid-template-rows: auto;
      justify-items: center;
      align-items: center;
      padding: 0;
      white-space: nowrap;
      color: ${xc};
      fill: currentcolor;
      cursor: pointer;
      border-radius: calc(${Ra} * 1px);
      border: calc(${Ma} * 1px) solid transparent;
      position: relative;
    }

    :host(.indent-0) {
      grid-template-columns: auto 1fr minmax(32px, auto);
    }

    :host(.indent-0) .content {
      grid-column: 1;
      grid-row: 1;
      margin-inline-start: 10px;
    }

    :host(.indent-0) .expand-collapse-glyph-container {
      grid-column: 5;
      grid-row: 1;
    }

    :host(.indent-2) {
      grid-template-columns: minmax(32px, auto) minmax(32px, auto) 1fr minmax(32px, auto) minmax(32px, auto);
    }

    :host(.indent-2) .content {
      grid-column: 3;
      grid-row: 1;
      margin-inline-start: 10px;
    }

    :host(.indent-2) .expand-collapse-glyph-container {
      grid-column: 5;
      grid-row: 1;
    }

    :host(.indent-2) .start {
      grid-column: 2;
    }

    :host(.indent-2) .end {
      grid-column: 4;
    }

    :host(:${Nu}) {
      ${Hu}
    }

    :host(:not([disabled]):hover) {
      background: ${vc};
    }

    :host(:not([disabled]):active),
    :host(.expanded) {
      background: ${mc};
      color: ${xc};
      z-index: 2;
    }

    :host([disabled]) {
      cursor: ${Vu};
      opacity: ${Ea};
    }

    .content {
      grid-column-start: 2;
      justify-self: start;
      overflow: hidden;
      text-overflow: ellipsis;
    }

    .start,
    .end {
      display: flex;
      justify-content: center;
    }

    :host(.indent-0[aria-haspopup='menu']) {
      display: grid;
      grid-template-columns: minmax(32px, auto) auto 1fr minmax(32px, auto) minmax(32px, auto);
      align-items: center;
      min-height: 32px;
    }

    :host(.indent-1[aria-haspopup='menu']),
    :host(.indent-1[role='menuitemcheckbox']),
    :host(.indent-1[role='menuitemradio']) {
      display: grid;
      grid-template-columns: minmax(32px, auto) auto 1fr minmax(32px, auto) minmax(32px, auto);
      align-items: center;
      min-height: 32px;
    }

    :host(.indent-2:not([aria-haspopup='menu'])) .end {
      grid-column: 5;
    }

    :host .input-container,
    :host .expand-collapse-glyph-container {
      display: none;
    }

    :host([aria-haspopup='menu']) .expand-collapse-glyph-container,
    :host([role='menuitemcheckbox']) .input-container,
    :host([role='menuitemradio']) .input-container {
      display: grid;
    }

    :host([aria-haspopup='menu']) .content,
    :host([role='menuitemcheckbox']) .content,
    :host([role='menuitemradio']) .content {
      grid-column-start: 3;
    }

    :host([aria-haspopup='menu'].indent-0) .content {
      grid-column-start: 1;
    }

    :host([aria-haspopup='menu']) .end,
    :host([role='menuitemcheckbox']) .end,
    :host([role='menuitemradio']) .end {
      grid-column-start: 4;
    }

    :host .expand-collapse,
    :host .checkbox,
    :host .radio {
      display: flex;
      align-items: center;
      justify-content: center;
      position: relative;
      box-sizing: border-box;
    }

    :host .checkbox-indicator,
    :host .radio-indicator,
    slot[name='checkbox-indicator'],
    slot[name='radio-indicator'] {
      display: none;
    }

    ::slotted([slot='end']:not(svg)) {
      margin-inline-end: 10px;
      color: ${Sc};
    }

    :host([aria-checked='true']) .checkbox-indicator,
    :host([aria-checked='true']) slot[name='checkbox-indicator'],
    :host([aria-checked='true']) .radio-indicator,
    :host([aria-checked='true']) slot[name='radio-indicator'] {
      display: flex;
    }
  `.withBehaviors(lh(ih`
        :host,
        ::slotted([slot='end']:not(svg)) {
          forced-color-adjust: none;
          color: ${dh.ButtonText};
          fill: currentcolor;
        }
        :host(:not([disabled]):hover) {
          background: ${dh.Highlight};
          color: ${dh.HighlightText};
          fill: currentcolor;
        }
        :host(:hover) .start,
        :host(:hover) .end,
        :host(:hover)::slotted(svg),
        :host(:active) .start,
        :host(:active) .end,
        :host(:active)::slotted(svg),
        :host(:hover) ::slotted([slot='end']:not(svg)),
        :host(:${Nu}) ::slotted([slot='end']:not(svg)) {
          color: ${dh.HighlightText};
          fill: currentcolor;
        }
        :host(.expanded) {
          background: ${dh.Highlight};
          color: ${dh.HighlightText};
        }
        :host(:${Nu}) {
          background: ${dh.Highlight};
          outline-color: ${dh.ButtonText};
          color: ${dh.HighlightText};
          fill: currentcolor;
        }
        :host([disabled]),
        :host([disabled]:hover),
        :host([disabled]:hover) .start,
        :host([disabled]:hover) .end,
        :host([disabled]:hover)::slotted(svg),
        :host([disabled]:${Nu}) {
          background: ${dh.ButtonFace};
          color: ${dh.GrayText};
          fill: currentcolor;
          opacity: 1;
        }
        :host([disabled]:${Nu}) {
          outline-color: ${dh.GrayText};
        }
        :host .expanded-toggle,
        :host .checkbox,
        :host .radio {
          border-color: ${dh.ButtonText};
          background: ${dh.HighlightText};
        }
        :host([checked]) .checkbox,
        :host([checked]) .radio {
          background: ${dh.HighlightText};
          border-color: ${dh.HighlightText};
        }
        :host(:hover) .expanded-toggle,
            :host(:hover) .checkbox,
            :host(:hover) .radio,
            :host(:${Nu}) .expanded-toggle,
            :host(:${Nu}) .checkbox,
            :host(:${Nu}) .radio,
            :host([checked]:hover) .checkbox,
            :host([checked]:hover) .radio,
            :host([checked]:${Nu}) .checkbox,
            :host([checked]:${Nu}) .radio {
          border-color: ${dh.HighlightText};
        }
        :host([aria-checked='true']) {
          background: ${dh.Highlight};
          color: ${dh.HighlightText};
        }
        :host([aria-checked='true']) .checkbox-indicator,
        :host([aria-checked='true']) ::slotted([slot='checkbox-indicator']),
        :host([aria-checked='true']) ::slotted([slot='radio-indicator']) {
          fill: ${dh.Highlight};
        }
        :host([aria-checked='true']) .radio-indicator {
          background: ${dh.Highlight};
        }
      `),new ag(ih`
        .expand-collapse-glyph-container {
          transform: rotate(0deg);
        }
      `,ih`
        .expand-collapse-glyph-container {
          transform: rotate(180deg);
        }
      `)),checkboxIndicator:'\n    <svg width="16" height="16" xmlns="http://www.w3.org/2000/svg">\n      <path d="M13.86 3.66a.5.5 0 01-.02.7l-7.93 7.48a.6.6 0 01-.84-.02L2.4 9.1a.5.5 0 01.72-.7l2.4 2.44 7.65-7.2a.5.5 0 01.7.02z"/>\n    </svg>\n  ',expandCollapseGlyph:'\n    <svg width="16" height="16" xmlns="http://www.w3.org/2000/svg">\n      <path d="M5.65 3.15a.5.5 0 000 .7L9.79 8l-4.14 4.15a.5.5 0 00.7.7l4.5-4.5a.5.5 0 000-.7l-4.5-4.5a.5.5 0 00-.7 0z"/>\n    </svg>\n  ',radioIndicator:'\n    <svg width="16" height="16" xmlns="http://www.w3.org/2000/svg">\n      <circle cx="8" cy="8" r="2"/>\n    </svg>\n  '});var Xf=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Jf=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(Bf,Kf,Ju);let Yf=class extends Pt{static get styles(){return Ef}constructor(){super(),this.onHeaderClick=e=>{Object.keys(this.options).length>1&&(e.preventDefault(),e.stopPropagation(),this.open=!this.open)},this.onHeaderKeyDown=e=>{if("Enter"===e.key){e.preventDefault(),e.stopPropagation(),this.open=!this.open;const t=this.renderRoot.querySelector("fluent-menu");t&&(t.classList.remove("closed"),t.classList.add("open"));const i=e.target;if(i){const e=this.renderRoot.querySelector("fluent-menu-item[tabindex='0']");e&&(i.blur(),e.focus())}}},this.value="",this.options={},this._clickHandler=()=>this.open=!1,window.addEventListener("onblur",(()=>this.open=!1))}connectedCallback(){super.connectedCallback(),window.addEventListener("click",this._clickHandler)}disconnectedCallback(){window.removeEventListener("click",this._clickHandler),super.disconnectedCallback()}render(){return Je`
      <fluent-button
        class="header"
        @click=${this.onHeaderClick}
        @keydown=${this.onHeaderKeyDown}
        appearance="lightweight">
          ${this.value}
      </fluent-button>
      <fluent-menu
        class=${ki({menu:!0,open:this.open,closed:!this.open})}>
          ${this.getMenuOptions()}
      </fluent-menu>`}getMenuOptions(){return Object.keys(this.options).map((e=>Je`
          <fluent-menu-item
            @click=${t=>{this.open=!1,this.options[e](t)}}
            @keydown=${t=>{const i=this.renderRoot.querySelector(".header");"Enter"===t.key?(this.open=!1,this.options[e](t),i.focus()):"Tab"===t.key?this.open=!1:"Escape"===t.key&&(this.open=!1,i&&i.focus())}}>
              ${e}
          </fluent-menu-item>`))}};Xf([Ct({type:Boolean}),Jf("design:type",Boolean)],Yf.prototype,"open",void 0),Xf([Ct({type:String}),Jf("design:type",String)],Yf.prototype,"value",void 0),Xf([Ct({type:Object}),Jf("design:type",Object)],Yf.prototype,"options",void 0),Yf=Xf([gi("arrow-options"),Jf("design:paramtypes",[])],Yf);const ev={dotOptionsTitle:"More options"},tv=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{display:flex;flex-direction:column;align-items:flex-end}:host .dot-icon{font-family:FabricMDL2Icons;min-width:40px;min-height:30px;text-align:center;line-height:30px}:host .menu{position:absolute;box-shadow:var(--neutral-fill-rest) 0 0 40px 5px;background:var(--neutral-fill-rest);z-index:1;display:none;white-space:nowrap;transform:var(--dot-options-translatey,translateY(32px))}:host .menu.open{display:block}:host fluent-button::part(control){background:inherit}
`];var iv=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},ov=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(Bf,Kf,Ju);let sv=class extends Pt{constructor(){super(...arguments),this._clickHandler=()=>this.open=!1,this.handleItemClick=(e,t)=>{e.preventDefault(),e.stopPropagation(),t(e),this.open=!1},this.handleItemKeydown=(e,t)=>{this.handleKeydownMenuOption(e),t(e),this.open=!1},this.onDotClick=e=>{e.preventDefault(),e.stopPropagation(),this.open=!this.open},this.onDotKeydown=e=>{"Enter"===e.key&&(e.preventDefault(),e.stopPropagation(),this.open=!this.open)}}static get styles(){return tv}get strings(){return ev}connectedCallback(){super.connectedCallback(),window.addEventListener("click",this._clickHandler)}disconnectedCallback(){window.removeEventListener("click",this._clickHandler),super.disconnectedCallback()}render(){const e=Object.keys(this.options);return Je(nv||(t=['\n      <fluent-button\n        appearance="stealth"\n        aria-label=',"\n        @click=","\n        @keydown=",'\n        class="dot-icon"></fluent-button>\n      <fluent-menu class=',">\n        ","\n      </fluent-menu>"],i=['\n      <fluent-button\n        appearance="stealth"\n        aria-label=',"\n        @click=","\n        @keydown=",'\n        class="dot-icon">\\uE712</fluent-button>\n      <fluent-menu class=',">\n        ","\n      </fluent-menu>"],Object.defineProperty?Object.defineProperty(t,"raw",{value:i}):t.raw=i,nv=t),this.strings.dotOptionsTitle,this.onDotClick,this.onDotKeydown,ki({menu:!0,open:this.open}),e.map((e=>this.getMenuOption(e,this.options[e]))));var t,i}getMenuOption(e,t){return Je`
      <fluent-menu-item
        @click=${e=>this.handleItemClick(e,t)}
        @keydown=${e=>this.handleItemKeydown(e,t)}>
          ${e}
      </fluent-menu-item>`}handleKeydownMenuOption(e){"Enter"===e.key&&(e.preventDefault(),e.stopPropagation())}};var nv;iv([Ct({type:Boolean}),ov("design:type",Boolean)],sv.prototype,"open",void 0),iv([Ct({type:Object}),ov("design:type",Object)],sv.prototype,"options",void 0),sv=iv([gi("dot-options")],sv);const rv=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{background-color:var(--tasks-background-color,transparent);padding:var(--tasks-padding,12px);border:var(--tasks-border,0);border-radius:var(--tasks-border-radius,0);--skeleton-fill:var(--neutral-foreground-active)}:host .header{display:flex;align-items:center;justify-content:space-between;padding:var(--tasks-header-padding,0 0 14px 0);margin:var(--tasks-header-padding,0 0 14px 0);font-size:var(--tasks-header-font-size,16px);font-weight:var(--tasks-header-font-weight,600);color:var(--tasks-header-text-color,var(--neutral-foreground-hint))}:host .header:hover{color:var(--tasks-header-text-hover-color,var(--neutral-foreground-hover))}:host .header .title{justify-content:left;display:flex;align-items:center}:host .header .title .shimmer{width:80px;height:20px}:host .header .title svg{margin-top:3px;padding:0 4px;width:16px;height:16px}:host .header .new-task-button{justify-content:right}:host .header .new-task-button .shimmer{width:40px;height:24px}:host .header .new-task-button::part(control){font-weight:var(--tasks-new-button-text-font-weight,700);color:var(--tasks-new-button-text-color,var(--foreground-on-accent-rest));width:var(--tasks-new-button-width,none);height:var(--tasks-new-button-height,none);background:var(--tasks-new-button-background,padding-box linear-gradient(var(--accent-fill-rest),var(--accent-fill-rest)),border-box var(--accent-stroke-control-rest))}:host .header .new-task-button::part(control):hover{background:var(--tasks-new-button-background-hover,var(--accent-fill-hover))}:host .header .new-task-button::part(control):active{background:var(--tasks-new-button-background-active,var(--accent-fill-active))}:host .tasks{display:flex;flex-direction:column;row-gap:var(--tasks-gap,20px)}:host .tasks .task{display:flex;column-gap:4px;align-items:flex-start;justify-content:space-between}:host .tasks .task.updating{background:var(--neutral-stroke-rest)!important;pointer-events:none;opacity:.4}:host .tasks .task.complete{border:var(--task-complete-border,2px dotted var(--neutral-foreground-active));border-radius:var(--task-complete-border-radius,4px);background:var(--task-complete-background-color,transparent);padding:var(--task-complete-padding,10px)}:host .tasks .task.incomplete{border:var(--task-incomplete-border,1px solid var(--neutral-foreground-active));border-radius:var(--task-complete-border-radius,4px);background:var(--task-incomplete-background-color,var(--neutral-layer-1));padding:var(--task-incomplete-padding,10px)}:host .tasks .task .task-details-container{display:flex;flex-direction:column;row-gap:12px;width:100%}:host .tasks .task .task-details-container .top{display:flex;justify-content:space-between;column-gap:4px}:host .tasks .task .task-details-container .top.add-new-task{flex-direction:row}:host .tasks .task .task-details-container .top .check-and-title{display:flex;align-items:flex-start;flex-direction:column;width:100%;row-gap:12px}:host .tasks .task .task-details-container .top .check-and-title.shimmer{display:flex;flex-direction:inherit;gap:10px}:host .tasks .task .task-details-container .top .check-and-title.shimmer .checkbox{height:10px;width:10px}:host .tasks .task .task-details-container .top .check-and-title.shimmer .title{height:10px;width:100%}:host .tasks .task .task-details-container .top .check-and-title .task-content{display:grid;grid-template-columns:repeat(auto-fit,250px);gap:12px;justify-content:start;width:100%}:host .tasks .task .task-details-container .top .check-and-title .task-content .picker{max-width:250px}:host .tasks .task .task-details-container .top .check-and-title .task-content .task-due fluent-text-field.dark::part(control){color-scheme:dark}:host .tasks .task .task-details-container .top .task-options .options{height:10px;width:20px}:host .tasks .task .task-details-container .top .task-options.new-task-action-buttons{display:flex;flex-direction:column;row-gap:12px}:host .tasks .task .task-details-container .bottom{display:grid;grid-auto-flow:column;grid-auto-columns:1fr;grid-column-gap:6px}:host .tasks .task .task-details-container .bottom .task-bucket,:host .tasks .task .task-details-container .bottom .task-due,:host .tasks .task .task-details-container .bottom .task-group{display:flex;align-items:center;gap:6px}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon,:host .tasks .task .task-details-container .bottom .task-due .task-icon,:host .tasks .task .task-details-container .bottom .task-group .task-icon{display:flex;place-content:center;width:var(--task-icons-width,20px);height:var(--task-icons-height,20px)}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon .shimmer.icon,:host .tasks .task .task-details-container .bottom .task-due .task-icon .shimmer.icon,:host .tasks .task .task-details-container .bottom .task-group .task-icon .shimmer.icon{width:20px;height:20px}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon svg,:host .tasks .task .task-details-container .bottom .task-due .task-icon svg,:host .tasks .task .task-details-container .bottom .task-group .task-icon svg{width:var(--task-icons-width,20px);height:var(--task-icons-height,20px)}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon svg path,:host .tasks .task .task-details-container .bottom .task-due .task-icon svg path,:host .tasks .task .task-details-container .bottom .task-group .task-icon svg path{fill:var(--task-icons-background-color,var(--neutral-foreground-hint))}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon-text,:host .tasks .task .task-details-container .bottom .task-due .task-icon-text,:host .tasks .task .task-details-container .bottom .task-group .task-icon-text{color:var(--task-icons-text-font-color,var(--neutral-foreground-hint));font-size:var(--task-icons-text-font-size,12px);font-weight:var(--task-icons-text-font-weight,600);white-space:normal;width:100%}:host .tasks .task .task-details-container .bottom .task-bucket .task-icon-text .shimmer.text,:host .tasks .task .task-details-container .bottom .task-due .task-icon-text .shimmer.text,:host .tasks .task .task-details-container .bottom .task-group .task-icon-text .shimmer.text{width:100%;height:10px}:host .tasks .task .task-details-container .task-details{display:flex;flex-direction:column;row-gap:8px}:host .tasks .task .task-details-container .task-details.shimmer{flex-direction:row;place-items:center;column-gap:6px}:host .tasks .task .task-details-container .task-details.shimmer .shimmer.icon{width:24px;height:24px}:host .tasks .task .task-details-container .task-details.shimmer .shimmer.text{width:100%;height:10px}:host .tasks .task .task-details-container .task-details .task-title{color:var(--foreground-on-neutral-rest)}:host .tasks .task .task-details-container .task-details .task-body{display:flex}:host fluent-button.add-task::part(control){font-weight:var(--task-add-new-button-text-font-weight,initial);color:var(--task-add-new-button-text-color,var(--neutral-foreground-rest));width:var(--task-add-new-button-width,none);height:var(--task-add-new-button-height,none);background:var(--task-add-new-button-background,padding-box linear-gradient(var(--neutral-fill-active),var(--neutral-fill-active)),border-box var(--neutral-stroke-control-active));border:var(--task-add-new-button-border,calc(var(--stroke-width) * 1px) solid transparent)}:host fluent-button.add-task::part(control):hover{background:var(--task-add-new-button-background-hover,padding-box linear-gradient(var(--neutral-fill-hover),var(--neutral-fill-hover)),border-box var(--neutral-stroke-control-hover))}:host fluent-button.add-task::part(control):active{background:var(--task-add-new-button-background-active,padding-box linear-gradient(var(--neutral-fill-active),var(--neutral-fill-active)),border-box var(--neutral-stroke-control-active))}:host fluent-button.cancel-task::part(control){font-weight:var(--task-cancel-new-button-text-font-weight,initial);color:var(--task-cancel-new-button-text-color,var(--neutral-foreground-rest));width:var(--task-cancel-new-button-width,none);height:var(--task-cancel-new-button-height,none);background:var(--task-cancel-new-button-background,padding-box linear-gradient(var(--neutral-fill-active),var(--neutral-fill-active)),border-box var(--neutral-stroke-control-active));border:var(--task-cancel-new-button-border,calc(var(--stroke-width) * 1px) solid transparent)}:host fluent-button.cancel-task::part(control):hover{background:var(--task-cancel-new-button-background-hover,padding-box linear-gradient(var(--neutral-fill-hover),var(--neutral-fill-hover)),border-box var(--neutral-stroke-control-hover))}:host fluent-button.cancel-task::part(control):active{background:var(--task-cancel-new-button-background-active,padding-box linear-gradient(var(--neutral-fill-active),var(--neutral-fill-active)),border-box var(--neutral-stroke-control-active))}:host fluent-option{background:var(--task-new-dropdown-list-background-color,var(--fill-color))}:host fluent-option:hover{background:var(--task-new-dropdown-option-hover-background-color,var(--neutral-fill-stealth-hover))}:host fluent-option::part(content){color:var(--task-new-dropdown-option-text-color,var(--neutral-foreground-rest))}:host fluent-select::part(listbox){background:var(--task-new-dropdown-list-background-color,var(--fill-color))}:host fluent-select::part(control){border:var(--task-new-dropdown-border,calc(var(--stroke-width) * 1px) solid transparent);border-radius:var(--task-new-dropdown-border-radius,calc(var(--control-corner-radius) * 1px));background:var(--task-new-dropdown-background-color,padding-box linear-gradient(var(--neutral-fill-input-rest),var(--neutral-fill-input-rest)),border-box var(--neutral-stroke-input-rest))}:host fluent-select::part(control):hover{background:var(--task-new-dropdown-hover-background-color,padding-box linear-gradient(var(--neutral-fill-input-hover),var(--neutral-fill-input-hover)),border-box var(--neutral-stroke-input-hover))}:host fluent-select::part(control)::placeholder{color:var(--task-new-dropdown-placeholder-color,var(--input-placeholder-rest))}:host fluent-checkbox{padding-top:1px}:host fluent-checkbox::part(control){border-radius:50%;background:var(--task-incomplete-checkbox-background-color,var(--neutral-fill-input-alt-rest))}:host fluent-checkbox::part(control):hover{background:var(--task-incomplete-checkbox-background-hover-color,var(--neutral-fill-input-alt-hover))}:host fluent-checkbox::part(label){font-size:var(--task-title-text-font-size,medium);font-weight:var(--task-title-text-font-weight,600);color:var(--task-incomplete-title-text-color,var(var(--neutral-foreground-rest)))}:host fluent-checkbox.checked::part(control){background:var(--task-complete-checkbox-background-color,var(--accent-fill-rest));color:var(--task-complete-checkbox-text-color,currentColor)}:host fluent-checkbox.checked::part(label){text-decoration:line-through;color:var(--task-complete-title-text-color,var(--neutral-foreground-hint))}:host fluent-text-field.new-task{width:100%}:host fluent-text-field.new-task::part(root){border:var(--task-new-input-border,calc(var(--stroke-width) * 1px) solid transparent);border-radius:var(--task-new-input-border-radius,calc(var(--control-corner-radius) * 1px));background:var(--task-new-input-background-color,padding-box linear-gradient(var(--neutral-fill-input-rest),var(--neutral-fill-input-rest)),border-box var(--neutral-stroke-input-rest))}:host fluent-text-field.new-task::part(root):hover{background:var(--task-new-input-hover-background-color,padding-box linear-gradient(var(--neutral-fill-input-hover),var(--neutral-fill-input-hover)),border-box var(--neutral-stroke-input-hover))}:host fluent-text-field.new-task::part(root)::placeholder{color:var(--task-new-input-placeholder-color,var(--input-placeholder-rest))}:host .people [slot=no-data] fluent-button::part(control){color:var(--task-new-person-icon-text-color,var(--neutral-foreground-hint))}:host .people [slot=no-data] svg{fill:var(--task-new-person-icon-color,var(--neutral-foreground-hint))}@media only screen and (width <= 600px){:host fluent-select{width:100%}:host .tasks .task .task-details-container .bottom{display:grid;grid-auto-flow:row;grid-auto-columns:unset;row-gap:4px}:host .tasks .task .task-details-container .bottom .ask-bucket,:host .tasks .task .task-details-container .bottom .ask-due,:host .tasks .task .task-details-container .bottom .ask-group{margin-inline-start:8px}:host .tasks .task .task-details-container .top.add-new-task{flex-direction:column;row-gap:12px}:host .tasks .task .task-details-container .top.add-new-task .check-and-title .task-content{display:grid;grid-auto-flow:row;row-gap:12px;width:100%}:host .tasks .task .task-details-container .top.add-new-task .task-options.new-task-action-buttons{flex-direction:row;column-gap:4px}}
`],av={removeTaskSubtitle:"Delete Task",cancelNewTaskSubtitle:"Cancel",newTaskPlaceholder:"Adding a task...",addTaskButtonSubtitle:"Add",due:"Due ",addTaskDate:"Add the task date",assign:"Assign"};var lv=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const dv=(e,t,i)=>lv(void 0,void 0,void 0,(function*(){const o={assignments:i,appliedCategories:{category4:!0}};yield cv(e,t,o)})),cv=(e,t,i)=>lv(void 0,void 0,void 0,(function*(){let o;try{o=yield e.api(`/planner/tasks/${t.id}`).header("Cache-Control","no-store").middlewareOptions(ie("Group.ReadWrite.All")).header("Prefer","return=representation").header("If-Match",t.eTag).update(i)}catch(e){}return o}));var hv=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const uv=(e,t,i,o)=>hv(void 0,void 0,void 0,(function*(){return yield e.api(`/me/outlook/tasks/${t}`).header("Cache-Control","no-store").header("If-Match",o).middlewareOptions(ie("Tasks.ReadWrite")).patch(i)}));var pv=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};class gv{constructor(e){this.graph=ue.fromGraph(e)}}class fv extends gv{getTaskGroups(){return pv(this,void 0,void 0,(function*(){var e;return(yield(e=this.graph,lv(void 0,void 0,void 0,(function*(){const t=yield e.api("/me/planner/plans").header("Cache-Control","no-store").middlewareOptions(ie("Group.Read.All")).get();return null==t?void 0:t.value})))).map((e=>{var t;return{id:e.id,title:e.title,containerId:null===(t=null==e?void 0:e.container)||void 0===t?void 0:t.containerId}}))}))}getTaskGroupsForGroup(e){return pv(this,void 0,void 0,(function*(){var t,i;return(yield(t=this.graph,i=e,lv(void 0,void 0,void 0,(function*(){const e=`/groups/${i}/planner/plans`,o=yield t.api(e).header("Cache-Control","no-store").middlewareOptions(ie("Group.Read.All")).get();return null==o?void 0:o.value})))).map((e=>({id:e.id,title:e.title})))}))}getTaskGroup(e){return pv(this,void 0,void 0,(function*(){const t=yield(i=this.graph,o=e,lv(void 0,void 0,void 0,(function*(){return yield i.api(`/planner/plans/${o}`).header("Cache-Control","no-store").middlewareOptions(ie("Group.Read.All")).get()})));var i,o;return{id:t.id,title:t.title,_raw:t}}))}getTaskFoldersForTaskGroup(e){return pv(this,void 0,void 0,(function*(){var t,i;return(yield(t=this.graph,i=e,lv(void 0,void 0,void 0,(function*(){const e=yield t.api(`/planner/plans/${i}/buckets`).header("Cache-Control","no-store").middlewareOptions(ie("Group.Read.All")).get();return null==e?void 0:e.value})))).map((e=>({_raw:e,id:e.id,name:e.name,parentId:e.planId})))}))}getTasksForTaskFolder(e){return pv(this,void 0,void 0,(function*(){var t,i;return(yield(t=this.graph,i=e,lv(void 0,void 0,void 0,(function*(){const e=yield t.api(`/planner/buckets/${i}/tasks`).header("Cache-Control","no-store").middlewareOptions(ie("Group.Read.All")).get();return null==e?void 0:e.value})))).map((e=>({_raw:e,assignments:e.assignments,completed:100===e.percentComplete,dueDate:e.dueDateTime&&new Date(e.dueDateTime),eTag:e["@odata.etag"],id:e.id,immediateParentId:e.bucketId,name:e.title,topParentId:e.planId})))}))}setTaskComplete(e){return pv(this,void 0,void 0,(function*(){return yield((e,t)=>lv(void 0,void 0,void 0,(function*(){yield cv(e,t,{percentComplete:100})})))(this.graph,e)}))}setTaskIncomplete(e){return pv(this,void 0,void 0,(function*(){return((e,t)=>lv(void 0,void 0,void 0,(function*(){yield cv(e,t,{percentComplete:0})})))(this.graph,e)}))}addTask(e){var t;return pv(this,void 0,void 0,(function*(){return yield((e,t)=>lv(void 0,void 0,void 0,(function*(){return yield e.api("/planner/tasks").header("Cache-Control","no-store").middlewareOptions(ie("Group.ReadWrite.All")).post(t)})))(this.graph,{assignments:e.assignments,bucketId:e.immediateParentId,dueDateTime:null===(t=e.dueDate)||void 0===t?void 0:t.toISOString(),planId:e.topParentId,title:e.name})}))}assignPeopleToTask(e,t){return pv(this,void 0,void 0,(function*(){return dv(this.graph,e,t)}))}removeTask(e){return pv(this,void 0,void 0,(function*(){return yield((e,t)=>lv(void 0,void 0,void 0,(function*(){yield e.api(`/planner/tasks/${t.id}`).header("Cache-Control","no-store").header("If-Match",t.eTag).middlewareOptions(ie("Group.ReadWrite.All")).delete()})))(this.graph,e)}))}isAssignedToMe(e,t){return Object.keys(e.assignments).includes(t)}}class vv extends gv{getTaskGroups(){return pv(this,void 0,void 0,(function*(){var e;return(yield(e=this.graph,hv(void 0,void 0,void 0,(function*(){const t=yield e.api("/me/outlook/taskGroups").header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get();return null==t?void 0:t.value})))).map((e=>({_raw:e,id:e.id,secondaryId:e.groupKey,title:e.name})))}))}getTaskGroup(e){return pv(this,void 0,void 0,(function*(){const t=yield(i=this.graph,o=e,hv(void 0,void 0,void 0,(function*(){return yield i.api(`/me/outlook/taskGroups/${o}`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get()})));var i,o;return{id:t.id,secondaryId:t.groupKey,title:t.name,_raw:t}}))}getTaskFoldersForTaskGroup(e){return pv(this,void 0,void 0,(function*(){var t,i;return(yield(t=this.graph,i=e,hv(void 0,void 0,void 0,(function*(){const e=yield t.api(`/me/outlook/taskGroups/${i}/taskFolders`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get();return null==e?void 0:e.value})))).map((t=>({_raw:t,id:t.id,name:t.name,parentId:e})))}))}getTasksForTaskFolder(e,t){return pv(this,void 0,void 0,(function*(){var i,o;return(yield(i=this.graph,o=e,hv(void 0,void 0,void 0,(function*(){const e=yield i.api(`/me/outlook/taskFolders/${o}/tasks`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get();return null==e?void 0:e.value})))).map((i=>({_raw:i,assignments:{},completed:!!i.completedDateTime,dueDate:i.dueDateTime&&new Date(i.dueDateTime.dateTime+"Z"),eTag:i["@odata.etag"],id:i.id,immediateParentId:e,name:i.subject,topParentId:t})))}))}setTaskComplete(e){return pv(this,void 0,void 0,(function*(){var t,i,o;yield(t=this.graph,i=e.id,o=e.eTag,hv(void 0,void 0,void 0,(function*(){return yield uv(t,i,{isReminderOn:!1,status:"completed"},o)})))}))}assignPeopleToTask(e,t){return pv(this,void 0,void 0,(function*(){return yield dv(this.graph,e,t)}))}setTaskIncomplete(e){return pv(this,void 0,void 0,(function*(){var t,i,o;yield(t=this.graph,i=e.id,o=e.eTag,hv(void 0,void 0,void 0,(function*(){return yield uv(t,i,{isReminderOn:!0,status:"notStarted"},o)})))}))}addTask(e){return pv(this,void 0,void 0,(function*(){const t={parentFolderId:e.immediateParentId,subject:e.name};return e.dueDate&&(t.dueDateTime={dateTime:e.dueDate.toISOString(),timeZone:"UTC"}),yield((e,t)=>hv(void 0,void 0,void 0,(function*(){const{parentFolderId:i=null}=t;return i?yield e.api(`/me/outlook/taskFolders/${i}/tasks`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.ReadWrite")).post(t):yield e.api("/me/outlook/tasks").header("Cache-Control","no-store").middlewareOptions(ie("Tasks.ReadWrite")).post(t)})))(this.graph,t)}))}removeTask(e){return pv(this,void 0,void 0,(function*(){return yield(t=this.graph,i=e.id,o=e.eTag,hv(void 0,void 0,void 0,(function*(){yield t.api(`/me/outlook/tasks/${i}`).header("Cache-Control","no-store").header("If-Match",o).middlewareOptions(ie("Tasks.ReadWrite")).delete()})));var t,i,o}))}isAssignedToMe(e,t){return Object.keys(e.assignments).includes(t)}getTaskGroupsForGroup(e){return pv(this,void 0,void 0,(function*(){return Promise.resolve(void 0)}))}}const mv=e=>{const t=vl.getValueFor(e);return aa(oa.create(t,t,t))};class bv extends Ig{}class yv extends(Iu(bv)){constructor(){super(...arguments),this.proxy=document.createElement("select")}}class wv extends yv{constructor(){super(...arguments),this.open=!1,this.forcedPosition=!1,this.listboxId=Pp("listbox-"),this.maxHeight=0}openChanged(e,t){if(this.collapsible){if(this.open)return this.ariaControls=this.listboxId,this.ariaExpanded="true",this.setPositioning(),this.focusAndScrollOptionIntoView(),this.indexWhenOpened=this.selectedIndex,void ps.queueUpdate((()=>this.focus()));this.ariaControls="",this.ariaExpanded="false"}}get collapsible(){return!(this.multiple||"number"==typeof this.size)}get value(){return vs.track(this,"value"),this._value}set value(e){var t,i,o,s,n,r,a;const l=`${this._value}`;if(null===(t=this._options)||void 0===t?void 0:t.length){const t=this._options.findIndex((t=>t.value===e)),l=null!==(o=null===(i=this._options[this.selectedIndex])||void 0===i?void 0:i.value)&&void 0!==o?o:null,d=null!==(n=null===(s=this._options[t])||void 0===s?void 0:s.value)&&void 0!==n?n:null;-1!==t&&l===d||(e="",this.selectedIndex=t),e=null!==(a=null===(r=this.firstSelectedOption)||void 0===r?void 0:r.value)&&void 0!==a?a:e}l!==e&&(this._value=e,super.valueChanged(l,e),vs.notify(this,"value"),this.updateDisplayValue())}updateValue(e){var t,i;this.$fastController.isConnected&&(this.value=null!==(i=null===(t=this.firstSelectedOption)||void 0===t?void 0:t.value)&&void 0!==i?i:""),e&&(this.$emit("input"),this.$emit("change",this,{bubbles:!0,composed:void 0}))}selectedIndexChanged(e,t){super.selectedIndexChanged(e,t),this.updateValue()}positionChanged(e,t){this.positionAttribute=t,this.setPositioning()}setPositioning(){const e=this.getBoundingClientRect(),t=window.innerHeight-e.bottom;this.position=this.forcedPosition?this.positionAttribute:e.top>t?Mp:zp,this.positionAttribute=this.forcedPosition?this.positionAttribute:this.position,this.maxHeight=this.position===Mp?~~e.top:~~t}get displayValue(){var e,t;return vs.track(this,"displayValue"),null!==(t=null===(e=this.firstSelectedOption)||void 0===e?void 0:e.text)&&void 0!==t?t:""}disabledChanged(e,t){super.disabledChanged&&super.disabledChanged(e,t),this.ariaDisabled=this.disabled?"true":"false"}formResetCallback(){this.setProxyOptions(),super.setDefaultSelectedOption(),-1===this.selectedIndex&&(this.selectedIndex=0)}clickHandler(e){if(!this.disabled){if(this.open){const t=e.target.closest("option,[role=option]");if(t&&t.disabled)return}return super.clickHandler(e),this.open=this.collapsible&&!this.open,this.open||this.indexWhenOpened===this.selectedIndex||this.updateValue(!0),!0}}focusoutHandler(e){var t;if(super.focusoutHandler(e),!this.open)return!0;const i=e.relatedTarget;this.isSameNode(i)?this.focus():(null===(t=this.options)||void 0===t?void 0:t.includes(i))||(this.open=!1,this.indexWhenOpened!==this.selectedIndex&&this.updateValue(!0))}handleChange(e,t){super.handleChange(e,t),"value"===t&&this.updateValue()}slottedOptionsChanged(e,t){this.options.forEach((e=>{vs.getNotifier(e).unsubscribe(this,"value")})),super.slottedOptionsChanged(e,t),this.options.forEach((e=>{vs.getNotifier(e).subscribe(this,"value")})),this.setProxyOptions(),this.updateValue()}mousedownHandler(e){var t;return e.offsetX>=0&&e.offsetX<=(null===(t=this.listbox)||void 0===t?void 0:t.scrollWidth)?super.mousedownHandler(e):this.collapsible}multipleChanged(e,t){super.multipleChanged(e,t),this.proxy&&(this.proxy.multiple=t)}selectedOptionsChanged(e,t){var i;super.selectedOptionsChanged(e,t),null===(i=this.options)||void 0===i||i.forEach(((e,t)=>{var i;const o=null===(i=this.proxy)||void 0===i?void 0:i.options.item(t);o&&(o.selected=e.selected)}))}setDefaultSelectedOption(){var e;const t=null!==(e=this.options)&&void 0!==e?e:Array.from(this.children).filter(Rp.slottedOptionFilter),i=null==t?void 0:t.findIndex((e=>e.hasAttribute("selected")||e.selected||e.value===this.value));this.selectedIndex=-1===i?0:i}setProxyOptions(){this.proxy instanceof HTMLSelectElement&&this.options&&(this.proxy.options.length=0,this.options.forEach((e=>{const t=e.proxy||(e instanceof HTMLOptionElement?e.cloneNode():null);t&&this.proxy.options.add(t)})))}keydownHandler(e){super.keydownHandler(e);const t=e.key||e.key.charCodeAt(0);switch(t){case wu:e.preventDefault(),this.collapsible&&this.typeAheadExpired&&(this.open=!this.open);break;case bu:case yu:e.preventDefault();break;case vu:e.preventDefault(),this.open=!this.open;break;case mu:this.collapsible&&this.open&&(e.preventDefault(),this.open=!1);break;case xu:return this.collapsible&&this.open&&(e.preventDefault(),this.open=!1),!0}return this.open||this.indexWhenOpened===this.selectedIndex||(this.updateValue(!0),this.indexWhenOpened=this.selectedIndex),!(t===uu||t===fu)}connectedCallback(){super.connectedCallback(),this.forcedPosition=!!this.positionAttribute,this.addEventListener("contentchange",this.updateDisplayValue)}disconnectedCallback(){this.removeEventListener("contentchange",this.updateDisplayValue),super.disconnectedCallback()}sizeChanged(e,t){super.sizeChanged(e,t),this.proxy&&(this.proxy.size=t)}updateDisplayValue(){this.collapsible&&vs.notify(this,"displayValue")}}Ms([Os({attribute:"open",mode:"boolean"})],wv.prototype,"open",void 0),Ms([function(e,t,i){return Object.assign({},i,{get:function(){return vs.trackVolatile(),i.get.apply(this)}})}],wv.prototype,"collapsible",null),Ms([ms],wv.prototype,"control",void 0),Ms([Os({attribute:"position"})],wv.prototype,"positionAttribute",void 0),Ms([ms],wv.prototype,"position",void 0),Ms([ms],wv.prototype,"maxHeight",void 0);class xv{}Ms([ms],xv.prototype,"ariaControls",void 0),cu(xv,Vp),cu(wv,nu,xv);class kv extends wv{appearanceChanged(e,t){e!==t&&(this.classList.add(t),this.classList.remove(e))}connectedCallback(){super.connectedCallback(),this.appearance||(this.appearance="outline"),this.listbox&&_d.setValueFor(this.listbox,wd)}}i([Os({mode:"fromView"})],kv.prototype,"appearance",void 0);const Cv=kv.compose({baseName:"select",baseClass:wv,template:(e,t)=>Rr`
    <template
        class="${e=>[e.collapsible&&"collapsible",e.collapsible&&e.open&&"open",e.disabled&&"disabled",e.collapsible&&e.position].filter(Boolean).join(" ")}"
        aria-activedescendant="${e=>e.ariaActiveDescendant}"
        aria-controls="${e=>e.ariaControls}"
        aria-disabled="${e=>e.ariaDisabled}"
        aria-expanded="${e=>e.ariaExpanded}"
        aria-haspopup="${e=>e.collapsible?"listbox":null}"
        aria-multiselectable="${e=>e.ariaMultiSelectable}"
        ?open="${e=>e.open}"
        role="combobox"
        tabindex="${e=>e.disabled?null:"0"}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        @focusin="${(e,t)=>e.focusinHandler(t.event)}"
        @focusout="${(e,t)=>e.focusoutHandler(t.event)}"
        @keydown="${(e,t)=>e.keydownHandler(t.event)}"
        @mousedown="${(e,t)=>e.mousedownHandler(t.event)}"
    >
        ${eu((e=>e.collapsible),Rr`
                <div
                    class="control"
                    part="control"
                    ?disabled="${e=>e.disabled}"
                    ${su("control")}
                >
                    ${au(0,t)}
                    <slot name="button-container">
                        <div class="selected-value" part="selected-value">
                            <slot name="selected-value">${e=>e.displayValue}</slot>
                        </div>
                        <div aria-hidden="true" class="indicator" part="indicator">
                            <slot name="indicator">
                                ${t.indicator||""}
                            </slot>
                        </div>
                    </slot>
                    ${ru(0,t)}
                </div>
            `)}
        <div
            class="listbox"
            id="${e=>e.listboxId}"
            part="listbox"
            role="listbox"
            ?disabled="${e=>e.disabled}"
            ?hidden="${e=>!!e.collapsible&&!e.open}"
            ${su("listbox")}
        >
            <slot
                ${Ru({filter:Rp.slottedOptionFilter,flatten:!0,property:"slottedOptions"})}
            ></slot>
        </div>
    </template>
`,styles:(e,t)=>ig().withBehaviors(Gu("outline",qu(0,0,eg,tg)),Gu("filled",Xp(0,0,Yp,eg).withBehaviors(lh(Jp(0,0,Yp,eg)))),Gu("stealth",Zu(0,0,eg,tg)),lh(ih`
    :host([open]) .listbox {
      background: ${dh.ButtonFace};
      border-color: ${dh.CanvasText};
    }
  `)),indicator:'\n    <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">\n      <path d="M2.15 4.65c.2-.2.5-.2.7 0L6 7.79l3.15-3.14a.5.5 0 11.7.7l-3.5 3.5a.5.5 0 01-.7 0l-3.5-3.5a.5.5 0 010-.7z"/>\n    </svg>\n  '});class $v extends Ln{constructor(){super(...arguments),this.shape="rect"}}Ms([Os],$v.prototype,"fill",void 0),Ms([Os],$v.prototype,"shape",void 0),Ms([Os],$v.prototype,"pattern",void 0),Ms([Os({mode:"boolean"})],$v.prototype,"shimmer",void 0);const Sv=$v.compose({baseName:"skeleton",template:(e,t)=>Rr`
    <template
        class="${e=>"circle"===e.shape?"circle":"rect"}"
        pattern="${e=>e.pattern}"
        ?shimmer="${e=>e.shimmer}"
    >
        ${eu((e=>!0===e.shimmer),Rr`
                <span class="shimmer"></span>
            `)}
        <object type="image/svg+xml" data="${e=>e.pattern}" role="presentation">
            <img class="pattern" src="${e=>e.pattern}" />
        </object>
        <slot></slot>
    </template>
`,styles:(e,t)=>ih`
    ${nh("block")} :host {
      --skeleton-fill-default: ${cc};
      overflow: hidden;
      width: 100%;
      position: relative;
      background-color: var(--skeleton-fill, var(--skeleton-fill-default));
      --skeleton-animation-gradient-default: linear-gradient(
        270deg,
        var(--skeleton-fill, var(--skeleton-fill-default)) 0%,
        ${hc} 51%,
        var(--skeleton-fill, var(--skeleton-fill-default)) 100%
      );
      --skeleton-animation-timing-default: ease-in-out;
    }

    :host(.rect) {
      border-radius: calc(${Ra} * 1px);
    }

    :host(.circle) {
      border-radius: 100%;
      overflow: hidden;
    }

    object {
      position: absolute;
      width: 100%;
      height: auto;
      z-index: 2;
    }

    object img {
      width: 100%;
      height: auto;
    }

    ${nh("block")} span.shimmer {
      position: absolute;
      width: 100%;
      height: 100%;
      background-image: var(--skeleton-animation-gradient, var(--skeleton-animation-gradient-default));
      background-size: 0px 0px / 90% 100%;
      background-repeat: no-repeat;
      background-color: var(--skeleton-animation-fill, ${cc});
      animation: shimmer 2s infinite;
      animation-timing-function: var(--skeleton-animation-timing, var(--skeleton-timing-default));
      animation-direction: normal;
      z-index: 1;
    }

    ::slotted(svg) {
      z-index: 2;
    }

    ::slotted(.pattern) {
      width: 100%;
      height: 100%;
    }

    @keyframes shimmer {
      0% {
        transform: translateX(-100%);
      }
      100% {
        transform: translateX(100%);
      }
    }
  `.withBehaviors(lh(ih`
        :host{
          background-color: ${dh.CanvasText};
        }
      `))});var _v,Iv=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Tv=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},Dv=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(Cv,dg,Kg,Ju,ip,Sv),function(e){e[e.planner=0]="planner",e[e.todo=1]="todo"}(_v||(_v={}));const Pv={BASE_SELF_ASSIGNED:"All Tasks",BUCKETS_SELF_ASSIGNED:"All Tasks",BUCKET_NOT_FOUND:"Folder not found",PLANS_SELF_ASSIGNED:"All groups",PLAN_NOT_FOUND:"Group not found"},Lv={BASE_SELF_ASSIGNED:"Assigned to Me",BUCKETS_SELF_ASSIGNED:"All Tasks",BUCKET_NOT_FOUND:"Bucket not found",PLANS_SELF_ASSIGNED:"All Plans",PLAN_NOT_FOUND:"Plan not found"},Ev={"@odata.type":"#microsoft.graph.plannerAssignment",orderHint:" !"};let Ov=class extends Nt{get res(){switch(this.dataSource){case _v.todo:return Pv;case _v.planner:default:return Lv}}static get styles(){return rv}get strings(){return av}get isNewTaskVisible(){return this._isNewTaskVisible}set isNewTaskVisible(e){this._isNewTaskVisible=e,e||(this._newTaskDueDate=null,this._newTaskName="",this._newTaskGroupId="",this._newTaskContainerId="")}static get requiredScopes(){return[...new Set(["group.read.all","group.readwrite.all","tasks.read","tasks.readwrite",...ts.requiredScopes,...tf.requiredScopes])]}constructor(){super(),this.dataSource=_v.planner,this._isDarkMode=!1,this._me=null,this.onResize=()=>{this.mediaQuery!==this.previousMediaQuery&&(this.previousMediaQuery=this.mediaQuery,this.requestUpdate())},this.onThemeChanged=()=>{this._isDarkMode=mv(this)},this.onAddTaskClick=()=>{var e;const t=this.getPeoplePicker(null),i={};if(t)for(const o of null!==(e=null==t?void 0:t.selectedPeople)&&void 0!==e?e:[])i[o.id]=Ev;!this._newTaskBeingAdded&&this._newTaskName&&(this._currentGroup||this._newTaskGroupId)&&this.addTask(this._newTaskName,this._newTaskDueDate,this._currentGroup?this._currentGroup:this._newTaskGroupId,this._currentFolder?this._currentFolder:this._newTaskFolderId,i)},this.onAddTaskKeyDown=e=>{"Enter"!==e.key&&" "!==e.key||this.onAddTaskClick()},this.newTaskButtonKeydown=e=>{"Enter"===e.key&&(this.isNewTaskVisible=!this.isNewTaskVisible)},this.addNewTaskButtonClick=()=>{this.isNewTaskVisible=!this.isNewTaskVisible},this.handleNewTaskDateChange=e=>{const t=e.target.value;this._newTaskDueDate=t?new Date(t+"T17:00"):null},this.handleSelectedPlan=e=>{var t,i;if(this._newTaskGroupId=e.target.value,this.dataSource===_v.planner){const e=this._groups.filter((e=>e.id===this._newTaskGroupId));this._newTaskContainerId=null!==(i=null===(t=e.pop())||void 0===t?void 0:t.containerId)&&void 0!==i?i:this._newTaskContainerId}},this.newTaskVisible=e=>{"Enter"===e.key&&(this.isNewTaskVisible=!1)},this.handleDateChange=e=>{const t=e.target.value;this._newTaskDueDate=t?new Date(t+"T17:00"):null},this.renderPlannerIcon=e=>Co(ko.Planner,e),this.renderBucketIcon=e=>Co(ko.Milestone,e),this.handlePeopleClick=(e,t)=>{this.togglePeoplePicker(t),e.stopPropagation()},this.handlePeopleKeydown=(e,t)=>{"Enter"!==e.key&&" "!==e.key||(this.togglePeoplePicker(t),e.stopPropagation(),e.preventDefault())},this.handlePeoplePickerKeydown=e=>{"Enter"===e.key&&e.stopPropagation()},this.clearState(),this.previousMediaQuery=this.mediaQuery}connectedCallback(){super.connectedCallback(),window.addEventListener("resize",this.onResize),window.addEventListener("darkmodechanged",this.onThemeChanged),this.onThemeChanged()}disconnectedCallback(){window.removeEventListener("resize",this.onResize),window.removeEventListener("darkmodechanged",this.onThemeChanged),super.disconnectedCallback()}attributeChangedCallback(e,t,i){super.attributeChangedCallback(e,t,i),"data-source"===e&&(this.dataSource===_v.planner?(this._currentGroup=this.initialId,this._currentFolder=this.initialBucketId):this.dataSource===_v.todo&&(this._currentGroup=null,this._currentFolder=this.initialId),this.clearState(),this.requestStateUpdate())}clearState(){this._newTaskFolderId="",this._newTaskGroupId="",this._newTaskDueDate=null,this._newTaskName="",this._newTaskBeingAdded=!1,this._tasks=[],this._folders=[],this._groups=[],this._hiddenTasks=[],this._loadingTasks=[],this._hasDoneInitialLoad=!1,this._inTaskLoad=!1,this._todoDefaultSet=!1}firstUpdated(e){super.firstUpdated(e),this.initialId&&!this._currentGroup&&(this.dataSource===_v.planner?this._currentGroup=this.initialId:this.dataSource===_v.todo&&(this._currentFolder=this.initialId)),this.dataSource===_v.planner&&this.initialBucketId&&!this._currentFolder&&(this._currentFolder=this.initialBucketId)}render(){const e=this._inTaskLoad&&!this._hasDoneInitialLoad?this.renderLoadingTask():null;let t;return this.hideHeader||(t=Je`
        <div class="header">
          ${this.renderPlanOptions()}
        </div>
      `),Je`
      ${t}
      <div class="tasks">
        ${this._isNewTaskVisible?this.renderNewTask():null} ${e}
        ${Xo(this._tasks,(e=>e.id),(e=>this.renderTask(e)))}
      </div>
    `}loadState(){return Dv(this,void 0,void 0,(function*(){const e=this.getTaskSource();if(!e)return;const t=te.globalProvider;if(t&&t.state===Q.SignedIn){if(this._inTaskLoad=!0,!this._me){const e=t.graph.forComponent(this);this._me=yield eo(e)}this.groupId&&this.dataSource===_v.planner?yield this._loadTasksForGroup(e):this.targetId?this.dataSource===_v.todo?yield this._loadTargetTodoTasks(e):yield this._loadTargetPlannerTasks(e):yield this._loadAllTasks(e),this._tasks=this._tasks.filter((e=>this.isTaskInSelectedGroupFilter(e))).filter((e=>this.isTaskInSelectedFolderFilter(e))).filter((e=>!this._hiddenTasks.includes(e.id))),this.taskFilter&&(this._tasks=this._tasks.filter((e=>this.taskFilter(e._raw)))),this._inTaskLoad=!1,this._hasDoneInitialLoad=!0}}))}_loadTargetTodoTasks(e){return Dv(this,void 0,void 0,(function*(){const t=yield e.getTaskGroups(),i=(yield Promise.all(t.map((t=>e.getTaskFoldersForTaskGroup(t.id))))).reduce(((e,t)=>[...e,...t]),[]),o=(yield Promise.all(i.map((t=>e.getTasksForTaskFolder(t.id,t.parentId))))).reduce(((e,t)=>[...e,...t]),[]);this._tasks=o,this._folders=i,this._groups=t,this._currentGroup=null}))}_loadTargetPlannerTasks(e){return Dv(this,void 0,void 0,(function*(){const t=yield e.getTaskGroup(this.targetId);let i=yield e.getTaskFoldersForTaskGroup(t.id);this.targetBucketId&&(i=i.filter((e=>e.id===this.targetBucketId)));const o=(yield Promise.all(i.map((t=>e.getTasksForTaskFolder(t.id,t.parentId))))).reduce(((e,t)=>[...e,...t]),[]);this._tasks=o,this._folders=i,this._groups=[t]}))}_loadAllTasks(e){return Dv(this,void 0,void 0,(function*(){const t=yield e.getTaskGroups(),i=(yield Promise.all(t.map((t=>e.getTaskFoldersForTaskGroup(t.id))))).reduce(((e,t)=>[...e,...t]),[]);if(!this.initialId&&this.dataSource===_v.todo&&!this._todoDefaultSet){this._todoDefaultSet=!0;const e=i.find((e=>e._raw.isDefaultFolder));e&&(this._currentFolder=e.id)}const o=(yield Promise.all(i.map((t=>e.getTasksForTaskFolder(t.id,t.parentId))))).reduce(((e,t)=>[...e,...t]),[]);this._tasks=o,this._folders=i,this._groups=t}))}_loadTasksForGroup(e){return Dv(this,void 0,void 0,(function*(){const t=yield e.getTaskGroupsForGroup(this.groupId),i=(yield Promise.all(t.map((t=>e.getTaskFoldersForTaskGroup(t.id))))).reduce(((e,t)=>[...e,...t]),[]),o=(yield Promise.all(i.map((t=>e.getTasksForTaskFolder(t.id,t.parentId))))).reduce(((e,t)=>[...e,...t]),[]);this._tasks=o,this._folders=i,this._groups=t}))}addTask(e,t,i,o,s={}){return Dv(this,void 0,void 0,(function*(){const n=this.getTaskSource();if(!n)return;const r={assignments:s,dueDate:t,immediateParentId:o,name:e,topParentId:i};this._newTaskBeingAdded=!0,r._raw=yield n.addTask(r),this.fireCustomEvent("taskAdded",r),yield this.requestStateUpdate(),this._newTaskBeingAdded=!1,this.isNewTaskVisible=!1}))}completeTask(e){return Dv(this,void 0,void 0,(function*(){const t=this.getTaskSource();t&&(this._loadingTasks=[...this._loadingTasks,e.id],yield t.setTaskComplete(e),this.fireCustomEvent("taskChanged",e),yield this.requestStateUpdate(),this._loadingTasks=this._loadingTasks.filter((t=>t!==e.id)))}))}uncompleteTask(e){return Dv(this,void 0,void 0,(function*(){const t=this.getTaskSource();t&&(this._loadingTasks=[...this._loadingTasks,e.id],yield t.setTaskIncomplete(e),this.fireCustomEvent("taskChanged",e),yield this.requestStateUpdate(),this._loadingTasks=this._loadingTasks.filter((t=>t!==e.id)))}))}removeTask(e){return Dv(this,void 0,void 0,(function*(){const t=this.getTaskSource();t&&(this._hiddenTasks=[...this._hiddenTasks,e.id],yield t.removeTask(e),this.fireCustomEvent("taskRemoved",e),yield this.requestStateUpdate(),this._hiddenTasks=this._hiddenTasks.filter((t=>t!==e.id)))}))}assignPeople(e,t=[]){return Dv(this,void 0,void 0,(function*(){const i=this.getTaskSource();if(!i)return;let o=[];e&&e.assignments&&(o=Object.keys(e.assignments).sort());const s=t.map((e=>e.id));if(s.length===o.length&&s.sort().every(((e,t)=>e===o[t])))return;const n={};for(const e of o)s.includes(e)?n[e]=Ev:n[e]=null;s.forEach((e=>{o.includes(e)||(n[e]=Ev)})),e&&(yield i.assignPeopleToTask(e,n),yield this.requestStateUpdate(),this._loadingTasks=this._loadingTasks.filter((t=>t!==e.id)))}))}renderPlanOptions(){var e;const t=te.globalProvider;if(!t||t.state!==Q.SignedIn)return null;if(this._inTaskLoad&&!this._hasDoneInitialLoad)return Je`<span class="loading-header"></span>`;const i=this.readOnly||this._isNewTaskVisible?null:Je`
          <fluent-button
            appearance="accent"
            class="new-task-button"
            @keydown=${this.newTaskButtonKeydown}
            @click=${()=>this.isNewTaskVisible=!this.isNewTaskVisible}>
              <span slot="start">${Co(ko.Add,"currentColor")}</span>
              ${this.strings.addTaskButtonSubtitle}
          </fluent-button>
        `;if(this.dataSource===_v.planner){const t=this._groups.find((e=>e.id===this._currentGroup))||{title:this.res.BASE_SELF_ASSIGNED},o={[this.res.BASE_SELF_ASSIGNED]:()=>{this._currentGroup=null,this._currentFolder=null}};for(const e of this._groups)o[e.title]=()=>{this._currentGroup=e.id,this._currentFolder=null};const s=pi`
        <mgt-arrow-options
          class="arrow-options"
          .options="${o}"
          .value="${t.title}"></mgt-arrow-options>`,n=this._currentGroup?Co(ko.ChevronRight):null,r=this._folders.find((e=>e.id===this._currentFolder))||{name:this.res.BUCKETS_SELF_ASSIGNED},a={[this.res.BUCKETS_SELF_ASSIGNED]:()=>{this._currentFolder=null}};for(const e of this._folders.filter((e=>e.parentId===this._currentGroup)))a[e.name]=()=>{this._currentFolder=e.id};const l=this.targetBucketId?Je`
            <span class="plan-title">
              ${(null===(e=this._folders[0])||void 0===e?void 0:e.name)||""}
            </span>`:pi`
            <mgt-arrow-options class="arrow-options" .options="${a}" .value="${r.name}"></mgt-arrow-options>
          `;return Je`
        <div class="Title">
          ${s} ${n} ${this._currentGroup?l:null}
        </div>
        ${i}
      `}{const e=this._folders.find((e=>e.id===this.targetId))||{name:this.res.BUCKETS_SELF_ASSIGNED},t=this._folders.find((e=>e.id===this._currentFolder))||{name:this.res.BUCKETS_SELF_ASSIGNED},o={};for(const e of this._folders)o[e.name]=()=>{this._currentFolder=e.id};o[this.res.BUCKETS_SELF_ASSIGNED]=()=>{this._currentFolder=null};const s=this.targetId?Je`
            <span class="plan-title">
              ${e.name}
            </span>
          `:pi`
            <mgt-arrow-options class="arrow-options" .value="${t.name}" .options="${o}"></mgt-arrow-options>
          `;return Je`
        <span class="title">
          ${s}
        </span>
        ${i}
      `}}renderNewTask(){const e="var(--neutral-foreground-hint)",t=Je`
      <fluent-text-field
        autocomplete="off"
        placeholder=${this.strings.newTaskPlaceholder}
        .value="${this._newTaskName}"
        class="new-task"
        aria-label=${this.strings.newTaskPlaceholder}
        @input=${e=>this._newTaskName=e.target.value}>
      </fluent-text-field>`;this._groups.length>0&&!this._newTaskGroupId&&(this._newTaskGroupId=this._groups[0].id);const i=Je`
      ${Xo(this._groups,(e=>e.id),(e=>Je`<fluent-option value="${e.id}">${e.title}</fluent-option>`))}`,o=this.dataSource===_v.todo?null:this._currentGroup?Je`
          <span class="new-task-group">
            ${this.renderPlannerIcon(e)}
            <span>${this.getPlanTitle(this._currentGroup)}</span>
          </span>`:Je`
            <fluent-select>
              <span slot="start">${this.renderPlannerIcon(e)}</span>
              ${this._groups.length>0?i:Je`<fluent-option selected>No groups found</fluent-option>`}
            </fluent-select>`,s=this._folders.filter((e=>this._currentGroup&&e.parentId===this._currentGroup||!this._currentGroup&&e.parentId===this._newTaskGroupId));s.length>0&&!this._newTaskFolderId&&(this._newTaskFolderId=s[0].id);const n=Je`
      ${Xo(s,(e=>e.id),(e=>Je`<fluent-option value="${e.id}">${e.name}</fluent-option>`))}`,r=this._currentFolder?Je`
          <span class="new-task-bucket">
            ${this.renderBucketIcon(e)}
            <span>${this.getFolderName(this._currentFolder)}</span>
          </span>
        `:Je`
         <fluent-select>
          <span slot="start">${this.renderBucketIcon(e)}</span>
          ${s.length>0?n:Je`<fluent-option selected>No folders found</fluent-option>`}
        </fluent-select>`,a={dark:this._isDarkMode,"new-task":!0},l=Je`
      <fluent-text-field
        autocomplete="off"
        type="date"
        class=${ki(a)}
        aria-label="${this.strings.addTaskDate}"
        .value="${this.dateToInputValue(this._newTaskDueDate)}"
        @change=${this.handleDateChange}>
      </fluent-text-field>`,d=this.dataSource===_v.todo?null:this.renderAssignedPeople(null),c=this._newTaskBeingAdded?Je`<div class="task-add-button-container"></div>`:Je`
          <fluent-button
            class="add-task"
            @click=${this.onAddTaskClick}
            @keydown=${this.onAddTaskKeyDown}
            appearance="neutral">
              ${this.strings.addTaskButtonSubtitle}
          </fluent-button>
          <fluent-button
            class="cancel-task"
            @click=${()=>this.isNewTaskVisible=!1}
            @keydown=${this.newTaskVisible}
            appearance="neutral">
              ${this.strings.cancelNewTaskSubtitle}
          </fluent-button>`;return Je`
    <div
      class=${ki({task:!0,"new-task":!0})}>
      <div class="task-details-container">
        <div class="top add-new-task">
          <div class="check-and-title">
            ${t}
            <div class="task-content">
              <div class="task-group">${o}</div>
              <div class="task-bucket">${r}</div>
              ${d}
              <div class="task-due">${l}</div>
            </div>
          </div>
          <div class="task-options new-task-action-buttons">${c}</div>
        </div>
      </div>
    </div>
  `}togglePeoplePicker(e){const t=this.getPeoplePicker(e),i=this.getMgtPeople(e),o=this.getFlyout(e);t&&i&&o&&(o.isOpen?o.close():(t.selectedPeople=i.people,o.open(),setTimeout((()=>t.focus()),100)))}updateAssignedPeople(e){const t=this.getPeoplePicker(e),i=this.getMgtPeople(e);t&&t.selectedPeople!==i.people&&(i.people=t.selectedPeople,this.assignPeople(e,t.selectedPeople))}getPeoplePicker(e){const t=e?e.id:"new-task";return this.renderRoot.querySelector(`.picker-${t}`)}getMgtPeople(e){const t=e?e.id:"new-task";return this.renderRoot.querySelector(`.people-${t}`)}getFlyout(e){const t=e?e.id:"new-task";return this.renderRoot.querySelector(`.flyout-${t}`)}renderTask(e){const{name:t="Task",completed:i=!1,dueDate:o}=e,s=this._currentGroup?null:this.getPlanTitle(e.topParentId),n=this._currentFolder?null:this.getFolderName(e.immediateParentId),r={task:Object.assign(Object.assign({},e._raw),{groupTitle:s,folderTitle:n})},a=this.renderTemplate("task",r,e.id);if(a)return a;let l=this.renderTemplate("task-details",r,`task-details-${e.id}`);if(!l){const t="var(--neutral-foreground-hint)",i=this.dataSource===_v.todo||this._currentGroup?null:Je`
              <div class="task-group">
                <span class="task-icon">${this.renderPlannerIcon(t)}</span>
                <span class="task-icon-text">${this.getPlanTitle(e.topParentId)}</span>
              </div>
            `,s=this._currentFolder?null:Je`
            <div class="task-bucket">
              <span class="task-icon">${this.renderBucketIcon(t)}</span>
              <span class="task-icon-text">${this.getFolderName(e.immediateParentId)}</span>
            </div>
          `,n=o?Je`
            <div class="task-due">
              <span class="task-icon-text">${this.strings.due}${(e=>{const t=e.getMonth(),i=e.getDate();return`${(e=>{switch(e){case 0:return"January";case 1:return"February";case 2:return"March";case 3:return"April";case 4:return"May";case 5:return"June";case 6:return"July";case 7:return"August";case 8:return"September";case 9:return"October";case 10:return"November";case 11:return"December";default:return"Month"}})(t)} ${i}`})(o)}</span>
            </div>
          `:null,r=this.dataSource===_v.todo?null:this.renderAssignedPeople(e);l=Je`${i} ${s} ${r} ${n}`}const d=this.readOnly||this.hideOptions?null:pi`
            <mgt-dot-options
              class="dot-options"
              .options="${{[this.strings.removeTaskSubtitle]:()=>this.removeTask(e)}}"
            ></mgt-dot-options>`,c=ki({task:!0,complete:i,incomplete:!i,"read-only":this.readOnly});return Je`
      <div
        data-id="task-${e.id}"
        class=${c}
        @click=${()=>this.handleTaskClick(e)}>
        <div class="task-details-container">
          <div class="top">
            <div class="check-and-title">
              <fluent-checkbox
                @click=${t=>this.checkTask(t,e)}
                @keydown=${t=>this.handleTaskCheckKeyDown(t,e)}
                ?checked=${i}>
                  ${t}
              </fluent-checkbox>
            </div>
            <div class="task-options">${d}</div>
          </div>
          <div class="bottom">${l}</div>
        </div>
      </div>
    `}handleTaskCheckKeyDown(e,t){return Dv(this,void 0,void 0,(function*(){"Enter"===e.key&&(this.readOnly||(t.completed?yield this.uncompleteTask(t):yield this.completeTask(t),e.stopPropagation(),e.preventDefault()))}))}checkTask(e,t){return Dv(this,void 0,void 0,(function*(){if(!this.readOnly){const i=this.shadowRoot.querySelector(`[data-id='task-${t.id}'`);i&&i.classList.add("updating"),t.completed?yield this.uncompleteTask(t):yield this.completeTask(t),i&&i.classList.remove("updating"),e.stopPropagation(),e.preventDefault()}}))}renderAssignedPeople(e){var t;let i;const o={"new-task-assignee":null===e,"task-assignee":null!==e,"task-detail":null!==e},s=e?e.id:"new-task";o[`flyout-${s}`]=!0;const n=e?Object.keys(e.assignments).map((e=>e)):[];if(!this.newTaskVisible){const o=null==e?void 0:e._raw,s=null==o?void 0:o.planId;s&&(i=null===(t=this._groups.filter((e=>e.id===s)).pop())||void 0===t?void 0:t.containerId)}const r=this.isNewTaskVisible?this._newTaskContainerId:i,a=pi`
      <mgt-people
        class="people people-${s}"
        .userIds=${n}
        .personCardInteraction=${Do.none}
        @click=${t=>this.handlePeopleClick(t,e)}
        @keydown=${t=>this.handlePeopleKeydown(t,e)}
      >
        <template data-type="no-data">
          <fluent-button>
            <span style="display:flex;place-content:start;gap:4px;padding-inline-start:4px">
              <svg width="20" height="20" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg" class="svg" fill="currentColor">
                <path d="M9 2a4 4 0 100 8 4 4 0 000-8zM6 6a3 3 0 116 0 3 3 0 01-6 0z"></path>
                <path d="M4 11a2 2 0 00-2 2c0 1.7.83 2.97 2.13 3.8A9.14 9.14 0 009 18c.41 0 .82-.02 1.21-.06A5.5 5.5 0 019.6 17 12 12 0 019 17a8.16 8.16 0 01-4.33-1.05A3.36 3.36 0 013 13a1 1 0 011-1h5.6c.18-.36.4-.7.66-1H4z"></path>
                <path d="M14.5 19a4.5 4.5 0 100-9 4.5 4.5 0 000 9zm0-7c.28 0 .5.22.5.5V14h1.5a.5.5 0 010 1H15v1.5a.5.5 0 01-1 0V15h-1.5a.5.5 0 010-1H14v-1.5c0-.28.22-.5.5-.5z"></path>
              </svg> Assign</span>
            </fluent-button>
        </template>
      </mgt-people>`,l=pi`
      <mgt-people-picker
        class="people-picker picker-${s}"
        .groupId=${Ao(r)}
        @keydown=${this.handlePeoplePickerKeydown}>
      ></mgt-people-picker>`;return pi`
      <mgt-flyout
        light-dismiss
        class=${ki(o)}
        @closed=${()=>this.updateAssignedPeople(e)}
      >
        <div slot="anchor">${a}</div>
        <div slot="flyout" part="picker" class="picker">${l}</div>
      </mgt-flyout>
    `}handleTaskClick(e){e&&this.fireCustomEvent("taskClick",e)}renderLoadingTask(){return Je`
      <div class="header">
        <div class="title">
          <fluent-skeleton shimmer class="shimmer" shape="rect"></fluent-skeleton>
        </div>
        <div class="new-task-button">
          <fluent-skeleton shimmer class="shimmer" shape="rect"></fluent-skeleton>
        </div>
      </div>
      <div class="tasks">
        <div class="task incomplete">
          <div class="task-details-container">
            <div class="top">
              <div class="check-and-title shimmer">
                <fluent-skeleton shimmer class="checkbox" shape="circle"></fluent-skeleton>
                <fluent-skeleton shimmer class="title" shape="rect"></fluent-skeleton>
              </div>
              <div class="task-options">
                <fluent-skeleton shimmer class="options" shape="rect"></fluent-skeleton>
              </div>
            </div>
            <div class="bottom">
              <div class="task-group">
                <div class="task-icon">
                  <fluent-skeleton shimmer class="shimmer icon" shape="rect"></fluent-skeleton>
                </div>
                <div class="task-icon-text">
                  <fluent-skeleton shimmer class="shimmer text" shape="rect"></fluent-skeleton>
                </div>
              </div>
              <div class="task-bucket">
                <div class="task-icon">
                  <fluent-skeleton shimmer class="shimmer icon" shape="rect"></fluent-skeleton>
                </div>
                <div class="task-icon-text">
                  <fluent-skeleton shimmer class="shimmer text" shape="rect"></fluent-skeleton>
                </div>
              </div>
              <div class="task-details shimmer">
                <fluent-skeleton shimmer class="shimmer icon" shape="circle"></fluent-skeleton>
                <fluent-skeleton shimmer class="shimmer icon" shape="circle"></fluent-skeleton>
                <fluent-skeleton shimmer class="shimmer icon" shape="circle"></fluent-skeleton>
              </div>
              <div class="task-due">
                <div class="task-icon-text">
                  <fluent-skeleton shimmer class="shimmer text" shape="rect"></fluent-skeleton>
                </div>
              </div>
              </div>
          </div>
        </div>
      </div>
    `}getTaskSource(){const e=te.globalProvider;if(!e||e.state!==Q.SignedIn)return null;const t=e.graph.forComponent(this);return this.dataSource===_v.planner?new fv(t):this.dataSource===_v.todo?new vv(t):null}getPlanTitle(e){return e?e===this.res.PLANS_SELF_ASSIGNED?this.res.PLANS_SELF_ASSIGNED:(this._groups.find((t=>t.id===e))||{title:this.res.PLAN_NOT_FOUND}).title:this.res.BASE_SELF_ASSIGNED}getFolderName(e){return e?(this._folders.find((t=>t.id===e))||{name:this.res.BUCKET_NOT_FOUND}).name:this.res.BUCKETS_SELF_ASSIGNED}isTaskInSelectedGroupFilter(e){var t;return!this._currentGroup||e.topParentId===this._currentGroup||!this._currentGroup&&this.getTaskSource().isAssignedToMe(e,null===(t=this._me)||void 0===t?void 0:t.id)}isTaskInSelectedFolderFilter(e){return e.immediateParentId===this._currentFolder||!this._currentFolder}dateToInputValue(e){return e?new Date(e.getTime()-6e4*e.getTimezoneOffset()).toISOString().split("T")[0]:null}};Iv([Ct({attribute:"read-only",type:Boolean}),Tv("design:type",Boolean)],Ov.prototype,"readOnly",void 0),Iv([Ct({attribute:"data-source",converter:(e,t)=>(e=e.toLowerCase(),_v[e]||_v.planner)}),Tv("design:type",Number)],Ov.prototype,"dataSource",void 0),Iv([Ct({attribute:"target-id",type:String}),Tv("design:type",String)],Ov.prototype,"targetId",void 0),Iv([Ct({attribute:"target-bucket-id",type:String}),Tv("design:type",String)],Ov.prototype,"targetBucketId",void 0),Iv([Ct({attribute:"initial-id",type:String}),Tv("design:type",String)],Ov.prototype,"initialId",void 0),Iv([Ct({attribute:"initial-bucket-id",type:String}),Tv("design:type",String)],Ov.prototype,"initialBucketId",void 0),Iv([Ct({attribute:"hide-header",type:Boolean}),Tv("design:type",Boolean)],Ov.prototype,"hideHeader",void 0),Iv([Ct({attribute:"hide-options",type:Boolean}),Tv("design:type",Boolean)],Ov.prototype,"hideOptions",void 0),Iv([Ct({attribute:"group-id",type:String}),Tv("design:type",String)],Ov.prototype,"groupId",void 0),Iv([Ct(),Tv("design:type",Boolean)],Ov.prototype,"_isNewTaskVisible",void 0),Iv([Ct(),Tv("design:type",Boolean)],Ov.prototype,"_newTaskBeingAdded",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_newTaskName",void 0),Iv([Ct(),Tv("design:type",Date)],Ov.prototype,"_newTaskDueDate",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_newTaskGroupId",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_newTaskFolderId",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_newTaskContainerId",void 0),Iv([Ct(),Tv("design:type",Array)],Ov.prototype,"_groups",void 0),Iv([Ct(),Tv("design:type",Array)],Ov.prototype,"_folders",void 0),Iv([Ct(),Tv("design:type",Array)],Ov.prototype,"_tasks",void 0),Iv([Ct(),Tv("design:type",Array)],Ov.prototype,"_hiddenTasks",void 0),Iv([Ct(),Tv("design:type",Array)],Ov.prototype,"_loadingTasks",void 0),Iv([Ct(),Tv("design:type",Boolean)],Ov.prototype,"_inTaskLoad",void 0),Iv([Ct(),Tv("design:type",Boolean)],Ov.prototype,"_hasDoneInitialLoad",void 0),Iv([Ct(),Tv("design:type",Boolean)],Ov.prototype,"_todoDefaultSet",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_currentGroup",void 0),Iv([Ct(),Tv("design:type",String)],Ov.prototype,"_currentFolder",void 0),Iv([$t(),Tv("design:type",Object)],Ov.prototype,"_isDarkMode",void 0),Iv([$t(),Tv("design:type",Object)],Ov.prototype,"_me",void 0),Ov=Iv([gi("tasks"),Tv("design:paramtypes",[])],Ov);const Fv=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host .container{display:flex;flex-direction:column;position:relative}:host .dropdown{display:none;position:absolute;z-index:1000;top:34px}:host .dropdown.visible{display:flex}:host .dropdown .team-photo{width:24px;position:inherit;border-radius:50%;margin:0 6px}:host .dropdown .team-start-slot{width:max-content}:host .dropdown .team-parent-name{width:auto}:host .loading-text,:host .search-error-text{font-style:normal;font-weight:400;font-size:14px;line-height:20px}:host .message-parent{display:flex;flex-direction:row;gap:5px;padding:5px}:host .message-parent .loading-text{margin:auto}:host fluent-card{background:var(--channel-picker-dropdown-background-color,var(--fill-color));padding:2px;--card-height:auto;--width:var(--card-width)}:host fluent-text-field{width:100%}:host fluent-text-field::part(root){background:padding-box linear-gradient(var(--channel-picker-input-background-color,var(--neutral-fill-input-rest)),var(--channel-picker-input-background-color,var(--neutral-fill-input-rest))),border-box var(--channel-picker-input-border-color,var(--neutral-stroke-input-rest))}:host fluent-text-field::part(root):hover{background:padding-box linear-gradient(var(--channel-picker-input-background-color-hover,var(--neutral-fill-input-hover)),var(--channel-picker-input-background-color-hover,var(--neutral-fill-input-hover))),border-box var(--channel-picker-input-hover-border-color,var(--neutral-stroke-input-hover))}:host fluent-text-field::part(root):focus,:host fluent-text-field::part(root):focus-within{background:padding-box linear-gradient(var(--channel-picker-input-background-color-focus,var(--neutral-fill-input-focus)),var(--channel-picker-input-background-color-focus,var(--neutral-fill-input-focus))),border-box var(--channel-picker-input-focus-border-color,var(--neutral-stroke-input-focus))}:host fluent-text-field::part(control){word-spacing:inherit;text-indent:inherit;letter-spacing:inherit}:host fluent-text-field::part(control)::placeholder{color:var(--channel-picker-input-placeholder-text-color,var(--input-placeholder-rest))}:host fluent-text-field::part(control):hover::placeholder{color:var(--channel-picker-input-placeholder-text-color-hover,var(--input-placeholder-hover))}:host fluent-text-field::part(control):focus-within::placeholder,:host fluent-text-field::part(control):focus::placeholder{color:var(--channel-picker-input-placeholder-text-color-focus,var(--input-placeholder-filled))}:host fluent-text-field .search-icon svg path{fill:var(--channel-picker-search-icon-color,currentColor)}:host fluent-text-field .down-chevron{height:auto;min-width:auto}:host fluent-text-field .down-chevron svg path{fill:var(--channel-picker-down-chevron-color,currentColor)}:host fluent-text-field .up-chevron{height:auto;min-width:auto}:host fluent-text-field .up-chevron svg path{fill:var(--channel-picker-up-chevron-color,currentColor)}:host fluent-text-field .close-icon{height:auto;min-width:auto}:host fluent-text-field .close-icon svg path{fill:var(--channel-picker-close-icon-color,currentColor)}:host fluent-tree-view{min-width:100%;--tree-item-nested-width:2em}:host fluent-tree-item{width:100%;--tree-item-nested-width:2em}:host fluent-tree-item:focus-visible{outline:0}:host fluent-tree-item::part(expand-collapse-button){background:0 0}:host fluent-tree-item::part(content-region),:host fluent-tree-item::part(positioning-region){color:var(--channel-picker-dropdown-item-text-color,currentColor);background:var(--channel-picker-dropdown-background-color,transparent);border:calc(var(--stroke-width) * 2px) solid transparent;height:auto}:host fluent-tree-item::part(content-region):hover,:host fluent-tree-item::part(positioning-region):hover{background:var(--channel-picker-dropdown-item-background-color-hover,var(--neutral-fill-stealth-hover))}:host fluent-tree-item::part(content-region):hover::part(expand-collapse-button),:host fluent-tree-item::part(positioning-region):hover::part(expand-collapse-button){background:var(--channel-picker-dropdown-item-background-color-hover,var(--neutral-fill-stealth-hover))}:host fluent-tree-item fluent-tree-item::part(content-region){height:auto}:host fluent-breadcrumb-item{color:var(--channel-picker-dropdown-item-text-color-selected,var(--neutral-foreground-rest))}:host fluent-breadcrumb-item .team-parent-name{font-weight:700}:host fluent-breadcrumb-item .team-photo{width:19px;position:inherit;border-radius:50%}:host fluent-breadcrumb-item .arrow{margin-left:8px;margin-right:8px}:host fluent-breadcrumb-item .arrow svg{stroke:var(--channel-picker-arrow-fill,var(--neutral-foreground-rest))}[dir=rtl] :host{--direction:rtl}[dir=rtl] .dropdown{text-align:right}[dir=rtl] .arrow{transform:scaleX(-1);filter:fliph;filter:FlipH;margin-right:0;margin-left:5px}[dir=rtl] .selected-team{padding-left:10px}[dir=rtl] .message-parent .loading-text{right:auto;left:10px;padding-right:8px;text-align:right}@media (forced-colors:active) and (prefers-color-scheme:dark){:host fluent-text-field svg{stroke:#fff!important}}@media (forced-colors:active) and (prefers-color-scheme:light){:host fluent-text-field svg{stroke:#000!important}}
`];var Av=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const Rv={inputPlaceholderText:"Select a channel",noResultsFound:"We didn't find any matches.",loadingMessage:"Loading...",photoFor:"Teams photo for",teamsChannels:"Teams and channels results",closeButtonAriaLabel:"remove the selected channel"};class Vv extends Ln{constructor(){super(...arguments),this.handleUnsupportedDelegatesFocus=()=>{var e;window.ShadowRoot&&!window.ShadowRoot.prototype.hasOwnProperty("delegatesFocus")&&(null===(e=this.$fastController.definition.shadowOptions)||void 0===e?void 0:e.delegatesFocus)&&(this.focus=()=>{var e;null===(e=this.control)||void 0===e||e.focus()})}}connectedCallback(){super.connectedCallback(),this.handleUnsupportedDelegatesFocus()}}Ms([Os],Vv.prototype,"download",void 0),Ms([Os],Vv.prototype,"href",void 0),Ms([Os],Vv.prototype,"hreflang",void 0),Ms([Os],Vv.prototype,"ping",void 0),Ms([Os],Vv.prototype,"referrerpolicy",void 0),Ms([Os],Vv.prototype,"rel",void 0),Ms([Os],Vv.prototype,"target",void 0),Ms([Os],Vv.prototype,"type",void 0),Ms([ms],Vv.prototype,"defaultSlottedContent",void 0);class Mv{}Ms([Os({attribute:"aria-expanded"})],Mv.prototype,"ariaExpanded",void 0),cu(Mv,iu),cu(Vv,nu,Mv);class zv extends Vv{constructor(){super(...arguments),this.separator=!0}}Ms([ms],zv.prototype,"separator",void 0),cu(zv,nu,Mv);class Nv extends Ln{slottedBreadcrumbItemsChanged(){if(this.$fastController.isConnected){if(void 0===this.slottedBreadcrumbItems||0===this.slottedBreadcrumbItems.length)return;const e=this.slottedBreadcrumbItems[this.slottedBreadcrumbItems.length-1];this.slottedBreadcrumbItems.forEach((t=>{const i=t===e;this.setItemSeparator(t,i),this.setAriaCurrent(t,i)}))}}setItemSeparator(e,t){e instanceof zv&&(e.separator=!t)}findChildWithHref(e){var t,i;return e.childElementCount>0?e.querySelector("a[href]"):(null===(t=e.shadowRoot)||void 0===t?void 0:t.childElementCount)?null===(i=e.shadowRoot)||void 0===i?void 0:i.querySelector("a[href]"):null}setAriaCurrent(e,t){const i=this.findChildWithHref(e);null===i&&e.hasAttribute("href")&&e instanceof zv?t?e.setAttribute("aria-current","page"):e.removeAttribute("aria-current"):null!==i&&(t?i.setAttribute("aria-current","page"):i.removeAttribute("aria-current"))}}Ms([ms],Nv.prototype,"slottedBreadcrumbItems",void 0);const Uv=Nv.compose({baseName:"breadcrumb",template:(e,t)=>Rr`
    <template role="navigation">
        <div role="list" class="list" part="list">
            <slot
                ${Ru({property:"slottedBreadcrumbItems",filter:Ou()})}
            ></slot>
        </div>
    </template>
`,styles:(e,t)=>ih`
  ${nh("inline-block")} :host {
    box-sizing: border-box;
    ${Bu};
  }

  .list {
    display: flex;
  }
`}),Bv=zv.compose({baseName:"breadcrumb-item",template:(e,t)=>Rr`
    <div role="listitem" class="listitem" part="listitem">
        ${eu((e=>e.href&&e.href.length>0),Rr`
                ${((e,t)=>Rr`
    <a
        class="control"
        part="control"
        download="${e=>e.download}"
        href="${e=>e.href}"
        hreflang="${e=>e.hreflang}"
        ping="${e=>e.ping}"
        referrerpolicy="${e=>e.referrerpolicy}"
        rel="${e=>e.rel}"
        target="${e=>e.target}"
        type="${e=>e.type}"
        aria-atomic="${e=>e.ariaAtomic}"
        aria-busy="${e=>e.ariaBusy}"
        aria-controls="${e=>e.ariaControls}"
        aria-current="${e=>e.ariaCurrent}"
        aria-describedby="${e=>e.ariaDescribedby}"
        aria-details="${e=>e.ariaDetails}"
        aria-disabled="${e=>e.ariaDisabled}"
        aria-errormessage="${e=>e.ariaErrormessage}"
        aria-expanded="${e=>e.ariaExpanded}"
        aria-flowto="${e=>e.ariaFlowto}"
        aria-haspopup="${e=>e.ariaHaspopup}"
        aria-hidden="${e=>e.ariaHidden}"
        aria-invalid="${e=>e.ariaInvalid}"
        aria-keyshortcuts="${e=>e.ariaKeyshortcuts}"
        aria-label="${e=>e.ariaLabel}"
        aria-labelledby="${e=>e.ariaLabelledby}"
        aria-live="${e=>e.ariaLive}"
        aria-owns="${e=>e.ariaOwns}"
        aria-relevant="${e=>e.ariaRelevant}"
        aria-roledescription="${e=>e.ariaRoledescription}"
        ${su("control")}
    >
        ${au(0,t)}
        <span class="content" part="content">
            <slot ${Ru("defaultSlottedContent")}></slot>
        </span>
        ${ru(0,t)}
    </a>
`)(0,t)}
            `)}
        ${eu((e=>!e.href),Rr`
                ${au(0,t)}
                <slot></slot>
                ${ru(0,t)}
            `)}
        ${eu((e=>e.separator),Rr`
                <span class="separator" part="separator" aria-hidden="true">
                    <slot name="separator">${t.separator||""}</slot>
                </span>
            `)}
    </div>
`,styles:(e,t)=>ih`
    ${nh("inline-flex")} :host {
      background: transparent;
      color: ${xc};
      fill: currentcolor;
      box-sizing: border-box;
      ${Bu};
      min-width: calc(${Uu} * 1px);
      border-radius: calc(${Ra} * 1px);
    }

    .listitem {
      display: flex;
      align-items: center;
      border-radius: inherit;
    }

    .control {
      position: relative;
      align-items: center;
      box-sizing: border-box;
      color: inherit;
      fill: inherit;
      cursor: pointer;
      display: flex;
      outline: none;
      text-decoration: none;
      white-space: nowrap;
      border-radius: inherit;
    }

    .control:hover {
      color: ${kc};
    }

    .control:active {
      color: ${Cc};
    }

    .control:${Nu} {
      ${ju}
    }

    :host(:not([href])),
    :host([aria-current]) .control {
      color: ${xc};
      fill: currentcolor;
      cursor: default;
    }

    .start {
      display: flex;
      margin-inline-end: 6px;
    }

    .end {
      display: flex;
      margin-inline-start: 6px;
    }

    .separator {
      display: flex;
    }
  `.withBehaviors(lh(ih`
        :host(:not([href])),
        .start,
        .end,
        .separator {
          background: ${dh.ButtonFace};
          color: ${dh.ButtonText};
          fill: currentcolor;
        }
        .separator {
          fill: ${dh.ButtonText};
        }
        :host([href]) {
          forced-color-adjust: none;
          background: ${dh.ButtonFace};
          color: ${dh.LinkText};
        }
        :host([href]) .control:hover {
          background: ${dh.LinkText};
          color: ${dh.HighlightText};
          fill: currentcolor;
        }
        .control:${Nu} {
          outline-color: ${dh.LinkText};
        }
      `)),shadowOptions:{delegatesFocus:!0},separator:'\n    <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">\n      <path d="M4.65 2.15a.5.5 0 000 .7L7.79 6 4.65 9.15a.5.5 0 10.7.7l3.5-3.5a.5.5 0 000-.7l-3.5-3.5a.5.5 0 00-.7 0z"/>\n    </svg>\n  '});function Hv(e){return Mu(e)&&"treeitem"===e.getAttribute("role")}class jv extends Ln{constructor(){super(...arguments),this.expanded=!1,this.focusable=!1,this.isNestedItem=()=>Hv(this.parentElement),this.handleExpandCollapseButtonClick=e=>{this.disabled||e.defaultPrevented||(this.expanded=!this.expanded)},this.handleFocus=e=>{this.setAttribute("tabindex","0")},this.handleBlur=e=>{this.setAttribute("tabindex","-1")}}expandedChanged(){this.$fastController.isConnected&&this.$emit("expanded-change",this)}selectedChanged(){this.$fastController.isConnected&&this.$emit("selected-change",this)}itemsChanged(e,t){this.$fastController.isConnected&&this.items.forEach((e=>{Hv(e)&&(e.nested=!0)}))}static focusItem(e){e.focusable=!0,e.focus()}childItemLength(){const e=this.childItems.filter((e=>Hv(e)));return e?e.length:0}}Ms([Os({mode:"boolean"})],jv.prototype,"expanded",void 0),Ms([Os({mode:"boolean"})],jv.prototype,"selected",void 0),Ms([Os({mode:"boolean"})],jv.prototype,"disabled",void 0),Ms([ms],jv.prototype,"focusable",void 0),Ms([ms],jv.prototype,"childItems",void 0),Ms([ms],jv.prototype,"items",void 0),Ms([ms],jv.prototype,"nested",void 0),Ms([ms],jv.prototype,"renderCollapsedChildren",void 0),cu(jv,nu);class qv extends Ln{constructor(){super(...arguments),this.currentFocused=null,this.handleFocus=e=>{if(!(this.slottedTreeItems.length<1))return e.target===this?(null===this.currentFocused&&(this.currentFocused=this.getValidFocusableItem()),void(null!==this.currentFocused&&jv.focusItem(this.currentFocused))):void(this.contains(e.target)&&(this.setAttribute("tabindex","-1"),this.currentFocused=e.target))},this.handleBlur=e=>{e.target instanceof HTMLElement&&(null===e.relatedTarget||!this.contains(e.relatedTarget))&&this.setAttribute("tabindex","0")},this.handleKeyDown=e=>{if(e.defaultPrevented)return;if(this.slottedTreeItems.length<1)return!0;const t=this.getVisibleNodes();switch(e.key){case bu:return void(t.length&&jv.focusItem(t[0]));case yu:return void(t.length&&jv.focusItem(t[t.length-1]));case pu:if(e.target&&this.isFocusableElement(e.target)){const t=e.target;t instanceof jv&&t.childItemLength()>0&&t.expanded?t.expanded=!1:t instanceof jv&&t.parentElement instanceof jv&&jv.focusItem(t.parentElement)}return!1;case gu:if(e.target&&this.isFocusableElement(e.target)){const t=e.target;t instanceof jv&&t.childItemLength()>0&&!t.expanded?t.expanded=!0:t instanceof jv&&t.childItemLength()>0&&this.focusNextNode(1,e.target)}return;case uu:return void(e.target&&this.isFocusableElement(e.target)&&this.focusNextNode(1,e.target));case fu:return void(e.target&&this.isFocusableElement(e.target)&&this.focusNextNode(-1,e.target));case vu:return void this.handleClick(e)}return!0},this.handleSelectedChange=e=>{if(e.defaultPrevented)return;if(!(e.target instanceof Element&&Hv(e.target)))return!0;const t=e.target;t.selected?(this.currentSelected&&this.currentSelected!==t&&(this.currentSelected.selected=!1),this.currentSelected=t):t.selected||this.currentSelected!==t||(this.currentSelected=null)},this.setItems=()=>{const e=this.treeView.querySelector("[aria-selected='true']");this.currentSelected=e,null!==this.currentFocused&&this.contains(this.currentFocused)||(this.currentFocused=this.getValidFocusableItem()),this.nested=this.checkForNestedItems(),this.getVisibleNodes().forEach((e=>{Hv(e)&&(e.nested=this.nested)}))},this.isFocusableElement=e=>Hv(e),this.isSelectedElement=e=>e.selected}slottedTreeItemsChanged(){this.$fastController.isConnected&&this.setItems()}connectedCallback(){super.connectedCallback(),this.setAttribute("tabindex","0"),ps.queueUpdate((()=>{this.setItems()}))}handleClick(e){if(e.defaultPrevented)return;if(!(e.target instanceof Element&&Hv(e.target)))return!0;const t=e.target;t.disabled||(t.selected=!t.selected)}focusNextNode(e,t){const i=this.getVisibleNodes();if(!i)return;const o=i[i.indexOf(t)+e];Mu(o)&&jv.focusItem(o)}getValidFocusableItem(){const e=this.getVisibleNodes();let t=e.findIndex(this.isSelectedElement);return-1===t&&(t=e.findIndex(this.isFocusableElement)),-1!==t?e[t]:null}checkForNestedItems(){return this.slottedTreeItems.some((e=>Hv(e)&&e.querySelector("[role='treeitem']")))}getVisibleNodes(){return function(e,t){if(e&&Mu(e))return Array.from(e.querySelectorAll(t)).filter((e=>null!==e.offsetParent))}(this,"[role='treeitem']")||[]}}Ms([Os({attribute:"render-collapsed-nodes"})],qv.prototype,"renderCollapsedNodes",void 0),Ms([ms],qv.prototype,"currentSelected",void 0),Ms([ms],qv.prototype,"slottedTreeItems",void 0);const Zv=qv.compose({baseName:"tree-view",template:(e,t)=>Rr`
    <template
        role="tree"
        ${su("treeView")}
        @keydown="${(e,t)=>e.handleKeyDown(t.event)}"
        @focusin="${(e,t)=>e.handleFocus(t.event)}"
        @focusout="${(e,t)=>e.handleBlur(t.event)}"
        @click="${(e,t)=>e.handleClick(t.event)}"
        @selected-change="${(e,t)=>e.handleSelectedChange(t.event)}"
    >
        <slot ${Ru("slottedTreeItems")}></slot>
    </template>
`,styles:(e,t)=>ih`
  :host([hidden]) {
    display: none;
  }

  ${nh("flex")} :host {
    flex-direction: column;
    align-items: stretch;
    min-width: fit-content;
    font-size: 0;
  }
`});class Wv extends Fu{constructor(e,t){super(e,t),this.observer=null,t.childList=!0}observe(){null===this.observer&&(this.observer=new MutationObserver(this.handleEvent.bind(this))),this.observer.observe(this.target,this.options)}disconnect(){this.observer.disconnect()}getNodes(){return"subtree"in this.options?Array.from(this.target.querySelectorAll(this.options.selector)):Array.from(this.target.childNodes)}}const Gv=ih`
  .expand-collapse-button svg {
    transform: rotate(0deg);
  }
  :host(.nested) .expand-collapse-button {
    left: var(--expand-collapse-button-nested-width, calc(${Uu} * -1px));
  }
  :host([selected])::after {
    left: calc(${za} * 1px);
  }
  :host([expanded]) > .positioning-region .expand-collapse-button svg {
    transform: rotate(90deg);
  }
`,Qv=ih`
  .expand-collapse-button svg {
    transform: rotate(180deg);
  }
  :host(.nested) .expand-collapse-button {
    right: var(--expand-collapse-button-nested-width, calc(${Uu} * -1px));
  }
  :host([selected])::after {
    right: calc(${za} * 1px);
  }
  :host([expanded]) > .positioning-region .expand-collapse-button svg {
    transform: rotate(90deg);
  }
`,Kv=sh`((${Oa} / 2) * ${Aa}) + ((${Aa} * ${Fa}) / 2)`,Xv=Jn.create("tree-item-expand-collapse-hover").withDefault((e=>{const t=gc.getValueFor(e);return t.evaluate(e,t.evaluate(e).hover).hover})),Jv=Jn.create("tree-item-expand-collapse-selected-hover").withDefault((e=>{const t=dc.getValueFor(e);return gc.getValueFor(e).evaluate(e,t.evaluate(e).rest).hover})),Yv=jv.compose({baseName:"tree-item",template:(e,t)=>{return Rr`
    <template
        role="treeitem"
        slot="${e=>e.isNestedItem()?"item":void 0}"
        tabindex="-1"
        class="${e=>e.expanded?"expanded":""} ${e=>e.selected?"selected":""} ${e=>e.nested?"nested":""}
            ${e=>e.disabled?"disabled":""}"
        aria-expanded="${e=>e.childItems&&e.childItemLength()>0?e.expanded:void 0}"
        aria-selected="${e=>e.selected}"
        aria-disabled="${e=>e.disabled}"
        @focusin="${(e,t)=>e.handleFocus(t.event)}"
        @focusout="${(e,t)=>e.handleBlur(t.event)}"
        ${i={property:"childItems",filter:Ou()},"string"==typeof i&&(i={property:i}),new ur("fast-children",Wv,i)}
    >
        <div class="positioning-region" part="positioning-region">
            <div class="content-region" part="content-region">
                ${eu((e=>e.childItems&&e.childItemLength()>0),Rr`
                        <div
                            aria-hidden="true"
                            class="expand-collapse-button"
                            part="expand-collapse-button"
                            @click="${(e,t)=>e.handleExpandCollapseButtonClick(t.event)}"
                            ${su("expandCollapseButton")}
                        >
                            <slot name="expand-collapse-glyph">
                                ${t.expandCollapseGlyph||""}
                            </slot>
                        </div>
                    `)}
                ${au(0,t)}
                <slot></slot>
                ${ru(0,t)}
            </div>
        </div>
        ${eu((e=>e.childItems&&e.childItemLength()>0&&(e.expanded||e.renderCollapsedChildren)),Rr`
                <div role="group" class="items" part="items">
                    <slot name="item" ${Ru("items")}></slot>
                </div>
            `)}
    </template>
`;var i},styles:(e,t)=>ih`
    ${nh("block")} :host {
      contain: content;
      position: relative;
      outline: none;
      color: ${xc};
      fill: currentcolor;
      cursor: pointer;
      font-family: ${Na};
      --expand-collapse-button-size: calc(${Uu} * 1px);
      --tree-item-nested-width: 0;
    }

    .positioning-region {
      display: flex;
      position: relative;
      box-sizing: border-box;
      background: ${fc};
      border: calc(${Ma} * 1px) solid transparent;
      border-radius: calc(${Ra} * 1px);
      height: calc((${Uu} + 1) * 1px);
    }

    :host(:${Nu}) .positioning-region {
      ${Hu}
    }

    .positioning-region::before {
      content: '';
      display: block;
      width: var(--tree-item-nested-width);
      flex-shrink: 0;
    }

    :host(:not([disabled])) .positioning-region:hover {
      background: ${vc};
    }

    :host(:not([disabled])) .positioning-region:active {
      background: ${mc};
    }

    .content-region {
      display: inline-flex;
      align-items: center;
      white-space: nowrap;
      width: 100%;
      height: calc(${Uu} * 1px);
      margin-inline-start: calc(${Aa} * 2px + 8px);
      ${Bu}
    }

    .items {
      display: none;
      ${""} font-size: calc(1em + (${Aa} + 16) * 1px);
    }

    .expand-collapse-button {
      background: none;
      border: none;
      border-radius: calc(${Ra} * 1px);
      ${""} width: calc((${Kv} + (${Aa} * 2)) * 1px);
      height: calc((${Kv} + (${Aa} * 2)) * 1px);
      padding: 0;
      display: flex;
      justify-content: center;
      align-items: center;
      cursor: pointer;
      margin: 0 6px;
    }

    .expand-collapse-button svg {
      transition: transform 0.1s linear;
      pointer-events: none;
    }

    .start,
    .end {
      display: flex;
    }

    .start {
      ${""} margin-inline-end: calc(${Aa} * 2px + 2px);
    }

    .end {
      ${""} margin-inline-start: calc(${Aa} * 2px + 2px);
    }

    :host(.expanded) > .items {
      display: block;
    }

    :host([disabled]) {
      opacity: ${Ea};
      cursor: ${Vu};
    }

    :host(.nested) .content-region {
      position: relative;
      margin-inline-start: var(--expand-collapse-button-size);
    }

    :host(.nested) .expand-collapse-button {
      position: absolute;
    }

    :host(.nested) .expand-collapse-button:hover {
      background: ${Xv};
    }

    :host(:not([disabled])[selected]) .positioning-region {
      background: ${cc};
    }

    :host(:not([disabled])[selected]) .expand-collapse-button:hover {
      background: ${Jv};
    }

    :host([selected])::after {
      content: '';
      display: block;
      position: absolute;
      top: calc((${Uu} / 4) * 1px);
      width: 3px;
      height: calc((${Uu} / 2) * 1px);
      ${""} background: ${Dd};
      border-radius: calc(${Ra} * 1px);
    }

    ::slotted(fluent-tree-item) {
      --tree-item-nested-width: 1em;
      --expand-collapse-button-nested-width: calc(${Uu} * -1px);
    }
  `.withBehaviors(new ag(Gv,Qv),lh(ih`
        :host {
          color: ${dh.ButtonText};
        }
        .positioning-region {
          border-color: ${dh.ButtonFace};
          background: ${dh.ButtonFace};
        }
        :host(:not([disabled])) .positioning-region:hover,
        :host(:not([disabled])) .positioning-region:active,
        :host(:not([disabled])[selected]) .positioning-region {
          background: ${dh.Highlight};
        }
        :host .positioning-region:hover .content-region,
        :host([selected]) .positioning-region .content-region {
          forced-color-adjust: none;
          color: ${dh.HighlightText};
        }
        :host([disabled][selected]) .positioning-region .content-region {
          color: ${dh.GrayText};
        }
        :host([selected])::after {
          background: ${dh.HighlightText};
        }
        :host(:${Nu}) .positioning-region {
          forced-color-adjust: none;
          outline-color: ${dh.ButtonFace};
        }
        :host([disabled]),
        :host([disabled]) .content-region,
        :host([disabled]) .positioning-region:hover .content-region {
          opacity: 1;
          color: ${dh.GrayText};
        }
        :host(.nested) .expand-collapse-button:hover,
        :host(:not([disabled])[selected]) .expand-collapse-button:hover {
          background: ${dh.ButtonFace};
          fill: ${dh.ButtonText};
        }
      `)),expandCollapseGlyph:'\n    <svg width="12" height="12" xmlns="http://www.w3.org/2000/svg">\n      <path d="M4.65 2.15a.5.5 0 000 .7L7.79 6 4.65 9.15a.5.5 0 10.7.7l3.5-3.5a.5.5 0 000-.7l-3.5-3.5a.5.5 0 00-.7 0z"/>\n    </svg>\n  '});var em,tm=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},im=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},om=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(Uv,Bv,$h,Zv,Yv,Kg);let sm=em=class extends Nt{static get styles(){return Fv}get strings(){return Rv}get selectedItem(){return this._selectedItemState?{channel:this._selectedItemState.item,team:this._selectedItemState.parent.item}:null}static get requiredScopes(){return["team.readbasic.all","channel.readbasic.all"]}set items(e){this._items!==e&&(this._items=e,this._treeViewState=e?this.generateTreeViewState(e):[],this.resetFocusState())}get items(){return this._items}get _inputWrapper(){return this.renderRoot.querySelector("fluent-text-field")}get _input(){return this._inputWrapper.shadowRoot.querySelector("input")}constructor(){super(),this.teamsPhotos={},this._inputValue="",this._treeViewState=[],this._focusList=[],this.handleInputClick=e=>{e.stopPropagation(),this.gainedFocus()},this.handleInputKeydown=e=>{const t=e.key;["ArrowDown","Enter"].includes(t)?this._isDropdownVisible?this.renderRoot.querySelector("fluent-tree-item").focus():this.gainedFocus():"Escape"===t&&this.lostFocus()},this.onClickCloseButton=()=>{this.removeSelectedChannel(null)},this.onKeydownCloseButton=e=>{"Enter"===e.key&&this.removeSelectedChannel(null)},this.onKeydownTreeView=e=>{"Escape"===e.key&&this.lostFocus()},this.handleTeamTreeItemClick=e=>{e.preventDefault(),e.stopImmediatePropagation();const t=e.target;t&&(t.getAttribute("expanded")?t.removeAttribute("expanded"):t.setAttribute("expanded","true"),t.removeAttribute("selected"),t.getAttribute("id")&&t.setAttribute("selected","true"))},this.handleInputChanged=e=>{const t=e.target;this._inputValue!==(null==t?void 0:t.value)&&(this._inputValue=null==t?void 0:t.value,this.gainedFocus(),this.debouncedSearch||(this.debouncedSearch=$i((()=>{this.filterList()}),400)),this.debouncedSearch())},this.handleWindowClick=e=>{e.target!==this&&this.lostFocus()},this.gainedFocus=()=>{const e=this._input;e&&e.focus(),this._isDropdownVisible=!0,this.toggleChevron(),this.resetFocusState(),this.requestUpdate()},this.lostFocus=()=>{this._input.value=this._inputValue="",this._input.textContent="",this._inputWrapper.value="",this._isDropdownVisible=!1,this.filterList(),this.toggleChevron(),this.requestUpdate(),void 0!==this._selectedItemState&&this.showCloseIcon()},this.handleFocus=()=>{this.lostFocus(),this.gainedFocus()},this.handleUpChevronClick=e=>{e.stopPropagation(),this.lostFocus()},this.addEventListener("focus",(()=>this.loadTeamsIfNotLoaded())),this.addEventListener("mouseover",(()=>this.loadTeamsIfNotLoaded())),this.addEventListener("blur",(()=>this.lostFocus())),this._inputValue="",this._treeViewState=[],this._focusList=[],this._isDropdownVisible=!1}connectedCallback(){super.connectedCallback(),window.addEventListener("click",this.handleWindowClick);const e=this.renderRoot.ownerDocument;e&&e.documentElement.setAttribute("dir",this.direction)}disconnectedCallback(){window.removeEventListener("click",this.handleWindowClick),super.disconnectedCallback()}selectChannelById(e){return om(this,void 0,void 0,(function*(){const t=te.globalProvider;if(t&&t.state===Q.SignedIn){this.items||(yield this.requestStateUpdate());for(const t of this._treeViewState)for(const i of t.channels)if(i.item.id===e)return t.isExpanded=!0,this.selectChannel(i),this.markSelectedChannelInDropdown(e),!0}return!1}))}markSelectedChannelInDropdown(e){const t=this.renderRoot.querySelector(`[id='${e}']`);t&&(t.setAttribute("selected","true"),t.parentElement&&t.parentElement.setAttribute("expanded","true"))}render(){var e;const t={dropdown:!0,visible:this._isDropdownVisible};return this.renderTemplate("default",{teams:null!==(e=this.items)&&void 0!==e?e:[]})||Je`
        <div class="container" @blur=${this.lostFocus}>
          <fluent-text-field
            autocomplete="off"
            appearance="outline"
            id="teams-channel-picker-input"
            role="combobox"
            placeholder="${this._selectedItemState?"":this.strings.inputPlaceholderText} "
            aria-label=${this.strings.inputPlaceholderText}
            aria-expanded="${this._isDropdownVisible}"
            label="teams-channel-picker-input"
            @focus=${this.handleFocus}
            @keyup=${this.handleInputChanged}
            @click=${this.handleInputClick}
            @keydown=${this.handleInputKeydown}
          >
            <div tabindex="0" slot="start" style="width: max-content;">${this.renderSelected()}</div>
            <div tabindex="0" slot="end">${this.renderChevrons()}${this.renderCloseButton()}</div>
          </fluent-text-field>
          <fluent-card
            class=${ki(t)}
          >
            ${this.renderDropdown()}
          </fluent-card>
        </div>`}renderSelected(){var e,t,i,o,s,n;if(!this._selectedItemState)return this.renderSearchIcon();let r;if(this._selectedItemState.parent.channels){const t=null===(e=this.teamsPhotos[this._selectedItemState.parent.item.id])||void 0===e?void 0:e.photo;r=Je`<img
        class="team-photo"
        alt="${this._selectedItemState.parent.item.displayName}"
        role="img"
        src=${t} />`}const a=null===(o=null===(i=null===(t=this._selectedItemState)||void 0===t?void 0:t.parent)||void 0===i?void 0:i.item)||void 0===o?void 0:o.displayName.trim(),l=null===(n=null===(s=this._selectedItemState)||void 0===s?void 0:s.item)||void 0===n?void 0:n.displayName.trim();return Je`
      <fluent-breadcrumb title=${this._selectedItemState.item.displayName}>
        <fluent-breadcrumb-item>
          <span slot="start">${r}</span>
          <span class="team-parent-name">${a}</span>
          <span slot="separator" class="arrow">${Co(ko.TeamSeparator,"#000000")}</span>
        </fluent-breadcrumb-item>
        <fluent-breadcrumb-item>${l}</fluent-breadcrumb-item>
      </fluent-breadcrumb>`}clearState(){this._inputValue="",this._treeViewState=[],this._focusList=[],this._isDropdownVisible=!1}renderSearchIcon(){return Je`
      <div class="search-icon">
        ${Co(ko.Search,"#252424")}
      </div>
    `}renderCloseButton(){return Je`
      <fluent-button
        appearance="stealth"
        class="close-icon"
        style="display:none"
        aria-label=${this.strings.closeButtonAriaLabel}
        @click=${this.onClickCloseButton}
        @keydown=${this.onKeydownCloseButton}>
        <svg width="8" height="8" viewBox="0 0 8 8" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M0.0885911 0.215694L0.146447 0.146447C0.320013 -0.0271197 0.589437 -0.046405 0.784306 0.0885911L0.853553 0.146447L4 3.293L7.14645 0.146447C7.34171 -0.0488154 7.65829 -0.0488154 7.85355 0.146447C8.04882 0.341709 8.04882 0.658291 7.85355 0.853553L4.707 4L7.85355 7.14645C8.02712 7.32001 8.0464 7.58944 7.91141 7.78431L7.85355 7.85355C7.67999 8.02712 7.41056 8.0464 7.21569 7.91141L7.14645 7.85355L4 4.707L0.853553 7.85355C0.658291 8.04882 0.341709 8.04882 0.146447 7.85355C-0.0488154 7.65829 -0.0488154 7.34171 0.146447 7.14645L3.293 4L0.146447 0.853553C-0.0271197 0.679987 -0.046405 0.410563 0.0885911 0.215694L0.146447 0.146447L0.0885911 0.215694Z" fill="#212121"/>
        </svg>
      </fluent-button>
    `}showCloseIcon(){const e=this.renderRoot.querySelector(".down-chevron"),t=this.renderRoot.querySelector(".up-chevron"),i=this.renderRoot.querySelector(".close-icon");e&&(e.style.display="none"),t&&(t.style.display="none"),i&&(i.style.display=null)}renderDownChevron(){return Je`
      <fluent-button appearance="stealth" class="down-chevron" @click=${this.gainedFocus}>
        <svg width="12" height="12" viewBox="0 0 12 12" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M2.21967 4.46967C2.51256 4.17678 2.98744 4.17678 3.28033 4.46967L6 7.18934L8.71967 4.46967C9.01256 4.17678 9.48744 4.17678 9.78033 4.46967C10.0732 4.76256 10.0732 5.23744 9.78033 5.53033L6.53033 8.78033C6.23744 9.07322 5.76256 9.07322 5.46967 8.78033L2.21967 5.53033C1.92678 5.23744 1.92678 4.76256 2.21967 4.46967Z" fill="#212121" />
        </svg>
      </fluent-button>`}renderUpChevron(){return Je`
      <fluent-button appearance="stealth" style="display:none" class="up-chevron" @click=${this.handleUpChevronClick}>
        <svg width="12" height="12" viewBox="0 0 12 12" fill="none" xmlns="http://www.w3.org/2000/svg">
          <path d="M2.21967 7.53033C2.51256 7.82322 2.98744 7.82322 3.28033 7.53033L6 4.81066L8.71967 7.53033C9.01256 7.82322 9.48744 7.82322 9.78033 7.53033C10.0732 7.23744 10.0732 6.76256 9.78033 6.46967L6.53033 3.21967C6.23744 2.92678 5.76256 2.92678 5.46967 3.21967L2.21967 6.46967C1.92678 6.76256 1.92678 7.23744 2.21967 7.53033Z" fill="#212121" />
        </svg>
      </fluent-button>`}renderChevrons(){return Je`${this.renderUpChevron()}${this.renderDownChevron()}`}renderDropdown(){return this.isLoadingState||!this._treeViewState?this.renderLoading():this._treeViewState?!this.isLoadingState&&0===this._treeViewState.length&&this._inputValue.length>0?this.renderError():this.renderDropdownList(this._treeViewState):Je``}renderDropdownList(e){if(e&&e.length>0){let t=null;return Je`
        <fluent-tree-view
          class="tree-view"
          dir=${this.direction}
          aria-live="polite"
          aria-relevant="all"
          aria-atomic="true"
          aria-label=${this.strings.teamsChannels}
          aria-orientation="horizontal"
          @keydown=${this.onKeydownTreeView}>
          ${Xo(e,(e=>null==e?void 0:e.item),(e=>{var i;return e.channels&&(t=Je`<img
                  class="team-photo"
                  alt="${this.strings.photoFor} ${e.item.displayName}"
                  src=${null===(i=this.teamsPhotos[e.item.id])||void 0===i?void 0:i.photo} />`),Je`
                <fluent-tree-item
                  ?expanded=${null==e?void 0:e.isExpanded}
                  @click=${this.handleTeamTreeItemClick}>
                    <span slot="start">${t}</span>${e.item.displayName}
                    ${Xo(null==e?void 0:e.channels,(e=>e.item),(e=>this.renderItem(e)))}
                </fluent-tree-item>`}))}
        </fluent-tree-view>`}return null}renderItem(e){var t;return Je`
      <fluent-tree-item
        id=${null===(t=null==e?void 0:e.item)||void 0===t?void 0:t.id}
        @keydown=${t=>this.onUserKeyDown(t,e)}
        @click=${()=>this.handleItemClick(e)}>
          ${null==e?void 0:e.item.displayName}
      </fluent-tree-item>`}renderError(){return this.renderTemplate("error",null,"error")||Je`
        <div class="message-parent">
          <div
            label="search-error-text"
            aria-live="polite"
            aria-relevant="all"
            aria-atomic="true"
            class="search-error-text"
          >
            ${this.strings.noResultsFound}
          </div>
        </div>
      `}renderLoading(){return this.renderTemplate("loading",null,"loading")||pi`
        <div class="message-parent">
          <mgt-spinner></mgt-spinner>
          <div label="loading-text" aria-label="loading" class="loading-text">
            ${this.strings.loadingMessage}
          </div>
        </div>
      `}loadState(){var e,t;return om(this,void 0,void 0,(function*(){const i=te.globalProvider;let o;if(i&&i.state===Q.SignedIn){const s=i.graph.forComponent(this);o=yield((e,t)=>Av(void 0,void 0,void 0,(function*(){const i=yield e.api("/me/joinedTeams").select(["displayName","id","isArchived"]).middlewareOptions(ie(...t)).get();return null==i?void 0:i.value})))(s,em.requiredScopes),o=o.filter((e=>!e.isArchived));const n=ue.fromGraph(s),r=o.map((e=>e.id));this.teamsPhotos=yield((e,t)=>Av(void 0,void 0,void 0,(function*(){let i,o={};if(lo()){i=ai.getCache(Ai,Ai.stores.teams);for(const e of t)try{const t=yield i.getValue(e);t&&ao()>Date.now()-t.timeCached&&(o[e]=t)}catch(e){}if(Object.keys(o).length)return o}const s=["team.readbasic.all"];o={};for(const n of t)try{const t=yield co(e,`/teams/${n}`,s);lo()&&t&&(yield i.putValue(n,t)),o[n]=t}catch(e){}return o})))(n,r);const a=s.createBatch();for(const e of o)a.get(e.id,`teams/${e.id}/channels`,em.requiredScopes);const l=yield a.executeAll();this._items=[];for(const i of o){const o=l.get(i.id);(null===(t=null===(e=o.content)||void 0===e?void 0:e.value)||void 0===t?void 0:t.length)&&this.items.push({item:i,channels:o.content.value.map((e=>({item:e})))})}}this.filterList(),this.resetFocusState()}))}removeSelectedChannel(e){this.selectChannel(e);const t=this.renderRoot.querySelectorAll("fluent-tree-item");t&&t.forEach((e=>{e.removeAttribute("expanded"),e.removeAttribute("selected")}))}handleItemClick(e){e.channels?e.isExpanded=!e.isExpanded:(this.selectChannel(e),this.lostFocus())}onUserKeyDown(e,t){switch(e.code){case"Enter":this.selectChannel(t),this.resetFocusState(),this.lostFocus(),e.preventDefault();break;case"Backspace":0===this._inputValue.length&&this._selectedItemState&&(this.selectChannel(null),this.resetFocusState(),e.preventDefault())}}filterList(){this.items&&(this._treeViewState=this.generateTreeViewState(this.items,this._inputValue),this.resetFocusState())}generateTreeViewState(e,t="",i=null){const o=[];if(t=t.toLowerCase(),e)for(const s of e){let e;if(0===t.length||s.item.displayName.toLowerCase().includes(t))e={item:s.item,parent:i},s.channels&&(e.channels=this.generateTreeViewState(s.channels,"",e),e.isExpanded=t.length>0);else if(s.channels){const o={item:s.item,parent:i},n=this.generateTreeViewState(s.channels,t,o);n.length>0&&(e=o,e.channels=n,e.isExpanded=!0)}e&&o.push(e)}return o}generateFocusList(e){if(!e||0===e.length)return[];let t=[];for(const i of e)t.push(i),i.channels&&i.isExpanded&&(t=[...t,...this.generateFocusList(i.channels)]);return t}resetFocusState(){this._focusList=this.generateFocusList(this._treeViewState),this.requestUpdate()}loadTeamsIfNotLoaded(){this.items||this.isLoadingState||this.requestStateUpdate()}selectChannel(e){e&&this._selectedItemState!==e?this._input.setAttribute("disabled","true"):this._input.removeAttribute("disabled"),this._selectedItemState=e,this.lostFocus(),this.fireCustomEvent("selectionChanged",this.selectedItem)}hideCloseIcon(){const e=this.renderRoot.querySelector(".close-icon");e&&(e.style.display="none")}toggleChevron(){const e=this.renderRoot.querySelector(".down-chevron"),t=this.renderRoot.querySelector(".up-chevron");this._isDropdownVisible?(e&&(e.style.display="none"),t&&(t.style.display=null)):(e&&(e.style.display=null,this.hideCloseIcon()),t&&(t.style.display="none")),this.hideCloseIcon()}};tm([$t(),im("design:type",Object)],sm.prototype,"_selectedItemState",void 0),tm([$t(),im("design:type",Boolean)],sm.prototype,"_isDropdownVisible",void 0),sm=em=tm([gi("teams-channel-picker"),im("design:paramtypes",[])],sm);const nm={cancelNewTaskSubtitle:"Cancel",newTaskPlaceholder:"Add a task",addTaskButtonSubtitle:"Add",removeTaskSubtitle:"Delete Task"};class rm{constructor(e){if(this.dayFormat="numeric",this.weekdayFormat="long",this.monthFormat="long",this.yearFormat="numeric",this.date=new Date,e)for(const t in e){const i=e[t];"date"===t?this.date=this.getDateObject(i):this[t]=i}}getDateObject(e){if("string"==typeof e){const t=e.split(/[/-]/);return t.length<3?new Date:new Date(parseInt(t[2],10),parseInt(t[0],10)-1,parseInt(t[1],10))}if("day"in e&&"month"in e&&"year"in e){const{day:t,month:i,year:o}=e;return new Date(o,i-1,t)}return e}getDate(e=this.date,t={weekday:this.weekdayFormat,month:this.monthFormat,day:this.dayFormat,year:this.yearFormat},i=this.locale){const o=this.getDateObject(e);if(!o.getTime())return"";const s=Object.assign({timeZone:Intl.DateTimeFormat().resolvedOptions().timeZone},t);return new Intl.DateTimeFormat(i,s).format(o)}getDay(e=this.date.getDate(),t=this.dayFormat,i=this.locale){return this.getDate({month:1,day:e,year:2020},{day:t},i)}getMonth(e=this.date.getMonth()+1,t=this.monthFormat,i=this.locale){return this.getDate({month:e,day:2,year:2020},{month:t},i)}getYear(e=this.date.getFullYear(),t=this.yearFormat,i=this.locale){return this.getDate({month:2,day:2,year:e},{year:t},i)}getWeekday(e=0,t=this.weekdayFormat,i=this.locale){const o=`1-${e+1}-2017`;return this.getDate(o,{weekday:t},i)}getWeekdays(e=this.weekdayFormat,t=this.locale){return Array(7).fill(null).map(((i,o)=>this.getWeekday(o,e,t)))}}class am extends Ln{constructor(){super(...arguments),this.dateFormatter=new rm,this.readonly=!1,this.locale="en-US",this.month=(new Date).getMonth()+1,this.year=(new Date).getFullYear(),this.dayFormat="numeric",this.weekdayFormat="short",this.monthFormat="long",this.yearFormat="numeric",this.minWeeks=0,this.disabledDates="",this.selectedDates="",this.oneDayInMs=864e5}localeChanged(){this.dateFormatter.locale=this.locale}dayFormatChanged(){this.dateFormatter.dayFormat=this.dayFormat}weekdayFormatChanged(){this.dateFormatter.weekdayFormat=this.weekdayFormat}monthFormatChanged(){this.dateFormatter.monthFormat=this.monthFormat}yearFormatChanged(){this.dateFormatter.yearFormat=this.yearFormat}getMonthInfo(e=this.month,t=this.year){const i=e=>new Date(e.getFullYear(),e.getMonth(),1).getDay(),o=e=>{const t=new Date(e.getFullYear(),e.getMonth()+1,1);return new Date(t.getTime()-this.oneDayInMs).getDate()},s=new Date(t,e-1),n=new Date(t,e),r=new Date(t,e-2);return{length:o(s),month:e,start:i(s),year:t,previous:{length:o(r),month:r.getMonth()+1,start:i(r),year:r.getFullYear()},next:{length:o(n),month:n.getMonth()+1,start:i(n),year:n.getFullYear()}}}getDays(e=this.getMonthInfo(),t=this.minWeeks){t=t>10?10:t;const{start:i,length:o,previous:s,next:n}=e,r=[];let a=1-i;for(;a<o+1||r.length<t||r[r.length-1].length%7!=0;){const{month:t,year:i}=a<1?s:a>o?n:e,l=a<1?s.length+a:a>o?a-o:a,d=`${t}-${l}-${i}`,c={day:l,month:t,year:i,disabled:this.dateInString(d,this.disabledDates),selected:this.dateInString(d,this.selectedDates)},h=r[r.length-1];0===r.length||h.length%7==0?r.push([c]):h.push(c),a++}return r}dateInString(e,t){const i=t.split(",").map((e=>e.trim()));return e="string"==typeof e?e:`${e.getMonth()+1}-${e.getDate()}-${e.getFullYear()}`,i.some((t=>t===e))}getDayClassNames(e,t){const{day:i,month:o,year:s,disabled:n,selected:r}=e;return["day",t===`${o}-${i}-${s}`&&"today",this.month!==o&&"inactive",n&&"disabled",r&&"selected"].filter(Boolean).join(" ")}getWeekdayText(){const e=this.dateFormatter.getWeekdays().map((e=>({text:e})));if("long"!==this.weekdayFormat){const t=this.dateFormatter.getWeekdays("long");e.forEach(((e,i)=>{e.abbr=t[i]}))}return e}handleDateSelect(e,t){e.preventDefault,this.$emit("dateselected",t)}handleKeydown(e,t){return e.key===vu&&this.handleDateSelect(e,t),!0}}function lm(e,t,i){return{index:e,removed:t,addedCount:i}}Ms([Os({mode:"boolean"})],am.prototype,"readonly",void 0),Ms([Os],am.prototype,"locale",void 0),Ms([Os({converter:Ls})],am.prototype,"month",void 0),Ms([Os({converter:Ls})],am.prototype,"year",void 0),Ms([Os({attribute:"day-format",mode:"fromView"})],am.prototype,"dayFormat",void 0),Ms([Os({attribute:"weekday-format",mode:"fromView"})],am.prototype,"weekdayFormat",void 0),Ms([Os({attribute:"month-format",mode:"fromView"})],am.prototype,"monthFormat",void 0),Ms([Os({attribute:"year-format",mode:"fromView"})],am.prototype,"yearFormat",void 0),Ms([Os({attribute:"min-weeks",converter:Ls})],am.prototype,"minWeeks",void 0),Ms([Os({attribute:"disabled-dates"})],am.prototype,"disabledDates",void 0),Ms([Os({attribute:"selected-dates"})],am.prototype,"selectedDates",void 0);const dm=0,cm=1,hm=2,um=3;function pm(e,t,i,o,s,n){let r=0,a=0;const l=Math.min(i-t,n-s);if(0===t&&0===s&&(r=function(e,t,i){for(let o=0;o<i;++o)if(e[o]!==t[o])return o;return i}(e,o,l)),i===e.length&&n===o.length&&(a=function(e,t,i){let o=e.length,s=t.length,n=0;for(;n<i&&e[--o]===t[--s];)n++;return n}(e,o,l-r)),s+=r,n-=a,(i-=a)-(t+=r)==0&&n-s==0)return ns;if(t===i){const e=lm(t,[],0);for(;s<n;)e.removed.push(o[s++]);return[e]}if(s===n)return[lm(t,[],i-t)];const d=function(e){let t=e.length-1,i=e[0].length-1,o=e[t][i];const s=[];for(;t>0||i>0;){if(0===t){s.push(hm),i--;continue}if(0===i){s.push(um),t--;continue}const n=e[t-1][i-1],r=e[t-1][i],a=e[t][i-1];let l;l=r<a?r<n?r:n:a<n?a:n,l===n?(n===o?s.push(dm):(s.push(cm),o=n),t--,i--):l===r?(s.push(um),t--,o=r):(s.push(hm),i--,o=a)}return s.reverse(),s}(function(e,t,i,o,s,n){const r=n-s+1,a=i-t+1,l=new Array(r);let d,c;for(let e=0;e<r;++e)l[e]=new Array(a),l[e][0]=e;for(let e=0;e<a;++e)l[0][e]=e;for(let i=1;i<r;++i)for(let n=1;n<a;++n)e[t+n-1]===o[s+i-1]?l[i][n]=l[i-1][n-1]:(d=l[i-1][n]+1,c=l[i][n-1]+1,l[i][n]=d<c?d:c);return l}(e,t,i,o,s,n)),c=[];let h,u=t,p=s;for(let e=0;e<d.length;++e)switch(d[e]){case dm:void 0!==h&&(c.push(h),h=void 0),u++,p++;break;case cm:void 0===h&&(h=lm(u,[],0)),h.addedCount++,u++,h.removed.push(o[p]),p++;break;case hm:void 0===h&&(h=lm(u,[],0)),h.addedCount++,u++;break;case um:void 0===h&&(h=lm(u,[],0)),h.removed.push(o[p]),p++}return void 0!==h&&c.push(h),c}const gm=Array.prototype.push;function fm(e,t,i,o){const s=lm(t,i,o);let n=!1,r=0;for(let t=0;t<e.length;t++){const i=e[t];if(i.index+=r,n)continue;const o=(a=s.index,l=s.index+s.removed.length,d=i.index,c=i.index+i.addedCount,l<d||c<a?-1:l===d||c===a?0:a<d?l<c?l-d:c-d:c<l?c-a:l-a);if(o>=0){e.splice(t,1),t--,r-=i.addedCount-i.removed.length,s.addedCount+=i.addedCount-o;const a=s.removed.length+i.removed.length-o;if(s.addedCount||a){let e=i.removed;if(s.index<i.index){const t=s.removed.slice(0,i.index-s.index);gm.apply(t,e),e=t}if(s.index+s.removed.length>i.index+i.addedCount){const t=s.removed.slice(i.index+i.addedCount-s.index);gm.apply(e,t)}s.removed=e,i.index<s.index&&(s.index=i.index)}else n=!0}else if(s.index<i.index){n=!0,e.splice(t,0,s),t++;const o=s.addedCount-s.removed.length;i.index+=o,r+=o}}var a,l,d,c;n||e.push(s)}let vm=!1;function mm(e,t){let i=e.index;const o=t.length;return i>o?i=o-e.addedCount:i<0&&(i=o+e.removed.length+i-e.addedCount),i<0&&(i=0),e.index=i,e}class bm extends gs{constructor(e){super(e),this.oldCollection=void 0,this.splices=void 0,this.needsQueue=!0,this.call=this.flush,Reflect.defineProperty(e,"$fastController",{value:this,enumerable:!1})}subscribe(e){this.flush(),super.subscribe(e)}addSplice(e){void 0===this.splices?this.splices=[e]:this.splices.push(e),this.needsQueue&&(this.needsQueue=!1,ps.queueUpdate(this))}reset(e){this.oldCollection=e,this.needsQueue&&(this.needsQueue=!1,ps.queueUpdate(this))}flush(){const e=this.splices,t=this.oldCollection;if(void 0===e&&void 0===t)return;this.needsQueue=!0,this.splices=void 0,this.oldCollection=void 0;const i=void 0===t?function(e,t){let i=[];const o=function(e){const t=[];for(let i=0,o=e.length;i<o;i++){const o=e[i];fm(t,o.index,o.removed,o.addedCount)}return t}(t);for(let t=0,s=o.length;t<s;++t){const s=o[t];1!==s.addedCount||1!==s.removed.length?i=i.concat(pm(e,s.index,s.index+s.addedCount,s.removed,0,s.removed.length)):s.removed[0]!==e[s.index]&&i.push(s)}return i}(this.source,e):pm(this.source,0,this.source.length,t,0,t.length);this.notify(i)}}const ym=Object.freeze({positioning:!1,recycle:!0});function wm(e,t,i,o){e.bind(t[i],o)}function xm(e,t,i,o){const s=Object.create(o);s.index=i,s.length=t.length,e.bind(t[i],s)}class km{constructor(e,t,i,o,s,n){this.location=e,this.itemsBinding=t,this.templateBinding=o,this.options=n,this.source=null,this.views=[],this.items=null,this.itemsObserver=null,this.originalContext=void 0,this.childContext=void 0,this.bindView=wm,this.itemsBindingObserver=vs.binding(t,this,i),this.templateBindingObserver=vs.binding(o,this,s),n.positioning&&(this.bindView=xm)}bind(e,t){this.source=e,this.originalContext=t,this.childContext=Object.create(t),this.childContext.parent=e,this.childContext.parentContext=this.originalContext,this.items=this.itemsBindingObserver.observe(e,this.originalContext),this.template=this.templateBindingObserver.observe(e,this.originalContext),this.observeItems(!0),this.refreshAllViews()}unbind(){this.source=null,this.items=null,null!==this.itemsObserver&&this.itemsObserver.unsubscribe(this),this.unbindAllViews(),this.itemsBindingObserver.disconnect(),this.templateBindingObserver.disconnect()}handleChange(e,t){e===this.itemsBinding?(this.items=this.itemsBindingObserver.observe(this.source,this.originalContext),this.observeItems(),this.refreshAllViews()):e===this.templateBinding?(this.template=this.templateBindingObserver.observe(this.source,this.originalContext),this.refreshAllViews(!0)):this.updateViews(t)}observeItems(e=!1){if(!this.items)return void(this.items=ns);const t=this.itemsObserver,i=this.itemsObserver=vs.getNotifier(this.items),o=t!==i;o&&null!==t&&t.unsubscribe(this),(o||e)&&i.subscribe(this)}updateViews(e){const t=this.childContext,i=this.views,o=this.bindView,s=this.items,n=this.template,r=this.options.recycle,a=[];let l=0,d=0;for(let c=0,h=e.length;c<h;++c){const h=e[c],u=h.removed;let p=0,g=h.index;const f=g+h.addedCount,v=i.splice(h.index,u.length),m=d=a.length+v.length;for(;g<f;++g){const e=i[g],c=e?e.firstChild:this.location;let h;r&&d>0?(p<=m&&v.length>0?(h=v[p],p++):(h=a[l],l++),d--):h=n.create(),i.splice(g,0,h),o(h,s,g,t),h.insertBefore(c)}v[p]&&a.push(...v.slice(p))}for(let e=l,t=a.length;e<t;++e)a[e].dispose();if(this.options.positioning)for(let e=0,t=i.length;e<t;++e){const o=i[e].context;o.length=t,o.index=e}}refreshAllViews(e=!1){const t=this.items,i=this.childContext,o=this.template,s=this.location,n=this.bindView;let r=t.length,a=this.views,l=a.length;if(0!==r&&!e&&this.options.recycle||(Or.disposeContiguousBatch(a),l=0),0===l){this.views=a=new Array(r);for(let e=0;e<r;++e){const r=o.create();n(r,t,e,i),a[e]=r,r.insertBefore(s)}}else{let e=0;for(;e<r;++e)if(e<l)n(a[e],t,e,i);else{const r=o.create();n(r,t,e,i),a.push(r),r.insertBefore(s)}const d=a.splice(e,l-e);for(e=0,r=d.length;e<r;++e)d[e].dispose()}}unbindAllViews(){const e=this.views;for(let t=0,i=e.length;t<i;++t)e[t].unbind()}}class Cm extends cr{constructor(e,t,i){super(),this.itemsBinding=e,this.templateBinding=t,this.options=i,this.createPlaceholder=ps.createBlockPlaceholder,function(){if(vm)return;vm=!0,vs.setArrayObserverFactory((e=>new bm(e)));const e=Array.prototype;if(e.$fastPatch)return;Reflect.defineProperty(e,"$fastPatch",{value:1,enumerable:!1});const t=e.pop,i=e.push,o=e.reverse,s=e.shift,n=e.sort,r=e.splice,a=e.unshift;e.pop=function(){const e=this.length>0,i=t.apply(this,arguments),o=this.$fastController;return void 0!==o&&e&&o.addSplice(lm(this.length,[i],0)),i},e.push=function(){const e=i.apply(this,arguments),t=this.$fastController;return void 0!==t&&t.addSplice(mm(lm(this.length-arguments.length,[],arguments.length),this)),e},e.reverse=function(){let e;const t=this.$fastController;void 0!==t&&(t.flush(),e=this.slice());const i=o.apply(this,arguments);return void 0!==t&&t.reset(e),i},e.shift=function(){const e=this.length>0,t=s.apply(this,arguments),i=this.$fastController;return void 0!==i&&e&&i.addSplice(lm(0,[t],0)),t},e.sort=function(){let e;const t=this.$fastController;void 0!==t&&(t.flush(),e=this.slice());const i=n.apply(this,arguments);return void 0!==t&&t.reset(e),i},e.splice=function(){const e=r.apply(this,arguments),t=this.$fastController;return void 0!==t&&t.addSplice(mm(lm(+arguments[0],e,arguments.length>2?arguments.length-2:0),this)),e},e.unshift=function(){const e=a.apply(this,arguments),t=this.$fastController;return void 0!==t&&t.addSplice(mm(lm(0,[],arguments.length),this)),e}}(),this.isItemsBindingVolatile=vs.isVolatileBinding(e),this.isTemplateBindingVolatile=vs.isVolatileBinding(t)}createBehavior(e){return new km(e,this.itemsBinding,this.isItemsBindingVolatile,this.templateBinding,this.isTemplateBindingVolatile,this.options)}}function $m(e,t,i=ym){return new Cm(e,"function"==typeof t?t:()=>t,Object.assign(Object.assign({},ym),i))}const Sm="sticky",_m="default",Im="columnheader",Tm="default",Dm=Rr`
    <template>
        ${e=>null===e.rowData||null===e.columnDefinition||null===e.columnDefinition.columnDataKey?null:e.rowData[e.columnDefinition.columnDataKey]}
    </template>
`,Pm=Rr`
    <template>
        ${e=>null===e.columnDefinition?null:void 0===e.columnDefinition.title?e.columnDefinition.columnDataKey:e.columnDefinition.title}
    </template>
`;class Lm extends Ln{constructor(){super(...arguments),this.cellType=_m,this.rowData=null,this.columnDefinition=null,this.isActiveCell=!1,this.customCellView=null,this.updateCellStyle=()=>{this.style.gridColumn=this.gridColumn}}cellTypeChanged(){this.$fastController.isConnected&&this.updateCellView()}gridColumnChanged(){this.$fastController.isConnected&&this.updateCellStyle()}columnDefinitionChanged(e,t){this.$fastController.isConnected&&this.updateCellView()}connectedCallback(){var e;super.connectedCallback(),this.addEventListener(jf,this.handleFocusin),this.addEventListener(qf,this.handleFocusout),this.addEventListener(Zf,this.handleKeydown),this.style.gridColumn=`${void 0===(null===(e=this.columnDefinition)||void 0===e?void 0:e.gridColumn)?0:this.columnDefinition.gridColumn}`,this.updateCellView(),this.updateCellStyle()}disconnectedCallback(){super.disconnectedCallback(),this.removeEventListener(jf,this.handleFocusin),this.removeEventListener(qf,this.handleFocusout),this.removeEventListener(Zf,this.handleKeydown),this.disconnectCellView()}handleFocusin(e){if(!this.isActiveCell){if(this.isActiveCell=!0,this.cellType===Im){if(null!==this.columnDefinition&&!0!==this.columnDefinition.headerCellInternalFocusQueue&&"function"==typeof this.columnDefinition.headerCellFocusTargetCallback){const e=this.columnDefinition.headerCellFocusTargetCallback(this);null!==e&&e.focus()}}else if(null!==this.columnDefinition&&!0!==this.columnDefinition.cellInternalFocusQueue&&"function"==typeof this.columnDefinition.cellFocusTargetCallback){const e=this.columnDefinition.cellFocusTargetCallback(this);null!==e&&e.focus()}this.$emit("cell-focused",this)}}handleFocusout(e){this===document.activeElement||this.contains(document.activeElement)||(this.isActiveCell=!1)}handleKeydown(e){if(!(e.defaultPrevented||null===this.columnDefinition||this.cellType===_m&&!0!==this.columnDefinition.cellInternalFocusQueue||this.cellType===Im&&!0!==this.columnDefinition.headerCellInternalFocusQueue))switch(e.key){case vu:case"F2":if(this.contains(document.activeElement)&&document.activeElement!==this)return;if(this.cellType===Im){if(void 0!==this.columnDefinition.headerCellFocusTargetCallback){const t=this.columnDefinition.headerCellFocusTargetCallback(this);null!==t&&t.focus(),e.preventDefault()}}else if(void 0!==this.columnDefinition.cellFocusTargetCallback){const t=this.columnDefinition.cellFocusTargetCallback(this);null!==t&&t.focus(),e.preventDefault()}break;case mu:this.contains(document.activeElement)&&document.activeElement!==this&&(this.focus(),e.preventDefault())}}updateCellView(){if(this.disconnectCellView(),null!==this.columnDefinition)switch(this.cellType){case Im:void 0!==this.columnDefinition.headerCellTemplate?this.customCellView=this.columnDefinition.headerCellTemplate.render(this,this):this.customCellView=Pm.render(this,this);break;case void 0:case"rowheader":case _m:void 0!==this.columnDefinition.cellTemplate?this.customCellView=this.columnDefinition.cellTemplate.render(this,this):this.customCellView=Dm.render(this,this)}}disconnectCellView(){null!==this.customCellView&&(this.customCellView.dispose(),this.customCellView=null)}}Ms([Os({attribute:"cell-type"})],Lm.prototype,"cellType",void 0),Ms([Os({attribute:"grid-column"})],Lm.prototype,"gridColumn",void 0),Ms([ms],Lm.prototype,"rowData",void 0),Ms([ms],Lm.prototype,"columnDefinition",void 0);class Em extends Ln{constructor(){super(...arguments),this.rowType=Tm,this.rowData=null,this.columnDefinitions=null,this.isActiveRow=!1,this.cellsRepeatBehavior=null,this.cellsPlaceholder=null,this.focusColumnIndex=0,this.refocusOnLoad=!1,this.updateRowStyle=()=>{this.style.gridTemplateColumns=this.gridTemplateColumns}}gridTemplateColumnsChanged(){this.$fastController.isConnected&&this.updateRowStyle()}rowTypeChanged(){this.$fastController.isConnected&&this.updateItemTemplate()}rowDataChanged(){null!==this.rowData&&this.isActiveRow&&(this.refocusOnLoad=!0)}cellItemTemplateChanged(){this.updateItemTemplate()}headerCellItemTemplateChanged(){this.updateItemTemplate()}connectedCallback(){super.connectedCallback(),null===this.cellsRepeatBehavior&&(this.cellsPlaceholder=document.createComment(""),this.appendChild(this.cellsPlaceholder),this.updateItemTemplate(),this.cellsRepeatBehavior=new Cm((e=>e.columnDefinitions),(e=>e.activeCellItemTemplate),{positioning:!0}).createBehavior(this.cellsPlaceholder),this.$fastController.addBehaviors([this.cellsRepeatBehavior])),this.addEventListener("cell-focused",this.handleCellFocus),this.addEventListener(qf,this.handleFocusout),this.addEventListener(Zf,this.handleKeydown),this.updateRowStyle(),this.refocusOnLoad&&(this.refocusOnLoad=!1,this.cellElements.length>this.focusColumnIndex&&this.cellElements[this.focusColumnIndex].focus())}disconnectedCallback(){super.disconnectedCallback(),this.removeEventListener("cell-focused",this.handleCellFocus),this.removeEventListener(qf,this.handleFocusout),this.removeEventListener(Zf,this.handleKeydown)}handleFocusout(e){this.contains(e.target)||(this.isActiveRow=!1,this.focusColumnIndex=0)}handleCellFocus(e){this.isActiveRow=!0,this.focusColumnIndex=this.cellElements.indexOf(e.target),this.$emit("row-focused",this)}handleKeydown(e){if(e.defaultPrevented)return;let t=0;switch(e.key){case pu:t=Math.max(0,this.focusColumnIndex-1),this.cellElements[t].focus(),e.preventDefault();break;case gu:t=Math.min(this.cellElements.length-1,this.focusColumnIndex+1),this.cellElements[t].focus(),e.preventDefault();break;case bu:e.ctrlKey||(this.cellElements[0].focus(),e.preventDefault());break;case yu:e.ctrlKey||(this.cellElements[this.cellElements.length-1].focus(),e.preventDefault())}}updateItemTemplate(){this.activeCellItemTemplate=this.rowType===Tm&&void 0!==this.cellItemTemplate?this.cellItemTemplate:this.rowType===Tm&&void 0===this.cellItemTemplate?this.defaultCellItemTemplate:void 0!==this.headerCellItemTemplate?this.headerCellItemTemplate:this.defaultHeaderCellItemTemplate}}Ms([Os({attribute:"grid-template-columns"})],Em.prototype,"gridTemplateColumns",void 0),Ms([Os({attribute:"row-type"})],Em.prototype,"rowType",void 0),Ms([ms],Em.prototype,"rowData",void 0),Ms([ms],Em.prototype,"columnDefinitions",void 0),Ms([ms],Em.prototype,"cellItemTemplate",void 0),Ms([ms],Em.prototype,"headerCellItemTemplate",void 0),Ms([ms],Em.prototype,"rowIndex",void 0),Ms([ms],Em.prototype,"isActiveRow",void 0),Ms([ms],Em.prototype,"activeCellItemTemplate",void 0),Ms([ms],Em.prototype,"defaultCellItemTemplate",void 0),Ms([ms],Em.prototype,"defaultHeaderCellItemTemplate",void 0),Ms([ms],Em.prototype,"cellElements",void 0);class Om extends Ln{constructor(){super(),this.noTabbing=!1,this.generateHeader="default",this.rowsData=[],this.columnDefinitions=null,this.focusRowIndex=0,this.focusColumnIndex=0,this.rowsPlaceholder=null,this.generatedHeader=null,this.isUpdatingFocus=!1,this.pendingFocusUpdate=!1,this.rowindexUpdateQueued=!1,this.columnDefinitionsStale=!0,this.generatedGridTemplateColumns="",this.focusOnCell=(e,t,i)=>{if(0===this.rowElements.length)return this.focusRowIndex=0,void(this.focusColumnIndex=0);const o=Math.max(0,Math.min(this.rowElements.length-1,e)),s=this.rowElements[o].querySelectorAll('[role="cell"], [role="gridcell"], [role="columnheader"], [role="rowheader"]'),n=s[Math.max(0,Math.min(s.length-1,t))];i&&this.scrollHeight!==this.clientHeight&&(o<this.focusRowIndex&&this.scrollTop>0||o>this.focusRowIndex&&this.scrollTop<this.scrollHeight-this.clientHeight)&&n.scrollIntoView({block:"center",inline:"center"}),n.focus()},this.onChildListChange=(e,t)=>{e&&e.length&&(e.forEach((e=>{e.addedNodes.forEach((e=>{1===e.nodeType&&"row"===e.getAttribute("role")&&(e.columnDefinitions=this.columnDefinitions)}))})),this.queueRowIndexUpdate())},this.queueRowIndexUpdate=()=>{this.rowindexUpdateQueued||(this.rowindexUpdateQueued=!0,ps.queueUpdate(this.updateRowIndexes))},this.updateRowIndexes=()=>{let e=this.gridTemplateColumns;if(void 0===e){if(""===this.generatedGridTemplateColumns&&this.rowElements.length>0){const e=this.rowElements[0];this.generatedGridTemplateColumns=new Array(e.cellElements.length).fill("1fr").join(" ")}e=this.generatedGridTemplateColumns}this.rowElements.forEach(((t,i)=>{const o=t;o.rowIndex=i,o.gridTemplateColumns=e,this.columnDefinitionsStale&&(o.columnDefinitions=this.columnDefinitions)})),this.rowindexUpdateQueued=!1,this.columnDefinitionsStale=!1}}static generateTemplateColumns(e){let t="";return e.forEach((e=>{t=`${t}${""===t?"":" "}1fr`})),t}noTabbingChanged(){this.$fastController.isConnected&&(this.noTabbing?this.setAttribute("tabIndex","-1"):this.setAttribute("tabIndex",this.contains(document.activeElement)||this===document.activeElement?"-1":"0"))}generateHeaderChanged(){this.$fastController.isConnected&&this.toggleGeneratedHeader()}gridTemplateColumnsChanged(){this.$fastController.isConnected&&this.updateRowIndexes()}rowsDataChanged(){null===this.columnDefinitions&&this.rowsData.length>0&&(this.columnDefinitions=Om.generateColumns(this.rowsData[0])),this.$fastController.isConnected&&this.toggleGeneratedHeader()}columnDefinitionsChanged(){null!==this.columnDefinitions?(this.generatedGridTemplateColumns=Om.generateTemplateColumns(this.columnDefinitions),this.$fastController.isConnected&&(this.columnDefinitionsStale=!0,this.queueRowIndexUpdate())):this.generatedGridTemplateColumns=""}headerCellItemTemplateChanged(){this.$fastController.isConnected&&null!==this.generatedHeader&&(this.generatedHeader.headerCellItemTemplate=this.headerCellItemTemplate)}focusRowIndexChanged(){this.$fastController.isConnected&&this.queueFocusUpdate()}focusColumnIndexChanged(){this.$fastController.isConnected&&this.queueFocusUpdate()}connectedCallback(){super.connectedCallback(),void 0===this.rowItemTemplate&&(this.rowItemTemplate=this.defaultRowItemTemplate),this.rowsPlaceholder=document.createComment(""),this.appendChild(this.rowsPlaceholder),this.toggleGeneratedHeader(),this.rowsRepeatBehavior=new Cm((e=>e.rowsData),(e=>e.rowItemTemplate),{positioning:!0}).createBehavior(this.rowsPlaceholder),this.$fastController.addBehaviors([this.rowsRepeatBehavior]),this.addEventListener("row-focused",this.handleRowFocus),this.addEventListener(Hf,this.handleFocus),this.addEventListener(Zf,this.handleKeydown),this.addEventListener(qf,this.handleFocusOut),this.observer=new MutationObserver(this.onChildListChange),this.observer.observe(this,{childList:!0}),this.noTabbing&&this.setAttribute("tabindex","-1"),ps.queueUpdate(this.queueRowIndexUpdate)}disconnectedCallback(){super.disconnectedCallback(),this.removeEventListener("row-focused",this.handleRowFocus),this.removeEventListener(Hf,this.handleFocus),this.removeEventListener(Zf,this.handleKeydown),this.removeEventListener(qf,this.handleFocusOut),this.observer.disconnect(),this.rowsPlaceholder=null,this.generatedHeader=null}handleRowFocus(e){this.isUpdatingFocus=!0;const t=e.target;this.focusRowIndex=this.rowElements.indexOf(t),this.focusColumnIndex=t.focusColumnIndex,this.setAttribute("tabIndex","-1"),this.isUpdatingFocus=!1}handleFocus(e){this.focusOnCell(this.focusRowIndex,this.focusColumnIndex,!0)}handleFocusOut(e){null!==e.relatedTarget&&this.contains(e.relatedTarget)||this.setAttribute("tabIndex",this.noTabbing?"-1":"0")}handleKeydown(e){if(e.defaultPrevented)return;let t;const i=this.rowElements.length-1,o=this.offsetHeight+this.scrollTop,s=this.rowElements[i];switch(e.key){case fu:e.preventDefault(),this.focusOnCell(this.focusRowIndex-1,this.focusColumnIndex,!0);break;case uu:e.preventDefault(),this.focusOnCell(this.focusRowIndex+1,this.focusColumnIndex,!0);break;case"PageUp":if(e.preventDefault(),0===this.rowElements.length){this.focusOnCell(0,0,!1);break}if(0===this.focusRowIndex)return void this.focusOnCell(0,this.focusColumnIndex,!1);for(t=this.focusRowIndex-1;t>=0;t--){const e=this.rowElements[t];if(e.offsetTop<this.scrollTop){this.scrollTop=e.offsetTop+e.clientHeight-this.clientHeight;break}}this.focusOnCell(t,this.focusColumnIndex,!1);break;case"PageDown":if(e.preventDefault(),0===this.rowElements.length){this.focusOnCell(0,0,!1);break}if(this.focusRowIndex>=i||s.offsetTop+s.offsetHeight<=o)return void this.focusOnCell(i,this.focusColumnIndex,!1);for(t=this.focusRowIndex+1;t<=i;t++){const e=this.rowElements[t];if(e.offsetTop+e.offsetHeight>o){let t=0;this.generateHeader===Sm&&null!==this.generatedHeader&&(t=this.generatedHeader.clientHeight),this.scrollTop=e.offsetTop-t;break}}this.focusOnCell(t,this.focusColumnIndex,!1);break;case bu:e.ctrlKey&&(e.preventDefault(),this.focusOnCell(0,0,!0));break;case yu:e.ctrlKey&&null!==this.columnDefinitions&&(e.preventDefault(),this.focusOnCell(this.rowElements.length-1,this.columnDefinitions.length-1,!0))}}queueFocusUpdate(){this.isUpdatingFocus&&(this.contains(document.activeElement)||this===document.activeElement)||!1===this.pendingFocusUpdate&&(this.pendingFocusUpdate=!0,ps.queueUpdate((()=>this.updateFocus())))}updateFocus(){this.pendingFocusUpdate=!1,this.focusOnCell(this.focusRowIndex,this.focusColumnIndex,!0)}toggleGeneratedHeader(){if(null!==this.generatedHeader&&(this.removeChild(this.generatedHeader),this.generatedHeader=null),"none"!==this.generateHeader&&this.rowsData.length>0){const e=document.createElement(this.rowElementTag);return this.generatedHeader=e,this.generatedHeader.columnDefinitions=this.columnDefinitions,this.generatedHeader.gridTemplateColumns=this.gridTemplateColumns,this.generatedHeader.rowType=this.generateHeader===Sm?"sticky-header":"header",void(null===this.firstChild&&null===this.rowsPlaceholder||this.insertBefore(e,null!==this.firstChild?this.firstChild:this.rowsPlaceholder))}}}Om.generateColumns=e=>Object.getOwnPropertyNames(e).map(((e,t)=>({columnDataKey:e,gridColumn:`${t}`}))),Ms([Os({attribute:"no-tabbing",mode:"boolean"})],Om.prototype,"noTabbing",void 0),Ms([Os({attribute:"generate-header"})],Om.prototype,"generateHeader",void 0),Ms([Os({attribute:"grid-template-columns"})],Om.prototype,"gridTemplateColumns",void 0),Ms([ms],Om.prototype,"rowsData",void 0),Ms([ms],Om.prototype,"columnDefinitions",void 0),Ms([ms],Om.prototype,"rowItemTemplate",void 0),Ms([ms],Om.prototype,"cellItemTemplate",void 0),Ms([ms],Om.prototype,"headerCellItemTemplate",void 0),Ms([ms],Om.prototype,"focusRowIndex",void 0),Ms([ms],Om.prototype,"focusColumnIndex",void 0),Ms([ms],Om.prototype,"defaultRowItemTemplate",void 0),Ms([ms],Om.prototype,"rowElementTag",void 0),Ms([ms],Om.prototype,"rowElements",void 0);const Fm=Rr`
    <div
        class="title"
        part="title"
        aria-label="${e=>e.dateFormatter.getDate(`${e.month}-2-${e.year}`,{month:"long",year:"numeric"})}"
    >
        <span part="month">
            ${e=>e.dateFormatter.getMonth(e.month)}
        </span>
        <span part="year">${e=>e.dateFormatter.getYear(e.year)}</span>
    </div>
`,Am=(e,t)=>{const i=e.tagFor(Om),o=e.tagFor(Em);return Rr`
    <${i} class="days interact" part="days" generate-header="none">
        <${o}
            class="week-days"
            part="week-days"
            role="row"
            row-type="header"
            grid-template-columns="1fr 1fr 1fr 1fr 1fr 1fr 1fr"
        >
            ${$m((e=>e.getWeekdayText()),(e=>{const t=e.tagFor(Lm);return Rr`
        <${t}
            class="week-day"
            part="week-day"
            tabindex="-1"
            grid-column="${(e,t)=>t.index+1}"
            abbr="${e=>e.abbr}"
        >
            ${e=>e.text}
        </${t}>
    `})(e),{positioning:!0})}
        </${o}>
        ${$m((e=>e.getDays()),((e,t)=>{const i=e.tagFor(Em);return Rr`
        <${i}
            class="week"
            part="week"
            role="row"
            role-type="default"
            grid-template-columns="1fr 1fr 1fr 1fr 1fr 1fr 1fr"
        >
        ${$m((e=>e),((e,t)=>{const i=e.tagFor(Lm);return Rr`
        <${i}
            class="${(e,i)=>i.parentContext.parent.getDayClassNames(e,t)}"
            part="day"
            tabindex="-1"
            role="gridcell"
            grid-column="${(e,t)=>t.index+1}"
            @click="${(e,t)=>t.parentContext.parent.handleDateSelect(t.event,e)}"
            @keydown="${(e,t)=>t.parentContext.parent.handleKeydown(t.event,e)}"
            aria-label="${(e,t)=>t.parentContext.parent.dateFormatter.getDate(`${e.month}-${e.day}-${e.year}`,{month:"long",day:"numeric"})}"
        >
            <div
                class="date"
                part="${e=>t===`${e.month}-${e.day}-${e.year}`?"today":"date"}"
            >
                ${(e,t)=>t.parentContext.parent.dateFormatter.getDay(e.day)}
            </div>
            <slot name="${e=>e.month}-${e=>e.day}-${e=>e.year}"></slot>
        </${i}>
    `})(e,t),{positioning:!0})}
        </${i}>
    `})(e,t))}
    </${i}>
`},Rm=ih`
.day.disabled::before {
  transform: translate(-50%, 0) rotate(45deg);
}
`,Vm=ih`
.day.disabled::before {
  transform: translate(50%, 0) rotate(-45deg);
}
`;class Mm extends am{constructor(){super(...arguments),this.readonly=!0}}i([Os({converter:Ps})],Mm.prototype,"readonly",void 0);const zm=Mm.compose({baseName:"calendar",template:(e,t)=>{var i;const o=new Date,s=`${o.getMonth()+1}-${o.getDate()}-${o.getFullYear()}`;return Rr`
        <template>
            ${du}
            ${t.title instanceof Function?t.title(e,t):null!==(i=t.title)&&void 0!==i?i:""}
            <slot></slot>
            ${eu((e=>e.readonly),(e=>Rr`
        <div class="days" part="days">
            <div class="week-days" part="week-days">
                ${$m((e=>e.getWeekdayText()),Rr`
                        <div class="week-day" part="week-day" abbr="${e=>e.abbr}">
                            ${e=>e.text}
                        </div>
                    `)}
            </div>
            ${$m((e=>e.getDays()),Rr`
                    <div class="week">
                        ${$m((e=>e),Rr`
                                <div
                                    class="${(t,i)=>i.parentContext.parent.getDayClassNames(t,e)}"
                                    part="day"
                                    aria-label="${(e,t)=>t.parentContext.parent.dateFormatter.getDate(`${e.month}-${e.day}-${e.year}`,{month:"long",day:"numeric"})}"
                                >
                                    <div
                                        class="date"
                                        part="${t=>e===`${t.month}-${t.day}-${t.year}`?"today":"date"}"
                                    >
                                        ${(e,t)=>t.parentContext.parent.dateFormatter.getDay(e.day)}
                                    </div>
                                    <slot
                                        name="${e=>e.month}-${e=>e.day}-${e=>e.year}"
                                    ></slot>
                                </div>
                            `)}
                    </div>
                `)}
        </div>
    `)(s),Am(e,s))}
            ${lu}
        </template>
    `},styles:(e,t)=>ih`
${nh("inline-block")} :host {
  --calendar-cell-size: calc((${Oa} + 2 + ${Fa}) * ${Aa} * 1px);
  --calendar-gap: 2px;
  ${Bu}
  color: ${xc};
}

.title {
  padding: calc(${Aa} * 2px);
  font-weight: 600;
}

.days {
  text-align: center;
}

.week-days,
.week {
  display: grid;
  grid-template-columns: repeat(7, 1fr);
  grid-gap: var(--calendar-gap);
  border: 0;
  padding: 0;
}

.day,
.week-day {
  border: 0;
  width: var(--calendar-cell-size);
  height: var(--calendar-cell-size);
  line-height: var(--calendar-cell-size);
  padding: 0;
  box-sizing: initial;
}

.week-day {
  font-weight: 600;
}

.day {
  border: calc(${Ma} * 1px) solid transparent;
  border-radius: calc(${Ra} * 1px);
}

.interact .day {
  cursor: pointer;
}

.date {
  height: 100%;
}

.inactive .date,
.inactive.disabled::before {
  color: ${Sc};
}

.disabled::before {
  content: '';
  display: inline-block;
  width: calc(var(--calendar-cell-size) * .8);
  height: calc(${Ma} * 1px);
  background: currentColor;
  position: absolute;
  margin-top: calc(var(--calendar-cell-size) / 2);
  transform-origin: center;
  z-index: 1;
}

.selected {
  color: ${Dd};
  border: 1px solid ${Dd};
  background: ${_d};
}

.selected + .selected {
  border-start-start-radius: 0;
  border-end-start-radius: 0;
  border-inline-start-width: 0;
  padding-inline-start: calc(var(--calendar-gap) + (${Ma} + ${Ra}) * 1px);
  margin-inline-start: calc((${Ra} * -1px) - var(--calendar-gap));
}

.today.disabled::before {
  color: ${Fd};
}

.today .date {
  color: ${Fd};
  background: ${Dd};
  border-radius: 50%;
  position: relative;
}
`.withBehaviors(lh(ih`
          .day.selected {
              color: ${dh.Highlight};
          }

          .today .date {
              background: ${dh.Highlight};
              color: ${dh.HighlightText};
          }
      `),new ag(Rm,Vm)),title:Fm});var Nm=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Um=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(Kg,Ju,zm);class Bm extends Nt{get strings(){return nm}constructor(){super(),this.handleTaskClick=e=>{this.fireCustomEvent("taskClick",{task:e})},this.onResize=()=>{this.mediaQuery!==this._previousMediaQuery&&(this._previousMediaQuery=this.mediaQuery,this.requestUpdate())},this.clearState(),this._previousMediaQuery=this.mediaQuery}attributeChangedCallback(e,t,i){switch(super.attributeChangedCallback(e,t,i),e){case"target-id":case"initial-id":this.clearState(),this.requestStateUpdate()}}connectedCallback(){super.connectedCallback(),window.addEventListener("resize",this.onResize)}disconnectedCallback(){window.removeEventListener("resize",this.onResize),super.disconnectedCallback()}render(){const e=te.globalProvider;if(!e||e.state!==Q.SignedIn)return Je``;if(this.isLoadingState)return this.renderLoadingTask();const t=this.renderPicker(),i=this.renderNewTask(),o=this.isLoadingState?this.renderLoadingTask():this.renderTasks();return Je`
      ${t}
      ${i}
      <div class="tasks" dir=${this.direction}>
        ${o}
      </div>
    `}renderLoadingTask(){return Je`
      <div class="task loading-task">
        <div class="task-details">
          <div class="title"></div>
          <div class="task-due"></div>
          <div class="task-delete"></div>
        </div>
      </div>
    `}clearState(){this.requestUpdate()}dateToInputValue(e){return e?new Date(e.getTime()-6e4*e.getTimezoneOffset()).toISOString().split("T")[0]:null}}Nm([Ct({attribute:"read-only",type:Boolean}),Um("design:type",Boolean)],Bm.prototype,"readOnly",void 0),Nm([Ct({attribute:"hide-header",type:Boolean}),Um("design:type",Boolean)],Bm.prototype,"hideHeader",void 0),Nm([Ct({attribute:"hide-options",type:Boolean}),Um("design:type",Boolean)],Bm.prototype,"hideOptions",void 0),Nm([Ct({attribute:"target-id",type:String}),Um("design:type",String)],Bm.prototype,"targetId",void 0),Nm([Ct({attribute:"initial-id",type:String}),Um("design:type",String)],Bm.prototype,"initialId",void 0);var Hm=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};const jm=(e,t)=>Hm(void 0,void 0,void 0,(function*(){const i=yield e.api(`/me/todo/lists/${t}/tasks`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get();return null==i?void 0:i.value})),qm=(e,t)=>Hm(void 0,void 0,void 0,(function*(){return yield e.api(`/me/todo/lists/${t}`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get()})),Zm=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host{display:flex;flex-direction:column;color:var(--color,var(--neutral-foreground-rest))}:host input[type=date]::-webkit-calendar-picker-indicator,:host input[type=date]::-webkit-inner-spin-button{display:none;appearance:none}:host .task-icon{font-family:FabricMDL2Icons;user-select:none}:host .task-icon.divider{vertical-align:initial;margin:0 12px;font-size:16px}:host .header{margin:var(--tasks-header-margin,0 0 12px 0);padding:var(--tasks-title-padding,0);display:flex;align-items:center;justify-content:space-between}:host .header .header__loading{max-width:90px;width:100%;height:20px;background:#f2f2f2}:host .header select{font-size:var(--tasks-plan-title-font-size,1.1em);padding:var(--tasks-plan-title-padding,5px);border:none;appearance:none;cursor:pointer}:host .header select::-ms-expand{display:none}:host .header .plan-title{font-size:var(--tasks-plan-title-font-size,1.1em);padding:var(--tasks-plan-title-padding,5px)}:host .header .add-bar{display:flex}:host .header .add-bar .add-bar-item{flex:1 1 auto}:host .header .new-task-due{display:flex}:host .header .new-task-due input{flex:1 1 auto;background-color:var(--task-background-color,var(--neutral-layer-floating))}:host .header .title-cont{flex:1 1 auto;display:flex;align-items:center;height:var(--tasks-new-button-height,34px)}:host .header .new-task-button{flex:0 0 auto;display:flex;justify-content:center;align-items:center;width:var(--tasks-new-button-width,auto);height:var(--tasks-new-button-height,32px);border-radius:2px;padding:0 20px;background:var(--tasks-new-button-background,#0078d4);border:var(--tasks-new-button-border,solid 1px transparent);color:var(--tasks-new-button-color,#fff);user-select:none;cursor:pointer}:host .header .new-task-button span{font-size:14px;font-weight:600;letter-spacing:.1px;line-height:14px}:host .header .new-task-button .task-icon{margin-right:8px}:host .header .new-task-button.hidden{visibility:hidden}:host .header .new-task-button:hover{background:var(--tasks-new-button-hover-background,#106ebe)}:host .header .new-task-button:active{background:var(--tasks-new-button-active-background,#005a9e)}:host .task{position:relative;margin:var(--task-margin,0 0 0 0);padding:var(--task-padding,0 0 0 0);background-color:var(--task-background-color,var(--neutral-layer-floating));border:var(--task-border,var(--neutral-stroke-input-active));border-radius:8px}:host .task .task-content{display:flex}:host .task .task-content .divider{position:absolute;height:2px;left:0;right:0;bottom:0;background-color:var(--task-background-color,var(--neutral-layer-floating))}:host .task .task-content .task-details-container{flex:1;display:grid;grid-template-columns:auto 1fr;-ms-grid-columns:auto 1fr;grid-template-rows:auto auto auto auto;-ms-grid-rows:auto auto auto auto;justify-content:space-between;align-items:flex-start;color:var(--task-detail-color,var(--neutral-foreground-hint));font-size:12px;font-weight:600;white-space:normal;margin-bottom:12px}:host .task .task-content .task-details-container .task-detail{width:100%;height:100%;margin:4px 24px 6px 0;display:flex;justify-content:flex-start;align-items:center}:host .task .task-content .task-details-container .task-title{color:var(--task-color,var(--neutral-foreground-rest));font-size:14px;font-weight:600;grid-row:1;grid-column:1/3;grid-column:1;-ms-grid-column-span:2;margin:22px 0 4px}:host .task .task-content .task-details-container .task-group{min-height:24px;grid-row:2;grid-column:1}:host .task .task-content .task-details-container .task-bucket{min-height:24px;grid-row:2;grid-column:2}:host .task .task-content .task-details-container .task-due{justify-content:flex-end;align-items:flex-start;grid-row:4;grid-column:1/3;grid-column:1;-ms-grid-column-span:2}:host .task .task-content .task-details-container.tablet{grid-template-columns:1fr .5fr 1fr .5fr;-ms-grid-columns:1fr .5fr 1fr .5fr;grid-template-rows:auto auto;-ms-grid-rows:auto auto}:host .task .task-content .task-details-container.tablet.no-plan{grid-template-columns:0 1fr 1fr 1fr;-ms-grid-columns:0 1fr 1fr 1fr}:host .task .task-content .task-details-container.tablet .task-detail{margin:4px 24px 6px 0}:host .task .task-content .task-details-container.tablet .task-title{grid-row:1;grid-column:1/5;grid-column:1;-ms-grid-column-span:4}:host .task .task-content .task-details-container.tablet .task-group{grid-row:2;grid-column:1}:host .task .task-content .task-details-container.tablet .task-bucket{grid-row:2;grid-column:2}:host .task .task-content .task-details-container.tablet .task-assignee{grid-row:2;grid-column:3}:host .task .task-content .task-details-container.tablet .task-due{justify-content:flex-start;align-items:center;grid-row:2;grid-column:4}:host .task .task-content .task-details-container.desktop{grid-template-columns:2fr 1fr .5fr 1fr .5fr;-ms-grid-columns:2fr 1fr .5fr 1fr .5fr;grid-template-rows:auto;-ms-grid-rows:auto;margin:0}:host .task .task-content .task-details-container.desktop.no-plan{grid-template-columns:2fr 0 1fr 1fr 1fr;-ms-grid-columns:2fr 0 1fr 1fr 1fr}:host .task .task-content .task-details-container.desktop .task-detail{margin:0 24px 0 0}:host .task .task-content .task-details-container.desktop .task-title{padding:0;grid-row:1;grid-column:1}:host .task .task-content .task-details-container.desktop .task-group{min-height:61px;grid-row:1;grid-column:2}:host .task .task-content .task-details-container.desktop .task-bucket{grid-row:1;grid-column:3}:host .task .task-content .task-details-container.desktop .task-assignee{grid-row:1;grid-column:4}:host .task .task-content .task-details-container.desktop .task-due{justify-content:flex-start;align-items:center;grid-row:1;grid-column:5}:host .task .task-content .task-details-container svg{vertical-align:middle;margin-right:4px}:host .task .task-content .task-details-container svg path{fill:var(--task-detail-color,var(--neutral-foreground-hint))}:host .task .task-content .task-details-container select,:host .task .task-content .task-details-container span{vertical-align:middle;color:var(--task-detail-color,var(--neutral-foreground-hint))}:host .task .task-content .task-details-container .task-icon{color:#797775;margin-right:8px}:host .task .task-content .task-details-container .people{color:var(--task-detail-color,var(--neutral-foreground-hint));font-size:16px}:host .task .task-content .task-details-container .person{display:inline-block}:host .task .task-content .task-details-container .picker{background-color:var(--task-background-color,var(--neutral-layer-floating));background-clip:padding-box;width:var(--mgt-flyout-set-width,350px);color:var(--task-detail-color,var(--neutral-foreground-hint))}:host .task .task-content .task-details-container .picker .people-picker{--separator-margin:0px 10px 0px 10px}:host .task .task-content .task-details-container input,:host .task .task-content .task-details-container select{color:var(--task-detail-color,var(--neutral-foreground-hint));font-size:.9em;background-color:var(--task-background-color,var(--neutral-layer-floating))}:host .task .task-check-container{font-family:FabricMDL2Icons;border-radius:50%;color:#fff;cursor:pointer;display:flex;align-items:var(--task-icon-alignment,flex-start);margin:21px 10px 20px 20px;user-select:none}:host .task .task-check-container.complete .task-check{background-color:var(--task-icon-background-completed,#00ad56);border:var(--task-icon-border-completed,solid 1px #fff);color:var(--task-icon-color-completed,#fff)}:host .task .task-check-container.complete .task-content .task-details-container .task-title{text-decoration:line-through;color:var(--task-detail-color,var(--neutral-foreground-hint))}:host .task .task-check-container .task-check{font-family:FabricMDL2Icons;font-size:12px;width:18px;height:18px;border-radius:var(--task-icon-border-radius,50%);border:var(--task-icon-border,solid 1px #797775);color:var(--task-color,var(--neutral-foreground-rest));display:flex;justify-content:center;align-items:center;background-color:var(--task-icon-background,transparent);user-select:none}:host .task .task-check-container .task-check.loading .task-check-content{animation:rotate-icon 2s infinite linear}:host .task .task-options{cursor:pointer;user-select:none;margin:16px 8px 0 0}:host .task.read-only .task-check-container{cursor:default}:host .task.complete{background:var(--task-complete-background,var(--neutral-layer-1));border:var(--task-complete-border,2px dotted inherit)}:host .task.complete .task-content .task-details-container .task-title{text-decoration:line-through;color:var(--task-detail-color,var(--neutral-foreground-hint))}:host .task.new-task{margin:var(--task-new-margin,var(--task-margin,0 0 24px 0));display:flex;flex-direction:row}:host .task.new-task .self-assign{display:none}:host .task.new-task .assign-to{border:0;background:0 0}:host .task.new-task .fake-check-box{width:15px;height:15px;cursor:pointer;margin:0 5px}:host .task.new-task .fake-check-box::after{font-family:FabricMDL2Icons;content:"uE739"}:host .task.new-task .fake-check-box~:checked{font-family:FabricMDL2Icons;content:"uE73A"}:host .task.new-task .task-content{flex:1 1 auto;align-content:center;vertical-align:middle;margin:0 0 0 12px}:host .task.new-task .task-content .task-details-container{display:flex;flex-direction:column;align-items:stretch;margin:0}:host .task.new-task .task-content .task-details-container .task-title{display:flex;height:32px;padding:2px}:host .task.new-task .task-content .task-details-container .task-title input{flex:1;margin:var(--task-new-input-margin,0 24px 0 16px);padding:var(--task-new-input-padding,6px);font-size:var(--task-new-input-font-size,14px);font-weight:600;border:var(--task-new-border,none);border-bottom:1px solid #e1dfdd;outline:0;border-radius:0;background-color:var(--task-background-color,var(--neutral-layer-floating))}:host .task.new-task .task-content .task-details-container .task-title input:hover{border-bottom:1px solid #106ebe}:host .task.new-task .task-content .task-details-container .task-title input:active{border-bottom:1px solid #005a9e}:host .task.new-task .task-content .task-details-container .task-title input:focus{border-bottom:1px solid #0078d4}:host .task.new-task .task-content .task-details-container .task-details{display:flex;justify-content:stretch;align-items:center;flex-wrap:wrap;margin:14px 0 14px 4px}:host .task.new-task .task-content .task-details-container .task-details .new-task-group{margin:8px 16px}:host .task.new-task .task-content .task-details-container .task-details .new-task-bucket{margin:8px 16px}:host .task.new-task .task-content .task-details-container .task-details .new-task-due{margin:8px 16px}:host .task.new-task .task-content .task-details-container .task-details .new-task-assignee{margin:8px 16px;min-width:80px}:host .task.new-task .task-content .task-details-container .task-details .task-people label{display:flex;align-content:center;align-items:center}:host .task.new-task .task-content .task-details-container .task-details input,:host .task.new-task .task-content .task-details-container .task-details select{font-size:12px;font-weight:600;border:var(--task-new-select-border,none);border-bottom:1px solid #e1dfdd}:host .task.new-task .task-content .task-details-container .task-details input:hover,:host .task.new-task .task-content .task-details-container .task-details select:hover{border-bottom:1px solid #106ebe}:host .task.new-task .task-content .task-details-container .task-details input:active,:host .task.new-task .task-content .task-details-container .task-details select:active{border-bottom:1px solid #005a9e}:host .task.new-task .task-content .task-details-container .task-details input:focus,:host .task.new-task .task-content .task-details-container .task-details select:focus{border-bottom:1px solid #0078d4}:host .task.new-task .task-add-button-container{margin-right:28px}:host .task.new-task .task-add-button-container .task-add,:host .task.new-task .task-add-button-container .task-cancel{justify-content:center;align-items:center;cursor:pointer;flex:0 0 auto;display:flex;width:var(--tasks-new-button-width,100px);height:var(--tasks-new-button-height,32px);border-radius:4px;border:var(--tasks-new-button-border,solid 1px #e5e5e5);font-size:14px;line-height:20px}:host .task.new-task .task-add-button-container .task-add{color:#fff;background:var(--task-new-add-button-background,#0078d4);margin:22px 0 12px auto}:host .task.new-task .task-add-button-container .task-cancel{color:var(--task-new-cancel-button-color,var(--neutral-foreground-rest))}:host .task.new-task .task-add-button-container.disabled .task-add{color:var(--task-new-cancel-button-color,var(--neutral-foreground-rest));background:var(--task-new-add-button-disabled-background,#fff);cursor:default}@keyframes rotate-icon{from{transform:rotate(0)}to{transform:rotate(360deg)}}[dir=rtl] .arrow-options{--arrow-options-left:auto}[dir=rtl] .dot-options{--dot-options-translatex:translateX(60px)}[dir=rtl] .task-details{margin-right:14px!important}[dir=rtl] .task-icon{margin-left:8px}[dir=rtl] .task-detail svg{margin-left:4px}@media (forced-colors:active) and (prefers-color-scheme:dark){:host svg{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}:host svg path{fill:#fff!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}@media (forced-colors:active) and (prefers-color-scheme:light){:host svg{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}:host svg path{fill:#000!important;fill-rule:nonzero!important;clip-rule:nonzero!important}}:host{border-radius:8px;width:100%}:host .task,:host.loading-task{margin-block:1px;box-shadow:var(--task-box-shadow,var(--elevation-shadow-card-active));width:100%;background-color:var(--task-background-color,var(--neutral-layer-floating))}:host .task.new-task,:host.loading-task.new-task{margin:14px 0 1px;box-shadow:var(--task-box-shadow,var(--elevation-shadow-card-active))}:host .task.complete,:host.loading-task.complete{text-decoration:line-through;border:1px solid var(--task-border-completed,var(--neutral-stroke-input-active));background:var(--task-complete-background,var(--neutral-layer-1))}:host .task.read-only,:host.loading-task.read-only{opacity:1}:host .task:hover,:host.loading-task:hover{background-color:var(--task-background-color-hover,var(--neutral-fill-hover));border-radius:8px}:host .task .task-details,:host.loading-task .task-details{box-sizing:border-box;display:flex;flex-direction:row;align-items:center;padding:2px;line-height:24px;border-radius:4px}:host .task .task-details .task>div,:host.loading-task .task-details .task>div{display:flex;align-items:center;width:200px}:host .task .task-details .title,:host.loading-task .task-details .title{flex-grow:1}:host .task .task-details .task-delete,:host.loading-task .task-details .task-delete{display:flex}:host .task .task-details .task-due,:host.loading-task .task-details .task-due{min-width:120px;margin-inline-end:12px;height:32px;text-decoration:inherit;display:flex}:host .task .task-details .task-due .task-calendar,:host.loading-task .task-details .task-due .task-calendar{display:flex;margin-top:5px;margin-inline-end:10px}:host .task .task-details .task-due .task-calendar svg,:host.loading-task .task-details .task-due .task-calendar svg{fill:var(--task-color,var(--neutral-foreground-rest))}:host .task .task-details .task-due .task-due-date,:host.loading-task .task-details .task-due .task-due-date{display:flex;margin-top:5px}:host fluent-text-field::part(end),:host fluent-text-field::part(start){margin-inline:unset}:host fluent-text-field::part(control){padding:0;cursor:pointer}:host fluent-text-field::part(root){background:0 0}:host fluent-text-field.new-task{width:100%;height:34px}:host fluent-text-field.new-task div.start .add-icon{display:flex;margin-inline:10px}:host fluent-text-field.new-task div:nth-child(2){display:flex;align-items:center}:host fluent-text-field.new-task div:nth-child(2) .calendar{display:flex;align-items:center}:host fluent-text-field.new-task div:nth-child(2) .calendar svg{fill:var(--task-color,var(--neutral-foreground-rest))}:host fluent-text-field.new-task div:nth-child(2) .calendar .date{margin-inline-start:10px;color:var(--task-color,var(--neutral-foreground-rest));width:auto;cursor:pointer}:host fluent-text-field.new-task div:nth-child(2) .calendar .date::after{border-bottom:none}:host fluent-text-field.new-task div:nth-child(2) .calendar .date.dark::part(control){color-scheme:dark}:host fluent-text-field.new-task div:nth-child(2) .calendar input{flex:1;border:none;border-bottom:1px solid var(--task-color,var(--neutral-foreground-rest));outline:0;border-radius:0}:host fluent-text-field.new-task div:nth-child(2) .calendar input:hover{border-bottom:1px solid var(--task-date-input-hover-color,var(--neutral-layer-1))}:host fluent-text-field.new-task div:nth-child(2) .calendar input:active{border-bottom:1px solid var(--task-date-input-active-color,var(--accent-fill-rest))}:host fluent-text-field.new-task div:nth-child(2) .calendar input:focus{border-bottom:1px solid var(--task-date-input-active-color,var(--accent-fill-rest))}:host fluent-button.task-add-icon.neutral,:host fluent-button.task-cancel-icon.neutral,:host fluent-button.task-delete.neutral{fill:var(--task-color,var(--neutral-foreground-rest))}:host fluent-button.task-add-icon.neutral::part(control),:host fluent-button.task-cancel-icon.neutral::part(control),:host fluent-button.task-delete.neutral::part(control){border:none;background:inherit}:host fluent-button.task-add-icon.neutral::part(control) svg,:host fluent-button.task-cancel-icon.neutral::part(control) svg,:host fluent-button.task-delete.neutral::part(control) svg{fill:var(--task-color,var(--neutral-foreground-rest))}:host fluent-checkbox.task.complete div>svg .filled{display:block}:host fluent-checkbox.task.complete div>svg .regular{display:none}:host fluent-checkbox.task.complete div>svg path{fill:var(--task-radio-background-color,var(--accent-fill-rest))}:host fluent-checkbox.task div>svg .filled{display:none}:host fluent-checkbox.task div>svg .regular{display:block}:host fluent-checkbox.task div>svg path{fill:var(--task-background-color,var(--neutral-layer-floating))}:host fluent-checkbox::part(control){margin-inline-start:10px;background:0 0;border-radius:50%}:host fluent-checkbox::part(label){margin-inline-end:unset;width:100%}
`],Wm={cancelNewTaskSubtitle:"Cancel",newTaskPlaceholder:"Add a task",newTaskLabel:"New Task Input",addTaskButtonSubtitle:"Add",deleteTaskLabel:"Delete Task",dueDate:"Due date",newTaskDateInputLabel:"New Task Date Input",newTaskNameInputLabel:"New Task Name Input",cancelAddingTask:"Cancel adding a new task"};class Gm extends Ln{constructor(){super(...arguments),this.orientation=Nf,this.radioChangeHandler=e=>{const t=e.target;t.checked&&(this.slottedRadioButtons.forEach((e=>{e!==t&&(e.checked=!1,this.isInsideFoundationToolbar||e.setAttribute("tabindex","-1"))})),this.selectedRadio=t,this.value=t.value,t.setAttribute("tabindex","0"),this.focusedRadio=t),e.stopPropagation()},this.moveToRadioByIndex=(e,t)=>{const i=e[t];this.isInsideToolbar||(i.setAttribute("tabindex","0"),i.readOnly?this.slottedRadioButtons.forEach((e=>{e!==i&&e.setAttribute("tabindex","-1")})):(i.checked=!0,this.selectedRadio=i)),this.focusedRadio=i,i.focus()},this.moveRightOffGroup=()=>{var e;null===(e=this.nextElementSibling)||void 0===e||e.focus()},this.moveLeftOffGroup=()=>{var e;null===(e=this.previousElementSibling)||void 0===e||e.focus()},this.focusOutHandler=e=>{const t=this.slottedRadioButtons,i=e.target,o=null!==i?t.indexOf(i):0,s=this.focusedRadio?t.indexOf(this.focusedRadio):-1;return(0===s&&o===s||s===t.length-1&&s===o)&&(this.selectedRadio?(this.focusedRadio=this.selectedRadio,this.isInsideFoundationToolbar||(this.selectedRadio.setAttribute("tabindex","0"),t.forEach((e=>{e!==this.selectedRadio&&e.setAttribute("tabindex","-1")})))):(this.focusedRadio=t[0],this.focusedRadio.setAttribute("tabindex","0"),t.forEach((e=>{e!==this.focusedRadio&&e.setAttribute("tabindex","-1")})))),!0},this.clickHandler=e=>{const t=e.target;if(t){const e=this.slottedRadioButtons;t.checked||0===e.indexOf(t)?(t.setAttribute("tabindex","0"),this.selectedRadio=t):(t.setAttribute("tabindex","-1"),this.selectedRadio=null),this.focusedRadio=t}e.preventDefault()},this.shouldMoveOffGroupToTheRight=(e,t,i)=>e===t.length&&this.isInsideToolbar&&i===gu,this.shouldMoveOffGroupToTheLeft=(e,t)=>(this.focusedRadio?e.indexOf(this.focusedRadio)-1:0)<0&&this.isInsideToolbar&&t===pu,this.checkFocusedRadio=()=>{null===this.focusedRadio||this.focusedRadio.readOnly||this.focusedRadio.checked||(this.focusedRadio.checked=!0,this.focusedRadio.setAttribute("tabindex","0"),this.focusedRadio.focus(),this.selectedRadio=this.focusedRadio)},this.moveRight=e=>{const t=this.slottedRadioButtons;let i=0;if(i=this.focusedRadio?t.indexOf(this.focusedRadio)+1:1,this.shouldMoveOffGroupToTheRight(i,t,e.key))this.moveRightOffGroup();else for(i===t.length&&(i=0);i<t.length&&t.length>1;){if(!t[i].disabled){this.moveToRadioByIndex(t,i);break}if(this.focusedRadio&&i===t.indexOf(this.focusedRadio))break;if(i+1>=t.length){if(this.isInsideToolbar)break;i=0}else i+=1}},this.moveLeft=e=>{const t=this.slottedRadioButtons;let i=0;if(i=this.focusedRadio?t.indexOf(this.focusedRadio)-1:0,i=i<0?t.length-1:i,this.shouldMoveOffGroupToTheLeft(t,e.key))this.moveLeftOffGroup();else for(;i>=0&&t.length>1;){if(!t[i].disabled){this.moveToRadioByIndex(t,i);break}if(this.focusedRadio&&i===t.indexOf(this.focusedRadio))break;i-1<0?i=t.length-1:i-=1}},this.keydownHandler=e=>{const t=e.key;if(t in ku&&this.isInsideFoundationToolbar)return!0;switch(t){case vu:this.checkFocusedRadio();break;case gu:case uu:this.direction===qr.ltr?this.moveRight(e):this.moveLeft(e);break;case pu:case fu:this.direction===qr.ltr?this.moveLeft(e):this.moveRight(e);break;default:return!0}}}readOnlyChanged(){void 0!==this.slottedRadioButtons&&this.slottedRadioButtons.forEach((e=>{this.readOnly?e.readOnly=!0:e.readOnly=!1}))}disabledChanged(){void 0!==this.slottedRadioButtons&&this.slottedRadioButtons.forEach((e=>{this.disabled?e.disabled=!0:e.disabled=!1}))}nameChanged(){this.slottedRadioButtons&&this.slottedRadioButtons.forEach((e=>{e.setAttribute("name",this.name)}))}valueChanged(){this.slottedRadioButtons&&this.slottedRadioButtons.forEach((e=>{e.value===this.value&&(e.checked=!0,this.selectedRadio=e)})),this.$emit("change")}slottedRadioButtonsChanged(e,t){this.slottedRadioButtons&&this.slottedRadioButtons.length>0&&this.setupRadioButtons()}get parentToolbar(){return this.closest('[role="toolbar"]')}get isInsideToolbar(){var e;return null!==(e=this.parentToolbar)&&void 0!==e&&e}get isInsideFoundationToolbar(){var e;return!!(null===(e=this.parentToolbar)||void 0===e?void 0:e.$fastController)}connectedCallback(){super.connectedCallback(),this.direction=Vf(this),this.setupRadioButtons()}disconnectedCallback(){this.slottedRadioButtons.forEach((e=>{e.removeEventListener("change",this.radioChangeHandler)}))}setupRadioButtons(){const e=this.slottedRadioButtons.filter((e=>e.hasAttribute("checked"))),t=e?e.length:0;t>1&&(e[t-1].checked=!0);let i=!1;if(this.slottedRadioButtons.forEach((e=>{void 0!==this.name&&e.setAttribute("name",this.name),this.disabled&&(e.disabled=!0),this.readOnly&&(e.readOnly=!0),this.value&&this.value===e.value?(this.selectedRadio=e,this.focusedRadio=e,e.checked=!0,e.setAttribute("tabindex","0"),i=!0):(this.isInsideFoundationToolbar||e.setAttribute("tabindex","-1"),e.checked=!1),e.addEventListener("change",this.radioChangeHandler)})),void 0===this.value&&this.slottedRadioButtons.length>0){const e=this.slottedRadioButtons.filter((e=>e.hasAttribute("checked"))),t=null!==e?e.length:0;if(t>0&&!i){const i=e[t-1];i.checked=!0,this.focusedRadio=i,i.setAttribute("tabindex","0")}else this.slottedRadioButtons[0].setAttribute("tabindex","0"),this.focusedRadio=this.slottedRadioButtons[0]}}}Ms([Os({attribute:"readonly",mode:"boolean"})],Gm.prototype,"readOnly",void 0),Ms([Os({attribute:"disabled",mode:"boolean"})],Gm.prototype,"disabled",void 0),Ms([Os],Gm.prototype,"name",void 0),Ms([Os],Gm.prototype,"value",void 0),Ms([Os],Gm.prototype,"orientation",void 0),Ms([ms],Gm.prototype,"childItems",void 0),Ms([ms],Gm.prototype,"slottedRadioButtons",void 0);const Qm=Gm.compose({baseName:"radio-group",template:(e,t)=>Rr`
    <template
        role="radiogroup"
        aria-disabled="${e=>e.disabled}"
        aria-readonly="${e=>e.readOnly}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        @keydown="${(e,t)=>e.keydownHandler(t.event)}"
        @focusout="${(e,t)=>e.focusOutHandler(t.event)}"
    >
        <slot name="label"></slot>
        <div
            class="positioning-region ${e=>e.orientation===Nf?"horizontal":"vertical"}"
            part="positioning-region"
        >
            <slot
                ${Ru({property:"slottedRadioButtons",filter:Ou("[role=radio]")})}
            ></slot>
        </div>
    </template>
`,styles:(e,t)=>ih`
  ${nh("flex")} :host {
    align-items: flex-start;
    flex-direction: column;
  }

  .positioning-region {
    display: flex;
    flex-wrap: wrap;
  }

  :host([orientation='vertical']) .positioning-region {
    flex-direction: column;
  }

  :host([orientation='horizontal']) .positioning-region {
    flex-direction: row;
  }
`});var Km=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Xm=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)},Jm=function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))};lr(ip,Qm,Ju);let Ym=class extends Bm{static get styles(){return Zm}get strings(){return Wm}static get requiredScopes(){return["tasks.read","tasks.readwrite"]}constructor(){super(),this._isDarkMode=!1,this.onThemeChanged=()=>{this._isDarkMode=mv(this)},this.addTask=()=>Jm(this,void 0,void 0,(function*(){if(!this._isNewTaskBeingAdded&&this._newTaskName){this._isNewTaskBeingAdded=!0,this.requestUpdate();try{yield this.createNewTask()}finally{this.clearNewTaskData(),this._isNewTaskBeingAdded=!1,this.requestUpdate()}}})),this.renderNewTask=()=>{const e=this._newTaskName?Je`
        <fluent-checkbox
          class="task-add-icon"
          @click="${this.addTask}">
        </fluent-checkbox>
      `:Je`
        <span class="add-icon">${Co(ko.Add)}</span>
      `,t=Je`
      <fluent-button
        aria-label=${this.strings.cancelAddingTask}
        class="task-cancel-icon" 
        @click="${this.clearNewTaskData}"
      >
        ${Co(ko.Cancel)}
      </fluent-button>
    `,i={dark:this._isDarkMode,date:!0},o=Je`
      <fluent-text-field
        autocomplete="off"
        type="date"
        id="new-taskDate-input"
        class="${ki(i)}"
        aria-label="${this.strings.newTaskDateInputLabel}"
        .value="${this.dateToInputValue(this._newTaskDueDate)}"
        @change="${this.handleDateChange}"
      >
      </fluent-text-field>
    `,s=this.readOnly?et:Je`
      <fluent-text-field
        autocomplete="off"
        appearance="outline"
        class="new-task"
        id="new-task-name-input"
        aria-label="${this.strings.newTaskLabel}"
        .value=${this._newTaskName}
        placeholder="${this.strings.newTaskPlaceholder}"
        @keydown="${this.handleKeyDown}"
        @input="${this.handleInput}"
      >
        <div slot="start" class="start">${e}</div>
        ${this._newTaskName?Je`
              <div slot="end" class="end">
                <span class="calendar">${o}</span>
                ${t}
              </div> `:Je``}
      </fluent-text-field>
    `;return Je`
      ${this.currentList?Je`
            <div dir=${this.direction} class="task new-task incomplete">
              ${s}
            </div>
        `:Je``}  
     `},this.handleSelectionChanged=e=>{this.currentList=e.detail,this.loadTasks(this.currentList)},this.renderTaskDetails=e=>{const t={task:e,list:this.currentList};if(this.hasTemplate("task"))return this.renderTemplate("task",t,e.id);let i=null;const o=e.dueDateTime?Je`
        <span class="task-calendar">${Co(ko.Calendar)}</span>
        <span class="task-due-date">${(e=>{const t=e.getMonth();return`${e.getDate()} / ${t} / ${e.getFullYear()}`})(new Date(e.dueDateTime.dateTime))}</span>
      `:Je``,s=this.readOnly?Je``:Je`
        <fluent-button class="task-delete"
          @click="${()=>this.removeTask(e.id)}"
          aria-label="${this.strings.deleteTaskLabel}"
        >
          ${Co(ko.Delete)}
        </fluent-button>
      `;return i=this.hasTemplate("task-details")?this.renderTemplate("task-details",t,`task-details-${e.id}`):Je`
      <div class="task-details">
        <div class="title">${e.title}</div>
        <div class="task-due">${o}</div>
        ${s}
      </div>
      `,Je`${i}`},this.renderTask=e=>{const t=ki({"read-only":this.readOnly,task:!0});return Je`
      <fluent-checkbox 
        id=${e.id}
        class=${t}
        ?disabled=${this.readOnly}
        @click="${()=>this.handleTaskCheckClick(e)}"
      >
        ${this.renderTaskDetails(e)}
      </fluent-checkbox>
    `},this.renderCompletedTask=e=>{const t=ki({complete:!0,"read-only":this.readOnly,task:!0}),i=Je`${Co(ko.CheckMark)}`;return Je`
      <fluent-checkbox 
        id=${e.id} 
        class=${t} 
        checked 
        ?disabled=${this.readOnly} 
        @click="${()=>this.handleTaskCheckClick(e)}"
      >
        <div slot="checked-indicator">
          ${i}
        </div>
        ${this.renderTaskDetails(e)}
      </fluent-checkbox>
    `},this.loadState=()=>Jm(this,void 0,void 0,(function*(){const e=te.globalProvider;if(e&&e.state===Q.SignedIn){if(this._isLoadingTasks=!0,!this._graph){const t=e.graph.forComponent(this);this._graph=t}if(!this.currentList&&!this.initialId){const e=yield(t=this._graph,Hm(void 0,void 0,void 0,(function*(){const e=yield t.api("/me/todo/lists").header("Cache-Control","no-store").middlewareOptions(ie("Tasks.Read")).get();return null==e?void 0:e.value}))),i=null==e?void 0:e.find((e=>"defaultList"===e.wellknownListName));i&&(yield this.loadTasks(i))}var t;this.targetId?(this.currentList=yield qm(this._graph,this.targetId),this._tasks=yield jm(this._graph,this.targetId)):this.initialId&&(this.currentList=yield qm(this._graph,this.initialId),this._tasks=yield jm(this._graph,this.initialId)),this._isLoadingTasks=!1}})),this.clearNewTaskData=()=>{this._newTaskDueDate=null,this._newTaskName=""},this.clearState=()=>{super.clearState(),this.currentList=null,this._tasks=[],this._loadingTasks=[],this._isLoadingTasks=!1},this.loadTasks=e=>Jm(this,void 0,void 0,(function*(){this._isLoadingTasks=!0,this.currentList=e,this._tasks=yield jm(this._graph,e.id),this._isLoadingTasks=!1,this.requestUpdate()})),this.updateTaskStatus=(e,t)=>Jm(this,void 0,void 0,(function*(){this._loadingTasks=[...this._loadingTasks,e.id],this.requestUpdate(),e.status=t;const i=this.currentList.id;e=yield((e,t,i,o)=>Hm(void 0,void 0,void 0,(function*(){return yield e.api(`/me/todo/lists/${t}/tasks/${i}`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.ReadWrite")).patch(o)})))(this._graph,i,e.id,e);const o=this._tasks.findIndex((t=>t.id===e.id));this._tasks[o]=e,this._loadingTasks=this._loadingTasks.filter((t=>t!==e.id)),this.requestUpdate()})),this.removeTask=e=>Jm(this,void 0,void 0,(function*(){this._tasks=this._tasks.filter((t=>t.id!==e)),this.requestUpdate();const t=this.currentList.id;yield((e,t,i)=>Hm(void 0,void 0,void 0,(function*(){yield e.api(`/me/todo/lists/${t}/tasks/${i}`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.ReadWrite")).delete()})))(this._graph,t,e),this._tasks=this._tasks.filter((t=>t.id!==e))})),this.handleInput=e=>{"new-task-name-input"===e.target.id&&(this._newTaskName=e.target.value)},this.handleKeyDown=e=>Jm(this,void 0,void 0,(function*(){"Enter"===e.key&&(yield this.addTask())})),this.handleDateChange=e=>{const t=e.target.value;this._newTaskDueDate=t?new Date(t+"T17:00"):null},this._graph=null,this._newTaskDueDate=null,this._tasks=[],this._loadingTasks=[],this._isLoadingTasks=!1,this.addEventListener("selectionChanged",this.handleSelectionChanged)}connectedCallback(){super.connectedCallback(),window.addEventListener("darkmodechanged",this.onThemeChanged),this.onThemeChanged()}disconnectedCallback(){window.removeEventListener("darkmodechanged",this.onThemeChanged),super.disconnectedCallback()}renderTasks(){if(this._isLoadingTasks)return this.renderLoadingTask();let e=this._tasks;e&&this.taskFilter&&(e=e.filter((e=>this.taskFilter(e))));const t=e.filter((e=>"completed"===e.status)),i=Xo(e.filter((e=>"completed"!==e.status)),(e=>e.id),(e=>this.renderTask(e))),o=Xo(t.sort(((e,t)=>new Date(e.lastModifiedDateTime).getTime()-new Date(t.lastModifiedDateTime).getTime())),(e=>e.id),(e=>this.renderCompletedTask(e)));return Je`
      ${i}
      ${o}
    `}renderPicker(){var e,t;return this.targetId?Je`<p>${null===(e=this.currentList)||void 0===e?void 0:e.displayName}</p>`:pi`
        <mgt-picker
          resource="me/todo/lists"
          scopes="tasks.read, tasks.readwrite"
          key-name="displayName"
          selected-value="${Ao(null===(t=this.currentList)||void 0===t?void 0:t.displayName)}"
          placeholder="Select a task list">
        </mgt-picker>`}createNewTask(){return Jm(this,void 0,void 0,(function*(){const e=this.currentList.id,t={title:this._newTaskName};this._newTaskDueDate&&(t.dueDateTime={dateTime:new Date(this._newTaskDueDate).toLocaleDateString(),timeZone:"UTC"});const i=yield((e,t,i)=>Hm(void 0,void 0,void 0,(function*(){return yield e.api(`/me/todo/lists/${t}/tasks`).header("Cache-Control","no-store").middlewareOptions(ie("Tasks.ReadWrite")).post(i)})))(this._graph,e,t);this._tasks.unshift(i)}))}handleTaskCheckClick(e){this.handleTaskClick(e),this.readOnly||("completed"===e.status?this.updateTaskStatus(e,"notStarted"):this.updateTaskStatus(e,"completed"))}};Km([$t(),Xm("design:type",String)],Ym.prototype,"_newTaskName",void 0),Km([$t(),Xm("design:type",Object)],Ym.prototype,"currentList",void 0),Km([$t(),Xm("design:type",Object)],Ym.prototype,"_isDarkMode",void 0),Ym=Km([gi("todo"),Xm("design:paramtypes",[])],Ym);class eb extends Ln{}class tb extends(Tu(eb)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class ib extends tb{constructor(){super(),this.initialValue="on",this.keypressHandler=e=>{if(!this.readOnly)switch(e.key){case vu:case wu:this.checked=!this.checked}},this.clickHandler=e=>{this.disabled||this.readOnly||(this.checked=!this.checked)},this.proxy.setAttribute("type","checkbox")}readOnlyChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.readOnly=this.readOnly),this.readOnly?this.classList.add("readonly"):this.classList.remove("readonly")}checkedChanged(e,t){super.checkedChanged(e,t),this.checked?this.classList.add("checked"):this.classList.remove("checked")}}Ms([Os({attribute:"readonly",mode:"boolean"})],ib.prototype,"readOnly",void 0),Ms([ms],ib.prototype,"defaultSlottedNodes",void 0);const ob=ib.compose({baseName:"switch",template:(e,t)=>Rr`
    <template
        role="switch"
        aria-checked="${e=>e.checked}"
        aria-disabled="${e=>e.disabled}"
        aria-readonly="${e=>e.readOnly}"
        tabindex="${e=>e.disabled?null:0}"
        @keypress="${(e,t)=>e.keypressHandler(t.event)}"
        @click="${(e,t)=>e.clickHandler(t.event)}"
        class="${e=>e.checked?"checked":""}"
    >
        <label
            part="label"
            class="${e=>e.defaultSlottedNodes&&e.defaultSlottedNodes.length?"label":"label label__hidden"}"
        >
            <slot ${Ru("defaultSlottedNodes")}></slot>
        </label>
        <div part="switch" class="switch">
            <slot name="switch">${t.switch||""}</slot>
        </div>
        <span class="status-message" part="status-message">
            <span class="checked-message" part="checked-message">
                <slot name="checked-message"></slot>
            </span>
            <span class="unchecked-message" part="unchecked-message">
                <slot name="unchecked-message"></slot>
            </span>
        </span>
    </template>
`,styles:(e,t)=>ih`
    :host([hidden]) {
      display: none;
    }

    ${nh("inline-flex")} :host {
      align-items: center;
      outline: none;
      font-family: ${Na};
      ${""} user-select: none;
    }

    :host(.disabled) {
      opacity: ${Ea};
    }

    :host(.disabled) .label,
    :host(.readonly) .label,
    :host(.disabled) .switch,
    :host(.readonly) .switch,
    :host(.disabled) .status-message,
    :host(.readonly) .status-message {
      cursor: ${Vu};
    }

    .switch {
      position: relative;
      box-sizing: border-box;
      width: calc(((${Uu} / 2) + ${Aa}) * 2px);
      height: calc(((${Uu} / 2) + ${Aa}) * 1px);
      background: ${oc};
      border-radius: calc(${Uu} * 1px);
      border: calc(${Ma} * 1px) solid ${Bc};
      cursor: pointer;
    }

    :host(:not(.disabled):hover) .switch {
      background: ${sc};
      border-color: ${Hc};
    }

    :host(:not(.disabled):active) .switch {
      background: ${nc};
      border-color: ${jc};
    }

    :host(:${Nu}) .switch {
      ${ju}
      background: ${rc};
    }

    :host(.checked) .switch {
      background: ${Dd};
      border-color: transparent;
    }

    :host(.checked:not(.disabled):hover) .switch {
      background: ${Pd};
      border-color: transparent;
    }

    :host(.checked:not(.disabled):active) .switch {
      background: ${Ld};
      border-color: transparent;
    }

    slot[name='switch'] {
      position: absolute;
      display: flex;
      border: 1px solid transparent; /* Spacing included in the transform reference box */
      fill: ${xc};
      transition: all 0.2s ease-in-out;
    }

    .status-message {
      color: ${xc};
      cursor: pointer;
      ${Bu}
    }

    .label__hidden {
      display: none;
      visibility: hidden;
    }

    .label {
      color: ${xc};
      ${Bu}
      margin-inline-end: calc(${Aa} * 2px + 2px);
      cursor: pointer;
    }

    ::slotted([slot="checked-message"]),
    ::slotted([slot="unchecked-message"]) {
        margin-inline-start: calc(${Aa} * 2px + 2px);
    }

    :host(.checked) .switch {
      background: ${Dd};
    }

    :host(.checked) .switch slot[name='switch'] {
      fill: ${Fd};
      filter: drop-shadow(0px 1px 1px rgba(0, 0, 0, 0.15));
    }

    :host(.checked:not(.disabled)) .switch:hover {
      background: ${Pd};
    }

    :host(.checked:not(.disabled)) .switch:hover slot[name='switch'] {
      fill: ${Ad};
    }

    :host(.checked:not(.disabled)) .switch:active {
      background: ${Ld};
    }

    :host(.checked:not(.disabled)) .switch:active slot[name='switch'] {
      fill: ${Rd};
    }

    .unchecked-message {
      display: block;
    }

    .checked-message {
      display: none;
    }

    :host(.checked) .unchecked-message {
      display: none;
    }

    :host(.checked) .checked-message {
      display: block;
    }
  `.withBehaviors(new ag(ih`
        slot[name='switch'] {
          left: 0;
        }

        :host(.checked) slot[name='switch'] {
          left: 100%;
          transform: translateX(-100%);
        }
      `,ih`
        slot[name='switch'] {
          right: 0;
        }

        :host(.checked) slot[name='switch'] {
          right: 100%;
          transform: translateX(100%);
        }
      `),lh(ih`
        :host(:not(.disabled)) .switch slot[name='switch'] {
          forced-color-adjust: none;
          fill: ${dh.FieldText};
        }
        .switch {
          background: ${dh.Field};
          border-color: ${dh.FieldText};
        }
        :host(.checked) .switch {
          background: ${dh.Highlight};
          border-color: ${dh.Highlight};
        }
        :host(:not(.disabled):hover) .switch ,
        :host(:not(.disabled):active) .switch,
        :host(.checked:not(.disabled):hover) .switch {
          background: ${dh.HighlightText};
          border-color: ${dh.Highlight};
        }
        :host(.checked:not(.disabled)) .switch slot[name="switch"] {
          fill: ${dh.HighlightText};
        }
        :host(.checked:not(.disabled):hover) .switch slot[name='switch'] {
          fill: ${dh.Highlight};
        }
        :host(:${Nu}) .switch {
          forced-color-adjust: none;
          background: ${dh.Field}; 
          border-color: ${dh.Highlight};
          outline-color: ${dh.FieldText};
        }
        :host(.disabled) {
          opacity: 1;
        }
        :host(.disabled) slot[name='switch'] {
          forced-color-adjust: none;
          fill: ${dh.GrayText};
        }
        :host(.disabled) .switch {
          background: ${dh.Field};
          border-color: ${dh.GrayText};
        }
        .status-message,
        .label {
          color: ${dh.FieldText};
        }
      `)),switch:'\n    <svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg">\n      <rect x="2" y="2" width="12" height="12" rx="6"/>\n    </svg>\n  '}),sb="#717171",nb=Jn.create("secondary-text-color").withDefault(sb),rb="#1a1a1a",ab=Jn.create("secondary-text-hover-color").withDefault(rb),lb={label:"Color mode:",on:"Dark",off:"Light"};var db=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},cb=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(ob);let hb=class extends Pt{constructor(){super(),this.onSwitchChanged=e=>{this.darkModeActive=e.target.checked};const e=window.matchMedia("(prefers-color-scheme:dark)").matches;this.darkModeActive=e,this.applyTheme(this.darkModeActive)}get strings(){return lb}updated(e){e.has("darkModeActive")&&this.applyTheme(this.darkModeActive)}render(){return Je`
      <fluent-switch checked=${this.darkModeActive} @change=${this.onSwitchChanged}>
        <span slot="checked-message">${lb.on}</span>
        <span slot="unchecked-message">${lb.off}</span>
        <label for="direction-switch">${lb.label}</label>
      </fluent-switch>
`}applyTheme(e){const t=e?"dark":"light";((e,t=document.body)=>{const i=(e=>{switch(e){case"contrast":return{accentBaseColor:"#7f85f5",neutralBaseColor:"#adadad",baseLayerLuminance:_a.DarkMode};case"default":return{accentBaseColor:"#5b5fc7",neutralBaseColor:"#616161",baseLayerLuminance:_a.LightMode};case"dark":return{accentBaseColor:"#479ef5",neutralBaseColor:"#adadad",baseLayerLuminance:_a.DarkMode,designTokenOverrides:e=>{Dd.setValueFor(e,oa.from(jr("#115ea3"))),Pd.setValueFor(e,oa.from(jr("#0f6cbd"))),Ld.setValueFor(e,oa.from(jr("#0c3b5e"))),Ed.setValueFor(e,oa.from(jr("#0f548c"))),zd.setValueFor(e,oa.from(jr("#479EF5"))),Nd.setValueFor(e,oa.from(jr("#62abf5"))),Ud.setValueFor(e,oa.from(jr("#2886de"))),Bd.setValueFor(e,oa.from(jr("#479ef5"))),jd.setValueFor(e,oa.from(jr("#115ea3"))),qd.setValueFor(e,oa.from(jr("#0f6cbd"))),Zd.setValueFor(e,oa.from(jr("#0c3b5e"))),Wd.setValueFor(e,oa.from(jr("#0f548c"))),Rd.setValueFor(e,oa.from(jr("#ffffff"))),Fd.setValueFor(e,oa.from(jr("#ffffff"))),Ad.setValueFor(e,oa.from(jr("#ffffff"))),Vd.setValueFor(e,oa.from(jr("#ffffff"))),nb.setValueFor(e,"#8e8e8e"),ab.setValueFor(e,"#ffffff")}};default:return{accentBaseColor:"#0f6cbd",neutralBaseColor:"#616161",baseLayerLuminance:_a.LightMode,designTokenOverrides:e=>{nb.setValueFor(e,sb),ab.setValueFor(e,rb)}}}})(e);((e,t=document.body)=>{var i;vd.setValueFor(t,oa.from(jr(e.accentBaseColor))),gd.setValueFor(t,oa.from(jr(e.neutralBaseColor))),vl.setValueFor(t,e.baseLayerLuminance),null===(i=e.designTokenOverrides)||void 0===i||i.call(e,t)})(i,t)})(t),document.body.classList.remove("mgt-dark-mode","mgt-light-mode"),document.body.classList.add(`mgt-${t}-mode`),this.fireCustomEvent("darkmodechanged",this.darkModeActive,!0,!1,!0)}};db([Ct({attribute:"mode",reflect:!0,type:String,converter:{fromAttribute:e=>"dark"===e,toAttribute:e=>e?"dark":"light"}}),cb("design:type",Boolean)],hb.prototype,"darkModeActive",void 0),hb=db([gi("theme-toggle"),cb("design:paramtypes",[])],hb);class ub extends Ln{}class pb extends(Iu(ub)){constructor(){super(...arguments),this.proxy=document.createElement("input")}}class gb extends pb{readOnlyChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.readOnly=this.readOnly,this.validate())}autofocusChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.autofocus=this.autofocus,this.validate())}placeholderChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.placeholder=this.placeholder)}listChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.setAttribute("list",this.list),this.validate())}maxlengthChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.maxLength=this.maxlength,this.validate())}minlengthChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.minLength=this.minlength,this.validate())}patternChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.pattern=this.pattern,this.validate())}sizeChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.size=this.size)}spellcheckChanged(){this.proxy instanceof HTMLInputElement&&(this.proxy.spellcheck=this.spellcheck)}connectedCallback(){super.connectedCallback(),this.validate(),this.autofocus&&ps.queueUpdate((()=>{this.focus()}))}validate(){super.validate(this.control)}handleTextInput(){this.value=this.control.value}handleClearInput(){this.value="",this.control.focus(),this.handleChange()}handleChange(){this.$emit("change")}}Ms([Os({attribute:"readonly",mode:"boolean"})],gb.prototype,"readOnly",void 0),Ms([Os({mode:"boolean"})],gb.prototype,"autofocus",void 0),Ms([Os],gb.prototype,"placeholder",void 0),Ms([Os],gb.prototype,"list",void 0),Ms([Os({converter:Ls})],gb.prototype,"maxlength",void 0),Ms([Os({converter:Ls})],gb.prototype,"minlength",void 0),Ms([Os],gb.prototype,"pattern",void 0),Ms([Os({converter:Ls})],gb.prototype,"size",void 0),Ms([Os({mode:"boolean"})],gb.prototype,"spellcheck",void 0),Ms([ms],gb.prototype,"defaultSlottedNodes",void 0);class fb{}cu(fb,iu),cu(gb,nu,fb);const vb=".root",mb=Jn.create("clear-button-hover").withDefault((e=>{const t=gc.getValueFor(e),i=Jd.getValueFor(e);return t.evaluate(e,i.evaluate(e).focus).hover})),bb=Jn.create("clear-button-active").withDefault((e=>{const t=gc.getValueFor(e),i=Jd.getValueFor(e);return t.evaluate(e,i.evaluate(e).focus).active}));class yb extends gb{constructor(){super(...arguments),this.appearance="outline"}}i([Os],yb.prototype,"appearance",void 0);const wb=yb.compose({baseName:"search",baseClass:gb,template:(e,t)=>Rr`
  <template
    class="
            ${e=>e.readOnly?"readonly":""}
        "
  >
    <label
      part="label"
      for="control"
      class="${e=>e.defaultSlottedNodes&&e.defaultSlottedNodes.length?"label":"label label__hidden"}"
    >
      <slot ${Ru({property:"defaultSlottedNodes",filter:Wg})}></slot>
    </label>
    <div class="root" part="root" ${su("root")}>
      ${au(0,t)}
      <div class="input-wrapper" part="input-wrapper">
        <input
          class="control"
          part="control"
          id="control"
          @input="${e=>e.handleTextInput()}"
          @change="${e=>e.handleChange()}"
          ?autofocus="${e=>e.autofocus}"
          ?disabled="${e=>e.disabled}"
          list="${e=>e.list}"
          maxlength="${e=>e.maxlength}"
          minlength="${e=>e.minlength}"
          pattern="${e=>e.pattern}"
          placeholder="${e=>e.placeholder}"
          ?readonly="${e=>e.readOnly}"
          ?required="${e=>e.required}"
          size="${e=>e.size}"
          ?spellcheck="${e=>e.spellcheck}"
          :value="${e=>e.value}"
          type="search"
          aria-atomic="${e=>e.ariaAtomic}"
          aria-busy="${e=>e.ariaBusy}"
          aria-controls="${e=>e.ariaControls}"
          aria-current="${e=>e.ariaCurrent}"
          aria-describedby="${e=>e.ariaDescribedby}"
          aria-details="${e=>e.ariaDetails}"
          aria-disabled="${e=>e.ariaDisabled}"
          aria-errormessage="${e=>e.ariaErrormessage}"
          aria-flowto="${e=>e.ariaFlowto}"
          aria-haspopup="${e=>e.ariaHaspopup}"
          aria-hidden="${e=>e.ariaHidden}"
          aria-invalid="${e=>e.ariaInvalid}"
          aria-keyshortcuts="${e=>e.ariaKeyshortcuts}"
          aria-label="${e=>e.ariaLabel}"
          aria-labelledby="${e=>e.ariaLabelledby}"
          aria-live="${e=>e.ariaLive}"
          aria-owns="${e=>e.ariaOwns}"
          aria-relevant="${e=>e.ariaRelevant}"
          aria-roledescription="${e=>e.ariaRoledescription}"
          ${su("control")}
        />
        <slot name="clear-button">
          <button
            class="clear-button ${e=>e.value?"":"clear-button__hidden"}"
            part="clear-button"
            tabindex="-1"
            @click=${e=>e.handleClearInput()}
          >
            <slot name="clear-glyph">
              <svg width="12" height="12" viewBox="0 0 12 12" xmlns="http://www.w3.org/2000/svg">
                <path
                  d="m2.09 2.22.06-.07a.5.5 0 0 1 .63-.06l.07.06L6 5.29l3.15-3.14a.5.5 0 1 1 .7.7L6.71 6l3.14 3.15c.18.17.2.44.06.63l-.06.07a.5.5 0 0 1-.63.06l-.07-.06L6 6.71 2.85 9.85a.5.5 0 0 1-.7-.7L5.29 6 2.15 2.85a.5.5 0 0 1-.06-.63l.06-.07-.06.07Z"
                />
              </svg>
            </slot>
          </button>
        </slot>
      </div>
      ${ru(0,t)}
    </div>
  </template>
`,styles:(e,t)=>ih`
    ${nh("inline-block")}

    ${Gp(0,0,vb)}

    ${Qp()}

    .root {
      display: flex;
      flex-direction: row;
    }
    .control {
      -webkit-appearance: none;
      color: inherit;
      background: transparent;
      border: 0;
      height: calc(100% - 4px);
      margin-top: auto;
      margin-bottom: auto;
      padding: 0 calc(${Aa} * 2px + 1px);
      font-family: inherit;
      font-size: inherit;
      line-height: inherit;
    }
    .clear-button {
      display: inline-flex;
      align-items: center;
      margin: 1px;
      height: calc(100% - 2px);
      opacity: 0;
      background: transparent;
      color: ${xc};
      fill: currentcolor;
      border: none;
      border-radius: calc(${Ra} * 1px);
      min-width: calc(${Uu} * 1px);
      ${Bu}
      outline: none;
      padding: 0 calc((10 + (${Aa} * 2 * ${Fa})) * 1px);
    }
    .clear-button:hover {
      background: ${mb};
    }
    .clear-button:active {
      background: ${bb};
    }
    :host(:hover:not([disabled], [readOnly])) .clear-button,
    :host(:active:not([disabled], [readOnly])) .clear-button,
    :host(:focus-within:not([disabled], [readOnly])) .clear-button {
        opacity: 1;
    }
    :host(:hover:not([disabled], [readOnly])) .clear-button__hidden,
    :host(:active:not([disabled], [readOnly])) .clear-button__hidden,
    :host(:focus-within:not([disabled], [readOnly])) .clear-button__hidden {
        opacity: 0;
    }
    .control::-webkit-search-cancel-button {
      -webkit-appearance: none;
    }
    .input-wrapper {
      display: flex;
      position: relative;
      width: 100%;
    }
    .start,
    .end {
      display: flex;
      margin: 1px;
      align-items: center;
    }
    .start {
      display: flex;
      margin-inline-start: 11px;
    }
    ::slotted([slot="end"]) {
      height: 100%
    }
    .clear-button__hidden {
      opacity: 0;
    }
    .end {
        margin-inline-end: 11px;
    }
    ::slotted(${e.tagFor(Lu)}) {
      margin-inline-end: 1px;
    }
  `.withBehaviors(Gu("outline",Kp(0,0,vb)),Gu("filled",Xp(0,0,vb)),lh(Jp(0,0,vb))),start:'<svg width="20" height="20" xmlns="http://www.w3.org/2000/svg%22%3E"><path d="M8.5 3a5.5 5.5 0 0 1 4.23 9.02l4.12 4.13a.5.5 0 0 1-.63.76l-.07-.06-4.13-4.12A5.5 5.5 0 1 1 8.5 3Zm0 1a4.5 4.5 0 1 0 0 9 4.5 4.5 0 0 0 0-9Z"/></svg>',shadowOptions:{delegatesFocus:!0}}),xb={placeholder:"Search",title:"Search"},kb=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}:host fluent-search{width:100%}
`];var Cb=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},$b=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(wb);let Sb=class extends Pt{static get styles(){return kb}get strings(){return xb}get searchTerm(){return this._searchTerm}set searchTerm(e){this._searchTerm=e,this.fireSearchTermChanged()}constructor(){super(),this._searchTerm="",this.onInputChanged=e=>{this.searchTerm=e.target.value},console.warn("🦒: <mgt-search-box> is a preview component and may change prior to becoming generally available. See more information https://aka.ms/mgt/preview-components"),this.debounceDelay=300}render(){var e;return Je`
      <fluent-search
        autocomplete="off"
        class="search-term-input"
        appearance="outline"
        value=${null!==(e=this.searchTerm)&&void 0!==e?e:""}
        placeholder=${this.placeholder?this.placeholder:xb.placeholder}
        title=${this.title?this.title:xb.title}
        @input=${this.onInputChanged}
        @change=${this.onInputChanged}
      >
      </fluent-search>`}fireSearchTermChanged(){this.debouncedSearchTermChanged||(this.debouncedSearchTermChanged=$i((()=>{this.fireCustomEvent("searchTermChanged",this.searchTerm)}),this.debounceDelay)),this.debouncedSearchTermChanged()}};Cb([Ct({attribute:"placeholder",type:String}),$b("design:type",String)],Sb.prototype,"placeholder",void 0),Cb([Ct({attribute:"search-term",type:String}),$b("design:type",Object),$b("design:paramtypes",[Object])],Sb.prototype,"searchTerm",null),Cb([Ct({attribute:"debounce-delay",type:Number,reflect:!0}),$b("design:type",Number)],Sb.prototype,"debounceDelay",void 0),Sb=Cb([gi("search-box"),$b("design:paramtypes",[])],Sb);const _b={modified:"modified on",back:"Back",next:"Next",pages:"pages",page:"Page"},Ib=[be`
:host([hidden]){display:none}:host{display:block;font-family:var(--default-font-family, "Segoe UI", "Segoe UI Web (West European)", "Segoe UI", -apple-system, "BlinkMacSystemFont", "Roboto", "Helvetica Neue", sans-serif);font-size:var(--default-font-size,14px);--theme-primary-color:#0078d7;--theme-dark-color:#005a9e}:focus-visible{outline-color:var(--focus-ring-color,Highlight);outline-color:var(--focus-ring-color,-webkit-focus-ring-color);outline-style:var(--focus-ring-style,auto)}.ms-icon{display:inline-block;font-family:FabricMDL2Icons;font-style:normal;font-weight:400;font-size:16px;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;margin:4px 0}.error{background-color:#fde7e9;padding-block:8px;padding-inline:8px 12px}.ms-icon-chevron-down::before{content:"\\\e70d"}.ms-icon-chevron-up::before{content:"\\\e70e"}.ms-icon-contact::before{content:"\\\e77b"}.ms-icon-add-friend::before{content:"\\\e8fa"}.ms-icon-outlook-logo-inverser::before{content:"\\\eb6d"}.search-results{scroll-margin:100px}.search-result-grid{font-size:14px;margin:16px 4px;display:grid;grid-template-columns:32px 2fr 0fr;gap:.5rem}.search-result{font-size:14px;margin:16px 4px}.file-icon{--file-type-icon-height:32px}.search-result-info{margin:4px 0;display:inline-flex}.search-result-date{padding-top:3px}.search-result-date__shimmer{border-radius:4px;margin-top:2%;margin-left:5px;height:10px;width:200px}.search-result-summary{margin:4px 0;color:var(--body-subtle-text-color)}.search-result-thumbnail__shimmer{width:126px;height:72px}.search-result-thumbnail img{height:72px;max-width:126px;width:126px;object-fit:cover}.search-result-url{font-size:14px;font-weight:600;margin:4px 0}.search-result-url a{color:var(--color);text-decoration:none}.search-result-url a:hover{text-decoration:underline}.search-result-content__shimmer{border-radius:4px;margin-top:10px;height:10px}.search-result-name{font-size:16px;font-weight:600;margin:4px 0}.search-result-name__shimmer{border-radius:4px;margin-top:10px;height:10px;width:20%}.search-result-name a{color:var(--color);text-decoration:none}.search-result-name a:hover{text-decoration:underline}.search-result-author__shimmer{width:24px;height:24px}.search-result-icon{width:30px;height:30px}.search-result-icon__shimmer{width:32px;height:32px}.search-result-icon img{width:100%}.search-result-icon svg,.search-result-icon svg>path{width:100%;height:100%;fill:var(--neutral-foreground-rest);fill-rule:nonzero!important;clip-rule:nonzero!important}.search-results-page-active{border-bottom-style:solid;border-bottom-color:var(--accent-base-color)}.search-results-page svg,.search-results-page svg>path{height:12px;fill:var(--neutral-foreground-rest);fill-rule:nonzero!important;clip-rule:nonzero!important}.search-result-answer{box-shadow:var(--answer-box-shadow,0 3.2px 7.2px rgba(0,0,0,.132),0 .6px 1.8px rgba(0,0,0,.108));border-radius:var(--answer-border-radius,4px);border:var(--answer-border,none);padding:var(--answer-padding,10px)}.search-results-pages{margin:16px 4px}
`];class Tb extends Ln{constructor(){super(...arguments),this.anchor="",this.delay=300,this.autoUpdateMode="anchor",this.anchorElement=null,this.viewportElement=null,this.verticalPositioningMode="dynamic",this.horizontalPositioningMode="dynamic",this.horizontalInset="false",this.verticalInset="false",this.horizontalScaling="content",this.verticalScaling="content",this.verticalDefaultPosition=void 0,this.horizontalDefaultPosition=void 0,this.tooltipVisible=!1,this.currentDirection=qr.ltr,this.showDelayTimer=null,this.hideDelayTimer=null,this.isAnchorHoveredFocused=!1,this.isRegionHovered=!1,this.handlePositionChange=e=>{this.classList.toggle("top","start"===this.region.verticalPosition),this.classList.toggle("bottom","end"===this.region.verticalPosition),this.classList.toggle("inset-top","insetStart"===this.region.verticalPosition),this.classList.toggle("inset-bottom","insetEnd"===this.region.verticalPosition),this.classList.toggle("center-vertical","center"===this.region.verticalPosition),this.classList.toggle("left","start"===this.region.horizontalPosition),this.classList.toggle("right","end"===this.region.horizontalPosition),this.classList.toggle("inset-left","insetStart"===this.region.horizontalPosition),this.classList.toggle("inset-right","insetEnd"===this.region.horizontalPosition),this.classList.toggle("center-horizontal","center"===this.region.horizontalPosition)},this.handleRegionMouseOver=e=>{this.isRegionHovered=!0},this.handleRegionMouseOut=e=>{this.isRegionHovered=!1,this.startHideDelayTimer()},this.handleAnchorMouseOver=e=>{this.tooltipVisible?this.isAnchorHoveredFocused=!0:this.startShowDelayTimer()},this.handleAnchorMouseOut=e=>{this.isAnchorHoveredFocused=!1,this.clearShowDelayTimer(),this.startHideDelayTimer()},this.handleAnchorFocusIn=e=>{this.startShowDelayTimer()},this.handleAnchorFocusOut=e=>{this.isAnchorHoveredFocused=!1,this.clearShowDelayTimer(),this.startHideDelayTimer()},this.startHideDelayTimer=()=>{this.clearHideDelayTimer(),this.tooltipVisible&&(this.hideDelayTimer=window.setTimeout((()=>{this.updateTooltipVisibility()}),60))},this.clearHideDelayTimer=()=>{null!==this.hideDelayTimer&&(clearTimeout(this.hideDelayTimer),this.hideDelayTimer=null)},this.startShowDelayTimer=()=>{this.isAnchorHoveredFocused||(this.delay>1?null===this.showDelayTimer&&(this.showDelayTimer=window.setTimeout((()=>{this.startHover()}),this.delay)):this.startHover())},this.startHover=()=>{this.isAnchorHoveredFocused=!0,this.updateTooltipVisibility()},this.clearShowDelayTimer=()=>{null!==this.showDelayTimer&&(clearTimeout(this.showDelayTimer),this.showDelayTimer=null)},this.getAnchor=()=>{const e=this.getRootNode();return e instanceof ShadowRoot?e.getElementById(this.anchor):document.getElementById(this.anchor)},this.handleDocumentKeydown=e=>{!e.defaultPrevented&&this.tooltipVisible&&e.key===mu&&(this.isAnchorHoveredFocused=!1,this.updateTooltipVisibility(),this.$emit("dismiss"))},this.updateTooltipVisibility=()=>{if(!1===this.visible)this.hideTooltip();else{if(!0===this.visible)return void this.showTooltip();if(this.isAnchorHoveredFocused||this.isRegionHovered)return void this.showTooltip();this.hideTooltip()}},this.showTooltip=()=>{this.tooltipVisible||(this.currentDirection=Vf(this),this.tooltipVisible=!0,document.addEventListener("keydown",this.handleDocumentKeydown),ps.queueUpdate(this.setRegionProps))},this.hideTooltip=()=>{this.tooltipVisible&&(this.clearHideDelayTimer(),null!==this.region&&void 0!==this.region&&(this.region.removeEventListener("positionchange",this.handlePositionChange),this.region.viewportElement=null,this.region.anchorElement=null,this.region.removeEventListener("mouseover",this.handleRegionMouseOver),this.region.removeEventListener("mouseout",this.handleRegionMouseOut)),document.removeEventListener("keydown",this.handleDocumentKeydown),this.tooltipVisible=!1)},this.setRegionProps=()=>{this.tooltipVisible&&(this.region.viewportElement=this.viewportElement,this.region.anchorElement=this.anchorElement,this.region.addEventListener("positionchange",this.handlePositionChange),this.region.addEventListener("mouseover",this.handleRegionMouseOver,{passive:!0}),this.region.addEventListener("mouseout",this.handleRegionMouseOut,{passive:!0}))}}visibleChanged(){this.$fastController.isConnected&&(this.updateTooltipVisibility(),this.updateLayout())}anchorChanged(){this.$fastController.isConnected&&(this.anchorElement=this.getAnchor())}positionChanged(){this.$fastController.isConnected&&this.updateLayout()}anchorElementChanged(e){if(this.$fastController.isConnected){if(null!=e&&(e.removeEventListener("mouseover",this.handleAnchorMouseOver),e.removeEventListener("mouseout",this.handleAnchorMouseOut),e.removeEventListener("focusin",this.handleAnchorFocusIn),e.removeEventListener("focusout",this.handleAnchorFocusOut)),null!==this.anchorElement&&void 0!==this.anchorElement){this.anchorElement.addEventListener("mouseover",this.handleAnchorMouseOver,{passive:!0}),this.anchorElement.addEventListener("mouseout",this.handleAnchorMouseOut,{passive:!0}),this.anchorElement.addEventListener("focusin",this.handleAnchorFocusIn,{passive:!0}),this.anchorElement.addEventListener("focusout",this.handleAnchorFocusOut,{passive:!0});const e=this.anchorElement.id;null!==this.anchorElement.parentElement&&this.anchorElement.parentElement.querySelectorAll(":hover").forEach((t=>{t.id===e&&this.startShowDelayTimer()}))}null!==this.region&&void 0!==this.region&&this.tooltipVisible&&(this.region.anchorElement=this.anchorElement),this.updateLayout()}}viewportElementChanged(){null!==this.region&&void 0!==this.region&&(this.region.viewportElement=this.viewportElement),this.updateLayout()}connectedCallback(){super.connectedCallback(),this.anchorElement=this.getAnchor(),this.updateTooltipVisibility()}disconnectedCallback(){this.hideTooltip(),this.clearShowDelayTimer(),this.clearHideDelayTimer(),super.disconnectedCallback()}updateLayout(){switch(this.verticalPositioningMode="locktodefault",this.horizontalPositioningMode="locktodefault",this.position){case"top":case"bottom":this.verticalDefaultPosition=this.position,this.horizontalDefaultPosition="center";break;case"right":case"left":case"start":case"end":this.verticalDefaultPosition="center",this.horizontalDefaultPosition=this.position;break;case"top-left":this.verticalDefaultPosition="top",this.horizontalDefaultPosition="left";break;case"top-right":this.verticalDefaultPosition="top",this.horizontalDefaultPosition="right";break;case"bottom-left":this.verticalDefaultPosition="bottom",this.horizontalDefaultPosition="left";break;case"bottom-right":this.verticalDefaultPosition="bottom",this.horizontalDefaultPosition="right";break;case"top-start":this.verticalDefaultPosition="top",this.horizontalDefaultPosition="start";break;case"top-end":this.verticalDefaultPosition="top",this.horizontalDefaultPosition="end";break;case"bottom-start":this.verticalDefaultPosition="bottom",this.horizontalDefaultPosition="start";break;case"bottom-end":this.verticalDefaultPosition="bottom",this.horizontalDefaultPosition="end";break;default:this.verticalPositioningMode="dynamic",this.horizontalPositioningMode="dynamic",this.verticalDefaultPosition=void 0,this.horizontalDefaultPosition="center"}}}Ms([Os({mode:"boolean"})],Tb.prototype,"visible",void 0),Ms([Os],Tb.prototype,"anchor",void 0),Ms([Os],Tb.prototype,"delay",void 0),Ms([Os],Tb.prototype,"position",void 0),Ms([Os({attribute:"auto-update-mode"})],Tb.prototype,"autoUpdateMode",void 0),Ms([Os({attribute:"horizontal-viewport-lock"})],Tb.prototype,"horizontalViewportLock",void 0),Ms([Os({attribute:"vertical-viewport-lock"})],Tb.prototype,"verticalViewportLock",void 0),Ms([ms],Tb.prototype,"anchorElement",void 0),Ms([ms],Tb.prototype,"viewportElement",void 0),Ms([ms],Tb.prototype,"verticalPositioningMode",void 0),Ms([ms],Tb.prototype,"horizontalPositioningMode",void 0),Ms([ms],Tb.prototype,"horizontalInset",void 0),Ms([ms],Tb.prototype,"verticalInset",void 0),Ms([ms],Tb.prototype,"horizontalScaling",void 0),Ms([ms],Tb.prototype,"verticalScaling",void 0),Ms([ms],Tb.prototype,"verticalDefaultPosition",void 0),Ms([ms],Tb.prototype,"horizontalDefaultPosition",void 0),Ms([ms],Tb.prototype,"tooltipVisible",void 0),Ms([ms],Tb.prototype,"currentDirection",void 0);const Db=class extends Tb{connectedCallback(){super.connectedCallback(),_d.setValueFor(this,wd)}}.compose({baseName:"tooltip",baseClass:Tb,template:(e,t)=>Rr`
        ${eu((e=>e.tooltipVisible),Rr`
            <${e.tagFor(Qf)}
                fixed-placement="true"
                auto-update-mode="${e=>e.autoUpdateMode}"
                vertical-positioning-mode="${e=>e.verticalPositioningMode}"
                vertical-default-position="${e=>e.verticalDefaultPosition}"
                vertical-inset="${e=>e.verticalInset}"
                vertical-scaling="${e=>e.verticalScaling}"
                horizontal-positioning-mode="${e=>e.horizontalPositioningMode}"
                horizontal-default-position="${e=>e.horizontalDefaultPosition}"
                horizontal-scaling="${e=>e.horizontalScaling}"
                horizontal-inset="${e=>e.horizontalInset}"
                vertical-viewport-lock="${e=>e.horizontalViewportLock}"
                horizontal-viewport-lock="${e=>e.verticalViewportLock}"
                dir="${e=>e.currentDirection}"
                ${su("region")}
            >
                <div class="tooltip" part="tooltip" role="tooltip">
                    <slot></slot>
                </div>
            </${e.tagFor(Qf)}>
        `)}
    `,styles:(e,t)=>ih`
    :host {
      position: relative;
      contain: layout;
      overflow: visible;
      height: 0;
      width: 0;
      z-index: 10000;
    }

    .tooltip {
      box-sizing: border-box;
      border-radius: calc(${Ra} * 1px);
      border: calc(${Ma} * 1px) solid ${Nc};
      background: ${_d};
      color: ${xc};
      padding: 4px 12px;
      height: fit-content;
      width: fit-content;
      ${Bu}
      white-space: nowrap;
      box-shadow: ${bh};
    }

    ${e.tagFor(Qf)} {
      display: flex;
      justify-content: center;
      align-items: center;
      overflow: visible;
      flex-direction: row;
    }

    ${e.tagFor(Qf)}.right,
    ${e.tagFor(Qf)}.left {
      flex-direction: column;
    }

    ${e.tagFor(Qf)}.top .tooltip::after,
    ${e.tagFor(Qf)}.bottom .tooltip::after,
    ${e.tagFor(Qf)}.left .tooltip::after,
    ${e.tagFor(Qf)}.right .tooltip::after {
      content: '';
      width: 12px;
      height: 12px;
      background: ${_d};
      border-top: calc(${Ma} * 1px) solid ${Nc};
      border-left: calc(${Ma} * 1px) solid ${Nc};
      position: absolute;
    }

    ${e.tagFor(Qf)}.top .tooltip::after {
      transform: translateX(-50%) rotate(225deg);
      bottom: 5px;
      left: 50%;
    }

    ${e.tagFor(Qf)}.top .tooltip {
      margin-bottom: 12px;
    }

    ${e.tagFor(Qf)}.bottom .tooltip::after {
      transform: translateX(-50%) rotate(45deg);
      top: 5px;
      left: 50%;
    }

    ${e.tagFor(Qf)}.bottom .tooltip {
      margin-top: 12px;
    }

    ${e.tagFor(Qf)}.left .tooltip::after {
      transform: translateY(-50%) rotate(135deg);
      top: 50%;
      right: 5px;
    }

    ${e.tagFor(Qf)}.left .tooltip {
      margin-right: 12px;
    }

    ${e.tagFor(Qf)}.right .tooltip::after {
      transform: translateY(-50%) rotate(-45deg);
      top: 50%;
      left: 5px;
    }

    ${e.tagFor(Qf)}.right .tooltip {
      margin-left: 12px;
    }
  `.withBehaviors(lh(ih`
        :host([disabled]) {
          opacity: 1;
        }
        ${e.tagFor(Qf)}.top .tooltip::after,
        ${e.tagFor(Qf)}.bottom .tooltip::after,
        ${e.tagFor(Qf)}.left .tooltip::after,
        ${e.tagFor(Qf)}.right .tooltip::after {
          content: '';
          width: unset;
          height: unset;
        }
      `))}),Pb=Uf.compose({baseName:"divider",template:(e,t)=>Rr`
    <template role="${e=>e.role}" aria-orientation="${e=>e.orientation}"></template>
`,styles:(e,t)=>ih`
    ${nh("block")} :host {
      box-sizing: content-box;
      height: 0;
      border: none;
      border-top: calc(${Ma} * 1px) solid ${Ac};
    }

    :host([orientation="vertical"]) {
      border: none;
      height: 100%;
      margin: 0 calc(${Aa} * 1px);
      border-left: calc(${Ma} * 1px) solid ${Ac};
  }
  `});var Lb=function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},Eb=function(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)};lr(Sv,Ju,Db,Pb);let Ob=class extends Nt{static get styles(){return Ib}get strings(){return _b}get queryString(){return this._queryString}set queryString(e){this._queryString!==e&&(this._queryString=e,this._currentPage=1,this.setLoadingState(!0),this.requestStateUpdate(!0))}get from(){return(this.currentPage-1)*this.size}get size(){return this._size}set size(e){e>this.maxPageSize?this._size=this.maxPageSize:this._size=e}get searchEndpoint(){return"/search/query"}get maxPageSize(){return 1e3}get currentPage(){return this._currentPage}set currentPage(e){this._currentPage!==e&&(this._currentPage=e,this.requestStateUpdate(!0))}constructor(){super(),this._size=10,this.entityTypes=["driveItem","listItem","site"],this.scopes=[],this.contentSources=[],this.version="v1.0",this.pagingMax=7,this.enableTopResults=!1,this.cacheEnabled=!1,this.cacheInvalidationPeriod=3e4,this.isRefreshing=!1,this.defaultFields=["webUrl","lastModifiedBy","lastModifiedDateTime","summary","displayName","name"],this._currentPage=1,this.onFirstPageClick=()=>{this.currentPage=1,this.scrollToFirstResult()},this.onPageBackClick=()=>{this.currentPage--,this.scrollToFirstResult()},this.onPageNextClick=()=>{this.currentPage++,this.scrollToFirstResult()},console.warn("🦒: <mgt-search-results> is a preview component and may change prior to becoming generally available. See more information https://aka.ms/mgt/preview-components")}attributeChangedCallback(e,t,i){super.attributeChangedCallback(e,t,i),this.requestStateUpdate()}refresh(e=!1){this.isRefreshing=!0,e&&this.clearState(),this.requestStateUpdate(e)}clearState(){this.response=null}render(){var e,t,i,o,s,n,r,a;let l=null,d=null,c=null;return this.hasTemplate("header")&&(d=this.renderTemplate("header",this.response)),c=this.renderFooter(null===(t=null===(e=this.response)||void 0===e?void 0:e.value[0])||void 0===t?void 0:t.hitsContainers[0]),l=this.isLoadingState?this.renderLoading():this.error?this.renderError():this.response&&this.hasTemplate("default")?this.renderTemplate("default",this.response)||Je``:(null===(o=null===(i=this.response)||void 0===i?void 0:i.value[0])||void 0===o?void 0:o.hitsContainers[0])?Je`${null===(a=null===(r=null===(n=null===(s=this.response)||void 0===s?void 0:s.value[0])||void 0===n?void 0:n.hitsContainers[0])||void 0===r?void 0:r.hits)||void 0===a?void 0:a.map((e=>this.renderResult(e)))}`:this.hasTemplate("no-data")?this.renderTemplate("no-data",null):Je``,Je`
      ${d}
      <div class="search-results">
        ${l}
      </div>
      ${c}`}loadState(){var e,t,i,o,s,n;return function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(this,void 0,void 0,(function*(){const r=te.globalProvider;if(this.error=null,r&&r.state===Q.SignedIn){if(this.queryString){try{const a=this.getRequestOptions();let l;const d=JSON.stringify({endpoint:`${this.version}${this.searchEndpoint}`,requestOptions:a});let c=null;if(this.shouldRetrieveCache()){l=ai.getCache(zi,zi.stores.responses);const e=Ei()?yield l.getValue(d):null;e&&(this.cacheInvalidationPeriod||ai.config.response.invalidationPeriod||ai.config.defaultInvalidationPeriod)>Date.now()-e.timeCached&&(c=JSON.parse(e.response))}if(!c){const h=r.graph.forComponent(this);let u=h.api(this.searchEndpoint).version(this.version);if((null===(e=this.scopes)||void 0===e?void 0:e.length)&&(u=u.middlewareOptions(ie(...this.scopes))),c=yield u.post({requests:[a]}),this.fetchThumbnail){const e=h.createBatch(),r=ue.fromGraph(h).createBatch(),a=(null===(t=c.value)||void 0===t?void 0:t.length)&&(null===(i=c.value[0].hitsContainers)||void 0===i?void 0:i.length)&&null!==(s=null===(o=c.value[0].hitsContainers[0])||void 0===o?void 0:o.hits)&&void 0!==s?s:[];for(const t of a){const i=t.resource;!(i.size>0||(null===(n=i.webUrl)||void 0===n?void 0:n.endsWith(".aspx")))||"#microsoft.graph.driveItem"!==i["@odata.type"]&&"#microsoft.graph.listItem"!==i["@odata.type"]||("#microsoft.graph.listItem"===i["@odata.type"]?r.get(t.hitId.toString(),`/sites/${i.parentReference.siteId}/pages/${i.id}`):e.get(t.hitId.toString(),`/drives/${i.parentReference.driveId}/items/${i.id}/thumbnails/0/medium`))}const l=e=>{if(e&&e.size>0)for(const[t,i]of e){const e=c.value[0].hitsContainers[0].hits[t],o="#microsoft.graph.listItem"===e.resource["@odata.type"]?{url:i.content.thumbnailWebUrl}:{url:i.content.url};e.resource.thumbnail=o}};try{l(yield e.executeAll()),l(yield r.executeAll())}catch(e){}}this.shouldUpdateCache()&&c&&(l=ai.getCache(zi,zi.stores.responses),yield l.putValue(d,{response:JSON.stringify(c)}))}Ft(this.response,c)||(this.response=c)}catch(e){this.error=e}this.response&&(this.error=null)}else this.response=null;this.isRefreshing=!1,this.fireCustomEvent("dataChange",{response:this.response,error:this.error})}}))}renderLoading(){return this.renderTemplate("loading",null)||Je`
        ${[...Array(this.size)].map((()=>Je`
            <div class="search-result">
              <div class="search-result-grid">
                <div class="search-result-icon">
                  <fluent-skeleton class="search-result-icon__shimmer" shape="rect" shimmer></fluent-skeleton>
                </div>
                <div class="searc-result-content">
                  <div class="search-result-name">
                    <fluent-skeleton class="search-result-name__shimmer" shape="rect" shimmer></fluent-skeleton>
                  </div>
                  <div class="search-result-info">
                    <div class="search-result-author">
                      <fluent-skeleton class="search-result-author__shimmer" shape="circle" shimmer></fluent-skeleton>
                    </div>
                    <div class="search-result-date">
                      <fluent-skeleton class="search-result-date__shimmer" shape="rect" shimmer></fluent-skeleton>
                    </div>
                  </div>
                  <fluent-skeleton class="search-result-content__shimmer" shape="rect" shimmer></fluent-skeleton>
                  <fluent-skeleton class="search-result-content__shimmer" shape="rect" shimmer></fluent-skeleton>
                </div>
                ${this.fetchThumbnail&&Je`
                    <div class="search-result-thumbnail">
                      <fluent-skeleton class="search-result-thumbnail__shimmer" shape="rect" shimmer></fluent-skeleton>
                    </div>
                  `}
              </div>
              <fluent-divider></fluent-divider>
            </div>
          `))}
       `}renderResult(e){const t=this.getResourceType(e.resource);if(this.hasTemplate(`result-${t}`))return this.renderTemplate(`result-${t}`,e,e.hitId);switch(e.resource["@odata.type"]){case"#microsoft.graph.driveItem":return this.renderDriveItem(e);case"#microsoft.graph.site":return this.renderSite(e);case"#microsoft.graph.person":return this.renderPerson(e);case"#microsoft.graph.drive":case"#microsoft.graph.list":return this.renderList(e);case"#microsoft.graph.listItem":return this.renderListItem(e);case"#microsoft.graph.search.bookmark":return this.renderBookmark(e);case"#microsoft.graph.search.acronym":return this.renderAcronym(e);case"#microsoft.graph.search.qna":return this.renderQnA(e);default:return this.renderDefault(e)}}renderFooter(e){if(this.pagingRequired(e)){const t=this.getActivePages(e.total);return Je`
        <div class="search-results-pages">
          ${this.renderPreviousPage()}
          ${this.renderFirstPage(t)}
          ${this.renderAllPages(t)}
          ${this.renderNextPage()}
        </div>
      `}}pagingRequired(e){return(null==e?void 0:e.moreResultsAvailable)||this.currentPage*this.size<(null==e?void 0:e.total)}getActivePages(e){const t=[],i=(()=>{const e=this.currentPage-Math.floor(this.pagingMax/2)-1;return e>=Math.floor(this.pagingMax/2)?e:0})();if(i+1>this.pagingMax-this.currentPage||this.pagingMax===this.currentPage)for(let o=i+1;o<Math.ceil(e/this.size)&&o<this.pagingMax+(this.currentPage-1)&&t.length<this.pagingMax-2;++o)t.push(o+1);else for(let e=i;e<this.pagingMax;++e)t.push(e+1);return t}renderAllPages(e){return Je`
      ${e.map((e=>Je`
            <fluent-button
              title="${_b.page} ${e}"
              appearance="stealth"
              class="${e===this.currentPage?"search-results-page-active":"search-results-page"}"
              @click="${()=>this.onPageClick(e)}">
                ${e}
            </fluent-button>`))}`}renderFirstPage(e){return Je`
      ${e.some((e=>1===e))?et:Je`
              <fluent-button
                 title="${_b.page} 1"
                 appearance="stealth"
                 class="search-results-page"
                 @click="${this.onFirstPageClick}">
                 1
               </fluent-button>`?Je`
              <fluent-button
                id="page-back-dot"
                appearance="stealth"
                class="search-results-page"
                title="${this.getDotButtonTitle()}"
                @click="${()=>this.onPageClick(this.currentPage-Math.ceil(this.pagingMax/2))}"
              >
                ...
              </fluent-button>`:et}`}getDotButtonTitle(){return`${_b.back} ${Math.ceil(this.pagingMax/2)} ${_b.pages}`}renderPreviousPage(){return this.currentPage>1?Je`
          <fluent-button
            appearance="stealth"
            class="search-results-page"
            title="${_b.back}"
            @click="${this.onPageBackClick}">
              ${Co(ko.ChevronLeft)}
            </fluent-button>`:et}renderNextPage(){return this.isLastPage()?et:Je`
          <fluent-button
            appearance="stealth"
            class="search-results-page"
            title="${_b.next}"
            aria-label="${_b.next}"
            @click="${this.onPageNextClick}">
              ${Co(ko.ChevronRight)}
            </fluent-button>`}onPageClick(e){this.currentPage=e,this.scrollToFirstResult()}isLastPage(){return this.currentPage===Math.ceil(this.response.value[0].hitsContainers[0].total/this.size)}scrollToFirstResult(){this.renderRoot.querySelector(".search-results").scrollIntoView({block:"start",behavior:"smooth"})}getResourceType(e){return e["@odata.type"].split(".").pop()}renderDriveItem(e){var t,i;const o=e.resource;return pi`
      <div class="search-result-grid">
        <div class="search-result-icon">
          <mgt-file
            .fileDetails="${e.resource}"
            view="image"
            class="file-icon">
          </mgt-file>
        </div>
        <div class="search-result-content">
          <div class="search-result-name">
            <a href="${o.webUrl}?Web=1" target="_blank">${Pi(o.name)}</a>
          </div>
          <div class="search-result-info">
            <div class="search-result-author">
              <mgt-person
                person-query=${o.lastModifiedBy.user.email}
                view="oneLine"
                person-card="hover"
                show-presence="true">
              </mgt-person>
            </div>
            <div class="search-result-date">
              &nbsp; ${_b.modified} ${Ci(new Date(o.lastModifiedDateTime))}
            </div>
          </div>
          <div class="search-result-summary" .innerHTML="${Di(e.summary)}"></div>
        </div>
        ${(null===(t=o.thumbnail)||void 0===t?void 0:t.url)&&Je`
          <div class="search-result-thumbnail">
            <a href="${o.webUrl}" target="_blank"><img alt="${o.name}" src="${null===(i=o.thumbnail)||void 0===i?void 0:i.url}" /></a>
          </div>`}

      </div>
      <fluent-divider></fluent-divider>
    `}renderSite(e){const t=e.resource;return Je`
      <div class="search-result-grid">
        <div class="search-result-icon">
          ${this.getResourceIcon(t)}
        </div>
        <div class="searc-result-content">
          <div class="search-result-name">
            <a href="${t.webUrl}" target="_blank">${t.displayName}</a>
          </div>
          <div class="search-result-info">
            <div class="search-result-url">
              <a href="${t.webUrl}" target="_blank">${t.webUrl}</a>
            </div>
          </div>
          <div class="search-result-summary" .innerHTML="${Di(e.summary)}"></div>
        </div>
      </div>
      <fluent-divider></fluent-divider>
    `}renderList(e){const t=e.resource;return pi`
      <div class="search-result-grid">
        <div class="search-result-icon">
          <mgt-file
            .fileDetails="${e.resource}"
            view="image">
          </mgt-file>
        </div>
        <div class="search-result-content">
          <div class="search-result-name">
            <a href="${t.webUrl}?Web=1" target="_blank">
              ${Pi(t.name||Li(t.webUrl))}
            </a>
          </div>
          <div class="search-result-summary" .innerHTML="${Di(e.summary)}"></div>
        </div>
      </div>
      <fluent-divider></fluent-divider>
    `}renderListItem(e){var t,i;const o=e.resource;return pi`
      <div class="search-result-grid">
        <div class="search-result-icon">
          ${o.webUrl.endsWith(".aspx")?Co(ko.News):Co(ko.FileOuter)}
        </div>
        <div class="search-result-content">
          <div class="search-result-name">
            <a href="${o.webUrl}?Web=1" target="_blank">
              ${Pi(o.name||Li(o.webUrl))}
            </a>
          </div>
          <div class="search-result-info">
            <div class="search-result-author">
              <mgt-person
                person-query=${o.lastModifiedBy.user.email}
                view="oneLine"
                person-card="hover"
                show-presence="true">
              </mgt-person>
            </div>
            <div class="search-result-date">
              &nbsp; ${_b.modified} ${Ci(new Date(o.lastModifiedDateTime))}
            </div>
          </div>
          <div class="search-result-summary" .innerHTML="${Di(e.summary)}"></div>
        </div>
        ${(null===(t=o.thumbnail)||void 0===t?void 0:t.url)&&Je`
          <div class="search-result-thumbnail">
            <a href="${o.webUrl}" target="_blank"><img alt="${Pi(o.name||Li(o.webUrl))}" src="${(null===(i=o.thumbnail)||void 0===i?void 0:i.url)||et}" /></a>
          </div>`}
      </div>
      <fluent-divider></fluent-divider>
    `}renderPerson(e){const t=e.resource;return pi`
      <div class="search-result">
        <mgt-person
          view="fourLines"
          person-query=${t.userPrincipalName}
          person-card="hover"
          show-presence="true">
        </mgt-person>
      </div>
      <fluent-divider></fluent-divider>
    `}renderBookmark(e){return this.renderAnswer(e,ko.DoubleBookmark)}renderAcronym(e){return this.renderAnswer(e,ko.BookOpen)}renderQnA(e){return this.renderAnswer(e,ko.BookQuestion)}renderAnswer(e,t){const i=e.resource;return Je`
      <div class="search-result-grid search-result-answer">
        <div class="search-result-icon">
          ${Co(t)}
        </div>
        <div class="search-result-content">
          <div class="search-result-name">
            <a href="${this.getResourceUrl(i)}?Web=1" target="_blank">${i.displayName}</a>
          </div>
          <div class="search-result-summary">${i.description}</div>
        </div>
      </div>
      <fluent-divider></fluent-divider>
    `}renderDefault(e){const t=e.resource,i=this.getResourceUrl(t);return Je`
      <div class="search-result-grid">
        <div class="search-result-icon">
          ${this.getResourceIcon(t)}
        </div>
        <div class="search-result-content">
          <div class="search-result-name">
            ${i?Je`
                  <a href="${i}?Web=1" target="_blank">${this.getResourceName(t)}</a>
                `:Je`
                  ${this.getResourceName(t)}
                `}
          </div>
          <div class="search-result-summary" .innerHTML="${this.getResultSummary(e)}"></div>
        </div>
      </div>
      <fluent-divider></fluent-divider>
    `}getResourceUrl(e){return e.webUrl||e.webLink||null}getResourceName(e){return e.displayName||e.subject||Pi(e.name)}getResultSummary(e){var t;return Di(e.summary||(null===(t=e.resource)||void 0===t?void 0:t.description)||null)}getResourceIcon(e){switch(e["@odata.type"]){case"#microsoft.graph.site":return Co(ko.Globe);case"#microsoft.graph.message":return Co(ko.Email);case"#microsoft.graph.event":return Co(ko.Event);case"microsoft.graph.chatMessage":return Co(ko.SmallChat);default:return Co(ko.FileOuter)}}shouldRetrieveCache(){return Ei()&&this.cacheEnabled&&!this.isRefreshing}shouldUpdateCache(){return Ei()&&this.cacheEnabled}getRequestOptions(){const e={entityTypes:this.entityTypes,query:{queryString:this.queryString},from:this.from?this.from:void 0,size:this.size?this.size:void 0,fields:this.getFields(),enableTopResults:this.enableTopResults?this.enableTopResults:void 0};return this.entityTypes.includes("externalItem")&&(e.contentSources=this.contentSources),"beta"===this.version&&(e.query.queryTemplate=this.queryTemplate?this.queryTemplate:void 0),e}getFields(){if(this.fields)return this.defaultFields.concat(this.fields)}};Lb([Ct({attribute:"query-string",type:String}),Eb("design:type",String),Eb("design:paramtypes",[String])],Ob.prototype,"queryString",null),Lb([Ct({attribute:"query-template",type:String}),Eb("design:type",String)],Ob.prototype,"queryTemplate",void 0),Lb([Ct({attribute:"entity-types",converter:e=>e.split(",").map((e=>e.trim())),type:String}),Eb("design:type",Array)],Ob.prototype,"entityTypes",void 0),Lb([Ct({attribute:"scopes",converter:(e,t)=>e?e.toLowerCase().split(","):null}),Eb("design:type",Array)],Ob.prototype,"scopes",void 0),Lb([Ct({attribute:"content-sources",converter:(e,t)=>e?e.toLowerCase().split(","):null}),Eb("design:type",Array)],Ob.prototype,"contentSources",void 0),Lb([Ct({attribute:"version",reflect:!0,type:String}),Eb("design:type",Object)],Ob.prototype,"version",void 0),Lb([Ct({attribute:"size",reflect:!0,type:Number}),Eb("design:type",Number),Eb("design:paramtypes",[Object])],Ob.prototype,"size",null),Lb([Ct({attribute:"paging-max",reflect:!0,type:Number}),Eb("design:type",Object)],Ob.prototype,"pagingMax",void 0),Lb([Ct({attribute:"fetch-thumbnail",type:Boolean}),Eb("design:type",Boolean)],Ob.prototype,"fetchThumbnail",void 0),Lb([Ct({attribute:"fields",converter:e=>e.split(",").map((e=>e.trim())),type:String}),Eb("design:type",Array)],Ob.prototype,"fields",void 0),Lb([Ct({attribute:"enable-top-results",reflect:!0,type:Boolean}),Eb("design:type",Object)],Ob.prototype,"enableTopResults",void 0),Lb([Ct({attribute:"cache-enabled",reflect:!0,type:Boolean}),Eb("design:type",Object)],Ob.prototype,"cacheEnabled",void 0),Lb([Ct({attribute:"cache-invalidation-period",reflect:!0,type:Number}),Eb("design:type",Object)],Ob.prototype,"cacheInvalidationPeriod",void 0),Lb([$t(),Eb("design:type",Object)],Ob.prototype,"response",void 0),Lb([$t(),Eb("design:type",Number),Eb("design:paramtypes",[Number])],Ob.prototype,"currentPage",null),Ob=Lb([gi("search-results"),Eb("design:paramtypes",[])],Ob);const Fb=window.location.href.replace("configureSecurity/","").replace("configure","").replace("pipeline-syntax/","").replace("computer/createItem","");te.globalProvider=new class extends J{get name(){return"MgtProxyProvider"}constructor(e,t){super(),this.graph=new vi(e,t),this.graph.api("me").get().then((e=>{null!=e?this.setState(Q.SignedIn):this.setState(Q.SignedOut)}),(e=>{this.setState(Q.SignedOut)}))}getAccessToken(){return Promise.resolve("")}}(`${Fb}/GraphProxy`,(()=>function(e,t,i,o){return new(i||(i=Promise))((function(s,n){function r(e){try{l(o.next(e))}catch(e){n(e)}}function a(e){try{l(o.throw(e))}catch(e){n(e)}}function l(e){var t;e.done?s(e.value):(t=e.value,t instanceof i?t:new i((function(e){e(t)}))).then(r,a)}l((o=o.apply(e,t||[])).next())}))}(void 0,void 0,void 0,(function*(){return{[document.head.dataset.crumbHeader]:document.head.dataset.crumbValue}}))))})();
//# sourceMappingURL=azure-ad-bundle.js.map